import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _Date$now from "@babel/runtime-corejs3/core-js-stable/date/now";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/splice";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
import Affix from '../Affix';
import { getScroll, addEventListener } from '../../utils';
import raf from 'raf';
function getDefaultContainer() {
  return window;
}
function getOffsetTop(element, container) {
  if (!element) {
    return 0;
  }
  if (!element.getClientRects().length) {
    return 0;
  }
  var rect = element.getBoundingClientRect();
  if (rect.width || rect.height) {
    if (container === window) {
      container = element.ownerDocument.documentElement;
      return rect.top - container.clientTop;
    }
    return rect.top - container.getBoundingClientRect().top;
  }
  return rect.top;
}
function easeInOutCubic(t, b, c, d) {
  var cc = c - b;
  t /= d / 2;
  if (t < 1) {
    return cc / 2 * t * t * t + b;
  }
  return cc / 2 * ((t -= 2) * t * t + 2) + b;
}
var sharpMatcherRegx = /#([^#]+)$/;
function scrollTo(href) {
  var offsetTop = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var getContainer = arguments.length > 2 ? arguments[2] : undefined;
  var callback = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : function () {};
  var container = getContainer();
  var scrollTop = getScroll(container, true);
  var sharpLinkMatch = sharpMatcherRegx.exec(href);
  if (!sharpLinkMatch) {
    return;
  }
  var targetElement = document.getElementById(sharpLinkMatch[1]);
  if (!targetElement) {
    return;
  }
  var eleOffsetTop = getOffsetTop(targetElement, container);
  var targetScrollTop = scrollTop + eleOffsetTop - offsetTop;
  var startTime = _Date$now();
  var frameFunc = function frameFunc() {
    var timestamp = _Date$now();
    var time = timestamp - startTime;
    var nextScrollTop = easeInOutCubic(time, scrollTop, targetScrollTop, 450);
    if (container === window) {
      window.scrollTo(window.pageXOffset, nextScrollTop);
    } else {
      container.scrollTop = nextScrollTop;
    }
    if (time < 450) {
      raf(frameFunc);
    } else {
      callback();
    }
  };
  raf(frameFunc);
}
var Anchor = /*#__PURE__*/function (_React$Component) {
  _inherits(Anchor, _React$Component);
  var _super = _createSuper(Anchor);
  function Anchor() {
    var _this;
    _classCallCheck(this, Anchor);
    _this = _super.apply(this, arguments);
    _this.state = {
      activeLink: null
    };
    _this.inkNode = null;
    _this.links = [];
    _this.scrollEvent = null;
    _this.animating = false;
    _this.handleScroll = function () {
      if (_this.animating) {
        return;
      }
      var _this$props = _this.props,
        offsetTop = _this$props.offsetTop,
        bounds = _this$props.bounds;
      _this.setState({
        activeLink: _this.getCurrentAnchor(offsetTop, bounds)
      });
    };
    _this.handleScrollTo = function (link) {
      var _this$props2 = _this.props,
        offsetTop = _this$props2.offsetTop,
        getContainer = _this$props2.getContainer;
      _this.animating = true;
      _this.setState({
        activeLink: link
      });
      scrollTo(link, offsetTop, getContainer, function () {
        _this.animating = false;
      });
    };
    _this.updateInk = function () {
      if (typeof document === 'undefined') {
        return;
      }
      var prefixCls = _this.props.prefixCls;
      var anchorNode = ReactDOM.findDOMNode(_assertThisInitialized(_this));
      var activeLinkNode = anchorNode.getElementsByClassName("".concat(prefixCls, "-link-active"))[0];
      if (activeLinkNode) {
        _this.inkNode.style.top = "".concat(activeLinkNode.offsetTop, "px");
        _this.inkNode.style.height = "".concat(activeLinkNode.offsetHeight, "px");
      }
    };
    _this.saveInkNode = function (node) {
      _this.inkNode = node;
    };
    return _this;
  }
  _createClass(Anchor, [{
    key: "getChildContext",
    value: function getChildContext() {
      var _this2 = this;
      var fishdAnchor = {
        registerLink: function registerLink(link) {
          var _context;
          if (!_includesInstanceProperty(_context = _this2.links).call(_context, link)) {
            _this2.links.push(link);
          }
        },
        unregisterLink: function unregisterLink(link) {
          var _context2;
          var index = _indexOfInstanceProperty(_context2 = _this2.links).call(_context2, link);
          if (index !== -1) {
            var _context3;
            _spliceInstanceProperty(_context3 = _this2.links).call(_context3, index, 1);
          }
        },
        activeLink: this.state.activeLink,
        scrollTo: this.handleScrollTo,
        onClick: this.props.onClick
      };
      return {
        fishdAnchor: fishdAnchor
      };
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var getContainer = this.props.getContainer;
      this.scrollEvent = addEventListener(getContainer(), 'scroll', this.handleScroll);
      this.handleScroll();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.scrollEvent) {
        this.scrollEvent.remove();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.updateInk();
    }
  }, {
    key: "getCurrentAnchor",
    value: function getCurrentAnchor() {
      var _context4;
      var offsetTop = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var bounds = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5;
      var activeLink = '';
      if (typeof document === 'undefined') {
        return activeLink;
      }
      var linkSections = [];
      var getContainer = this.props.getContainer;
      var container = getContainer();
      _forEachInstanceProperty(_context4 = this.links).call(_context4, function (link) {
        var sharpLinkMatch = sharpMatcherRegx.exec(link.toString());
        if (!sharpLinkMatch) {
          return;
        }
        var target = document.getElementById(sharpLinkMatch[1]);
        if (target) {
          var top = getOffsetTop(target, container);
          if (top < offsetTop + bounds) {
            linkSections.push({
              link: link,
              top: top
            });
          }
        }
      });
      if (linkSections.length) {
        var maxSection = _reduceInstanceProperty(linkSections).call(linkSections, function (prev, curr) {
          return curr.top > prev.top ? curr : prev;
        });
        return maxSection.link;
      }
      return '';
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props3 = this.props,
        prefixCls = _this$props3.prefixCls,
        _this$props3$classNam = _this$props3.className,
        className = _this$props3$classNam === void 0 ? '' : _this$props3$classNam,
        style = _this$props3.style,
        offsetTop = _this$props3.offsetTop,
        affix = _this$props3.affix,
        showInkInFixed = _this$props3.showInkInFixed,
        children = _this$props3.children,
        getContainer = _this$props3.getContainer,
        inkPosition = _this$props3.inkPosition;
      var activeLink = this.state.activeLink;
      var inkClass = classNames("".concat(prefixCls, "-ink-ball"), {
        visible: activeLink,
        left: inkPosition === 'left',
        right: inkPosition === 'right'
      });
      var wrapperClass = classNames(className, "".concat(prefixCls, "-wrapper"));
      var anchorClass = classNames(prefixCls, {
        fixed: !affix && !showInkInFixed
      });
      var wrapperStyle = _Object$assign({
        maxHeight: offsetTop ? "calc(100vh - ".concat(offsetTop, "px)") : '100vh'
      }, style);
      var inkNodeClass = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-ink"), true), _defineProperty(_classNames, "".concat(prefixCls, "-ink-left"), inkPosition === 'left'), _defineProperty(_classNames, "".concat(prefixCls, "-ink-right"), inkPosition === 'right'), _classNames));
      var anchorContent = /*#__PURE__*/React.createElement("div", {
        className: wrapperClass,
        style: wrapperStyle
      }, /*#__PURE__*/React.createElement("div", {
        className: anchorClass
      }, /*#__PURE__*/React.createElement("div", {
        className: inkNodeClass
      }, /*#__PURE__*/React.createElement("span", {
        className: inkClass,
        ref: this.saveInkNode
      })), children));
      return !affix ? anchorContent : /*#__PURE__*/React.createElement(Affix, {
        offsetTop: offsetTop,
        target: getContainer
      }, anchorContent);
    }
  }]);
  return Anchor;
}(React.Component);
export { Anchor as default };
Anchor.defaultProps = {
  prefixCls: 'fishd-anchor',
  inkPosition: 'left',
  affix: true,
  showInkInFixed: false,
  getContainer: getDefaultContainer
};
Anchor.childContextTypes = {
  fishdAnchor: PropTypes.object
};