import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React, { Component, Children } from 'react';
import PropTypes from 'prop-types';
import { TransitionGroup } from 'react-transition-group';
import AnimateChild from './child';
var noop = function noop() {};
var FirstChild = function FirstChild(props) {
  var childrenArray = React.Children.toArray(props.children);
  return childrenArray[0] || null;
};
var Animate = /*#__PURE__*/function (_Component) {
  _inherits(Animate, _Component);
  var _super = _createSuper(Animate);
  function Animate() {
    _classCallCheck(this, Animate);
    return _super.apply(this, arguments);
  }
  _createClass(Animate, [{
    key: "normalizeNames",
    value: function normalizeNames(names) {
      if (typeof names === 'string') {
        return {
          appear: "".concat(names, "-appear"),
          appearActive: "".concat(names, "-appear-active"),
          enter: "".concat(names, "-enter"),
          enterActive: "".concat(names, "-enter-active"),
          leave: "".concat(names, "-leave"),
          leaveActive: "".concat(names, "-leave-active")
        };
      }
      if (_typeof(names) === 'object') {
        return {
          appear: names.appear,
          appearActive: "".concat(names.appear, "-active"),
          enter: "".concat(names.enter),
          enterActive: "".concat(names.enter, "-active"),
          leave: "".concat(names.leave),
          leaveActive: "".concat(names.leave, "-active")
        };
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;
      var _a = this.props,
        animation = _a.animation,
        children = _a.children,
        animationAppear = _a.animationAppear,
        singleMode = _a.singleMode,
        component = _a.component,
        beforeAppear = _a.beforeAppear,
        onAppear = _a.onAppear,
        afterAppear = _a.afterAppear,
        beforeEnter = _a.beforeEnter,
        onEnter = _a.onEnter,
        afterEnter = _a.afterEnter,
        beforeLeave = _a.beforeLeave,
        onLeave = _a.onLeave,
        afterLeave = _a.afterLeave,
        _a$timeout = _a.timeout,
        timeout = _a$timeout === void 0 ? 500 : _a$timeout,
        others = __rest(_a, ["animation", "children", "animationAppear", "singleMode", "component", "beforeAppear", "onAppear", "afterAppear", "beforeEnter", "onEnter", "afterEnter", "beforeLeave", "onLeave", "afterLeave", "timeout"]);
      var animateChildren = _mapInstanceProperty(Children).call(Children, children, function (child) {
        return /*#__PURE__*/React.createElement(AnimateChild
        // @ts-ignore
        , {
          // @ts-ignore
          key: child.key,
          names: _this.normalizeNames(animation),
          onAppear: beforeAppear,
          onAppearing: onAppear,
          onAppeared: afterAppear,
          onEnter: beforeEnter,
          onEntering: onEnter,
          onEntered: afterEnter,
          onExit: beforeLeave,
          onExiting: onLeave,
          onExited: afterLeave,
          timeout: timeout
        }, child);
      });
      return /*#__PURE__*/React.createElement(TransitionGroup, _Object$assign({
        appear: animationAppear,
        component: singleMode ? FirstChild : component
      }, others), animateChildren);
    }
  }]);
  return Animate;
}(Component);
Animate.propTypes = {
  animation: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  animationAppear: PropTypes.bool,
  component: PropTypes.oneOfType([PropTypes.element, PropTypes.string]),
  singleMode: PropTypes.bool,
  children: PropTypes.oneOfType([PropTypes.element, PropTypes.arrayOf(PropTypes.element)]),
  beforeAppear: PropTypes.func,
  onAppear: PropTypes.func,
  afterAppear: PropTypes.func,
  beforeEnter: PropTypes.func,
  onEnter: PropTypes.func,
  afterEnter: PropTypes.func,
  beforeLeave: PropTypes.func,
  onLeave: PropTypes.func,
  afterLeave: PropTypes.func,
  timeout: PropTypes.oneOfType([PropTypes.number, PropTypes.object])
};
Animate.defaultProps = {
  animationAppear: true,
  component: 'span',
  singleMode: true,
  beforeAppear: noop,
  onAppear: noop,
  afterAppear: noop,
  beforeEnter: noop,
  onEnter: noop,
  afterEnter: noop,
  beforeLeave: noop,
  onLeave: noop,
  afterLeave: noop
};
export default Animate;