import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/splice";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
import _parseFloat from "@babel/runtime-corejs3/core-js-stable/parse-float";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import PropTypes from 'prop-types';
import { Transition } from 'react-transition-group';
import { supportAni, addClass, removeClass, guid } from '../../utils';
var noop = function noop() {};
function _off(node, eventName, callback) {
  var useCapture = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  if (node.removeEventListener) {
    node.removeEventListener(eventName, callback, useCapture);
  }
}
function on(node, eventName, callback) {
  var useCapture = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  if (node.addEventListener) {
    node.addEventListener(eventName, callback, useCapture);
  }
  return {
    off: function off() {
      return _off(node, eventName, callback, useCapture);
    }
  };
}
function getStyleProperty(node, name) {
  var prefixes = ['-webkit-', '-moz-', '-o-', 'ms-', ''];
  var style = window.getComputedStyle(node);
  var ret = '';
  for (var i = 0; i < prefixes.length; i++) {
    ret = style.getPropertyValue(prefixes[i] + name);
    if (ret) {
      break;
    }
  }
  return ret;
}
var AnimateChild = /*#__PURE__*/function (_React$Component) {
  _inherits(AnimateChild, _React$Component);
  var _super = _createSuper(AnimateChild);
  function AnimateChild(props) {
    var _this2;
    _classCallCheck(this, AnimateChild);
    _this2 = _super.call(this, props);
    _this2.endListeners = {
      transitionend: [],
      animationend: []
    };
    _this2.node = null;
    _this2.generateEndListener = function (node, done, eventName, id) {
      var _this = _assertThisInitialized(_this2);
      return function endListener(e) {
        if (e && e.target === node) {
          if (_this.timeoutMap[id]) {
            clearTimeout(_this.timeoutMap[id]);
            delete _this.timeoutMap[id];
          }
          done();
          _off(node, eventName, endListener);
          var listeners = _this.endListeners[eventName];
          var index = _indexOfInstanceProperty(listeners).call(listeners, endListener);
          index > -1 && _spliceInstanceProperty(listeners).call(listeners, index, 1);
        }
      };
    };
    _this2.addEndListener = function (node, done) {
      if (supportAni.transition || supportAni.animation) {
        var id = guid();
        _this2.node = node;
        if (supportAni.transition) {
          var transitionEndListener = _this2.generateEndListener(node, done, 'transitionend', id);
          on(node, 'transitionend', transitionEndListener);
          _this2.endListeners.transitionend.push(transitionEndListener);
        }
        if (supportAni.animation) {
          var animationEndListener = _this2.generateEndListener(node, done, 'animationend', id);
          on(node, 'animationend', animationEndListener);
          _this2.endListeners.animationend.push(animationEndListener);
        }
        _setTimeout(function () {
          var transitionDelay = _parseFloat(getStyleProperty(node, 'transition-delay')) || 0;
          var transitionDuration = _parseFloat(getStyleProperty(node, 'transition-duration')) || 0;
          var animationDelay = _parseFloat(getStyleProperty(node, 'animation-delay')) || 0;
          var animationDuration = _parseFloat(getStyleProperty(node, 'animation-duration')) || 0;
          var time = Math.max(transitionDuration + transitionDelay, animationDuration + animationDelay);
          _this2.timeoutMap[id] = _setTimeout(function () {
            done();
          }, time * 1000 + 200);
        }, 15);
      } else {
        done();
      }
    };
    _this2.removeEndtListener = function () {
      _this2.transitionOff && _this2.transitionOff();
      _this2.animationOff && _this2.animationOff();
    };
    _this2.removeClassNames = function (node, names) {
      var _context;
      _forEachInstanceProperty(_context = _Object$keys(names)).call(_context, function (key) {
        removeClass(node, names[key], false);
      });
    };
    _this2.handleEnter = function (node, isAppearing) {
      var names = _this2.props.names;
      if (names) {
        _this2.removeClassNames(node, names);
        var className = isAppearing ? 'appear' : 'enter';
        addClass(node, names[className], false);
      }
      var hook = isAppearing ? _this2.props.onAppear : _this2.props.onEnter;
      hook(node);
    };
    _this2.handleEntering = function (node, isAppearing) {
      _setTimeout(function () {
        var names = _this2.props.names;
        if (names) {
          var className = isAppearing ? 'appearActive' : 'enterActive';
          addClass(node, names[className], false);
        }
        var hook = isAppearing ? _this2.props.onAppearing : _this2.props.onEntering;
        hook(node);
      }, 10);
    };
    _this2.handleEntered = function (node, isAppearing) {
      var names = _this2.props.names;
      if (names && _typeof(names) === 'object') {
        var classNames = isAppearing ? [names.appear, names.appearActive] : [names.enter, names.enterActive];
        _forEachInstanceProperty(classNames).call(classNames, function (className) {
          removeClass(node, className, false);
        });
      }
      var hook = isAppearing ? _this2.props.onAppeared : _this2.props.onEntered;
      hook(node);
    };
    _this2.handleExit = function (node) {
      var names = _this2.props.names;
      if (names) {
        _this2.removeClassNames(node, names);
        addClass(node, names.leave, false);
      }
      _this2.props.onExit(node);
    };
    _this2.handleExiting = function (node) {
      _setTimeout(function () {
        var names = _this2.props.names;
        if (names) {
          addClass(node, names.leaveActive, false);
        }
        _this2.props.onExiting(node);
      }, 10);
    };
    _this2.handleExited = function (node) {
      var names = _this2.props.names;
      if (names) {
        var _context2;
        _forEachInstanceProperty(_context2 = [names.leave, names.leaveActive]).call(_context2, function (className) {
          removeClass(node, className, false);
        });
      }
      _this2.props.onExited(node);
    };
    _this2.endListeners = {
      transitionend: [],
      animationend: []
    };
    _this2.timeoutMap = {};
    return _this2;
  }
  _createClass(AnimateChild, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _context3,
        _this3 = this;
      _forEachInstanceProperty(_context3 = _Object$keys(this.endListeners)).call(_context3, function (eventName) {
        var _context4;
        _forEachInstanceProperty(_context4 = _this3.endListeners[eventName]).call(_context4, function (listener) {
          _off(_this3.node, eventName, listener);
        });
      });
      this.endListeners = {
        transitionend: [],
        animationend: []
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _a = this.props,
        names = _a.names,
        onAppear = _a.onAppear,
        onAppeared = _a.onAppeared,
        onAppearing = _a.onAppearing,
        onEnter = _a.onEnter,
        onEntering = _a.onEntering,
        onEntered = _a.onEntered,
        onExit = _a.onExit,
        onExiting = _a.onExiting,
        onExited = _a.onExited,
        others = __rest(_a, ["names", "onAppear", "onAppeared", "onAppearing", "onEnter", "onEntering", "onEntered", "onExit", "onExiting", "onExited"]);
      return /*#__PURE__*/React.createElement(Transition, _Object$assign({}, others, {
        onEnter: this.handleEnter,
        onEntering: this.handleEntering,
        onEntered: this.handleEntered,
        onExit: this.handleExit,
        onExiting: this.handleExiting,
        onExited: this.handleExited,
        addEndListener: this.addEndListener
      }));
    }
  }]);
  return AnimateChild;
}(React.Component);
export { AnimateChild as default };
AnimateChild.propTypes = {
  names: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  onAppear: PropTypes.func,
  onAppearing: PropTypes.func,
  onAppeared: PropTypes.func,
  onEnter: PropTypes.func,
  onEntering: PropTypes.func,
  onEntered: PropTypes.func,
  onExit: PropTypes.func,
  onExiting: PropTypes.func,
  onExited: PropTypes.func,
  timeout: PropTypes.oneOfType([PropTypes.number, PropTypes.object])
};
AnimateChild.defaultProps = {
  onAppear: noop,
  onAppearing: noop,
  onAppeared: noop,
  onEnter: noop,
  onEntering: noop,
  onEntered: noop,
  onExit: noop,
  onExiting: noop,
  onExited: noop
};