import * as React from 'react';
import { Option, OptGroup } from './src/index.js';
import { AbstractSelectProps, SelectValue, OptionProps, OptGroupProps } from './Select';
import './style/index.less';
export interface DataSourceItemObject {
    value: string;
    text: string;
}
export declare type DataSourceItemType = string | DataSourceItemObject | React.ReactElement<OptionProps> | React.ReactElement<OptGroupProps>;
export interface AutoCompleteInputProps {
    onChange?: React.FormEventHandler<any>;
    value: any;
}
export declare type ValidInputElement = HTMLInputElement | HTMLTextAreaElement | React.ReactElement<AutoCompleteInputProps>;
export interface AutoCompleteProps extends AbstractSelectProps {
    value?: SelectValue;
    defaultValue?: SelectValue;
    dataSource?: DataSourceItemType[];
    autoFocus?: boolean;
    backfill?: boolean;
    highlightSelected?: boolean;
    optionLabelProp?: string;
    getPopupContainer?: (triggerNode: HTMLElement) => HTMLElement;
    onChange?: (value: SelectValue) => void;
    onSelect?: (value: SelectValue, option: Record<string, any>) => any;
    children?: ValidInputElement | React.ReactElement<OptionProps> | Array<React.ReactElement<OptionProps>>;
}
export default class AutoComplete extends React.Component<AutoCompleteProps, {}> {
    static Option: typeof Option;
    static OptGroup: typeof OptGroup;
    static defaultProps: {
        prefixCls: string;
        transitionName: string;
        optionLabelProp: string;
        choiceTransitionName: string;
        showSearch: boolean;
        filterOption: boolean;
        highlightSelected: boolean;
    };
    private select;
    getInputElement: () => JSX.Element;
    focus(): void;
    blur(): void;
    saveSelect: (node: any) => void;
    render(): JSX.Element;
}
