import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import * as React from 'react';
import PropTypes from 'prop-types';
import { cloneElement } from 'react';
import warning from 'warning';
import BreadcrumbItem from './BreadcrumbItem';
import classNames from 'classnames';
import Icon from '../Icon';
function getBreadcrumbName(route, params) {
  if (!route.breadcrumbName) {
    return null;
  }
  var paramsKeys = _Object$keys(params).join('|');
  var name = route.breadcrumbName.replace(new RegExp(":(".concat(paramsKeys, ")"), 'g'), function (replacement, key) {
    return params[key] || replacement;
  });
  return name;
}
function defaultItemRender(route, params, routes, paths) {
  var isLastItem = _indexOfInstanceProperty(routes).call(routes, route) === routes.length - 1;
  var name = getBreadcrumbName(route, params);
  return isLastItem ? /*#__PURE__*/React.createElement("span", null, name) : /*#__PURE__*/React.createElement("a", {
    href: "#/".concat(paths.join('/'))
  }, name);
}
var Breadcrumb = /*#__PURE__*/function (_React$Component) {
  _inherits(Breadcrumb, _React$Component);
  var _super = _createSuper(Breadcrumb);
  function Breadcrumb() {
    _classCallCheck(this, Breadcrumb);
    return _super.apply(this, arguments);
  }
  _createClass(Breadcrumb, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var props = this.props;
      warning(!('linkRender' in props || 'nameRender' in props), '`linkRender` and `nameRender` are removed, please use `itemRender` instead, ' + 'see: https://u.ant.design/item-render.');
    }
  }, {
    key: "render",
    value: function render() {
      var crumbs;
      var _this$props = this.props,
        separator = _this$props.separator,
        prefixCls = _this$props.prefixCls,
        style = _this$props.style,
        className = _this$props.className,
        routes = _this$props.routes,
        _this$props$params = _this$props.params,
        params = _this$props$params === void 0 ? {} : _this$props$params,
        children = _this$props.children,
        _this$props$itemRende = _this$props.itemRender,
        itemRender = _this$props$itemRende === void 0 ? defaultItemRender : _this$props$itemRende,
        maxWidth = _this$props.maxWidth,
        size = _this$props.size;
      if (routes && routes.length > 0) {
        var paths = [];
        crumbs = _mapInstanceProperty(routes).call(routes, function (route) {
          var _context;
          route.path = route.path || '';
          var path = route.path.replace(/^\//, '');
          _forEachInstanceProperty(_context = _Object$keys(params)).call(_context, function (key) {
            path = path.replace(":".concat(key), params[key]);
          });
          if (path) {
            paths.push(path);
          }
          return /*#__PURE__*/React.createElement(BreadcrumbItem, {
            separator: separator,
            key: route.breadcrumbName || path,
            maxWidth: maxWidth
          }, itemRender(route, params, routes, paths));
        });
      } else if (children) {
        var _context2;
        crumbs = _mapInstanceProperty(_context2 = React.Children).call(_context2, children, function (element, index) {
          if (!element) {
            return element;
          }
          warning(element.type && element.type.__FISHD_BREADCRUMB_ITEM, "Breadcrumb only accepts Breadcrumb.Item as it's children");
          return /*#__PURE__*/cloneElement(element, {
            separator: separator,
            maxWidth: maxWidth,
            key: index
          });
        });
      }
      var cls = classNames(className, prefixCls, {
        small: size === 'small'
      });
      return /*#__PURE__*/React.createElement("div", {
        className: cls,
        style: style
      }, crumbs);
    }
  }]);
  return Breadcrumb;
}(React.Component);
export { Breadcrumb as default };
Breadcrumb.defaultProps = {
  prefixCls: 'fishd-breadcrumb',
  separator: /*#__PURE__*/React.createElement(Icon, {
    type: "arrow-line-regular"
  }),
  size: 'default'
};
Breadcrumb.propTypes = {
  prefixCls: PropTypes.string,
  size: PropTypes.string,
  separator: PropTypes.node,
  routes: PropTypes.array,
  params: PropTypes.object,
  linkRender: PropTypes.func,
  nameRender: PropTypes.func
};