import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _findIndexInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/find-index";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _sortInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/sort";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import RcCascader from './src';
import arrayTreeFilter from 'array-tree-filter';
import { polyfill } from 'react-lifecycles-compat';
import classNames from 'classnames';
import omit from 'omit.js';
import warning from 'warning';
import { KeyCode } from '../../utils';
import Input from '../Input';
import Icon from '../Icon';
import ConfigConsumer from '../Config/Consumer';
// We limit the filtered item count by default
var defaultLimit = 50;
//搜索项高亮-String类型支持
function highlightKeyword(str, keyword, prefixCls) {
  var _context;
  return _mapInstanceProperty(_context = str.split(keyword)).call(_context, function (node, index) {
    return index === 0 ? node : [/*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-menu-item-keyword"),
      key: "seperator"
    }, keyword), node];
  });
}
//默认filterOption
function defaultFilterOption(inputValue, path, names) {
  return _someInstanceProperty(path).call(path, function (option) {
    var _context2;
    return _indexOfInstanceProperty(_context2 = option[names.label]).call(_context2, inputValue) > -1;
  });
}
//默认的搜索后的option渲染方法
function defaultRenderFilteredOption(inputValue, path, prefixCls, names) {
  return _mapInstanceProperty(path).call(path, function (option, index) {
    var label = option[names.label];
    var node = _indexOfInstanceProperty(label).call(label, inputValue) > -1 ? highlightKeyword(label, inputValue, prefixCls) : label;
    return index === 0 ? node : [' / ', node];
  });
}
//默认搜索后的option排序方案
function defaultSortFilteredOption(a, b, inputValue, names) {
  function callback(elem) {
    var _context3;
    return _indexOfInstanceProperty(_context3 = elem[names.label]).call(_context3, inputValue) > -1;
  }
  return _findIndexInstanceProperty(a).call(a, callback) - _findIndexInstanceProperty(b).call(b, callback);
}
//自定义option参数的名字
function getFilledFieldNames(props) {
  var fieldNames = props.fieldNames || {};
  var names = {
    children: fieldNames.children || 'children',
    label: fieldNames.label || 'label',
    value: fieldNames.value || 'value'
  };
  return names;
}
function flattenTree(options, props) {
  var ancestor = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var names = getFilledFieldNames(props);
  var flattenOptions = [];
  var childrenName = names.children;
  _forEachInstanceProperty(options).call(options, function (option) {
    var path = _concatInstanceProperty(ancestor).call(ancestor, option);
    if (props.changeOnSelect || !option[childrenName] || !option[childrenName].length) {
      flattenOptions.push(path);
    }
    if (option[childrenName]) {
      flattenOptions = _concatInstanceProperty(flattenOptions).call(flattenOptions, flattenTree(option[childrenName], props, path));
    }
  });
  return flattenOptions;
}
var defaultDisplayRender = function defaultDisplayRender(label) {
  return label.join(' / ');
};
var Cascader = /*#__PURE__*/function (_React$Component) {
  _inherits(Cascader, _React$Component);
  var _super = _createSuper(Cascader);
  function Cascader(props) {
    var _this;
    _classCallCheck(this, Cascader);
    _this = _super.call(this, props);
    _this.handleChange = function (value, selectedOptions) {
      _this.setState({
        inputValue: ''
      });
      if (selectedOptions[0].__IS_FILTERED_OPTION) {
        var unwrappedValue = value[0];
        var unwrappedSelectedOptions = selectedOptions[0].path;
        _this.setValue(unwrappedValue, unwrappedSelectedOptions);
        return;
      }
      _this.setValue(value, selectedOptions);
    };
    _this.handlePopupVisibleChange = function (popupVisible) {
      if (!('popupVisible' in _this.props)) {
        _this.setState({
          popupVisible: popupVisible,
          inputFocused: popupVisible,
          inputValue: popupVisible ? _this.state.inputValue : ''
        });
      }
      var onVisibleChange = _this.props.onVisibleChange;
      if (onVisibleChange) {
        onVisibleChange(popupVisible);
      }
    };
    _this.handleInputBlur = function () {
      _this.setState({
        inputFocused: false
      });
    };
    _this.handleInputClick = function (e) {
      var _this$state = _this.state,
        inputFocused = _this$state.inputFocused,
        popupVisible = _this$state.popupVisible;
      // Prevent `Trigger` behaviour.
      if (inputFocused || popupVisible) {
        e.stopPropagation();
        if (e.nativeEvent.stopImmediatePropagation) {
          e.nativeEvent.stopImmediatePropagation();
        }
      }
    };
    _this.handleKeyDown = function (e) {
      if (e.keyCode === KeyCode.BACKSPACE) {
        e.stopPropagation();
      }
    };
    _this.handleInputChange = function (e) {
      var inputValue = e.target.value;
      _this.setState({
        inputValue: inputValue
      });
    };
    _this.setValue = function (value) {
      var selectedOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      if (!('value' in _this.props)) {
        _this.setState({
          value: value
        });
      }
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange(value, selectedOptions);
      }
    };
    _this.clearSelection = function (e) {
      e.preventDefault();
      e.stopPropagation();
      if (!_this.state.inputValue) {
        _this.setValue([]);
        _this.handlePopupVisibleChange(false);
      } else {
        _this.setState({
          inputValue: ''
        });
      }
    };
    _this.saveInput = function (node) {
      _this.input = node;
    };
    _this.state = {
      value: props.value || props.defaultValue || [],
      inputValue: '',
      inputFocused: false,
      popupVisible: props.popupVisible,
      flattenOptions: props.showSearch ? flattenTree(props.options, props) : undefined,
      prevProps: props
    };
    return _this;
  }
  _createClass(Cascader, [{
    key: "getLabel",
    value: function getLabel() {
      var _this$props = this.props,
        options = _this$props.options,
        _this$props$displayRe = _this$props.displayRender,
        displayRender = _this$props$displayRe === void 0 ? defaultDisplayRender : _this$props$displayRe;
      var names = getFilledFieldNames(this.props);
      var value = this.state.value;
      var unwrappedValue = _Array$isArray(value[0]) ? value[0] : value;
      var selectedOptions = arrayTreeFilter(options, function (o, level) {
        return o[names.value] === unwrappedValue[level];
      });
      var label = _mapInstanceProperty(selectedOptions).call(selectedOptions, function (o) {
        return o[names.label];
      });
      return displayRender(label, selectedOptions);
    }
  }, {
    key: "generateFilteredOptions",
    value: function generateFilteredOptions(prefixCls, Locale) {
      var _this2 = this,
        _ref2;
      var _this$props2 = this.props,
        showSearch = _this$props2.showSearch,
        _this$props2$notFound = _this$props2.notFoundContent,
        notFoundContent = _this$props2$notFound === void 0 ? Locale.notFoundContent : _this$props2$notFound;
      var names = getFilledFieldNames(this.props);
      var _showSearch$filter = _filterInstanceProperty(showSearch),
        filter = _showSearch$filter === void 0 ? defaultFilterOption : _showSearch$filter,
        _showSearch$render = showSearch.render,
        render = _showSearch$render === void 0 ? defaultRenderFilteredOption : _showSearch$render,
        _showSearch$sort = _sortInstanceProperty(showSearch),
        sort = _showSearch$sort === void 0 ? defaultSortFilteredOption : _showSearch$sort,
        _showSearch$limit = showSearch.limit,
        limit = _showSearch$limit === void 0 ? defaultLimit : _showSearch$limit;
      var _this$state2 = this.state,
        _this$state2$flattenO = _this$state2.flattenOptions,
        flattenOptions = _this$state2$flattenO === void 0 ? [] : _this$state2$flattenO,
        inputValue = _this$state2.inputValue;
      // Limit the filter if needed
      var filtered;
      if (limit > 0) {
        filtered = [];
        var matchCount = 0;
        // Perf optimization to filter items only below the limit
        _someInstanceProperty(flattenOptions).call(flattenOptions, function (path) {
          var match = filter(_this2.state.inputValue, path, names);
          if (match) {
            filtered.push(path);
            matchCount += 1;
          }
          return matchCount >= limit;
        });
      } else {
        warning(typeof limit !== 'number', "'limit' of showSearch in Cascader should be positive number or false.");
        filtered = _filterInstanceProperty(flattenOptions).call(flattenOptions, function (path) {
          return filter(_this2.state.inputValue, path, names);
        });
      }
      _sortInstanceProperty(filtered).call(filtered, function (a, b) {
        return sort(a, b, inputValue, names);
      });
      if (filtered.length > 0) {
        return _mapInstanceProperty(filtered).call(filtered, function (path) {
          var _ref;
          return _ref = {
            __IS_FILTERED_OPTION: true,
            path: path
          }, _defineProperty(_ref, names.label, render(inputValue, path, prefixCls, names)), _defineProperty(_ref, names.value, _mapInstanceProperty(path).call(path, function (o) {
            return o[names.value];
          })), _defineProperty(_ref, "disabled", _someInstanceProperty(path).call(path, function (o) {
            return !!o.disabled;
          })), _ref;
        });
      }
      return [(_ref2 = {}, _defineProperty(_ref2, names.label, notFoundContent), _defineProperty(_ref2, names.value, 'FISHD_CASCADER_NOT_FOUND'), _defineProperty(_ref2, "disabled", true), _ref2)];
    }
  }, {
    key: "focus",
    value: function focus() {
      this.input.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.input.blur();
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _classNames2,
        _context4,
        _classNames3,
        _this3 = this;
      var props = this.props,
        state = this.state;
      var prefixCls = props.prefixCls,
        inputPrefixCls = props.inputPrefixCls,
        children = props.children,
        placeholder = props.placeholder,
        notFoundContent = props.notFoundContent,
        size = props.size,
        disabled = props.disabled,
        className = props.className,
        style = props.style,
        allowClear = props.allowClear,
        _props$showSearch = props.showSearch,
        showSearch = _props$showSearch === void 0 ? false : _props$showSearch,
        otherProps = __rest(props, ["prefixCls", "inputPrefixCls", "children", "placeholder", "notFoundContent", "size", "disabled", "className", "style", "allowClear", "showSearch"]);
      var value = state.value,
        inputFocused = state.inputFocused;
      var sizeCls = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(inputPrefixCls, "-lg"), size === 'large'), _defineProperty(_classNames, "".concat(inputPrefixCls, "-sm"), size === 'small'), _classNames));
      var clearIcon = allowClear && !disabled && value.length > 0 || state.inputValue ? /*#__PURE__*/React.createElement(Icon, {
        type: "close-circle-fill",
        className: "".concat(prefixCls, "-picker-clear"),
        onClick: this.clearSelection
      }) : null;
      var arrowCls = classNames((_classNames2 = {}, _defineProperty(_classNames2, "".concat(prefixCls, "-picker-arrow"), true), _defineProperty(_classNames2, "".concat(prefixCls, "-picker-arrow-expand"), state.popupVisible), _classNames2));
      var pickerCls = classNames(className, "".concat(prefixCls, "-picker"), (_classNames3 = {}, _defineProperty(_classNames3, "".concat(prefixCls, "-picker-with-value"), state.inputValue), _defineProperty(_classNames3, "".concat(prefixCls, "-picker-disabled"), disabled), _defineProperty(_classNames3, _concatInstanceProperty(_context4 = "".concat(prefixCls, "-picker-")).call(_context4, size), !!size), _defineProperty(_classNames3, "".concat(prefixCls, "-picker-show-search"), !!showSearch), _defineProperty(_classNames3, "".concat(prefixCls, "-picker-focused"), inputFocused), _classNames3));
      // Fix bug of https://github.com/facebook/react/pull/5004
      // and https://fb.me/react-unknown-prop
      var inputProps = omit(otherProps, ['onChange', 'options', 'popupPlacement', 'transitionName', 'displayRender', 'onVisibleChange', 'changeOnSelect', 'expandTrigger', 'popupVisible', 'getPopupContainer', 'loadData', 'popupClassName', 'filterOption', 'renderFilteredOption', 'sortFilteredOption', 'notFoundContent', 'fieldNames', 'esc']);
      var getOptionsAndOthers = function getOptionsAndOthers(Locale) {
        var _this3$props = _this3.props,
          _this3$props$notFound = _this3$props.notFoundContent,
          notFoundContent = _this3$props$notFound === void 0 ? Locale.notFoundContent : _this3$props$notFound,
          _this3$props$placehol = _this3$props.placeholder,
          placeholder = _this3$props$placehol === void 0 ? Locale.placeholder : _this3$props$placehol;
        var options = props.options;
        if (state.inputValue) {
          options = _this3.generateFilteredOptions(prefixCls, Locale);
        }
        // Dropdown menu should keep previous status until it is fully closed.
        if (!state.popupVisible) {
          options = _this3.cachedOptions;
        } else {
          _this3.cachedOptions = options;
        }
        var dropdownMenuColumnStyle = {};
        var isNotFound = (options || []).length === 1 && options[0].value === 'FISHD_CASCADER_NOT_FOUND';
        if (isNotFound) {
          dropdownMenuColumnStyle.height = 'auto'; // Height of one row.
        }
        // The default value of `matchInputWidth` is `true`
        var resultListMatchInputWidth = showSearch.matchInputWidth === false ? false : true;
        if (resultListMatchInputWidth && state.inputValue && _this3.input) {
          dropdownMenuColumnStyle.width = _this3.input.input.offsetWidth;
        }
        return {
          options: options,
          dropdownMenuColumnStyle: dropdownMenuColumnStyle,
          notFoundContent: notFoundContent,
          placeholder: placeholder
        };
      };
      var label = this.getLabel();
      var getInput = function getInput(Locale) {
        var _context5;
        var _this3$props$placehol2 = _this3.props.placeholder,
          placeholder = _this3$props$placehol2 === void 0 ? Locale.placeholder : _this3$props$placehol2;
        return children || /*#__PURE__*/React.createElement("span", {
          style: style,
          className: pickerCls
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-picker-label"),
          title: typeof label === 'string' ? label : ''
        }, label), /*#__PURE__*/React.createElement(Input, _Object$assign({}, inputProps, {
          ref: _this3.saveInput,
          prefixCls: inputPrefixCls,
          placeholder: value && value.length > 0 ? undefined : placeholder,
          className: _concatInstanceProperty(_context5 = "".concat(prefixCls, "-input ")).call(_context5, sizeCls),
          value: state.inputValue,
          disabled: disabled,
          readOnly: !showSearch,
          autoComplete: "off",
          onClick: showSearch ? _this3.handleInputClick : undefined,
          onBlur: showSearch ? _this3.handleInputBlur : undefined,
          onKeyDown: _this3.handleKeyDown,
          onChange: showSearch ? _this3.handleInputChange : undefined
        })), clearIcon, /*#__PURE__*/React.createElement(Icon, {
          type: "down-fill",
          className: arrowCls
        }));
      };
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "Cascader"
      }, function (Locale) {
        return /*#__PURE__*/React.createElement(RcCascader, _Object$assign({}, props, getOptionsAndOthers(Locale), {
          value: value,
          popupVisible: state.popupVisible,
          onPopupVisibleChange: _this3.handlePopupVisibleChange,
          onChange: _this3.handleChange
        }), getInput(Locale));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, _ref3) {
      var prevProps = _ref3.prevProps;
      var newState = {
        prevProps: nextProps
      };
      if ('value' in nextProps) {
        newState.value = nextProps.value || [];
      }
      if ('popupVisible' in nextProps) {
        newState.popupVisible = nextProps.popupVisible;
      }
      if (nextProps.showSearch && prevProps.options !== nextProps.options) {
        newState.flattenOptions = flattenTree(nextProps.options, nextProps);
      }
      return newState;
    }
  }]);
  return Cascader;
}(React.Component);
Cascader.defaultProps = {
  prefixCls: 'fishd-cascader',
  inputPrefixCls: 'fishd-input',
  transitionName: 'slide-up',
  popupPlacement: 'bottomLeft',
  options: [],
  disabled: false,
  allowClear: true
};
polyfill(Cascader);
export default Cascader;