import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/splice";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import Checkbox from './Checkbox';
import { shallowEqual } from '../../utils';
var CheckboxGroup = /*#__PURE__*/function (_React$Component) {
  _inherits(CheckboxGroup, _React$Component);
  var _super = _createSuper(CheckboxGroup);
  function CheckboxGroup(props) {
    var _this;
    _classCallCheck(this, CheckboxGroup);
    _this = _super.call(this, props);
    _this.toggleOption = function (option) {
      var _context;
      var optionIndex = _indexOfInstanceProperty(_context = _this.state.value).call(_context, option.value);
      var value = _toConsumableArray(_this.state.value);
      if (optionIndex === -1) {
        value.push(option.value);
      } else {
        _spliceInstanceProperty(value).call(value, optionIndex, 1);
      }
      if (!('value' in _this.props)) {
        _this.setState({
          value: value
        });
      }
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange(value);
      }
    };
    _this.state = {
      value: props.value || props.defaultValue || []
    };
    return _this;
  }
  _createClass(CheckboxGroup, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        checkboxGroup: {
          toggleOption: this.toggleOption,
          value: this.state.value,
          disabled: this.props.disabled
        }
      };
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !shallowEqual(this.props, nextProps) || !shallowEqual(this.state, nextState);
    }
  }, {
    key: "getOptions",
    value: function getOptions() {
      var options = this.props.options;
      // https://github.com/Microsoft/TypeScript/issues/7960
      return _mapInstanceProperty(options).call(options, function (option) {
        if (typeof option === 'string') {
          return {
            label: option,
            value: option
          };
        }
        return option;
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var props = this.props,
        state = this.state;
      var prefixCls = props.prefixCls,
        className = props.className,
        style = props.style,
        options = props.options;
      var groupPrefixCls = "".concat(prefixCls, "-group");
      var children = props.children;
      if (options && options.length > 0) {
        var _context2;
        children = _mapInstanceProperty(_context2 = this.getOptions()).call(_context2, function (option) {
          var _context3;
          return /*#__PURE__*/React.createElement(Checkbox, {
            prefixCls: prefixCls,
            key: option.value.toString(),
            disabled: 'disabled' in option ? option.disabled : props.disabled,
            value: option.value,
            checked: _indexOfInstanceProperty(_context3 = state.value).call(_context3, option.value) !== -1,
            onChange: function onChange() {
              return _this2.toggleOption(option);
            },
            className: "".concat(groupPrefixCls, "-item")
          }, option.label);
        });
      }
      var classString = classNames(groupPrefixCls, className);
      return /*#__PURE__*/React.createElement("div", {
        className: classString,
        style: style
      }, children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      if ('value' in nextProps) {
        return {
          value: nextProps.value || []
        };
      }
      return null;
    }
  }]);
  return CheckboxGroup;
}(React.Component);
CheckboxGroup.defaultProps = {
  options: [],
  prefixCls: 'fishd-checkbox'
};
CheckboxGroup.propTypes = {
  defaultValue: PropTypes.array,
  value: PropTypes.array,
  options: PropTypes.array.isRequired,
  onChange: PropTypes.func
};
CheckboxGroup.childContextTypes = {
  checkboxGroup: PropTypes.any
};
polyfill(CheckboxGroup);
export default CheckboxGroup;