import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import Color from './helpers/color';
var WIDTH = 200;
var HEIGHT = 150;
var Board = /*#__PURE__*/function (_React$Component) {
  _inherits(Board, _React$Component);
  var _super = _createSuper(Board);
  function Board(props) {
    var _this;
    _classCallCheck(this, Board);
    _this = _super.call(this, props);
    _this.onBoardMouseDown = function (e) {
      var buttons = e.buttons;
      // only work on left click
      // @see https://developer.mozilla.org/en-US/docs/Web/Events/mousedown
      if (buttons !== 1) return;
      _this.removeListeners();
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
      window.addEventListener('mousemove', _this.onBoardDrag);
      window.addEventListener('mouseup', _this.onBoardDragEnd);
    };
    _this.onBoardTouchStart = function (e) {
      if (e.touches.length !== 1) {
        return;
      }
      _this.removeTouchListeners();
      var x = e.targetTouches[0].clientX;
      var y = e.targetTouches[0].clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
      window.addEventListener('touchmove', _this.onBoardTouchMove);
      window.addEventListener('touchend', _this.onBoardTouchEnd);
    };
    _this.onBoardTouchMove = function (e) {
      if (e.preventDefault) {
        e.preventDefault();
      }
      var x = e.targetTouches[0].clientX;
      var y = e.targetTouches[0].clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
    };
    _this.onBoardTouchEnd = function () {
      _this.removeTouchListeners();
    };
    _this.onBoardDrag = function (e) {
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
    };
    _this.onBoardDragEnd = function (e) {
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
      _this.removeListeners();
    };
    _this.getPrefixCls = function () {
      return "".concat(_this.props.rootPrefixCls, "-board");
    };
    _this.removeTouchListeners = function () {
      window.removeEventListener('touchmove', _this.onBoardTouchMove);
      window.removeEventListener('touchend', _this.onBoardTouchEnd);
    };
    _this.removeListeners = function () {
      window.removeEventListener('mousemove', _this.onBoardDrag);
      window.removeEventListener('mouseup', _this.onBoardDragEnd);
    };
    /**
     * 移动光标位置到
     * @param  {object} pos X Y 全局坐标点
     */
    _this.pointMoveTo = function (pos) {
      var rect = ReactDOM.findDOMNode(_assertThisInitialized(_this)).getBoundingClientRect();
      var left = pos.x - rect.left;
      var top = pos.y - rect.top;
      var rWidth = rect.width || WIDTH;
      var rHeight = rect.height || HEIGHT;
      left = Math.max(0, left);
      left = Math.min(left, rWidth);
      top = Math.max(0, top);
      top = Math.min(top, rHeight);
      var color = _this.props.color;
      color.saturation = left / rWidth;
      color.brightness = 1 - top / rHeight;
      _this.props.onChange(color);
    };
    return _this;
  }
  _createClass(Board, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeListeners();
      this.removeTouchListeners();
    }
  }, {
    key: "render",
    value: function render() {
      var prefixCls = this.getPrefixCls();
      var color = this.props.color;
      var hueHsv = {
        h: color.hue,
        s: 1,
        v: 1
      };
      var hueColor = new Color(hueHsv).toHexString();
      var xRel = color.saturation * 100;
      var yRel = (1 - color.brightness) * 100;
      return /*#__PURE__*/React.createElement("div", {
        className: prefixCls
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-hsv"),
        style: {
          backgroundColor: hueColor
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-value")
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-saturation")
      })), /*#__PURE__*/React.createElement("span", {
        style: {
          left: "".concat(xRel, "%"),
          top: "".concat(yRel, "%")
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-handler"),
        onMouseDown: this.onBoardMouseDown,
        onTouchStart: this.onBoardTouchStart
      }));
    }
  }]);
  return Board;
}(React.Component);
export { Board as default };
Board.propTypes = {
  color: PropTypes.object,
  onChange: PropTypes.func,
  rootPrefixCls: PropTypes.string
};