import React from 'react';
import ColorPickerPanel from './Panel';
import Color from './helpers/color';
import QuickPanel, { ColorType } from './QuickPanel';
import { ParamsColor } from './Params';
declare function noop(): void;
export interface ColorPickerProps {
    alpha?: number;
    children?: React.ReactNode;
    className?: string;
    color?: string | ParamsColor | Color;
    colorMap?: string[];
    defaultAlpha?: number;
    defaultColor?: string;
    disabled?: boolean;
    enableAlpha?: boolean;
    enableHistory?: boolean;
    maxHistory?: number;
    mode?: 'RGB' | 'HSL' | 'HSB';
    onChange?: (color: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    prefixCls?: string;
    quickMode?: boolean;
    style?: React.CSSProperties;
    popupStyle?: React.CSSProperties;
    esc?: boolean;
    transitionName?: string;
    getPopupContainer?: (triggerNode: HTMLElement) => HTMLElement;
    align?: string;
    animation?: string;
}
interface ColorPickerState {
    visible?: boolean;
    color?: string;
    alpha?: number;
    colorHistory?: ColorType[];
}
declare class ColorPicker extends React.Component<ColorPickerProps, ColorPickerState> {
    static Panel: typeof ColorPickerPanel;
    static QuickPanel: typeof QuickPanel;
    static propTypes: {
        alpha: any;
        children: any;
        className: any;
        color: any;
        colorMap: any;
        defaultAlpha: any;
        defaultColor: any;
        disabled: any;
        enableAlpha: any;
        enableHistory: any;
        maxHistory: any;
        mode: any;
        onChange: any;
        onVisibleChange: any;
        prefixCls: any;
        quickMode: any;
        style: any;
        popupStyle: any;
        esc: any;
    };
    static defaultProps: {
        children: JSX.Element;
        className: string;
        colorMap: string[];
        defaultAlpha: number;
        defaultColor: string;
        disabled: boolean;
        enableAlpha: boolean;
        enableHistory: boolean;
        maxHistory: number;
        onChange: typeof noop;
        onVisibleChange: typeof noop;
        prefixCls: string;
        quickMode: boolean;
        style: {};
        popupStyle: {};
        esc: boolean;
    };
    static getDerivedStateFromProps(nextProps: any, prevState: any): {
        color?: string;
        alpha?: number;
    };
    constructor(props: any);
    saveTriggerRef: HTMLElement | null;
    triggerInstance: any;
    onChange: (colors: any) => void;
    onBlur: () => void;
    onVisibleChangeFromTrigger: (visible: any) => void;
    onPanelMount: (panelDOMRef: any) => void;
    setVisible: (visible: boolean, callback?: any) => void;
    getRootDOMNode: () => Element | Text;
    getTriggerDOMNode: () => Element | Text;
    getPickerElement: () => JSX.Element;
    focus: () => void;
    handleKeyDown: (e: any) => void;
    render(): JSX.Element;
}
export default ColorPicker;
