import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _slicedToArray from "@babel/runtime-corejs3/helpers/slicedToArray";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import { findDOMNode } from 'react-dom';
import PropTypes from 'prop-types';
import Trigger from 'rc-trigger';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import { KeyCode } from '../../utils';
import ColorPickerPanel from './Panel';
import placements from './placements';
import Color from './helpers/color';
import QuickPanel from './QuickPanel';
function refFn(field, component) {
  this[field] = component;
}
function prevent(e) {
  e.preventDefault();
}
function noop() {}
var ColorPicker = /*#__PURE__*/function (_React$Component) {
  _inherits(ColorPicker, _React$Component);
  var _super = _createSuper(ColorPicker);
  function ColorPicker(props) {
    var _this;
    _classCallCheck(this, ColorPicker);
    _this = _super.call(this, props);
    _this.onChange = function (colors) {
      _this.setState(_Object$assign({}, colors), function () {
        _this.props.onChange(_this.state);
      });
    };
    _this.onBlur = function () {
      _this.setVisible(false);
    };
    _this.onVisibleChangeFromTrigger = function (visible) {
      _this.setVisible(visible);
    };
    _this.onPanelMount = function (panelDOMRef) {
      if (_this.state.visible) {
        _setTimeout(function () {
          panelDOMRef.focus();
        }, 0);
      }
    };
    _this.setVisible = function (visible, callback) {
      if (_this.state.visible !== visible) {
        _this.setState({
          visible: visible
        }, function () {
          if (typeof callback === 'function') callback();
          var _this$props = _this.props,
            onVisibleChange = _this$props.onVisibleChange,
            enableHistory = _this$props.enableHistory,
            maxHistory = _this$props.maxHistory;
          onVisibleChange(_this.state.visible);
          //关闭时记录历史记录
          if (!_this.state.visible && enableHistory) {
            var _context, _context2;
            var _this$state = _this.state,
              color = _this$state.color,
              _alpha = _this$state.alpha,
              colorHistory = _this$state.colorHistory;
            // @ts-ignore
            if (colorHistory.length && color === colorHistory[0].color && _alpha === colorHistory[0].alpha) return;
            var history = colorHistory.length >= maxHistory ? _concatInstanceProperty(_context = [{
              color: color,
              alpha: _alpha
            }]).call(_context, _toConsumableArray(_sliceInstanceProperty(colorHistory).call(colorHistory, 0, -1))) : _concatInstanceProperty(_context2 = [{
              color: color,
              alpha: _alpha
            }]).call(_context2, _toConsumableArray(colorHistory));
            // @ts-ignore
            _this.setState({
              colorHistory: history
            });
          }
        });
      }
    };
    _this.getRootDOMNode = function () {
      return findDOMNode(_assertThisInitialized(_this));
    };
    _this.getTriggerDOMNode = function () {
      return findDOMNode(_this.triggerInstance);
    };
    _this.getPickerElement = function () {
      if (_this.props.quickMode) {
        return /*#__PURE__*/React.createElement(QuickPanel, {
          __useInComponent: true,
          onMount: _this.onPanelMount,
          defaultColor: _this.state.color,
          color: _this.state.color,
          onChange: _this.onChange,
          onVisibleChange: _this.setVisible,
          onBlur: _this.onBlur,
          colorMap: _this.props.colorMap,
          className: _this.props.className,
          userSelectColor: false,
          esc: _this.props.esc
        });
      }
      return /*#__PURE__*/React.createElement(ColorPickerPanel, {
        onMount: _this.onPanelMount,
        defaultColor: _this.state.color,
        alpha: _this.state.alpha,
        enableAlpha: _this.props.enableAlpha,
        prefixCls: "".concat(_this.props.prefixCls, "-panel"),
        onChange: _this.onChange,
        onBlur: _this.onBlur,
        mode: _this.props.mode,
        className: _this.props.className,
        colorHistory: _this.state.colorHistory,
        enableHistory: _this.props.enableHistory,
        maxHistory: _this.props.maxHistory
      });
    };
    _this.focus = function () {
      if (!_this.state.visible) {
        findDOMNode(_assertThisInitialized(_this)).focus();
      }
    };
    _this.handleKeyDown = function (e) {
      var keyCode = e.keyCode;
      if (keyCode === KeyCode.ESC && _this.props.esc || keyCode === KeyCode.ENTER) {
        _this.setVisible(false);
      }
    };
    var alpha = typeof props.alpha === 'undefined' ? props.defaultAlpha : Math.min(props.alpha, props.defaultAlpha);
    _this.state = {
      color: props.color || props.defaultColor,
      alpha: alpha,
      visible: false,
      colorHistory: []
    };
    _this.saveTriggerRef = _bindInstanceProperty(refFn).call(refFn, _assertThisInitialized(_this), 'triggerInstance');
    return _this;
  }
  _createClass(ColorPicker, [{
    key: "render",
    value: function render() {
      var _classNames;
      var props = this.props;
      var state = this.state;
      var classes = ["".concat(props.prefixCls, "-wrap"), props.className];
      if (state.visible) {
        classes.push("".concat(props.prefixCls, "-open"));
      }
      var children = props.children;
      var _Color$RGB = _slicedToArray(new Color(this.state.color).RGB, 3),
        r = _Color$RGB[0],
        g = _Color$RGB[1],
        b = _Color$RGB[2];
      var RGBA = [r, g, b];
      RGBA.push(this.state.alpha / 100);
      if (children) {
        children = /*#__PURE__*/React.cloneElement(children, {
          ref: this.saveTriggerRef,
          unselectable: 'unselectable',
          style: _Object$assign(_Object$assign({}, props.style), {
            backgroundColor: "rgba(".concat(RGBA.join(','), ")")
          }),
          onMouseDown: prevent
        });
      }
      var prefixCls = props.prefixCls,
        popupStyle = props.popupStyle,
        getPopupContainer = props.getPopupContainer,
        align = props.align,
        animation = props.animation,
        disabled = props.disabled,
        transitionName = props.transitionName,
        quickMode = props.quickMode;
      var arrowCls = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-arrow"), true), _defineProperty(_classNames, "quick", quickMode), _classNames));
      return /*#__PURE__*/React.createElement("div", {
        className: classes.join(' ')
      }, /*#__PURE__*/React.createElement(Trigger, {
        popup: /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-content"),
          onKeyDown: this.handleKeyDown
        }, /*#__PURE__*/React.createElement("div", {
          className: arrowCls
        }), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-inner")
        }, this.getPickerElement())),
        popupAlign: align,
        builtinPlacements: placements,
        popupPlacement: 'topCenter',
        action: disabled ? [] : ['click'],
        destroyPopupOnHide: true,
        getPopupContainer: getPopupContainer,
        popupStyle: popupStyle,
        popupAnimation: animation,
        popupTransitionName: transitionName,
        popupVisible: state.visible,
        onPopupVisibleChange: this.onVisibleChangeFromTrigger,
        prefixCls: prefixCls
      }, children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if ('color' in nextProps) {
        newState.color = nextProps.color;
      }
      if ('alpha' in nextProps && nextProps.alpha !== undefined && nextProps.alpha !== null) {
        newState.alpha = nextProps.alpha;
      }
      return newState;
    }
  }]);
  return ColorPicker;
}(React.Component);
ColorPicker.Panel = ColorPickerPanel;
ColorPicker.QuickPanel = QuickPanel;
ColorPicker.propTypes = {
  alpha: PropTypes.number,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  color: PropTypes.string,
  colorMap: PropTypes.array,
  defaultAlpha: PropTypes.number,
  defaultColor: PropTypes.string,
  disabled: PropTypes.bool,
  enableAlpha: PropTypes.bool,
  enableHistory: PropTypes.bool,
  maxHistory: PropTypes.number,
  mode: PropTypes.oneOf(['RGB', 'HSL', 'HSB']),
  onChange: PropTypes.func,
  onVisibleChange: PropTypes.func,
  prefixCls: PropTypes.string.isRequired,
  quickMode: PropTypes.bool,
  style: PropTypes.object,
  popupStyle: PropTypes.object,
  esc: PropTypes.bool
};
ColorPicker.defaultProps = {
  children: /*#__PURE__*/React.createElement("span", {
    className: "fishd-color-picker-trigger"
  }),
  className: '',
  colorMap: ['#33bbff', '#337eff', '#8a73ff', '#bb67e6', '#f290b6', '#f24957', '#cc613d', '#faa702', '#ffe500', '#aacc00', '#26bf40', '#3dd9af'],
  defaultAlpha: 100,
  defaultColor: '#33bbff',
  disabled: false,
  enableAlpha: false,
  enableHistory: true,
  maxHistory: 8,
  onChange: noop,
  onVisibleChange: noop,
  prefixCls: 'fishd-color-picker',
  quickMode: false,
  style: {},
  popupStyle: {},
  esc: true
};
polyfill(ColorPicker);
export default ColorPicker;