import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _slicedToArray from "@babel/runtime-corejs3/helpers/slicedToArray";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Array$from from "@babel/runtime-corejs3/core-js-stable/array/from";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import Color from './helpers/color';
var History = /*#__PURE__*/function (_React$Component) {
  _inherits(History, _React$Component);
  var _super = _createSuper(History);
  function History() {
    _classCallCheck(this, History);
    return _super.apply(this, arguments);
  }
  _createClass(History, [{
    key: "render",
    value: function render() {
      var _this = this;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        colorHistory = _this$props.colorHistory,
        maxHistory = _this$props.maxHistory;
      var renderColors = _toConsumableArray(colorHistory);
      if (colorHistory.length < maxHistory) {
        var _context;
        var historyList = _Array$from({
          length: maxHistory - colorHistory.length
        });
        renderColors = _concatInstanceProperty(_context = []).call(_context, _toConsumableArray(renderColors), _toConsumableArray(historyList));
      }
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-history")
      }, _mapInstanceProperty(renderColors).call(renderColors, function (obj, key) {
        if (obj) {
          var props = {};
          if (_typeof(obj) === 'object') {
            var _Color$RGB = _slicedToArray(new Color(obj.color).RGB, 3),
              r = _Color$RGB[0],
              g = _Color$RGB[1],
              b = _Color$RGB[2];
            var RGBA = [r, g, b];
            RGBA.push(obj.alpha / 100);
            props = {
              key: key,
              onClick: function onClick() {
                return _this.props.onHistoryClick(obj);
              },
              className: "".concat(prefixCls, "-history-color"),
              style: {
                background: "rgba(".concat(RGBA.join(','), ")")
              }
            };
          } else if (typeof obj === 'string') {
            props = {
              key: key,
              onClick: function onClick() {
                return _this.props.onHistoryClick({
                  color: obj,
                  alpha: 100
                });
              },
              className: "".concat(prefixCls, "-history-color"),
              style: {
                background: obj
              }
            };
          }
          return /*#__PURE__*/React.createElement("span", _Object$assign({}, props));
        } else {
          var _props = {
            key: key,
            className: "".concat(prefixCls, "-history-color 111")
          };
          return /*#__PURE__*/React.createElement("span", _Object$assign({}, _props));
        }
      }));
    }
  }]);
  return History;
}(React.Component);
export { History as default };
History.propTypes = {
  colorHistory: PropTypes.array,
  maxHistory: PropTypes.number,
  onHistoryClick: PropTypes.func,
  prefixCls: PropTypes.string
};