import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
// @ts-nocheck
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import Color from './helpers/color';
import typeColor from './utils/validationColor';
import Params from './Params';
import Board from './Board';
import Preview from './Preview';
import Ribbon from './Ribbon';
import Alpha from './Alpha';
import History from './History';
function noop() {}
var Panel = /*#__PURE__*/function (_React$Component) {
  _inherits(Panel, _React$Component);
  var _super = _createSuper(Panel);
  function Panel(props) {
    var _this;
    _classCallCheck(this, Panel);
    _this = _super.call(this, props);
    _this.onSystemColorPickerOpen = function (e) {
      // only work with broswer which support color input
      if (e.target.type === 'color') {
        _this.systemColorPickerOpen = true;
      }
    };
    _this.onFocus = function () {
      if (_this._blurTimer) {
        clearTimeout(_this._blurTimer);
        _this._blurTimer = null;
      } else {
        _this.props.onFocus();
      }
    };
    _this.onBlur = function () {
      if (_this._blurTimer) {
        clearTimeout(_this._blurTimer);
      }
      _this._blurTimer = _setTimeout(function () {
        // if is system color picker open, then stop run blur
        if (_this.systemColorPickerOpen) {
          _this.systemColorPickerOpen = false;
          return;
        }
        _this.props.onBlur();
      }, 100);
    };
    /**
     * 响应 alpha 的变更
     * @param  {Number} alpha Range 0~100
     */
    _this.handleAlphaChange = function (alpha) {
      var color = _this.state.color;
      color.alpha = alpha;
      _this.setState({
        alpha: alpha,
        color: color
      });
      _this.props.onChange({
        color: color.toHexString(),
        alpha: alpha
      });
    };
    /**
     * color change
     * @param  {Object}  color      tinycolor instance
     */
    _this.handleChange = function (color) {
      var alpha = _this.state.alpha;
      color.alpha = alpha;
      _this.setState({
        color: color
      });
      _this.props.onChange({
        color: color.toHexString(),
        alpha: color.alpha
      });
    };
    /**
     * 响应 History 的变更
     * @param  {Object} obj color and alpha
     */
    _this.handleHistoryClick = function (obj) {
      _this.setState({
        color: new Color(obj.color),
        alpha: obj.alpha
      });
      _this.props.onChange({
        color: obj.color,
        alpha: obj.alpha
      });
    };
    var alpha = typeof props.alpha === 'undefined' ? props.defaultAlpha : Math.min(props.alpha, props.defaultAlpha);
    var color = new Color(props.color || props.defaultColor);
    _this.state = {
      color: color,
      alpha: alpha
    };
    return _this;
  }
  _createClass(Panel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.onMount(this.ref);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        enableAlpha = _this$props.enableAlpha,
        enableHistory = _this$props.enableHistory,
        colorHistory = _this$props.colorHistory;
      var _this$state = this.state,
        color = _this$state.color,
        alpha = _this$state.alpha;
      var wrapClasses = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-wrap"), true), _defineProperty(_classNames, "".concat(prefixCls, "-wrap-has-alpha"), enableAlpha), _classNames));
      return /*#__PURE__*/React.createElement("div", {
        ref: function ref(_ref) {
          return _this2.ref = _ref;
        },
        className: [prefixCls, this.props.className].join(' '),
        style: this.props.style,
        onFocus: this.onFocus,
        onBlur: this.onBlur,
        tabIndex: 0
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-inner")
      }, /*#__PURE__*/React.createElement(Board, {
        rootPrefixCls: prefixCls,
        color: color,
        onChange: this.handleChange
      }), /*#__PURE__*/React.createElement("div", {
        className: wrapClasses
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-wrap-ribbon")
      }, /*#__PURE__*/React.createElement(Ribbon, {
        rootPrefixCls: prefixCls,
        color: color,
        onChange: this.handleChange
      })), enableAlpha && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-wrap-alpha")
      }, /*#__PURE__*/React.createElement(Alpha, {
        rootPrefixCls: prefixCls,
        alpha: alpha,
        color: color,
        onChange: this.handleAlphaChange
      })), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-wrap-preview")
      }, /*#__PURE__*/React.createElement(Preview, {
        rootPrefixCls: prefixCls,
        alpha: alpha,
        onChange: this.handleChange,
        onInputClick: this.onSystemColorPickerOpen,
        color: color
      }))), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-wrap"),
        style: {
          height: 40,
          marginTop: 6
        }
      }, /*#__PURE__*/React.createElement(Params, {
        rootPrefixCls: prefixCls,
        color: color,
        alpha: alpha,
        onAlphaChange: this.handleAlphaChange,
        onChange: this.handleChange,
        mode: this.props.mode,
        enableAlpha: this.props.enableAlpha,
        enableHistory: this.props.enableHistory
      })), enableHistory && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-wrap-history")
      }, /*#__PURE__*/React.createElement(History, {
        prefixCls: prefixCls,
        colorHistory: colorHistory,
        onHistoryClick: this.handleHistoryClick,
        maxHistory: this.props.maxHistory
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if ('color' in nextProps) {
        newState.color = new Color(nextProps.color);
      }
      if ('alpha' in nextProps && nextProps.alpha !== undefined) {
        newState.alpha = nextProps.alpha;
      }
      return newState;
    }
  }]);
  return Panel;
}(React.Component);
Panel.propTypes = {
  alpha: PropTypes.number,
  className: PropTypes.string,
  color: typeColor,
  colorHistory: PropTypes.array,
  defaultAlpha: PropTypes.number,
  defaultColor: typeColor,
  enableAlpha: PropTypes.bool,
  enableHistory: PropTypes.bool,
  maxHistory: PropTypes.number,
  mode: PropTypes.oneOf(['RGB', 'HSL', 'HSB']),
  onBlur: PropTypes.func,
  onChange: PropTypes.func,
  onFocus: PropTypes.func,
  onMount: PropTypes.func,
  prefixCls: PropTypes.string,
  style: PropTypes.object
};
Panel.defaultProps = {
  className: '',
  colorHistory: [],
  defaultAlpha: 100,
  defaultColor: '#e93334',
  enableAlpha: false,
  enableHistory: true,
  maxHistory: 8,
  mode: 'RGB',
  onBlur: noop,
  onChange: noop,
  onFocus: noop,
  onMount: noop,
  prefixCls: 'fishd-color-picker-panel',
  style: {}
};
polyfill(Panel);
export default Panel;