import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _parseInt from "@babel/runtime-corejs3/core-js-stable/parse-int";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import Color from './helpers/color';
import percentage from './helpers/percentage';
var modesMap = ['RGB', 'HSB'];
var Params = /*#__PURE__*/function (_React$Component) {
  _inherits(Params, _React$Component);
  var _super = _createSuper(Params);
  function Params(props) {
    var _this;
    _classCallCheck(this, Params);
    _this = _super.call(this, props);
    _this.getChannelInRange = function (value, index) {
      var channelMap = {
        RGB: [[0, 255], [0, 255], [0, 255]],
        HSB: [[0, 359], [0, 100], [0, 100]]
      };
      var mode = _this.state.mode;
      var range = channelMap[mode][index];
      var result = _parseInt(value, 10);
      if (isNaN(result)) {
        result = 0;
      }
      result = Math.max(range[0], result);
      result = Math.min(result, range[1]);
      return result;
    };
    _this.getPrefixCls = function () {
      return "".concat(_this.props.rootPrefixCls, "-params");
    };
    _this.handleHexBlur = function () {
      var hex = _this.state.hex;
      var color = null;
      if (Color.isValidHex(hex)) {
        color = new Color(hex);
      }
      if (color !== null) {
        _this.setState({
          color: color,
          hex: hex
        });
        _this.props.onChange(color, false);
      }
    };
    _this.handleHexPress = function (event) {
      var hex = _this.state.hex;
      if (event.nativeEvent.which === 13) {
        var color = null;
        if (Color.isValidHex(hex)) {
          color = new Color(hex);
        }
        if (color !== null) {
          _this.setState({
            color: color,
            hex: hex
          });
          _this.props.onChange(color, false);
        }
      }
    };
    _this.handleHexChange = function (event) {
      var hex = event.target.value;
      _this.setState({
        hex: hex
      });
    };
    _this.handleModeChange = function () {
      var mode = _this.state.mode;
      var modeIndex = (_indexOfInstanceProperty(modesMap).call(modesMap, mode) + 1) % modesMap.length;
      mode = modesMap[modeIndex];
      _this.setState({
        mode: mode
      });
    };
    _this.handleAlphaHandler = function (event) {
      var alpha = _parseInt(event.target.value, 10);
      if (isNaN(alpha)) {
        alpha = 0;
      }
      alpha = Math.max(0, alpha);
      alpha = Math.min(alpha, 100);
      _this.props.onAlphaChange(alpha);
    };
    _this.updateColorByChanel = function (channel, value) {
      var color = _this.props.color;
      var mode = _this.state.mode;
      if (mode === 'HSB') {
        if (channel === 'H') {
          color.hue = _parseInt(value, 10);
        } else if (channel === 'S') {
          color.saturation = _parseInt(value, 10) / 100;
        } else if (channel === 'B') {
          color.brightness = _parseInt(value, 10) / 100;
        }
      } else {
        if (channel === 'R') {
          color.red = _parseInt(value, 10);
        } else if (channel === 'G') {
          color.green = _parseInt(value, 10);
        } else if (channel === 'B') {
          color.blue = _parseInt(value, 10);
        }
      }
      return color;
    };
    _this.handleColorChannelChange = function (index, event) {
      var value = _this.getChannelInRange(event.target.value, index);
      var mode = _this.state.mode;
      var channel = mode[index];
      var color = _this.updateColorByChanel(channel, value);
      _this.setState({
        hex: color.hex,
        color: color
      }, function () {
        _this.props.onChange(color, false);
      });
    };
    // 管理 input 的状态
    _this.state = {
      mode: props.mode,
      hex: props.color.hex,
      color: props.color // instanceof tinycolor
    };
    return _this;
  }
  _createClass(Params, [{
    key: "render",
    value: function render() {
      var _classNames, _context, _context2, _context3;
      var prefixCls = this.getPrefixCls();
      var _this$props = this.props,
        enableAlpha = _this$props.enableAlpha,
        enableHistory = _this$props.enableHistory;
      var _this$state = this.state,
        mode = _this$state.mode,
        color = _this$state.color;
      var colorChannel = color[mode];
      if (mode === 'HSB') {
        colorChannel[0] = _parseInt(colorChannel[0], 10);
        colorChannel[1] = percentage(colorChannel[1]);
        colorChannel[2] = percentage(colorChannel[2]);
      }
      var paramsClasses = classNames((_classNames = {}, _defineProperty(_classNames, prefixCls, true), _defineProperty(_classNames, "".concat(prefixCls, "-has-history"), enableHistory), _defineProperty(_classNames, "".concat(prefixCls, "-has-alpha"), enableAlpha), _classNames));
      return /*#__PURE__*/React.createElement("div", {
        className: paramsClasses
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-input")
      }, /*#__PURE__*/React.createElement("input", {
        className: "".concat(prefixCls, "-hex"),
        type: "text",
        maxLength: 6,
        onKeyPress: this.handleHexPress,
        onBlur: this.handleHexBlur,
        onChange: this.handleHexChange,
        value: this.state.hex.toLowerCase()
      }), /*#__PURE__*/React.createElement("input", {
        type: "number",
        ref: "channel_0",
        value: colorChannel[0],
        onChange: _bindInstanceProperty(_context = this.handleColorChannelChange).call(_context, null, 0)
      }), /*#__PURE__*/React.createElement("input", {
        type: "number",
        ref: "channel_1",
        value: colorChannel[1],
        onChange: _bindInstanceProperty(_context2 = this.handleColorChannelChange).call(_context2, null, 1)
      }), /*#__PURE__*/React.createElement("input", {
        type: "number",
        ref: "channel_2",
        value: colorChannel[2],
        onChange: _bindInstanceProperty(_context3 = this.handleColorChannelChange).call(_context3, null, 2)
      }), enableAlpha && /*#__PURE__*/React.createElement("input", {
        type: "number",
        value: Math.round(this.props.alpha),
        onChange: this.handleAlphaHandler
      })), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-lable")
      }, /*#__PURE__*/React.createElement("label", {
        className: "".concat(prefixCls, "-lable-hex")
      }, "Hex"), /*#__PURE__*/React.createElement("label", {
        className: "".concat(prefixCls, "-lable-number"),
        onClick: this.handleModeChange
      }, mode[0]), /*#__PURE__*/React.createElement("label", {
        className: "".concat(prefixCls, "-lable-number"),
        onClick: this.handleModeChange
      }, mode[1]), /*#__PURE__*/React.createElement("label", {
        className: "".concat(prefixCls, "-lable-number"),
        onClick: this.handleModeChange
      }, mode[2]), enableAlpha && /*#__PURE__*/React.createElement("label", {
        className: "".concat(prefixCls, "-lable-alpha")
      }, "A")));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if ('color' in nextProps) {
        newState.color = nextProps.color;
        newState.hex = nextProps.color.hex;
      }
      return newState;
    }
  }]);
  return Params;
}(React.Component);
Params.propTypes = {
  alpha: PropTypes.number,
  color: PropTypes.object.isRequired,
  enableAlpha: PropTypes.bool,
  enableHistory: PropTypes.bool,
  mode: PropTypes.oneOf(modesMap),
  onAlphaChange: PropTypes.func,
  onChange: PropTypes.func,
  rootPrefixCls: PropTypes.string
};
Params.defaultProps = {
  mode: modesMap[0],
  enableAlpha: true
};
polyfill(Params);
export default Params;