import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import tinycolor from 'tinycolor2';
var Color = /*#__PURE__*/function () {
  function Color(input) {
    var _this = this;
    _classCallCheck(this, Color);
    this.initRgb = function () {
      var _this$color$toRgb = _this.color.toRgb(),
        r = _this$color$toRgb.r,
        g = _this$color$toRgb.g,
        b = _this$color$toRgb.b;
      _this.redValue = r;
      _this.greenValue = g;
      _this.blueValue = b;
    };
    this.initHsb = function () {
      var _this$color$toHsv = _this.color.toHsv(),
        h = _this$color$toHsv.h,
        s = _this$color$toHsv.s,
        v = _this$color$toHsv.v;
      _this.hueValue = h;
      _this.saturationValue = s;
      _this.brightnessValue = v;
    };
    this.toHexString = function () {
      return _this.color.toHexString();
    };
    this.toRgbString = function () {
      return _this.color.toRgbString();
    };
    this.color = tinycolor(input);
    this.initRgb();
    this.initHsb();
    var initAlpha = input && input.alpha || this.color.toRgb().a;
    this.alphaValue = Math.min(1, initAlpha) * 100;
  }
  _createClass(Color, [{
    key: "hex",
    get: function get() {
      return this.color.toHex();
    }
    // 色调
  }, {
    key: "hue",
    get: function get() {
      return this.hueValue;
    }
    // 饱和度
    ,
    set: function set(value) {
      this.color = tinycolor({
        h: value,
        s: this.saturation,
        v: this.brightness
      });
      this.initRgb();
      this.hueValue = value;
    }
  }, {
    key: "saturation",
    get: function get() {
      return this.saturationValue;
    }
    // 亮度
    ,
    set: function set(value) {
      this.color = tinycolor({
        h: this.hue,
        s: value,
        v: this.brightness
      });
      this.initRgb();
      this.saturationValue = value;
    }
  }, {
    key: "lightness",
    get: function get() {
      return this.lightnessValue;
    },
    set: function set(value) {
      this.color = tinycolor({
        h: this.hue,
        s: this.saturation,
        l: value
      });
      this.initRgb();
      this.lightnessValue = value;
    }
  }, {
    key: "brightness",
    get: function get() {
      return this.brightnessValue;
    }
    // red
    ,
    set: function set(value) {
      this.color = tinycolor({
        h: this.hue,
        s: this.saturation,
        v: value
      });
      this.initRgb();
      this.brightnessValue = value;
    }
  }, {
    key: "red",
    get: function get() {
      return this.redValue;
    }
    // green
    ,
    set: function set(value) {
      var rgb = this.color.toRgb();
      this.color = tinycolor(_Object$assign(_Object$assign({}, rgb), {
        r: value
      }));
      this.initHsb();
      this.redValue = value;
    }
  }, {
    key: "green",
    get: function get() {
      return this.greenValue;
    }
    // blue
    ,
    set: function set(value) {
      var rgb = this.color.toRgb();
      this.color = tinycolor(_Object$assign(_Object$assign({}, rgb), {
        g: value
      }));
      this.initHsb();
      this.greenValue = value;
    }
  }, {
    key: "blue",
    get: function get() {
      return this.blueValue;
    }
    // alpha
    ,
    set: function set(value) {
      var rgb = this.color.toRgb();
      this.color = tinycolor(_Object$assign(_Object$assign({}, rgb), {
        b: value
      }));
      this.initHsb();
      this.blueValue = value;
    }
  }, {
    key: "alpha",
    get: function get() {
      return this.color.getAlpha() * 100;
    },
    set: function set(value) {
      this.color.setAlpha(value / 100);
    }
  }, {
    key: "RGB",
    get: function get() {
      return [this.red, this.green, this.blue];
    }
  }, {
    key: "HSB",
    get: function get() {
      return [this.hue, this.saturation, this.brightness];
    }
  }], [{
    key: "isValidHex",
    value: function isValidHex(hex) {
      return tinycolor(hex).isValid();
    }
  }]);
  return Color;
}();
export { Color as default };