import * as React from 'react';
import Input from '../Input';
import { TimeSelectProps } from './TimeSelect';
export declare enum Mode {
    YEAR = "year",
    MONTH = "month",
    WEEK = "week",
    DAY = "day",
    RANGE = "range"
}
export declare type Placement = 'bottomLeft' | 'bottomCenter' | 'bottomRight' | 'topLeft' | 'topCenter' | 'topRight';
export declare type BasePickerProps = {
    allowClear?: boolean;
    className?: string;
    disabled?: boolean;
    esc?: boolean;
    shortcuts?: {
        text: string;
        onClick: () => void;
    }[];
    placeholder?: string;
    format?: string;
    placement?: Placement;
    prefixCls?: string;
    getPopupContainer?: (triggerNode: HTMLElement) => HTMLElement;
    showTrigger?: boolean;
    firstDayOfWeek?: number;
    disabledDate?: (date?: Date, mode?: Mode) => boolean;
    footer?: () => HTMLElement | undefined;
    showWeekNumber?: boolean;
    showTime?: boolean;
    value?: Date;
    onFocus?: (e: React.FocusEvent) => void;
    onBlur?: (e: React.FocusEvent) => void;
    onChange?: (value: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    style?: React.CSSProperties;
    separator?: string;
    yearCount?: number;
    timeSelectMode?: 'TimePicker' | 'TimeSelect';
    timeSelectModeProps?: TimeSelectProps;
    timeSelectableRange?: string[];
};
interface BasePickerState {
    pickerVisible?: boolean;
    value?: Date;
    text?: string;
    confirmValue?: Date;
    type?: string;
    prevPropValue?: Date;
}
declare class BasePicker extends React.Component<BasePickerProps, BasePickerState> {
    static get propTypes(): {
        className: any;
        placeholder: any;
        format: any;
        disabledDate: any;
        footer: any;
        showTime: any;
        showWeekNumber: any;
        shortcuts: any;
        placement: any;
        prefixCls: any;
        firstDayOfWeek: any;
        getPopupContainer: any;
        showTrigger: any;
        allowClear: any;
        disabled: any;
        esc: any;
        value: any;
        onFocus: any;
        onBlur: any;
        onChange: any;
        onVisibleChange: any;
        style: any;
        yearCount: any;
    };
    static get defaultProps(): {
        placeholder: string;
        placement: string;
        prefixCls: string;
        showTrigger: boolean;
        allowClear: boolean;
        disabled: boolean;
        esc: boolean;
        onFocus: () => void;
        onBlur: () => void;
        onChange: () => void;
        onVisibleChange: () => void;
    };
    static getDerivedStateFromProps: React.GetDerivedStateFromProps<BasePickerProps, BasePickerState>;
    static dateToStr(date: Date, type: string, format: string, separator: string): string;
    type: string;
    inputClick: boolean;
    refInputRoot: Input;
    trigger: HTMLElement | null;
    constructor(props: any, _type?: any, state?: any);
    isDateValid(date: any): boolean;
    pickerPanel(state: BasePickerState, props?: BasePickerProps): void;
    getFormatSeparator(): any;
    onPicked: (value: any, isKeepPannel?: boolean, isConfirmValue?: boolean) => void;
    onCancelPicked: () => void;
    dateToStr(date: any): string;
    parseDate(dateStr: string): any;
    getFormat(): any;
    togglePickerVisible(): void;
    handleFocus: (e: React.FocusEvent) => void;
    handleBlur: (e: React.FocusEvent) => void;
    handleKeydown: (evt: any) => void;
    handleClickCloseIcon: (e: any) => void;
    onVisibleChange: (visible: any) => void;
    saveValidInputValue: () => void;
    render(): JSX.Element;
}
export default BasePicker;
