import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _trimInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/trim";
import _Symbol from "@babel/runtime-corejs3/core-js-stable/symbol";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import * as React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Input from '../Input';
import Icon from '../Icon';
import Trigger from 'rc-trigger';
import { HAVE_TRIGGER_TYPES, TYPE_VALUE_RESOLVER_MAP, DEFAULT_FORMATS } from './constants';
import { Errors, require_condition } from './libs/utils';
import KEYCODE from '../../utils/KeyCode';
import { isValidValue, equalDate } from '../../utils/date';
import placements from './placements';
import isEqual from 'lodash/isEqual';
var haveTriggerType = function haveTriggerType(type) {
  return _indexOfInstanceProperty(HAVE_TRIGGER_TYPES).call(HAVE_TRIGGER_TYPES, type) !== -1;
};
var isInputValid = function isInputValid(text, date) {
  if (_trimInstanceProperty(text).call(text) === '' || !isValidValue(date)) return false;
  return true;
};
var $type = _Symbol('type');
export var Mode;
(function (Mode) {
  Mode["YEAR"] = "year";
  Mode["MONTH"] = "month";
  Mode["WEEK"] = "week";
  Mode["DAY"] = "day";
  Mode["RANGE"] = "range";
})(Mode || (Mode = {}));
var BasePicker = /*#__PURE__*/function (_React$Component) {
  _inherits(BasePicker, _React$Component);
  var _super = _createSuper(BasePicker);
  function BasePicker(props, _type, state) {
    var _this$state2;
    var _this;
    _classCallCheck(this, BasePicker);
    _this = _super.call(this, props);
    _this.onPicked = function (value) {
      var isKeepPannel = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var isConfirmValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      _this.setState({
        pickerVisible: isKeepPannel,
        value: value,
        text: _this.dateToStr(value)
      }, function () {
        _this.props.onVisibleChange(isKeepPannel);
      });
      if (isConfirmValue) {
        _this.setState({
          confirmValue: value
        });
        _this.props.onChange(value);
      }
    };
    _this.onCancelPicked = function () {
      var confirmValue = _this.state.confirmValue;
      _this.setState({
        pickerVisible: false,
        value: confirmValue ? confirmValue : null,
        text: confirmValue ? _this.dateToStr(confirmValue) : ''
      }, function () {
        _this.props.onVisibleChange(false);
      });
    };
    // 聚焦
    _this.handleFocus = function (e) {
      _this.props.onFocus(e);
    };
    // 失焦
    _this.handleBlur = function (e) {
      _this.props.onBlur(e);
    };
    // 键盘事件
    _this.handleKeydown = function (evt) {
      var keyCode = evt.keyCode;
      // esc
      if (_this.props.esc && keyCode === KEYCODE.ESC) {
        _this.setState({
          pickerVisible: false
        }, function () {
          _this.props.onVisibleChange(false);
        });
        _this.refInputRoot.blur();
        evt.stopPropagation();
      }
      // enter
      if (keyCode === KEYCODE.ENTER) {
        _this.setState({
          pickerVisible: false
        }, function () {
          _this.saveValidInputValue();
        });
        _this.refInputRoot.blur();
      }
    };
    // 点击清空图标
    _this.handleClickCloseIcon = function (e) {
      e && e.stopPropagation();
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        allowClear = _this$props.allowClear;
      var text = _this.state.text;
      if (disabled || !allowClear) return;
      if (!text) {
        _this.togglePickerVisible();
      } else {
        _this.setState({
          text: '',
          value: null,
          pickerVisible: false,
          confirmValue: null
        }, function () {
          _this.props.onVisibleChange(false);
          _this.props.onChange(null);
        });
      }
    };
    // 面板打开或关闭的回调
    _this.onVisibleChange = function (visible) {
      if (_this.inputClick && !visible) {
        _this.inputClick = false;
        return;
      }
      _this.inputClick = false;
      _this.setState({
        pickerVisible: visible
      }, function () {
        if (!visible) {
          _this.saveValidInputValue();
        } else {
          _this.props.onVisibleChange(visible);
        }
      });
    };
    // 保存合法的输入值
    _this.saveValidInputValue = function () {
      var _this$state = _this.state,
        value = _this$state.value,
        confirmValue = _this$state.confirmValue;
      if (_this.isDateValid(value) && !equalDate(value, confirmValue)) {
        _this.onPicked(value, false, true);
      } else {
        _this.onCancelPicked();
      }
    };
    require_condition(typeof _type === 'string');
    _this.type = _type;
    _this.inputClick = false;
    _this.state = (_this$state2 = {}, _defineProperty(_this$state2, $type, _type), _defineProperty(_this$state2, "pickerVisible", false), _defineProperty(_this$state2, "value", null), _defineProperty(_this$state2, "text", ''), _defineProperty(_this$state2, "confirmValue", null), _this$state2);
    return _this;
  }
  _createClass(BasePicker, [{
    key: "isDateValid",
    value: function isDateValid(date) {
      return date === null || isValidValue(date);
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state, props) {
      throw new Errors.MethodImplementationRequiredError(props.toString());
    }
  }, {
    key: "getFormatSeparator",
    value: function getFormatSeparator() {
      return undefined;
    }
  }, {
    key: "dateToStr",
    value: function dateToStr(date) {
      return BasePicker.dateToStr(date, this.type, this.props.format, this.getFormatSeparator());
    }
    // (string) => Date | null
  }, {
    key: "parseDate",
    value: function parseDate(dateStr) {
      if (!dateStr) return null;
      var type = this.type;
      var parser = (TYPE_VALUE_RESOLVER_MAP[type] || TYPE_VALUE_RESOLVER_MAP['default']).parser;
      return parser(dateStr, this.getFormat(), this.getFormatSeparator());
    }
  }, {
    key: "getFormat",
    value: function getFormat() {
      return this.props.format || DEFAULT_FORMATS[this.type];
    }
  }, {
    key: "togglePickerVisible",
    value: function togglePickerVisible() {
      var _this2 = this;
      this.setState({
        pickerVisible: !this.state.pickerVisible
      }, function () {
        _this2.props.onVisibleChange(!_this2.state.pickerVisible);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        className = _this$props2.className,
        placeholder = _this$props2.placeholder,
        placement = _this$props2.placement,
        prefixCls = _this$props2.prefixCls,
        getPopupContainer = _this$props2.getPopupContainer,
        showTrigger = _this$props2.showTrigger,
        allowClear = _this$props2.allowClear,
        disabled = _this$props2.disabled,
        style = _this$props2.style;
      var _this$state3 = this.state,
        pickerVisible = _this$state3.pickerVisible,
        value = _this$state3.value,
        text = _this$state3.text;
      var triggerClass = function triggerClass() {
        var _context, _context2;
        return _includesInstanceProperty(_context = _this3.type).call(_context, 'date') || _includesInstanceProperty(_context2 = _this3.type).call(_context2, 'week') ? 'date-line' : 'time-line';
      };
      var calcIsShowTrigger = function calcIsShowTrigger() {
        if (showTrigger != null) {
          return !!showTrigger;
        } else {
          return haveTriggerType(_this3.type);
        }
      };
      // 前缀图标
      var prefixIcon = function prefixIcon() {
        if (calcIsShowTrigger()) {
          return /*#__PURE__*/React.createElement(Icon, {
            className: classNames("".concat(prefixCls, "-date-picker-icon"), 'prefix-iconfont'),
            type: triggerClass()
          });
        } else {
          return null;
        }
      };
      // 后缀图标
      var suffixIcon = function suffixIcon() {
        if (text && allowClear) {
          return /*#__PURE__*/React.createElement(Icon, {
            className: classNames("".concat(prefixCls, "-date-picker-icon"), 'suffix-iconfont'),
            type: "close-circle-fill",
            onClick: _this3.handleClickCloseIcon
          });
        } else {
          return null;
        }
      };
      // 下拉面板
      var getPickerPanel = function getPickerPanel() {
        return _this3.pickerPanel(_this3.state);
      };
      // 选择框
      var getInputPanel = function getInputPanel() {
        var _context3;
        return /*#__PURE__*/React.createElement("span", {
          className: classNames("".concat(prefixCls, "-date-editor"), className, {
            'is-have-trigger': calcIsShowTrigger(),
            'is-active': pickerVisible,
            'is-filled': !!value,
            'is-disable': disabled
          }),
          style: _Object$assign({}, style),
          onClick: function onClick() {
            return _this3.inputClick = true;
          }
        }, /*#__PURE__*/React.createElement("div", {
          className: classNames(_concatInstanceProperty(_context3 = "".concat(prefixCls, "-date-editor--")).call(_context3, _this3.type), {
            'is-active': pickerVisible,
            disabled: disabled
          })
        }, /*#__PURE__*/React.createElement(Input, {
          disabled: disabled,
          type: "text",
          placeholder: placeholder,
          onFocus: _this3.handleFocus,
          onBlur: _this3.handleBlur,
          onKeyDown: _this3.handleKeydown,
          onChange: function onChange(e) {
            var inputValue = e.target.value;
            var ndate = _this3.parseDate(inputValue);
            if (!isInputValid(inputValue, ndate)) {
              _this3.setState({
                text: inputValue,
                pickerVisible: true
              });
            } else {
              //only set value on a valid date input
              _this3.setState({
                text: inputValue,
                value: ndate,
                pickerVisible: true
              });
            }
          },
          ref: function ref(e) {
            return _this3.refInputRoot = e;
          },
          value: text,
          prefix: prefixIcon(),
          suffix: suffixIcon()
        })));
      };
      return /*#__PURE__*/React.createElement(Trigger, {
        action: disabled ? [] : ['click'],
        builtinPlacements: placements,
        ref: function ref(node) {
          return _this3.trigger = node;
        },
        getPopupContainer: getPopupContainer,
        onPopupVisibleChange: this.onVisibleChange,
        popup: getPickerPanel(),
        popupPlacement: placement,
        popupVisible: pickerVisible,
        prefixCls: "".concat(prefixCls, "-date-time-picker-popup"),
        destroyPopupOnHide: true
      }, getInputPanel());
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        className: PropTypes.string,
        placeholder: PropTypes.string,
        format: PropTypes.string,
        disabledDate: PropTypes.func,
        footer: PropTypes.func,
        showTime: PropTypes.bool,
        showWeekNumber: PropTypes.bool,
        shortcuts: PropTypes.arrayOf(PropTypes.shape({
          text: PropTypes.string.isRequired,
          onClick: PropTypes.func.isRequired
        })),
        placement: PropTypes.oneOf(['bottomLeft', 'bottomCenter', 'bottomRight', 'topLeft', 'topCenter', 'topRight']),
        prefixCls: PropTypes.string,
        firstDayOfWeek: PropTypes.number,
        getPopupContainer: PropTypes.func,
        showTrigger: PropTypes.bool,
        allowClear: PropTypes.bool,
        disabled: PropTypes.bool,
        esc: PropTypes.bool,
        value: PropTypes.instanceOf(Date),
        onFocus: PropTypes.func,
        onBlur: PropTypes.func,
        onChange: PropTypes.func,
        onVisibleChange: PropTypes.func,
        style: PropTypes.object,
        yearCount: PropTypes.number
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        placeholder: '',
        placement: 'bottomLeft',
        prefixCls: 'fishd',
        showTrigger: true,
        allowClear: true,
        disabled: false,
        esc: true,
        onFocus: function onFocus() {},
        onBlur: function onBlur() {},
        onChange: function onChange() {},
        onVisibleChange: function onVisibleChange() {}
      };
    }
  }, {
    key: "dateToStr",
    value: function dateToStr(date, type, format, separator) {
      if (!date || !isValidValue(date)) return '';
      var tdate = date;
      var formatter = (TYPE_VALUE_RESOLVER_MAP[type] || TYPE_VALUE_RESOLVER_MAP['default']).formatter;
      var result = formatter(tdate, format || DEFAULT_FORMATS[type], separator);
      return result;
    }
  }]);
  return BasePicker;
}(React.Component);
BasePicker.getDerivedStateFromProps = function (nextProps, prevState) {
  if ('value' in nextProps && !isEqual(nextProps.value, prevState.prevPropValue)) {
    var validDate = isValidValue(nextProps.value) ? nextProps.value : null;
    var text = isValidValue(nextProps.value) ? BasePicker.dateToStr(nextProps.value, prevState[$type], nextProps.format, nextProps.separator) : '';
    var state = {
      value: validDate,
      text: text,
      // 增加一个confirmValue记录每次确定的值，当点击"取消"或者输入不合法时，恢复这个值
      confirmValue: validDate
    };
    state.prevPropValue = nextProps.value;
    return state;
  }
  return null;
};
export default BasePicker;