import * as React from 'react';
import Input from '../Input';
import Trigger from 'rc-trigger';
import { Placement } from './BasePicker';
import { TimeSelectProps } from './TimeSelect';
declare type GetPopupContainer = (triggerNode: HTMLElement) => HTMLElement;
interface DateRangeBasePickerProps {
    className?: string;
    startPlaceholder?: string;
    endPlaceholder?: string;
    separator?: string;
    format?: string;
    placement?: Placement;
    prefixCls?: string;
    getPopupContainer?: GetPopupContainer;
    showTrigger?: boolean;
    allowClear?: boolean;
    disabled?: boolean;
    esc?: boolean;
    value?: Date[];
    onFocus?: (event: React.FocusEvent) => void;
    onBlur?: (event: React.FocusEvent) => void;
    onChange?: (value: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    style?: React.CSSProperties;
    showTime: boolean;
    disabledDate?: (date: Date, mode: string) => boolean;
    startTimeSelectMode: 'TimePicker' | 'TimeSelect';
    startTimeSelectModeProps?: TimeSelectProps;
    startTimeSelectableRange?: string | string[];
    endTimeSelectModeProps?: TimeSelectProps;
    endTimeSelectMode?: 'TimePicker' | 'TimeSelect';
    endTimeSelectableRange?: string | string[];
    onError?(value: any): any;
}
interface DateRangeBasePickerState {
    pickerVisible?: boolean;
    value?: Date[] | null;
    text?: Date | Date[] | string | string[];
    confirmValue?: Date[] | null | [];
    prevPropValue?: Date[] | null;
}
declare class DateRangeBasePicker extends React.Component<DateRangeBasePickerProps, DateRangeBasePickerState> {
    static get propTypes(): {
        className: any;
        startPlaceholder: any;
        endPlaceholder: any;
        separator: any;
        format: any;
        placement: any;
        prefixCls: any;
        getPopupContainer: any;
        showTrigger: any;
        allowClear: any;
        disabled: any;
        esc: any;
        value: any;
        onFocus: any;
        onBlur: any;
        onChange: any;
        onVisibleChange: any;
        style: any;
    };
    static get defaultProps(): {
        startPlaceholder: string;
        endPlaceholder: string;
        separator: string;
        placement: string;
        prefixCls: string;
        showTrigger: boolean;
        allowClear: boolean;
        disabled: boolean;
        esc: boolean;
        onFocus: () => void;
        onBlur: () => void;
        onChange: () => void;
        onVisibleChange: () => void;
    };
    static dateToStr(date: any, type: any, format: any, separator: any): string;
    static propToState({ value, format, separator }: DateRangeBasePickerProps, state: DateRangeBasePickerState): {
        value: Date[];
        text: string | string[];
        confirmValue: Date[];
    };
    static getDerivedStateFromProps: React.GetDerivedStateFromProps<DateRangeBasePickerProps, DateRangeBasePickerState>;
    type: string;
    inputClick: boolean;
    refInputRoot: Input;
    trigger: Trigger;
    constructor(props: DateRangeBasePickerProps, _type: any, state: DateRangeBasePickerState);
    isDateValid(date: any): boolean;
    pickerPanel(state?: any, props?: any): void;
    getFormatSeparator(): any;
    onError(value: any): any;
    onPicked: (value: Date[], isKeepPannel?: boolean, isConfirmValue?: boolean) => void;
    onCancelPicked: () => void;
    getFormat(): any;
    dateToStr: (date: any) => string;
    parseDate: (dateStr: string) => Date;
    togglePickerVisible(): void;
    handleFocus: (e: any) => void;
    handleBlur: (e: any) => void;
    handleKeydown: (evt: any) => void;
    handleClickCloseIcon: (e: any) => void;
    onVisibleChange: (visible: any) => void;
    saveValidInputValue: () => void;
    render(): JSX.Element;
}
export default DateRangeBasePicker;
