import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _trimInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/trim";
import _Symbol from "@babel/runtime-corejs3/core-js-stable/symbol";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import * as React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Input from '../Input';
import Icon from '../Icon';
import Trigger from 'rc-trigger';
import { HAVE_TRIGGER_TYPES, TYPE_VALUE_RESOLVER_MAP, DEFAULT_FORMATS } from './constants';
import { Errors, require_condition } from './libs/utils';
import KEYCODE from '../../utils/KeyCode';
import { isValidValue, isValidValueArr, equalDateArr } from '../../utils/date';
import placements from './placements';
import isEqual from 'lodash/isEqual';
import ConfigConsumer from '../Config/Consumer';
var haveTriggerType = function haveTriggerType(type) {
  return _indexOfInstanceProperty(HAVE_TRIGGER_TYPES).call(HAVE_TRIGGER_TYPES, type) !== -1;
};
var isInputValid = function isInputValid(text, date) {
  if (_trimInstanceProperty(text).call(text) === '' || !isValidValue(date)) return false;
  return true;
};
var $type = _Symbol('type');
var DateRangeBasePicker = /*#__PURE__*/function (_React$Component) {
  _inherits(DateRangeBasePicker, _React$Component);
  var _super = _createSuper(DateRangeBasePicker);
  function DateRangeBasePicker(props, _type, state) {
    var _this;
    _classCallCheck(this, DateRangeBasePicker);
    _this = _super.call(this, props);
    _this.onPicked = function (value) {
      var isKeepPannel = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var isConfirmValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      // 当为日期范围选择面板时，把结束时间默认设置为23:59:59:999
      if (_this.type == 'daterange' && value && value.length === 2) {
        value[1] = new Date(value[1].setHours(23, 59, 59, 999));
      }
      _this.setState({
        pickerVisible: isKeepPannel,
        value: value,
        text: value && value.length === 2 ? [_this.dateToStr(value[0]), _this.dateToStr(value[1])] : ''
      }, function () {
        _this.props.onVisibleChange(isKeepPannel);
      });
      if (isConfirmValue) {
        _this.setState({
          confirmValue: value
        });
        _this.props.onChange(value);
      }
    };
    _this.onCancelPicked = function () {
      _this.setState({
        pickerVisible: false,
        value: _this.state.confirmValue && _this.state.confirmValue.length === 2 ? _this.state.confirmValue : null,
        text: _this.state.confirmValue && _this.state.confirmValue.length === 2 ? [_this.dateToStr(new Date(_this.state.confirmValue[0])), _this.dateToStr(new Date(_this.state.confirmValue[1]))] : ''
      }, function () {
        _this.props.onVisibleChange(false);
      });
    };
    _this.dateToStr = function (date) {
      return DateRangeBasePicker.dateToStr(date, _this.type, _this.getFormat(), _this.getFormatSeparator());
    };
    _this.parseDate = function (dateStr) {
      if (!dateStr) return null;
      var type = _this.type;
      var parser = TYPE_VALUE_RESOLVER_MAP['date'].parser;
      return parser(dateStr, _this.getFormat(), _this.getFormatSeparator());
    };
    // 聚焦
    _this.handleFocus = function (e) {
      _this.props.onFocus(e);
    };
    // 失焦
    _this.handleBlur = function (e) {
      _this.props.onBlur(e);
    };
    // 键盘事件
    _this.handleKeydown = function (evt) {
      var keyCode = evt.keyCode;
      // esc
      if (_this.props.esc && keyCode === KEYCODE.ESC) {
        _this.setState({
          pickerVisible: false
        }, function () {
          _this.props.onVisibleChange(false);
        });
        _this.refInputRoot.blur();
        evt.stopPropagation();
      }
      // enter
      if (keyCode === KEYCODE.ENTER) {
        _this.setState({
          pickerVisible: false
        }, function () {
          _this.saveValidInputValue();
        });
        _this.refInputRoot.blur();
      }
    };
    // 点击清空图标
    _this.handleClickCloseIcon = function (e) {
      e && e.stopPropagation();
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        allowClear = _this$props.allowClear;
      var text = _this.state.text;
      if (disabled || !allowClear) return;
      if (!text) {
        _this.togglePickerVisible();
      } else {
        _this.setState({
          text: '',
          value: null,
          pickerVisible: false,
          confirmValue: null
        }, function () {
          _this.props.onVisibleChange(false);
          _this.props.onChange(null);
        });
      }
    };
    // 面板打开或关闭的回调
    _this.onVisibleChange = function (visible) {
      if (_this.inputClick && !visible) {
        _this.inputClick = false;
        return;
      }
      _this.inputClick = false;
      _this.setState({
        pickerVisible: visible
      }, function () {
        if (!visible) {
          _this.saveValidInputValue();
        } else {
          _this.props.onVisibleChange(visible);
        }
      });
    };
    // 保存合法的输入值
    _this.saveValidInputValue = function () {
      var _this$state = _this.state,
        value = _this$state.value,
        confirmValue = _this$state.confirmValue;
      if (value && value.length === 2 && _this.onError) {
        var error = _this.onError([value[0], value[1]]);
        if (error) {
          _this.setState({
            pickerVisible: error
          });
          return;
        }
      }
      if (_this.isDateValid(value) && !equalDateArr(value, confirmValue)) {
        _this.onPicked(value, false, true);
      } else {
        _this.onCancelPicked();
      }
    };
    require_condition(typeof _type === 'string');
    _this.type = _type;
    _this.inputClick = false;
    _this.state = {
      pickerVisible: false,
      value: props.value && isValidValueArr(props.value) ? props.value : null,
      text: props.value && isValidValueArr(props.value) ? [_this.dateToStr(props.value[0]), _this.dateToStr(props.value[1])] : '',
      // 增加一个confirmValue记录每次确定的值，当点击"取消"或者空白处时，恢复这个值
      confirmValue: props.value && isValidValueArr(props.value) ? props.value : null
    };
    return _this;
  }
  _createClass(DateRangeBasePicker, [{
    key: "isDateValid",
    value: function isDateValid(date) {
      return date === null || isValidValueArr(date);
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state, props) {
      throw new Errors.MethodImplementationRequiredError(props);
    }
  }, {
    key: "getFormatSeparator",
    value: function getFormatSeparator() {
      return undefined;
    }
  }, {
    key: "onError",
    value: function onError(value) {
      return undefined;
    }
  }, {
    key: "getFormat",
    value: function getFormat() {
      return this.props.format || DEFAULT_FORMATS[this.type];
    }
  }, {
    key: "togglePickerVisible",
    value: function togglePickerVisible() {
      var _this2 = this;
      this.setState({
        pickerVisible: !this.state.pickerVisible
      }, function () {
        _this2.props.onVisibleChange(!_this2.state.pickerVisible);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        startPlaceholder = _this$props2.startPlaceholder,
        endPlaceholder = _this$props2.endPlaceholder,
        separator = _this$props2.separator,
        showTrigger = _this$props2.showTrigger,
        allowClear = _this$props2.allowClear,
        disabled = _this$props2.disabled,
        className = _this$props2.className,
        placement = _this$props2.placement,
        prefixCls = _this$props2.prefixCls,
        getPopupContainer = _this$props2.getPopupContainer,
        style = _this$props2.style;
      var _this$state2 = this.state,
        pickerVisible = _this$state2.pickerVisible,
        value = _this$state2.value,
        text = _this$state2.text;
      var calcIsShowTrigger = function calcIsShowTrigger() {
        if (showTrigger !== null) {
          return !!showTrigger;
        } else {
          return haveTriggerType(_this3.type);
        }
      };
      var triggerClass = function triggerClass() {
        var _context, _context2;
        return _includesInstanceProperty(_context = _this3.type).call(_context, 'date') || _includesInstanceProperty(_context2 = _this3.type).call(_context2, 'week') ? 'date-line' : 'time-line';
      };
      // 前缀图标
      var prefixIcon = function prefixIcon() {
        if (calcIsShowTrigger()) {
          return /*#__PURE__*/React.createElement(Icon, {
            className: classNames("".concat(prefixCls, "-date-picker-icon"), 'prefix-iconfont'),
            type: triggerClass()
          });
        } else {
          return null;
        }
      };
      // 后缀图标
      var suffixIcon = function suffixIcon() {
        if (text && allowClear) {
          return /*#__PURE__*/React.createElement(Icon, {
            className: classNames("".concat(prefixCls, "-date-picker-icon"), 'suffix-iconfont'),
            type: "close-circle-fill",
            onClick: _this3.handleClickCloseIcon
          });
        } else {
          return null;
        }
      };
      // 下拉面板
      var getPickerPanel = function getPickerPanel() {
        return _this3.pickerPanel(_this3.state);
      };
      // 选择框
      var getInputPanel = function getInputPanel(locales) {
        var _context3;
        return /*#__PURE__*/React.createElement("span", {
          className: classNames("".concat(prefixCls, "-date-editor"), className, {
            'is-have-trigger': calcIsShowTrigger(),
            'is-active': pickerVisible,
            'is-filled': !!value,
            'is-disable': disabled
          }),
          style: _Object$assign({}, style),
          onClick: function onClick() {
            return _this3.inputClick = true;
          }
        }, /*#__PURE__*/React.createElement("div", {
          className: classNames(_concatInstanceProperty(_context3 = "".concat(prefixCls, "-date-editor--")).call(_context3, _this3.type), {
            'is-active': pickerVisible,
            disabled: disabled
          })
        }, /*#__PURE__*/React.createElement(Input, {
          disabled: disabled,
          type: "text",
          placeholder: startPlaceholder,
          onFocus: _this3.handleFocus,
          onBlur: _this3.handleBlur,
          onKeyDown: _this3.handleKeydown,
          onChange: function onChange(e) {
            var inputValue = e.target.value;
            var ndate = _this3.parseDate(inputValue);
            if (!isInputValid(inputValue, ndate)) {
              _this3.setState({
                text: [inputValue, _this3.state.text[1]],
                pickerVisible: true
              });
            } else {
              //only set value on a valid date input
              _this3.setState({
                text: [inputValue, _this3.state.text[1]],
                value: [ndate, _this3.state.value[1]],
                pickerVisible: true
              });
            }
          },
          ref: function ref(e) {
            return _this3.refInputRoot = e;
          },
          value: text && text.length == 2 ? text[0] : '',
          prefix: prefixIcon()
        }), /*#__PURE__*/React.createElement("span", {
          className: classNames('range-separator', {
            disabled: disabled
          })
        }, locales.separator), /*#__PURE__*/React.createElement(Input, {
          className: "".concat(prefixCls, "-date-range-picker-second-input"),
          disabled: disabled,
          type: "text",
          placeholder: endPlaceholder,
          onFocus: _this3.handleFocus,
          onBlur: _this3.handleBlur,
          onKeyDown: _this3.handleKeydown,
          onChange: function onChange(e) {
            var inputValue = e.target.value;
            var ndate = _this3.parseDate(inputValue);
            if (!isInputValid(inputValue, ndate)) {
              _this3.setState({
                text: [_this3.state.text[0], inputValue],
                pickerVisible: true
              });
            } else {
              //only set value on a valid date input
              _this3.setState({
                text: [_this3.state.text[0], inputValue],
                value: [_this3.state.value[0], ndate],
                pickerVisible: true
              });
            }
          },
          value: text && text.length == 2 ? text[1] : '',
          suffix: suffixIcon()
        })));
      };
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "DatePicker"
      }, function (Locales) {
        return /*#__PURE__*/React.createElement(Trigger, {
          action: disabled ? [] : ['click'],
          builtinPlacements: placements,
          ref: function ref(node) {
            return _this3.trigger = node;
          },
          getPopupContainer: getPopupContainer,
          onPopupVisibleChange: _this3.onVisibleChange,
          popup: getPickerPanel(),
          popupPlacement: placement,
          popupVisible: pickerVisible,
          prefixCls: "".concat(prefixCls, "-date-time-picker-popup"),
          destroyPopupOnHide: true
        }, getInputPanel(Locales));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        className: PropTypes.string,
        startPlaceholder: PropTypes.string,
        endPlaceholder: PropTypes.string,
        separator: PropTypes.string,
        format: PropTypes.string,
        placement: PropTypes.oneOf(['bottomLeft', 'bottomCenter', 'bottomRight', 'topLeft', 'topCenter', 'topRight']),
        prefixCls: PropTypes.string,
        getPopupContainer: PropTypes.func,
        showTrigger: PropTypes.bool,
        allowClear: PropTypes.bool,
        disabled: PropTypes.bool,
        esc: PropTypes.bool,
        value: PropTypes.arrayOf(PropTypes.instanceOf(Date)),
        onFocus: PropTypes.func,
        onBlur: PropTypes.func,
        onChange: PropTypes.func,
        onVisibleChange: PropTypes.func,
        style: PropTypes.object
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        startPlaceholder: '开始日期',
        endPlaceholder: '结束日期',
        separator: '至',
        placement: 'bottomLeft',
        prefixCls: 'fishd',
        showTrigger: true,
        allowClear: true,
        disabled: false,
        esc: true,
        onFocus: function onFocus() {},
        onBlur: function onBlur() {},
        onChange: function onChange() {},
        onVisibleChange: function onVisibleChange() {}
      };
    }
  }, {
    key: "dateToStr",
    value: function dateToStr(date, type, format, separator) {
      if (!date || !isValidValue(date)) return '';
      var tdate = date;
      var formatter = TYPE_VALUE_RESOLVER_MAP['date'].formatter;
      var result = formatter(tdate, format || DEFAULT_FORMATS[type], separator);
      return result;
    }
  }, {
    key: "propToState",
    value: function propToState(_ref, state) {
      var value = _ref.value,
        format = _ref.format,
        separator = _ref.separator;
      var type = state[$type];
      return {
        value: value && isValidValueArr(value) ? value : null,
        text: value && isValidValueArr(value) ? [DateRangeBasePicker.dateToStr(value[0], type, format, separator), DateRangeBasePicker.dateToStr(value[1], type, format, separator)] : '',
        confirmValue: value && isValidValueArr(value) ? value : null
      };
    }
  }]);
  return DateRangeBasePicker;
}(React.Component);
DateRangeBasePicker.getDerivedStateFromProps = function (nextProps, prevState) {
  // 只 value 受控
  if ('value' in nextProps && !isEqual(prevState.prevPropValue, nextProps.value)) {
    var state = DateRangeBasePicker.propToState(nextProps, prevState);
    state.prevPropValue = nextProps.value;
    return state;
  }
  return null;
};
export default DateRangeBasePicker;