/// <reference types="react" />
import DateRangeBasePicker from './DateRangeBasePicker';
export default class DateRangePicker extends DateRangeBasePicker {
    static get propTypes(): {
        separator: any;
        yearCount: any;
        shortcuts: any;
        disabledDate: any;
        firstDayOfWeek: any;
        footer: any;
        onError: any;
    } & {
        className: any;
        startPlaceholder: any;
        endPlaceholder: any;
        separator: any;
        format: any;
        placement: any;
        prefixCls: any;
        getPopupContainer: any;
        showTrigger: any;
        allowClear: any;
        disabled: any;
        esc: any;
        value: any;
        onFocus: any;
        onBlur: any;
        onChange: any;
        onVisibleChange: any;
        style: any;
    };
    static get defaultProps(): {
        prefixCls: string;
        yearCount: number;
        firstDayOfWeek: number;
        onError: () => void;
        defaultPanelMonth: Date;
        scene: string;
        showTime: boolean;
        showTimeCurrent: boolean;
        defaultStartTimeValue: any;
        defaultEndTimeValue: any;
        startTimeSelectMode: string;
        startTimeSelectModeProps: {
            start: string;
            end: string;
            step: string;
            minTime: string;
            maxTime: string;
        };
        endTimeSelectMode: string;
        endTimeSelectModeProps: {
            start: string;
            end: string;
            step: string;
            minTime: string;
            maxTime: string;
        };
    } & {
        startPlaceholder: string;
        endPlaceholder: string;
        separator: string;
        placement: string;
        prefixCls: string;
        showTrigger: boolean;
        allowClear: boolean;
        disabled: boolean;
        esc: boolean;
        onFocus: () => void;
        onBlur: () => void;
        onChange: () => void;
        onVisibleChange: () => void;
    };
    constructor(props: any);
    isDateValid(value: any): boolean;
    getFormatSeparator: () => string;
    onError: (value: any) => any;
    pickerPanel(state: any): JSX.Element;
}
