import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { Scrollbar } from '../scrollbar';
import debounce from 'lodash/debounce';
import { getRangeHours } from '../../../utils/date';
function range(end) {
  var r = [];
  for (var i = 0; i < end; i++) {
    r.push(i);
  }
  return r;
}
var isNumber = function isNumber(value) {
  return typeof value === 'number';
};
var validateHour = function validateHour(value) {
  return isNumber(value) && value >= 0 && value <= 23;
};
var validateMinOrSec = function validateMinOrSec(value) {
  return isNumber(value) && value >= 0 && value <= 59;
};
function propsToState(props) {
  var hours = props.hours,
    minutes = props.minutes,
    seconds = props.seconds,
    selectableRange = props.selectableRange;
  var state = {};
  var setOnValid = function setOnValid(isValid, cb) {
    return isValid && cb(state);
  };
  setOnValid(validateHour(hours), function (state) {
    return state.hours = hours;
  });
  setOnValid(validateMinOrSec(minutes), function (state) {
    return state.minutes = minutes;
  });
  setOnValid(validateMinOrSec(seconds), function (state) {
    return state.seconds = seconds;
  });
  state.hoursList = getRangeHours(selectableRange);
  state.minutesLisit = range(60);
  state.secondsList = range(60);
  return state;
}
var SCROLL_AJUST_VALUE = 85;
var calcScrollTop = function calcScrollTop(value) {
  return Math.max(0, (value - 2.5) * 32 + SCROLL_AJUST_VALUE);
};
var PROPS_MATTER = ['hours', "minutes", "seconds", "selectableRange"];
var propsChangeTester = function propsChangeTester(props, state) {
  return _someInstanceProperty(PROPS_MATTER).call(PROPS_MATTER, function (prop) {
    return state['__' + prop] !== props[prop];
  });
};
var propsChangeSaver = function propsChangeSaver(props, state) {
  return _forEachInstanceProperty(PROPS_MATTER).call(PROPS_MATTER, function (prop) {
    state['__' + prop] = props[prop];
  });
};
var TimeSpinner = /*#__PURE__*/function (_React$Component) {
  _inherits(TimeSpinner, _React$Component);
  var _super = _createSuper(TimeSpinner);
  function TimeSpinner(props) {
    var _context, _context2;
    var _this;
    _classCallCheck(this, TimeSpinner);
    _this = _super.call(this, props);
    _this.state = {
      hours: 0,
      minutes: 0,
      seconds: 0
    };
    _Object$assign(_this.state, propsToState(props));
    _this.ajustScrollTop = _bindInstanceProperty(_context = _this._ajustScrollTop).call(_context, _assertThisInitialized(_this));
    _this.handleScroll = debounce(_bindInstanceProperty(_context2 = _this._handleScroll).call(_context2, _assertThisInitialized(_this)), 20);
    return _this;
  }
  _createClass(TimeSpinner, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.ajustScrollTop(this.state);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      this.ajustScrollTop(this.state);
    }
  }, {
    key: "emitSelectRange",
    value: function emitSelectRange(type) {
      var onSelectRangeChange = this.props.onSelectRangeChange;
      if (type === 'hours') {
        onSelectRangeChange(0, 3);
      } else if (type === 'minutes') {
        onSelectRangeChange(3, 5);
      } else if (type === 'seconds') {
        onSelectRangeChange(6, 9);
      }
    }
  }, {
    key: "_handleScroll",
    value: function _handleScroll(_type) {
      var value = Math.min(Math.floor((this.refs[_type].refs.wrap.scrollTop - SCROLL_AJUST_VALUE) / 32 + 3), 59);
      this.handleChange(_type, value);
    }
    // type: hours, minutes, seconds
  }, {
    key: "handleChange",
    value: function handleChange(type, value, disabled) {
      var _this2 = this;
      if (disabled) return;
      this.state[type] = value; // eslint-disable-line react/no-direct-mutation-state
      var changed = {};
      changed[type] = value;
      this.setState({}, function () {
        _this2.ajustScrollTop(_this2.state);
      });
      this.props.onChange(changed);
    }
  }, {
    key: "_ajustScrollTop",
    value: function _ajustScrollTop(_ref) {
      var hours = _ref.hours,
        minutes = _ref.minutes,
        seconds = _ref.seconds;
      if (hours != null) {
        this.refs.hours.refs.wrap.scrollTop = calcScrollTop(hours);
      }
      if (minutes != null) {
        this.refs.minutes.refs.wrap.scrollTop = calcScrollTop(minutes);
      }
      if (this.props.isShowSeconds && seconds != null) {
        this.refs.seconds.refs.wrap.scrollTop = calcScrollTop(seconds);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$state = this.state,
        hoursList = _this$state.hoursList,
        minutesLisit = _this$state.minutesLisit,
        secondsList = _this$state.secondsList,
        hours = _this$state.hours,
        minutes = _this$state.minutes,
        seconds = _this$state.seconds;
      var _this$props = this.props,
        isShowSeconds = _this$props.isShowSeconds,
        prefixCls = _this$props.prefixCls;
      return /*#__PURE__*/React.createElement("div", {
        className: classNames("".concat(prefixCls, "-time-spinner"), {
          'has-seconds': isShowSeconds
        })
      }, /*#__PURE__*/React.createElement(Scrollbar, {
        onMouseEnter: function onMouseEnter() {
          return _this3.emitSelectRange('hours');
        },
        onWheel: function onWheel() {
          _this3.handleScroll('hours');
        },
        ref: "hours",
        className: "".concat(prefixCls, "-time-spinner__wrapper"),
        wrapStyle: {
          maxHeight: 'inherit'
        },
        viewClass: "".concat(prefixCls, "-time-spinner__list"),
        viewComponent: "ul"
      }, _mapInstanceProperty(hoursList).call(hoursList, function (disabled, idx) {
        return /*#__PURE__*/React.createElement("li", {
          key: idx,
          onClick: function onClick() {
            return _this3.handleChange('hours', idx, disabled);
          },
          className: classNames("".concat(prefixCls, "-time-spinner__item"), {
            active: idx === hours,
            disabled: disabled
          })
        }, idx);
      })), /*#__PURE__*/React.createElement(Scrollbar, {
        onMouseEnter: function onMouseEnter() {
          return _this3.emitSelectRange('minutes');
        },
        onWheel: function onWheel() {
          return _this3.handleScroll('minutes');
        },
        ref: "minutes",
        className: "".concat(prefixCls, "-time-spinner__wrapper"),
        wrapStyle: {
          maxHeight: 'inherit'
        },
        viewClass: "".concat(prefixCls, "-time-spinner__list"),
        viewComponent: "ul"
      }, _mapInstanceProperty(minutesLisit).call(minutesLisit, function (minute) {
        return /*#__PURE__*/React.createElement("li", {
          key: minute,
          onClick: function onClick() {
            return _this3.handleChange('minutes', minute);
          },
          className: classNames("".concat(prefixCls, "-time-spinner__item"), {
            active: minute === minutes
          })
        }, minute);
      })), isShowSeconds && /*#__PURE__*/React.createElement(Scrollbar, {
        onMouseEnter: function onMouseEnter() {
          return _this3.emitSelectRange('seconds');
        },
        onWheel: function onWheel() {
          return _this3.handleScroll('seconds');
        },
        ref: "seconds",
        className: "".concat(prefixCls, "-time-spinner__wrapper"),
        wrapStyle: {
          maxHeight: 'inherit'
        },
        viewClass: "".concat(prefixCls, "-time-spinner__list"),
        viewComponent: "ul"
      }, _mapInstanceProperty(secondsList).call(secondsList, function (sec) {
        return /*#__PURE__*/React.createElement("li", {
          key: sec,
          onClick: function onClick() {
            return _this3.handleChange('seconds', sec);
          },
          className: classNames("".concat(prefixCls, "-time-spinner__item"), {
            active: sec === seconds
          })
        }, sec);
      })));
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        hours: PropTypes.number,
        minutes: PropTypes.number,
        seconds: PropTypes.number,
        isShowSeconds: PropTypes.bool,
        //[[datefrom, dateend]...]
        selectableRange: PropTypes.arrayOf(PropTypes.arrayOf(PropTypes.instanceOf(Date))),
        /*
        type: one of [hours, minutes, seconds]
        onChange: ({type})=>()
        */
        onChange: PropTypes.func.isRequired,
        onSelectRangeChange: PropTypes.func,
        prefixCls: PropTypes.string
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        hours: 0,
        minutes: 0,
        seconds: 0,
        isShowSeconds: true,
        onSelectRangeChange: function onSelectRangeChange() {},
        prefixCls: 'fishd'
      };
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      // only props has changed
      if (propsChangeTester(nextProps, prevState)) {
        var state = propsToState(nextProps);
        propsChangeSaver(nextProps, state);
        return state;
      }
      return null;
    }
  }]);
  return TimeSpinner;
}(React.Component);
export default TimeSpinner;