export declare const RANGE_SEPARATOR = " - ";
export declare const DEFAULT_FORMATS: {
    date: string;
    month: string;
    year: string;
    datetime: string;
    week: string;
    time: string;
    timerange: string;
    timeselect: string;
    daterange: string;
    datetimerange: string;
};
export declare const HAVE_TRIGGER_TYPES: string[];
export declare const DATE_FORMATTER: (value: any, format: any, separator?: string) => string;
export declare const DATE_PARSER: (text: any, format: any, separator?: string) => boolean | Date;
export declare const RANGE_FORMATTER: (value: any, format: any, separator?: string) => string;
export declare const RANGE_PARSER: (text: any, format: any, separator?: string) => (boolean | Date)[];
export declare const TYPE_VALUE_RESOLVER_MAP: {
    default: {
        formatter(value: any): string;
        parser(text: any): any;
    };
    week: {
        formatter(value: any, format: any): string;
        parser(text: any, format: any): boolean | "" | Date;
    };
    date: {
        formatter: (value: any, format: any, separator?: string) => string;
        parser: (text: any, format: any, separator?: string) => boolean | Date;
    };
    datetime: {
        formatter: (value: any, format: any, separator?: string) => string;
        parser: (text: any, format: any, separator?: string) => boolean | Date;
    };
    daterange: {
        formatter: (value: any, format: any, separator?: string) => string;
        parser: (text: any, format: any, separator?: string) => (boolean | Date)[];
    };
    datetimerange: {
        formatter: (value: any, format: any, separator?: string) => string;
        parser: (text: any, format: any, separator?: string) => (boolean | Date)[];
    };
    timerange: {
        formatter: (value: any, format: any, separator?: string) => string;
        parser: (text: any, format: any, separator?: string) => (boolean | Date)[];
    };
    time: {
        formatter: (value: any, format: any, separator?: string) => string;
        parser: (text: any, format: any, separator?: string) => boolean | Date;
    };
    timeselect: {
        formatter: (value: any, format: any, separator?: string) => string;
        parser: (text: any, format: any, separator?: string) => boolean | Date;
    };
    month: {
        formatter: (value: any, format: any, separator?: string) => string;
        parser: (text: any, format: any, separator?: string) => boolean | Date;
    };
    year: {
        formatter: (value: any, format: any, separator?: string) => string;
        parser: (value: any, format: any, separator?: string) => string;
    };
    number: {
        formatter(value: any): string;
        parser(text: any): number;
    };
};
