import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _trimInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/trim";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Input from '../../Input/index';
import Icon from '../../Icon/index';
import Button from '../../Button/index';
import TimePicker from '../../TimePicker/index';
import YearAndMonthPopover from './YearAndMonthPopover.js';
import { DateTable } from '../basic';
import isEqual from 'lodash/isEqual';
import { SELECTION_MODES, deconstructDate, formatDate, parseDate, toDate, prevYear, nextYear, prevMonth, nextMonth, timeFormat, dateFormat, YEARS_ARRAY, isValidValue, setTime } from '../../../utils/date';
import ConfigConsumer from '../../Config/Consumer';
var PICKER_VIEWS = {
  YEAR: 'year',
  MONTH: 'month',
  DATE: 'date'
};
var isInputValid = function isInputValid(text, date, disabledDate) {
  if (_trimInstanceProperty(text).call(text) === '' || !isValidValue(date) || !DatePanel.isValid(date, disabledDate)) return false;
  return true;
};
var DatePanel = /*#__PURE__*/function (_React$Component) {
  _inherits(DatePanel, _React$Component);
  var _super = _createSuper(DatePanel);
  function DatePanel(props) {
    var _this;
    _classCallCheck(this, DatePanel);
    _this = _super.call(this, props);
    // 日期时间都选择，确定按钮才可点击
    _this.confirmBtnDisabled = function () {
      var _this$state = _this.state,
        date = _this$state.date,
        time = _this$state.time;
      return !(date && time);
    };
    // 未选择日期时，时间不可选
    _this.timePickerDisable = function () {
      var _this$state2 = _this.state,
        date = _this$state2.date,
        dateInputText = _this$state2.dateInputText;
      return !(date && dateInputText);
    };
    // 日期输入框变化
    _this.handleDateInputChange = function (e) {
      var _this$props = _this.props,
        disabledDate = _this$props.disabledDate,
        format = _this$props.format;
      var inputText = e.target.value;
      var ndate = parseDate(inputText, dateFormat(format));
      if (!isInputValid(inputText, ndate, disabledDate)) {
        _this.setState({
          dateInputText: inputText
        });
      } else {
        //only set value on a valid date input
        _this.setState({
          dateInputText: inputText,
          date: new Date(ndate),
          currentDate: new Date(ndate)
        });
      }
    };
    // 日期输入框失焦时，重置入合法值
    _this.handleDateInputBlur = function (e) {
      var date = _this.state.date;
      _this.setState({
        dateInputText: formatDate(date, dateFormat(_this.props.format))
      });
    };
    // 时间输入框变化
    _this.handleTimeInputChange = function (val) {
      if (val) {
        _this.setState({
          time: new Date(val)
        });
      }
    };
    // 上一年
    _this.prevYear = function () {
      _this.setState({
        currentDate: prevYear(_this.state.currentDate)
      });
    };
    // 下一年
    _this.nextYear = function () {
      _this.setState({
        currentDate: nextYear(_this.state.currentDate)
      });
    };
    // 上一月
    _this.prevMonth = function () {
      _this.setState({
        currentDate: prevMonth(_this.state.currentDate)
      });
    };
    // 下一月
    _this.nextMonth = function () {
      _this.setState({
        currentDate: nextMonth(_this.state.currentDate)
      });
    };
    // 切换年份
    _this.handleChangeYear = function (year) {
      var currentDate = _this.state.currentDate;
      _this.setState({
        currentDate: new Date(new Date(currentDate).setFullYear(year))
      });
    };
    // 切换月份
    _this.handleChangeMonth = function (month, locales) {
      var _context;
      var currentDate = _this.state.currentDate;
      var monthNumber = _indexOfInstanceProperty(_context = locales.MONTH_ARRAY).call(_context, month);
      _this.setState({
        currentDate: new Date(new Date(currentDate).setMonth(monthNumber))
      });
    };
    // 点击日期
    _this.handleDatePick = function (value) {
      var _this$props2 = _this.props,
        mode = _this$props2.mode,
        showTime = _this$props2.showTime,
        onPick = _this$props2.onPick,
        format = _this$props2.format;
      var pdate = value.date;
      if (mode === SELECTION_MODES.DAY) {
        if (!showTime) {
          onPick(pdate);
        }
        _this.setState({
          date: new Date(pdate),
          dateInputText: formatDate(pdate, dateFormat(format)),
          currentDate: pdate
        });
      } else if (mode === SELECTION_MODES.WEEK) {
        onPick(pdate);
      }
    };
    // 点击确定按钮
    _this.handleConfirm = function () {
      var _this$state3 = _this.state,
        date = _this$state3.date,
        time = _this$state3.time;
      var pickedTime = setTime(date, time);
      _this.props.onPick(pickedTime, false, true);
    };
    // 点击取消按钮
    _this.handleCancel = function () {
      _this.props.onCancelPicked();
    };
    var currentView = PICKER_VIEWS.DATE;
    // switch (props.mode) {
    //   case SELECTION_MODES.MONTH:
    //     currentView = PICKER_VIEWS.MONTH; break;
    //   case SELECTION_MODES.YEAR:
    //     currentView = PICKER_VIEWS.YEAR; break;
    // }
    _this.state = _Object$assign({}, {
      currentView: currentView
    }, DatePanel.propsToState(props));
    return _this;
  }
  _createClass(DatePanel, [{
    key: "_pickerContent",
    value:
    // 年份、月份面板先注释掉，需要时再打开
    function _pickerContent() {
      var _this$props3 = this.props,
        mode = _this$props3.mode,
        disabledDate = _this$props3.disabledDate,
        showWeekNumber = _this$props3.showWeekNumber,
        firstDayOfWeek = _this$props3.firstDayOfWeek;
      var _this$state4 = this.state,
        date = _this$state4.date,
        currentDate = _this$state4.currentDate;
      var currentView = this.state.currentView;
      var result = null;
      switch (currentView) {
        case PICKER_VIEWS.DATE:
          result = /*#__PURE__*/React.createElement(DateTable, {
            onPick: this.handleDatePick,
            date: currentDate,
            value: date,
            mode: mode,
            disabledDate: disabledDate,
            showWeekNumber: showWeekNumber,
            firstDayOfWeek: firstDayOfWeek
          });
          break;
        // case PICKER_VIEWS.YEAR:
        //   result = (<YearTable
        //     ref="yearTable"
        //     value={value}
        //     date={date}
        //     onPick={this.handleYearPick.bind(this)}
        //     disabledDate={disabledDate}
        //   />);
        //   break;
        // case PICKER_VIEWS.MONTH:
        //   result = (<MonthTable
        //     value={value}
        //     date={date}
        //     onPick={this.handleMonthPick.bind(this)}
        //     disabledDate={disabledDate}
        //   />);
        //   break;
        default:
          throw new Error('invalid currentView value');
      }
      return result;
    }
    // 点击快捷按钮
  }, {
    key: "handleShortcutClick",
    value: function handleShortcutClick(shortcut) {
      shortcut.onClick();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props4 = this.props,
        format = _this$props4.format,
        shortcuts = _this$props4.shortcuts,
        yearCount = _this$props4.yearCount,
        showTime = _this$props4.showTime,
        showTimeCurrent = _this$props4.showTimeCurrent,
        timeSelectableRange = _this$props4.timeSelectableRange,
        footer = _this$props4.footer,
        prefixCls = _this$props4.prefixCls,
        timeSelectMode = _this$props4.timeSelectMode,
        timeSelectModeProps = _this$props4.timeSelectModeProps;
      var _this$state5 = this.state,
        currentView = _this$state5.currentView,
        currentDate = _this$state5.currentDate,
        dateInputText = _this$state5.dateInputText,
        time = _this$state5.time;
      var _deconstructDate = deconstructDate(currentDate),
        month = _deconstructDate.month;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "DatePicker"
      }, function (Locales, lang) {
        var _context2, _context3, _context4, _context5, _context6;
        var monthSelector = currentView === PICKER_VIEWS.DATE && /*#__PURE__*/React.createElement(YearAndMonthPopover, {
          key: "month",
          value: currentDate.getMonth() + 1,
          sourceData: Locales.MONTH_ARRAY,
          onChange: function onChange(month) {
            return _this2.handleChangeMonth(month, Locales);
          }
        }, /*#__PURE__*/React.createElement("span", {
          className: classNames("".concat(prefixCls, "-date-picker__header-label"), {
            active: currentView === 'month'
          })
        }, Locales.MONTH_ARRAY[month]));
        var yearSelector = /*#__PURE__*/React.createElement(YearAndMonthPopover, {
          key: "year",
          value: currentDate.getFullYear(),
          sourceData: YEARS_ARRAY(yearCount),
          onChange: _this2.handleChangeYear
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-picker__header-label")
        }, _concatInstanceProperty(_context2 = "".concat(currentDate.getFullYear())).call(_context2, Locales.year)));
        // TODO: 配置此处展示方式
        var selectors = lang === 'en_US' ? [monthSelector, yearSelector] : [yearSelector, monthSelector];
        return /*#__PURE__*/React.createElement("div", {
          className: classNames("".concat(prefixCls, "-picker-panel"), "".concat(prefixCls, "-date-picker"), {
            'has-sidebar': shortcuts,
            'has-time': showTime
          })
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__body-wrapper")
        }, _Array$isArray(shortcuts) && /*#__PURE__*/React.createElement("div", {
          className: classNames("".concat(prefixCls, "-picker-panel__sidebar"))
        }, _mapInstanceProperty(shortcuts).call(shortcuts, function (e, idx) {
          return /*#__PURE__*/React.createElement("button", {
            key: idx,
            type: "button",
            className: "".concat(prefixCls, "-picker-panel__shortcut"),
            onClick: function onClick() {
              return _this2.handleShortcutClick(e);
            }
          }, e.text);
        })), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__body")
        }, showTime && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-date-picker__time-header")
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-picker__editor-wrap")
        }, /*#__PURE__*/React.createElement(Input, {
          placeholder: Locales.selectDate,
          value: dateInputText,
          onChange: _this2.handleDateInputChange,
          onBlur: _this2.handleDateInputBlur
        })), /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-picker__editor-wrap")
        }, timeSelectMode === 'TimePicker' ? /*#__PURE__*/React.createElement(TimePicker, {
          className: "".concat(prefixCls, "-date-picker-time__editor"),
          placeholder: Locales.selectTime,
          format: timeFormat(format),
          getPopupContainer: function getPopupContainer(node) {
            return node.parentNode;
          },
          showTrigger: false,
          allowClear: false,
          disabled: _this2.timePickerDisable(),
          value: time,
          onChange: _this2.handleTimeInputChange,
          isShowCurrent: showTimeCurrent,
          selectableRange: timeSelectableRange
        }) : /*#__PURE__*/React.createElement(TimePicker.TimeSelect, {
          className: "".concat(prefixCls, "-date-picker-time__editor"),
          placeholder: Locales.selectTime,
          getPopupContainer: function getPopupContainer(node) {
            return node.parentNode;
          },
          showTrigger: false,
          allowClear: false,
          disabled: _this2.timePickerDisable(),
          value: time,
          onChange: _this2.handleTimeInputChange,
          start: timeSelectModeProps.start,
          step: timeSelectModeProps.step,
          end: timeSelectModeProps.end,
          maxTime: timeSelectModeProps.maxTime,
          minTime: timeSelectModeProps.minTime
        }))), currentView !== 'time' && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-date-picker__header")
        }, /*#__PURE__*/React.createElement(Icon, {
          type: "left-double",
          onClick: _this2.prevYear,
          className: _concatInstanceProperty(_context3 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context3, prefixCls, "-date-picker__prev-btn")
        }), currentView === PICKER_VIEWS.DATE && /*#__PURE__*/React.createElement(Icon, {
          type: "left",
          onClick: _this2.prevMonth,
          className: _concatInstanceProperty(_context4 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context4, prefixCls, "-date-picker__prev-btn")
        }), selectors, /*#__PURE__*/React.createElement(Icon, {
          type: "right-double",
          onClick: _this2.nextYear,
          className: _concatInstanceProperty(_context5 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context5, prefixCls, "-date-picker__next-btn")
        }), currentView === PICKER_VIEWS.DATE && /*#__PURE__*/React.createElement(Icon, {
          type: "right",
          onClick: _this2.nextMonth,
          className: _concatInstanceProperty(_context6 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context6, prefixCls, "-date-picker__next-btn")
        })), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__content")
        }, _this2._pickerContent()))), typeof footer == 'function' && footer() && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__extra-footer")
        }, footer()), showTime && currentView === PICKER_VIEWS.DATE && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__footer")
        }, /*#__PURE__*/React.createElement(Button, {
          className: "".concat(prefixCls, "-picker-panel__btn cancel"),
          onClick: _this2.handleCancel
        }, Locales.cancel), /*#__PURE__*/React.createElement(Button, {
          type: "primary",
          className: "".concat(prefixCls, "-picker-panel__btn confirm"),
          onClick: _this2.handleConfirm,
          disabled: _this2.confirmBtnDisabled()
        }, Locales.confirm)));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      var _context7;
      return {
        prefixCls: PropTypes.string,
        format: PropTypes.string,
        value: PropTypes.instanceOf(Date),
        onPick: PropTypes.func.isRequired,
        onCancelPicked: PropTypes.func.isRequired,
        yearCount: PropTypes.number,
        showWeekNumber: PropTypes.bool,
        shortcuts: PropTypes.arrayOf(PropTypes.shape({
          text: PropTypes.string.isRequired,
          onClick: PropTypes.func.isRequired
        })),
        mode: PropTypes.oneOf(_mapInstanceProperty(_context7 = _Object$keys(SELECTION_MODES)).call(_context7, function (e) {
          return SELECTION_MODES[e];
        })),
        disabledDate: PropTypes.func,
        firstDayOfWeek: PropTypes.number,
        footer: PropTypes.func,
        //时间面板
        showTime: PropTypes.bool,
        showTimeCurrent: PropTypes.bool,
        timeSelectableRange: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]),
        defaultTimeValue: PropTypes.instanceOf(Date),
        timeSelectMode: PropTypes.oneOf(['TimePicker', 'TimeSelect']),
        timeSelectModeProps: PropTypes.object
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        prefixCls: 'fishd',
        yearCount: 50,
        showWeekNumber: false,
        mode: SELECTION_MODES.DAY,
        firstDayOfWeek: 0,
        showTime: false,
        showTimeCurrent: false,
        defaultTimeValue: null,
        timeSelectMode: 'TimePicker',
        timeSelectModeProps: {
          start: '09:00',
          end: '18:00',
          step: '00:30',
          minTime: '',
          maxTime: ''
        }
      };
    }
  }, {
    key: "propsToState",
    value: function propsToState(_ref) {
      var value = _ref.value,
        format = _ref.format,
        defaultTimeValue = _ref.defaultTimeValue;
      var state = {};
      state.currentDate = isValidValue(value) ? toDate(value) : new Date(); // 日历视图
      state.date = toDate(value); // 日期
      state.dateInputText = formatDate(value, dateFormat(format)); // 日期输入框的值(string)，当props.value为null时，值为''
      state.time = toDate(value || defaultTimeValue); // 时间
      return state;
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if ('value' in nextProps && !isEqual(nextProps.value, prevState.prevPropValue)) {
        var state = DatePanel.propsToState(nextProps);
        state.prevPropValue = nextProps.value;
        return state;
      }
      return null;
    }
  }]);
  return DatePanel;
}(React.Component);
DatePanel.isValid = function (value, disabledDate) {
  return typeof disabledDate === 'function' && value instanceof Date ? !disabledDate(value) : true;
};
export default DatePanel;