import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import TimeSpinner from '../basic/TimeSpinner.js';
import { limitRange, isLimitRange, parseDate } from '../../../utils/date';
import { DEFAULT_FORMATS } from '../constants';
import isEqual from 'lodash/isEqual';
import ConfigConsumer from '../../Config/Consumer';
var mapPropsToState = function mapPropsToState(props) {
  var _context;
  var format = props.format,
    value = props.value,
    selectableRange = props.selectableRange;
  var state = {
    format: format || DEFAULT_FORMATS.time,
    currentDate: value || parseDate('00:00:00', DEFAULT_FORMATS.time),
    confirmButtonDisabled: value === null || !TimePanel.isValid(value, selectableRange),
    currentButtonDisabled: !isLimitRange(new Date(), selectableRange, DEFAULT_FORMATS.time)
  };
  state.isShowSeconds = _indexOfInstanceProperty(_context = state.format || '').call(_context, 'ss') !== -1;
  return state;
};
var TimePanel = /*#__PURE__*/function (_React$Component) {
  _inherits(TimePanel, _React$Component);
  var _super = _createSuper(TimePanel);
  function TimePanel(props) {
    var _this;
    _classCallCheck(this, TimePanel);
    _this = _super.call(this, props);
    _this.handleChange = function (date) {
      var currentDate = _this.state.currentDate;
      var newDate = new Date(currentDate);
      if (date.hours !== undefined) {
        newDate.setHours(date.hours);
      }
      if (date.minutes !== undefined) {
        newDate.setMinutes(date.minutes);
      }
      if (date.seconds !== undefined) {
        newDate.setSeconds(date.seconds);
      }
      if (!TimePanel.isValid(newDate, _this.props.selectableRange)) {
        _this.setState({
          confirmButtonDisabled: true,
          currentDate: newDate
        }, function () {
          _this.props.onValueChange(newDate);
        });
      } else {
        _this.setState({
          confirmButtonDisabled: false,
          currentDate: newDate
        }, function () {
          _this.props.onValueChange(newDate);
          _this.handleConfirm(true, false); //面板展开，不保存值
        });
      }
    };
    // 点击确定按钮
    _this.handleConfirm = function (isKeepPannelOpen, isConfirmValue) {
      var currentDate = _this.state.currentDate;
      var _this$props = _this.props,
        onPicked = _this$props.onPicked,
        selectableRange = _this$props.selectableRange;
      var date = new Date(limitRange(currentDate, selectableRange, DEFAULT_FORMATS.time));
      onPicked(date, isKeepPannelOpen, isConfirmValue);
    };
    // 点击取消按钮
    _this.handleCancel = function () {
      _this.props.onCancelPicked();
    };
    // 点击此刻按钮
    _this.handleCurrent = function () {
      var onPicked = _this.props.onPicked;
      var value = new Date();
      onPicked(value, false, true);
    };
    _this.state = mapPropsToState(props);
    return _this;
  }
  _createClass(TimePanel, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props2 = this.props,
        onSelectRangeChange = _this$props2.onSelectRangeChange,
        selectableRange = _this$props2.selectableRange,
        isShowCurrent = _this$props2.isShowCurrent,
        footer = _this$props2.footer,
        prefixCls = _this$props2.prefixCls;
      var _this$state = this.state,
        isShowSeconds = _this$state.isShowSeconds,
        currentDate = _this$state.currentDate,
        confirmButtonDisabled = _this$state.confirmButtonDisabled,
        currentButtonDisabled = _this$state.currentButtonDisabled;
      var hours = currentDate ? currentDate.getHours() : null;
      var minutes = currentDate ? currentDate.getMinutes() : null;
      var seconds = currentDate ? currentDate.getSeconds() : null;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "DatePicker"
      }, function (Locales) {
        var _context2;
        return /*#__PURE__*/React.createElement("div", {
          className: _concatInstanceProperty(_context2 = "".concat(prefixCls, "-picker-panel ")).call(_context2, prefixCls, "-time-panel")
        }, /*#__PURE__*/React.createElement("div", {
          className: classNames("".concat(prefixCls, "-time-panel__content"), {
            'has-seconds': isShowSeconds
          })
        }, /*#__PURE__*/React.createElement(TimeSpinner, {
          isShowSeconds: isShowSeconds,
          hours: hours,
          minutes: minutes,
          seconds: seconds,
          selectableRange: selectableRange,
          onSelectRangeChange: onSelectRangeChange,
          onChange: _this2.handleChange
        })), typeof footer == 'function' && footer() && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-time-panel__extra-footer")
        }, footer()), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-time-panel__footer")
        }, /*#__PURE__*/React.createElement("div", null, isShowCurrent ? /*#__PURE__*/React.createElement("button", {
          type: "button",
          disabled: currentButtonDisabled,
          className: classNames("".concat(prefixCls, "-time-panel__btn confirm"), {
            'disabled': currentButtonDisabled
          }),
          onClick: _this2.handleCurrent
        }, Locales.now) : null), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("button", {
          type: "button",
          className: "".concat(prefixCls, "-time-panel__btn cancel"),
          onClick: _this2.handleCancel
        }, Locales.cancel), /*#__PURE__*/React.createElement("button", {
          type: "button",
          disabled: confirmButtonDisabled,
          className: classNames("".concat(prefixCls, "-time-panel__btn confirm"), {
            'disabled': confirmButtonDisabled
          }),
          onClick: function onClick() {
            return _this2.handleConfirm(false, true);
          }
        }, Locales.confirm))));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        prefixCls: PropTypes.string,
        format: PropTypes.string,
        value: PropTypes.instanceOf(Date),
        onPicked: PropTypes.func.isRequired,
        onCancelPicked: PropTypes.func.isRequired,
        selectableRange: TimeSpinner.propTypes.selectableRange,
        onSelectRangeChange: TimeSpinner.propTypes.onSelectRangeChange,
        isShowCurrent: PropTypes.bool,
        footer: PropTypes.func,
        onValueChange: PropTypes.func
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        prefixCls: 'fishd',
        isShowCurrent: false,
        onValueChange: function onValueChange() {}
      };
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if ("value" in nextProps && !isEqual(nextProps.value, prevState.prevPropValue)) {
        var state = mapPropsToState(nextProps);
        state.prevPropValue = nextProps.value;
        return state;
      }
      return null;
    }
  }]);
  return TimePanel;
}(React.Component);
TimePanel.isValid = function (value, selectableRange) {
  return value === null || isLimitRange(value, selectableRange, DEFAULT_FORMATS.time);
};
export default TimePanel;