import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _findInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/find";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _parseInt from "@babel/runtime-corejs3/core-js-stable/parse-int";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { Scrollbar } from '../scrollbar';
import scrollIntoView from 'dom-scroll-into-view';
import isEqual from 'lodash/isEqual';
var TimeSelectPanel = /*#__PURE__*/function (_React$Component) {
  _inherits(TimeSelectPanel, _React$Component);
  var _super = _createSuper(TimeSelectPanel);
  function TimeSelectPanel(props) {
    var _this;
    _classCallCheck(this, TimeSelectPanel);
    _this = _super.call(this, props);
    _this.items = function () {
      return getItems(_this.props);
    };
    _this.scrollToOption = function () {
      var className = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "selected";
      var menu = _this.timeSelectRoot.querySelector(".".concat(_this.props.prefixCls, "-picker-panel__content"));
      var selected = menu.getElementsByClassName(className)[0];
      selected && scrollIntoView(selected, menu, {
        offsetTop: 74,
        alignWithTop: true
      });
    };
    _this.state = {};
    return _this;
  }
  _createClass(TimeSelectPanel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.scrollToOption();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.scrollToOption();
    }
  }, {
    key: "handleClick",
    value: function handleClick(item) {
      var _this$props = this.props,
        onPicked = _this$props.onPicked,
        dateParser = _this$props.dateParser;
      if (!item.disabled) {
        onPicked(dateParser(item.value), false, true);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this,
        _context;
      var _this$props2 = this.props,
        value = _this$props2.value,
        prefixCls = _this$props2.prefixCls;
      return /*#__PURE__*/React.createElement("div", {
        ref: function ref(node) {
          return _this2.timeSelectRoot = node;
        },
        className: "".concat(prefixCls, "-picker-panel time-select-panel")
      }, /*#__PURE__*/React.createElement(Scrollbar, {
        wrapClass: "".concat(prefixCls, "-picker-panel__content"),
        noresize: true
      }, _mapInstanceProperty(_context = this.items()).call(_context, function (item, idx) {
        return /*#__PURE__*/React.createElement("div", {
          key: idx,
          className: classNames('time-select-item', {
            selected: value === item.value,
            disabled: item.disabled
          }),
          disabled: item.disabled,
          onClick: function onClick() {
            return _this2.handleClick(item);
          }
        }, item.value);
      })));
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        prefixCls: PropTypes.string,
        value: PropTypes.string,
        onPicked: PropTypes.func.isRequired,
        start: PropTypes.string,
        end: PropTypes.string,
        step: PropTypes.string,
        minTime: PropTypes.string,
        maxTime: PropTypes.string,
        dateParser: PropTypes.func.isRequired
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        prefixCls: 'fishd',
        start: '09:00',
        end: '18:00',
        step: '00:30',
        minTime: '',
        maxTime: '',
        onPicked: function onPicked() {}
      };
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if ('value' in nextProps && !isEqual(nextProps.vlaue, prevState.prevPropValue)) {
        return {
          prevPropValue: nextProps.vlaue
        };
      }
      return null;
    }
  }]);
  return TimeSelectPanel;
}(React.Component);
TimeSelectPanel.isValid = function (value, _ref) {
  var _context2;
  var start = _ref.start,
    end = _ref.end,
    step = _ref.step,
    minTime = _ref.minTime,
    maxTime = _ref.maxTime;
  var items = getItems({
    start: start,
    end: end,
    step: step,
    minTime: minTime,
    maxTime: maxTime
  });
  return !!_findInstanceProperty(_context2 = _filterInstanceProperty(items).call(items, function (e) {
    return !e.disabled;
  })).call(_context2, function (e) {
    return e.value === value;
  });
};
var getItems = function getItems(_ref2) {
  var start = _ref2.start,
    end = _ref2.end,
    step = _ref2.step,
    minTime = _ref2.minTime,
    maxTime = _ref2.maxTime;
  var result = [];
  if (start && end && step) {
    var current = start;
    while (compareTime(current, end) <= 0) {
      result.push({
        value: current,
        disabled: compareTime(current, minTime || '-1:-1') <= 0 || compareTime(current, maxTime || '100:100') >= 0
      });
      current = nextTime(current, step);
    }
  }
  return result;
};
var parseTime = function parseTime(time) {
  var values = (time || '').split(':');
  if (values.length >= 2) {
    var hours = _parseInt(values[0], 10);
    var minutes = _parseInt(values[1], 10);
    return {
      hours: hours,
      minutes: minutes
    };
  }
  return null;
};
var compareTime = function compareTime(time1, time2) {
  var value1 = parseTime(time1);
  var value2 = parseTime(time2);
  var minutes1 = value1.minutes + value1.hours * 60;
  var minutes2 = value2.minutes + value2.hours * 60;
  if (minutes1 === minutes2) {
    return 0;
  }
  return minutes1 > minutes2 ? 1 : -1;
};
var formatTime = function formatTime(time) {
  return (time.hours < 10 ? '0' + time.hours : time.hours) + ':' + (time.minutes < 10 ? '0' + time.minutes : time.minutes);
};
var nextTime = function nextTime(time, step) {
  var timeValue = parseTime(time);
  var stepValue = parseTime(step);
  var next = {
    hours: timeValue.hours,
    minutes: timeValue.minutes
  };
  next.minutes += stepValue.minutes;
  next.hours += stepValue.hours;
  next.hours += Math.floor(next.minutes / 60);
  next.minutes = next.minutes % 60;
  return formatTime(next);
};
export default TimeSelectPanel;