import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { BAR_MAP, renderThumbStyle } from './util';
import { on, off } from '../libs/utils/dom';
export var Bar = /*#__PURE__*/function (_React$Component) {
  _inherits(Bar, _React$Component);
  var _super = _createSuper(Bar);
  function Bar(props) {
    var _context, _context2, _context3, _context4;
    var _this;
    _classCallCheck(this, Bar);
    _this = _super.call(this, props);
    _this.clickTrackHandler = _bindInstanceProperty(_context = _this.clickTrackHandler).call(_context, _assertThisInitialized(_this));
    _this.clickThumbHandler = _bindInstanceProperty(_context2 = _this.clickThumbHandler).call(_context2, _assertThisInitialized(_this));
    _this.mouseMoveDocumentHandler = _bindInstanceProperty(_context3 = _this.mouseMoveDocumentHandler).call(_context3, _assertThisInitialized(_this));
    _this.mouseUpDocumentHandler = _bindInstanceProperty(_context4 = _this.mouseUpDocumentHandler).call(_context4, _assertThisInitialized(_this));
    return _this;
  }
  _createClass(Bar, [{
    key: "bar",
    get: function get() {
      return BAR_MAP[this.props.vertical ? 'vertical' : 'horizontal'];
    }
  }, {
    key: "wrap",
    get: function get() {
      return this.props.getParentWrap();
    }
  }, {
    key: "clickThumbHandler",
    value: function clickThumbHandler(e) {
      this.startDrag(e);
      this[this.bar.axis] = e.currentTarget[this.bar.offset] - (e[this.bar.client] - e.currentTarget.getBoundingClientRect()[this.bar.direction]);
    }
  }, {
    key: "clickTrackHandler",
    value: function clickTrackHandler(e) {
      var offset = Math.abs(e.target.getBoundingClientRect()[this.bar.direction] - e[this.bar.client]);
      var thumbHalf = this.thumbRef[this.bar.offset] / 2;
      var thumbPositionPercentage = (offset - thumbHalf) * 100 / this.rootRef[this.bar.offset];
      this.wrap[this.bar.scroll] = thumbPositionPercentage * this.wrap[this.bar.scrollSize] / 100;
    }
  }, {
    key: "startDrag",
    value: function startDrag(e) {
      e.nativeEvent.stopImmediatePropagation;
      this.cursorDown = true;
      on(document, 'mousemove', this.mouseMoveDocumentHandler);
      on(document, 'mouseup', this.mouseUpDocumentHandler);
      document.onselectstart = function () {
        return false;
      };
    }
  }, {
    key: "mouseMoveDocumentHandler",
    value: function mouseMoveDocumentHandler(e) {
      if (this.cursorDown === false) return;
      var prevPage = this[this.bar.axis];
      if (!prevPage) return;
      var offset = e[this.bar.client] - this.rootRef.getBoundingClientRect()[this.bar.direction];
      var thumbClickPosition = this.thumbRef[this.bar.offset] - prevPage;
      var thumbPositionPercentage = (offset - thumbClickPosition) * 100 / this.rootRef[this.bar.offset];
      this.wrap[this.bar.scroll] = thumbPositionPercentage * this.wrap[this.bar.scrollSize] / 100;
    }
  }, {
    key: "mouseUpDocumentHandler",
    value: function mouseUpDocumentHandler() {
      this.cursorDown = false;
      this[this.bar.axis] = 0;
      off(document, 'mousemove', this.mouseMoveDocumentHandler);
      document.onselectstart = null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        size = _this$props.size,
        move = _this$props.move,
        prefixCls = _this$props.prefixCls;
      return /*#__PURE__*/React.createElement("div", {
        ref: function ref(root) {
          return _this2.rootRef = root;
        },
        className: classNames("".concat(prefixCls, "-scrollbar__bar"), "is-".concat(this.bar.key)),
        onMouseDown: this.clickTrackHandler
      }, /*#__PURE__*/React.createElement("div", {
        ref: function ref(thumb) {
          return _this2.thumbRef = thumb;
        },
        className: "".concat(prefixCls, "-scrollbar__thumb"),
        onMouseDown: this.clickThumbHandler,
        style: renderThumbStyle({
          size: size,
          move: move,
          bar: this.bar
        })
      }));
    }
  }]);
  return Bar;
}(React.Component);
Bar.propTypes = {
  vertical: PropTypes.bool,
  size: PropTypes.string,
  move: PropTypes.number,
  getParentWrap: PropTypes.func.isRequired,
  prefixCls: PropTypes.string
};
Bar.defaultProps = {
  prefixCls: 'fishd'
};