import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import PropTypes from 'prop-types';
import ReactDOM from 'react-dom';
import classNames from 'classnames';
import { addResizeListener, removeResizeListener } from '../libs/utils/resize-event';
import { getScrollBarWidth } from './scrollar-width';
import { Bar } from './Bar';
export var Scrollbar = /*#__PURE__*/function (_React$Component) {
  _inherits(Scrollbar, _React$Component);
  var _super = _createSuper(Scrollbar);
  function Scrollbar(props) {
    var _context;
    var _this;
    _classCallCheck(this, Scrollbar);
    _this = _super.call(this, props);
    _this.state = {
      sizeWidth: '0',
      sizeHeight: '0',
      moveX: 0,
      moveY: 0
    };
    _this.update = _bindInstanceProperty(_context = _this._update).call(_context, _assertThisInitialized(_this));
    return _this;
  }
  _createClass(Scrollbar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this["native"]) return;
      var rafId = requestAnimationFrame(this.update);
      this.cleanRAF = function () {
        cancelAnimationFrame(rafId);
      };
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _this2 = this;
      this.resizeDom = ReactDOM.findDOMNode(this.refs.resize);
      if (!this.props.noresize) {
        addResizeListener(this.resizeDom, this.update);
        this.cleanResize = function () {
          removeResizeListener(_this2.resizeDom, _this2.update);
        };
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.cleanRAF();
      this.cleanResize && this.cleanResize();
    }
  }, {
    key: "wrap",
    get: function get() {
      return this.refs.wrap;
    }
  }, {
    key: "handleScroll",
    value: function handleScroll() {
      var wrap = this.wrap;
      this.setState({
        moveY: wrap.scrollTop * 100 / wrap.clientHeight,
        moveX: wrap.scrollLeft * 100 / wrap.clientWidth
      });
    }
  }, {
    key: "_update",
    value: function _update() {
      var heightPercentage, widthPercentage;
      var wrap = this.wrap;
      if (!wrap) return;
      heightPercentage = wrap.clientHeight * 100 / wrap.scrollHeight;
      widthPercentage = wrap.clientWidth * 100 / wrap.scrollWidth;
      var sizeHeight = heightPercentage < 100 ? heightPercentage + '%' : '';
      var sizeWidth = widthPercentage < 100 ? widthPercentage + '%' : '';
      this.setState({
        sizeHeight: sizeHeight,
        sizeWidth: sizeWidth
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      /* eslint-disable */
      var _a = this.props,
        _native = _a["native"],
        viewStyle = _a.viewStyle,
        wrapStyle = _a.wrapStyle,
        viewClass = _a.viewClass,
        children = _a.children,
        viewComponent = _a.viewComponent,
        wrapClass = _a.wrapClass,
        noresize = _a.noresize,
        className = _a.className,
        prefixCls = _a.prefixCls,
        others = __rest(_a, ["native", "viewStyle", "wrapStyle", "viewClass", "children", "viewComponent", "wrapClass", "noresize", "className", "prefixCls"]);
      var _this$state = this.state,
        moveX = _this$state.moveX,
        moveY = _this$state.moveY,
        sizeWidth = _this$state.sizeWidth,
        sizeHeight = _this$state.sizeHeight;
      /* eslint-enable */
      var style = wrapStyle;
      var gutter = getScrollBarWidth();
      if (gutter) {
        var gutterWith = "-".concat(gutter, "px");
        if (_Array$isArray(wrapStyle)) {
          var _context2;
          style = _Object$assign.apply(null, _concatInstanceProperty(_context2 = []).call(_context2, _toConsumableArray(wrapStyle), [{
            marginRight: gutterWith,
            marginBottom: gutterWith
          }]));
        } else {
          style = _Object$assign({}, wrapStyle, {
            marginRight: gutterWith,
            marginBottom: gutterWith
          });
        }
      }
      var view = /*#__PURE__*/React.createElement(viewComponent, {
        className: classNames("".concat(prefixCls, "-scrollbar__view"), viewClass),
        style: viewStyle,
        ref: 'resize'
      }, children);
      var nodes;
      if (!_native) {
        var _context3;
        var wrap = /*#__PURE__*/React.createElement("div", _Object$assign({}, others, {
          ref: "wrap",
          key: 0,
          style: style,
          onScroll: _bindInstanceProperty(_context3 = this.handleScroll).call(_context3, this),
          className: classNames(wrapClass, "".concat(prefixCls, "-scrollbar__wrap"), gutter ? '' : "".concat(prefixCls, "-scrollbar__wrap--hidden-default"))
        }), view);
        nodes = [wrap, /*#__PURE__*/React.createElement(Bar, {
          key: 1,
          move: moveX,
          size: sizeWidth,
          getParentWrap: function getParentWrap() {
            return _this3.wrap;
          }
        }), /*#__PURE__*/React.createElement(Bar, {
          key: 2,
          move: moveY,
          size: sizeHeight,
          getParentWrap: function getParentWrap() {
            return _this3.wrap;
          },
          vertical: true
        })];
      } else {
        nodes = [/*#__PURE__*/React.createElement("div", _Object$assign({}, others, {
          key: 0,
          ref: "wrap",
          className: classNames(wrapClass, "".concat(prefixCls, "-scrollbar__wrap")),
          style: style
        }), view)];
      }
      return /*#__PURE__*/React.createElement('div', {
        className: classNames("".concat(prefixCls, "-scrollbar"), className)
      }, nodes);
    }
  }]);
  return Scrollbar;
}(React.Component);
Scrollbar.propTypes = {
  "native": PropTypes.bool,
  wrapStyle: PropTypes.object,
  wrapClass: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  viewClass: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  viewStyle: PropTypes.object,
  className: PropTypes.string,
  viewComponent: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  noresize: PropTypes.bool,
  prefixCls: PropTypes.string
};
Scrollbar.defaultProps = {
  viewComponent: 'div',
  prefixCls: 'fishd'
};