import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import PropTypes from 'prop-types';
import Tooltip from '../Tooltip';
export var getStrFullLength = function getStrFullLength() {
  var _context;
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return _reduceInstanceProperty(_context = str.split('')).call(_context, function (pre, cur) {
    var charCode = cur.charCodeAt(0);
    if (charCode >= 0 && charCode <= 128) {
      return pre + 1;
    }
    return pre + 2;
  }, 0);
};
export var cutStrByFullLength = function cutStrByFullLength() {
  var _context2;
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var maxLength = arguments.length > 1 ? arguments[1] : undefined;
  var showLength = 0;
  return _reduceInstanceProperty(_context2 = str.split('')).call(_context2, function (pre, cur) {
    var charCode = cur.charCodeAt(0);
    if (charCode >= 0 && charCode <= 128) {
      showLength += 1;
    } else {
      showLength += 2;
    }
    if (showLength <= maxLength) {
      return pre + cur;
    }
    return pre;
  }, '');
};
var EllipsisText = function EllipsisText(_a) {
  var prefix = _a.prefix,
    text = _a.text,
    length = _a.length,
    tooltip = _a.tooltip,
    className = _a.className,
    fullWidthRecognition = _a.fullWidthRecognition,
    tooltipProps = _a.tooltipProps,
    other = __rest(_a, ["prefix", "text", "length", "tooltip", "className", "fullWidthRecognition", "tooltipProps"]);
  if (typeof text !== 'string') {
    throw new Error('Ellipsis children must be string.');
  }
  var textLength = fullWidthRecognition ? getStrFullLength(text) : text.length;
  if (textLength <= length || length < 0) {
    return /*#__PURE__*/React.createElement("span", _Object$assign({
      className: className
    }, other), text);
  }
  var tail = '...';
  var displayText;
  if (length - tail.length <= 0) {
    displayText = '';
  } else {
    displayText = fullWidthRecognition ? cutStrByFullLength(text, length) : _sliceInstanceProperty(text).call(text, 0, length);
  }
  if (tooltip) {
    return /*#__PURE__*/React.createElement(Tooltip, _Object$assign({}, tooltipProps, {
      overlayClassName: "".concat(prefix, "-tooltip"),
      title: text
    }), /*#__PURE__*/React.createElement("span", {
      className: className
    }, displayText, tail));
  }
  return /*#__PURE__*/React.createElement("span", _Object$assign({
    className: className
  }, other), displayText, tail);
};
EllipsisText.propTypes = {
  prefix: PropTypes.string,
  text: PropTypes.string,
  length: PropTypes.number,
  tooltip: PropTypes.bool,
  fullWidthRecognition: PropTypes.bool,
  tooltipProps: PropTypes.object
};
export default EllipsisText;