import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _everyInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/every";
import set from 'lodash/set';
import createFormField, { isFormField } from './createFormField';
import { flattenFields as _flattenFields, getErrorStrs, startsWith } from './utils';
function partOf(a, b) {
  var _context;
  return _indexOfInstanceProperty(b).call(b, a) === 0 && _indexOfInstanceProperty(_context = ['.', '[']).call(_context, b[a.length]) !== -1;
}
var FieldsStore = /*#__PURE__*/function () {
  function FieldsStore(fields) {
    var _this = this;
    _classCallCheck(this, FieldsStore);
    this.setFieldsInitialValue = function (initialValues) {
      var _context2;
      var flattenedInitialValues = _this.flattenRegisteredFields(initialValues);
      var fieldsMeta = _this.fieldsMeta;
      _forEachInstanceProperty(_context2 = _Object$keys(flattenedInitialValues)).call(_context2, function (name) {
        if (fieldsMeta[name]) {
          _this.setFieldMeta(name, _Object$assign(_Object$assign({}, _this.getFieldMeta(name)), {
            initialValue: flattenedInitialValues[name]
          }));
        }
      });
    };
    this.getAllValues = function () {
      var _context3;
      var fieldsMeta = _this.fieldsMeta,
        fields = _this.fields;
      return _reduceInstanceProperty(_context3 = _Object$keys(fieldsMeta)).call(_context3, function (acc, name) {
        return set(acc, name, _this.getValueFromFields(name, fields));
      }, {});
    };
    this.getFieldsValue = function (names) {
      return _this.getNestedFields(names, _this.getFieldValue);
    };
    this.getFieldValue = function (name) {
      var fields = _this.fields;
      return _this.getNestedField(name, function (fullName) {
        return _this.getValueFromFields(fullName, fields);
      });
    };
    this.getFieldsError = function (names) {
      return _this.getNestedFields(names, _this.getFieldError);
    };
    this.getFieldError = function (name) {
      return _this.getNestedField(name, function (fullName) {
        return getErrorStrs(_this.getFieldMember(fullName, 'errors'));
      });
    };
    this.isFieldValidating = function (name) {
      return _this.getFieldMember(name, 'validating');
    };
    this.isFieldsValidating = function (ns) {
      var names = ns || _this.getValidFieldsName();
      return _someInstanceProperty(names).call(names, function (n) {
        return _this.isFieldValidating(n);
      });
    };
    this.isFieldTouched = function (name) {
      return _this.getFieldMember(name, 'touched');
    };
    this.isFieldsTouched = function (ns) {
      var names = ns || _this.getValidFieldsName();
      return _someInstanceProperty(names).call(names, function (n) {
        return _this.isFieldTouched(n);
      });
    };
    this.fields = this.flattenFields(fields);
    this.fieldsMeta = {};
  }
  _createClass(FieldsStore, [{
    key: "updateFields",
    value: function updateFields(fields) {
      this.fields = this.flattenFields(fields);
    }
  }, {
    key: "flattenFields",
    value: function flattenFields(fields) {
      return _flattenFields(fields, function (_, node) {
        return isFormField(node);
      }, 'You must wrap field data with `createFormField`.');
    }
  }, {
    key: "flattenRegisteredFields",
    value: function flattenRegisteredFields(fields) {
      var validFieldsName = this.getAllFieldsName();
      return _flattenFields(fields, function (path) {
        return _indexOfInstanceProperty(validFieldsName).call(validFieldsName, path) >= 0;
      }, 'You cannot set field before registering it.');
    }
  }, {
    key: "setFields",
    value: function setFields(fields) {
      var _context4,
        _this2 = this,
        _context5;
      var fieldsMeta = this.fieldsMeta;
      var nowFields = _Object$assign(_Object$assign({}, this.fields), fields);
      var nowValues = {};
      _forEachInstanceProperty(_context4 = _Object$keys(fieldsMeta)).call(_context4, function (f) {
        return nowValues[f] = _this2.getValueFromFields(f, nowFields);
      });
      _forEachInstanceProperty(_context5 = _Object$keys(nowValues)).call(_context5, function (f) {
        var value = nowValues[f];
        var fieldMeta = _this2.getFieldMeta(f);
        if (fieldMeta && fieldMeta.normalize) {
          var nowValue = fieldMeta.normalize(value, _this2.getValueFromFields(f, _this2.fields), nowValues);
          if (nowValue !== value) {
            nowFields[f] = _Object$assign(_Object$assign({}, nowFields[f]), {
              value: nowValue
            });
          }
        }
      });
      this.fields = nowFields;
    }
  }, {
    key: "resetFields",
    value: function resetFields(ns) {
      var fields = this.fields;
      var names = ns ? this.getValidFieldsFullName(ns) : this.getAllFieldsName();
      return _reduceInstanceProperty(names).call(names, function (acc, name) {
        var field = fields[name];
        if (field && 'value' in field) {
          acc[name] = {};
        }
        return acc;
      }, {});
    }
  }, {
    key: "setFieldMeta",
    value: function setFieldMeta(name, meta) {
      this.fieldsMeta[name] = meta;
    }
  }, {
    key: "getFieldMeta",
    value: function getFieldMeta(name) {
      this.fieldsMeta[name] = this.fieldsMeta[name] || {};
      return this.fieldsMeta[name];
    }
  }, {
    key: "getValueFromFields",
    value: function getValueFromFields(name, fields) {
      var field = fields[name];
      if (field && 'value' in field) {
        return field.value;
      }
      var fieldMeta = this.getFieldMeta(name);
      return fieldMeta && fieldMeta.initialValue;
    }
  }, {
    key: "getValidFieldsName",
    value: function getValidFieldsName() {
      var _context6,
        _this3 = this;
      var fieldsMeta = this.fieldsMeta;
      return fieldsMeta ? _filterInstanceProperty(_context6 = _Object$keys(fieldsMeta)).call(_context6, function (name) {
        return !_this3.getFieldMeta(name).hidden;
      }) : [];
    }
  }, {
    key: "getAllFieldsName",
    value: function getAllFieldsName() {
      var fieldsMeta = this.fieldsMeta;
      return fieldsMeta ? _Object$keys(fieldsMeta) : [];
    }
  }, {
    key: "getValidFieldsFullName",
    value: function getValidFieldsFullName(maybePartialName) {
      var _context7;
      var maybePartialNames = _Array$isArray(maybePartialName) ? maybePartialName : [maybePartialName];
      return _filterInstanceProperty(_context7 = this.getValidFieldsName()).call(_context7, function (fullName) {
        return _someInstanceProperty(maybePartialNames).call(maybePartialNames, function (partialName) {
          var _context8;
          return fullName === partialName || startsWith(fullName, partialName) && _indexOfInstanceProperty(_context8 = ['.', '[']).call(_context8, fullName[partialName.length]) >= 0;
        });
      });
    }
  }, {
    key: "getFieldValuePropValue",
    value: function getFieldValuePropValue(fieldMeta) {
      var name = fieldMeta.name,
        getValueProps = fieldMeta.getValueProps,
        valuePropName = fieldMeta.valuePropName;
      var field = this.getField(name);
      var fieldValue = 'value' in field ? field.value : fieldMeta.initialValue;
      if (getValueProps) {
        return getValueProps(fieldValue);
      }
      return _defineProperty({}, valuePropName, fieldValue);
    }
  }, {
    key: "getField",
    value: function getField(name) {
      return _Object$assign(_Object$assign({}, this.fields[name]), {
        name: name
      });
    }
  }, {
    key: "getNotCollectedFields",
    value: function getNotCollectedFields() {
      var _context9,
        _context10,
        _context11,
        _this4 = this;
      return _reduceInstanceProperty(_context9 = _mapInstanceProperty(_context10 = _filterInstanceProperty(_context11 = this.getValidFieldsName()).call(_context11, function (name) {
        return !_this4.fields[name];
      })).call(_context10, function (name) {
        return {
          name: name,
          dirty: false,
          value: _this4.getFieldMeta(name).initialValue
        };
      })).call(_context9, function (acc, field) {
        return set(acc, field.name, createFormField(field));
      }, {});
    }
  }, {
    key: "getNestedAllFields",
    value: function getNestedAllFields() {
      var _context12,
        _this5 = this;
      return _reduceInstanceProperty(_context12 = _Object$keys(this.fields)).call(_context12, function (acc, name) {
        return set(acc, name, createFormField(_this5.fields[name]));
      }, this.getNotCollectedFields());
    }
  }, {
    key: "getFieldMember",
    value: function getFieldMember(name, member) {
      return this.getField(name)[member];
    }
  }, {
    key: "getNestedFields",
    value: function getNestedFields(names, getter) {
      var fields = names || this.getValidFieldsName();
      return _reduceInstanceProperty(fields).call(fields, function (acc, f) {
        return set(acc, f, getter(f));
      }, {});
    }
  }, {
    key: "getNestedField",
    value: function getNestedField(name, getter) {
      var fullNames = this.getValidFieldsFullName(name);
      if (fullNames.length === 0 ||
      // Not registered
      fullNames.length === 1 && fullNames[0] === name // Name already is full name.
      ) {
        return getter(name);
      }
      var isArrayValue = fullNames[0][name.length] === '[';
      var suffixNameStartIndex = isArrayValue ? name.length : name.length + 1;
      return _reduceInstanceProperty(fullNames).call(fullNames, function (acc, fullName) {
        return set(acc, _sliceInstanceProperty(fullName).call(fullName, suffixNameStartIndex), getter(fullName));
      }, isArrayValue ? [] : {});
    }
    // @private
    // BG: `a` and `a.b` cannot be use in the same form
  }, {
    key: "isValidNestedFieldName",
    value: function isValidNestedFieldName(name) {
      var names = this.getAllFieldsName();
      return _everyInstanceProperty(names).call(names, function (n) {
        return !partOf(n, name) && !partOf(name, n);
      });
    }
  }, {
    key: "clearField",
    value: function clearField(name) {
      delete this.fields[name];
      delete this.fieldsMeta[name];
    }
  }]);
  return FieldsStore;
}();
export default function createFieldsStore(fields) {
  return new FieldsStore(fields);
}