import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _lastIndexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/last-index-of";
/* eslint-disable no-console */
import hoistStatics from 'hoist-non-react-statics';
function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'WrappedComponent';
}
export function argumentContainer(Container, WrappedComponent) {
  /* eslint no-param-reassign:0 */
  Container.displayName = "Form(".concat(getDisplayName(WrappedComponent), ")");
  Container.WrappedComponent = WrappedComponent;
  return hoistStatics(Container, WrappedComponent);
}
export function identity(obj) {
  return obj;
}
export function flattenArray(arr) {
  return _concatInstanceProperty(Array.prototype).apply([], arr);
}
export function treeTraverse() {
  var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var tree = arguments.length > 1 ? arguments[1] : undefined;
  var isLeafNode = arguments.length > 2 ? arguments[2] : undefined;
  var errorMessage = arguments.length > 3 ? arguments[3] : undefined;
  var callback = arguments.length > 4 ? arguments[4] : undefined;
  if (isLeafNode(path, tree)) {
    callback(path, tree);
  } else if (tree === undefined || tree === null) {
    return;
  } else if (_Array$isArray(tree)) {
    _forEachInstanceProperty(tree).call(tree, function (subTree, index) {
      var _context;
      return treeTraverse(_concatInstanceProperty(_context = "".concat(path, "[")).call(_context, index, "]"), subTree, isLeafNode, errorMessage, callback);
    });
  } else {
    var _context2;
    // It's object and not a leaf node
    if (_typeof(tree) !== 'object') {
      console.error(errorMessage);
      return;
    }
    _forEachInstanceProperty(_context2 = _Object$keys(tree)).call(_context2, function (subTreeKey) {
      var _context3, _context4;
      var subTree = tree[subTreeKey];
      treeTraverse(_concatInstanceProperty(_context3 = _concatInstanceProperty(_context4 = "".concat(path)).call(_context4, path ? '.' : '')).call(_context3, subTreeKey), subTree, isLeafNode, errorMessage, callback);
    });
  }
}
export function flattenFields(maybeNestedFields, isLeafNode, errorMessage) {
  var fields = {};
  treeTraverse(undefined, maybeNestedFields, isLeafNode, errorMessage, function (path, node) {
    fields[path] = node;
  });
  return fields;
}
export function normalizeValidateRules(validate, rules, validateTrigger) {
  var validateRules = _mapInstanceProperty(validate).call(validate, function (item) {
    var newItem = _Object$assign(_Object$assign({}, item), {
      trigger: item.trigger || []
    });
    if (typeof newItem.trigger === 'string') {
      newItem.trigger = [newItem.trigger];
    }
    return newItem;
  });
  if (rules) {
    var _context5;
    validateRules.push({
      trigger: validateTrigger ? _concatInstanceProperty(_context5 = []).call(_context5, validateTrigger) : [],
      rules: rules
    });
  }
  return validateRules;
}
export function getValidateTriggers(validateRules) {
  var _context6, _context7;
  return _reduceInstanceProperty(_context6 = _mapInstanceProperty(_context7 = _filterInstanceProperty(validateRules).call(validateRules, function (item) {
    return !!item.rules && item.rules.length;
  })).call(_context7, function (item) {
    return item.trigger;
  })).call(_context6, function (pre, curr) {
    return _concatInstanceProperty(pre).call(pre, curr);
  }, []);
}
export function getValueFromEvent(e) {
  // To support custom element
  if (!e || !e.target) {
    return e;
  }
  var target = e.target;
  return target.type === 'checkbox' ? target.checked : target.value;
}
export function getErrorStrs(errors) {
  if (errors) {
    return _mapInstanceProperty(errors).call(errors, function (e) {
      if (e && e.message) {
        return e.message;
      }
      return e;
    });
  }
  return errors;
}
export function getParams(ns, opt, cb) {
  var names = ns;
  var options = opt;
  var callback = cb;
  if (cb === undefined) {
    if (typeof names === 'function') {
      callback = names;
      options = {};
      names = undefined;
    } else if (_Array$isArray(names)) {
      if (typeof options === 'function') {
        callback = options;
        options = {};
      } else {
        options = options || {};
      }
    } else {
      callback = options;
      options = names || {};
      names = undefined;
    }
  }
  return {
    names: names,
    options: options,
    callback: callback
  };
}
export function isEmptyObject(obj) {
  return _Object$keys(obj).length === 0;
}
export function hasRules(validate) {
  if (validate) {
    return _someInstanceProperty(validate).call(validate, function (item) {
      return item.rules && item.rules.length;
    });
  }
  return false;
}
export function startsWith(str, prefix) {
  return _lastIndexOfInstanceProperty(str).call(str, prefix, 0) === 0;
}