import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Driver from './src';
import { ESC_KEY_CODE, LEFT_KEY_CODE, RIGHT_KEY_CODE } from './src/common/constants';
import Modal from '../Modal';
import Button from '../Button';
import './style/index.less';
import ConfigConsumer from '../Config/Consumer';
var Guide = /*#__PURE__*/function (_Component) {
  _inherits(Guide, _Component);
  var _super = _createSuper(Guide);
  function Guide(props) {
    var _this;
    _classCallCheck(this, Guide);
    _this = _super.call(this, props);
    _this.totalCount = 0;
    _this.driver = null;
    _this.init = function () {
      var _this$props = _this.props,
        steps = _this$props.steps,
        mode = _this$props.mode;
      if (!(steps && steps.length) || mode == 'fixed') return;
      _setTimeout(function () {
        if (steps.length == 1) {
          _this.driver.highlight(steps[0]);
        } else {
          _this.driver.defineSteps(_this.props.steps);
          _this.driver.start();
        }
      }, 300);
    };
    _this.handleClose = function () {
      _this.setState({
        visible: false
      }, function () {
        _this.setState({
          currentIndex: 0
        });
      });
      _this.props.onClose && _this.props.onClose();
    };
    _this.handleNext = function () {
      var currentIndex = _this.state.currentIndex,
        nextIndex = 0;
      if (currentIndex >= _this.totalCount - 1) {
        nextIndex = _this.totalCount - 1;
        _this.handleClose();
      } else {
        nextIndex = currentIndex + 1;
      }
      _this.setState({
        currentIndex: nextIndex
      });
    };
    _this.handlePrev = function () {
      var currentIndex = _this.state.currentIndex,
        nextIndex = 0;
      if (currentIndex <= 0) {
        nextIndex = 0;
      } else {
        nextIndex = currentIndex - 1;
      }
      _this.setState({
        currentIndex: nextIndex
      });
    };
    _this.renderTitle = function (curStep) {
      if (!curStep.title) return null;
      if (curStep.subtitle) {
        return /*#__PURE__*/React.createElement(React.Fragment, null, curStep.title, /*#__PURE__*/React.createElement("div", {
          className: "".concat(_this.props.prefixCls, "-fixed-subtitle")
        }, curStep.subtitle));
      } else {
        return curStep.title;
      }
    };
    _this.state = {
      visible: props.visible,
      currentIndex: 0
    };
    _this.totalCount = props.steps.length;
    if (props.mode != 'fixed') {
      var opt = {
        counter: props.counter,
        allowClose: props.allowClose,
        keyboardControl: props.keyboardControl,
        onReset: function onReset() {
          _this.handleClose();
        }
      };
      if (!props.mask) {
        opt['opacity'] = 0;
      }
      _this.driver = new Driver(opt);
    } else {
      if (props.keyboardControl) {
        var _context;
        window.addEventListener('keyup', _bindInstanceProperty(_context = _this.onKeyUp).call(_context, _assertThisInitialized(_this)), false);
      }
    }
    return _this;
  }
  _createClass(Guide, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var visible = this.state.visible;
      if (!visible) return;
      this.init();
    }
    // eslint-disable-next-line react/no-deprecated
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;
      var visible = this.state.visible;
      if (!visible && nextProps.visible) {
        this.setState({
          visible: true
        }, function () {
          _this2.init();
        });
      }
    }
  }, {
    key: "onKeyUp",
    value: function onKeyUp(event) {
      if (!this.props.keyboardControl || this.props.mode != 'fixed') return;
      if (event.keyCode === ESC_KEY_CODE) {
        this.handleClose();
        return;
      }
      if (event.keyCode === RIGHT_KEY_CODE) {
        this.handleNext();
      } else if (event.keyCode === LEFT_KEY_CODE) {
        this.handlePrev();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        allowClose = _this$props2.allowClose,
        mode = _this$props2.mode,
        mask = _this$props2.mask,
        className = _this$props2.className,
        style = _this$props2.style,
        steps = _this$props2.steps,
        _this$state = this.state,
        visible = _this$state.visible,
        currentIndex = _this$state.currentIndex,
        rootCls = classNames("".concat(prefixCls, "-fixed"), _defineProperty({}, className, className)),
        isFirstStep = currentIndex <= 0,
        isLastStep = currentIndex >= this.totalCount - 1;
      if (mode != 'fixed') {
        return null;
      }
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "Guide"
      }, function (Locale) {
        var _context2;
        var _Locale$prevBtnText = Locale.prevBtnText,
          prevBtnText = _Locale$prevBtnText === void 0 ? '上一步' : _Locale$prevBtnText,
          _Locale$nextBtnText = Locale.nextBtnText,
          nextBtnText = _Locale$nextBtnText === void 0 ? '下一步' : _Locale$nextBtnText,
          _Locale$doneBtnText = Locale.doneBtnText,
          doneBtnText = _Locale$doneBtnText === void 0 ? '知道了' : _Locale$doneBtnText,
          _Locale$skipBtnText = Locale.skipBtnText,
          skipBtnText = _Locale$skipBtnText === void 0 ? '跳过' : _Locale$skipBtnText;
        return /*#__PURE__*/React.createElement(Modal, {
          className: rootCls,
          style: _Object$assign({}, style),
          mask: mask,
          maskClosable: allowClose,
          title: _this3.renderTitle(steps[currentIndex]),
          visible: visible,
          width: 800,
          footer: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
            key: "skip",
            className: "skip",
            onClick: _this3.handleClose
          }, skipBtnText), isFirstStep ? null : /*#__PURE__*/React.createElement(Button, {
            key: "prev",
            onClick: _this3.handlePrev
          }, prevBtnText), /*#__PURE__*/React.createElement(Button, {
            key: "next",
            type: "primary",
            onClick: _this3.handleNext
          }, isLastStep ? doneBtnText : nextBtnText, _concatInstanceProperty(_context2 = " (".concat(currentIndex + 1, "/")).call(_context2, steps.length, ")"))),
          onCancel: _this3.handleClose
        }, steps[currentIndex].content);
      });
    }
  }]);
  return Guide;
}(Component);
Guide.propTypes = {
  prefixCls: PropTypes.string,
  className: PropTypes.string,
  style: PropTypes.object,
  mode: PropTypes.string,
  steps: PropTypes.array.isRequired,
  visible: PropTypes.bool,
  counter: PropTypes.bool,
  mask: PropTypes.bool,
  allowClose: PropTypes.bool,
  keyboardControl: PropTypes.bool,
  onClose: PropTypes.func
};
Guide.defaultProps = {
  prefixCls: 'fishd-guide',
  mode: 'normal',
  allowClose: false,
  keyboardControl: false,
  visible: false,
  counter: true,
  mask: true,
  steps: []
};
export default Guide;