import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import { CLASS_STAGE_NO_ANIMATION, ID_STAGE, STAGE_HTML, CLASS_STAGE_INDEX } from '../common/constants';
import { createNodeFromString } from '../common/utils';
import Element from './element';
/**
 * Stage behind the highlighted element to give it a little
 * highlight from rest of the page
 */
var Stage = /*#__PURE__*/function (_Element) {
  _inherits(Stage, _Element);
  var _super = _createSuper(Stage);
  /**
   * @param {Object} options
   * @param {Window} window
   * @param {Document} document
   */
  function Stage(options, window, document) {
    var _this;
    _classCallCheck(this, Stage);
    _this = _super.call(this);
    _this.options = options;
    _this.window = window;
    _this.document = document;
    return _this;
  }
  /**
   * Prepares the DOM element if not already there
   * @private
   */
  _createClass(Stage, [{
    key: "attachNode",
    value: function attachNode() {
      var stage = this.document.getElementById(ID_STAGE);
      if (!stage) {
        stage = createNodeFromString(STAGE_HTML());
        document.body.appendChild(stage);
      }
      this.node = stage;
      this.currentIndexNode = stage.querySelector(".".concat(CLASS_STAGE_INDEX));
      if (!this.options.animate) {
        this.node.classList.add(CLASS_STAGE_NO_ANIMATION);
      } else {
        this.node.classList.remove(CLASS_STAGE_NO_ANIMATION);
      }
    }
    /**
     * Simply hides the stage
     * @public
     */
  }, {
    key: "hide",
    value: function hide() {
      if (!this.node || !this.node.parentElement) {
        return;
      }
      this.node.parentElement.removeChild(this.node);
    }
    /**
     * Makes it visible and sets the default properties
     * @private
     */
  }, {
    key: "setInitialStyle",
    value: function setInitialStyle() {
      this.node.style.display = 'block';
      this.node.style.left = '0';
      this.node.style.top = '0';
      this.node.style.bottom = '';
      this.node.style.right = '';
    }
    /**
     * Shows the stage at provided position
     * @param {Position} position
     * @public
     */
  }, {
    key: "show",
    value: function show(position) {
      this.attachNode();
      this.setInitialStyle();
      // 展示或隐藏步骤计数器
      if (this.options.totalCount <= 1 || !this.options.counter) {
        this.currentIndexNode.style.display = 'none';
      } else {
        this.currentIndexNode.innerHTML = this.options.currentIndex + 1;
        this.currentIndexNode.style.display = 'block';
      }
      // 设置步骤计数器的位置
      switch (this.options.counterPosition) {
        case 'leftBottom':
          this.currentIndexNode.className = "".concat(CLASS_STAGE_INDEX, " left-bottom");
          break;
        case 'rightTop':
          this.currentIndexNode.className = "".concat(CLASS_STAGE_INDEX, " right-top");
          break;
        case 'rightBottom':
          this.currentIndexNode.className = "".concat(CLASS_STAGE_INDEX, " right-bottom");
          break;
        case 'leftTop':
        default:
          this.currentIndexNode.className = "".concat(CLASS_STAGE_INDEX);
          break;
      }
      // Make it two times the padding because, half will be given on left and half on right
      var requiredPadding = this.options.padding * 2;
      var width = position.right - position.left + requiredPadding;
      var height = position.bottom - position.top + requiredPadding;
      // Show the stage
      this.node.style.display = 'block';
      this.node.style.position = 'absolute';
      this.node.style.width = "".concat(width, "px");
      this.node.style.height = "".concat(height, "px");
      this.node.style.top = "".concat(position.top - requiredPadding / 2, "px");
      this.node.style.left = "".concat(position.left - requiredPadding / 2, "px");
      this.node.style.backgroundColor = this.options.stageBackground;
    }
  }]);
  return Stage;
}(Element);
export { Stage as default };