import React from 'react';
declare type StatusValue = 'pending' | 'loading' | 'loaded' | 'failed';
interface ImageLoaderProps {
    className?: string;
    prefixCls?: string;
    placeholderSize?: string | object;
    style?: React.CSSProperties;
    preLoader?: React.ReactNode | (() => React.ReactNode);
    failedLoader?: React.ReactNode | (() => React.ReactNode);
    src: string;
    onLoad?: (event: Event) => void;
    onError?: (error: Error) => void;
    imgProps?: object;
}
interface ImageLoaderState {
    status?: StatusValue;
    prevProps?: ImageLoaderProps;
}
declare class ImageLoader extends React.Component<ImageLoaderProps, ImageLoaderState> {
    static propTypes: {
        className: any;
        prefixCls: any;
        placeholderSize: any;
        style: any;
        preLoader: any;
        failedLoader: any;
        src: any;
        onLoad: any;
        onError: any;
        imgProps: any;
    };
    static defaultProps: {
        prefixCls: string;
        placeholderSize: string;
        onLoad: () => void;
        onError: () => void;
    };
    static getDerivedStateFromProps: React.GetDerivedStateFromProps<ImageLoaderProps, ImageLoaderState>;
    private img;
    constructor(props: ImageLoaderProps);
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    getClassName(): string;
    base64Img: (cls: any) => JSX.Element;
    createLoader(): void;
    destroyLoader(): void;
    handleLoad(event: any): void;
    handleError(error: any): void;
    renderImg(): JSX.Element;
    render(): JSX.Element;
}
export default ImageLoader;
