import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import omit from 'omit.js';
import { polyfill } from 'react-lifecycles-compat';
var defaultSizeMap = {
  small: {
    width: 90,
    height: 60
  },
  "default": {
    width: 150,
    height: 100
  },
  large: {
    width: 240,
    height: 160
  }
};
var Status = {
  PENDING: 'pending',
  LOADING: 'loading',
  LOADED: 'loaded',
  FAILED: 'failed'
};
var noop = function noop() {};
var ImageLoader = /*#__PURE__*/function (_React$Component) {
  _inherits(ImageLoader, _React$Component);
  var _super = _createSuper(ImageLoader);
  function ImageLoader(props) {
    var _this;
    _classCallCheck(this, ImageLoader);
    _this = _super.call(this, props);
    _this.base64Img = function (cls) {
      var _context;
      var placeholderSize = _this.props.placeholderSize;
      var sizeProps = {
        width: '100%'
      };
      if (_typeof(placeholderSize) === 'object') {
        sizeProps = _Object$assign({}, sizeProps, placeholderSize);
      } else if (_indexOfInstanceProperty(_context = ['small', 'default', 'large']).call(_context, placeholderSize) > -1) {
        sizeProps = _Object$assign({}, sizeProps, defaultSizeMap[placeholderSize]);
      }
      return /*#__PURE__*/React.createElement("div", {
        className: cls,
        style: _Object$assign({}, sizeProps)
      });
    };
    _this.state = {
      status: props.src ? Status.LOADING : Status.PENDING,
      prevProps: props
    };
    return _this;
  }
  _createClass(ImageLoader, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.state.status === Status.LOADING) {
        this.createLoader();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.state.status === Status.LOADING && !this.img) {
        this.createLoader();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.destroyLoader();
    }
  }, {
    key: "getClassName",
    value: function getClassName() {
      var _context2, _context3;
      var prefixCls = this.props.prefixCls;
      var className = _concatInstanceProperty(_context2 = _concatInstanceProperty(_context3 = "".concat(prefixCls, " ")).call(_context3, prefixCls, "-")).call(_context2, this.state.status);
      if (this.props.className) {
        var _context4;
        className = _concatInstanceProperty(_context4 = "".concat(className, " ")).call(_context4, this.props.className);
      }
      return className;
    }
  }, {
    key: "createLoader",
    value: function createLoader() {
      var _context5, _context6;
      this.destroyLoader(); // We can only have one loader at a time.
      this.img = new Image();
      this.img.onload = _bindInstanceProperty(_context5 = this.handleLoad).call(_context5, this);
      this.img.onerror = _bindInstanceProperty(_context6 = this.handleError).call(_context6, this);
      this.img.src = this.props.src;
    }
  }, {
    key: "destroyLoader",
    value: function destroyLoader() {
      if (this.img) {
        this.img.onload = null;
        this.img.onerror = null;
        this.img = null;
      }
    }
  }, {
    key: "handleLoad",
    value: function handleLoad(event) {
      this.destroyLoader();
      this.setState({
        status: Status.LOADED
      });
      if (this.props.onLoad) this.props.onLoad(event);
    }
  }, {
    key: "handleError",
    value: function handleError(error) {
      this.destroyLoader();
      this.setState({
        status: Status.FAILED
      });
      if (this.props.onError) this.props.onError(error);
    }
  }, {
    key: "renderImg",
    value: function renderImg() {
      var _this$props = this.props,
        src = _this$props.src,
        imgProps = _this$props.imgProps;
      var otherProps = omit(imgProps, ['src']);
      return /*#__PURE__*/React.createElement("img", _Object$assign({
        src: src
      }, otherProps));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        style = _this$props2.style,
        preLoader = _this$props2.preLoader,
        failedLoader = _this$props2.failedLoader;
      var wrapperProps = {
        style: {},
        className: this.getClassName()
      };
      if (style) {
        wrapperProps.style = style;
      }
      var content = null;
      switch (this.state.status) {
        case Status.LOADED:
          // 加载成功
          content = this.renderImg();
          break;
        case Status.FAILED:
          // 使用自定义加载失败图片
          if (failedLoader) {
            if (typeof failedLoader === 'function') {
              content = failedLoader();
            } else {
              content = failedLoader;
            }
            // 使用系统预置加载失败图片
          } else {
            content = this.base64Img('failed-img');
          }
          break;
        default:
          // 使用自定义占位图片
          if (preLoader) {
            if (typeof preLoader === 'function') {
              content = preLoader();
            } else {
              content = preLoader;
            }
            // 使用系统预置占位图片
          } else {
            content = this.base64Img('preload-img');
          }
          break;
      }
      return /*#__PURE__*/React.createElement("div", _Object$assign({}, wrapperProps), content);
    }
  }]);
  return ImageLoader;
}(React.Component);
ImageLoader.propTypes = {
  className: PropTypes.string,
  prefixCls: PropTypes.string,
  placeholderSize: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  style: PropTypes.object,
  preLoader: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  failedLoader: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  src: PropTypes.string,
  onLoad: PropTypes.func,
  onError: PropTypes.func,
  imgProps: PropTypes.object
};
ImageLoader.defaultProps = {
  prefixCls: 'fishd-image-loader',
  placeholderSize: 'default',
  onLoad: noop,
  onError: noop
};
ImageLoader.getDerivedStateFromProps = function (nextProps, prevState) {
  var _prevState$prevProps = prevState.prevProps,
    prevProps = _prevState$prevProps === void 0 ? {
      src: ''
    } : _prevState$prevProps;
  var newState = {
    prevProps: nextProps
  };
  if (prevProps.src !== nextProps.src) {
    newState.status = nextProps.src ? Status.LOADING : Status.PENDING;
  }
  return newState;
};
polyfill(ImageLoader);
export default ImageLoader;