import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _keysInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/keys";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/splice";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Spin from '../Spin';
import Sortable from './sortable';
import Pagination from '../Pagination';
import { Row } from '../Grid';
import Item from './Item';
import './style/index.less';
import ConfigConsumer from '../Config/Consumer';
var List = /*#__PURE__*/function (_React$Component) {
  _inherits(List, _React$Component);
  var _super = _createSuper(List);
  function List() {
    var _this;
    _classCallCheck(this, List);
    _this = _super.apply(this, arguments);
    _this.state = {
      paginationCurrent: 1
    };
    _this.defaultPaginationProps = {
      current: 1,
      pageSize: 10,
      onChange: function onChange(page, pageSize) {
        var pagination = _this.props.pagination;
        _this.setState({
          paginationCurrent: page
        });
        if (pagination && pagination.onChange) {
          pagination.onChange(page, pageSize);
        }
      },
      total: 0
    };
    _this.keys = {};
    _this.renderItem = function (item, index) {
      var _this$props = _this.props,
        dataSource = _this$props.dataSource,
        renderItem = _this$props.renderItem,
        rowKey = _this$props.rowKey;
      var key;
      if (typeof rowKey === 'function') {
        key = rowKey(dataSource[index]);
      } else if (typeof rowKey === 'string') {
        key = dataSource[rowKey];
      } else {
        key = dataSource.key;
      }
      if (!key) {
        key = "list-item-".concat(index);
      }
      _keysInstanceProperty(_this)[index] = key;
      return renderItem(item, index);
    };
    _this.renderEmpty = function (Locale) {
      var defaultEmptyText = Locale ? Locale.emptyText : '暂无数据';
      var emptyText = _this.props.locale ? _this.props.locale.emptyText : defaultEmptyText;
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(_this.props.prefixCls, "-empty-text")
      }, emptyText);
    };
    return _this;
  }
  _createClass(List, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        grid: this.props.grid
      };
    }
  }, {
    key: "isSomethingAfterLastItem",
    value: function isSomethingAfterLastItem() {
      var _this$props2 = this.props,
        loadMore = _this$props2.loadMore,
        pagination = _this$props2.pagination,
        footer = _this$props2.footer;
      return !!(loadMore || pagination || footer);
    }
  }, {
    key: "render",
    value: function render() {
      var _context,
        _classNames,
        _this2 = this;
      var paginationCurrent = this.state.paginationCurrent;
      var _a = this.props,
        bordered = _a.bordered,
        split = _a.split,
        className = _a.className,
        children = _a.children,
        itemLayout = _a.itemLayout,
        loadMore = _a.loadMore,
        pagination = _a.pagination,
        prefixCls = _a.prefixCls,
        grid = _a.grid,
        dataSource = _a.dataSource,
        size = _a.size,
        rowKey = _a.rowKey,
        renderItem = _a.renderItem,
        header = _a.header,
        footer = _a.footer,
        loading = _a.loading,
        striped = _a.striped,
        rest = __rest(_a, ["bordered", "split", "className", "children", "itemLayout", "loadMore", "pagination", "prefixCls", "grid", "dataSource", "size", "rowKey", "renderItem", "header", "footer", "loading", "striped"]);
      var loadingProp = loading;
      if (typeof loadingProp === 'boolean') {
        loadingProp = {
          spinning: loadingProp
        };
      }
      var isLoading = loadingProp && loadingProp.spinning;
      // large => lg
      // small => sm
      var sizeCls = '';
      switch (size) {
        case 'large':
          sizeCls = 'lg';
          break;
        case 'small':
          sizeCls = 'sm';
          break;
      }
      var classString = classNames(prefixCls, className, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-vertical"), itemLayout === 'vertical'), _defineProperty(_classNames, _concatInstanceProperty(_context = "".concat(prefixCls, "-")).call(_context, sizeCls), sizeCls), _defineProperty(_classNames, "".concat(prefixCls, "-split"), split), _defineProperty(_classNames, "".concat(prefixCls, "-bordered"), bordered), _defineProperty(_classNames, "".concat(prefixCls, "-loading"), isLoading), _defineProperty(_classNames, "".concat(prefixCls, "-grid"), grid), _defineProperty(_classNames, "".concat(prefixCls, "-striped"), striped), _defineProperty(_classNames, "".concat(prefixCls, "-something-after-last-item"), this.isSomethingAfterLastItem()), _classNames));
      var paginationProps = _Object$assign(_Object$assign(_Object$assign({}, this.defaultPaginationProps), {
        total: dataSource.length,
        current: paginationCurrent
      }), pagination || {});
      var largestPage = Math.ceil(paginationProps.total / paginationProps.pageSize);
      if (paginationProps.current > largestPage) {
        paginationProps.current = largestPage;
      }
      var paginationContent = pagination ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-pagination")
      }, /*#__PURE__*/React.createElement(Pagination, _Object$assign({}, paginationProps, {
        onChange: this.defaultPaginationProps.onChange
      }))) : null;
      var splitDataSource = _toConsumableArray(dataSource);
      if (pagination) {
        if (dataSource.length > (paginationProps.current - 1) * paginationProps.pageSize) {
          var _context2;
          splitDataSource = _spliceInstanceProperty(_context2 = _toConsumableArray(dataSource)).call(_context2, (paginationProps.current - 1) * paginationProps.pageSize, paginationProps.pageSize);
        }
      }
      var renderChildrenContent = function renderChildrenContent(Locale) {
        var childrenContent;
        childrenContent = isLoading && /*#__PURE__*/React.createElement("div", {
          style: {
            minHeight: 53
          }
        });
        if (splitDataSource.length > 0) {
          var _context3;
          var items = _mapInstanceProperty(splitDataSource).call(splitDataSource, function (item, index) {
            return _this2.renderItem(item, index);
          });
          var childrenList = _mapInstanceProperty(_context3 = React.Children).call(_context3, items, function (child, index) {
            return /*#__PURE__*/React.cloneElement(child, {
              key: _keysInstanceProperty(_this2)[index]
            });
          });
          childrenContent = grid ? /*#__PURE__*/React.createElement(Row, {
            gutter: grid.gutter
          }, childrenList) : childrenList;
        } else if (!children && !isLoading) {
          childrenContent = /*#__PURE__*/React.createElement("div", null, _this2.renderEmpty(Locale));
        }
        return childrenContent;
      };
      var paginationPosition = paginationProps.position || 'bottom';
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "List"
      }, function (Locale) {
        return /*#__PURE__*/React.createElement("div", _Object$assign({
          className: classString
        }, rest), (paginationPosition === 'top' || paginationPosition === 'both') && paginationContent, header && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-header")
        }, header), /*#__PURE__*/React.createElement(Spin, _Object$assign({}, loadingProp), renderChildrenContent(Locale), children), footer && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-footer")
        }, footer), loadMore || (paginationPosition === 'bottom' || paginationPosition === 'both') && paginationContent);
      });
    }
  }]);
  return List;
}(React.Component);
List.Item = Item;
List.Sortable = Sortable;
List.childContextTypes = {
  grid: PropTypes.any
};
List.propTypes = {
  locale: PropTypes.shape({
    emptyText: PropTypes.string
  }),
  dataSource: PropTypes.array,
  prefixCls: PropTypes.string,
  bordered: PropTypes.bool,
  split: PropTypes.bool,
  loading: PropTypes.bool,
  pagination: PropTypes.bool,
  striped: PropTypes.bool
};
List.defaultProps = {
  dataSource: [],
  prefixCls: 'fishd-list',
  bordered: false,
  split: true,
  loading: false,
  pagination: false,
  striped: false
};
export default List;