import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import PropTypes from 'prop-types';
import { swapArrayElements, isMouseBeyond } from './helpers.js';
export var VERTICAL = 'VERTICAL';
export var HORIZONTAL = 'HORIZONTAL';
/*** Higher-order component - this component works like a factory for draggable items */
var draggingIndex = null;
export function SortableComposition(Component) {
  var flowDirection = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : VERTICAL;
  var _a;
  return _a = /*#__PURE__*/function (_React$Component) {
    _inherits(Sortable, _React$Component);
    var _super = _createSuper(Sortable);
    function Sortable() {
      var _this;
      _classCallCheck(this, Sortable);
      _this = _super.apply(this, arguments);
      _this.sortEnd = function (e) {
        e.preventDefault();
        draggingIndex = null;
      };
      _this.sortStart = function (e) {
        draggingIndex = e.currentTarget.dataset.id;
        var dt = e.dataTransfer;
        if (dt !== undefined) {
          dt.effectAllowed = 'move';
          e.dataTransfer.setData('text', e.target.innerHTML);
          if (dt.setDragImage && e.currentTarget.tagName.toLowerCase() === 'a') {
            dt.setDragImage(e.target, 0, 0);
          }
        }
      };
      _this.dragOver = function (e) {
        e.preventDefault();
        var moveInMiddle = _this.props.moveInMiddle;
        var overEl = e.currentTarget; //underlying element
        var indexDragged = Number(overEl.dataset.id); //index of underlying element in the set DOM elements
        var indexFrom = Number(draggingIndex);
        var height = overEl.getBoundingClientRect().height;
        var width = overEl.getBoundingClientRect().width;
        var positionX = e.clientX;
        var positionY = e.clientY;
        var topOffset = overEl.getBoundingClientRect().top;
        var leftOffset = overEl.getBoundingClientRect().left;
        var mouseBeyond;
        var items = _this.props.items;
        if (flowDirection === VERTICAL) {
          mouseBeyond = isMouseBeyond(positionY, topOffset, height, moveInMiddle);
        }
        if (flowDirection === HORIZONTAL) {
          mouseBeyond = isMouseBeyond(positionX, leftOffset, width, moveInMiddle);
        }
        if (indexDragged !== indexFrom && mouseBeyond) {
          items = swapArrayElements(items, indexFrom, indexDragged);
          draggingIndex = indexDragged;
          _this.props.onSortItems(items);
        }
      };
      return _this;
    }
    _createClass(Sortable, [{
      key: "render",
      value: function render() {
        var newProps = _Object$assign({}, this.props);
        delete newProps.onSortItems;
        var sortId = newProps.sortId,
          moveInMiddle = newProps.moveInMiddle,
          items = newProps.items,
          props = __rest(newProps, ["sortId", "moveInMiddle", "items"]);
        return /*#__PURE__*/React.createElement(Component, _Object$assign({
          draggable: true,
          onDragOver: this.dragOver,
          onDragStart: this.sortStart,
          onDragEnd: this.sortEnd,
          onTouchStart: this.sortStart,
          onTouchMove: this.dragOver,
          onTouchEnd: this.sortEnd,
          "data-id": sortId
        }, props));
      }
    }]);
    return Sortable;
  }(React.Component), _a.propTypes = {
    items: PropTypes.array.isRequired,
    onSortItems: PropTypes.func.isRequired,
    sortId: PropTypes.number,
    moveInMiddle: PropTypes.bool
  }, _a.defaultProps = {
    moveInMiddle: false
  }, _a;
}