import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import { findDOMNode } from 'react-dom';
import RcMenu, { Divider, ItemGroup } from './src';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
import warning from 'warning';
import { polyfill } from 'react-lifecycles-compat';
import animation from '../../utils/openAnimation';
import SubMenu from './SubMenu';
import Item from './MenuItem';
import './style/index.less';
var Menu = /*#__PURE__*/function (_React$Component) {
  _inherits(Menu, _React$Component);
  var _super = _createSuper(Menu);
  function Menu(props, context) {
    var _this;
    _classCallCheck(this, Menu);
    _this = _super.call(this, props);
    _this.inlineOpenKeys = [];
    _this.handleClick = function (e) {
      _this.handleOpenChange([]);
      var onClick = _this.props.onClick;
      if (onClick) {
        onClick(e);
      }
    };
    _this.handleOpenChange = function (openKeys) {
      _this.setOpenKeys(openKeys);
      var onOpenChange = _this.props.onOpenChange;
      if (onOpenChange) {
        onOpenChange(openKeys);
      }
    };
    warning(!('onOpen' in props || 'onClose' in props), '`onOpen` and `onClose` are removed, please use `onOpenChange` instead, ' + 'see: https://u.ant.design/menu-on-open-change.');
    warning(!('inlineCollapsed' in props && props.mode !== 'inline'), "`inlineCollapsed` should only be used when Menu's `mode` is inline.");
    _this.switchModeFromInline = true;
    var openKeys;
    if ('defaultOpenKeys' in props) {
      openKeys = props.defaultOpenKeys;
    } else if ('openKeys' in props) {
      openKeys = props.openKeys;
    }
    _this.state = {
      openKeys: openKeys || []
    };
    return _this;
  }
  _createClass(Menu, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if ('openKeys' in this.props) return;
      var newState = {};
      if (prevProps.mode === 'inline' && this.props.mode !== 'inline') {
        this.switchModeFromInline = true;
      }
      if (this.props.inlineCollapsed && !prevProps.inlineCollapsed || this.context.siderCollapsed && !this.siderCollapsed) {
        var menuNode = findDOMNode(this);
        this.switchModeFromInline = !!prevState.openKeys.length && !!menuNode.querySelectorAll(".".concat(this.props.prefixCls, "-submenu-open")).length;
        this.inlineOpenKeys = this.state.openKeys;
        newState['openKeys'] = [];
        this.siderCollapsed = this.context.siderCollapsed;
        this.setState(newState);
      } else if (!this.props.inlineCollapsed && prevProps.inlineCollapsed || !this.context.siderCollapsed && this.siderCollapsed) {
        newState['openKeys'] = this.inlineOpenKeys;
        this.siderCollapsed = this.context.siderCollapsed;
        this.inlineOpenKeys = [];
        this.setState(newState);
      }
    }
  }, {
    key: "getChildContext",
    value: function getChildContext() {
      return {
        inlineCollapsed: this.getInlineCollapsed(),
        menuTheme: this.props.theme
      };
    }
  }, {
    key: "setOpenKeys",
    value: function setOpenKeys(openKeys) {
      if (!('openKeys' in this.props)) {
        this.setState({
          openKeys: openKeys
        });
      }
    }
  }, {
    key: "getRealMenuMode",
    value: function getRealMenuMode() {
      var inlineCollapsed = this.getInlineCollapsed();
      if (this.switchModeFromInline && inlineCollapsed) {
        return 'inline';
      }
      var mode = this.props.mode;
      return inlineCollapsed ? 'vertical' : mode;
    }
  }, {
    key: "getInlineCollapsed",
    value: function getInlineCollapsed() {
      var inlineCollapsed = this.props.inlineCollapsed;
      if (this.context.siderCollapsed !== undefined) {
        return this.context.siderCollapsed;
      }
      return inlineCollapsed;
    }
  }, {
    key: "getMenuOpenAnimation",
    value: function getMenuOpenAnimation(menuMode) {
      var _this2 = this;
      var _this$props = this.props,
        openAnimation = _this$props.openAnimation,
        openTransitionName = _this$props.openTransitionName;
      var menuOpenAnimation = openAnimation || openTransitionName;
      if (openAnimation === undefined && openTransitionName === undefined) {
        switch (menuMode) {
          case 'horizontal':
            menuOpenAnimation = 'slide-up';
            break;
          case 'vertical':
          case 'vertical-left':
          case 'vertical-right':
            // When mode switch from inline
            // submenu should hide without animation
            if (this.switchModeFromInline) {
              menuOpenAnimation = '';
              this.switchModeFromInline = false;
            } else {
              menuOpenAnimation = 'zoom-big';
            }
            break;
          case 'inline':
            menuOpenAnimation = _Object$assign(_Object$assign({}, animation), {
              leave: function leave(node, done) {
                return animation.leave(node, function () {
                  // Make sure inline menu leave animation finished before mode is switched
                  _this2.switchModeFromInline = false;
                  _this2.setState({});
                  // when inlineCollapsed change false to true, all submenu will be unmounted,
                  // so that we don't need handle animation leaving.
                  if (_this2.getRealMenuMode() === 'vertical') {
                    return;
                  }
                  done();
                });
              }
            });
            break;
          default:
        }
      }
      return menuOpenAnimation;
    }
  }, {
    key: "render",
    value: function render() {
      var _context;
      var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        className = _this$props2.className,
        theme = _this$props2.theme;
      var menuMode = this.getRealMenuMode();
      var menuOpenAnimation = this.getMenuOpenAnimation(menuMode);
      var menuClassName = classNames(className, _concatInstanceProperty(_context = "".concat(prefixCls, "-")).call(_context, theme), _defineProperty({}, "".concat(prefixCls, "-inline-collapsed"), this.getInlineCollapsed()));
      var menuProps = {
        openKeys: this.state.openKeys,
        onOpenChange: this.handleOpenChange,
        className: menuClassName,
        mode: menuMode
      };
      if (menuMode !== 'inline') {
        // closing vertical popup submenu after click it
        menuProps.onClick = this.handleClick;
        menuProps.openTransitionName = menuOpenAnimation;
      } else {
        menuProps.openAnimation = menuOpenAnimation;
      }
      // https://github.com/ant-design/ant-design/issues/8587
      var collapsedWidth = this.context.collapsedWidth;
      if (this.getInlineCollapsed() && (collapsedWidth === 0 || collapsedWidth === '0' || collapsedWidth === '0px')) {
        return null;
      }
      return /*#__PURE__*/React.createElement(RcMenu, _Object$assign({}, this.props, menuProps));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if ('openKeys' in nextProps) {
        newState['openKeys'] = nextProps.openKeys;
      }
      return newState;
    }
  }]);
  return Menu;
}(React.Component);
Menu.Divider = Divider;
Menu.Item = Item;
Menu.SubMenu = SubMenu;
Menu.ItemGroup = ItemGroup;
Menu.defaultProps = {
  prefixCls: 'fishd-menu',
  className: '',
  theme: 'light',
  focusable: false
};
Menu.childContextTypes = {
  inlineCollapsed: PropTypes.bool,
  menuTheme: PropTypes.string
};
Menu.contextTypes = {
  siderCollapsed: PropTypes.bool,
  collapsedWidth: PropTypes.oneOfType([PropTypes.number, PropTypes.string])
};
polyfill(Menu);
export default Menu;