import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _parseInt from "@babel/runtime-corejs3/core-js-stable/parse-int";
import _Date$now from "@babel/runtime-corejs3/core-js-stable/date/now";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import Animate from 'rc-animate';
import Draggable from 'react-draggable';
import classNames from 'classnames';
import Icon from '../Icon';
import { contains, getScrollBarSize, KeyCode } from '../../utils/index';
import LazyRenderBox from './LazyRenderBox';
var uuid = 0;
var openCount = 0;
/* eslint react/no-is-mounted:0 */
function getScroll(w, top) {
  var ret = w["page".concat(top ? 'Y' : 'X', "Offset")];
  var method = "scroll".concat(top ? 'Top' : 'Left');
  if (typeof ret !== 'number') {
    var d = w.document;
    ret = d.documentElement[method];
    if (typeof ret !== 'number') {
      ret = d.body[method];
    }
  }
  return ret;
}
function setTransformOrigin(node, value) {
  var _context;
  var style = node.style;
  _forEachInstanceProperty(_context = ['Webkit', 'Moz', 'Ms', 'ms']).call(_context, function (prefix) {
    style["".concat(prefix, "TransformOrigin")] = value;
  });
  style["transformOrigin"] = value;
}
function offset(el) {
  var rect = el.getBoundingClientRect();
  var pos = {
    left: rect.left,
    top: rect.top
  };
  var doc = el.ownerDocument;
  var w = doc.defaultView || doc.parentWindow;
  pos.left += getScroll(w);
  pos.top += getScroll(w, true);
  return pos;
}
var Dialog = /*#__PURE__*/function (_React$Component) {
  _inherits(Dialog, _React$Component);
  var _super = _createSuper(Dialog);
  function Dialog(props) {
    var _this;
    _classCallCheck(this, Dialog);
    _this = _super.call(this, props);
    _this.getBodyMaxHeight = function () {
      var dialog = ReactDOM.findDOMNode(_this.dialog);
      var offsetTop = Math.max(0, _parseInt(getComputedStyle(dialog).top));
      var difference = 2 * offsetTop;
      if (_this.header) difference += _this.header.offsetHeight;
      if (_this.footer) difference += _this.footer.offsetHeight;
      return difference;
    };
    _this.onAnimateLeave = function () {
      var afterClose = _this.props.afterClose;
      // need demo?
      // https://github.com/react-component/dialog/pull/28
      if (_this.wrap) {
        _this.wrap.style.display = 'none';
      }
      _this.inTransition = false;
      _this.removeScrollingEffect();
      if (afterClose) {
        afterClose();
      }
    };
    _this.onMaskClick = function (e) {
      // android trigger click on open (fastclick??)
      if (_Date$now() - _this.openTime < 300) {
        return;
      }
      if (e.target === e.currentTarget) {
        _this.close(e);
      }
    };
    _this.onKeyDown = function (e) {
      var props = _this.props;
      if (props.esc && e.keyCode === KeyCode.ESC) {
        _this.close(e);
      }
      // keep focus inside dialog
      if (props.visible) {
        if (e.keyCode === KeyCode.TAB) {
          var activeElement = document.activeElement;
          var dialogRoot = _this.wrap;
          if (e.shiftKey) {
            if (activeElement === dialogRoot) {
              _this.sentinel.focus();
            }
          } else if (activeElement === _this.sentinel) {
            dialogRoot.focus();
          }
        }
      }
    };
    _this.getDialogElement = function () {
      var _context2;
      var props = _this.props;
      var closable = props.closable;
      var prefixCls = props.prefixCls;
      var dest = {};
      if (props.width !== undefined) {
        dest.width = props.width;
      }
      if (props.height !== undefined) {
        dest.height = props.height;
      }
      var footer;
      if (props.footer) {
        footer = /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-footer"),
          ref: _this.saveRef('footer')
        }, props.footer);
      }
      var header;
      if (props.title) {
        header = /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-header"),
          ref: _this.saveRef('header')
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-title"),
          id: _this.titleId
        }, props.title));
      }
      var closer;
      if (closable) {
        closer = /*#__PURE__*/React.createElement("button", {
          onClick: _this.close,
          "aria-label": "Close",
          className: "".concat(prefixCls, "-close")
        }, /*#__PURE__*/React.createElement(Icon, {
          type: "close-modal-line"
        }));
      }
      var style = _Object$assign(_Object$assign({}, props.style), dest);
      var transitionName = props.transitionName;
      var dialog = /*#__PURE__*/React.createElement("div", {
        className: classNames("".concat(prefixCls, "-dialog"), {
          draggable: props.draggable
        })
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-content")
      }, closer, header, /*#__PURE__*/React.createElement("div", _Object$assign({
        className: "".concat(prefixCls, "-body"),
        style: props.bodyStyle,
        ref: _this.saveRef('body')
      }, props.bodyProps), props.children), footer), /*#__PURE__*/React.createElement("div", {
        tabIndex: 0,
        ref: _this.saveRef('sentinel'),
        style: {
          width: 0,
          height: 0,
          overflow: 'hidden'
        }
      }, "sentinel"));
      var dialogElement = /*#__PURE__*/React.createElement(LazyRenderBox, {
        key: "dialog-element",
        role: "document",
        ref: _this.saveRef('dialog'),
        style: style,
        className: _concatInstanceProperty(_context2 = "".concat(prefixCls, " ")).call(_context2, props.className || ''),
        visible: props.visible
      }, props.draggable ? /*#__PURE__*/React.createElement(Draggable, null, dialog) : dialog);
      return /*#__PURE__*/React.createElement(Animate, {
        key: "dialog",
        showProp: "visible",
        onLeave: _this.onAnimateLeave,
        transitionName: transitionName,
        component: "",
        visible: props.visible,
        transitionAppear: true
      }, props.visible || !props.destroyOnClose ? dialogElement : null);
    };
    _this.getZIndexStyle = function () {
      var style = {};
      var props = _this.props;
      if (props.zIndex !== undefined) {
        style.zIndex = props.zIndex;
      }
      return style;
    };
    _this.getWrapStyle = function () {
      return _Object$assign(_Object$assign({}, _this.getZIndexStyle()), _this.props.wrapStyle);
    };
    _this.getMaskStyle = function () {
      return _Object$assign(_Object$assign({}, _this.getZIndexStyle()), _this.props.maskStyle);
    };
    _this.getMaskElement = function () {
      var props = _this.props;
      var maskElement;
      if (props.mask) {
        var maskTransition = props.maskTransitionName;
        maskElement = /*#__PURE__*/React.createElement(LazyRenderBox, _Object$assign({
          style: _this.getMaskStyle(),
          key: "mask",
          className: "".concat(props.prefixCls, "-mask"),
          hiddenClassName: "".concat(props.prefixCls, "-mask-hidden"),
          visible: props.visible
        }, props.maskProps));
        if (maskTransition) {
          maskElement = /*#__PURE__*/React.createElement(Animate, {
            key: "mask",
            showProp: "visible",
            transitionAppear: true,
            component: "",
            transitionName: maskTransition
          }, maskElement);
        }
      }
      return maskElement;
    };
    _this.setScrollbar = function () {
      if (_this.bodyIsOverflowing && _this.scrollbarWidth !== undefined) {
        document.body.style.paddingRight = "".concat(_this.scrollbarWidth, "px");
      }
    };
    _this.addScrollingEffect = function () {
      openCount++;
      if (openCount !== 1) {
        return;
      }
      _this.checkScrollbar();
      _this.setScrollbar();
      document.body.style.overflow = 'hidden';
      // this.adjustDialog();
    };

    _this.removeScrollingEffect = function () {
      openCount--;
      if (openCount !== 0) {
        return;
      }
      document.body.style.overflow = '';
      _this.resetScrollbar();
      // this.resetAdjustments();
    };

    _this.close = function (e) {
      var onClose = _this.props.onClose;
      if (onClose) {
        onClose(e);
      }
    };
    _this.checkScrollbar = function () {
      var fullWindowWidth = window.innerWidth;
      if (!fullWindowWidth) {
        // workaround for missing window.innerWidth in IE8
        var documentElementRect = document.documentElement.getBoundingClientRect();
        fullWindowWidth = documentElementRect.right - Math.abs(documentElementRect.left);
      }
      _this.bodyIsOverflowing = document.body.clientWidth < fullWindowWidth;
      if (_this.bodyIsOverflowing) {
        _this.scrollbarWidth = getScrollBarSize();
      }
    };
    _this.resetScrollbar = function () {
      document.body.style.paddingRight = '';
    };
    _this.adjustDialog = function () {
      if (_this.wrap && _this.scrollbarWidth !== undefined) {
        var modalIsOverflowing = _this.wrap.scrollHeight > document.documentElement.clientHeight;
        _this.wrap.style.paddingLeft = "".concat(!_this.bodyIsOverflowing && modalIsOverflowing ? _this.scrollbarWidth : '', "px");
        _this.wrap.style.paddingRight = "".concat(_this.bodyIsOverflowing && !modalIsOverflowing ? _this.scrollbarWidth : '', "px");
      }
    };
    _this.resetAdjustments = function () {
      if (_this.wrap) {
        _this.wrap.style.paddingLeft = _this.wrap.style.paddingLeft = '';
      }
    };
    _this.saveRef = function (name) {
      return function (node) {
        _this[name] = node;
      };
    };
    if ('keyboard' in props) {
      throw new Error("API 'keyboard' is deprecated. Use 'esc' instead.");
    }
    _this.inTransition = false;
    _this.titleId = "rcDialogTitle".concat(uuid++);
    return _this;
  }
  _createClass(Dialog, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.componentDidUpdate({});
      if (this.body) {
        this.body.style.maxHeight = "calc(100vh - ".concat(this.getBodyMaxHeight(), "px)");
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var props = this.props;
      var mousePosition = this.props.mousePosition;
      if (props.visible) {
        // first show
        if (!prevProps.visible) {
          this.openTime = _Date$now();
          this.addScrollingEffect();
          this.tryFocus();
          var dialogNode = ReactDOM.findDOMNode(this.dialog);
          if (mousePosition) {
            var _context3;
            var elOffset = offset(dialogNode);
            setTransformOrigin(dialogNode, _concatInstanceProperty(_context3 = "".concat(mousePosition.x - elOffset.left, "px ")).call(_context3, mousePosition.y - elOffset.top, "px"));
          } else {
            setTransformOrigin(dialogNode, '');
          }
        }
      } else if (prevProps.visible) {
        this.inTransition = true;
        if (props.mask && this.lastOutSideFocusNode) {
          try {
            this.lastOutSideFocusNode.focus();
          } catch (e) {
            this.lastOutSideFocusNode = null;
          }
          this.lastOutSideFocusNode = null;
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.props.visible || this.inTransition) {
        this.removeScrollingEffect();
      }
    }
  }, {
    key: "tryFocus",
    value: function tryFocus() {
      if (!contains(this.wrap, document.activeElement)) {
        this.lastOutSideFocusNode = document.activeElement;
        this.wrap.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _context4;
      var props = this.props;
      var prefixCls = props.prefixCls,
        maskClosable = props.maskClosable;
      var style = this.getWrapStyle();
      // clear hide display
      // and only set display after async anim, not here for hide
      if (props.visible) {
        style.display = null;
      }
      return /*#__PURE__*/React.createElement("div", null, this.getMaskElement(), /*#__PURE__*/React.createElement("div", _Object$assign({
        tabIndex: -1,
        onKeyDown: this.onKeyDown,
        className: _concatInstanceProperty(_context4 = "".concat(prefixCls, "-wrap ")).call(_context4, props.wrapClassName || ''),
        ref: this.saveRef('wrap'),
        onClick: maskClosable ? this.onMaskClick : undefined,
        role: "dialog",
        "aria-labelledby": props.title ? this.titleId : null,
        style: style
      }, props.wrapProps), this.getDialogElement()));
    }
  }]);
  return Dialog;
}(React.Component);
export { Dialog as default };
Dialog.defaultProps = {
  className: '',
  mask: true,
  visible: false,
  esc: true,
  closable: true,
  maskClosable: true,
  destroyOnClose: false,
  draggable: false,
  prefixCls: 'rc-dialog'
};