import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import Dialog from './DialogWrap';
import * as PropTypes from 'prop-types';
import { addEventListener } from '../../utils/index';
import Button from '../Button';
import ConfigConsumer from '../Config/Consumer';
var mousePosition;
var mousePositionEventBinded;
var Modal = /*#__PURE__*/function (_React$Component) {
  _inherits(Modal, _React$Component);
  var _super = _createSuper(Modal);
  function Modal() {
    var _this;
    _classCallCheck(this, Modal);
    _this = _super.apply(this, arguments);
    _this.handleCancel = function (e) {
      var onCancel = _this.props.onCancel;
      if (onCancel) {
        onCancel(e);
      }
    };
    _this.handleOk = function (e) {
      var onOk = _this.props.onOk;
      if (onOk) {
        onOk(e);
      }
    };
    return _this;
  }
  _createClass(Modal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (mousePositionEventBinded) {
        return;
      }
      // 只有点击事件支持从鼠标位置动画展开
      addEventListener(document.documentElement, 'click', function (e) {
        mousePosition = {
          x: e.pageX,
          y: e.pageY
        };
        // 100ms 内发生过点击事件，则从点击位置动画展示
        // 否则直接 zoom 展示
        // 这样可以兼容非点击方式展开
        _setTimeout(function () {
          return mousePosition = null;
        }, 100);
      });
      mousePositionEventBinded = true;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        footer = _this$props.footer,
        visible = _this$props.visible,
        okText = _this$props.okText,
        okType = _this$props.okType,
        cancelText = _this$props.cancelText,
        confirmLoading = _this$props.confirmLoading,
        cancelButtonDisabled = _this$props.cancelButtonDisabled,
        okButtonDisabled = _this$props.okButtonDisabled,
        cancelButtonProps = _this$props.cancelButtonProps,
        okButtonProps = _this$props.okButtonProps;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "Modal"
      }, function (Locale) {
        var defaultFooter = /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Button, _Object$assign({
          onClick: _this2.handleCancel,
          disabled: cancelButtonDisabled
        }, cancelButtonProps), cancelText || Locale.cancelText), /*#__PURE__*/React.createElement(Button, _Object$assign({
          type: okType,
          loading: confirmLoading,
          onClick: _this2.handleOk,
          disabled: okButtonDisabled
        }, okButtonProps), okText || Locale.okText));
        return /*#__PURE__*/React.createElement(Dialog, _Object$assign({}, _this2.props, {
          footer: footer === undefined ? defaultFooter : footer,
          visible: visible,
          mousePosition: mousePosition,
          onClose: _this2.handleCancel
        }));
      });
    }
  }]);
  return Modal;
}(React.Component);
export { Modal as default };
Modal.defaultProps = {
  prefixCls: 'fishd-modal',
  width: 560,
  transitionName: 'zoom',
  maskTransitionName: 'fade',
  confirmLoading: false,
  visible: false,
  okType: 'primary',
  okButtonDisabled: false,
  cancelButtonDisabled: false,
  draggable: false,
  maskClosable: false,
  esc: false
  // okText: '确定',
  // cancelText: '取消',
  // justOkText: '知道了'
};

Modal.propTypes = {
  prefixCls: PropTypes.string,
  onOk: PropTypes.func,
  onCancel: PropTypes.func,
  okText: PropTypes.node,
  cancelText: PropTypes.node,
  draggable: PropTypes.bool,
  width: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  confirmLoading: PropTypes.bool,
  visible: PropTypes.bool,
  align: PropTypes.object,
  footer: PropTypes.node,
  title: PropTypes.node,
  closable: PropTypes.bool
};