var _this = this;
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import classNames from 'classnames';
import Icon from '../Icon/index';
import Dialog from './Modal';
import ActionButton from './ActionButton';
import { getRuntimeLocale } from '../Config/Locale/Provider';
var IS_REACT_16 = !!ReactDOM.createPortal;
var ConfirmDialog = function ConfirmDialog(props) {
  var _context;
  var runtimeLocale = getRuntimeLocale('Modal');
  var onCancel = props.onCancel,
    onOk = props.onOk,
    close = props.close,
    zIndex = props.zIndex,
    afterClose = props.afterClose,
    visible = props.visible,
    esc = props.esc;
  var iconType = props.iconType || 'hints-descriptions';
  var okType = props.okType || 'primary';
  var prefixCls = props.prefixCls || 'fishd-confirm';
  // 默认为 true，保持向下兼容
  var okCancel = 'okCancel' in props ? props.okCancel : true;
  var width = props.width || 416;
  var style = props.style || {};
  // 默认为 false，保持旧版默认行为
  var maskClosable = props.maskClosable === undefined ? false : props.maskClosable;
  var okText = props.okText || runtimeLocale.okText;
  var cancelText = props.cancelText || runtimeLocale.cancelText;
  var classString = classNames(prefixCls, _concatInstanceProperty(_context = "".concat(prefixCls, "-")).call(_context, props.type), props.className);
  var cancelButton = okCancel && /*#__PURE__*/React.createElement(ActionButton, {
    actionFn: onCancel,
    closeModal: close
  }, cancelText);
  return /*#__PURE__*/React.createElement(Dialog, {
    className: classString,
    onCancel: _bindInstanceProperty(close).call(close, _this, {
      triggerCancel: true
    }),
    visible: visible,
    title: "",
    footer: "",
    maskClosable: maskClosable,
    style: style,
    width: width,
    zIndex: zIndex,
    afterClose: afterClose,
    esc: esc
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-body-wrapper")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-body")
  }, /*#__PURE__*/React.createElement(Icon, {
    type: iconType
  }), /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-title")
  }, props.title), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-content")
  }, props.content)), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-btns")
  }, cancelButton, /*#__PURE__*/React.createElement(ActionButton, {
    type: okType,
    actionFn: onOk,
    closeModal: close,
    autoFocus: true
  }, okText || runtimeLocale.okText))));
};
export default function confirm(config) {
  var div = document.createElement('div');
  document.body.appendChild(div);
  function close() {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    if (IS_REACT_16) {
      var _context2;
      render(_Object$assign(_Object$assign({}, config), {
        close: close,
        visible: false,
        afterClose: _bindInstanceProperty(destroy).apply(destroy, _concatInstanceProperty(_context2 = [this]).call(_context2, args))
      }));
    } else {
      destroy.apply(void 0, args);
    }
  }
  function destroy() {
    var unmountResult = ReactDOM.unmountComponentAtNode(div);
    if (unmountResult && div.parentNode) {
      div.parentNode.removeChild(div);
    }
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    var triggerCancel = args && args.length && _someInstanceProperty(args).call(args, function (param) {
      return param && param.triggerCancel;
    });
    if (config.onCancel && triggerCancel) {
      config.onCancel.apply(config, args);
    }
  }
  function render(props) {
    ReactDOM.render( /*#__PURE__*/React.createElement(ConfirmDialog, _Object$assign({}, props)), div);
  }
  render(_Object$assign(_Object$assign({}, config), {
    visible: true,
    close: close
  }));
  return {
    destroy: close
  };
}