import React, { Component } from 'react';
import './style/index.less';
declare type ImageItem = {
    rotateValue?: number;
    src?: string;
    alt?: string;
    name?: string;
};
interface PicturePreviewProps {
    activeIndex?: number;
    className?: string;
    draggable?: boolean;
    esc?: boolean;
    mask?: boolean;
    onClose?: () => void;
    progress?: boolean;
    source?: ImageItem[];
    style?: React.CSSProperties;
    toolbar?: boolean;
    visible?: boolean;
    prefixCls?: string;
    children?: React.ReactNode;
}
interface PicturePreviewState {
    lastActiveIndex: number;
    current: number;
    lastVisible: boolean;
    show: boolean;
    imgs: ImageItem[];
    container: {
        rect?: {
            left: number;
            top: number;
        };
        startX?: number;
        startY?: number;
        style?: {
            [key: string]: any;
        };
        isFull?: boolean;
    };
    image: {
        el: null;
        startX: number;
        startY: number;
        marginL: number;
        marginT: number;
        naturalWidth: number;
        naturalHeight: number;
        ratio: number;
    };
    shown: boolean;
}
declare class PicturePreview extends Component<PicturePreviewProps, PicturePreviewState> {
    static propTypes: {
        prefixCls: any;
        className: any;
        style: any;
        children: any;
        toolbar: any;
        source: any;
        draggable: any;
        esc: any;
        mask: any;
        progress: any;
        visible: any;
        activeIndex: any;
        onClose: any;
    };
    static defaultProps: {
        prefixCls: string;
        toolbar: boolean;
        source: any[];
        draggable: boolean;
        esc: boolean;
        mask: boolean;
        progress: boolean;
        visible: boolean;
        activeIndex: number;
        onClose: () => void;
    };
    static getDerivedStateFromProps: React.GetDerivedStateFromProps<PicturePreviewProps, PicturePreviewState>;
    imgEl: ImageItem & HTMLImageElement;
    downloadImgUrl: string;
    moving: string;
    bodyDefaultOverflow: string;
    $el: HTMLElement | null;
    $root: HTMLElement | null;
    constructor(props: PicturePreviewProps);
    componentDidMount(): void;
    componentDidUpdate(prevProps: any, prevState: any, snapshot: any): void;
    componentWillUnmount(): void;
    getSnapshotBeforeUpdate(prevProps: any, prevState: any): string;
    /**
     * 切换图片时，根据图片大小确定容器的尺寸及位置
     */
    setContainerStyle: () => void;
    isFullEnabled: () => any;
    isOne2One: () => boolean;
    handleClose: () => void;
    handlePrev: () => void;
    handleNext: () => void;
    handleZoom: (ratio: any) => void;
    handleSwitchFull: () => void;
    handleRotate: () => void;
    handleSave: () => void;
    handleFullChange: (e: any) => void;
    handleMouseDown: (e: any) => void;
    handleMouseMove: (e: any) => void;
    handleMouseUp: (e: any) => void;
    handleWheel: (e: any) => void;
    handleKeyDown: (e: any) => void;
    render(): JSX.Element;
}
export default PicturePreview;
