import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _parseInt from "@babel/runtime-corejs3/core-js-stable/parse-int";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import PropTypes from 'prop-types';
import * as React from 'react';
import Icon from '../Icon';
import { Circle } from './src/index.js';
import classNames from 'classnames';
var statusColorMap = {
  normal: '#108ee9',
  exception: '#ff5500',
  success: '#87d068'
};
var validProgress = function validProgress(progress) {
  if (!progress || progress < 0) {
    return 0;
  } else if (progress > 100) {
    return 100;
  }
  return progress;
};
var Progress = /*#__PURE__*/function (_React$Component) {
  _inherits(Progress, _React$Component);
  var _super = _createSuper(Progress);
  function Progress() {
    _classCallCheck(this, Progress);
    return _super.apply(this, arguments);
  }
  _createClass(Progress, [{
    key: "render",
    value: function render() {
      var _context, _context2, _context3, _classNames;
      var props = this.props;
      var prefixCls = props.prefixCls,
        className = props.className,
        _props$percent = props.percent,
        percent = _props$percent === void 0 ? 0 : _props$percent,
        status = props.status,
        format = props.format,
        trailColor = props.trailColor,
        size = props.size,
        successPercent = props.successPercent,
        type = props.type,
        strokeWidth = props.strokeWidth,
        width = props.width,
        showInfo = props.showInfo,
        _props$gapDegree = props.gapDegree,
        gapDegree = _props$gapDegree === void 0 ? 0 : _props$gapDegree,
        gapPosition = props.gapPosition,
        strokeColor = props.strokeColor,
        _props$strokeLinecap = props.strokeLinecap,
        strokeLinecap = _props$strokeLinecap === void 0 ? 'round' : _props$strokeLinecap,
        extraContent = props.extraContent,
        message = props.message,
        operation = props.operation,
        restProps = __rest(props, ["prefixCls", "className", "percent", "status", "format", "trailColor", "size", "successPercent", "type", "strokeWidth", "width", "showInfo", "gapDegree", "gapPosition", "strokeColor", "strokeLinecap", "extraContent", "message", "operation"]);
      var progressStatus = _parseInt(successPercent ? successPercent.toString() : percent.toString(), 10) >= 100 && !('status' in props) ? 'success' : status || 'normal';
      var progressInfo;
      var progress;
      var textFormatter = format || function (percentNumber) {
        return "".concat(percentNumber, "%");
      };
      if (showInfo) {
        var text;
        var iconType = type === 'circle' || type === 'dashboard' ? 'hints-alone-' : 'hints-';
        if (format || progressStatus !== 'exception' && progressStatus !== 'success') {
          text = textFormatter(validProgress(percent), validProgress(successPercent));
        } else if (progressStatus === 'exception') {
          text = /*#__PURE__*/React.createElement(Icon, {
            type: "".concat(iconType, "error")
          });
        } else if (progressStatus === 'success') {
          text = /*#__PURE__*/React.createElement(Icon, {
            type: "".concat(iconType, "success")
          });
        }
        progressInfo = /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-text")
        }, text);
      }
      if (type === 'line') {
        var percentStyle = {
          width: "".concat(validProgress(percent), "%"),
          height: strokeWidth || (size === 'small' ? 6 : 8),
          background: strokeColor,
          borderRadius: strokeLinecap === 'square' ? 0 : '100px'
        };
        var successPercentStyle = {
          width: "".concat(validProgress(successPercent), "%"),
          height: strokeWidth || (size === 'small' ? 6 : 8),
          borderRadius: strokeLinecap === 'square' ? 0 : '100px'
        };
        var successSegment = successPercent !== undefined ? /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-success-bg"),
          style: successPercentStyle
        }) : null;
        progress = /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-line-ctner")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-basic")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-outer")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-inner")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-bg"),
          style: percentStyle
        }, extraContent ? /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-extra")
        }, extraContent) : null), successSegment)), progressInfo), message ? /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-msg")
        }, message) : null, operation ? /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-oper")
        }, operation) : null);
      } else if (type === 'circle' || type === 'dashboard') {
        var circleSize = width || 120;
        var circleStyle = {
          width: circleSize,
          height: circleSize,
          fontSize: circleSize * 0.15 + 6
        };
        var circleWidth = strokeWidth || 6;
        var gapPos = gapPosition || type === 'dashboard' && 'bottom' || 'top';
        var gapDeg = gapDegree || type === 'dashboard' && 75;
        progress = /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-inner"),
          style: circleStyle
        }, /*#__PURE__*/React.createElement(Circle, {
          percent: validProgress(percent),
          strokeWidth: circleWidth,
          trailWidth: circleWidth,
          strokeColor: statusColorMap[progressStatus],
          strokeLinecap: strokeLinecap,
          trailColor: trailColor,
          prefixCls: prefixCls,
          gapDegree: gapDeg,
          gapPosition: gapPos
        }), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-circle-info")
        }, progressInfo, message ? /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-msg")
        }, message) : null));
      }
      var classString = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, _concatInstanceProperty(_context = "".concat(prefixCls, "-")).call(_context, type === 'dashboard' && 'circle' || type), true), _defineProperty(_classNames, _concatInstanceProperty(_context2 = "".concat(prefixCls, "-status-")).call(_context2, progressStatus), true), _defineProperty(_classNames, "".concat(prefixCls, "-show-info"), showInfo), _defineProperty(_classNames, _concatInstanceProperty(_context3 = "".concat(prefixCls, "-")).call(_context3, size), size), _classNames), className);
      return /*#__PURE__*/React.createElement("div", _Object$assign({}, restProps, {
        className: classString
      }), progress, (type === 'circle' || type === 'dashboard') && operation ? /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-oper")
      }, operation) : null);
    }
  }]);
  return Progress;
}(React.Component);
export { Progress as default };
Progress.defaultProps = {
  type: 'line',
  percent: 0,
  showInfo: true,
  trailColor: '#f3f3f3',
  prefixCls: 'fishd-progress',
  size: 'default'
};
Progress.propTypes = {
  status: PropTypes.oneOf(['normal', 'exception', 'active', 'success']),
  type: PropTypes.oneOf(['line', 'circle', 'dashboard']),
  showInfo: PropTypes.bool,
  percent: PropTypes.number,
  width: PropTypes.number,
  strokeWidth: PropTypes.number,
  strokeLinecap: PropTypes.oneOf(['round', 'square']),
  strokeColor: PropTypes.string,
  trailColor: PropTypes.string,
  format: PropTypes.func,
  gapDegree: PropTypes.number,
  "default": PropTypes.oneOf(['default', 'small'])
};