import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _slicedToArray from "@babel/runtime-corejs3/helpers/slicedToArray";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _trimInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/trim";
import _parseInt from "@babel/runtime-corejs3/core-js-stable/parse-int";
import _Promise from "@babel/runtime-corejs3/core-js-stable/promise";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _sortInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/sort";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React, { Component } from 'react';
import { findDOMNode } from 'react-dom';
import ReactQuill, { Quill } from './quill/index';
import classNames from 'classnames';
import { addEventListener } from '../../../utils';
import { polyfill } from 'react-lifecycles-compat';
import Spin from '../../Spin/index';
import Radio from '../../Radio/index';
import Modal from '../../Modal/index';
import Input from '../../Input/index';
import Button from '../../Button/index';
import message from '../../message/index';
import CustomToolbar from './toolbar';
import CustomSizeBlot from './formats/size';
import EmojiBlot from './formats/emoji';
import LinkBlot from './formats/link';
import ImageBlot from './formats/image';
import VideoBlot from './formats/video';
import CustomClipboard from './modules/customClipboard';
import ImageDrop from './modules/imageDrop';
import FileDrop from './modules/fileDrop';
import ImageResize from './modules/imageResize';
import TableUI, { isTable } from './modules/table';
import attachBlot from './formats/attach';
import SearchedStringBlot from './formats/SearchBlot';
import SearchedStringActiveBlot from './formats/SearchActiveBlot';
import ConfigConsumer from '../../Config/Consumer';
import FindModal from './findModal';
Quill.register(SearchedStringBlot);
Quill.register(SearchedStringActiveBlot);
Quill.register(EmojiBlot);
Quill.register(LinkBlot);
Quill.register(ImageBlot);
Quill.register(VideoBlot);
Quill.register(attachBlot);
Quill.register(CustomSizeBlot);
Quill.register('modules/imageDrop', ImageDrop, true);
Quill.register('modules/fileDrop', FileDrop, true);
Quill.register('modules/resize', ImageResize, true);
Quill.register(Quill["import"]('attributors/style/align'), true);
Quill.register(Quill["import"]('attributors/style/direction'), true);
Quill.register({
  'modules/tableUI': TableUI
}, true);
var getImageSize = function getImageSize(url, callback) {
  var newImage = document.createElement('img');
  newImage.onload = function () {
    callback(this.width, this.height);
  };
  newImage.src = url;
};
var Range = /*#__PURE__*/_createClass(function Range(index) {
  var length = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  _classCallCheck(this, Range);
  this.index = index;
  this.length = length;
});
var RichEditor = /*#__PURE__*/function (_Component) {
  _inherits(RichEditor, _Component);
  var _super = _createSuper(RichEditor);
  function RichEditor(props) {
    var _context14;
    var _this;
    _classCallCheck(this, RichEditor);
    _this = _super.call(this, props);
    _this.historyConfig = {
      delay: 0,
      maxStack: 100,
      userOnly: true
    };
    _this.imageSizeParams = {
      parchment: {
        image: {
          attribute: ['width', 'height'],
          limit: {
            ratio: true,
            minWidth: 50
          }
        }
      }
    };
    _this.formatFontTag = function (value) {
      if (!value) return value;
      var fontTagStart = /(<\s*?)font(\s+)(.*?)(>)/gi,
        fontTagEnd = /(<\s*?\/\s*?)font(\s*?>)/gi;
      value = value.replace(fontTagStart, function ($0, $1, $2, $3, $4) {
        var tagStyle = ' style="',
          tagAttr = ' ';
        $3.replace(/(\w+-?\w+)\s*=\s*["']\s*(.*?)\s*["']/gi, function ($0, $1, $2) {
          var key = $1,
            value = $2;
          switch (key) {
            case 'color':
              {
                tagStyle += 'color:' + value + ';';
                break;
              }
            case 'size':
              {
                // font标签size属性的value是数字类型，取值范围是[1,7]。
                var size2pxMap = {
                    '1': '12px',
                    '2': '13px',
                    '3': '16px',
                    '4': '18px',
                    '5': '24px',
                    '6': '32px',
                    '7': '48px'
                  },
                  sizeWithUnit = _this.defaultFontSize,
                  val = value && _trimInstanceProperty(value).call(value);
                // value非数字或不在[1,7]范围内时，取默认字体大小
                if (!/^\d+$/.test(val) || _parseInt(val) > 7 || _parseInt(val) < 1) {
                  sizeWithUnit = _this.defaultFontSize;
                } else {
                  sizeWithUnit = size2pxMap[val] || _this.defaultFontSize;
                }
                tagStyle += 'font-size:' + sizeWithUnit + ';';
                break;
              }
            case 'face':
              {
                tagStyle += 'font-family:' + value + ';';
                break;
              }
            default:
              {
                tagAttr += key + '=' + value;
                break;
              }
          }
        });
        tagStyle += '"';
        return $1 + 'span' + $2 + tagStyle + tagAttr + $4;
      });
      return value.replace(fontTagEnd, '$1span$2');
    };
    _this.focus = function () {
      if (!_this.reactQuillRef) return;
      _this.reactQuillRef.focus();
    };
    _this.blur = function () {
      if (!_this.reactQuillRef) return;
      _this.reactQuillRef.blur();
    };
    _this.getEditor = function () {
      if (!_this.reactQuillRef) return;
      return _this.reactQuillRef.getEditor();
    };
    _this._closeFindModal = function () {
      _this.setState({
        findVisible: false
      });
    };
    // 提供给外部的关闭操作
    _this.closeFindModal = function () {
      return new _Promise(function (resolve) {
        _this.setState({
          findVisible: false
        }, function () {
          return resolve('');
        });
      });
    };
    _this.handleLinkModalOk = function () {
      var _context;
      var el = _this.linkModalInputRef.input,
        val = _trimInstanceProperty(_context = el.value).call(_context);
      if (val) {
        if (val.length > 1000) {
          message.error(_this.Locale.linkToolongError);
          return;
        }
        var quill = _this.getEditor();
        quill.formatText(_this.state.curRange, 'link', {
          // type: 'default',
          url: val
        }, 'user');
        quill.setSelection(_this.state.curRange); // 设置超链接后恢复选区
        _this.setState({
          value: quill.getRawHTML(),
          showLinkModal: false,
          defaultInputLink: _this.defaultLinkPrefix
        });
      } else {
        message.error(_this.Locale.linkEmptyTip);
      }
    };
    _this.handleLinkModalCancel = function () {
      _this.setState({
        showLinkModal: false,
        defaultInputLink: _this.defaultLinkPrefix
      });
    };
    _this.handleVideoModalOk = function () {
      var val = null;
      if (_this.videoModalInputRef) {
        var _context2;
        val = _trimInstanceProperty(_context2 = _this.videoModalInputRef.input.value).call(_context2);
      }
      if (val) {
        if (val.length > 1000) {
          message.error(_this.Locale.videoLinkTooLongError);
          return;
        }
        if (_indexOfInstanceProperty(val).call(val, '//') < 0) {
          message.error(_this.Locale.videoUrlFormattingError);
          return;
        }
        var quill = _this.getEditor(),
          range = _this.state.curRange ? _this.state.curRange : quill.getSelection(true),
          videoTagAttrs = _this.props.videoTagAttrs;
        _this.insertVideo(range.index, _Object$assign(_Object$assign({}, videoTagAttrs), {
          src: val
        }));
        _this.videoModalInputRef && (_this.videoModalInputRef.input.value = '');
        _this.setState({
          value: quill.getRawHTML(),
          showVideoModal: false,
          curRange: null
        });
      } else {
        message.error(_this.Locale.noVideoUrlErrorTip);
      }
    };
    _this.handleVideoModalCancel = function () {
      if (_this.videoModalInputRef) {
        _this.videoModalInputRef.input.value = '';
      }
      _this.setState({
        curVideoType: _this.defaultVideoType,
        showVideoModal: false,
        curRange: null
      });
    };
    _this.handleImageModalCancel = function () {
      _this.setState({
        showImageModal: false,
        curRange: null
      });
    };
    _this.handleAttachmentModalCancel = function () {
      _this.setState({
        showAttachmentModal: false,
        curRange: null
      });
    };
    // 图片选择回调
    _this.handlePickLocalImage = function () {
      var customInsertImage = _this.props.customInsertImage,
        toolbarCtner = _this.state.toolbarCtner,
        quill = _this.getEditor(),
        fileInput = toolbarCtner.querySelector('input.ql-image[type=file]');
      var handleInsertImage = function handleInsertImage(info) {
        var _context3;
        if (info.src == undefined) {
          message.error(_this.Locale.noPicSrcTip);
          return;
        }
        info.src = info.src && _trimInstanceProperty(_context3 = info.src).call(_context3);
        var range = _this.state.curRange ? _this.state.curRange : quill.getSelection(true);
        if (info.width == undefined || info.height == undefined) {
          getImageSize(info.src, function (naturalWidth, naturalHeight) {
            info.width = naturalWidth;
            info.height = naturalHeight;
            quill.insertEmbed(range.index, 'image', info);
            quill.setSelection(range.index + 1, 'silent');
            _this.setState({
              value: quill.getRawHTML(),
              curRange: null
            });
          });
        } else {
          quill.insertEmbed(range.index, 'image', info);
          quill.setSelection(range.index + 1, 'silent');
          _this.setState({
            value: quill.getRawHTML(),
            curRange: null
          });
        }
      };
      var getImageCb = function getImageCb(imgList) {
        if (_Array$isArray(imgList)) {
          _forEachInstanceProperty(imgList).call(imgList, function (imgInfo) {
            handleInsertImage(imgInfo);
          });
        } else {
          handleInsertImage(imgList);
        }
      };
      _this.setState({
        showImageModal: false
      }, function () {
        if (_this.state.fullScreen) {
          document.body.style.overflow = 'hidden';
        }
      });
      if (customInsertImage && typeof customInsertImage === 'function') {
        customInsertImage(getImageCb);
      } else {
        if (fileInput == null) {
          fileInput = document.createElement('input');
          fileInput.setAttribute('type', 'file');
          fileInput.setAttribute('accept', 'image/jpg, image/jpeg, image/png, image/gif, image/bmp');
          fileInput.setAttribute('multiple', 'multiple');
          fileInput.classList.add('ql-image');
          fileInput.addEventListener('change', function () {
            if (fileInput.files != null && fileInput.files.length) {
              for (var i = 0, len = fileInput.files.length; i < len; i++) {
                var reader = new FileReader();
                reader.onload = function (e) {
                  getImageCb({
                    src: e.target.result
                  });
                  fileInput.value = '';
                };
                reader.readAsDataURL(fileInput.files[i]);
              }
            }
          });
          toolbarCtner.appendChild(fileInput);
        }
        fileInput.click();
      }
    };
    _this.handlePickLocalFile = function () {
      var _this$props = _this.props,
        customInsertAttachment = _this$props.customInsertAttachment,
        _this$props$attachmen = _this$props.attachmentIconMap,
        attachmentIconMap = _this$props$attachmen === void 0 ? {} : _this$props$attachmen,
        quill = _this.getEditor();
      var handleInsertFile = function handleInsertFile(file, rangeIndex) {
        var _context4;
        if (!file || !file.url || !file.name) {
          message.error(_this.Locale.noFileInfoTip);
          return;
        }
        var nextChar = quill.getText(rangeIndex + 1, 1);
        var attrs = {
          url: file.url && _trimInstanceProperty(_context4 = file.url).call(_context4),
          name: file.name,
          iconUrl: attachmentIconMap[file.type] || attachmentIconMap['default'] || '//res.qiyukf.net/operation/2edfafe507a11ad70724973bb505addd'
        };
        // 插入附件
        // 在一行的中间插入
        if (nextChar && nextChar != '\n') {
          quill.insertText(rangeIndex, '\n'); // 插入前换行，避免丢失文字
          quill.insertEmbed(rangeIndex + 1, 'attach', attrs);
          quill.setSelection(rangeIndex + 1, 'silent');
        } else {
          // 在一行的末尾插入
          quill.insertEmbed(rangeIndex + 1, 'attach', attrs);
          quill.insertText(rangeIndex + 2, '\n'); // 插入后换行，避免丢失光标
          quill.setSelection(rangeIndex + 2, 'silent');
        }
      };
      var getFileCb = function getFileCb(fileList) {
        var range = _this.state.curRange ? _this.state.curRange : quill.getSelection(true);
        if (_Array$isArray(fileList)) {
          var _context5;
          _forEachInstanceProperty(_context5 = _sortInstanceProperty(fileList).call(fileList, function (a, b) {
            // 单次插入多个不同类型的文件时，按”视频 -> 图片 -> 其他文件“的顺序排列
            var order = ['other', 'image', 'video'];
            return _indexOfInstanceProperty(order).call(order, b.type) - _indexOfInstanceProperty(order).call(order, a.type);
          })).call(_context5, function (file, index) {
            handleInsertFile(file, range.index);
            _this.setState({
              value: quill.getRawHTML(),
              curRange: null
            });
          });
        } else {
          handleInsertFile(fileList, range.index);
          _this.setState({
            value: quill.getRawHTML(),
            curRange: null
          });
        }
      };
      _this.setState({
        showAttachmentModal: false
      });
      if (customInsertAttachment && typeof customInsertAttachment === 'function') {
        customInsertAttachment(getFileCb);
      }
    };
    _this.insertVideo = function (rangeIndex, attrs) {
      var _context6;
      var quill = _this.getEditor(),
        prevChar = quill.getText(rangeIndex - 1, 1),
        nextChar = quill.getText(rangeIndex + 1, 1),
        videoNode = document.createElement('video');
      videoNode.onerror = function () {
        message.error(_this.Locale.VideoCantPlayTip);
      };
      videoNode.src = attrs.src && _trimInstanceProperty(_context6 = attrs.src).call(_context6);
      videoNode = null;
      if (rangeIndex > 0 && prevChar != '\n') {
        // 在一行的中间插入视频
        if (nextChar && nextChar != '\n') {
          quill.insertText(rangeIndex, '\n'); // 插入视频前换行，避免丢失文字
          quill.insertEmbed(rangeIndex + 1, 'myVideo', attrs);
          quill.setSelection(rangeIndex + 1, 'silent');
        } else {
          // 在一行的末尾插入视频
          quill.insertEmbed(rangeIndex + 1, 'myVideo', attrs);
          quill.insertText(rangeIndex + 2, '\n'); // 插入视频后换行，避免丢失光标
          quill.setSelection(rangeIndex + 2, 'silent');
        }
      } else {
        // 一行的开头插入视频
        quill.insertEmbed(rangeIndex, 'myVideo', attrs);
        quill.setSelection(rangeIndex + 1, 'silent');
      }
    };
    _this.handlePickLocalVideo = function () {
      var _this$props2 = _this.props,
        customInsertVideo = _this$props2.customInsertVideo,
        videoTagAttrs = _this$props2.videoTagAttrs,
        quill = _this.getEditor(); // 获取选区前先聚焦
      var handleVideoInsert = function handleVideoInsert(info) {
        var _context7;
        if (info.src == undefined) {
          message.error(_this.Locale.noVideoLinkErrorTip);
          return;
        }
        info.src = info.src && _trimInstanceProperty(_context7 = info.src).call(_context7);
        var range = _this.state.curRange ? _this.state.curRange : quill.getSelection(true);
        _this.insertVideo(range.index, _Object$assign(_Object$assign({}, videoTagAttrs), info));
      };
      var getVideoCb = function getVideoCb(videoList) {
        if (_Array$isArray(videoList)) {
          _forEachInstanceProperty(videoList).call(videoList, function (videoInfo) {
            handleVideoInsert(videoInfo);
          });
        } else {
          handleVideoInsert(videoList);
        }
        _this.setState({
          value: quill.getRawHTML(),
          curRange: null
        });
      };
      _this.setState({
        showVideoModal: false
      });
      if (customInsertVideo && typeof customInsertVideo === 'function') {
        customInsertVideo(getVideoCb);
      }
    };
    _this.handleInsertEmoji = function (e) {
      var toolbarCtner = _this.state.toolbarCtner,
        target = e.target,
        clsList = target.classList.value;
      if ((_indexOfInstanceProperty(clsList).call(clsList, 'emoji-item') > -1 || _indexOfInstanceProperty(clsList).call(clsList, 'emoji-extend-item') > -1) && target.hasAttribute('value')) {
        var el = toolbarCtner.querySelector('button.ql-emoji[data-role="emoji"]');
        if (el == null) {
          el = document.createElement('button');
          toolbarCtner.querySelector('.custom-emoji').appendChild(el);
        }
        el.setAttribute('type', 'button');
        el.setAttribute('data-role', 'emoji');
        el.setAttribute('value', target.getAttribute('value'));
        el.classList.add('ql-emoji', 'hide');
        el.click();
      }
    };
    _this.handleFormatBackground = function (e) {
      var _context8;
      var toolbarCtner = _this.state.toolbarCtner,
        target = e.target;
      if (_indexOfInstanceProperty(_context8 = target.classList.value).call(_context8, 'background-item') > -1 && target.hasAttribute('value')) {
        var el = toolbarCtner.querySelector('button.ql-background[data-role="background"]');
        if (el == null) {
          el = document.createElement('button');
          toolbarCtner.querySelector('.custom-background').appendChild(el);
        }
        el.setAttribute('type', 'button');
        el.setAttribute('data-role', 'background');
        el.setAttribute('value', target.getAttribute('value'));
        el.classList.add('ql-background', 'hide');
        el.click();
      }
    };
    _this.handleFormatColor = function (e) {
      var _context9;
      var toolbarCtner = _this.state.toolbarCtner,
        target = e.target;
      if (_indexOfInstanceProperty(_context9 = target.classList.value).call(_context9, 'color-item') > -1 && target.hasAttribute('value')) {
        var el = toolbarCtner.querySelector('button.ql-color[data-role="color"]');
        if (el == null) {
          el = document.createElement('button');
          toolbarCtner.querySelector('.custom-color').appendChild(el);
        }
        el.setAttribute('type', 'button');
        el.setAttribute('data-role', 'color');
        el.setAttribute('value', target.getAttribute('value'));
        el.classList.add('ql-color', 'hide');
        el.click();
      }
    };
    _this.handleFormatSize = function (value) {
      var quill = _this.getEditor();
      quill && quill.format('customAttr', {
        fontSize: value
      });
    };
    _this.handleInsertTable = function (row, col) {
      var quill = _this.getEditor();
      if (quill) {
        quill.focus();
        var table = quill.getModule('table');
        table.insertTable(row, col);
      }
    };
    _this.handleFormatLineHeight = function (value) {
      var quill = _this.getEditor();
      quill && quill.format('customAttr', {
        lineHeight: value
      });
    };
    _this.handleInsertValue = function (e) {
      var _context10;
      var toolbarCtner = _this.state.toolbarCtner,
        target = e.target;
      if (_indexOfInstanceProperty(_context10 = target.classList.value).call(_context10, 'insert-value-item') > -1 && target.hasAttribute('value')) {
        var el = toolbarCtner.querySelector('button.ql-customInsertValue[data-role="customInsertValue"]');
        if (el == null) {
          el = document.createElement('button');
          toolbarCtner.querySelector('.custom-insert-value').appendChild(el);
        }
        el.setAttribute('type', 'button');
        el.setAttribute('data-role', 'customInsertValue');
        el.setAttribute('value', target.getAttribute('value'));
        el.classList.add('ql-customInsertValue', 'hide');
        el.click();
      }
    };
    _this.handleChange = function (value, delta, source, editor) {
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange(value, delta, source, editor);
      }
    };
    _this.handleShowTooltip = function (root) {
      if (!root) return;
      root.classList.remove('ql-editing');
      root.classList.remove('ql-hidden');
      root.classList.remove('custom-hide');
      root.classList.add('custom-show');
    };
    _this.handleHideTooltip = function (root) {
      if (!root) return;
      root.classList.remove('custom-show');
      root.classList.add('ql-hidden');
      root.classList.add('custom-hide');
    };
    _this.handleSelectionChange = function (nextSelection, source, editor) {
      var onSelectionChange = _this.props.onSelectionChange;
      onSelectionChange && onSelectionChange(nextSelection, source, editor);
      var quill = _this.getEditor();
      if (!quill) return;
      // 处理插入表格按钮的禁用状态，禁止嵌套插入表格
      if (isTable(quill, quill.getSelection() || _this.state.curRange)) {
        _this.setState({
          insertTableDisabled: true
        });
      } else {
        _this.setState({
          insertTableDisabled: false
        });
      }
      // 格式刷
      if (_this.prevSelectionFormat && nextSelection) {
        var _context11;
        // 清除当前选区的格式
        quill.removeFormat(nextSelection.index, nextSelection.length);
        // 设置当前选区的格式
        _forEachInstanceProperty(_context11 = _Object$keys(_this.prevSelectionFormat)).call(_context11, function (name) {
          quill.format(name, _this.prevSelectionFormat[name]);
        });
        // 取消格式刷高亮
        _this.setState({
          formatPainterActive: false
        });
        // 重置保存的格式
        _this.prevSelectionFormat = null;
      }
      var tooltip = quill.theme && quill.theme.tooltip;
      if (!tooltip) return;
      // 光标定位到超链接上时展示tooltip
      if (nextSelection && nextSelection.length === 0 && source === 'user') {
        var _quill$scroll$descend = quill.scroll.descendant(LinkBlot, nextSelection.index),
          _quill$scroll$descend2 = _slicedToArray(_quill$scroll$descend, 2),
          link = _quill$scroll$descend2[0],
          offset = _quill$scroll$descend2[1];
        if (link != null) {
          // 附件的超链接不可编辑
          if (link.domNode.dataset.qlLinkType == 'attachment') {
            return;
          }
          tooltip.linkRange = new Range(nextSelection.index - offset, link.length());
          _this.linkRange = tooltip.linkRange; // 保存到当前实例，在编辑/删除超链接的事件回调中使用
          var preview = LinkBlot.formats(link.domNode).url;
          tooltip.preview.textContent = preview;
          tooltip.preview.setAttribute('href', preview);
          // 需要在显示后设置位置
          _this.handleShowTooltip(tooltip.root);
          _this.handleTooltipPosition(tooltip, quill.getBounds(tooltip.linkRange));
          return;
        }
      }
      _this.handleHideTooltip(tooltip.root);
    };
    _this.handleVideoTypeChange = function (e) {
      _this.setState({
        curVideoType: e.target.value || _this.defaultVideoType
      });
    };
    _this.getCurrentLineHeight = function () {
      var quill = _this.getEditor();
      if (!quill) return null;
      var formats = quill.getFormat();
      if (formats && formats.customAttr && formats.customAttr.lineHeight) {
        return formats.customAttr.lineHeight;
      }
      return null;
    };
    _this.getCurrentSize = function () {
      var quill = _this.getEditor();
      if (!quill) return null;
      var formats = quill.getFormat(),
        customAttr = formats && formats.customAttr,
        customAttrType = Object.prototype.toString.call(customAttr);
      if (!customAttr) return _this.defaultFontSize;
      if (customAttrType == '[object Object]') {
        return customAttr.fontSize || _this.defaultFontSize;
      }
      if (customAttrType == '[object Array]') {
        var len = customAttr.length;
        if (len) {
          var fontSize = customAttr[0].fontSize,
            hasMultiFontSize = false;
          for (var i = 0; i < len; i++) {
            // 选中的富文本有多种字体大小时不高亮字号
            if (customAttr[i].fontSize != fontSize) {
              hasMultiFontSize = true;
              break;
            }
          }
          if (hasMultiFontSize) {
            return null;
          } else {
            return fontSize;
          }
        } else {
          return _this.defaultFontSize;
        }
      }
      return null;
    };
    _this.handleSaveSelectionFormat = function () {
      var quill = _this.getEditor();
      if (!quill) return null;
      _this.prevSelectionFormat = quill.getFormat();
      // 格式刷高亮
      _this.setState({
        formatPainterActive: true
      });
    };
    _this.handleUnsaveSelectionFormat = function () {
      if (_this.prevSelectionFormat) {
        _this.prevSelectionFormat = null;
      }
      // 取消格式刷高亮
      _this.setState({
        formatPainterActive: false
      });
    };
    // 变更伪类的content
    _this.changePseudoElementText = function () {
      var _this$Locale = _this.Locale,
        accessLink = _this$Locale.accessLink,
        edit = _this$Locale.edit,
        deleteText = _this$Locale.deleteText;
      var editorCtner = _this.editorCtner;
      var elEdit = editorCtner.querySelector('.ql-snow .ql-tooltip a.ql-action');
      var elDelete = editorCtner.querySelector('.ql-snow .ql-tooltip a.ql-remove');
      var elAccessLink = editorCtner.querySelector('.ql-snow .ql-tooltip');
      elEdit && elEdit.setAttribute('data-after-content', edit);
      elDelete && elDelete.setAttribute('data-before-content', deleteText);
      elAccessLink && elAccessLink.setAttribute('data-before-content', accessLink);
    };
    // 变更编辑器placeholder
    _this.changeEditorPlaceholder = function () {
      var _a;
      var root = (_a = _this.getEditor()) === null || _a === void 0 ? void 0 : _a.root;
      root && root.setAttribute('data-placeholder', _this.props.placeholder || _this.Locale.placeholder);
    };
    _this.reactQuillNode = document.body;
    _this.defaultFontSize = '14px';
    _this.defaultLinkPrefix = 'https://';
    _this.Locale = {};
    var _this$props3 = _this.props,
      value = _this$props3.value,
      customLink = _this$props3.customLink,
      supportFontTag = _this$props3.supportFontTag,
      pastePlainText = _this$props3.pastePlainText,
      pasteFormater = _this$props3.pasteFormater,
      customInsertVideo = _this$props3.customInsertVideo;
    // 粘贴时的功能扩展
    if (pastePlainText || pasteFormater) {
      Quill.register('modules/clipboard', CustomClipboard, true);
    }
    _this.onBlurHandler = null;
    var formatValue = value;
    if (supportFontTag) {
      formatValue = _this.formatFontTag(value);
    }
    _this.defaultVideoType = 'video_link';
    if (customInsertVideo && typeof customInsertVideo === 'function') {
      _this.isSupportCustomInsertVideo = true;
      _this.defaultVideoType = 'video_local';
    }
    // 格式刷保存的格式
    _this.prevSelectionFormat = null;
    _this.state = {
      lastValue: value,
      value: formatValue || '',
      loading: false,
      showLinkModal: false,
      showVideoModal: false,
      showImageModal: false,
      toolbarCtner: null,
      curRange: null,
      curVideoType: _this.defaultVideoType,
      defaultInputLink: _this.defaultLinkPrefix,
      linkModalTitle: '',
      formatPainterActive: false,
      insertTableDisabled: false,
      fullScreen: false,
      findVisible: false
    };
    _this.handlers = {
      link: function link(value, fromAction) {
        var onClickToolbarBtn = _this.props.onClickToolbarBtn;
        if (typeof onClickToolbarBtn == 'function' && onClickToolbarBtn('link') === false) {
          return;
        }
        var quill = _this.getEditor(),
          range = quill.getSelection();
        if (range && range.length !== 0) {
          // 附件不能设置超链接
          var _quill$scroll$descend3 = quill.scroll.descendant(LinkBlot, range.index),
            _quill$scroll$descend4 = _slicedToArray(_quill$scroll$descend3, 2),
            link = _quill$scroll$descend4[0],
            offset = _quill$scroll$descend4[1];
          if (link && link.domNode.dataset.qlLinkType == 'attachment') {
            return;
          }
          var newState = {
            value: quill.getRawHTML(),
            showLinkModal: true,
            defaultInputLink: _this.defaultLinkPrefix,
            curRange: range
          };
          // 点击编辑链接触发
          if (fromAction) {
            newState['defaultInputLink'] = value;
            newState['linkModalTitle'] = _this.Locale.editLink;
          } else {
            newState['linkModalTitle'] = _this.Locale.insertLink;
          }
          _this.setState(newState);
        } else {
          message.error(_this.Locale.noSelectionText);
        }
      },
      video: function video(value) {
        var onClickToolbarBtn = _this.props.onClickToolbarBtn;
        if (typeof onClickToolbarBtn == 'function' && onClickToolbarBtn('video') === false) {
          return;
        }
        var quill = _this.getEditor();
        _this.setState({
          value: quill.getRawHTML(),
          showVideoModal: true,
          curRange: quill.getSelection() // 防止插入视频时光标定位错误
        });
      },

      fullscreen: function fullscreen(value) {
        _this.setState(function (prev) {
          return {
            fullScreen: !prev.fullScreen
          };
        }, function () {
          document.body.style.overflow = _this.state.fullScreen ? 'hidden' : 'auto';
        });
      },
      emoji: function emoji(value) {
        var _context12;
        var quill = _this.getEditor(),
          range = quill.getSelection(),
          mValue = JSON.parse(value);
        quill.insertEmbed(range.index, 'emoji', {
          type: mValue.type,
          alt: mValue.alt,
          src: mValue.src && _trimInstanceProperty(_context12 = mValue.src).call(_context12),
          width: mValue.width,
          height: mValue.height,
          id: mValue.id
        });
        quill.setSelection(range.index + 1);
      },
      image: function image() {
        var _this$props4 = _this.props,
          onClickToolbarBtn = _this$props4.onClickToolbarBtn,
          insertImageModalVisible = _this$props4.insertImageModalVisible;
        if (typeof onClickToolbarBtn == 'function' && onClickToolbarBtn('image') === false) {
          return;
        }
        var showImageModal = true;
        if (!insertImageModalVisible) {
          showImageModal = false;
          _this.handlePickLocalImage();
        }
        var quill = _this.getEditor();
        _this.setState({
          value: quill.getRawHTML(),
          showImageModal: showImageModal,
          curRange: quill.getSelection()
        });
      },
      attachment: function attachment() {
        var _this$props5 = _this.props,
          onClickToolbarBtn = _this$props5.onClickToolbarBtn,
          insertAttachmentModalVisible = _this$props5.insertAttachmentModalVisible;
        if (typeof onClickToolbarBtn == 'function' && onClickToolbarBtn('attachment') === false) {
          return;
        }
        var showAttachmentModal = true;
        if (!insertAttachmentModalVisible) {
          showAttachmentModal = false;
          _this.handlePickLocalFile();
        }
        var quill = _this.getEditor();
        _this.setState({
          value: quill.getRawHTML(),
          showAttachmentModal: showAttachmentModal,
          curRange: quill.getSelection()
        });
      },
      clean: function clean() {
        var Parchment = Quill.imports.parchment;
        var quill = _this.getEditor(),
          range = quill.getSelection();
        if (range == null) return;
        // 只在有选中的时候 clean, 原方案removeFormat 会清除图片,自定义格式, 或者清除失败的情况
        if (range.length !== 0) {
          var _context13;
          var formatArr = ['strike', 'bold', 'link', 'color', 'background', 'underline', 'font', 'size', 'direction', 'customAttr'];
          var index = range.index,
            length = range.length;
          quill.format('blockquote', false);
          quill.format('code-block', false); // 全选时,或者选中再加一个空白行 可能会失败
          quill.format('indent', false);
          quill.format('italic', false);
          quill.format('script', false);
          quill.format('align', false);
          quill.format('list', false);
          quill.format('orderedList', false);
          _forEachInstanceProperty(formatArr).call(formatArr, function (type) {
            quill.formatText(index, length, type, false);
          });
          // 兼容 code-block 全选, 半全选 格式化失败的问题
          var start = index;
          _forEachInstanceProperty(_context13 = quill.getContents(index, length)).call(_context13, function (delta, line, all) {
            var lineLength = delta.insert && delta.insert.length || 0;
            var attributes = delta.attributes;
            if (attributes) {
              // 遗漏点: 如果先选择背景色和字体颜色, 在方法, 清除格式的时候, 只有这里判断
              if (attributes['code-block'] || attributes['customAttr']) {
                quill.removeFormat(start, lineLength);
              }
            }
            start += lineLength;
          });
        }
      },
      undo: function undo() {
        var quill = _this.getEditor();
        quill && quill.history.undo();
      },
      redo: function redo() {
        var quill = _this.getEditor();
        quill && quill.history.redo();
      },
      // 处理定制的插入值
      customInsertValue: function customInsertValue(value) {
        var quill = _this.getEditor(),
          range = quill.getSelection(),
          mValue = JSON.parse(value);
        if (!range) return;
        if (mValue.editable === false) {
          quill.insertText(range.index, mValue.value, {
            customAttr: {
              editable: false
            }
          });
        } else {
          quill.insertText(range.index, mValue.value);
        }
      },
      findAndReplace: function findAndReplace(val) {
        _this.setState(function (prev) {
          return {
            findVisible: !prev.findVisible
          };
        });
      },
      customTable: function customTable(value) {
        var onClickToolbarBtn = _this.props.onClickToolbarBtn;
        if (typeof onClickToolbarBtn == 'function' && onClickToolbarBtn('table') === false) {
          return;
        }
        var quill = _this.getEditor();
        if (!quill) return;
        _this.setState({
          value: quill.getRawHTML(),
          curRange: quill.getSelection() // 保存range，用于判断插入表格时光标是否在表格内
        });
      }
    };
    // 处理定制的超链接
    _forEachInstanceProperty(_context14 = _Object$keys(customLink)).call(_context14, function (moduleName) {
      var that = _assertThisInitialized(_this);
      _this.handlers["".concat(moduleName, "Entry")] = function () {
        var _this2 = this;
        var range = this.quill.getSelection(),
          url = customLink[moduleName].url;
        if (range.length !== 0) {
          // 附件不能设置超链接
          var _this$quill$scroll$de = this.quill.scroll.descendant(LinkBlot, range.index),
            _this$quill$scroll$de2 = _slicedToArray(_this$quill$scroll$de, 2),
            link = _this$quill$scroll$de2[0],
            offset = _this$quill$scroll$de2[1];
          if (link && link.domNode.dataset.qlLinkType == 'attachment') {
            return;
          }
          if (url) {
            // 异步获取URL
            if (Object.prototype.toString.call(url) == '[object Function]') {
              var format = this.quill.getFormat(),
                prevValue = format && format.link && format.link.url;
              url(function (value) {
                _this2.quill.format('link', {
                  type: "".concat(moduleName, "Entry"),
                  url: value
                });
              }, prevValue);
            } else {
              this.quill.format('link', {
                type: "".concat(moduleName, "Entry"),
                url: url
              });
            }
          }
        } else {
          message.error(that.Locale.noSelectionText);
        }
      };
    });
    return _this;
  }
  _createClass(RichEditor, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this3 = this;
      /* eslint-disable react/no-did-mount-set-state */
      this.setState({
        toolbarCtner: findDOMNode(this.toolbarRef)
      }, function () {
        if (!_this3.reactQuillRef) return;
        _this3.reactQuillNode = findDOMNode(_this3.reactQuillRef);
        _this3.onBlurHandler = addEventListener(_this3.reactQuillNode.querySelector('.ql-editor'), 'blur', function () {
          if (!_this3.reactQuillRef) return;
          var quill = _this3.reactQuillRef.getEditor(),
            range = quill.getSelection();
          if (typeof _this3.props.onBlur == 'function') {
            _this3.props.onBlur(range, 'user', quill);
          }
        });
        // 编辑超链接
        _this3.onClickActionHandler = addEventListener(_this3.reactQuillNode.querySelector('a.ql-action'), 'click', function (event) {
          if (!_this3.reactQuillRef) return;
          var quill = _this3.reactQuillRef.getEditor();
          if (!quill) return;
          var tooltip = quill.theme && quill.theme.tooltip;
          if (tooltip && _this3.linkRange != null) {
            tooltip.linkRange = _this3.linkRange;
            quill.setSelection(_this3.linkRange);
            _this3.handlers.link(tooltip.preview.getAttribute('href'), true);
          }
          event.preventDefault();
        });
        // 删除超链接
        _this3.onClickRemoveHandler = addEventListener(_this3.reactQuillNode.querySelector('a.ql-remove'), 'click', function (event) {
          if (!_this3.reactQuillRef) return;
          var quill = _this3.reactQuillRef.getEditor();
          if (!quill) return;
          var tooltip = quill.theme && quill.theme.tooltip;
          if (tooltip && _this3.linkRange != null) {
            tooltip.linkRange = _this3.linkRange;
            quill.formatText(tooltip.linkRange, 'link', false, 'user');
            quill.focus();
            delete tooltip.linkRange;
            _this3.linkRange = null;
          }
          event.preventDefault();
        });
      });
      this.changePseudoElementText();
      _setTimeout(function () {
        _this3.changeEditorPlaceholder();
      }, 10);
      /* eslint-enable react/no-did-mount-set-state */
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      /* eslint-disable react/no-did-update-set-state */
      if (prevState.lastValue != this.state.lastValue && this.props.supportFontTag) {
        this.setState({
          value: this.formatFontTag(this.state.lastValue)
        });
      }
      this.changePseudoElementText();
      this.changeEditorPlaceholder();
      /* eslint-enable react/no-did-update-set-state */
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.onBlurHandler && this.onBlurHandler.remove();
      this.onClickActionHandler && this.onClickActionHandler.remove();
      this.onClickRemoveHandler && this.onClickRemoveHandler.remove();
    }
  }, {
    key: "handleTooltipPosition",
    value: function handleTooltipPosition(tooltip, reference) {
      var left = reference.left + reference.width / 2 - tooltip.root.offsetWidth / 2;
      // root.scrollTop should be 0 if scrollContainer !== root
      var top = reference.bottom + tooltip.quill.root.scrollTop;
      tooltip.root.style.left = left + 'px';
      tooltip.root.style.top = top + 'px';
      tooltip.root.classList.remove('ql-flip');
      var containerBounds = tooltip.boundsContainer.getBoundingClientRect();
      var rootBounds = tooltip.root.getBoundingClientRect();
      var shift = 0,
        offset = 15;
      if (rootBounds.right > containerBounds.right) {
        shift = containerBounds.right - rootBounds.right;
        tooltip.root.style.left = left + shift - offset + 'px';
      }
      if (rootBounds.left < containerBounds.left) {
        shift = containerBounds.left - rootBounds.left;
        tooltip.root.style.left = left + shift + offset + 'px';
      }
      if (rootBounds.bottom > containerBounds.bottom) {
        var height = rootBounds.bottom - rootBounds.top;
        var verticalShift = reference.bottom - reference.top + height;
        tooltip.root.style.top = top - verticalShift + 'px';
        tooltip.root.classList.add('ql-flip');
      }
      return shift;
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;
      var _this$state = this.state,
        loading = _this$state.loading,
        value = _this$state.value,
        showLinkModal = _this$state.showLinkModal,
        showVideoModal = _this$state.showVideoModal,
        showImageModal = _this$state.showImageModal,
        showAttachmentModal = _this$state.showAttachmentModal,
        toolbarCtner = _this$state.toolbarCtner,
        curVideoType = _this$state.curVideoType,
        defaultInputLink = _this$state.defaultInputLink,
        linkModalTitle = _this$state.linkModalTitle,
        fullScreen = _this$state.fullScreen,
        findVisible = _this$state.findVisible;
      var _a = this.props,
        className = _a.className,
        prefixCls = _a.prefixCls,
        toolbar = _a.toolbar,
        placeholder = _a.placeholder,
        customLink = _a.customLink,
        customInsertValue = _a.customInsertValue,
        resizable = _a.resizable,
        style = _a.style,
        getPopupContainer = _a.getPopupContainer,
        customEmoji = _a.customEmoji,
        insertImageTip = _a.insertImageTip,
        insertAttachmentTip = _a.insertAttachmentTip,
        insertVideoTip = _a.insertVideoTip,
        insertLinkTip = _a.insertLinkTip,
        onChange = _a.onChange,
        onSelectionChange = _a.onSelectionChange,
        popoverPlacement = _a.popoverPlacement,
        tooltipPlacement = _a.tooltipPlacement,
        imageDrop = _a.imageDrop,
        fileDrop = _a.fileDrop,
        customDropImage = _a.customDropImage,
        customDropFile = _a.customDropFile,
        pastePlainText = _a.pastePlainText,
        pasteFormater = _a.pasteFormater,
        imageResize = _a.imageResize,
        attachmentIconMap = _a.attachmentIconMap,
        historyConfig = _a.historyConfig,
        restProps = __rest(_a, ["className", "prefixCls", "toolbar", "placeholder", "customLink", "customInsertValue", "resizable", "style", "getPopupContainer", "customEmoji", "insertImageTip", "insertAttachmentTip", "insertVideoTip", "insertLinkTip", "onChange", "onSelectionChange", "popoverPlacement", "tooltipPlacement", "imageDrop", "fileDrop", "customDropImage", "customDropFile", "pastePlainText", "pasteFormater", "imageResize", "attachmentIconMap", "historyConfig"]);
      delete restProps.customInsertImage;
      var cls = classNames("".concat(prefixCls), {
        fullScreen: fullScreen,
        resizable: resizable
      }, className);
      if (value) {
        restProps.value = value;
      }
      // 上传本地视频时Modal无确认和取消按钮
      var videoFooter = {};
      if (curVideoType == 'video_local') {
        videoFooter['footer'] = null;
      }
      var moduleOpts = {
        toolbar: {
          container: toolbarCtner,
          handlers: this.handlers
        },
        history: historyConfig || this.historyConfig,
        table: true,
        tableUI: {
          Locale: this.Locale
        }
      };
      // fileDrop 为 true 时，使 imageDrop 失效
      if (fileDrop && customDropFile) {
        // customDropFile 自定义文件上传逻辑，必选
        moduleOpts['fileDrop'] = {
          customDropFile: customDropFile,
          attachmentIconMap: attachmentIconMap
        };
      } else if (imageDrop) {
        // customDropImage 不存在时，将图片文件转为 dataUrl 格式
        moduleOpts['imageDrop'] = {
          customDropImage: customDropImage
        };
      }
      if (imageResize) {
        moduleOpts['resize'] = this.imageSizeParams;
      }
      if (pastePlainText || pasteFormater) {
        var clipboardOpt = {};
        if (pastePlainText) {
          clipboardOpt['pastePlainText'] = true;
        }
        if (pasteFormater) {
          clipboardOpt['pasteFormater'] = pasteFormater;
        }
        moduleOpts['clipboard'] = clipboardOpt;
      }
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "RichEditor"
      }, function (Locale) {
        _this4.Locale = Locale;
        return /*#__PURE__*/React.createElement("div", {
          className: cls,
          style: style,
          ref: function ref(el) {
            return _this4.editorCtner = el;
          }
        }, /*#__PURE__*/React.createElement(Modal, {
          title: linkModalTitle || _this4.Locale.linkModalTitle,
          className: "".concat(prefixCls, "-link-modal"),
          visible: showLinkModal,
          onOk: _this4.handleLinkModalOk,
          onCancel: _this4.handleLinkModalCancel,
          destroyOnClose: true
        }, /*#__PURE__*/React.createElement("span", {
          className: "text"
        }, Locale.HyperlinkAddress), /*#__PURE__*/React.createElement(Input, {
          ref: function ref(el) {
            return _this4.linkModalInputRef = el;
          },
          style: {
            width: '420px'
          },
          defaultValue: defaultInputLink
        }), insertLinkTip ? /*#__PURE__*/React.createElement("div", {
          className: "tip"
        }, insertLinkTip) : null), /*#__PURE__*/React.createElement(Modal, {
          title: Locale.insertPicture,
          className: "".concat(prefixCls, "-image-modal"),
          visible: showImageModal,
          footer: null,
          onCancel: _this4.handleImageModalCancel
        }, /*#__PURE__*/React.createElement(Button, {
          type: "primary",
          onClick: _this4.handlePickLocalImage
        }, Locale.selectLocalImage), insertImageTip ? /*#__PURE__*/React.createElement("div", {
          className: "tip"
        }, insertImageTip === true ? Locale.insertImageTip : insertImageTip) : null), /*#__PURE__*/React.createElement(Modal, {
          title: Locale.insertAttachment,
          className: "".concat(prefixCls, "-image-modal"),
          visible: showAttachmentModal,
          footer: null,
          onCancel: _this4.handleAttachmentModalCancel
        }, /*#__PURE__*/React.createElement(Button, {
          type: "primary",
          onClick: _this4.handlePickLocalFile
        }, Locale.selectLocalFile), insertAttachmentTip ? /*#__PURE__*/React.createElement("div", {
          className: "tip"
        }, insertAttachmentTip) : null), /*#__PURE__*/React.createElement(Modal, _Object$assign({
          title: Locale.insertVideo,
          className: "".concat(prefixCls, "-video-modal"),
          visible: showVideoModal
        }, videoFooter, {
          onOk: _this4.handleVideoModalOk,
          onCancel: _this4.handleVideoModalCancel
        }), /*#__PURE__*/React.createElement(Radio.Group, {
          style: {
            marginBottom: 24
          },
          onChange: _this4.handleVideoTypeChange,
          value: curVideoType
        }, _this4.isSupportCustomInsertVideo ? /*#__PURE__*/React.createElement(Radio, {
          value: "video_local"
        }, Locale.localVideo) : null, /*#__PURE__*/React.createElement(Radio, {
          value: "video_link"
        }, Locale.videoLink)), curVideoType == 'video_local' ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, {
          style: {
            display: 'block'
          },
          type: "primary",
          onClick: _this4.handlePickLocalVideo
        }, Locale.selectLocalVideo), insertVideoTip ? /*#__PURE__*/React.createElement("div", {
          className: "tip"
        }, insertVideoTip === true ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", null, Locale.rule1), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("span", null, Locale.rule2)) : insertVideoTip) : null) : /*#__PURE__*/React.createElement(Input, {
          ref: function ref(el) {
            return _this4.videoModalInputRef = el;
          },
          style: {
            width: '434px'
          },
          placeholder: Locale.PleaseEnterTheVideolinkURL
        })), /*#__PURE__*/React.createElement(CustomToolbar, {
          ref: function ref(el) {
            return _this4.toolbarRef = el;
          },
          className: 'editor-head',
          toolbar: toolbar,
          customEmoji: customEmoji,
          customLink: customLink,
          customInsertValue: customInsertValue,
          handleInsertEmoji: _this4.handleInsertEmoji,
          handleFormatColor: _this4.handleFormatColor,
          handleFormatBackground: _this4.handleFormatBackground,
          handleFormatSize: _this4.handleFormatSize,
          handleInsertTable: _this4.handleInsertTable,
          handleFormatLineHeight: _this4.handleFormatLineHeight,
          handleInsertValue: _this4.handleInsertValue,
          popoverPlacement: popoverPlacement,
          tooltipPlacement: tooltipPlacement,
          getPopupContainer: getPopupContainer,
          getCurrentSize: _this4.getCurrentSize,
          getCurrentLineHeight: _this4.getCurrentLineHeight,
          formatPainterActive: _this4.state.formatPainterActive,
          insertTableDisabled: _this4.state.insertTableDisabled,
          saveSelectionFormat: _this4.handleSaveSelectionFormat,
          unsaveSelectionFormat: _this4.handleUnsaveSelectionFormat,
          fullScreen: fullScreen
        }), /*#__PURE__*/React.createElement(ReactQuill, _Object$assign({}, restProps, {
          ref: function ref(el) {
            return _this4.reactQuillRef = el;
          },
          bounds: _this4.editorCtner,
          className: 'editor-body',
          modules: moduleOpts,
          // placeholder={Locale.placeholder}
          onChange: _this4.handleChange,
          onSelectionChange: _this4.handleSelectionChange
        })), findVisible ? /*#__PURE__*/React.createElement(FindModal, {
          locale: _this4.Locale,
          closeFindModal: _this4._closeFindModal,
          getEditor: _this4.getEditor
        }) : null, loading ? /*#__PURE__*/React.createElement(Spin, {
          style: {
            position: 'absolute',
            width: '100%',
            background: 'rgba(255, 255, 255, 0.75)'
          }
        }) : null);
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if (nextProps.value !== prevState.lastValue) {
        newState['lastValue'] = newState['value'] = nextProps.value;
      }
      if (nextProps.loading !== prevState.loading) {
        newState['loading'] = nextProps.loading;
      }
      return newState;
    }
  }]);
  return RichEditor;
}(Component);
RichEditor.defaultProps = {
  customEmoji: [],
  customLink: {},
  customInsertValue: {},
  insertImageTip: true,
  insertImageModalVisible: true,
  insertAttachmentModalVisible: true,
  insertVideoTip: true,
  placeholder: '',
  prefixCls: 'fishd-richeditor',
  popoverPlacement: 'top',
  tooltipPlacement: 'bottom',
  loading: false,
  imageDrop: false,
  fileDrop: false,
  resizable: false,
  pastePlainText: false,
  imageResize: false,
  pasteFormater: null,
  toolbar: [['link', 'bold', 'italic', 'underline'], ['size'], ['color'], [{
    align: ''
  }, {
    align: 'center'
  }, {
    align: 'right'
  }], [{
    list: 'ordered'
  }, {
    list: 'bullet'
  }], ['emoji'], ['image'], ['clean', 'formatPainter']],
  getPopupContainer: function getPopupContainer() {
    return document.body;
  }
};
polyfill(RichEditor);
export { Quill };
export default RichEditor;