import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _findInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/find";
import _replaceAllInstanceProperty from "@babel/runtime-corejs3/core-js/instance/replace-all";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import Tabs from '../../Tabs';
import Input from '../../Input';
import Checkbox from '../../Checkbox';
import Icon from '../../Icon';
import Button from '../../Button';
import debounce from 'lodash/debounce';
import Emitter from './quillCore/core/emitter';
var TabPane = Tabs.TabPane;
function escapeRegExp(string) {
  return string.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
  //$&表示整个被匹配的字符串
}
// 场景验证
// 1. 有搜索结果, 但是把搜索框清空, 搜索结果也应该清空
// 2. 正常的文本输入和输入框配置都会触发搜索函数
var FindModal = /*#__PURE__*/function (_React$Component) {
  _inherits(FindModal, _React$Component);
  var _super = _createSuper(FindModal);
  function FindModal() {
    var _this;
    _classCallCheck(this, FindModal);
    _this = _super.apply(this, arguments);
    _this.currentIndex = null;
    _this.replaceKey = '';
    _this.state = {
      indices: [],
      currentPosition: 0,
      searchKey: '',
      checked: false
    };
    _this.onCheck = function (e) {
      _this.setState({
        checked: e.target.checked
      });
      _this.removeStyle();
      _this.search();
    };
    _this.editorOnChange = function (delta, oldDelta, source) {
      if (source == 'user') {
        _this.search();
      }
    };
    _this.removeStyle = function () {
      // 删除全部搜索样式
      var getEditor = _this.props.getEditor;
      var quill = getEditor();
      if (quill) {
        var length = quill.getText().length;
        quill.formatText(0, length, 'SearchedString', false, Emitter.sources.API);
        quill.formatText(0, length, 'SearchedStringActive', false, Emitter.sources.API);
      }
    };
    _this.specialArray = [];
    _this.countSpecial = function (index, lastIndex) {
      var getEditor = _this.props.getEditor;
      var quill = getEditor();
      var delta = quill.getContents();
      // 获取上一个节点到当前节点的 delta
      var restDelta = _sliceInstanceProperty(delta).call(delta, lastIndex, index);
      var initValue = _this.specialArray.length ? _this.specialArray[_this.specialArray.length - 1] : 0;
      var num = _reduceInstanceProperty(restDelta).call(restDelta, function (num, op) {
        if (_typeof(op.insert) === 'object') {
          return num + 1;
        }
        return num;
      }, initValue);
      _this.specialArray.push(num);
      return index + num;
    };
    _this.search = debounce(function () {
      _this.setState({
        indices: []
      });
      var searchKey = _this.state.searchKey;
      _this.removeStyle();
      if (!searchKey) {
        return;
      }
      var getEditor = _this.props.getEditor;
      var quill = getEditor();
      var totalText = quill.getText();
      var re = new RegExp(escapeRegExp(searchKey), _this.state.checked ? 'g' : 'gi');
      var length = searchKey.length;
      var match;
      var indices = [];
      _this.specialArray = [];
      while ((match = re.exec(totalText)) !== null) {
        // 目标文本在文档中的位置
        var index = match.index;
        // 计算 从最初到 index 有多少个特殊 insert
        index = _this.countSpecial(index, indices.length ? indices[indices.length - 1].index : 0);
        // 高亮, 第 0 个默认选中
        quill.formatText(index, length, 'SearchedString', true, Emitter.sources.API);
        indices.push({
          index: index
        });
      }
      if (indices.length) {
        _this.currentIndex = indices[0].index;
        quill.formatText(indices[0].index, length, 'SearchedStringActive', true, Emitter.sources.API);
        _this.setState({
          currentPosition: 0,
          indices: indices
        });
      }
    }, 300);
    _this.onChange = function (ev) {
      var value = ev.target.value;
      _this.setState({
        searchKey: value
      });
      _this.search();
    };
    _this.leftClick = function () {
      var getEditor = _this.props.getEditor;
      var _this$state = _this.state,
        indices = _this$state.indices,
        searchKey = _this$state.searchKey;
      var quill = getEditor();
      // 先恢复上一个的样式为 true
      quill.formatText(_this.currentIndex, searchKey.length, 'SearchedStringActive', false, Emitter.sources.API);
      // 获取上一个
      var last = _this.state.currentPosition - 1;
      _this.setState({
        currentPosition: last
      });
      var prevIndex = _this.state.indices[last];
      if (!prevIndex) {
        prevIndex = indices[indices.length - 1];
        _this.setState({
          currentPosition: indices.length - 1
        });
      }
      _this.currentIndex = prevIndex.index;
      // 下一个的 format
      quill.formatText(prevIndex.index, searchKey.length, 'SearchedStringActive', true, Emitter.sources.API);
      _this.checkView(prevIndex.index);
    };
    _this.rightClick = function () {
      var getEditor = _this.props.getEditor;
      var _this$state2 = _this.state,
        indices = _this$state2.indices,
        searchKey = _this$state2.searchKey;
      var quill = getEditor();
      // 先恢复上一个的样式为 true
      quill.formatText(_this.currentIndex, searchKey.length, 'SearchedStringActive', false, Emitter.sources.API);
      var next = _this.state.currentPosition + 1;
      _this.setState({
        currentPosition: next
      });
      // 获取下一个, 如果下一个不在, 那就变成第 1 个
      var nextIndex = indices[next];
      if (!nextIndex) {
        nextIndex = indices[0];
        _this.setState({
          currentPosition: 0
        });
      }
      _this.currentIndex = nextIndex.index;
      // 下一个的 format
      quill.formatText(nextIndex.index, searchKey.length, 'SearchedStringActive', true, Emitter.sources.API);
      _this.checkView(nextIndex.index);
    };
    _this.checkView = function (index) {
      // 检查选中的目标是否在窗口中, 如果不在则需要滚动
      var getEditor = _this.props.getEditor;
      var searchKey = _this.state.searchKey;
      var quill = getEditor();
      var scrollingContainer = quill.scrollingContainer;
      var bounds = quill.getBounds(index + searchKey.length, 1);
      // bounds.top + scrollingContainer.scrollTop 等于目标到最顶部的距离
      if (bounds.top < 0 || bounds.top > scrollingContainer.scrollTop + scrollingContainer.offsetHeight) {
        scrollingContainer.scrollTop = bounds.top - scrollingContainer.offsetHeight / 3;
      }
    };
    _this.replaceOnChange = function (ev) {
      _this.replaceKey = ev.target.value;
    };
    _this.replaceAll = function () {
      var _this$state3 = _this.state,
        indices = _this$state3.indices,
        searchKey = _this$state3.searchKey;
      if (!indices.length) return;
      var oldStringLen = searchKey.length;
      var newString = _this.replaceKey;
      var getEditor = _this.props.getEditor;
      var quill = getEditor();
      var length = indices.length;
      // 遍历 indices 尾部替换
      while (length--) {
        // 先删除再添加
        quill.deleteText(indices[length].index, oldStringLen, Emitter.sources.USER);
        quill.insertText(indices[length].index, newString, Emitter.sources.USER);
      }
      // 结束后重新搜索
      _this.search();
    };
    _this.replace = function () {
      var _this$state4 = _this.state,
        indices = _this$state4.indices,
        searchKey = _this$state4.searchKey;
      if (!indices.length) return;
      var getEditor = _this.props.getEditor;
      var quill = getEditor();
      // 删除, 添加
      quill.deleteText(_this.currentIndex, searchKey.length, Emitter.sources.USER);
      quill.insertText(_this.currentIndex, _this.replaceKey, Emitter.sources.USER);
      _this.search();
    };
    _this.renderSearch = function () {
      var _this$state5 = _this.state,
        currentPosition = _this$state5.currentPosition,
        indices = _this$state5.indices,
        searchKey = _this$state5.searchKey,
        checked = _this$state5.checked;
      var locale = _this.props.locale;
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
        className: 'find-input-box'
      }, /*#__PURE__*/React.createElement("label", null, _findInstanceProperty(locale)), /*#__PURE__*/React.createElement(Input, {
        onChange: _this.onChange,
        value: searchKey,
        suffix: indices.length ? /*#__PURE__*/React.createElement("span", {
          className: 'search-range'
        }, /*#__PURE__*/React.createElement(Icon, {
          onClick: _this.leftClick,
          type: "left"
        }), currentPosition + 1, " / ", indices.length, /*#__PURE__*/React.createElement(Icon, {
          onClick: _this.rightClick,
          type: "right"
        })) : null
      })), /*#__PURE__*/React.createElement(Checkbox, {
        checked: checked,
        onChange: _this.onCheck
      }, locale.caseSensitive));
    };
    return _this;
  }
  _createClass(FindModal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var getEditor = this.props.getEditor;
      var quill = getEditor();
      quill && quill.on('text-change', this.editorOnChange);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeStyle();
      var getEditor = this.props.getEditor;
      var quill = getEditor();
      quill && quill.off('text-change', this.editorOnChange);
    }
  }, {
    key: "render",
    value: function render() {
      var indices = this.state.indices;
      var locale = this.props.locale;
      return /*#__PURE__*/React.createElement("div", {
        className: 'find-modal'
      }, /*#__PURE__*/React.createElement(Icon, {
        type: "hints-alone-error",
        onClick: this.props.closeFindModal
      }), /*#__PURE__*/React.createElement(Tabs, {
        defaultActiveKey: "1",
        size: 'small'
      }, /*#__PURE__*/React.createElement(TabPane, {
        tab: _findInstanceProperty(locale),
        key: "1"
      }, this.renderSearch()), /*#__PURE__*/React.createElement(TabPane, {
        tab: locale.replace,
        key: "2"
      }, this.renderSearch(), /*#__PURE__*/React.createElement("div", {
        className: 'find-input-box replace-input'
      }, /*#__PURE__*/React.createElement("label", null, locale.replaceTo), /*#__PURE__*/React.createElement(Input, {
        onChange: this.replaceOnChange
      })), /*#__PURE__*/React.createElement("div", {
        className: 'replace-buttons'
      }, /*#__PURE__*/React.createElement(Button, {
        disabled: !indices.length,
        size: 'small',
        onClick: _replaceAllInstanceProperty(this)
      }, _replaceAllInstanceProperty(locale)), /*#__PURE__*/React.createElement(Button, {
        disabled: !indices.length,
        size: 'small',
        type: 'primary',
        onClick: this.replace
      }, locale.replace)))));
    }
  }]);
  return FindModal;
}(React.Component);
export default FindModal;