import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
var ImageDrop = /*#__PURE__*/function () {
  function ImageDrop(quill) {
    var _context, _context2;
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
      customDropImage: undefined
    };
    _classCallCheck(this, ImageDrop);
    this.quill = quill;
    this.customDropImage = options.customDropImage || null;
    this.handleDrop = _bindInstanceProperty(_context = this.handleDrop).call(_context, this);
    this.handlePaste = _bindInstanceProperty(_context2 = this.handlePaste).call(_context2, this);
    this.quill.root.addEventListener('drop', this.handleDrop, true);
    this.quill.root.addEventListener('paste', this.handlePaste, true);
  }
  _createClass(ImageDrop, [{
    key: "handleDrop",
    value: function handleDrop(evt) {
      evt.preventDefault();
      if (evt.dataTransfer && evt.dataTransfer.files && evt.dataTransfer.files.length) {
        if (document.caretRangeFromPoint) {
          var selection = document.getSelection();
          var range = document.caretRangeFromPoint(evt.clientX, evt.clientY);
          if (selection && range) {
            selection.setBaseAndExtent(range.startContainer, range.startOffset, range.startContainer, range.startOffset);
          }
        }
        if (this.customDropImage && typeof this.customDropImage == 'function') {
          var _context3;
          this.customDropImage(evt.dataTransfer.files, _bindInstanceProperty(_context3 = this.insert).call(_context3, this));
        } else {
          var _context4;
          this.readFiles(evt.dataTransfer.files, _bindInstanceProperty(_context4 = this.insert).call(_context4, this));
        }
      }
    }
  }, {
    key: "handlePaste",
    value: function handlePaste(evt) {
      var _this = this;
      if (evt.clipboardData && evt.clipboardData.items && evt.clipboardData.items.length) {
        var hasFile = false,
          len = evt.clipboardData.items.length;
        for (var i = 0; i < len; i++) {
          var item = evt.clipboardData.items[i];
          if (item.kind == 'file') {
            hasFile = true;
            break;
          }
        }
        // 粘贴文件时禁止浏览器执行默认动作，防止粘贴后插入两次文件。粘贴非文件时执行浏览器默认的动作。
        if (hasFile) {
          evt.preventDefault();
          if (this.customDropImage && typeof this.customDropImage == 'function') {
            var _context5;
            this.customDropImage(evt.clipboardData.items, _bindInstanceProperty(_context5 = this.insert).call(_context5, this));
          } else {
            this.readFiles(evt.clipboardData.items, function (attrs) {
              // 等待 this.quill.getSelection() 返回有效的 index
              _setTimeout(function () {
                return _this.insert(attrs);
              }, 0);
            });
          }
        }
      }
    }
  }, {
    key: "insert",
    value: function insert(attrs) {
      var range = this.quill.getSelection() || {},
        index = range.index != undefined ? range.index : this.quill.getLength();
      if (!attrs.src) return;
      this.quill.insertEmbed(index, 'image', attrs);
      this.quill.setSelection(index + 1);
    }
    // Extract image URIs a list of files from evt.dataTransfer or evt.clipboardData
  }, {
    key: "readFiles",
    value: function readFiles(files, callback) {
      // check each file for an image
      _forEachInstanceProperty([]).call(files, function (file) {
        if (!file.type.match(/^image\/(gif|jpe?g|a?png|svg|webp|bmp|vnd\.microsoft\.icon)/i)) {
          // Note that some file formats such as psd start with image/* but are not readable
          return;
        }
        var reader = new FileReader();
        reader.onload = function (evt) {
          callback({
            src: evt.target.result
          });
        };
        // read the clipboard item or file
        var blob = file.getAsFile ? file.getAsFile() : file;
        if (blob instanceof Blob) {
          reader.readAsDataURL(blob);
        }
      });
    }
  }]);
  return ImageDrop;
}();
export { ImageDrop as default };