import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _slicedToArray from "@babel/runtime-corejs3/helpers/slicedToArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _keysInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/keys";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import BaseModule from './BaseModule';
var Keyboard = /*#__PURE__*/function (_BaseModule) {
  _inherits(Keyboard, _BaseModule);
  var _super = _createSuper(Keyboard);
  function Keyboard() {
    _classCallCheck(this, Keyboard);
    return _super.apply(this, arguments);
  }
  _createClass(Keyboard, [{
    key: "onCreate",
    value: function onCreate(e) {
      var _this = this;
      this.keyboardProxy = function (evt) {
        return _this.keyboardHandle(evt);
      };
      document.addEventListener('keydown', this.keyboardProxy, true);
    }
  }, {
    key: "onDestroy",
    value: function onDestroy() {
      document.removeEventListener('keydown', this.keyboardProxy, true);
    }
  }, {
    key: "keyboardHandle",
    value: function keyboardHandle(evt) {
      if (evt.defaultPrevented) return;
      if (evt.shiftKey || evt.ctrlKey || evt.altKey) {
        return;
      }
      if (!this.activeEle || evt.fromResize || evt.ctrlKey) return;
      var code = evt.keyCode;
      var index = this.blot.offset(this.quill.scroll);
      var nextBlot;
      var handled = false;
      // delete
      if (code === _keysInstanceProperty(Keyboard).BACKSPACE || code === _keysInstanceProperty(Keyboard).DELETE) {
        this.blot.deleteAt(0);
        this.blot.parent.optimize();
        handled = true;
        // direction key
      } else if (code >= _keysInstanceProperty(Keyboard).LEFT && code <= _keysInstanceProperty(Keyboard).DOWN) {
        if (code === _keysInstanceProperty(Keyboard).RIGHT) {
          index++;
        } else if (code === _keysInstanceProperty(Keyboard).UP) {
          index = this.getOtherLineIndex(-1);
          nextBlot = this.quill.getLeaf(index)[0];
        } else if (code === _keysInstanceProperty(Keyboard).DOWN) {
          index = this.getOtherLineIndex(1);
          nextBlot = this.quill.getLeaf(index)[0];
        }
        handled = true;
      }
      if (handled) {
        evt.stopPropagation();
        evt.preventDefault();
      }
      if (nextBlot && this.resizer.judgeShow(nextBlot, nextBlot.domNode)) return;
      this.quill.setSelection(index);
      this.resizer.hide();
    }
  }, {
    key: "getOtherLineIndex",
    value: function getOtherLineIndex(dir) {
      var index = this.blot.offset(this.quill.scroll);
      var _this$quill$getLine = this.quill.getLine(index),
        _this$quill$getLine2 = _slicedToArray(_this$quill$getLine, 1),
        line = _this$quill$getLine2[0];
      var lineIndex = this.blot.offset(line) + 1;
      var otherLine = dir > 0 ? line.next : line.prev;
      if (otherLine) {
        var len = otherLine.length();
        if (otherLine.statics.blotName === 'block') len--;
        index = otherLine.offset(this.quill.scroll) + Math.min(len, lineIndex);
      }
      return index;
    }
    // 转发event到quill
  }, {
    key: "dispatchEvent",
    value: function dispatchEvent(evt) {
      var event = new evt.constructor(evt);
      event.fromResize = true;
      this.quill.root.dispatchEvent(event);
    }
  }], [{
    key: "injectInit",
    value: function injectInit(quill) {
      // left/right
      var bindings = quill.keyboard.bindings;
      bindings[_keysInstanceProperty(this).LEFT].unshift(this.makeArrowHandler(_keysInstanceProperty(this).LEFT, false));
      bindings[_keysInstanceProperty(this).RIGHT].unshift(this.makeArrowHandler(_keysInstanceProperty(this).RIGHT, false));
      // // up
      // const upBinding = this.makeArrowHandler(this.keys.UP, false)
      // if (bindings[this.keys.UP]) {
      //   bindings[this.keys.UP].unshift(upBinding)
      // } else {
      //   quill.keyboard.addBinding(upBinding)
      // }
      // // down
      // const downBinding = this.makeArrowHandler(this.keys.DOWN, false)
      // if (bindings[this.keys.DOWN]) {
      //   bindings[this.keys.DOWN].unshift(downBinding)
      // } else {
      //   quill.keyboard.addBinding(downBinding)
      // }
    }
  }, {
    key: "makeArrowHandler",
    value: function makeArrowHandler(key, shiftKey) {
      var _ref;
      var where = key === _keysInstanceProperty(Keyboard).LEFT ? 'prefix' : 'suffix';
      return _ref = {
        key: key,
        shiftKey: shiftKey,
        altKey: null
      }, _defineProperty(_ref, where, /^$/), _defineProperty(_ref, "handler", function handler(range) {
        if (!this.quill.resizer) return true;
        var index = range.index;
        // check end of line
        var _this$quill$getLine3 = this.quill.getLine(range.index),
          _this$quill$getLine4 = _slicedToArray(_this$quill$getLine3, 1),
          line = _this$quill$getLine4[0];
        var lineIndex = this.quill.getIndex(line);
        if (key === _keysInstanceProperty(Keyboard).RIGHT && lineIndex + line.length() - 1 === index) return true;
        // get leaf/offset
        if (key === _keysInstanceProperty(Keyboard).RIGHT) {
          index += range.length + 1;
        }
        var _this$quill$getLeaf = this.quill.getLeaf(index),
          _this$quill$getLeaf2 = _slicedToArray(_this$quill$getLeaf, 1),
          leaf = _this$quill$getLeaf2[0];
        var offset = leaf.offset(leaf.parent);
        // check start of line
        if (key === _keysInstanceProperty(Keyboard).LEFT && (index === 0 || index === lineIndex)) return true;
        // get previous leaf
        if (key === _keysInstanceProperty(Keyboard).LEFT) {
          if (offset === 0) {
            index -= 1;
            leaf = this.quill.getLeaf(index)[0];
          }
        }
        return !this.quill.resizer.judgeShow(leaf);
      }), _ref;
    }
  }]);
  return Keyboard;
}(BaseModule);
export { Keyboard as default };
Keyboard.keys = {
  BACKSPACE: 'Backspace',
  TAB: 'Tab',
  ENTER: 'Enter',
  ESCAPE: 'Escape',
  LEFT: 'ArrowLeft',
  UP: 'ArrowUp',
  RIGHT: 'ArrowRight',
  DOWN: 'ArrowDown',
  DELETE: 'Delete'
};