import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _slicedToArray from "@babel/runtime-corejs3/helpers/slicedToArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _fillInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/fill";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import Block from '../blots/block';
import Container from '../blots/container';
var TableCell = /*#__PURE__*/function (_Block) {
  _inherits(TableCell, _Block);
  var _super = _createSuper(TableCell);
  function TableCell() {
    _classCallCheck(this, TableCell);
    return _super.apply(this, arguments);
  }
  _createClass(TableCell, [{
    key: "cellOffset",
    value: function cellOffset() {
      if (this.parent) {
        var _context;
        return _indexOfInstanceProperty(_context = this.parent.children).call(_context, this);
      }
      return -1;
    }
  }, {
    key: "format",
    value: function format(name, value) {
      if (name === TableCell.blotName && value) {
        this.domNode.setAttribute('data-row', value);
      } else {
        _get(_getPrototypeOf(TableCell.prototype), "format", this).call(this, name, value);
      }
    }
  }, {
    key: "row",
    value: function row() {
      return this.parent;
    }
  }, {
    key: "rowOffset",
    value: function rowOffset() {
      if (this.row()) {
        return this.row().rowOffset();
      }
      return -1;
    }
  }, {
    key: "table",
    value: function table() {
      return this.row() && this.row().table();
    }
  }], [{
    key: "create",
    value: function create(value) {
      var node = _get(_getPrototypeOf(TableCell), "create", this).call(this);
      if (value) {
        node.setAttribute('data-row', value);
      } else {
        node.setAttribute('data-row', tableId());
      }
      return node;
    }
  }, {
    key: "formats",
    value: function formats(domNode) {
      if (domNode.hasAttribute('data-row')) {
        return domNode.getAttribute('data-row');
      }
      return undefined;
    }
  }]);
  return TableCell;
}(Block);
TableCell.blotName = 'table';
TableCell.tagName = 'TD';
var TableRow = /*#__PURE__*/function (_Container) {
  _inherits(TableRow, _Container);
  var _super2 = _createSuper(TableRow);
  function TableRow() {
    _classCallCheck(this, TableRow);
    return _super2.apply(this, arguments);
  }
  _createClass(TableRow, [{
    key: "checkMerge",
    value: function checkMerge() {
      if (_get(_getPrototypeOf(TableRow.prototype), "checkMerge", this).call(this) && this.next.children.head != null) {
        var thisHead = this.children.head.formats();
        var thisTail = this.children.tail.formats();
        var nextHead = this.next.children.head.formats();
        var nextTail = this.next.children.tail.formats();
        return thisHead.table === thisTail.table && thisHead.table === nextHead.table && thisHead.table === nextTail.table;
      }
      return false;
    }
  }, {
    key: "optimize",
    value: function optimize() {
      var _get2,
        _context2,
        _context3,
        _this = this;
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      (_get2 = _get(_getPrototypeOf(TableRow.prototype), "optimize", this)).call.apply(_get2, _concatInstanceProperty(_context2 = [this]).call(_context2, args));
      _forEachInstanceProperty(_context3 = this.children).call(_context3, function (child) {
        if (child.next == null) return;
        var childFormats = child.formats();
        var nextFormats = child.next.formats();
        if (childFormats.table !== nextFormats.table) {
          var next = _this.splitAfter(child);
          if (next) {
            next.optimize();
          }
          // We might be able to merge with prev now
          if (_this.prev) {
            _this.prev.optimize();
          }
        }
      });
    }
  }, {
    key: "rowOffset",
    value: function rowOffset() {
      if (this.parent) {
        var _context4;
        return _indexOfInstanceProperty(_context4 = this.parent.children).call(_context4, this);
      }
      return -1;
    }
  }, {
    key: "table",
    value: function table() {
      return this.parent && this.parent.parent;
    }
  }]);
  return TableRow;
}(Container);
TableRow.blotName = 'table-row';
TableRow.tagName = 'TR';
var TableBody = /*#__PURE__*/function (_Container2) {
  _inherits(TableBody, _Container2);
  var _super3 = _createSuper(TableBody);
  function TableBody() {
    _classCallCheck(this, TableBody);
    return _super3.apply(this, arguments);
  }
  return _createClass(TableBody);
}(Container);
TableBody.blotName = 'table-body';
TableBody.tagName = 'TBODY';
var TableContainer = /*#__PURE__*/function (_Container3) {
  _inherits(TableContainer, _Container3);
  var _super4 = _createSuper(TableContainer);
  function TableContainer() {
    _classCallCheck(this, TableContainer);
    return _super4.apply(this, arguments);
  }
  _createClass(TableContainer, [{
    key: "balanceCells",
    value: function balanceCells() {
      var _this2 = this;
      var rows = this.descendants(TableRow);
      var maxColumns = _reduceInstanceProperty(rows).call(rows, function (max, row) {
        return Math.max(row.children.length, max);
      }, 0);
      _forEachInstanceProperty(rows).call(rows, function (row) {
        var _context5, _context6;
        _forEachInstanceProperty(_context5 = _fillInstanceProperty(_context6 = new Array(maxColumns - row.children.length)).call(_context6, 0)).call(_context5, function () {
          var value;
          if (row.children.head != null) {
            value = TableCell.formats(row.children.head.domNode);
          }
          var blot = _this2.scroll.create(TableCell.blotName, value);
          row.appendChild(blot);
          blot.optimize(); // Add break blot
        });
      });
    }
  }, {
    key: "cells",
    value: function cells(column) {
      var _context7;
      return _mapInstanceProperty(_context7 = this.rows()).call(_context7, function (row) {
        return row.children.at(column);
      });
    }
  }, {
    key: "deleteColumn",
    value: function deleteColumn(index) {
      var _context8;
      var _this$descendant = this.descendant(TableBody),
        _this$descendant2 = _slicedToArray(_this$descendant, 1),
        body = _this$descendant2[0];
      if (body == null || body.children.head == null) return;
      _forEachInstanceProperty(_context8 = body.children).call(_context8, function (row) {
        var cell = row.children.at(index);
        if (cell != null) {
          cell.remove();
        }
      });
    }
  }, {
    key: "insertColumn",
    value: function insertColumn(index) {
      var _context9,
        _this3 = this;
      var _this$descendant3 = this.descendant(TableBody),
        _this$descendant4 = _slicedToArray(_this$descendant3, 1),
        body = _this$descendant4[0];
      if (body == null || body.children.head == null) return;
      _forEachInstanceProperty(_context9 = body.children).call(_context9, function (row) {
        var ref = row.children.at(index);
        var value = TableCell.formats(row.children.head.domNode);
        var cell = _this3.scroll.create(TableCell.blotName, value);
        row.insertBefore(cell, ref);
      });
    }
  }, {
    key: "insertRow",
    value: function insertRow(index) {
      var _context10,
        _this4 = this;
      var _this$descendant5 = this.descendant(TableBody),
        _this$descendant6 = _slicedToArray(_this$descendant5, 1),
        body = _this$descendant6[0];
      if (body == null || body.children.head == null) return;
      var id = tableId();
      var row = this.scroll.create(TableRow.blotName);
      _forEachInstanceProperty(_context10 = body.children.head.children).call(_context10, function () {
        var cell = _this4.scroll.create(TableCell.blotName, id);
        row.appendChild(cell);
      });
      var ref = body.children.at(index);
      body.insertBefore(row, ref);
    }
  }, {
    key: "rows",
    value: function rows() {
      var _context11;
      var body = this.children.head;
      if (body == null) return [];
      return _mapInstanceProperty(_context11 = body.children).call(_context11, function (row) {
        return row;
      });
    }
  }]);
  return TableContainer;
}(Container);
TableContainer.blotName = 'table-container';
TableContainer.tagName = 'TABLE';
TableContainer.allowedChildren = [TableBody];
TableBody.requiredContainer = TableContainer;
TableBody.allowedChildren = [TableRow];
TableRow.requiredContainer = TableBody;
TableRow.allowedChildren = [TableCell];
TableCell.requiredContainer = TableRow;
function tableId() {
  var _context12;
  var id = _sliceInstanceProperty(_context12 = Math.random().toString(36)).call(_context12, 2, 6);
  return "row-".concat(id);
}
export { TableCell, TableRow, TableBody, TableContainer, tableId };