import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _Array$from from "@babel/runtime-corejs3/core-js-stable/array/from";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Promise from "@babel/runtime-corejs3/core-js-stable/promise";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import Delta from 'quill-delta';
import Emitter from '../core/emitter';
import Module from '../core/module';
var Uploader = /*#__PURE__*/function (_Module) {
  _inherits(Uploader, _Module);
  var _super = _createSuper(Uploader);
  function Uploader(quill, options) {
    var _this;
    _classCallCheck(this, Uploader);
    var _a;
    _this = _super.call(this, quill, options);
    // 这里的执行结果, 图片 drop, 自动读取 base64 渲染, 因为自定义图片上传, 会用接口传, 这里就没必要了
    if ((_a = quill.options.modules.imageDrop) === null || _a === void 0 ? void 0 : _a.customDropImage) {
      return _possibleConstructorReturn(_this);
    }
    quill.root.addEventListener('drop', function (e) {
      e.preventDefault();
      var _native;
      if (document.caretRangeFromPoint) {
        _native = document.caretRangeFromPoint(e.clientX, e.clientY);
      } else if (document.caretPositionFromPoint) {
        var position = document.caretPositionFromPoint(e.clientX, e.clientY);
        _native = document.createRange();
        _native.setStart(position.offsetNode, position.offset);
        _native.setEnd(position.offsetNode, position.offset);
      } else {
        return;
      }
      var normalized = quill.selection.normalizeNative(_native);
      var range = quill.selection.normalizedToRange(normalized);
      _this.upload(range, e.dataTransfer.files);
    });
    return _this;
  }
  _createClass(Uploader, [{
    key: "upload",
    value: function upload(range, files) {
      var _context,
        _this2 = this;
      var uploads = [];
      _forEachInstanceProperty(_context = _Array$from(files)).call(_context, function (file) {
        var _context2;
        if (file && _includesInstanceProperty(_context2 = _this2.options.mimetypes).call(_context2, file.type)) {
          uploads.push(file);
        }
      });
      if (uploads.length > 0) {
        this.options.handler.call(this, range, uploads);
      }
    }
  }]);
  return Uploader;
}(Module);
Uploader.DEFAULTS = {
  mimetypes: ['image/png', 'image/jpeg'],
  handler: function handler(range, files) {
    var _this3 = this;
    var promises = _mapInstanceProperty(files).call(files, function (file) {
      return new _Promise(function (resolve) {
        var reader = new FileReader();
        reader.onload = function (e) {
          resolve(e.target.result);
        };
        reader.readAsDataURL(file);
      });
    });
    _Promise.all(promises).then(function (images) {
      var update = _reduceInstanceProperty(images).call(images, function (delta, image) {
        return delta.insert({
          image: image
        });
      }, new Delta().retain(range.index)["delete"](range.length));
      _this3.quill.updateContents(update, Emitter.sources.USER);
      _this3.quill.setSelection(range.index + images.length, Emitter.sources.SILENT);
    });
  }
};
export default Uploader;