import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _slicedToArray from "@babel/runtime-corejs3/helpers/slicedToArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import merge from 'lodash/merge';
import Emitter from '../core/emitter';
import BaseTheme, { BaseTooltip } from './base';
import LinkBlot from '../formats/link';
import { Range } from '../core/selection';
import icons from '../ui/icons';
var TOOLBAR_CONFIG = [[{
  header: ['1', '2', '3', false]
}], ['bold', 'italic', 'underline', 'link'], [{
  list: 'ordered'
}, {
  list: 'bullet'
}], ['clean']];
var SnowTooltip = /*#__PURE__*/function (_BaseTooltip) {
  _inherits(SnowTooltip, _BaseTooltip);
  var _super = _createSuper(SnowTooltip);
  function SnowTooltip(quill, bounds) {
    var _this;
    _classCallCheck(this, SnowTooltip);
    _this = _super.call(this, quill, bounds);
    _this.preview = _this.root.querySelector('a.ql-preview');
    return _this;
  }
  _createClass(SnowTooltip, [{
    key: "listen",
    value: function listen() {
      var _this2 = this;
      _get(_getPrototypeOf(SnowTooltip.prototype), "listen", this).call(this);
      this.root.querySelector('a.ql-action').addEventListener('click', function (event) {
        if (_this2.root.classList.contains('ql-editing')) {
          _this2.save();
        } else {
          _this2.edit('link', _this2.preview.textContent);
        }
        event.preventDefault();
      });
      this.root.querySelector('a.ql-remove').addEventListener('click', function (event) {
        if (_this2.linkRange != null) {
          var range = _this2.linkRange;
          _this2.restoreFocus();
          _this2.quill.formatText(range, 'link', false, Emitter.sources.USER);
          delete _this2.linkRange;
        }
        event.preventDefault();
        _this2.hide();
      });
      this.quill.on(Emitter.events.SELECTION_CHANGE, function (range, oldRange, source) {
        if (range == null) return;
        if (range.length === 0 && source === Emitter.sources.USER) {
          var _this2$quill$scroll$d = _this2.quill.scroll.descendant(LinkBlot, range.index),
            _this2$quill$scroll$d2 = _slicedToArray(_this2$quill$scroll$d, 2),
            link = _this2$quill$scroll$d2[0],
            offset = _this2$quill$scroll$d2[1];
          if (link != null) {
            _this2.linkRange = new Range(range.index - offset, link.length());
            var preview = LinkBlot.formats(link.domNode);
            _this2.preview.textContent = preview;
            _this2.preview.setAttribute('href', preview);
            _this2.show();
            _this2.position(_this2.quill.getBounds(_this2.linkRange));
            return;
          }
        } else {
          delete _this2.linkRange;
        }
        _this2.hide();
      });
    }
  }, {
    key: "show",
    value: function show() {
      _get(_getPrototypeOf(SnowTooltip.prototype), "show", this).call(this);
      this.root.removeAttribute('data-mode');
    }
  }]);
  return SnowTooltip;
}(BaseTooltip);
SnowTooltip.TEMPLATE = ['<a class="ql-preview" rel="noopener noreferrer" target="_blank" href="about:blank"></a>', '<input type="text" data-formula="e=mc^2" data-link="https://quilljs.com" data-video="Embed URL">', '<a class="ql-action"></a>', '<a class="ql-remove"></a>'].join('');
var SnowTheme = /*#__PURE__*/function (_BaseTheme) {
  _inherits(SnowTheme, _BaseTheme);
  var _super2 = _createSuper(SnowTheme);
  function SnowTheme(quill, options) {
    var _this3;
    _classCallCheck(this, SnowTheme);
    if (options.modules.toolbar != null && options.modules.toolbar.container == null) {
      options.modules.toolbar.container = TOOLBAR_CONFIG;
    }
    _this3 = _super2.call(this, quill, options);
    _this3.quill.container.classList.add('ql-snow');
    return _this3;
  }
  _createClass(SnowTheme, [{
    key: "extendToolbar",
    value: function extendToolbar(toolbar) {
      toolbar.container.classList.add('ql-snow');
      this.buildButtons(toolbar.container.querySelectorAll('button'), icons);
      // this.buildPickers(toolbar.container.querySelectorAll('select'), icons);
      this.tooltip = new SnowTooltip(this.quill, this.options.bounds);
      if (toolbar.container.querySelector('.ql-link')) {
        this.quill.keyboard.addBinding({
          key: 'k',
          shortKey: true
        }, function (range, context) {
          toolbar.handlers.link.call(toolbar, !context.format.link);
        });
      }
    }
  }]);
  return SnowTheme;
}(BaseTheme);
SnowTheme.DEFAULTS = merge({}, BaseTheme.DEFAULTS, {
  modules: {
    toolbar: {
      handlers: {
        link: function link(value) {
          if (value) {
            var range = this.quill.getSelection();
            if (range == null || range.length === 0) return;
            var preview = this.quill.getText(range);
            if (/^\S+@\S+\.\S+$/.test(preview) && _indexOfInstanceProperty(preview).call(preview, 'mailto:') !== 0) {
              preview = "mailto:".concat(preview);
            }
            var tooltip = this.quill.theme.tooltip;
            tooltip.edit('link', preview);
          } else {
            this.quill.format('link', false);
          }
        }
      }
    }
  }
});
export default SnowTheme;