import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { addEventListener } from '../../utils';
var Handle = /*#__PURE__*/function (_React$Component) {
  _inherits(Handle, _React$Component);
  var _super = _createSuper(Handle);
  function Handle() {
    var _this;
    _classCallCheck(this, Handle);
    _this = _super.apply(this, arguments);
    _this.state = {
      clickFocused: false
    };
    _this.handleMouseUp = function () {
      if (document.activeElement === _this.handle) {
        _this.setClickFocus(true);
      }
    };
    _this.handleBlur = function () {
      _this.setClickFocus(false);
    };
    _this.handleKeyDown = function () {
      _this.setClickFocus(false);
    };
    return _this;
  }
  _createClass(Handle, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // mouseup won't trigger if mouse moved out of handle,
      // so we listen on document here.
      this.onMouseUpListener = addEventListener(document, 'mouseup', this.handleMouseUp);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.onMouseUpListener) {
        this.onMouseUpListener.remove();
      }
    }
  }, {
    key: "setClickFocus",
    value: function setClickFocus(focused) {
      this.setState({
        clickFocused: focused
      });
    }
  }, {
    key: "clickFocus",
    value: function clickFocus() {
      this.setClickFocus(true);
      this.focus();
    }
  }, {
    key: "focus",
    value: function focus() {
      this.handle.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.handle.blur();
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        vertical = _a.vertical,
        offset = _a.offset,
        style = _a.style,
        disabled = _a.disabled,
        min = _a.min,
        max = _a.max,
        value = _a.value,
        tabIndex = _a.tabIndex,
        handle = _a.handle,
        restProps = __rest(_a, ["prefixCls", "vertical", "offset", "style", "disabled", "min", "max", "value", "tabIndex", "handle"]);
      var elClassName = classNames((_classNames = {}, _defineProperty(_classNames, this.props.className, true), _defineProperty(_classNames, "".concat(prefixCls, "-handle-custom"), !!this.props.handle), _defineProperty(_classNames, "".concat(prefixCls, "-handle-click-focused"), this.state.clickFocused), _classNames));
      var postionStyle = vertical ? {
        bottom: "".concat(offset, "%")
      } : {
        left: "".concat(offset, "%")
      };
      var elStyle = _Object$assign(_Object$assign({}, style), postionStyle);
      var ariaProps = {};
      if (value !== undefined) {
        ariaProps = _Object$assign(_Object$assign({}, ariaProps), {
          'aria-valuemin': min,
          'aria-valuemax': max,
          'aria-valuenow': value,
          'aria-disabled': !!disabled
        });
      }
      return /*#__PURE__*/React.createElement("div", _Object$assign({
        ref: function ref(node) {
          return _this2.handle = node;
        },
        role: "slider",
        tabIndex: disabled ? null : tabIndex || 0
      }, ariaProps, restProps, {
        className: elClassName,
        style: elStyle,
        onBlur: this.handleBlur,
        onKeyDown: this.handleKeyDown
      }), !!handle && handle);
    }
  }]);
  return Handle;
}(React.Component);
export { Handle as default };
Handle.propTypes = {
  prefixCls: PropTypes.string,
  className: PropTypes.string,
  vertical: PropTypes.bool,
  offset: PropTypes.number,
  style: PropTypes.object,
  disabled: PropTypes.bool,
  min: PropTypes.number,
  max: PropTypes.number,
  value: PropTypes.number,
  tabIndex: PropTypes.number,
  handle: PropTypes.node
};