import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _parseFloat from "@babel/runtime-corejs3/core-js-stable/parse-float";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import warning from 'warning';
var calcPoints = function calcPoints(vertical, marks, dots, step, min, max) {
  var _context;
  warning(dots ? step > 0 : true, '`Slider[step]` should be a positive number in order to make Slider[dots] work.');
  var points = _mapInstanceProperty(_context = _Object$keys(marks)).call(_context, _parseFloat);
  if (dots) {
    for (var i = min; i <= max; i = i + step) {
      if (_indexOfInstanceProperty(points).call(points, i) >= 0) continue;
      points.push(i);
    }
  }
  return points;
};
var Steps = function Steps(_ref) {
  var _context2;
  var prefixCls = _ref.prefixCls,
    vertical = _ref.vertical,
    marks = _ref.marks,
    dots = _ref.dots,
    step = _ref.step,
    included = _ref.included,
    lowerBound = _ref.lowerBound,
    upperBound = _ref.upperBound,
    max = _ref.max,
    min = _ref.min,
    dotStyle = _ref.dotStyle,
    activeDotStyle = _ref.activeDotStyle;
  var range = max - min;
  var elements = _mapInstanceProperty(_context2 = calcPoints(vertical, marks, dots, step, min, max)).call(_context2, function (point) {
    var _classNames;
    var offset = "".concat(Math.abs(point - min) / range * 100, "%");
    var isActived = !included && point === upperBound || included && point <= upperBound && point >= lowerBound;
    var style = vertical ? _Object$assign({
      bottom: offset
    }, dotStyle) : _Object$assign({
      left: offset
    }, dotStyle);
    if (isActived) {
      style = _Object$assign(_Object$assign({}, style), activeDotStyle);
    }
    var pointClassName = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-dot"), true), _defineProperty(_classNames, "".concat(prefixCls, "-dot-active"), isActived), _classNames));
    return /*#__PURE__*/React.createElement("span", {
      className: pointClassName,
      style: style,
      key: point
    });
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-step")
  }, elements);
};
Steps.propTypes = {
  prefixCls: PropTypes.string,
  vertical: PropTypes.bool,
  marks: PropTypes.object,
  dots: PropTypes.bool,
  step: PropTypes.number,
  included: PropTypes.bool,
  lowerBound: PropTypes.number,
  upperBound: PropTypes.number,
  max: PropTypes.number,
  min: PropTypes.number,
  dotStyle: PropTypes.object,
  activeDotStyle: PropTypes.object
};
export default Steps;