import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _parseFloat from "@babel/runtime-corejs3/core-js-stable/parse-float";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import { findDOMNode } from 'react-dom';
import { KeyCode } from '../../utils';
export function isEventFromHandle(e, handles) {
  var _context;
  return _someInstanceProperty(_context = _Object$keys(handles)).call(_context, function (key) {
    return e.target === findDOMNode(handles[key]);
  });
}
export function isValueOutOfRange(value, _ref) {
  var min = _ref.min,
    max = _ref.max;
  return value < min || value > max;
}
export function isNotTouchEvent(e) {
  return e.touches.length > 1 || e.type.toLowerCase() === 'touchend' && e.touches.length > 0;
}
export function getClosestPoint(val, _ref2) {
  var _context2;
  var marks = _ref2.marks,
    step = _ref2.step,
    min = _ref2.min;
  var points = _mapInstanceProperty(_context2 = _Object$keys(marks)).call(_context2, _parseFloat);
  if (step !== null) {
    var closestStep = Math.round((val - min) / step) * step + min;
    points.push(closestStep);
  }
  var diffs = _mapInstanceProperty(points).call(points, function (point) {
    return Math.abs(val - point);
  });
  return points[_indexOfInstanceProperty(diffs).call(diffs, Math.min.apply(Math, _toConsumableArray(diffs)))] || 0;
}
export function getPrecision(step) {
  var stepString = step.toString();
  var precision = 0;
  if (_indexOfInstanceProperty(stepString).call(stepString, '.') >= 0) {
    precision = stepString.length - _indexOfInstanceProperty(stepString).call(stepString, '.') - 1;
  }
  return precision;
}
export function getMousePosition(vertical, e) {
  return vertical ? e.clientY : e.pageX;
}
export function getTouchPosition(vertical, e) {
  return vertical ? e.touches[0].clientY : e.touches[0].pageX;
}
export function getHandleCenterPosition(vertical, handle) {
  var coords = handle.getBoundingClientRect();
  return vertical ? coords.top + coords.height * 0.5 : coords.left + coords.width * 0.5;
}
export function ensureValueInRange(val, _ref3) {
  var max = _ref3.max,
    min = _ref3.min;
  if (val <= min) {
    return min;
  }
  if (val >= max) {
    return max;
  }
  return val;
}
export function ensureValuePrecision(val, props) {
  var step = props.step;
  var closestPoint = getClosestPoint(val, props);
  return step === null ? closestPoint : _parseFloat(closestPoint.toFixed(getPrecision(step)));
}
export function pauseEvent(e) {
  e.stopPropagation();
  e.preventDefault();
}
export function getKeyboardValueMutator(e) {
  switch (e.keyCode) {
    case KeyCode.UP:
    case KeyCode.RIGHT:
      return function (value, props) {
        return value + props.step;
      };
    case KeyCode.DOWN:
    case KeyCode.LEFT:
      return function (value, props) {
        return value - props.step;
      };
    case KeyCode.END:
      return function (value, props) {
        return props.max;
      };
    case KeyCode.HOME:
      return function (value, props) {
        return props.min;
      };
    case KeyCode.PAGE_UP:
      return function (value, props) {
        return value + props.step * 2;
      };
    case KeyCode.PAGE_DOWN:
      return function (value, props) {
        return value - props.step * 2;
      };
    default:
      return undefined;
  }
}