import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import * as React from 'react';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import Checkbox from '../Checkbox';
import Dropdown from '../Dropdown';
import Menu from '../Menu';
import Icon from '../Icon';
function checkSelection(props, data, type, byDefaultChecked) {
  var store = props.store,
    getCheckboxPropsByItem = props.getCheckboxPropsByItem,
    getRecordKey = props.getRecordKey;
  // type should be 'every' | 'some'
  if (type === 'every' || type === 'some') {
    return byDefaultChecked ? data[type](function (item, i) {
      return getCheckboxPropsByItem(item, i).defaultChecked;
    }) : data[type](function (item, i) {
      var _context;
      return _indexOfInstanceProperty(_context = store.getState().selectedRowKeys).call(_context, getRecordKey(item, i)) >= 0;
    });
  }
  return false;
}
function getCheckState(props) {
  var store = props.store,
    data = props.data;
  var checked;
  if (!data.length) {
    checked = false;
  } else {
    checked = store.getState().selectionDirty ? checkSelection(props, data, 'every', false) : checkSelection(props, data, 'every', false) || checkSelection(props, data, 'every', true);
  }
  return checked;
}
function getIndeterminateState(props) {
  var store = props.store,
    data = props.data;
  var indeterminate;
  if (!data.length) {
    indeterminate = false;
  } else {
    indeterminate = store.getState().selectionDirty ? checkSelection(props, data, 'some', false) && !checkSelection(props, data, 'every', false) : checkSelection(props, data, 'some', false) && !checkSelection(props, data, 'every', false) || checkSelection(props, data, 'some', true) && !checkSelection(props, data, 'every', true);
  }
  return indeterminate;
}
function getCheckAndIndeterminateState(props, state) {
  var checked = getCheckState(props);
  var indeterminate = getIndeterminateState(props);
  var newState = {};
  if (indeterminate !== state.indeterminate) {
    newState.indeterminate = indeterminate;
  }
  if (checked !== state.checked) {
    newState.checked = checked;
  }
  return newState;
}
var SelectionCheckboxAll = /*#__PURE__*/function (_React$Component) {
  _inherits(SelectionCheckboxAll, _React$Component);
  var _super = _createSuper(SelectionCheckboxAll);
  function SelectionCheckboxAll(props) {
    var _this;
    _classCallCheck(this, SelectionCheckboxAll);
    _this = _super.call(this, props);
    _this.handleSelectAllChange = function (e) {
      var checked = e.target.checked;
      _this.props.onSelect(checked ? 'all' : 'removeAll', 0, null);
    };
    _this.defaultSelections = props.hideDefaultSelections ? [] : [{
      key: 'all',
      text: props.locale.selectAll,
      onSelect: function onSelect() {}
    }, {
      key: 'invert',
      text: props.locale.selectInvert,
      onSelect: function onSelect() {}
    }];
    _this.state = {
      checked: getCheckState(props),
      indeterminate: getIndeterminateState(props)
    };
    return _this;
  }
  _createClass(SelectionCheckboxAll, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.subscribe();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.unsubscribe) {
        this.unsubscribe();
      }
    }
  }, {
    key: "subscribe",
    value: function subscribe() {
      var _this2 = this;
      var store = this.props.store;
      this.unsubscribe = store.subscribe(function () {
        _this2.setState(getCheckAndIndeterminateState(_this2.props, _this2.state));
      });
    }
  }, {
    key: "renderMenus",
    value: function renderMenus(selections) {
      var _this3 = this;
      return _mapInstanceProperty(selections).call(selections, function (selection, index) {
        return /*#__PURE__*/React.createElement(Menu.Item, {
          key: selection.key || index
        }, /*#__PURE__*/React.createElement("div", {
          onClick: function onClick() {
            _this3.props.onSelect(selection.key, index, selection.onSelect);
          }
        }, selection.text));
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        disabled = _this$props.disabled,
        prefixCls = _this$props.prefixCls,
        selections = _this$props.selections,
        getPopupContainer = _this$props.getPopupContainer;
      var _this$state = this.state,
        checked = _this$state.checked,
        indeterminate = _this$state.indeterminate;
      var selectionPrefixCls = "".concat(prefixCls, "-selection");
      var customSelections = null;
      if (selections) {
        var _context2;
        var newSelections = _Array$isArray(selections) ? _concatInstanceProperty(_context2 = this.defaultSelections).call(_context2, selections) : this.defaultSelections;
        var menu = /*#__PURE__*/React.createElement(Menu, {
          className: "".concat(selectionPrefixCls, "-menu"),
          selectedKeys: []
        }, this.renderMenus(newSelections));
        customSelections = newSelections.length > 0 ? /*#__PURE__*/React.createElement(Dropdown, {
          overlay: menu,
          getPopupContainer: getPopupContainer
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(selectionPrefixCls, "-down")
        }, /*#__PURE__*/React.createElement(Icon, {
          type: "down-bolder"
        }))) : null;
      }
      return /*#__PURE__*/React.createElement("div", {
        className: selectionPrefixCls
      }, /*#__PURE__*/React.createElement(Checkbox, {
        className: classNames(_defineProperty({}, "".concat(selectionPrefixCls, "-select-all-custom"), customSelections)),
        checked: checked,
        indeterminate: indeterminate,
        disabled: disabled,
        onChange: this.handleSelectAllChange
      }), customSelections);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      return getCheckAndIndeterminateState(nextProps, prevState);
    }
  }]);
  return SelectionCheckboxAll;
}(React.Component);
polyfill(SelectionCheckboxAll);
export default SelectionCheckboxAll;