import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/splice";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { DragSource, DropTarget } from 'react-dnd';
import DragAndDrop from './DragAndDrop';
import './index.less';
var modulePrefix = 'TableDraggable';
var dragingIndex = -1;
/**
 * @param {*} WrappedTable
 * @param {*} config
 *                - dnd 是否启用 Drag&Drop
 *                - renderBodyRow 自定义渲染 row
 */
var TableDraggableHOC = function TableDraggableHOC(WrappedTable, config) {
  var _a;
  var BodyRow = /*#__PURE__*/function (_Component) {
    _inherits(BodyRow, _Component);
    var _super = _createSuper(BodyRow);
    function BodyRow() {
      _classCallCheck(this, BodyRow);
      return _super.apply(this, arguments);
    }
    _createClass(BodyRow, [{
      key: "render",
      value: function render() {
        var _a = this.props,
          isOver = _a.isOver,
          connectDragSource = _a.connectDragSource,
          connectDropTarget = _a.connectDropTarget,
          moveRow = _a.moveRow,
          restProps = __rest(_a, ["isOver", "connectDragSource", "connectDropTarget", "moveRow"]);
        var style = _Object$assign(_Object$assign({}, restProps.style), {
          cursor: 'move'
        });
        var style2 = _Object$assign(_Object$assign({}, restProps.style), {
          cursor: 'auto'
        });
        var className = restProps.className;
        if (isOver) {
          if (restProps.index > dragingIndex) {
            className += ' drop-over-downward';
          }
          if (restProps.index < dragingIndex) {
            className += ' drop-over-upward';
          }
        }
        if (config.renderBodyRow) {
          var rendered = config.renderBodyRow(_Object$assign(_Object$assign({}, restProps), {
            className: className,
            style: style
          }));
          var renderedNoMove = config.renderBodyRow(_Object$assign(_Object$assign({}, restProps), {
            className: className,
            style2: style2
          }));
          // 自定义渲染 TableRow 时是否开启拖拽功能
          if (config.dndRow) {
            var isRowDnd = config.dndRow(_Object$assign({}, restProps));
            return isRowDnd ? connectDragSource(connectDropTarget(rendered)) : renderedNoMove;
          } else {
            return renderedNoMove ? config.dnd ? connectDragSource(connectDropTarget(rendered)) : renderedNoMove : null;
          }
        }
        return connectDragSource(connectDropTarget( /*#__PURE__*/React.createElement("tr", _Object$assign({}, restProps, {
          style: style
        }))));
      }
    }]);
    return BodyRow;
  }(Component);
  var rowSource = {
    beginDrag: function beginDrag(props) {
      dragingIndex = props.index;
      return {
        record: props.record,
        index: props.index
      };
    }
  };
  var rowTarget = config.rowTarget || {
    drop: function drop(props, monitor) {
      var dragIndex = monitor.getItem().index;
      var hoverIndex = props.index;
      // Don't replace items with themselves
      if (dragIndex === hoverIndex) {
        return;
      }
      // Time to actually perform the action
      // 非自定义渲染 Row 时才进行移动
      props.moveRow(dragIndex, hoverIndex);
      // Note: we're mutating the monitor item here!
      // Generally it's better to avoid mutations,
      // but it's good here for the sake of performance
      // to avoid expensive index searches.
      monitor.getItem().index = hoverIndex;
    }
  };
  var DragableBodyRow = DropTarget('row', rowTarget, function (connect, monitor) {
    return {
      connectDropTarget: connect.dropTarget(),
      isOver: monitor.isOver()
    };
  })(DragSource('row', rowSource, function (connect) {
    return {
      connectDragSource: connect.dragSource()
    };
  })(BodyRow));
  return _a = /*#__PURE__*/function (_Component2) {
    _inherits(TableWrapper, _Component2);
    var _super2 = _createSuper(TableWrapper);
    function TableWrapper() {
      var _this;
      _classCallCheck(this, TableWrapper);
      _this = _super2.apply(this, arguments);
      _this.state = {
        dataSource: []
      };
      _this.components = {
        body: {
          row: DragableBodyRow
        }
      };
      _this.moveRow = function (dragIndex, hoverIndex) {
        var _context;
        var dataSource = _sliceInstanceProperty(_context = _this.state.dataSource).call(_context);
        // 自定义渲染 Row 时指定该项，不修改 Table 的 dataSource
        if (config.rowTarget) {
          _this.props.onRowMoved && _this.props.onRowMoved(dragIndex, hoverIndex);
        } else {
          // 默认逻辑：拖动 & 排序
          var dragged = _spliceInstanceProperty(dataSource).call(dataSource, dragIndex, 1)[0];
          _spliceInstanceProperty(dataSource).call(dataSource, hoverIndex, 0, dragged);
          _this.setState({
            dataSource: dataSource
          });
          _this.props.onRowMoved && _this.props.onRowMoved(dataSource);
        }
      };
      return _this;
    }
    _createClass(TableWrapper, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.setState({
          dataSource: this.props.dataSource
        });
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        if (this.props.dataSource !== prevProps.dataSource && this.props.dataSource !== this.state.dataSource) {
          this.setState({
            dataSource: this.props.dataSource
          });
        }
      }
    }, {
      key: "render",
      value: function render() {
        var _this2 = this;
        var _a = this.props,
          dataSource = _a.dataSource,
          _a$onRow = _a.onRow,
          _onRow = _a$onRow === void 0 ? function () {} : _a$onRow,
          otherProps = __rest(_a, ["dataSource", "onRow"]);
        return /*#__PURE__*/React.createElement(DragAndDrop, null, /*#__PURE__*/React.createElement(WrappedTable, _Object$assign({
          dataSource: this.state.dataSource,
          components: this.components,
          onRow: function onRow(record, index) {
            return _Object$assign({
              record: record,
              index: index,
              moveRow: _this2.moveRow
            }, _onRow(record, index));
          }
        }, otherProps)));
      }
    }]);
    return TableWrapper;
  }(Component), _a.propTypes = {
    onRowMoved: PropTypes.func
  }, _a;
};
export default TableDraggableHOC;