import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/splice";
export default function createStore(initialState) {
  var state = initialState;
  var listeners = [];
  function setState(partial) {
    state = _Object$assign(_Object$assign({}, state), partial);
    for (var i = 0; i < listeners.length; i++) {
      listeners[i]();
    }
  }
  function getState() {
    return state;
  }
  function subscribe(listener) {
    listeners.push(listener);
    return function unsubscribe() {
      var index = _indexOfInstanceProperty(listeners).call(listeners, listener);
      _spliceInstanceProperty(listeners).call(listeners, index, 1);
    };
  }
  return {
    setState: setState,
    getState: getState,
    subscribe: subscribe
  };
}