import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { polyfill } from 'react-lifecycles-compat';
import Menu, { SubMenu, Item as MenuItem } from '../Menu/src';
import closest from 'dom-closest';
import classNames from 'classnames';
import { shallowEqual } from '../../utils';
import Dropdown from '../Dropdown';
import Icon from '../Icon';
import Checkbox from '../Checkbox';
import Radio from '../Radio';
import FilterDropdownMenuWrapper from './FilterDropdownMenuWrapper';
var FilterMenu = /*#__PURE__*/function (_React$Component) {
  _inherits(FilterMenu, _React$Component);
  var _super = _createSuper(FilterMenu);
  function FilterMenu(props) {
    var _this;
    _classCallCheck(this, FilterMenu);
    _this = _super.call(this, props);
    _this.getNeverShown = function (column) {
      var rootNode = ReactDOM.findDOMNode(_assertThisInitialized(_this));
      var filterBelongToScrollBody = !!closest(rootNode, ".fishd-table-scroll");
      if (filterBelongToScrollBody) {
        // When fixed column have filters, there will be two dropdown menus
        // Filter dropdown menu inside scroll body should never be shown
        // To fix https://github.com/ant-design/ant-design/issues/5010 and
        // https://github.com/ant-design/ant-design/issues/7909
        return !!column.fixed;
      }
      return false;
    };
    _this.setSelectedKeys = function (_ref) {
      var selectedKeys = _ref.selectedKeys;
      _this.setState({
        selectedKeys: selectedKeys
      });
    };
    _this.handleClearFilters = function () {
      _this.setState({
        selectedKeys: []
      }, _this.handleConfirm);
    };
    _this.handleConfirm = function () {
      _this.setVisible(false);
      _this.confirmFilter();
    };
    _this.onVisibleChange = function (visible) {
      _this.setVisible(visible);
      if (!visible) {
        _this.confirmFilter();
      }
    };
    _this.handleMenuItemClick = function (info) {
      var _context;
      if (!info.keyPath || info.keyPath.length <= 1) {
        return;
      }
      var keyPathOfSelectedItem = _this.state.keyPathOfSelectedItem;
      if (_indexOfInstanceProperty(_context = _this.state.selectedKeys).call(_context, info.key) >= 0) {
        // deselect SubMenu child
        delete keyPathOfSelectedItem[info.key];
      } else {
        // select SubMenu child
        keyPathOfSelectedItem[info.key] = info.keyPath;
      }
      _this.setState({
        keyPathOfSelectedItem: keyPathOfSelectedItem
      });
    };
    _this.renderFilterIcon = function () {
      var _this$props = _this.props,
        column = _this$props.column,
        locale = _this$props.locale,
        prefixCls = _this$props.prefixCls;
      var filterd = _this.props.selectedKeys.length > 0;
      var filterIcon = column.filterIcon;
      if (typeof filterIcon === 'function') {
        filterIcon = filterIcon(filterd);
      }
      var dropdownSelectedClass = filterd ? "".concat(prefixCls, "-selected") : '';
      return filterIcon ? /*#__PURE__*/React.cloneElement(filterIcon, {
        title: locale.filterTitle,
        className: classNames("".concat(prefixCls, "-icon"), filterIcon.props.className)
      }) : /*#__PURE__*/React.createElement(Icon, {
        title: locale.filterTitle,
        type: "filter",
        className: dropdownSelectedClass
      });
    };
    var visible = 'filterDropdownVisible' in props.column ? props.column.filterDropdownVisible : false;
    _this.state = {
      selectedKeys: props.selectedKeys,
      keyPathOfSelectedItem: {},
      visible: visible,
      prevProps: props,
      neverShown: false
    };
    return _this;
  }
  _createClass(FilterMenu, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var column = this.props.column;
      this.setState({
        neverShown: this.getNeverShown(column)
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var column = this.props.column;
      var neverShown = this.getNeverShown(column);
      if (this.state.neverShown !== neverShown) {
        this.setState({
          neverShown: neverShown
        });
      }
    }
  }, {
    key: "setVisible",
    value: function setVisible(visible) {
      var column = this.props.column;
      if (!('filterDropdownVisible' in column)) {
        this.setState({
          visible: visible
        });
      }
      if (column.onFilterDropdownVisibleChange) {
        column.onFilterDropdownVisibleChange(visible);
      }
    }
  }, {
    key: "confirmFilter",
    value: function confirmFilter() {
      if (this.state.selectedKeys !== this.props.selectedKeys) {
        this.props.confirmFilter(this.props.column, this.state.selectedKeys);
      }
    }
  }, {
    key: "renderMenuItem",
    value: function renderMenuItem(item) {
      var column = this.props.column;
      var selectedKeys = this.state.selectedKeys;
      var multiple = 'filterMultiple' in column ? column.filterMultiple : true;
      var input = multiple ? /*#__PURE__*/React.createElement(Checkbox, {
        checked: _indexOfInstanceProperty(selectedKeys).call(selectedKeys, item.value.toString()) >= 0
      }) : /*#__PURE__*/React.createElement(Radio, {
        checked: _indexOfInstanceProperty(selectedKeys).call(selectedKeys, item.value.toString()) >= 0
      });
      return /*#__PURE__*/React.createElement(MenuItem, {
        key: item.value
      }, input, /*#__PURE__*/React.createElement("span", null, item.text));
    }
  }, {
    key: "hasSubMenu",
    value: function hasSubMenu() {
      var _this$props$column$fi = this.props.column.filters,
        filters = _this$props$column$fi === void 0 ? [] : _this$props$column$fi;
      return _someInstanceProperty(filters).call(filters, function (item) {
        return !!(item.children && item.children.length > 0);
      });
    }
  }, {
    key: "renderMenus",
    value: function renderMenus(items) {
      var _this2 = this;
      return _mapInstanceProperty(items).call(items, function (item) {
        if (item.children && item.children.length > 0) {
          var _context2;
          var keyPathOfSelectedItem = _this2.state.keyPathOfSelectedItem;
          var containSelected = _someInstanceProperty(_context2 = _Object$keys(keyPathOfSelectedItem)).call(_context2, function (key) {
            var _context3;
            return _indexOfInstanceProperty(_context3 = keyPathOfSelectedItem[key]).call(_context3, item.value) >= 0;
          });
          var subMenuCls = containSelected ? "".concat(_this2.props.dropdownPrefixCls, "-submenu-contain-selected") : '';
          return /*#__PURE__*/React.createElement(SubMenu, {
            title: item.text,
            className: subMenuCls,
            key: item.value.toString()
          }, _this2.renderMenus(item.children));
        }
        return _this2.renderMenuItem(item);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        column = _this$props2.column,
        locale = _this$props2.locale,
        prefixCls = _this$props2.prefixCls,
        dropdownPrefixCls = _this$props2.dropdownPrefixCls,
        getPopupContainer = _this$props2.getPopupContainer;
      // default multiple selection in filter dropdown
      var multiple = 'filterMultiple' in column ? column.filterMultiple : true;
      var dropdownMenuClass = classNames(_defineProperty({}, "".concat(dropdownPrefixCls, "-menu-without-submenu"), !this.hasSubMenu()));
      var filterDropdown = column.filterDropdown;
      if (filterDropdown && typeof filterDropdown === 'function') {
        filterDropdown = filterDropdown({
          prefixCls: "".concat(dropdownPrefixCls, "-custom"),
          setSelectedKeys: function setSelectedKeys(selectedKeys) {
            return _this3.setSelectedKeys({
              selectedKeys: selectedKeys
            });
          },
          selectedKeys: this.state.selectedKeys,
          confirm: this.handleConfirm,
          clearFilters: this.handleClearFilters,
          filters: column.filters,
          getPopupContainer: function getPopupContainer(triggerNode) {
            return triggerNode.parentNode;
          }
        });
      }
      var menus = filterDropdown ? /*#__PURE__*/React.createElement(FilterDropdownMenuWrapper, null, filterDropdown) : /*#__PURE__*/React.createElement(FilterDropdownMenuWrapper, {
        className: "".concat(prefixCls, "-dropdown")
      }, /*#__PURE__*/React.createElement(Menu, {
        multiple: multiple,
        onClick: this.handleMenuItemClick,
        prefixCls: "".concat(dropdownPrefixCls, "-menu"),
        className: dropdownMenuClass,
        onSelect: this.setSelectedKeys,
        onDeselect: this.setSelectedKeys,
        selectedKeys: this.state.selectedKeys,
        getPopupContainer: function getPopupContainer(triggerNode) {
          return triggerNode.parentNode;
        }
      }, this.renderMenus(column.filters)), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-dropdown-btns")
      }, /*#__PURE__*/React.createElement("a", {
        className: "".concat(prefixCls, "-dropdown-link clear"),
        onClick: this.handleClearFilters
      }, locale.filterReset), /*#__PURE__*/React.createElement("a", {
        className: "".concat(prefixCls, "-dropdown-link confirm"),
        onClick: this.handleConfirm
      }, locale.filterConfirm)));
      return /*#__PURE__*/React.createElement(Dropdown, {
        trigger: ['click'],
        overlay: menus,
        visible: this.state.neverShown ? false : this.state.visible,
        onVisibleChange: this.onVisibleChange,
        getPopupContainer: getPopupContainer,
        forceRender: true
      }, this.renderFilterIcon());
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      if ('selectedKeys' in nextProps && !shallowEqual(prevProps.selectedKeys, nextProps.selectedKeys)) {
        newState.selectedKeys = nextProps.selectedKeys;
      }
      var column = nextProps.column;
      if ('filterDropdownVisible' in column) {
        newState.visible = column.filterDropdownVisible;
      }
      return newState;
    }
  }]);
  return FilterMenu;
}(React.Component);
FilterMenu.defaultProps = {
  handleFilter: function handleFilter() {},
  column: {}
};
polyfill(FilterMenu);
export default FilterMenu;