import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _parseInt from "@babel/runtime-corejs3/core-js-stable/parse-int";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import { connect } from 'mini-store';
import classNames from 'classnames';
import ColGroup from './ColGroup';
import TableHeader from './TableHeader';
import TableRow from './TableRow';
import ExpandableRow from './ExpandableRow';
var BaseTable = /*#__PURE__*/function (_React$Component) {
  _inherits(BaseTable, _React$Component);
  var _super = _createSuper(BaseTable);
  function BaseTable() {
    var _this;
    _classCallCheck(this, BaseTable);
    _this = _super.apply(this, arguments);
    _this.handleRowHover = function (isHover, key) {
      _this.props.store.setState({
        currentHoverKey: isHover ? key : null
      });
    };
    _this.renderRows = function (renderData, indent) {
      var ancestorKeys = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
      var table = _this.context.table;
      var columnManager = table.columnManager,
        components = table.components;
      var _table$props = table.props,
        prefixCls = _table$props.prefixCls,
        activeRowByClick = _table$props.activeRowByClick,
        childrenColumnName = _table$props.childrenColumnName,
        rowClassName = _table$props.rowClassName,
        rowRef = _table$props.rowRef,
        onRowClick = _table$props.onRowClick,
        onRowDoubleClick = _table$props.onRowDoubleClick,
        onRowContextMenu = _table$props.onRowContextMenu,
        onRowMouseEnter = _table$props.onRowMouseEnter,
        onRowMouseLeave = _table$props.onRowMouseLeave,
        onRow = _table$props.onRow;
      var _this$props = _this.props,
        getRowKey = _this$props.getRowKey,
        fixed = _this$props.fixed,
        expander = _this$props.expander,
        isAnyColumnsFixed = _this$props.isAnyColumnsFixed;
      var rows = [];
      var _loop = function _loop(i) {
        var record = renderData[i];
        var key = getRowKey(record, i);
        var className = typeof rowClassName === 'string' ? rowClassName : rowClassName(record, i, indent);
        var onHoverProps = {};
        if (columnManager.isAnyColumnsFixed()) {
          onHoverProps.onHover = _this.handleRowHover;
        }
        var leafColumns;
        if (fixed === 'left') {
          leafColumns = columnManager.leftLeafColumns();
        } else if (fixed === 'right') {
          leafColumns = columnManager.rightLeafColumns();
        } else {
          leafColumns = _this.getColumns(columnManager.leafColumns());
        }
        var rowPrefixCls = "".concat(prefixCls, "-row");
        var row = /*#__PURE__*/React.createElement(ExpandableRow, _Object$assign({}, expander.props, {
          fixed: fixed,
          index: i,
          prefixCls: rowPrefixCls,
          record: record,
          key: key,
          rowKey: key,
          onRowClick: onRowClick,
          needIndentSpaced: expander.needIndentSpaced,
          onExpandedChange: expander.handleExpandChange
        }), function (expandableRow) {
          return /*#__PURE__*/React.createElement(TableRow, _Object$assign({
            fixed: fixed,
            indent: indent,
            className: className,
            activeRowByClick: activeRowByClick,
            record: record,
            index: i,
            prefixCls: rowPrefixCls,
            childrenColumnName: childrenColumnName,
            columns: leafColumns,
            onRow: onRow,
            onRowDoubleClick: onRowDoubleClick,
            onRowContextMenu: onRowContextMenu,
            onRowMouseEnter: onRowMouseEnter,
            onRowMouseLeave: onRowMouseLeave
          }, onHoverProps, {
            rowKey: key,
            ancestorKeys: ancestorKeys,
            ref: rowRef(record, i, indent),
            components: components,
            isAnyColumnsFixed: isAnyColumnsFixed
          }, expandableRow));
        });
        rows.push(row);
        expander.renderRows(_this.renderRows, rows, record, i, indent, fixed, key, ancestorKeys);
      };
      for (var i = 0; i < renderData.length; i++) {
        _loop(i);
      }
      return rows;
    };
    return _this;
  }
  _createClass(BaseTable, [{
    key: "getColumns",
    value: function getColumns(cols) {
      var _context;
      var _this$props2 = this.props,
        _this$props2$columns = _this$props2.columns,
        columns = _this$props2$columns === void 0 ? [] : _this$props2$columns,
        fixed = _this$props2.fixed;
      var table = this.context.table;
      var prefixCls = table.props.prefixCls;
      return _mapInstanceProperty(_context = cols || columns).call(_context, function (column) {
        return _Object$assign(_Object$assign({}, column), {
          className: !!column.fixed && !fixed ? classNames("".concat(prefixCls, "-fixed-columns-in-body"), column.className) : column.className
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var table = this.context.table;
      var components = table.components;
      var _table$props2 = table.props,
        prefixCls = _table$props2.prefixCls,
        scroll = _table$props2.scroll,
        data = _table$props2.data,
        getBodyWrapper = _table$props2.getBodyWrapper;
      var _this$props3 = this.props,
        expander = _this$props3.expander,
        tableClassName = _this$props3.tableClassName,
        hasHead = _this$props3.hasHead,
        hasBody = _this$props3.hasBody,
        fixed = _this$props3.fixed;
      var tableStyle = {};
      if (!fixed && scroll.x) {
        // not set width, then use content fixed width
        if (scroll.x === true) {
          tableStyle.tableLayout = 'fixed';
        } else {
          tableStyle.width = scroll.x;
        }
      }
      var Table = hasBody ? components.table : 'table';
      var BodyWrapper = components.body.wrapper;
      var body;
      if (hasBody) {
        body = /*#__PURE__*/React.createElement(BodyWrapper, {
          className: "".concat(prefixCls, "-tbody")
        }, this.renderRows(data, 0));
        if (getBodyWrapper) {
          body = getBodyWrapper(body);
        }
      }
      var columns = this.getColumns();
      // ellipsis-column 添加 fixed支持
      if (_someInstanceProperty(columns).call(columns, function (column) {
        return column.ellipsis;
      })) {
        tableStyle.tableLayout = 'fixed';
        // 左右 fixed Table 添加宽度
        if (fixed) {
          var columnsWidthTotal = _reduceInstanceProperty(columns).call(columns, function (a, b) {
            return a + _parseInt(b.width);
          }, 0);
          columnsWidthTotal && (tableStyle.width = columnsWidthTotal);
        }
      }
      return /*#__PURE__*/React.createElement(Table, {
        className: tableClassName,
        style: tableStyle,
        key: "table"
      }, /*#__PURE__*/React.createElement(ColGroup, {
        columns: columns,
        fixed: fixed
      }), hasHead && /*#__PURE__*/React.createElement(TableHeader, {
        expander: expander,
        columns: columns,
        fixed: fixed
      }), body);
    }
  }]);
  return BaseTable;
}(React.Component);
BaseTable.propTypes = {
  fixed: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  columns: PropTypes.array.isRequired,
  tableClassName: PropTypes.string.isRequired,
  hasHead: PropTypes.bool.isRequired,
  hasBody: PropTypes.bool.isRequired,
  store: PropTypes.object.isRequired,
  expander: PropTypes.object.isRequired,
  activeRowByClick: PropTypes.func,
  getRowKey: PropTypes.func,
  isAnyColumnsFixed: PropTypes.bool
};
BaseTable.contextTypes = {
  table: PropTypes.any
};
export default connect()(BaseTable);