import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import React from 'react';
import PropTypes from 'prop-types';
export default function ColGroup(props, _ref) {
  var table = _ref.table;
  var _table$props = table.props,
    prefixCls = _table$props.prefixCls,
    expandIconAsCell = _table$props.expandIconAsCell;
  var fixed = props.fixed;
  var cols = [];
  if (expandIconAsCell && fixed !== 'right') {
    cols.push( /*#__PURE__*/React.createElement("col", {
      className: "".concat(prefixCls, "-expand-icon-col"),
      key: "rc-table-expand-icon-col"
    }));
  }
  var leafColumns;
  if (fixed === 'left') {
    leafColumns = table.columnManager.leftLeafColumns();
  } else if (fixed === 'right') {
    leafColumns = table.columnManager.rightLeafColumns();
  } else {
    leafColumns = table.columnManager.leafColumns();
  }
  cols = _concatInstanceProperty(cols).call(cols, _mapInstanceProperty(leafColumns).call(leafColumns, function (c) {
    return /*#__PURE__*/React.createElement("col", {
      key: c.key || c.dataIndex,
      style: {
        width: c.width,
        minWidth: c.width
      }
    });
  }));
  return /*#__PURE__*/React.createElement("colgroup", null, cols);
}
ColGroup.propTypes = {
  fixed: PropTypes.string
};
ColGroup.contextTypes = {
  table: PropTypes.any
};