import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import get from 'lodash/get';
import Ellipsis from '../../Ellipsis';
function isInvalidRenderCellText(text) {
  return text && ! /*#__PURE__*/React.isValidElement(text) && Object.prototype.toString.call(text) === '[object Object]';
}
var TableCell = /*#__PURE__*/function (_React$Component) {
  _inherits(TableCell, _React$Component);
  var _super = _createSuper(TableCell);
  function TableCell() {
    var _this;
    _classCallCheck(this, TableCell);
    _this = _super.apply(this, arguments);
    _this.handleClick = function (e) {
      var _this$props = _this.props,
        record = _this$props.record,
        onCellClick = _this$props.column.onCellClick;
      if (onCellClick) {
        onCellClick(record, e);
      }
    };
    return _this;
  }
  _createClass(TableCell, [{
    key: "render",
    value: function render() {
      var _context;
      var _this$props2 = this.props,
        record = _this$props2.record,
        indentSize = _this$props2.indentSize,
        prefixCls = _this$props2.prefixCls,
        indent = _this$props2.indent,
        index = _this$props2.index,
        expandIcon = _this$props2.expandIcon,
        column = _this$props2.column,
        BodyCell = _this$props2.component;
      var dataIndex = column.dataIndex,
        render = column.render,
        _column$className = column.className,
        className = _column$className === void 0 ? '' : _column$className;
      // We should return undefined if no dataIndex is specified, but in order to
      // be compatible with object-path's behavior, we return the record object instead.
      var text;
      if (typeof dataIndex === 'number') {
        text = get(record, dataIndex);
      } else if (!dataIndex || dataIndex.length === 0) {
        text = record;
      } else {
        text = get(record, dataIndex);
      }
      var tdProps = {};
      var colSpan;
      var rowSpan;
      if (render) {
        text = render(text, record, index);
        if (isInvalidRenderCellText(text)) {
          tdProps = text.props || tdProps;
          colSpan = tdProps.colSpan;
          rowSpan = tdProps.rowSpan;
          text = text.children;
        }
      }
      if (column.onCell) {
        tdProps = _Object$assign(_Object$assign({}, tdProps), column.onCell(record, index));
      }
      // Fix https://github.com/ant-design/ant-design/issues/1202
      if (isInvalidRenderCellText(text)) {
        text = null;
      }
      var indentText = expandIcon ? /*#__PURE__*/React.createElement("span", {
        style: {
          paddingLeft: "".concat(indentSize * indent, "px")
        },
        className: _concatInstanceProperty(_context = "".concat(prefixCls, "-indent indent-level-")).call(_context, indent)
      }) : null;
      if (rowSpan === 0 || colSpan === 0) {
        return null;
      }
      if (column.align) {
        tdProps.style = _Object$assign(_Object$assign({}, tdProps.style), {
          textAlign: column.align
        });
      }
      if (column.ellipsis) {
        text = /*#__PURE__*/React.createElement(Ellipsis, {
          width: '100%',
          style: {
            position: 'relative',
            top: '3px'
          }
        }, text);
      }
      return /*#__PURE__*/React.createElement(BodyCell, _Object$assign({
        className: className,
        onClick: this.handleClick
      }, tdProps), indentText, expandIcon, text);
    }
  }]);
  return TableCell;
}(React.Component);
export { TableCell as default };
TableCell.propTypes = {
  record: PropTypes.object,
  prefixCls: PropTypes.string,
  index: PropTypes.number,
  indent: PropTypes.number,
  indentSize: PropTypes.number,
  column: PropTypes.object,
  expandIcon: PropTypes.node,
  component: PropTypes.oneOfType([PropTypes.func, PropTypes.node, PropTypes.string])
};