import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import PropTypes from 'prop-types';
import { connect } from 'mini-store';
import classNames from 'classnames';
function TableHeaderRow(_ref) {
  var row = _ref.row,
    index = _ref.index,
    height = _ref.height,
    components = _ref.components,
    onHeaderRow = _ref.onHeaderRow,
    prefixCls = _ref.prefixCls;
  var HeaderRow = components.header.row;
  var HeaderCell = components.header.cell;
  var rowProps = onHeaderRow(_mapInstanceProperty(row).call(row, function (cell) {
    return cell.column;
  }), index);
  var customStyle = rowProps ? rowProps.style : {};
  var style = _Object$assign({
    height: height
  }, customStyle);
  return /*#__PURE__*/React.createElement(HeaderRow, _Object$assign({}, rowProps, {
    style: style
  }), _mapInstanceProperty(row).call(row, function (cell, i) {
    var column = cell.column,
      cellProps = __rest(cell, ["column"]);
    var customProps = column.onHeaderCell ? column.onHeaderCell(column) : {};
    if (column.align) {
      var _context;
      customProps.style = _Object$assign(_Object$assign({}, customProps.style), {
        textAlign: column.align
      });
      customProps.className = classNames(customProps.className, column.className, _defineProperty({}, _concatInstanceProperty(_context = "".concat(prefixCls, "-align-")).call(_context, column.align), !!column.align));
    }
    return /*#__PURE__*/React.createElement(HeaderCell, _Object$assign({}, cellProps, customProps, {
      key: column.key || column.dataIndex || i
    }));
  }));
}
TableHeaderRow.propTypes = {
  row: PropTypes.array,
  index: PropTypes.number,
  prefixCls: PropTypes.string,
  height: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  components: PropTypes.shape({
    table: PropTypes.any,
    header: PropTypes.shape({
      wrapper: PropTypes.any,
      row: PropTypes.any,
      cell: PropTypes.any
    }),
    body: PropTypes.shape({
      wrapper: PropTypes.any,
      row: PropTypes.any,
      cell: PropTypes.any
    })
  }),
  onHeaderRow: PropTypes.func
};
function getRowHeight(state, props) {
  var fixedColumnsHeadRowsHeight = state.fixedColumnsHeadRowsHeight;
  var columns = props.columns,
    rows = props.rows,
    fixed = props.fixed;
  var headerHeight = fixedColumnsHeadRowsHeight[0];
  if (!fixed) {
    return null;
  }
  if (headerHeight && columns) {
    if (headerHeight === 'auto') {
      return 'auto';
    }
    return headerHeight / rows.length;
  }
  return null;
}
export default connect(function (state, props) {
  return {
    height: getRowHeight(state, props)
  };
})(TableHeaderRow);