import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _everyInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/every";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import { connect } from 'mini-store';
import { polyfill } from 'react-lifecycles-compat';
import classNames from 'classnames';
import TableCell from './TableCell';
import { warningOnce } from './utils';
var noop = function noop() {};
var TableRow = /*#__PURE__*/function (_React$Component) {
  _inherits(TableRow, _React$Component);
  var _super = _createSuper(TableRow);
  function TableRow(props) {
    var _this;
    _classCallCheck(this, TableRow);
    _this = _super.call(this, props);
    _this.onRowClick = function (event) {
      var _this$props = _this.props,
        store = _this$props.store,
        record = _this$props.record,
        index = _this$props.index,
        onRowClick = _this$props.onRowClick,
        activeRowByClick = _this$props.activeRowByClick,
        rowKey = _this$props.rowKey;
      // 点击高亮功能
      activeRowByClick && store.setState({
        currentClickedKey: rowKey
      });
      if (onRowClick) {
        onRowClick(record, index, event);
      }
    };
    _this.onRowDoubleClick = function (event) {
      var _this$props2 = _this.props,
        record = _this$props2.record,
        index = _this$props2.index,
        onRowDoubleClick = _this$props2.onRowDoubleClick;
      if (onRowDoubleClick) {
        onRowDoubleClick(record, index, event);
      }
    };
    _this.onContextMenu = function (event) {
      var _this$props3 = _this.props,
        record = _this$props3.record,
        index = _this$props3.index,
        onRowContextMenu = _this$props3.onRowContextMenu;
      if (onRowContextMenu) {
        onRowContextMenu(record, index, event);
      }
    };
    _this.onMouseEnter = function (event) {
      var _this$props4 = _this.props,
        record = _this$props4.record,
        index = _this$props4.index,
        onRowMouseEnter = _this$props4.onRowMouseEnter,
        onHover = _this$props4.onHover,
        rowKey = _this$props4.rowKey;
      onHover(true, rowKey);
      if (onRowMouseEnter) {
        onRowMouseEnter(record, index, event);
      }
    };
    _this.onMouseLeave = function (event) {
      var _this$props5 = _this.props,
        record = _this$props5.record,
        index = _this$props5.index,
        onRowMouseLeave = _this$props5.onRowMouseLeave,
        onHover = _this$props5.onHover,
        rowKey = _this$props5.rowKey;
      onHover(false, rowKey);
      if (onRowMouseLeave) {
        onRowMouseLeave(record, index, event);
      }
    };
    _this.shouldRender = props.visible;
    _this.state = {};
    return _this;
  }
  _createClass(TableRow, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.state.shouldRender) {
        this.saveRowRef();
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return !!(this.props.visible || nextProps.visible);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.state.shouldRender && !this.rowRef) {
        this.saveRowRef();
      }
    }
  }, {
    key: "setExpanedRowHeight",
    value: function setExpanedRowHeight() {
      var _this$props6 = this.props,
        store = _this$props6.store,
        rowKey = _this$props6.rowKey;
      var _store$getState = store.getState(),
        expandedRowsHeight = _store$getState.expandedRowsHeight;
      var height = this.rowRef.getBoundingClientRect().height;
      expandedRowsHeight = _Object$assign(_Object$assign({}, expandedRowsHeight), _defineProperty({}, rowKey, height));
      store.setState({
        expandedRowsHeight: expandedRowsHeight
      });
    }
  }, {
    key: "setRowHeight",
    value: function setRowHeight() {
      var _this$props7 = this.props,
        store = _this$props7.store,
        rowKey = _this$props7.rowKey;
      var _store$getState2 = store.getState(),
        fixedColumnsBodyRowsHeight = _store$getState2.fixedColumnsBodyRowsHeight;
      var height = this.rowRef.getBoundingClientRect().height;
      store.setState({
        fixedColumnsBodyRowsHeight: _Object$assign(_Object$assign({}, fixedColumnsBodyRowsHeight), _defineProperty({}, rowKey, height))
      });
    }
  }, {
    key: "getStyle",
    value: function getStyle() {
      var _this$props8 = this.props,
        height = _this$props8.height,
        visible = _this$props8.visible;
      if (height && height !== this.style.height) {
        this.style = _Object$assign(_Object$assign({}, this.style), {
          height: height
        });
      }
      if (!visible && !this.style.display) {
        this.style = _Object$assign(_Object$assign({}, this.style), {
          display: 'none'
        });
      }
      return this.style;
    }
  }, {
    key: "saveRowRef",
    value: function saveRowRef() {
      this.rowRef = ReactDOM.findDOMNode(this);
      var _this$props9 = this.props,
        isAnyColumnsFixed = _this$props9.isAnyColumnsFixed,
        fixed = _this$props9.fixed,
        expandedRow = _this$props9.expandedRow,
        ancestorKeys = _this$props9.ancestorKeys;
      if (!isAnyColumnsFixed) {
        return;
      }
      if (!fixed && expandedRow) {
        this.setExpanedRowHeight();
      }
      if (!fixed && ancestorKeys.length >= 0) {
        this.setRowHeight();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _context;
      if (!this.state.shouldRender) {
        return null;
      }
      var _this$props10 = this.props,
        prefixCls = _this$props10.prefixCls,
        columns = _this$props10.columns,
        record = _this$props10.record,
        rowKey = _this$props10.rowKey,
        index = _this$props10.index,
        onRow = _this$props10.onRow,
        indent = _this$props10.indent,
        indentSize = _this$props10.indentSize,
        hovered = _this$props10.hovered,
        clicked = _this$props10.clicked,
        height = _this$props10.height,
        visible = _this$props10.visible,
        components = _this$props10.components,
        hasExpandIcon = _this$props10.hasExpandIcon,
        renderExpandIcon = _this$props10.renderExpandIcon,
        renderExpandIconCell = _this$props10.renderExpandIconCell;
      var BodyRow = components.body.row;
      var BodyCell = components.body.cell;
      var className = this.props.className;
      if (hovered) {
        className += " ".concat(prefixCls, "-hover");
      }
      if (clicked) {
        className += " ".concat(prefixCls, "-click");
      }
      var cells = [];
      renderExpandIconCell(cells);
      for (var i = 0; i < columns.length; i++) {
        var column = columns[i];
        warningOnce(column.onCellClick === undefined, 'column[onCellClick] is deprecated, please use column[onCell] instead.');
        cells.push( /*#__PURE__*/React.createElement(TableCell, {
          prefixCls: prefixCls,
          record: record,
          indentSize: indentSize,
          indent: indent,
          index: index,
          column: column,
          key: column.key || column.dataIndex,
          expandIcon: hasExpandIcon(i) && renderExpandIcon(),
          component: BodyCell
        }));
      }
      var _a = onRow(record, index) || {},
        customClassName = _a.className,
        customStyle = _a.style,
        rowProps = __rest(_a, ["className", "style"]);
      var style = {
        height: height
      };
      if (!visible) {
        style.display = 'none';
      }
      style = _Object$assign(_Object$assign({}, style), customStyle);
      var rowClassName = classNames(prefixCls, className, _concatInstanceProperty(_context = "".concat(prefixCls, "-level-")).call(_context, indent), customClassName);
      return /*#__PURE__*/React.createElement(BodyRow, _Object$assign({
        onClick: this.onRowClick,
        onDoubleClick: this.onRowDoubleClick,
        onMouseEnter: this.onMouseEnter,
        onMouseLeave: this.onMouseLeave,
        onContextMenu: this.onContextMenu
      }, rowProps, {
        className: rowClassName,
        style: style,
        "data-row-key": rowKey
      }), cells);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (prevState.visible || !prevState.visible && nextProps.visible) {
        return {
          shouldRender: true,
          visible: nextProps.visible
        };
      }
      return {
        visible: nextProps.visible
      };
    }
  }]);
  return TableRow;
}(React.Component);
TableRow.propTypes = {
  onRow: PropTypes.func,
  onRowClick: PropTypes.func,
  onRowDoubleClick: PropTypes.func,
  onRowContextMenu: PropTypes.func,
  onRowMouseEnter: PropTypes.func,
  onRowMouseLeave: PropTypes.func,
  record: PropTypes.object,
  prefixCls: PropTypes.string,
  onHover: PropTypes.func,
  columns: PropTypes.array,
  activeRowByClick: PropTypes.bool,
  height: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  index: PropTypes.number,
  rowKey: PropTypes.oneOfType([PropTypes.string, PropTypes.number]).isRequired,
  className: PropTypes.string,
  indent: PropTypes.number,
  indentSize: PropTypes.number,
  hasExpandIcon: PropTypes.func,
  hovered: PropTypes.bool.isRequired,
  clicked: PropTypes.bool.isRequired,
  visible: PropTypes.bool.isRequired,
  store: PropTypes.object.isRequired,
  fixed: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  renderExpandIcon: PropTypes.func,
  renderExpandIconCell: PropTypes.func,
  components: PropTypes.shape({
    table: PropTypes.any,
    header: PropTypes.shape({
      wrapper: PropTypes.any,
      row: PropTypes.any,
      cell: PropTypes.any
    }),
    body: PropTypes.shape({
      wrapper: PropTypes.any,
      row: PropTypes.any,
      cell: PropTypes.any
    })
  }),
  expandedRow: PropTypes.bool,
  isAnyColumnsFixed: PropTypes.bool,
  ancestorKeys: PropTypes.array.isRequired
};
TableRow.defaultProps = {
  onRow: noop,
  onHover: noop,
  hasExpandIcon: noop,
  renderExpandIcon: noop,
  renderExpandIconCell: noop
};
function getRowHeight(state, props) {
  var expandedRowsHeight = state.expandedRowsHeight,
    fixedColumnsBodyRowsHeight = state.fixedColumnsBodyRowsHeight;
  var fixed = props.fixed,
    rowKey = props.rowKey;
  if (!fixed) {
    return null;
  }
  if (expandedRowsHeight[rowKey]) {
    return expandedRowsHeight[rowKey];
  }
  if (fixedColumnsBodyRowsHeight[rowKey]) {
    return fixedColumnsBodyRowsHeight[rowKey];
  }
  return null;
}
polyfill(TableRow);
export default connect(function (state, props) {
  var currentHoverKey = state.currentHoverKey,
    currentClickedKey = state.currentClickedKey,
    expandedRowKeys = state.expandedRowKeys;
  var rowKey = props.rowKey,
    ancestorKeys = props.ancestorKeys;
  var visible = ancestorKeys.length === 0 || _everyInstanceProperty(ancestorKeys).call(ancestorKeys, function (k) {
    return ~_indexOfInstanceProperty(expandedRowKeys).call(expandedRowKeys, k);
  });
  return {
    visible: visible,
    hovered: currentHoverKey === rowKey,
    clicked: currentClickedKey === rowKey,
    height: getRowHeight(state, props)
  };
})(TableRow);