import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import * as React from 'react';
export function flatArray() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var childrenName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'children';
  var result = [];
  var loop = function loop(array) {
    _forEachInstanceProperty(array).call(array, function (item) {
      if (item[childrenName]) {
        var newItem = _Object$assign({}, item);
        delete newItem[childrenName];
        result.push(newItem);
        if (item[childrenName].length > 0) {
          loop(item[childrenName]);
        }
      } else {
        result.push(item);
      }
    });
  };
  loop(data);
  return result;
}
export function treeMap(tree, mapper) {
  var childrenName = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'children';
  return _mapInstanceProperty(tree).call(tree, function (node, index) {
    var extra = {};
    if (node[childrenName]) {
      extra[childrenName] = treeMap(node[childrenName], mapper, childrenName);
    }
    return _Object$assign(_Object$assign({}, mapper(node, index)), extra);
  });
}
export function flatFilter(tree, callback) {
  return _reduceInstanceProperty(tree).call(tree, function (acc, node) {
    if (callback(node)) {
      acc.push(node);
    }
    if (node.children) {
      var children = flatFilter(node.children, callback);
      acc.push.apply(acc, _toConsumableArray(children));
    }
    return acc;
  }, []);
}
export function normalizeColumns(elements) {
  var _context;
  var columns = [];
  _forEachInstanceProperty(_context = React.Children).call(_context, elements, function (element) {
    if (! /*#__PURE__*/React.isValidElement(element)) {
      return;
    }
    var column = _Object$assign({}, element.props);
    if (element.key) {
      column.key = element.key;
    }
    if (element.type && element.type.__FISHD_TABLE_COLUMN_GROUP) {
      column.children = normalizeColumns(column.children);
    }
    columns.push(column);
  });
  return columns;
}