import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import { findDOMNode } from 'react-dom';
import RcTabs, { TabPane, TabContent, ScrollableInkTabBar } from './src/index.js';
import classNames from 'classnames';
import Icon from '../Icon';
import './style/index.less';
function isFlexSupported() {
  if (typeof window !== 'undefined' && window.document && window.document.documentElement) {
    var documentElement = window.document.documentElement;
    return 'flex' in documentElement.style || 'webkitFlex' in documentElement.style || 'Flex' in documentElement.style || 'msFlex' in documentElement.style;
  }
  return false;
}
var Tabs = /*#__PURE__*/function (_React$Component) {
  _inherits(Tabs, _React$Component);
  var _super = _createSuper(Tabs);
  function Tabs() {
    var _this;
    _classCallCheck(this, Tabs);
    _this = _super.apply(this, arguments);
    _this.createNewTab = function (targetKey) {
      var onEdit = _this.props.onEdit;
      if (onEdit) {
        onEdit(targetKey, 'add');
      }
    };
    _this.removeTab = function (targetKey, e) {
      e.stopPropagation();
      if (!targetKey) {
        return;
      }
      var onEdit = _this.props.onEdit;
      if (onEdit) {
        onEdit(targetKey, 'remove');
      }
    };
    _this.handleChange = function (activeKey) {
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange(activeKey);
      }
    };
    return _this;
  }
  _createClass(Tabs, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _context;
      var NO_FLEX = ' no-flex';
      var tabNode = findDOMNode(this);
      if (tabNode && !isFlexSupported() && _indexOfInstanceProperty(_context = tabNode.className).call(_context, NO_FLEX) === -1) {
        tabNode.className += NO_FLEX;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _context2,
        _context3,
        _classNames,
        _this2 = this;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        _this$props$className = _this$props.className,
        className = _this$props$className === void 0 ? '' : _this$props$className,
        size = _this$props.size,
        type = _this$props.type,
        tabPosition = _this$props.tabPosition,
        children = _this$props.children,
        tabBarExtraContent = _this$props.tabBarExtraContent,
        tabBarStyle = _this$props.tabBarStyle,
        hideAdd = _this$props.hideAdd,
        loading = _this$props.loading,
        onTabClick = _this$props.onTabClick,
        onPrevClick = _this$props.onPrevClick,
        onNextClick = _this$props.onNextClick,
        animated = _this$props.animated,
        tabBarGutter = _this$props.tabBarGutter;
      var _ref = _typeof(animated) === 'object' ? {
          inkBarAnimated: animated.inkBar,
          tabPaneAnimated: animated.tabPane
        } : {
          inkBarAnimated: animated,
          tabPaneAnimated: animated
        },
        inkBarAnimated = _ref.inkBarAnimated,
        tabPaneAnimated = _ref.tabPaneAnimated;
      var showInkBar = true;
      // card tabs should not have animation
      if (type !== 'line') {
        showInkBar = false;
        tabPaneAnimated = 'animated' in this.props ? tabPaneAnimated : false;
      }
      var cls = classNames(className, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-vertical"), tabPosition === 'left' || tabPosition === 'right'), _defineProperty(_classNames, _concatInstanceProperty(_context2 = "".concat(prefixCls, "-")).call(_context2, size), !!size), _defineProperty(_classNames, "".concat(prefixCls, "-card"), _indexOfInstanceProperty(type).call(type, 'card') >= 0), _defineProperty(_classNames, _concatInstanceProperty(_context3 = "".concat(prefixCls, "-")).call(_context3, type), true), _defineProperty(_classNames, "".concat(prefixCls, "-no-animation"), !tabPaneAnimated), _classNames));
      // only card type tabs can be added and closed
      var childrenWithClose = [];
      if (type === 'editable-card') {
        var _context4;
        childrenWithClose = [];
        _forEachInstanceProperty(_context4 = React.Children).call(_context4, children, function (child, index) {
          var closable = child.props.closable;
          closable = typeof closable === 'undefined' ? true : closable;
          var closeIcon = closable ? /*#__PURE__*/React.createElement(Icon, {
            type: "close-tag-line",
            onClick: function onClick(e) {
              return _this2.removeTab(child.key, e);
            }
          }) : null;
          childrenWithClose.push( /*#__PURE__*/React.cloneElement(child, {
            tab: /*#__PURE__*/React.createElement("div", {
              className: closable ? undefined : "".concat(prefixCls, "-tab-unclosable")
            }, child.props.tab, closeIcon),
            key: child.key || index
          }));
        });
        // Add new tab handler
        if (!hideAdd) {
          tabBarExtraContent = /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Icon, {
            type: "upload-plus",
            className: "".concat(prefixCls, "-new-tab"),
            onClick: this.createNewTab
          }), tabBarExtraContent);
        }
      }
      tabBarExtraContent = tabBarExtraContent ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-extra-content")
      }, tabBarExtraContent) : null;
      var renderTabBar = function renderTabBar() {
        return /*#__PURE__*/React.createElement(ScrollableInkTabBar, {
          showInkBar: showInkBar,
          inkBarAnimated: inkBarAnimated,
          extraContent: tabBarExtraContent,
          onTabClick: onTabClick,
          onPrevClick: onPrevClick,
          onNextClick: onNextClick,
          style: tabBarStyle,
          tabBarGutter: tabBarGutter
        });
      };
      return /*#__PURE__*/React.createElement(RcTabs, _Object$assign({}, this.props, {
        className: cls,
        tabBarPosition: tabPosition,
        renderTabBar: renderTabBar,
        renderTabContent: function renderTabContent() {
          return /*#__PURE__*/React.createElement(TabContent, {
            animated: tabPaneAnimated,
            animatedWithMargin: true,
            loading: loading
          });
        },
        onChange: this.handleChange
      }), childrenWithClose.length > 0 ? childrenWithClose : children);
    }
  }]);
  return Tabs;
}(React.Component);
export { Tabs as default };
Tabs.TabPane = TabPane;
Tabs.defaultProps = {
  prefixCls: 'fishd-tabs',
  hideAdd: false,
  loading: false,
  size: 'default',
  tabPosition: 'top',
  type: 'line'
};