import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import * as React from 'react';
import { cloneElement } from 'react';
import RcTooltip from './RcTooltip';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import _getPlacements from './placements';
import './style/index.less';
var splitObject = function splitObject(obj, keys) {
  var picked = {};
  var omitted = _Object$assign({}, obj);
  _forEachInstanceProperty(keys).call(keys, function (key) {
    if (obj && key in obj) {
      picked[key] = obj[key];
      delete omitted[key];
    }
  });
  return {
    picked: picked,
    omitted: omitted
  };
};
var Tooltip = /*#__PURE__*/function (_React$Component) {
  _inherits(Tooltip, _React$Component);
  var _super = _createSuper(Tooltip);
  function Tooltip(props) {
    var _this;
    _classCallCheck(this, Tooltip);
    _this = _super.call(this, props);
    _this.onVisibleChange = function (visible) {
      var onVisibleChange = _this.props.onVisibleChange;
      if (!('visible' in _this.props)) {
        _this.setState({
          visible: _this.isNoTitle() ? false : visible
        });
      }
      if (onVisibleChange && !_this.isNoTitle()) {
        onVisibleChange(visible);
      }
    };
    // 动态设置动画点
    _this.onPopupAlign = function (domNode, align) {
      var _context, _context2;
      var placements = _this.getPlacements();
      // 当前返回的位置
      var placement = _filterInstanceProperty(_context = _Object$keys(placements)).call(_context, function (key) {
        return placements[key].points[0] === align.points[0] && placements[key].points[1] === align.points[1];
      })[0];
      if (!placement) {
        return;
      }
      // 根据当前坐标设置动画点
      var rect = domNode.getBoundingClientRect();
      var transformOrigin = {
        top: '50%',
        left: '50%'
      };
      if (_indexOfInstanceProperty(placement).call(placement, 'top') >= 0 || _indexOfInstanceProperty(placement).call(placement, 'Bottom') >= 0) {
        transformOrigin.top = "".concat(rect.height - align.offset[1], "px");
      } else if (_indexOfInstanceProperty(placement).call(placement, 'Top') >= 0 || _indexOfInstanceProperty(placement).call(placement, 'bottom') >= 0) {
        transformOrigin.top = "".concat(-align.offset[1], "px");
      }
      if (_indexOfInstanceProperty(placement).call(placement, 'left') >= 0 || _indexOfInstanceProperty(placement).call(placement, 'Right') >= 0) {
        transformOrigin.left = "".concat(rect.width - align.offset[0], "px");
      } else if (_indexOfInstanceProperty(placement).call(placement, 'right') >= 0 || _indexOfInstanceProperty(placement).call(placement, 'Left') >= 0) {
        transformOrigin.left = "".concat(-align.offset[0], "px");
      }
      domNode.style.transformOrigin = _concatInstanceProperty(_context2 = "".concat(transformOrigin.left, " ")).call(_context2, transformOrigin.top);
    };
    _this.saveTooltip = function (node) {
      _this.tooltip = node;
    };
    _this.state = {
      visible: !!props.visible || !!props.defaultVisible
    };
    return _this;
  }
  _createClass(Tooltip, [{
    key: "getPopupDomNode",
    value: function getPopupDomNode() {
      return this.tooltip.getPopupDomNode();
    }
  }, {
    key: "getPlacements",
    value: function getPlacements() {
      var _this$props = this.props,
        builtinPlacements = _this$props.builtinPlacements,
        arrowPointAtCenter = _this$props.arrowPointAtCenter,
        autoAdjustOverflow = _this$props.autoAdjustOverflow;
      return builtinPlacements || _getPlacements({
        arrowPointAtCenter: arrowPointAtCenter,
        verticalArrowShift: 8,
        autoAdjustOverflow: autoAdjustOverflow
      });
    }
  }, {
    key: "isHoverTrigger",
    value: function isHoverTrigger() {
      var trigger = this.props.trigger;
      if (!trigger || trigger === 'hover') {
        return true;
      }
      if (_Array$isArray(trigger)) {
        return _indexOfInstanceProperty(trigger).call(trigger, 'hover') >= 0;
      }
      return false;
    }
    // Fix Tooltip won't hide at disabled button
    // mouse events don't trigger at disabled button in Chrome
    // https://github.com/react-component/tooltip/issues/18
  }, {
    key: "getDisabledCompatibleChildren",
    value: function getDisabledCompatibleChildren(element) {
      if ((element.type.__FISHD_BUTTON || element.type === 'button') && element.props.disabled && this.isHoverTrigger()) {
        // Pick some layout related style properties up to span
        // Prevent layout bugs like https://github.com/ant-design/ant-design/issues/5254
        var _splitObject = splitObject(element.props.style, ['position', 'left', 'right', 'top', 'bottom', 'float', 'display', 'zIndex']),
          picked = _splitObject.picked,
          omitted = _splitObject.omitted;
        var spanStyle = _Object$assign(_Object$assign({
          display: 'inline-block'
        }, picked), {
          cursor: 'not-allowed'
        });
        var buttonStyle = _Object$assign(_Object$assign({}, omitted), {
          pointerEvents: 'none'
        });
        var child = /*#__PURE__*/cloneElement(element, {
          style: buttonStyle,
          className: null
        });
        return /*#__PURE__*/React.createElement("span", {
          style: spanStyle,
          className: element.props.className
        }, child);
      }
      return element;
    }
  }, {
    key: "isNoTitle",
    value: function isNoTitle() {
      var _this$props2 = this.props,
        title = _this$props2.title,
        overlay = _this$props2.overlay;
      return !title && !overlay; // overlay for old version compatibility
    }
  }, {
    key: "render",
    value: function render() {
      var props = this.props,
        state = this.state;
      var prefixCls = props.prefixCls,
        title = props.title,
        overlay = props.overlay,
        openClassName = props.openClassName,
        getPopupContainer = props.getPopupContainer,
        getTooltipContainer = props.getTooltipContainer;
      var children = props.children;
      var visible = state.visible;
      // Hide tooltip when there is no title
      if (!('visible' in props) && this.isNoTitle()) {
        visible = false;
      }
      var child = this.getDisabledCompatibleChildren( /*#__PURE__*/React.isValidElement(children) ? children : /*#__PURE__*/React.createElement("span", null, children));
      var childProps = child.props;
      var childCls = classNames(childProps.className, _defineProperty({}, openClassName || "".concat(prefixCls, "-open"), true));
      return /*#__PURE__*/React.createElement(RcTooltip, _Object$assign({}, this.props, {
        getTooltipContainer: getPopupContainer || getTooltipContainer,
        ref: this.saveTooltip,
        builtinPlacements: this.getPlacements(),
        overlay: overlay || title || '',
        visible: visible,
        onVisibleChange: this.onVisibleChange,
        onPopupAlign: this.onPopupAlign
      }), visible ? /*#__PURE__*/cloneElement(child, {
        className: childCls
      }) : child);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      if ('visible' in nextProps) {
        return {
          visible: nextProps.visible
        };
      }
      return null;
    }
  }]);
  return Tooltip;
}(React.Component);
Tooltip.defaultProps = {
  prefixCls: 'fishd-tooltip',
  placement: 'top',
  transitionName: 'zoom-big-fast',
  mouseEnterDelay: 0.1,
  mouseLeaveDelay: 0.1,
  arrowPointAtCenter: false,
  autoAdjustOverflow: true
};
polyfill(Tooltip);
export default Tooltip;