import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _Array$from from "@babel/runtime-corejs3/core-js-stable/array/from";
import _Set from "@babel/runtime-corejs3/core-js-stable/set";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import classNames from 'classnames';
import omit from 'omit.js';
import debounce from 'lodash/debounce';
import { polyfill } from 'react-lifecycles-compat';
import { conductExpandParent, convertTreeToEntities } from '../TreeSelect/rcTree/util';
import Tree from './Tree';
import { calcRangeKeys, getFullKeyList } from './util';
import Icon from '../Icon';
function getIcon(props) {
  var isLeaf = props.isLeaf,
    expanded = props.expanded;
  if (isLeaf) {
    return /*#__PURE__*/React.createElement(Icon, {
      type: "file-line"
    });
  }
  return /*#__PURE__*/React.createElement(Icon, {
    type: expanded ? 'folder-open-line' : 'folder-close-line'
  });
}
var DirectoryTree = /*#__PURE__*/function (_React$Component) {
  _inherits(DirectoryTree, _React$Component);
  var _super = _createSuper(DirectoryTree);
  function DirectoryTree(props) {
    var _this;
    _classCallCheck(this, DirectoryTree);
    _this = _super.call(this, props);
    _this.onExpand = function (expandedKeys, info) {
      var onExpand = _this.props.onExpand;
      _this.setUncontrolledState({
        expandedKeys: expandedKeys
      });
      // Call origin function
      if (onExpand) {
        return onExpand(expandedKeys, info);
      }
      return undefined;
    };
    _this.onClick = function (event, node) {
      var _this$props = _this.props,
        onClick = _this$props.onClick,
        expandAction = _this$props.expandAction;
      // Expand the tree
      if (expandAction === 'click') {
        _this.onDebounceExpand(event, node);
      }
      if (onClick) {
        onClick(event, node);
      }
    };
    _this.onDoubleClick = function (event, node) {
      var _this$props2 = _this.props,
        onDoubleClick = _this$props2.onDoubleClick,
        expandAction = _this$props2.expandAction;
      // Expand the tree
      if (expandAction === 'doubleClick') {
        _this.onDebounceExpand(event, node);
      }
      if (onDoubleClick) {
        onDoubleClick(event, node);
      }
    };
    _this.onSelect = function (keys, event) {
      var _this$props3 = _this.props,
        onSelect = _this$props3.onSelect,
        multiple = _this$props3.multiple,
        children = _this$props3.children;
      var _this$state = _this.state,
        _this$state$expandedK = _this$state.expandedKeys,
        expandedKeys = _this$state$expandedK === void 0 ? [] : _this$state$expandedK,
        _this$state$selectedK = _this$state.selectedKeys,
        selectedKeys = _this$state$selectedK === void 0 ? [] : _this$state$selectedK;
      var node = event.node,
        nativeEvent = event.nativeEvent;
      var _node$props$eventKey = node.props.eventKey,
        eventKey = _node$props$eventKey === void 0 ? '' : _node$props$eventKey;
      var newState = {};
      // Windows / Mac single pick
      var ctrlPick = nativeEvent.ctrlKey || nativeEvent.metaKey;
      var shiftPick = nativeEvent.shiftKey;
      // Generate new selected keys
      var newSelectedKeys = _sliceInstanceProperty(selectedKeys).call(selectedKeys);
      if (multiple && ctrlPick) {
        // Control click
        newSelectedKeys = keys;
        _this.lastSelectedKey = eventKey;
        _this.cachedSelectedKeys = newSelectedKeys;
      } else if (multiple && shiftPick) {
        var _context;
        // Shift click
        newSelectedKeys = _Array$from(new _Set(_concatInstanceProperty(_context = []).call(_context, _toConsumableArray(_this.cachedSelectedKeys || []), _toConsumableArray(calcRangeKeys(children, expandedKeys, eventKey, _this.lastSelectedKey)))));
      } else {
        // Single click
        newSelectedKeys = [eventKey];
        _this.lastSelectedKey = eventKey;
        _this.cachedSelectedKeys = newSelectedKeys;
      }
      newState.selectedKeys = newSelectedKeys;
      if (onSelect) {
        onSelect(newSelectedKeys, event);
      }
      _this.setUncontrolledState(newState);
    };
    _this.expandFolderNode = function (event, node) {
      var isLeaf = node.props.isLeaf;
      if (isLeaf || event.shiftKey || event.metaKey || event.ctrlKey) {
        return;
      }
      // Get internal rc-tree
      var internalTree = _this.tree.tree;
      // Call internal rc-tree expand function
      // https://github.com/ant-design/ant-design/issues/12567
      internalTree.onNodeExpand(event, node);
    };
    _this.setUncontrolledState = function (state) {
      var newState = omit(state, _Object$keys(_this.props));
      if (_Object$keys(newState).length) {
        _this.setState(newState);
      }
    };
    var defaultExpandAll = props.defaultExpandAll,
      defaultExpandParent = props.defaultExpandParent,
      expandedKeys = props.expandedKeys,
      defaultExpandedKeys = props.defaultExpandedKeys,
      children = props.children;
    var _convertTreeToEntitie = convertTreeToEntities(children),
      keyEntities = _convertTreeToEntitie.keyEntities;
    // Selected keys
    _this.state = {
      selectedKeys: props.selectedKeys || props.defaultSelectedKeys || []
    };
    // Expanded keys
    if (defaultExpandAll) {
      _this.state.expandedKeys = getFullKeyList(props.children);
    } else if (defaultExpandParent) {
      _this.state.expandedKeys = conductExpandParent(expandedKeys || defaultExpandedKeys, keyEntities);
    } else {
      _this.state.expandedKeys = expandedKeys || defaultExpandedKeys;
    }
    _this.onDebounceExpand = debounce(_this.expandFolderNode, 200, {
      leading: true
    });
    return _this;
  }
  _createClass(DirectoryTree, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        className = _a.className,
        props = __rest(_a, ["prefixCls", "className"]);
      var _this$state2 = this.state,
        expandedKeys = _this$state2.expandedKeys,
        selectedKeys = _this$state2.selectedKeys;
      var connectClassName = classNames("".concat(prefixCls, "-directory"), className);
      return /*#__PURE__*/React.createElement(Tree, _Object$assign({
        icon: getIcon,
        ref: function ref(node) {
          return _this2.tree = node;
        }
      }, props, {
        prefixCls: prefixCls,
        className: connectClassName,
        expandedKeys: expandedKeys,
        selectedKeys: selectedKeys,
        onSelect: this.onSelect,
        onClick: this.onClick,
        onDoubleClick: this.onDoubleClick,
        onExpand: this.onExpand
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      var newState = {};
      if ('expandedKeys' in nextProps) {
        newState.expandedKeys = nextProps.expandedKeys;
      }
      if ('selectedKeys' in nextProps) {
        newState.selectedKeys = nextProps.selectedKeys;
      }
      return newState;
    }
  }]);
  return DirectoryTree;
}(React.Component);
DirectoryTree.defaultProps = {
  prefixCls: 'fishd-tree',
  showIcon: true,
  expandAction: 'click'
};
polyfill(DirectoryTree);
export default DirectoryTree;