import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import { createRef } from '../util';
import Icon from '../../../Icon/index';
export var selectorPropTypes = {
  prefixCls: PropTypes.string,
  className: PropTypes.string,
  style: PropTypes.object,
  open: PropTypes.bool,
  valueList: PropTypes.array,
  allowClear: PropTypes.bool,
  showArrow: PropTypes.bool,
  uniqueTreeNodeByLabel: PropTypes.bool,
  onClick: PropTypes.func,
  onBlur: PropTypes.func,
  onFocus: PropTypes.func,
  removeSelected: PropTypes.func,
  // Pass by component
  ariaId: PropTypes.string
};
export var selectorContextTypes = {
  onSelectorFocus: PropTypes.func.isRequired,
  onSelectorBlur: PropTypes.func.isRequired,
  onSelectorKeyDown: PropTypes.func.isRequired,
  onSelectorClear: PropTypes.func.isRequired
};
export default function (modeName) {
  var BaseSelector = /*#__PURE__*/function (_React$Component) {
    _inherits(BaseSelector, _React$Component);
    var _super = _createSuper(BaseSelector);
    function BaseSelector() {
      var _this;
      _classCallCheck(this, BaseSelector);
      _this = _super.call(this);
      _this.onFocus = function () {
        var _this$props = _this.props,
          onFocus = _this$props.onFocus,
          focused = _this$props.focused;
        var onSelectorFocus = _this.context.rcTreeSelect.onSelectorFocus;
        if (!focused) {
          onSelectorFocus();
        }
        if (onFocus) {
          onFocus.apply(void 0, arguments);
        }
      };
      _this.onBlur = function () {
        var onBlur = _this.props.onBlur;
        var onSelectorBlur = _this.context.rcTreeSelect.onSelectorBlur;
        // TODO: Not trigger when is inner component get focused
        onSelectorBlur();
        if (onBlur) {
          onBlur.apply(void 0, arguments);
        }
      };
      _this.focus = function () {
        _this.domRef.current.focus();
      };
      _this.blur = function () {
        _this.domRef.current.focus();
      };
      _this.domRef = createRef();
      return _this;
    }
    _createClass(BaseSelector, [{
      key: "renderClear",
      value: function renderClear() {
        var _this$props2 = this.props,
          prefixCls = _this$props2.prefixCls,
          allowClear = _this$props2.allowClear,
          valueList = _this$props2.valueList;
        var onSelectorClear = this.context.rcTreeSelect.onSelectorClear;
        if (!allowClear || !valueList.length || !valueList[0].value) {
          return null;
        }
        return /*#__PURE__*/React.createElement("span", {
          key: "clear",
          className: "".concat(prefixCls, "-selection__clear"),
          onClick: onSelectorClear
        });
      }
    }, {
      key: "renderArrow",
      value: function renderArrow() {
        var _this$props3 = this.props,
          prefixCls = _this$props3.prefixCls,
          showArrow = _this$props3.showArrow;
        if (!showArrow) {
          return null;
        }
        return /*#__PURE__*/React.createElement(Icon, {
          key: "arrow",
          type: "down-fill",
          className: "".concat(prefixCls, "-arrow"),
          style: {
            outline: 'none'
          }
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _classNames, _context;
        var _this$props4 = this.props,
          prefixCls = _this$props4.prefixCls,
          className = _this$props4.className,
          style = _this$props4.style,
          open = _this$props4.open,
          focused = _this$props4.focused,
          disabled = _this$props4.disabled,
          allowClear = _this$props4.allowClear,
          onClick = _this$props4.onClick,
          ariaId = _this$props4.ariaId,
          renderSelection = _this$props4.renderSelection,
          renderPlaceholder = _this$props4.renderPlaceholder,
          tabIndex = _this$props4.tabIndex,
          showArrow = _this$props4.showArrow;
        var onSelectorKeyDown = this.context.rcTreeSelect.onSelectorKeyDown;
        var myTabIndex = tabIndex;
        if (disabled) {
          myTabIndex = null;
        }
        return /*#__PURE__*/React.createElement("span", {
          style: style,
          // 用 onMouseDown 代替 onClick，修复加载页面后点击弹层，RcTrigger v2.6.2 中
          // onDocumentClick 先于 onPopupMouseDown 执行，导致的弹层异常关闭的问题
          onMouseDown: onClick,
          className: classNames(className, prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-open"), open), _defineProperty(_classNames, "".concat(prefixCls, "-focused"), open || focused), _defineProperty(_classNames, "".concat(prefixCls, "-disabled"), disabled), _defineProperty(_classNames, "".concat(prefixCls, "-enabled"), !disabled), _defineProperty(_classNames, "".concat(prefixCls, "-allow-clear"), allowClear), _classNames)),
          ref: this.domRef,
          role: "combobox",
          "aria-expanded": open,
          "aria-owns": open ? ariaId : undefined,
          "aria-controls": open ? ariaId : undefined,
          "aria-haspopup": "listbox",
          "aria-disabled": disabled,
          tabIndex: myTabIndex,
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          onKeyDown: onSelectorKeyDown
        }, /*#__PURE__*/React.createElement("span", {
          key: "selection",
          className: classNames("".concat(prefixCls, "-selection"), _concatInstanceProperty(_context = "".concat(prefixCls, "-selection--")).call(_context, modeName), {
            readonly: modeName == 'multiple' && showArrow
          })
        }, renderSelection(), this.renderClear(), this.renderArrow(), renderPlaceholder && renderPlaceholder()));
      }
    }]);
    return BaseSelector;
  }(React.Component);
  BaseSelector.propTypes = _Object$assign(_Object$assign({}, selectorPropTypes), {
    // Pass by HOC
    renderSelection: PropTypes.func.isRequired,
    renderPlaceholder: PropTypes.func,
    tabIndex: PropTypes.number
  });
  BaseSelector.contextTypes = {
    rcTreeSelect: PropTypes.shape(_Object$assign({}, selectorContextTypes))
  };
  BaseSelector.defaultProps = {
    tabIndex: 0
  };
  polyfill(BaseSelector);
  return BaseSelector;
}