import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
/**
 * Since search box is in different position with different mode.
 * - Single: in the popup box
 * - multiple: in the selector
 * Move the code as a SearchInput for easy management.
 */
import React from 'react';
import PropTypes from 'prop-types';
import { polyfill } from 'react-lifecycles-compat';
import { createRef } from './util';
import classNames from 'classnames';
export var searchContextTypes = {
  onSearchInputChange: PropTypes.func.isRequired
};
var SearchInput = /*#__PURE__*/function (_React$Component) {
  _inherits(SearchInput, _React$Component);
  var _super = _createSuper(SearchInput);
  function SearchInput(props) {
    var _this;
    _classCallCheck(this, SearchInput);
    _this = _super.call(this, props);
    /**
     * `scrollWidth` is not correct in IE, do the workaround.
     * ref: https://github.com/react-component/tree-select/issues/65
     */
    _this.alignInputWidth = function () {
      _this.inputRef.current.style.width = "".concat(_this.mirrorInputRef.current.clientWidth, "px");
    };
    /**
     * Need additional timeout for focus cause parent dom is not ready when didMount trigger
     */
    _this.focus = function (isDidMount) {
      if (_this.inputRef.current) {
        _this.inputRef.current.focus();
        if (isDidMount) {
          _setTimeout(function () {
            _this.inputRef.current.focus();
          }, 0);
        }
      }
    };
    _this.blur = function () {
      if (_this.inputRef.current) {
        _this.inputRef.current.blur();
      }
    };
    _this.handleClearInput = function () {
      var r = _this.inputRef;
      r.current.value = '';
      _this.handleInputChange({
        target: {
          value: ''
        }
      });
    };
    _this.handleInputChange = function (e) {
      var _this$context$rcTreeS = _this.context.rcTreeSelect,
        onSearchInputChange = _this$context$rcTreeS.onSearchInputChange,
        onSearchInputKeyDown = _this$context$rcTreeS.onSearchInputKeyDown;
      var value = e.target.value;
      if (value) {
        _this.setState({
          showClear: true
        });
      } else {
        _this.setState({
          showClear: false
        });
      }
      onSearchInputChange(e);
    };
    _this.inputRef = createRef();
    _this.mirrorInputRef = createRef();
    _this.state = {
      showClear: !!_this.props.searchValue
    };
    return _this;
  }
  _createClass(SearchInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
        open = _this$props.open,
        needAlign = _this$props.needAlign;
      if (needAlign) {
        this.alignInputWidth();
      }
      if (open) {
        this.focus(true);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props2 = this.props,
        open = _this$props2.open,
        searchValue = _this$props2.searchValue,
        needAlign = _this$props2.needAlign;
      if (open && prevProps.open !== open) {
        this.focus();
      }
      if (needAlign && searchValue !== prevProps.searchValue) {
        this.alignInputWidth();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        searchValue = _this$props3.searchValue,
        prefixCls = _this$props3.prefixCls,
        disabled = _this$props3.disabled,
        renderPlaceholder = _this$props3.renderPlaceholder,
        open = _this$props3.open,
        ariaId = _this$props3.ariaId;
      var _this$context$rcTreeS2 = this.context.rcTreeSelect,
        onSearchInputChange = _this$context$rcTreeS2.onSearchInputChange,
        onSearchInputKeyDown = _this$context$rcTreeS2.onSearchInputKeyDown;
      var showClear = this.state.showClear;
      var clearIconClass = classNames(_defineProperty({
        'hide': !showClear,
        'select-clear-icon': true
      }, "".concat(prefixCls, "-selection__clear"), true));
      return /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-search__field__wrap")
      }, /*#__PURE__*/React.createElement("input", {
        type: "text",
        ref: this.inputRef,
        onChange: this.handleInputChange,
        onKeyDown: onSearchInputKeyDown,
        value: searchValue,
        disabled: disabled,
        className: "".concat(prefixCls, "-search__field"),
        "aria-label": "filter select",
        "aria-autocomplete": "list",
        "aria-controls": open ? ariaId : undefined,
        "aria-multiline": "false"
      }), /*#__PURE__*/React.createElement("span", {
        ref: this.mirrorInputRef,
        className: "".concat(prefixCls, "-search__field__mirror")
      }, searchValue, "\xA0"), renderPlaceholder ? renderPlaceholder() : null, /*#__PURE__*/React.createElement("span", {
        className: clearIconClass,
        onClick: this.handleClearInput
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {
        prevProps: nextProps
      };
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      if (nextProps.searchValue != prevProps.searchValue) {
        newState.showClear = !!nextProps.searchValue;
      }
      return newState;
    }
  }]);
  return SearchInput;
}(React.Component);
SearchInput.propTypes = {
  open: PropTypes.bool,
  searchValue: PropTypes.string,
  prefixCls: PropTypes.string,
  disabled: PropTypes.bool,
  renderPlaceholder: PropTypes.func,
  needAlign: PropTypes.bool,
  ariaId: PropTypes.string
};
SearchInput.contextTypes = {
  rcTreeSelect: PropTypes.shape(_Object$assign({}, searchContextTypes))
};
polyfill(SearchInput);
export default SearchInput;