import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import React from 'react';
import PropTypes from 'prop-types';
import { polyfill } from 'react-lifecycles-compat';
import Trigger from 'rc-trigger';
import classNames from 'classnames';
import { createRef } from './util';
var commonPlacements = {
  overflow: {
    adjustX: 1,
    adjustY: 1
  },
  ignoreShake: true
};
var BUILT_IN_PLACEMENTS = {
  leftCenter: _Object$assign({
    points: ['cr', 'cl'],
    offset: [-8, 0]
  }, commonPlacements),
  leftTop: _Object$assign({
    points: ['tr', 'tl'],
    offset: [-8, 0]
  }, commonPlacements),
  leftBottom: _Object$assign({
    points: ['br', 'bl'],
    offset: [-8, 0]
  }, commonPlacements),
  rightCenter: _Object$assign({
    points: ['cl', 'cr'],
    offset: [8, 0]
  }, commonPlacements),
  rightTop: _Object$assign({
    points: ['tl', 'tr'],
    offset: [8, 0]
  }, commonPlacements),
  rightBottom: _Object$assign({
    points: ['bl', 'br'],
    offset: [8, 0]
  }, commonPlacements),
  topCenter: _Object$assign({
    points: ['bc', 'tc'],
    offset: [0, -8]
  }, commonPlacements),
  topRight: _Object$assign({
    points: ['br', 'tr'],
    offset: [0, -8]
  }, commonPlacements),
  topLeft: _Object$assign({
    points: ['bl', 'tl'],
    offset: [0, -8]
  }, commonPlacements),
  bottomCenter: _Object$assign({
    points: ['tc', 'bc'],
    offset: [0, 8]
  }, commonPlacements),
  bottomRight: _Object$assign({
    points: ['tr', 'br'],
    offset: [0, 8]
  }, commonPlacements),
  bottomLeft: _Object$assign({
    points: ['tl', 'bl'],
    offset: [0, 8]
  }, commonPlacements)
};
var SelectTrigger = /*#__PURE__*/function (_React$Component) {
  _inherits(SelectTrigger, _React$Component);
  var _super = _createSuper(SelectTrigger);
  function SelectTrigger(props) {
    var _this;
    _classCallCheck(this, SelectTrigger);
    _this = _super.call(this, props);
    _this.getDropdownTransitionName = function () {
      var _this$props = _this.props,
        transitionName = _this$props.transitionName,
        animation = _this$props.animation,
        dropdownPrefixCls = _this$props.dropdownPrefixCls;
      if (!transitionName && animation) {
        var _context;
        return _concatInstanceProperty(_context = "".concat(dropdownPrefixCls, "-")).call(_context, animation);
      }
      return transitionName;
    };
    _this.forcePopupAlign = function () {
      var $trigger = _this.triggerRef.current;
      if ($trigger) {
        $trigger.forcePopupAlign();
      }
    };
    _this.triggerRef = createRef();
    return _this;
  }
  _createClass(SelectTrigger, [{
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props2 = this.props,
        disabled = _this$props2.disabled,
        isMultiple = _this$props2.isMultiple,
        dropdownPopupAlign = _this$props2.dropdownPopupAlign,
        dropdownMatchSelectWidth = _this$props2.dropdownMatchSelectWidth,
        dropdownClassName = _this$props2.dropdownClassName,
        dropdownStyle = _this$props2.dropdownStyle,
        onDropdownVisibleChange = _this$props2.onDropdownVisibleChange,
        getPopupContainer = _this$props2.getPopupContainer,
        dropdownPrefixCls = _this$props2.dropdownPrefixCls,
        popupElement = _this$props2.popupElement,
        open = _this$props2.open,
        children = _this$props2.children,
        placement = _this$props2.placement;
      // TODO: [Legacy] Use new action when trigger fixed: https://github.com/react-component/trigger/pull/86
      // When false do nothing with the width
      // ref: https://github.com/ant-design/ant-design/issues/10927
      var stretch;
      if (dropdownMatchSelectWidth !== false) {
        stretch = dropdownMatchSelectWidth ? 'width' : 'minWidth';
      }
      return /*#__PURE__*/React.createElement(Trigger, {
        ref: this.triggerRef,
        action: disabled ? [] : ['click'],
        popupPlacement: placement,
        // forceRender
        builtinPlacements: BUILT_IN_PLACEMENTS,
        popupAlign: dropdownPopupAlign,
        prefixCls: dropdownPrefixCls,
        popupTransitionName: this.getDropdownTransitionName(),
        onPopupVisibleChange: onDropdownVisibleChange,
        popup: popupElement,
        popupVisible: open,
        getPopupContainer: getPopupContainer,
        stretch: stretch,
        popupClassName: classNames(dropdownClassName, (_classNames = {}, _defineProperty(_classNames, "".concat(dropdownPrefixCls, "--multiple"), isMultiple), _defineProperty(_classNames, "".concat(dropdownPrefixCls, "--single"), !isMultiple), _classNames)),
        popupStyle: dropdownStyle
      }, children);
    }
  }]);
  return SelectTrigger;
}(React.Component);
SelectTrigger.propTypes = {
  // Pass by outside user props
  disabled: PropTypes.bool,
  dropdownPopupAlign: PropTypes.object,
  placement: PropTypes.string,
  dropdownClassName: PropTypes.string,
  dropdownStyle: PropTypes.object,
  getPopupContainer: PropTypes.func,
  children: PropTypes.node,
  dropdownMatchSelectWidth: PropTypes.bool,
  transitionName: PropTypes.string,
  animation: PropTypes.string,
  // Pass by Select
  isMultiple: PropTypes.bool,
  dropdownPrefixCls: PropTypes.string,
  onDropdownVisibleChange: PropTypes.func,
  popupElement: PropTypes.node,
  open: PropTypes.bool
};
SelectTrigger.defaultProps = {
  open: false
};
polyfill(SelectTrigger);
export default SelectTrigger;