import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import PropTypes from 'prop-types';
import { isLabelInValue } from './util';
var internalValProp = PropTypes.oneOfType([PropTypes.string, PropTypes.number]);
export function genArrProps(propType) {
  return PropTypes.oneOfType([propType, PropTypes.arrayOf(propType)]);
}
/**
 * Origin code check `multiple` is true when `treeCheckStrictly` & `labelInValue`.
 * But in process logic is already cover to array.
 * Check array is not necessary. Let's simplify this check logic.
 */
export function valueProp() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  var props = args[0],
    propName = args[1],
    Component = args[2];
  if (isLabelInValue(props)) {
    var _err = genArrProps(PropTypes.shape({
      label: PropTypes.node,
      value: internalValProp
    })).apply(void 0, args);
    if (_err) {
      var _context;
      return new Error(_concatInstanceProperty(_context = "Invalid prop `".concat(propName, "` supplied to `")).call(_context, Component, "`. ") + "You should use { label: string, value: string | number } \n         or [{ label: string, value: string | number }] instead.");
    }
    return null;
  }
  var err = genArrProps(internalValProp).apply(void 0, args);
  if (err) {
    var _context2;
    return new Error(_concatInstanceProperty(_context2 = "Invalid prop `".concat(propName, "` supplied to `")).call(_context2, Component, "`. ") + "You should use string or [string] instead.");
  }
  return null;
}