import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import PropTypes from 'prop-types';
import Icon from '../Icon';
import classNames from 'classnames';
import './style/index.less';
var Trend = function Trend(props) {
  var _props$colorful = props.colorful,
    colorful = _props$colorful === void 0 ? true : _props$colorful,
    _props$reverseColor = props.reverseColor,
    reverseColor = _props$reverseColor === void 0 ? false : _props$reverseColor,
    flag = props.flag,
    children = props.children,
    className = props.className,
    _props$size = props.size,
    size = _props$size === void 0 ? 'small' : _props$size,
    style = props.style,
    value = props.value,
    restProps = __rest(props, ["colorful", "reverseColor", "flag", "children", "className", "size", "style", "value"]);
  var cls = classNames('trend-item', {
    'trend-item-grey': !colorful,
    'reverse-color': reverseColor && colorful,
    normal: size == 'normal',
    large: size == 'large'
  }, className);
  var renderFlag = function renderFlag() {
    var _context;
    if (!flag) return;
    var iconType = null,
      mark = null;
    if (flag == 'up') {
      mark = '+';
      iconType = 'trendrise';
    } else {
      mark = '-';
      iconType = 'trenddecline';
    }
    return /*#__PURE__*/React.createElement("span", {
      className: flag
    }, value && typeof value == 'string' ? _concatInstanceProperty(_context = "".concat(mark)).call(_context, value) : /*#__PURE__*/React.createElement(Icon, {
      type: iconType
    }));
  };
  return /*#__PURE__*/React.createElement("div", _Object$assign({}, restProps, {
    className: cls,
    title: typeof children === 'string' ? children : '',
    style: style
  }), /*#__PURE__*/React.createElement("span", {
    className: "value"
  }, children), renderFlag());
};
Trend.propTypes = {
  className: PropTypes.string,
  style: PropTypes.object,
  flag: PropTypes.string,
  size: PropTypes.string,
  value: PropTypes.string,
  colorful: PropTypes.bool,
  reverseColor: PropTypes.bool,
  children: PropTypes.node
};
export default Trend;