import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _setInterval from "@babel/runtime-corejs3/core-js-stable/set-interval";
import _Promise from "@babel/runtime-corejs3/core-js-stable/promise";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import { polyfill } from 'react-lifecycles-compat';
import RcUpload from './src/index.js';
import classNames from 'classnames';
import uniqBy from 'lodash/uniqBy';
import Dragger from './Dragger';
import UploadList from './UploadList';
import { T, fileToObject, genPercentAdd, getFileItem, removeFileItem } from './utils';
import ConfigConsumer from '../Config/Locale/Consumer';
var Upload = /*#__PURE__*/function (_React$Component) {
  _inherits(Upload, _React$Component);
  var _super = _createSuper(Upload);
  function Upload(props) {
    var _this;
    _classCallCheck(this, Upload);
    _this = _super.call(this, props);
    _this.onStart = function (file) {
      var _context;
      var nextFileList = _concatInstanceProperty(_context = _this.state.fileList).call(_context);
      var targetItem = fileToObject(file);
      targetItem.status = 'uploading';
      nextFileList.push(targetItem);
      _this.onChange({
        file: targetItem,
        fileList: nextFileList
      });
      // fix ie progress
      if (!window.FormData) {
        _this.autoUpdateProgress(0, targetItem);
      }
    };
    _this.onSuccess = function (response, file) {
      _this.clearProgressTimer();
      try {
        if (typeof response === 'string') {
          response = JSON.parse(response);
        }
      } catch (e) {
        /* do nothing */
      }
      var fileList = _this.state.fileList;
      var targetItem = getFileItem(file, fileList);
      // removed
      if (!targetItem) {
        return;
      }
      targetItem.status = 'done';
      targetItem.response = response;
      _this.onChange({
        file: _Object$assign({}, targetItem),
        fileList: fileList
      });
    };
    _this.onProgress = function (e, file) {
      var fileList = _this.state.fileList;
      var targetItem = getFileItem(file, fileList);
      // removed
      if (!targetItem) {
        return;
      }
      targetItem.percent = e.percent;
      _this.onChange({
        event: e,
        file: _Object$assign({}, targetItem),
        fileList: _this.state.fileList
      });
    };
    _this.onError = function (error, response, file) {
      _this.clearProgressTimer();
      var fileList = _this.state.fileList;
      var targetItem = getFileItem(file, fileList);
      // removed
      if (!targetItem) {
        return;
      }
      targetItem.error = error;
      targetItem.response = response;
      targetItem.status = 'error';
      _this.onChange({
        file: _Object$assign({}, targetItem),
        fileList: fileList
      });
    };
    _this.handleDeleteAll = function () {
      var _context2;
      _forEachInstanceProperty(_context2 = _this.state.fileList).call(_context2, function (file) {
        _this.upload.abort(file);
        file.status = 'removed'; // eslint-disable-line
      });

      _this.setState({
        fileList: []
      });
      var onDeleteAll = _this.props.onDeleteAll;
      if (onDeleteAll) {
        onDeleteAll();
      }
    };
    _this.handleManualRemove = function (file) {
      _this.upload.abort(file);
      file.status = 'removed'; // eslint-disable-line
      _this.handleRemove(file);
    };
    _this.onChange = function (info) {
      if (!('fileList' in _this.props)) {
        _this.setState({
          fileList: info.fileList
        });
      }
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange(info);
      }
    };
    _this.onFileDrop = function (e) {
      _this.setState({
        dragState: e.type
      });
    };
    _this.beforeUpload = function (file, fileList) {
      if (!_this.props.beforeUpload) {
        return true;
      }
      var result = _this.props.beforeUpload(file, fileList);
      if (result === false) {
        var _context3;
        _this.onChange({
          file: file,
          fileList: uniqBy(_concatInstanceProperty(_context3 = _this.state.fileList).call(_context3, _mapInstanceProperty(fileList).call(fileList, fileToObject)), function (item) {
            return item.uid;
          })
        });
        return false;
      } else if (result && result.then) {
        return result;
      }
      return true;
    };
    _this.saveUpload = function (node) {
      _this.upload = node;
    };
    _this.renderUploadList = function (locale) {
      var _this$props = _this.props,
        showUploadList = _this$props.showUploadList,
        listType = _this$props.listType,
        onPreview = _this$props.onPreview,
        disabled = _this$props.disabled,
        maxFileCount = _this$props.maxFileCount,
        showDeleteAll = _this$props.showDeleteAll;
      var showRemoveIcon = showUploadList.showRemoveIcon,
        showPreviewIcon = showUploadList.showPreviewIcon;
      return /*#__PURE__*/React.createElement(UploadList, {
        listType: listType,
        items: _this.state.fileList,
        onPreview: onPreview,
        onRemove: _this.handleManualRemove,
        onDeleteAll: _this.handleDeleteAll,
        showRemoveIcon: !disabled && showRemoveIcon,
        showPreviewIcon: showPreviewIcon,
        maxFileCount: maxFileCount,
        showDeleteAll: showDeleteAll,
        locale: _Object$assign(_Object$assign({}, locale), _this.props.locale)
      });
    };
    _this.state = {
      fileList: props.fileList || props.defaultFileList || [],
      dragState: 'drop',
      action: props.action || ''
    };
    return _this;
  }
  _createClass(Upload, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.clearProgressTimer();
    }
  }, {
    key: "autoUpdateProgress",
    value: function autoUpdateProgress(_, file) {
      var _this2 = this;
      var getPercent = genPercentAdd();
      var curPercent = 0;
      this.clearProgressTimer();
      this.progressTimer = _setInterval(function () {
        curPercent = getPercent(curPercent);
        _this2.onProgress({
          percent: curPercent * 100
        }, file);
      }, 200);
    }
  }, {
    key: "handleRemove",
    value: function handleRemove(file) {
      var _this3 = this;
      var onRemove = this.props.onRemove;
      _Promise.resolve(typeof onRemove === 'function' ? onRemove(file) : onRemove).then(function (ret) {
        // Prevent removing file
        if (ret === false) {
          return;
        }
        var removedFileList = removeFileItem(file, _this3.state.fileList);
        if (removedFileList) {
          _this3.onChange({
            file: file,
            fileList: removedFileList
          });
        }
      });
    }
  }, {
    key: "clearProgressTimer",
    value: function clearProgressTimer() {
      clearInterval(this.progressTimer);
    }
  }, {
    key: "renderUpload",
    value: function renderUpload(Locale) {
      var _context5, _classNames2;
      var _this$props2 = this.props,
        _this$props2$prefixCl = _this$props2.prefixCls,
        prefixCls = _this$props2$prefixCl === void 0 ? '' : _this$props2$prefixCl,
        className = _this$props2.className,
        style = _this$props2.style,
        showUploadList = _this$props2.showUploadList,
        listType = _this$props2.listType,
        type = _this$props2.type,
        disabled = _this$props2.disabled,
        children = _this$props2.children,
        tip = _this$props2.tip;
      var rcUploadProps = _Object$assign(_Object$assign({
        onStart: this.onStart,
        onError: this.onError,
        onProgress: this.onProgress,
        onSuccess: this.onSuccess
      }, this.props), {
        beforeUpload: this.beforeUpload
      });
      delete rcUploadProps.className;
      delete rcUploadProps.style;
      delete rcUploadProps.action;
      var uploadList = showUploadList ? this.renderUploadList({
        uploading: Locale.uploading,
        removeFile: Locale.removeFile,
        uploadError: Locale.uploadError,
        previewFile: Locale.previewFile
      }) : null;
      var uploadTips = tip ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-tip")
      }, tip) : null;
      if (type === 'drag') {
        var _context4, _classNames;
        var dragCls = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-drag"), true), _defineProperty(_classNames, "".concat(prefixCls, "-drag-uploading"), _someInstanceProperty(_context4 = this.state.fileList).call(_context4, function (file) {
          return file.status === 'uploading';
        })), _defineProperty(_classNames, "".concat(prefixCls, "-drag-hover"), this.state.dragState === 'dragover'), _defineProperty(_classNames, "".concat(prefixCls, "-disabled"), disabled), _classNames));
        return /*#__PURE__*/React.createElement("span", {
          className: className,
          style: style
        }, /*#__PURE__*/React.createElement("div", {
          className: dragCls,
          onDrop: this.onFileDrop,
          onDragOver: this.onFileDrop,
          onDragLeave: this.onFileDrop
        }, /*#__PURE__*/React.createElement(RcUpload, _Object$assign({}, rcUploadProps, {
          action: this.state.action,
          ref: this.saveUpload,
          className: "".concat(prefixCls, "-btn")
        }), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-drag-container")
        }, children))), uploadTips, uploadList);
      }
      var uploadButtonCls = classNames(prefixCls, (_classNames2 = {}, _defineProperty(_classNames2, "".concat(prefixCls, "-select"), true), _defineProperty(_classNames2, _concatInstanceProperty(_context5 = "".concat(prefixCls, "-select-")).call(_context5, listType), true), _defineProperty(_classNames2, "".concat(prefixCls, "-disabled"), disabled), _classNames2));
      var uploadButton = /*#__PURE__*/React.createElement("div", {
        className: uploadButtonCls,
        style: {
          display: children ? '' : 'none'
        }
      }, /*#__PURE__*/React.createElement(RcUpload, _Object$assign({}, rcUploadProps, {
        action: this.state.action,
        ref: this.saveUpload
      })));
      var renderNode = null;
      if (listType === 'picture-card') {
        renderNode = /*#__PURE__*/React.createElement("span", {
          className: className,
          style: style
        }, uploadList, uploadButton, uploadTips);
      } else {
        renderNode = /*#__PURE__*/React.createElement("span", {
          className: className,
          style: style
        }, uploadButton, uploadTips, uploadList);
      }
      return renderNode;
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "Upload"
      }, function (Locale) {
        return _this4.renderUpload(Locale);
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      // action 受控
      if ('action' in nextProps && prevState.action !== nextProps.action) {
        newState.action = nextProps.action;
      }
      if ('fileList' in nextProps) {
        newState.fileList = nextProps.fileList || [];
      }
      return newState;
    }
  }]);
  return Upload;
}(React.Component);
Upload.Dragger = Dragger;
Upload.defaultProps = {
  prefixCls: 'fishd-upload',
  type: 'select',
  multiple: false,
  action: '',
  data: {},
  accept: '',
  beforeUpload: T,
  showUploadList: true,
  listType: 'text',
  className: '',
  disabled: false,
  supportServerRender: true,
  tip: ''
};
polyfill(Upload);
export default Upload;