import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import PropTypes from 'prop-types';
import videojs from 'video.js';
import './component/vjsDownLoad';
import './component/vjsFullScreen';
import './component/vjsVolume';
import './component/vjsPlay';
import './component/vjsErrorDisplay';
import { zh_CN } from './lang/zh-CN';
import KEYCODE from '../../utils/KeyCode';
videojs.addLanguage('zh-CN', zh_CN);
var VideoViewer = /*#__PURE__*/function (_React$Component) {
  _inherits(VideoViewer, _React$Component);
  var _super = _createSuper(VideoViewer);
  function VideoViewer(props) {
    var _this;
    _classCallCheck(this, VideoViewer);
    _this = _super.call(this, props);
    _this.getVideoPlayer = function () {
      return _this.player;
    };
    // 空格键控制 暂停、播放
    _this.handleSpaceKeyDown = function (e) {
      if (e.which === KEYCODE.SPACE) {
        e.preventDefault();
        if (_this.player) {
          if (_this.player.paused()) {
            _this.player.play();
          } else {
            _this.player.pause();
          }
        }
      }
    };
    return _this;
  }
  _createClass(VideoViewer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      var _a = this.props,
        download = _a.download,
        bigPlayButton = _a.bigPlayButton,
        otherProps = __rest(_a, ["download", "bigPlayButton"]);
      var initOptions = {
        //aspectRatio: '16:9',
        //autoSetup: false,
        //fluid: true,
        //inactivityTimeout: 3000,
        //liveui: true,
        //notSupportedMessage: '',
        //responsive: true,
        loadingSpinner: true,
        bigPlayButton: bigPlayButton,
        controlBar: {
          children: [{
            name: 'progressControl'
          }, {
            name: 'vjsPlay'
          }, {
            name: 'currentTimeDisplay'
          }, {
            name: 'timeDivider'
          }, {
            name: 'durationDisplay'
          }, {
            name: 'vjsFullScreen'
          }, {
            name: download ? 'vjsDownLoad' : ''
          }, {
            name: 'vjsVolume'
          }]
        },
        errorDisplay: {
          children: [{
            name: 'vjsErrorDisplay'
          }]
        }
      };
      var option = _Object$assign({}, initOptions, otherProps);
      // instantiate video.js
      this.player = videojs(this.videoNode, option, function () {
        _this2.player.on('timeupdate', function (e) {
          // 控制焦点
          _this2.videoPlayerRef.focus();
        });
      });
    }
    // destroy player on unmount
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.player) {
        this.player.dispose();
      }
    }
    // wrap the player in a div with a `data-vjs-player` attribute
    // so videojs won't create additional wrapper in the DOM
    // see https://github.com/videojs/ video.js /pull/3856
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className;
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-wrap")
      }, /*#__PURE__*/React.createElement("div", {
        "data-vjs-player": true,
        ref: function ref(node) {
          return _this3.videoPlayerRef = node;
        },
        onKeyDown: this.handleSpaceKeyDown
      }, /*#__PURE__*/React.createElement("video", {
        ref: function ref(node) {
          return _this3.videoNode = node;
        },
        className: className
      })));
    }
  }]);
  return VideoViewer;
}(React.Component);
export { VideoViewer as default };
VideoViewer.propTypes = {
  prefixCls: PropTypes.string,
  className: PropTypes.string,
  width: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  height: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  poster: PropTypes.string,
  sources: PropTypes.array,
  autoplay: PropTypes.bool,
  loop: PropTypes.bool,
  muted: PropTypes.bool,
  preload: PropTypes.oneOf(['auto', 'none', 'metadata']),
  controls: PropTypes.bool,
  download: PropTypes.bool,
  bigPlayButton: PropTypes.bool
};
VideoViewer.defaultProps = {
  prefixCls: 'fishd-video-js',
  className: 'video-js',
  width: 640,
  height: 360,
  poster: '',
  sources: [],
  autoplay: false,
  loop: false,
  muted: false,
  preload: 'auto',
  controls: true,
  download: false,
  bigPlayButton: true // 是否显示大按钮
};