import * as React from 'react';
import Video from './Video';
import VideoModal, { VideoModalProps } from './VideoModal';
interface VideoViewerProps {
    prefixCls?: string;
    width?: string | number;
    height?: string | number;
    poster?: string;
    failedMessage?: string;
    onThumbClick?: (e: React.MouseEvent) => void;
    modalProps?: VideoModalProps;
    videoProps?: VideoModalProps;
}
interface VideoViewerState {
    videoModalVisible: boolean;
}
declare class VideoViewer extends React.Component<VideoViewerProps, VideoViewerState> {
    static propTypes: {
        prefixCls: any;
        width: any;
        height: any;
        poster: any;
        failedMessage: any;
        modalProps: any;
        videoProps: any;
        onThumbClick: any;
    };
    static defaultProps: {
        prefixCls: string;
        poster: any;
        width: number;
        height: number;
        failedMessage: any;
    };
    video: React.RefObject<any>;
    static Video: typeof Video;
    static VideoModal: typeof VideoModal;
    constructor(props: any);
    handleThumbClick: (e: any) => void;
    onClose: () => void;
    handleCancel: (e: any) => void;
    render(): JSX.Element;
}
export default VideoViewer;
