import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import omit from 'omit.js';
import Video from './Video';
import VideoModal from './VideoModal';
import Icon from '../Icon';
var VideoViewer = /*#__PURE__*/function (_React$Component) {
  _inherits(VideoViewer, _React$Component);
  var _super = _createSuper(VideoViewer);
  function VideoViewer(props) {
    var _this;
    _classCallCheck(this, VideoViewer);
    _this = _super.call(this, props);
    // 点击缩略图
    _this.handleThumbClick = function (e) {
      if (_this.props.failedMessage !== null) return;
      _this.setState({
        videoModalVisible: true
      }, function () {
        var video = _this.video && _this.video.current;
        var player = video && video.getVideoPlayer();
        if (player && typeof player.play === 'function') {
          player.play();
        }
      });
      _this.props.onThumbClick && _this.props.onThumbClick(e);
    };
    // 模态框关闭的回调
    _this.onClose = function () {
      var video = _this.video && _this.video.current;
      var player = video && video.getVideoPlayer();
      if (player && typeof player.pause === 'function') {
        player.pause();
      }
      _this.props.modalProps.afterClose && _this.props.modalProps.afterClose();
    };
    // 点击模态框关闭按钮
    _this.handleCancel = function (e) {
      _this.setState({
        videoModalVisible: false
      });
      _this.props.modalProps.onCancel && _this.props.modalProps.onCancel();
    };
    _this.state = {
      videoModalVisible: false
    };
    _this.video = /*#__PURE__*/React.createRef();
    return _this;
  }
  _createClass(VideoViewer, [{
    key: "render",
    value: function render() {
      var _classnames;
      var videoModalVisible = this.state.videoModalVisible;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        width = _this$props.width,
        height = _this$props.height,
        poster = _this$props.poster,
        modalProps = _this$props.modalProps,
        videoProps = _this$props.videoProps,
        failedMessage = _this$props.failedMessage;
      var otherModalProps = omit(modalProps, ['visible', 'afterClose', 'onCancel']);
      var otherVideoProps = omit(videoProps, ['autoPlay']);
      var thumbCls = classnames((_classnames = {}, _defineProperty(_classnames, "".concat(prefixCls, "-thumb"), true), _defineProperty(_classnames, "".concat(prefixCls, "-thumb-disabled"), failedMessage !== null), _classnames));
      var wrapStyle = {
        width: width,
        height: height
      };
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-wrap"),
        style: wrapStyle
      }, /*#__PURE__*/React.createElement("div", {
        className: thumbCls,
        onClick: this.handleThumbClick
      }, failedMessage === null ? /*#__PURE__*/React.createElement("div", {
        className: classnames(["".concat(prefixCls, "-thumb-status"), "".concat(prefixCls, "-thumb-big-play-button")])
      }, /*#__PURE__*/React.createElement(Icon, {
        type: "play"
      })) : /*#__PURE__*/React.createElement("div", {
        className: classnames(["".concat(prefixCls, "-thumb-status"), "".concat(prefixCls, "-thumb-failed-message")])
      }, /*#__PURE__*/React.createElement("span", null, failedMessage)), /*#__PURE__*/React.createElement(Video, {
        width: width,
        height: height,
        poster: poster,
        sources: otherVideoProps.sources,
        controls: false
      })), /*#__PURE__*/React.createElement(VideoModal, _Object$assign({}, otherModalProps, {
        visible: videoModalVisible,
        afterClose: this.onClose,
        onCancel: this.handleCancel
      }), /*#__PURE__*/React.createElement(Video, _Object$assign({}, otherVideoProps, {
        ref: this.video,
        autoplay: true,
        bigPlayButton: false
      }))));
    }
  }]);
  return VideoViewer;
}(React.Component);
VideoViewer.propTypes = {
  prefixCls: PropTypes.string,
  width: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  height: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  poster: PropTypes.string,
  failedMessage: PropTypes.string,
  modalProps: PropTypes.object,
  videoProps: PropTypes.object,
  onThumbClick: PropTypes.func
};
VideoViewer.defaultProps = {
  prefixCls: 'fishd-video-viewer',
  poster: null,
  width: 240,
  height: 135,
  failedMessage: null
};
VideoViewer.Video = Video;
VideoViewer.VideoModal = VideoModal;
export default VideoViewer;