import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _parseInt from "@babel/runtime-corejs3/core-js-stable/parse-int";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Icon from '../../Icon/index';
import Popover from '../../Popover/index';
import Slider from '../../Slider/index';
var FullScreen = /*#__PURE__*/function (_Component) {
  _inherits(FullScreen, _Component);
  var _super = _createSuper(FullScreen);
  function FullScreen(props) {
    var _this;
    _classCallCheck(this, FullScreen);
    _this = _super.call(this, props);
    // 音量值变化
    _this.handleChangeVolume = function (value) {
      _this.setState({
        currentVolume: value,
        lastVolume: value,
        isMuted: !value
      });
    };
    // 音量面板状态变化
    _this.onVolumeVisibleChange = function (state) {
      _this.setState({
        volumeOpen: state
      });
    };
    // 点击音量
    _this.handleVolumeClick = function () {
      var _this$state = _this.state,
        isMuted = _this$state.isMuted,
        lastVolume = _this$state.lastVolume;
      _this.setState({
        isMuted: !isMuted,
        currentVolume: isMuted ? lastVolume : 0
      });
    };
    _this.player = props.vjsComponent.player_;
    _this.state = {
      isMuted: false,
      currentVolume: _parseInt(_this.player.volume() * 100),
      lastVolume: _parseInt(_this.player.volume() * 100),
      volumeOpen: false // 是否打开音量控制
    };
    return _this;
  }
  _createClass(FullScreen, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var prefixCls = this.props.prefixCls;
      var _this$state2 = this.state,
        isMuted = _this$state2.isMuted,
        currentVolume = _this$state2.currentVolume,
        volumeOpen = _this$state2.volumeOpen;
      // 设置播放器音量
      this.player.volume(currentVolume / 100);
      var volumeIcon = function volumeIcon() {
        if (isMuted || currentVolume === 0) {
          return 'sound-mute';
        } else if (currentVolume > 0 && currentVolume <= 50) {
          return 'sound-medium';
        } else {
          return 'sound-loud';
        }
      };
      var getVolumePopupContent = function getVolumePopupContent() {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-volume-box")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-volume-value")
        }, currentVolume, "%"), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-volume-slider")
        }, /*#__PURE__*/React.createElement(Slider, {
          vertical: true,
          min: 0,
          max: 100,
          step: 1,
          handle: /*#__PURE__*/React.createElement("div", {
            className: "".concat(prefixCls, "-customer-handle")
          }, /*#__PURE__*/React.createElement(Icon, {
            type: "sound-drag"
          })),
          tipFormatter: null,
          value: currentVolume,
          onChange: function onChange(value) {
            return _this2.handleChangeVolume(value);
          }
        })));
      };
      return /*#__PURE__*/React.createElement("div", {
        className: classnames(prefixCls, 'fishd-video-js-customer-button')
      }, /*#__PURE__*/React.createElement(Popover, {
        trigger: "hover",
        placement: "top",
        content: getVolumePopupContent(currentVolume),
        visible: volumeOpen,
        onVisibleChange: this.onVolumeVisibleChange,
        getPopupContainer: function getPopupContainer(node) {
          return node.parentNode;
        }
      }, /*#__PURE__*/React.createElement(Icon, {
        className: "control-volume",
        type: volumeIcon(),
        onClick: this.handleVolumeClick
      })));
    }
  }]);
  return FullScreen;
}(Component);
export { FullScreen as default };
FullScreen.propTypes = {
  prefixCls: PropTypes.string,
  vjsComponent: PropTypes.object
};
FullScreen.defaultProps = {
  prefixCls: 'fishd-video-viewer-volume'
};