import React from 'react';
export interface AudioPlayerProps {
    prefixCls?: string;
    className?: string;
    controlVolume?: boolean;
    controlProgress?: boolean;
    displayTime?: boolean;
    download?: boolean;
    src: string;
    title?: string;
    size?: 'default' | 'small';
    autoPlay?: boolean;
    loop?: boolean;
    muted?: boolean;
    preload?: 'auto' | 'metadata' | 'none';
    volume?: number;
    rateOptions?: {
        value?: number;
        suffix?: string;
        decimal?: number;
        range?: number[];
    };
    onAbort?: () => void;
    onCanPlay?: () => void;
    onCanPlayThrough?: () => void;
    onEnded?: () => void;
    onError?: () => void;
    onLoadedMetadata?: () => void;
    onPause?: () => void;
    onPlay?: () => void;
    onSeeked?: () => void;
}
export interface AudioPlayerState {
    isPlay: boolean;
    isMuted: boolean;
    currentVolume: number;
    volumeOpen: boolean;
    rateOpen: boolean;
    allTime: number;
    currentTime: number | undefined;
    disabled: boolean;
    rate: number;
}
declare class AudioPlayer extends React.Component<AudioPlayerProps, AudioPlayerState> {
    static propTypes: {
        prefixCls: any;
        className: any;
        size: any;
        title: any;
        src: any;
        loop: any;
        preload: any;
        autoPlay: any;
        muted: any;
        volume: any;
        controlVolume: any;
        controlProgress: any;
        displayTime: any;
        rateOptions: any;
        download: any;
        onLoadedMetadata: any;
        onCanPlay: any;
        onCanPlayThrough: any;
        onAbort: any;
        onEnded: any;
        onError: any;
        onPause: any;
        onPlay: any;
        onSeeked: any;
    };
    static defaultProps: AudioPlayerProps;
    audioInstance: HTMLAudioElement | null;
    constructor(props: AudioPlayerProps);
    componentDidMount(): void;
    controlAudio: (type: string, value?: number) => void;
    millisecondToDate: (time: number, format?: boolean) => string | number;
    getVolumePopupContent: () => JSX.Element;
    onVolumeVisibleChange: (state: boolean) => void;
    onRateVisibleChange: (state: boolean) => void;
    render(): JSX.Element;
}
export default AudioPlayer;
