"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _warning = _interopRequireDefault(require("warning"));
var _BreadcrumbItem = _interopRequireDefault(require("./BreadcrumbItem"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Icon = _interopRequireDefault(require("../Icon"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function getBreadcrumbName(route, params) {
  if (!route.breadcrumbName) {
    return null;
  }
  var paramsKeys = (0, _keys["default"])(params).join('|');
  var name = route.breadcrumbName.replace(new RegExp(":(".concat(paramsKeys, ")"), 'g'), function (replacement, key) {
    return params[key] || replacement;
  });
  return name;
}
function defaultItemRender(route, params, routes, paths) {
  var isLastItem = (0, _indexOf["default"])(routes).call(routes, route) === routes.length - 1;
  var name = getBreadcrumbName(route, params);
  return isLastItem ? /*#__PURE__*/React.createElement("span", null, name) : /*#__PURE__*/React.createElement("a", {
    href: "#/".concat(paths.join('/'))
  }, name);
}
var Breadcrumb = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Breadcrumb, _React$Component);
  var _super = _createSuper(Breadcrumb);
  function Breadcrumb() {
    (0, _classCallCheck2["default"])(this, Breadcrumb);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Breadcrumb, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var props = this.props;
      (0, _warning["default"])(!('linkRender' in props || 'nameRender' in props), '`linkRender` and `nameRender` are removed, please use `itemRender` instead, ' + 'see: https://u.ant.design/item-render.');
    }
  }, {
    key: "render",
    value: function render() {
      var crumbs;
      var _this$props = this.props,
        separator = _this$props.separator,
        prefixCls = _this$props.prefixCls,
        style = _this$props.style,
        className = _this$props.className,
        routes = _this$props.routes,
        _this$props$params = _this$props.params,
        params = _this$props$params === void 0 ? {} : _this$props$params,
        children = _this$props.children,
        _this$props$itemRende = _this$props.itemRender,
        itemRender = _this$props$itemRende === void 0 ? defaultItemRender : _this$props$itemRende,
        maxWidth = _this$props.maxWidth,
        size = _this$props.size;
      if (routes && routes.length > 0) {
        var paths = [];
        crumbs = (0, _map["default"])(routes).call(routes, function (route) {
          var _context;
          route.path = route.path || '';
          var path = route.path.replace(/^\//, '');
          (0, _forEach["default"])(_context = (0, _keys["default"])(params)).call(_context, function (key) {
            path = path.replace(":".concat(key), params[key]);
          });
          if (path) {
            paths.push(path);
          }
          return /*#__PURE__*/React.createElement(_BreadcrumbItem["default"], {
            separator: separator,
            key: route.breadcrumbName || path,
            maxWidth: maxWidth
          }, itemRender(route, params, routes, paths));
        });
      } else if (children) {
        var _context2;
        crumbs = (0, _map["default"])(_context2 = React.Children).call(_context2, children, function (element, index) {
          if (!element) {
            return element;
          }
          (0, _warning["default"])(element.type && element.type.__FISHD_BREADCRUMB_ITEM, "Breadcrumb only accepts Breadcrumb.Item as it's children");
          return /*#__PURE__*/(0, React.cloneElement)(element, {
            separator: separator,
            maxWidth: maxWidth,
            key: index
          });
        });
      }
      var cls = (0, _classnames["default"])(className, prefixCls, {
        small: size === 'small'
      });
      return /*#__PURE__*/React.createElement("div", {
        className: cls,
        style: style
      }, crumbs);
    }
  }]);
  return Breadcrumb;
}(React.Component);
exports["default"] = Breadcrumb;
Breadcrumb.defaultProps = {
  prefixCls: 'fishd-breadcrumb',
  separator: /*#__PURE__*/React.createElement(_Icon["default"], {
    type: "arrow-line-regular"
  }),
  size: 'default'
};
Breadcrumb.propTypes = {
  prefixCls: _propTypes["default"].string,
  size: _propTypes["default"].string,
  separator: _propTypes["default"].node,
  routes: _propTypes["default"].array,
  params: _propTypes["default"].object,
  linkRender: _propTypes["default"].func,
  nameRender: _propTypes["default"].func
};