import React, { Component } from 'react';
import CollapsePanel from './Panel';
export declare type KeyedReactChild = {
    key: any;
    props: any;
} & React.ReactChild;
export interface CollapseProps {
    prefixCls: string;
    className: string;
    defaultActiveKey: string | string[];
    activeKey: string | string[];
    isScrollToHeader: boolean;
    accordion: boolean;
    showClose: boolean;
    bordered: boolean;
    onChange: (value: string) => void;
    close: (e: any) => void;
    statusList: any[];
}
export interface CollapseState {
    activeKey?: string | string[];
    statusList?: any[];
    prevProps?: CollapseProps;
}
declare class Collapse extends Component<CollapseProps, CollapseState> {
    static propTypes: {
        children: any;
        prefixCls: any;
        className: any;
        defaultActiveKey: any;
        activeKey: any;
        isScrollToHeader: any;
        accordion: any;
        showClose: any;
        bordered: any;
        statusList: any;
        onChange: any;
        close: any;
    };
    collapse: HTMLElement;
    static defaultProps: {
        prefixCls: string;
        isScrollToHeader: boolean;
        accordion: boolean;
        showClose: boolean;
        bordered: boolean;
        onChange(value: any): void;
        close(e: React.MouseEvent): void;
    };
    static Panel: typeof CollapsePanel;
    static getDerivedStateFromProps(nextProps: CollapseProps, prevState: CollapseState): CollapseState;
    currentKey: any;
    constructor(props: any);
    componentDidUpdate(prevProps: any, prevState: any): void;
    onClickItem(key: any): () => void;
    onCloseItem(key: any): () => void;
    getItems(): React.ReactElement<any>[];
    setActiveKey(activeKey: any): void;
    scrollToHeader(): void;
    render(): JSX.Element;
}
export default Collapse;
