"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireDefault(require("react"));
var _reactDom = require("react-dom");
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function rgbaColor(r, g, b, a) {
  return "rgba(".concat([r, g, b, a / 100].join(','), ")");
}
var Alpha = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Alpha, _React$Component);
  var _super = _createSuper(Alpha);
  function Alpha(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Alpha);
    _this = _super.call(this, props);
    _this.onMouseDown = function (e) {
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
      window.addEventListener('mousemove', _this.onDrag);
      window.addEventListener('mouseup', _this.onDragEnd);
    };
    _this.onDrag = function (e) {
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
    };
    _this.onDragEnd = function (e) {
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
      _this.removeListeners();
    };
    _this.getBackground = function () {
      var _context;
      var _this$props$color = _this.props.color,
        red = _this$props$color.red,
        green = _this$props$color.green,
        blue = _this$props$color.blue;
      var opacityGradient = (0, _concat["default"])(_context = "linear-gradient(to right, ".concat(rgbaColor(red, green, blue, 0), " , ")).call(_context, rgbaColor(red, green, blue, 100), ")");
      return opacityGradient;
    };
    _this.getPrefixCls = function () {
      return "".concat(_this.props.rootPrefixCls, "-alpha");
    };
    _this.pointMoveTo = function (coords) {
      var rect = (0, _reactDom.findDOMNode)((0, _assertThisInitialized2["default"])(_this)).getBoundingClientRect();
      var width = rect.width;
      var left = coords.x - rect.left;
      left = Math.max(0, left);
      left = Math.min(left, width);
      var alpha = Math.round(left / width * 100);
      _this.props.onChange(alpha);
    };
    _this.removeListeners = function () {
      window.removeEventListener('mousemove', _this.onDrag);
      window.removeEventListener('mouseup', _this.onDragEnd);
    };
    return _this;
  }
  (0, _createClass2["default"])(Alpha, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeListeners();
    }
  }, {
    key: "render",
    value: function render() {
      var prefixCls = this.getPrefixCls();
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: prefixCls
      }, /*#__PURE__*/_react["default"].createElement("div", {
        ref: "bg",
        className: "".concat(prefixCls, "-bg"),
        style: {
          background: this.getBackground()
        }
      }), /*#__PURE__*/_react["default"].createElement("span", {
        style: {
          left: "".concat(this.props.alpha, "%")
        }
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-handler"),
        onMouseDown: this.onMouseDown
      }));
    }
  }]);
  return Alpha;
}(_react["default"].Component);
exports["default"] = Alpha;
Alpha.propTypes = {
  alpha: _propTypes["default"].number,
  color: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  rootPrefixCls: _propTypes["default"].string
};