"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _color = _interopRequireDefault(require("./helpers/color"));
var _validationColor = _interopRequireDefault(require("./utils/validationColor"));
var _Params = _interopRequireDefault(require("./Params"));
var _Board = _interopRequireDefault(require("./Board"));
var _Preview = _interopRequireDefault(require("./Preview"));
var _Ribbon = _interopRequireDefault(require("./Ribbon"));
var _Alpha = _interopRequireDefault(require("./Alpha"));
var _History = _interopRequireDefault(require("./History"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
// @ts-nocheck

function noop() {}
var Panel = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Panel, _React$Component);
  var _super = _createSuper(Panel);
  function Panel(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Panel);
    _this = _super.call(this, props);
    _this.onSystemColorPickerOpen = function (e) {
      // only work with broswer which support color input
      if (e.target.type === 'color') {
        _this.systemColorPickerOpen = true;
      }
    };
    _this.onFocus = function () {
      if (_this._blurTimer) {
        clearTimeout(_this._blurTimer);
        _this._blurTimer = null;
      } else {
        _this.props.onFocus();
      }
    };
    _this.onBlur = function () {
      if (_this._blurTimer) {
        clearTimeout(_this._blurTimer);
      }
      _this._blurTimer = (0, _setTimeout2["default"])(function () {
        // if is system color picker open, then stop run blur
        if (_this.systemColorPickerOpen) {
          _this.systemColorPickerOpen = false;
          return;
        }
        _this.props.onBlur();
      }, 100);
    };
    /**
     * 响应 alpha 的变更
     * @param  {Number} alpha Range 0~100
     */
    _this.handleAlphaChange = function (alpha) {
      var color = _this.state.color;
      color.alpha = alpha;
      _this.setState({
        alpha: alpha,
        color: color
      });
      _this.props.onChange({
        color: color.toHexString(),
        alpha: alpha
      });
    };
    /**
     * color change
     * @param  {Object}  color      tinycolor instance
     */
    _this.handleChange = function (color) {
      var alpha = _this.state.alpha;
      color.alpha = alpha;
      _this.setState({
        color: color
      });
      _this.props.onChange({
        color: color.toHexString(),
        alpha: color.alpha
      });
    };
    /**
     * 响应 History 的变更
     * @param  {Object} obj color and alpha
     */
    _this.handleHistoryClick = function (obj) {
      _this.setState({
        color: new _color["default"](obj.color),
        alpha: obj.alpha
      });
      _this.props.onChange({
        color: obj.color,
        alpha: obj.alpha
      });
    };
    var alpha = typeof props.alpha === 'undefined' ? props.defaultAlpha : Math.min(props.alpha, props.defaultAlpha);
    var color = new _color["default"](props.color || props.defaultColor);
    _this.state = {
      color: color,
      alpha: alpha
    };
    return _this;
  }
  (0, _createClass2["default"])(Panel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.onMount(this.ref);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        enableAlpha = _this$props.enableAlpha,
        enableHistory = _this$props.enableHistory,
        colorHistory = _this$props.colorHistory;
      var _this$state = this.state,
        color = _this$state.color,
        alpha = _this$state.alpha;
      var wrapClasses = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-wrap"), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-wrap-has-alpha"), enableAlpha), _classNames));
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: function ref(_ref) {
          return _this2.ref = _ref;
        },
        className: [prefixCls, this.props.className].join(' '),
        style: this.props.style,
        onFocus: this.onFocus,
        onBlur: this.onBlur,
        tabIndex: 0
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-inner")
      }, /*#__PURE__*/_react["default"].createElement(_Board["default"], {
        rootPrefixCls: prefixCls,
        color: color,
        onChange: this.handleChange
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: wrapClasses
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-wrap-ribbon")
      }, /*#__PURE__*/_react["default"].createElement(_Ribbon["default"], {
        rootPrefixCls: prefixCls,
        color: color,
        onChange: this.handleChange
      })), enableAlpha && /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-wrap-alpha")
      }, /*#__PURE__*/_react["default"].createElement(_Alpha["default"], {
        rootPrefixCls: prefixCls,
        alpha: alpha,
        color: color,
        onChange: this.handleAlphaChange
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-wrap-preview")
      }, /*#__PURE__*/_react["default"].createElement(_Preview["default"], {
        rootPrefixCls: prefixCls,
        alpha: alpha,
        onChange: this.handleChange,
        onInputClick: this.onSystemColorPickerOpen,
        color: color
      }))), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-wrap"),
        style: {
          height: 40,
          marginTop: 6
        }
      }, /*#__PURE__*/_react["default"].createElement(_Params["default"], {
        rootPrefixCls: prefixCls,
        color: color,
        alpha: alpha,
        onAlphaChange: this.handleAlphaChange,
        onChange: this.handleChange,
        mode: this.props.mode,
        enableAlpha: this.props.enableAlpha,
        enableHistory: this.props.enableHistory
      })), enableHistory && /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-wrap-history")
      }, /*#__PURE__*/_react["default"].createElement(_History["default"], {
        prefixCls: prefixCls,
        colorHistory: colorHistory,
        onHistoryClick: this.handleHistoryClick,
        maxHistory: this.props.maxHistory
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if ('color' in nextProps) {
        newState.color = new _color["default"](nextProps.color);
      }
      if ('alpha' in nextProps && nextProps.alpha !== undefined) {
        newState.alpha = nextProps.alpha;
      }
      return newState;
    }
  }]);
  return Panel;
}(_react["default"].Component);
Panel.propTypes = {
  alpha: _propTypes["default"].number,
  className: _propTypes["default"].string,
  color: _validationColor["default"],
  colorHistory: _propTypes["default"].array,
  defaultAlpha: _propTypes["default"].number,
  defaultColor: _validationColor["default"],
  enableAlpha: _propTypes["default"].bool,
  enableHistory: _propTypes["default"].bool,
  maxHistory: _propTypes["default"].number,
  mode: _propTypes["default"].oneOf(['RGB', 'HSL', 'HSB']),
  onBlur: _propTypes["default"].func,
  onChange: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onMount: _propTypes["default"].func,
  prefixCls: _propTypes["default"].string,
  style: _propTypes["default"].object
};
Panel.defaultProps = {
  className: '',
  colorHistory: [],
  defaultAlpha: 100,
  defaultColor: '#e93334',
  enableAlpha: false,
  enableHistory: true,
  maxHistory: 8,
  mode: 'RGB',
  onBlur: noop,
  onChange: noop,
  onFocus: noop,
  onMount: noop,
  prefixCls: 'fishd-color-picker-panel',
  style: {}
};
(0, _reactLifecyclesCompat.polyfill)(Panel);
var _default = Panel;
exports["default"] = _default;