"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _color = _interopRequireDefault(require("./helpers/color"));
var _percentage = _interopRequireDefault(require("./helpers/percentage"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var modesMap = ['RGB', 'HSB'];
var Params = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Params, _React$Component);
  var _super = _createSuper(Params);
  function Params(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Params);
    _this = _super.call(this, props);
    _this.getChannelInRange = function (value, index) {
      var channelMap = {
        RGB: [[0, 255], [0, 255], [0, 255]],
        HSB: [[0, 359], [0, 100], [0, 100]]
      };
      var mode = _this.state.mode;
      var range = channelMap[mode][index];
      var result = (0, _parseInt2["default"])(value, 10);
      if (isNaN(result)) {
        result = 0;
      }
      result = Math.max(range[0], result);
      result = Math.min(result, range[1]);
      return result;
    };
    _this.getPrefixCls = function () {
      return "".concat(_this.props.rootPrefixCls, "-params");
    };
    _this.handleHexBlur = function () {
      var hex = _this.state.hex;
      var color = null;
      if (_color["default"].isValidHex(hex)) {
        color = new _color["default"](hex);
      }
      if (color !== null) {
        _this.setState({
          color: color,
          hex: hex
        });
        _this.props.onChange(color, false);
      }
    };
    _this.handleHexPress = function (event) {
      var hex = _this.state.hex;
      if (event.nativeEvent.which === 13) {
        var color = null;
        if (_color["default"].isValidHex(hex)) {
          color = new _color["default"](hex);
        }
        if (color !== null) {
          _this.setState({
            color: color,
            hex: hex
          });
          _this.props.onChange(color, false);
        }
      }
    };
    _this.handleHexChange = function (event) {
      var hex = event.target.value;
      _this.setState({
        hex: hex
      });
    };
    _this.handleModeChange = function () {
      var mode = _this.state.mode;
      var modeIndex = ((0, _indexOf["default"])(modesMap).call(modesMap, mode) + 1) % modesMap.length;
      mode = modesMap[modeIndex];
      _this.setState({
        mode: mode
      });
    };
    _this.handleAlphaHandler = function (event) {
      var alpha = (0, _parseInt2["default"])(event.target.value, 10);
      if (isNaN(alpha)) {
        alpha = 0;
      }
      alpha = Math.max(0, alpha);
      alpha = Math.min(alpha, 100);
      _this.props.onAlphaChange(alpha);
    };
    _this.updateColorByChanel = function (channel, value) {
      var color = _this.props.color;
      var mode = _this.state.mode;
      if (mode === 'HSB') {
        if (channel === 'H') {
          color.hue = (0, _parseInt2["default"])(value, 10);
        } else if (channel === 'S') {
          color.saturation = (0, _parseInt2["default"])(value, 10) / 100;
        } else if (channel === 'B') {
          color.brightness = (0, _parseInt2["default"])(value, 10) / 100;
        }
      } else {
        if (channel === 'R') {
          color.red = (0, _parseInt2["default"])(value, 10);
        } else if (channel === 'G') {
          color.green = (0, _parseInt2["default"])(value, 10);
        } else if (channel === 'B') {
          color.blue = (0, _parseInt2["default"])(value, 10);
        }
      }
      return color;
    };
    _this.handleColorChannelChange = function (index, event) {
      var value = _this.getChannelInRange(event.target.value, index);
      var mode = _this.state.mode;
      var channel = mode[index];
      var color = _this.updateColorByChanel(channel, value);
      _this.setState({
        hex: color.hex,
        color: color
      }, function () {
        _this.props.onChange(color, false);
      });
    };
    // 管理 input 的状态
    _this.state = {
      mode: props.mode,
      hex: props.color.hex,
      color: props.color // instanceof tinycolor
    };

    return _this;
  }
  (0, _createClass2["default"])(Params, [{
    key: "render",
    value: function render() {
      var _classNames, _context, _context2, _context3;
      var prefixCls = this.getPrefixCls();
      var _this$props = this.props,
        enableAlpha = _this$props.enableAlpha,
        enableHistory = _this$props.enableHistory;
      var _this$state = this.state,
        mode = _this$state.mode,
        color = _this$state.color;
      var colorChannel = color[mode];
      if (mode === 'HSB') {
        colorChannel[0] = (0, _parseInt2["default"])(colorChannel[0], 10);
        colorChannel[1] = (0, _percentage["default"])(colorChannel[1]);
        colorChannel[2] = (0, _percentage["default"])(colorChannel[2]);
      }
      var paramsClasses = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, prefixCls, true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-has-history"), enableHistory), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-has-alpha"), enableAlpha), _classNames));
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: paramsClasses
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-input")
      }, /*#__PURE__*/_react["default"].createElement("input", {
        className: "".concat(prefixCls, "-hex"),
        type: "text",
        maxLength: 6,
        onKeyPress: this.handleHexPress,
        onBlur: this.handleHexBlur,
        onChange: this.handleHexChange,
        value: this.state.hex.toLowerCase()
      }), /*#__PURE__*/_react["default"].createElement("input", {
        type: "number",
        ref: "channel_0",
        value: colorChannel[0],
        onChange: (0, _bind["default"])(_context = this.handleColorChannelChange).call(_context, null, 0)
      }), /*#__PURE__*/_react["default"].createElement("input", {
        type: "number",
        ref: "channel_1",
        value: colorChannel[1],
        onChange: (0, _bind["default"])(_context2 = this.handleColorChannelChange).call(_context2, null, 1)
      }), /*#__PURE__*/_react["default"].createElement("input", {
        type: "number",
        ref: "channel_2",
        value: colorChannel[2],
        onChange: (0, _bind["default"])(_context3 = this.handleColorChannelChange).call(_context3, null, 2)
      }), enableAlpha && /*#__PURE__*/_react["default"].createElement("input", {
        type: "number",
        value: Math.round(this.props.alpha),
        onChange: this.handleAlphaHandler
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-lable")
      }, /*#__PURE__*/_react["default"].createElement("label", {
        className: "".concat(prefixCls, "-lable-hex")
      }, "Hex"), /*#__PURE__*/_react["default"].createElement("label", {
        className: "".concat(prefixCls, "-lable-number"),
        onClick: this.handleModeChange
      }, mode[0]), /*#__PURE__*/_react["default"].createElement("label", {
        className: "".concat(prefixCls, "-lable-number"),
        onClick: this.handleModeChange
      }, mode[1]), /*#__PURE__*/_react["default"].createElement("label", {
        className: "".concat(prefixCls, "-lable-number"),
        onClick: this.handleModeChange
      }, mode[2]), enableAlpha && /*#__PURE__*/_react["default"].createElement("label", {
        className: "".concat(prefixCls, "-lable-alpha")
      }, "A")));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if ('color' in nextProps) {
        newState.color = nextProps.color;
        newState.hex = nextProps.color.hex;
      }
      return newState;
    }
  }]);
  return Params;
}(_react["default"].Component);
Params.propTypes = {
  alpha: _propTypes["default"].number,
  color: _propTypes["default"].object.isRequired,
  enableAlpha: _propTypes["default"].bool,
  enableHistory: _propTypes["default"].bool,
  mode: _propTypes["default"].oneOf(modesMap),
  onAlphaChange: _propTypes["default"].func,
  onChange: _propTypes["default"].func,
  rootPrefixCls: _propTypes["default"].string
};
Params.defaultProps = {
  mode: modesMap[0],
  enableAlpha: true
};
(0, _reactLifecyclesCompat.polyfill)(Params);
var _default = Params;
exports["default"] = _default;