import React from 'react';
import typeColor from './utils/validationColor';
import Color from './helpers/color';
import { ColorPickerProps } from './ColorPicker';
import { ParamsColor } from './Params';
declare function noop(): void;
declare type QuickPanelProps = Omit<ColorPickerProps, 'children'> & {
    __useInComponent: boolean;
    onBlur?: () => void;
    onFocus?: () => void;
    onMount?: (ref: HTMLElement) => void;
    userSelectColor: boolean;
};
export declare type ColorType = string | ParamsColor | Color;
interface QuickPanelState {
    color?: ColorType;
    alpha?: number;
    visible?: boolean;
    colorHistory?: ColorType[];
}
declare class QuickPanel extends React.Component<QuickPanelProps, QuickPanelState> {
    _blurTimer: any;
    ref: HTMLDivElement;
    systemColorPickerOpen: boolean;
    static propTypes: {
        __useInComponent: any;
        alpha: any;
        className: any;
        color: typeof typeColor;
        colorHistory: any;
        colorMap: any;
        defaultAlpha: any;
        defaultColor: typeof typeColor;
        disabled: any;
        enableAlpha: any;
        enableHistory: any;
        getPopupContainer: any;
        maxHistory: any;
        mode: any;
        onBlur: any;
        onChange: any;
        onFocus: any;
        onMount: any;
        onVisibleChange: any;
        prefixCls: any;
        userSelectColor: any;
        style: any;
        popupStyle: any;
        esc: any;
    };
    static defaultProps: {
        __useInComponent: boolean;
        className: string;
        colorHistory: any[];
        colorMap: string[];
        defaultAlpha: number;
        defaultColor: string;
        enableAlpha: boolean;
        enableHistory: boolean;
        maxHistory: number;
        mode: string;
        onBlur: typeof noop;
        onChange: typeof noop;
        onFocus: typeof noop;
        onMount: typeof noop;
        onVisibleChange: typeof noop;
        prefixCls: string;
        userSelectColor: boolean;
        style: {};
        popupStyle: {};
        esc: boolean;
    };
    static getDerivedStateFromProps(nextProps: any, prevState: any): QuickPanelState;
    constructor(props: any);
    componentDidMount(): void;
    onFocus: () => void;
    onBlur: () => void;
    handleChange: (color: any, alpha: any, fireChange?: boolean) => void;
    onChange: (colors: any) => void;
    onVisibleChangeFromTrigger: (visible: any) => void;
    onPanelMount: (panelDOMRef: HTMLElement) => void;
    handleKeyDown: (e: any) => void;
    handleSpnKeyDown: (e: any) => void;
    setVisible: (visible: boolean, callback?: any) => void;
    getPickerElement: () => JSX.Element;
    render(): JSX.Element;
}
export default QuickPanel;
