"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Mode = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));
var _symbol = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/symbol"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Input = _interopRequireDefault(require("../Input"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _rcTrigger = _interopRequireDefault(require("rc-trigger"));
var _constants = require("./constants");
var _utils = require("./libs/utils");
var _KeyCode = _interopRequireDefault(require("../../utils/KeyCode"));
var _date = require("../../utils/date");
var _placements = _interopRequireDefault(require("./placements"));
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var haveTriggerType = function haveTriggerType(type) {
  return (0, _indexOf["default"])(_constants.HAVE_TRIGGER_TYPES).call(_constants.HAVE_TRIGGER_TYPES, type) !== -1;
};
var isInputValid = function isInputValid(text, date) {
  if ((0, _trim["default"])(text).call(text) === '' || !(0, _date.isValidValue)(date)) return false;
  return true;
};
var $type = (0, _symbol["default"])('type');
var Mode;
exports.Mode = Mode;
(function (Mode) {
  Mode["YEAR"] = "year";
  Mode["MONTH"] = "month";
  Mode["WEEK"] = "week";
  Mode["DAY"] = "day";
  Mode["RANGE"] = "range";
})(Mode || (exports.Mode = Mode = {}));
var BasePicker = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(BasePicker, _React$Component);
  var _super = _createSuper(BasePicker);
  function BasePicker(props, _type, state) {
    var _this$state2;
    var _this;
    (0, _classCallCheck2["default"])(this, BasePicker);
    _this = _super.call(this, props);
    _this.onPicked = function (value) {
      var isKeepPannel = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var isConfirmValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      _this.setState({
        pickerVisible: isKeepPannel,
        value: value,
        text: _this.dateToStr(value)
      }, function () {
        _this.props.onVisibleChange(isKeepPannel);
      });
      if (isConfirmValue) {
        _this.setState({
          confirmValue: value
        });
        _this.props.onChange(value);
      }
    };
    _this.onCancelPicked = function () {
      var confirmValue = _this.state.confirmValue;
      _this.setState({
        pickerVisible: false,
        value: confirmValue ? confirmValue : null,
        text: confirmValue ? _this.dateToStr(confirmValue) : ''
      }, function () {
        _this.props.onVisibleChange(false);
      });
    };
    // 聚焦
    _this.handleFocus = function (e) {
      _this.props.onFocus(e);
    };
    // 失焦
    _this.handleBlur = function (e) {
      _this.props.onBlur(e);
    };
    // 键盘事件
    _this.handleKeydown = function (evt) {
      var keyCode = evt.keyCode;
      // esc
      if (_this.props.esc && keyCode === _KeyCode["default"].ESC) {
        _this.setState({
          pickerVisible: false
        }, function () {
          _this.props.onVisibleChange(false);
        });
        _this.refInputRoot.blur();
        evt.stopPropagation();
      }
      // enter
      if (keyCode === _KeyCode["default"].ENTER) {
        _this.setState({
          pickerVisible: false
        }, function () {
          _this.saveValidInputValue();
        });
        _this.refInputRoot.blur();
      }
    };
    // 点击清空图标
    _this.handleClickCloseIcon = function (e) {
      e && e.stopPropagation();
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        allowClear = _this$props.allowClear;
      var text = _this.state.text;
      if (disabled || !allowClear) return;
      if (!text) {
        _this.togglePickerVisible();
      } else {
        _this.setState({
          text: '',
          value: null,
          pickerVisible: false,
          confirmValue: null
        }, function () {
          _this.props.onVisibleChange(false);
          _this.props.onChange(null);
        });
      }
    };
    // 面板打开或关闭的回调
    _this.onVisibleChange = function (visible) {
      if (_this.inputClick && !visible) {
        _this.inputClick = false;
        return;
      }
      _this.inputClick = false;
      _this.setState({
        pickerVisible: visible
      }, function () {
        if (!visible) {
          _this.saveValidInputValue();
        } else {
          _this.props.onVisibleChange(visible);
        }
      });
    };
    // 保存合法的输入值
    _this.saveValidInputValue = function () {
      var _this$state = _this.state,
        value = _this$state.value,
        confirmValue = _this$state.confirmValue;
      if (_this.isDateValid(value) && !(0, _date.equalDate)(value, confirmValue)) {
        _this.onPicked(value, false, true);
      } else {
        _this.onCancelPicked();
      }
    };
    (0, _utils.require_condition)(typeof _type === 'string');
    _this.type = _type;
    _this.inputClick = false;
    _this.state = (_this$state2 = {}, (0, _defineProperty2["default"])(_this$state2, $type, _type), (0, _defineProperty2["default"])(_this$state2, "pickerVisible", false), (0, _defineProperty2["default"])(_this$state2, "value", null), (0, _defineProperty2["default"])(_this$state2, "text", ''), (0, _defineProperty2["default"])(_this$state2, "confirmValue", null), _this$state2);
    return _this;
  }
  (0, _createClass2["default"])(BasePicker, [{
    key: "isDateValid",
    value: function isDateValid(date) {
      return date === null || (0, _date.isValidValue)(date);
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state, props) {
      throw new _utils.Errors.MethodImplementationRequiredError(props.toString());
    }
  }, {
    key: "getFormatSeparator",
    value: function getFormatSeparator() {
      return undefined;
    }
  }, {
    key: "dateToStr",
    value: function dateToStr(date) {
      return BasePicker.dateToStr(date, this.type, this.props.format, this.getFormatSeparator());
    }
    // (string) => Date | null
  }, {
    key: "parseDate",
    value: function parseDate(dateStr) {
      if (!dateStr) return null;
      var type = this.type;
      var parser = (_constants.TYPE_VALUE_RESOLVER_MAP[type] || _constants.TYPE_VALUE_RESOLVER_MAP['default']).parser;
      return parser(dateStr, this.getFormat(), this.getFormatSeparator());
    }
  }, {
    key: "getFormat",
    value: function getFormat() {
      return this.props.format || _constants.DEFAULT_FORMATS[this.type];
    }
  }, {
    key: "togglePickerVisible",
    value: function togglePickerVisible() {
      var _this2 = this;
      this.setState({
        pickerVisible: !this.state.pickerVisible
      }, function () {
        _this2.props.onVisibleChange(!_this2.state.pickerVisible);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        className = _this$props2.className,
        placeholder = _this$props2.placeholder,
        placement = _this$props2.placement,
        prefixCls = _this$props2.prefixCls,
        getPopupContainer = _this$props2.getPopupContainer,
        showTrigger = _this$props2.showTrigger,
        allowClear = _this$props2.allowClear,
        disabled = _this$props2.disabled,
        style = _this$props2.style;
      var _this$state3 = this.state,
        pickerVisible = _this$state3.pickerVisible,
        value = _this$state3.value,
        text = _this$state3.text;
      var triggerClass = function triggerClass() {
        var _context, _context2;
        return (0, _includes["default"])(_context = _this3.type).call(_context, 'date') || (0, _includes["default"])(_context2 = _this3.type).call(_context2, 'week') ? 'date-line' : 'time-line';
      };
      var calcIsShowTrigger = function calcIsShowTrigger() {
        if (showTrigger != null) {
          return !!showTrigger;
        } else {
          return haveTriggerType(_this3.type);
        }
      };
      // 前缀图标
      var prefixIcon = function prefixIcon() {
        if (calcIsShowTrigger()) {
          return /*#__PURE__*/React.createElement(_Icon["default"], {
            className: (0, _classnames["default"])("".concat(prefixCls, "-date-picker-icon"), 'prefix-iconfont'),
            type: triggerClass()
          });
        } else {
          return null;
        }
      };
      // 后缀图标
      var suffixIcon = function suffixIcon() {
        if (text && allowClear) {
          return /*#__PURE__*/React.createElement(_Icon["default"], {
            className: (0, _classnames["default"])("".concat(prefixCls, "-date-picker-icon"), 'suffix-iconfont'),
            type: "close-circle-fill",
            onClick: _this3.handleClickCloseIcon
          });
        } else {
          return null;
        }
      };
      // 下拉面板
      var getPickerPanel = function getPickerPanel() {
        return _this3.pickerPanel(_this3.state);
      };
      // 选择框
      var getInputPanel = function getInputPanel() {
        var _context3;
        return /*#__PURE__*/React.createElement("span", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-date-editor"), className, {
            'is-have-trigger': calcIsShowTrigger(),
            'is-active': pickerVisible,
            'is-filled': !!value,
            'is-disable': disabled
          }),
          style: (0, _assign["default"])({}, style),
          onClick: function onClick() {
            return _this3.inputClick = true;
          }
        }, /*#__PURE__*/React.createElement("div", {
          className: (0, _classnames["default"])((0, _concat["default"])(_context3 = "".concat(prefixCls, "-date-editor--")).call(_context3, _this3.type), {
            'is-active': pickerVisible,
            disabled: disabled
          })
        }, /*#__PURE__*/React.createElement(_Input["default"], {
          disabled: disabled,
          type: "text",
          placeholder: placeholder,
          onFocus: _this3.handleFocus,
          onBlur: _this3.handleBlur,
          onKeyDown: _this3.handleKeydown,
          onChange: function onChange(e) {
            var inputValue = e.target.value;
            var ndate = _this3.parseDate(inputValue);
            if (!isInputValid(inputValue, ndate)) {
              _this3.setState({
                text: inputValue,
                pickerVisible: true
              });
            } else {
              //only set value on a valid date input
              _this3.setState({
                text: inputValue,
                value: ndate,
                pickerVisible: true
              });
            }
          },
          ref: function ref(e) {
            return _this3.refInputRoot = e;
          },
          value: text,
          prefix: prefixIcon(),
          suffix: suffixIcon()
        })));
      };
      return /*#__PURE__*/React.createElement(_rcTrigger["default"], {
        action: disabled ? [] : ['click'],
        builtinPlacements: _placements["default"],
        ref: function ref(node) {
          return _this3.trigger = node;
        },
        getPopupContainer: getPopupContainer,
        onPopupVisibleChange: this.onVisibleChange,
        popup: getPickerPanel(),
        popupPlacement: placement,
        popupVisible: pickerVisible,
        prefixCls: "".concat(prefixCls, "-date-time-picker-popup"),
        destroyPopupOnHide: true
      }, getInputPanel());
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        className: _propTypes["default"].string,
        placeholder: _propTypes["default"].string,
        format: _propTypes["default"].string,
        disabledDate: _propTypes["default"].func,
        footer: _propTypes["default"].func,
        showTime: _propTypes["default"].bool,
        showWeekNumber: _propTypes["default"].bool,
        shortcuts: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          text: _propTypes["default"].string.isRequired,
          onClick: _propTypes["default"].func.isRequired
        })),
        placement: _propTypes["default"].oneOf(['bottomLeft', 'bottomCenter', 'bottomRight', 'topLeft', 'topCenter', 'topRight']),
        prefixCls: _propTypes["default"].string,
        firstDayOfWeek: _propTypes["default"].number,
        getPopupContainer: _propTypes["default"].func,
        showTrigger: _propTypes["default"].bool,
        allowClear: _propTypes["default"].bool,
        disabled: _propTypes["default"].bool,
        esc: _propTypes["default"].bool,
        value: _propTypes["default"].instanceOf(Date),
        onFocus: _propTypes["default"].func,
        onBlur: _propTypes["default"].func,
        onChange: _propTypes["default"].func,
        onVisibleChange: _propTypes["default"].func,
        style: _propTypes["default"].object,
        yearCount: _propTypes["default"].number
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        placeholder: '',
        placement: 'bottomLeft',
        prefixCls: 'fishd',
        showTrigger: true,
        allowClear: true,
        disabled: false,
        esc: true,
        onFocus: function onFocus() {},
        onBlur: function onBlur() {},
        onChange: function onChange() {},
        onVisibleChange: function onVisibleChange() {}
      };
    }
  }, {
    key: "dateToStr",
    value: function dateToStr(date, type, format, separator) {
      if (!date || !(0, _date.isValidValue)(date)) return '';
      var tdate = date;
      var formatter = (_constants.TYPE_VALUE_RESOLVER_MAP[type] || _constants.TYPE_VALUE_RESOLVER_MAP['default']).formatter;
      var result = formatter(tdate, format || _constants.DEFAULT_FORMATS[type], separator);
      return result;
    }
  }]);
  return BasePicker;
}(React.Component);
BasePicker.getDerivedStateFromProps = function (nextProps, prevState) {
  if ('value' in nextProps && !(0, _isEqual["default"])(nextProps.value, prevState.prevPropValue)) {
    var validDate = (0, _date.isValidValue)(nextProps.value) ? nextProps.value : null;
    var text = (0, _date.isValidValue)(nextProps.value) ? BasePicker.dateToStr(nextProps.value, prevState[$type], nextProps.format, nextProps.separator) : '';
    var state = {
      value: validDate,
      text: text,
      // 增加一个confirmValue记录每次确定的值，当点击"取消"或者输入不合法时，恢复这个值
      confirmValue: validDate
    };
    state.prevPropValue = nextProps.value;
    return state;
  }
  return null;
};
var _default = BasePicker;
exports["default"] = _default;