"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));
var _symbol = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/symbol"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Input = _interopRequireDefault(require("../Input"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _rcTrigger = _interopRequireDefault(require("rc-trigger"));
var _constants = require("./constants");
var _utils = require("./libs/utils");
var _KeyCode = _interopRequireDefault(require("../../utils/KeyCode"));
var _date = require("../../utils/date");
var _placements = _interopRequireDefault(require("./placements"));
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var haveTriggerType = function haveTriggerType(type) {
  return (0, _indexOf["default"])(_constants.HAVE_TRIGGER_TYPES).call(_constants.HAVE_TRIGGER_TYPES, type) !== -1;
};
var isInputValid = function isInputValid(text, date) {
  if ((0, _trim["default"])(text).call(text) === '' || !(0, _date.isValidValue)(date)) return false;
  return true;
};
var $type = (0, _symbol["default"])('type');
var DateRangeBasePicker = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(DateRangeBasePicker, _React$Component);
  var _super = _createSuper(DateRangeBasePicker);
  function DateRangeBasePicker(props, _type, state) {
    var _this;
    (0, _classCallCheck2["default"])(this, DateRangeBasePicker);
    _this = _super.call(this, props);
    _this.onPicked = function (value) {
      var isKeepPannel = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var isConfirmValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      // 当为日期范围选择面板时，把结束时间默认设置为23:59:59:999
      if (_this.type == 'daterange' && value && value.length === 2) {
        value[1] = new Date(value[1].setHours(23, 59, 59, 999));
      }
      _this.setState({
        pickerVisible: isKeepPannel,
        value: value,
        text: value && value.length === 2 ? [_this.dateToStr(value[0]), _this.dateToStr(value[1])] : ''
      }, function () {
        _this.props.onVisibleChange(isKeepPannel);
      });
      if (isConfirmValue) {
        _this.setState({
          confirmValue: value
        });
        _this.props.onChange(value);
      }
    };
    _this.onCancelPicked = function () {
      _this.setState({
        pickerVisible: false,
        value: _this.state.confirmValue && _this.state.confirmValue.length === 2 ? _this.state.confirmValue : null,
        text: _this.state.confirmValue && _this.state.confirmValue.length === 2 ? [_this.dateToStr(new Date(_this.state.confirmValue[0])), _this.dateToStr(new Date(_this.state.confirmValue[1]))] : ''
      }, function () {
        _this.props.onVisibleChange(false);
      });
    };
    _this.dateToStr = function (date) {
      return DateRangeBasePicker.dateToStr(date, _this.type, _this.getFormat(), _this.getFormatSeparator());
    };
    _this.parseDate = function (dateStr) {
      if (!dateStr) return null;
      var type = _this.type;
      var parser = _constants.TYPE_VALUE_RESOLVER_MAP['date'].parser;
      return parser(dateStr, _this.getFormat(), _this.getFormatSeparator());
    };
    // 聚焦
    _this.handleFocus = function (e) {
      _this.props.onFocus(e);
    };
    // 失焦
    _this.handleBlur = function (e) {
      _this.props.onBlur(e);
    };
    // 键盘事件
    _this.handleKeydown = function (evt) {
      var keyCode = evt.keyCode;
      // esc
      if (_this.props.esc && keyCode === _KeyCode["default"].ESC) {
        _this.setState({
          pickerVisible: false
        }, function () {
          _this.props.onVisibleChange(false);
        });
        _this.refInputRoot.blur();
        evt.stopPropagation();
      }
      // enter
      if (keyCode === _KeyCode["default"].ENTER) {
        _this.setState({
          pickerVisible: false
        }, function () {
          _this.saveValidInputValue();
        });
        _this.refInputRoot.blur();
      }
    };
    // 点击清空图标
    _this.handleClickCloseIcon = function (e) {
      e && e.stopPropagation();
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        allowClear = _this$props.allowClear;
      var text = _this.state.text;
      if (disabled || !allowClear) return;
      if (!text) {
        _this.togglePickerVisible();
      } else {
        _this.setState({
          text: '',
          value: null,
          pickerVisible: false,
          confirmValue: null
        }, function () {
          _this.props.onVisibleChange(false);
          _this.props.onChange(null);
        });
      }
    };
    // 面板打开或关闭的回调
    _this.onVisibleChange = function (visible) {
      if (_this.inputClick && !visible) {
        _this.inputClick = false;
        return;
      }
      _this.inputClick = false;
      _this.setState({
        pickerVisible: visible
      }, function () {
        if (!visible) {
          _this.saveValidInputValue();
        } else {
          _this.props.onVisibleChange(visible);
        }
      });
    };
    // 保存合法的输入值
    _this.saveValidInputValue = function () {
      var _this$state = _this.state,
        value = _this$state.value,
        confirmValue = _this$state.confirmValue;
      if (value && value.length === 2 && _this.onError) {
        var error = _this.onError([value[0], value[1]]);
        if (error) {
          _this.setState({
            pickerVisible: error
          });
          return;
        }
      }
      if (_this.isDateValid(value) && !(0, _date.equalDateArr)(value, confirmValue)) {
        _this.onPicked(value, false, true);
      } else {
        _this.onCancelPicked();
      }
    };
    (0, _utils.require_condition)(typeof _type === 'string');
    _this.type = _type;
    _this.inputClick = false;
    _this.state = {
      pickerVisible: false,
      value: props.value && (0, _date.isValidValueArr)(props.value) ? props.value : null,
      text: props.value && (0, _date.isValidValueArr)(props.value) ? [_this.dateToStr(props.value[0]), _this.dateToStr(props.value[1])] : '',
      // 增加一个confirmValue记录每次确定的值，当点击"取消"或者空白处时，恢复这个值
      confirmValue: props.value && (0, _date.isValidValueArr)(props.value) ? props.value : null
    };
    return _this;
  }
  (0, _createClass2["default"])(DateRangeBasePicker, [{
    key: "isDateValid",
    value: function isDateValid(date) {
      return date === null || (0, _date.isValidValueArr)(date);
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state, props) {
      throw new _utils.Errors.MethodImplementationRequiredError(props);
    }
  }, {
    key: "getFormatSeparator",
    value: function getFormatSeparator() {
      return undefined;
    }
  }, {
    key: "onError",
    value: function onError(value) {
      return undefined;
    }
  }, {
    key: "getFormat",
    value: function getFormat() {
      return this.props.format || _constants.DEFAULT_FORMATS[this.type];
    }
  }, {
    key: "togglePickerVisible",
    value: function togglePickerVisible() {
      var _this2 = this;
      this.setState({
        pickerVisible: !this.state.pickerVisible
      }, function () {
        _this2.props.onVisibleChange(!_this2.state.pickerVisible);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        startPlaceholder = _this$props2.startPlaceholder,
        endPlaceholder = _this$props2.endPlaceholder,
        separator = _this$props2.separator,
        showTrigger = _this$props2.showTrigger,
        allowClear = _this$props2.allowClear,
        disabled = _this$props2.disabled,
        className = _this$props2.className,
        placement = _this$props2.placement,
        prefixCls = _this$props2.prefixCls,
        getPopupContainer = _this$props2.getPopupContainer,
        style = _this$props2.style;
      var _this$state2 = this.state,
        pickerVisible = _this$state2.pickerVisible,
        value = _this$state2.value,
        text = _this$state2.text;
      var calcIsShowTrigger = function calcIsShowTrigger() {
        if (showTrigger !== null) {
          return !!showTrigger;
        } else {
          return haveTriggerType(_this3.type);
        }
      };
      var triggerClass = function triggerClass() {
        var _context, _context2;
        return (0, _includes["default"])(_context = _this3.type).call(_context, 'date') || (0, _includes["default"])(_context2 = _this3.type).call(_context2, 'week') ? 'date-line' : 'time-line';
      };
      // 前缀图标
      var prefixIcon = function prefixIcon() {
        if (calcIsShowTrigger()) {
          return /*#__PURE__*/React.createElement(_Icon["default"], {
            className: (0, _classnames["default"])("".concat(prefixCls, "-date-picker-icon"), 'prefix-iconfont'),
            type: triggerClass()
          });
        } else {
          return null;
        }
      };
      // 后缀图标
      var suffixIcon = function suffixIcon() {
        if (text && allowClear) {
          return /*#__PURE__*/React.createElement(_Icon["default"], {
            className: (0, _classnames["default"])("".concat(prefixCls, "-date-picker-icon"), 'suffix-iconfont'),
            type: "close-circle-fill",
            onClick: _this3.handleClickCloseIcon
          });
        } else {
          return null;
        }
      };
      // 下拉面板
      var getPickerPanel = function getPickerPanel() {
        return _this3.pickerPanel(_this3.state);
      };
      // 选择框
      var getInputPanel = function getInputPanel(locales) {
        var _context3;
        return /*#__PURE__*/React.createElement("span", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-date-editor"), className, {
            'is-have-trigger': calcIsShowTrigger(),
            'is-active': pickerVisible,
            'is-filled': !!value,
            'is-disable': disabled
          }),
          style: (0, _assign["default"])({}, style),
          onClick: function onClick() {
            return _this3.inputClick = true;
          }
        }, /*#__PURE__*/React.createElement("div", {
          className: (0, _classnames["default"])((0, _concat["default"])(_context3 = "".concat(prefixCls, "-date-editor--")).call(_context3, _this3.type), {
            'is-active': pickerVisible,
            disabled: disabled
          })
        }, /*#__PURE__*/React.createElement(_Input["default"], {
          disabled: disabled,
          type: "text",
          placeholder: startPlaceholder,
          onFocus: _this3.handleFocus,
          onBlur: _this3.handleBlur,
          onKeyDown: _this3.handleKeydown,
          onChange: function onChange(e) {
            var inputValue = e.target.value;
            var ndate = _this3.parseDate(inputValue);
            if (!isInputValid(inputValue, ndate)) {
              _this3.setState({
                text: [inputValue, _this3.state.text[1]],
                pickerVisible: true
              });
            } else {
              //only set value on a valid date input
              _this3.setState({
                text: [inputValue, _this3.state.text[1]],
                value: [ndate, _this3.state.value[1]],
                pickerVisible: true
              });
            }
          },
          ref: function ref(e) {
            return _this3.refInputRoot = e;
          },
          value: text && text.length == 2 ? text[0] : '',
          prefix: prefixIcon()
        }), /*#__PURE__*/React.createElement("span", {
          className: (0, _classnames["default"])('range-separator', {
            disabled: disabled
          })
        }, locales.separator), /*#__PURE__*/React.createElement(_Input["default"], {
          className: "".concat(prefixCls, "-date-range-picker-second-input"),
          disabled: disabled,
          type: "text",
          placeholder: endPlaceholder,
          onFocus: _this3.handleFocus,
          onBlur: _this3.handleBlur,
          onKeyDown: _this3.handleKeydown,
          onChange: function onChange(e) {
            var inputValue = e.target.value;
            var ndate = _this3.parseDate(inputValue);
            if (!isInputValid(inputValue, ndate)) {
              _this3.setState({
                text: [_this3.state.text[0], inputValue],
                pickerVisible: true
              });
            } else {
              //only set value on a valid date input
              _this3.setState({
                text: [_this3.state.text[0], inputValue],
                value: [_this3.state.value[0], ndate],
                pickerVisible: true
              });
            }
          },
          value: text && text.length == 2 ? text[1] : '',
          suffix: suffixIcon()
        })));
      };
      return /*#__PURE__*/React.createElement(_Consumer["default"], {
        componentName: "DatePicker"
      }, function (Locales) {
        return /*#__PURE__*/React.createElement(_rcTrigger["default"], {
          action: disabled ? [] : ['click'],
          builtinPlacements: _placements["default"],
          ref: function ref(node) {
            return _this3.trigger = node;
          },
          getPopupContainer: getPopupContainer,
          onPopupVisibleChange: _this3.onVisibleChange,
          popup: getPickerPanel(),
          popupPlacement: placement,
          popupVisible: pickerVisible,
          prefixCls: "".concat(prefixCls, "-date-time-picker-popup"),
          destroyPopupOnHide: true
        }, getInputPanel(Locales));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        className: _propTypes["default"].string,
        startPlaceholder: _propTypes["default"].string,
        endPlaceholder: _propTypes["default"].string,
        separator: _propTypes["default"].string,
        format: _propTypes["default"].string,
        placement: _propTypes["default"].oneOf(['bottomLeft', 'bottomCenter', 'bottomRight', 'topLeft', 'topCenter', 'topRight']),
        prefixCls: _propTypes["default"].string,
        getPopupContainer: _propTypes["default"].func,
        showTrigger: _propTypes["default"].bool,
        allowClear: _propTypes["default"].bool,
        disabled: _propTypes["default"].bool,
        esc: _propTypes["default"].bool,
        value: _propTypes["default"].arrayOf(_propTypes["default"].instanceOf(Date)),
        onFocus: _propTypes["default"].func,
        onBlur: _propTypes["default"].func,
        onChange: _propTypes["default"].func,
        onVisibleChange: _propTypes["default"].func,
        style: _propTypes["default"].object
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        startPlaceholder: '开始日期',
        endPlaceholder: '结束日期',
        separator: '至',
        placement: 'bottomLeft',
        prefixCls: 'fishd',
        showTrigger: true,
        allowClear: true,
        disabled: false,
        esc: true,
        onFocus: function onFocus() {},
        onBlur: function onBlur() {},
        onChange: function onChange() {},
        onVisibleChange: function onVisibleChange() {}
      };
    }
  }, {
    key: "dateToStr",
    value: function dateToStr(date, type, format, separator) {
      if (!date || !(0, _date.isValidValue)(date)) return '';
      var tdate = date;
      var formatter = _constants.TYPE_VALUE_RESOLVER_MAP['date'].formatter;
      var result = formatter(tdate, format || _constants.DEFAULT_FORMATS[type], separator);
      return result;
    }
  }, {
    key: "propToState",
    value: function propToState(_ref, state) {
      var value = _ref.value,
        format = _ref.format,
        separator = _ref.separator;
      var type = state[$type];
      return {
        value: value && (0, _date.isValidValueArr)(value) ? value : null,
        text: value && (0, _date.isValidValueArr)(value) ? [DateRangeBasePicker.dateToStr(value[0], type, format, separator), DateRangeBasePicker.dateToStr(value[1], type, format, separator)] : '',
        confirmValue: value && (0, _date.isValidValueArr)(value) ? value : null
      };
    }
  }]);
  return DateRangeBasePicker;
}(React.Component);
DateRangeBasePicker.getDerivedStateFromProps = function (nextProps, prevState) {
  // 只 value 受控
  if ('value' in nextProps && !(0, _isEqual["default"])(prevState.prevPropValue, nextProps.value)) {
    var state = DateRangeBasePicker.propToState(nextProps, prevState);
    state.prevPropValue = nextProps.value;
    return state;
  }
  return null;
};
var _default = DateRangeBasePicker;
exports["default"] = _default;