"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.converSelectRange = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _BasePicker2 = _interopRequireDefault(require("./BasePicker"));
var _TimePanel = _interopRequireDefault(require("./panel/TimePanel"));
var _constants = require("./constants");
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _TimeSelect = _interopRequireDefault(require("./TimeSelect"));
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var converSelectRange = function converSelectRange(props) {
  var selectableRange = [];
  if (props.selectableRange) {
    var ranges = props.selectableRange;
    var parser = _constants.TYPE_VALUE_RESOLVER_MAP.datetimerange.parser;
    var format = _constants.DEFAULT_FORMATS.timerange;
    ranges = (0, _isArray["default"])(ranges) ? ranges : [ranges];
    selectableRange = (0, _map["default"])(ranges).call(ranges, function (range) {
      return parser(range, format);
    });
  }
  return selectableRange;
};
exports.converSelectRange = converSelectRange;
var TimePicker = /*#__PURE__*/function (_BasePicker) {
  (0, _inherits2["default"])(TimePicker, _BasePicker);
  var _super = _createSuper(TimePicker);
  function TimePicker(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TimePicker);
    //props, type, state
    _this = _super.call(this, props, 'time', {});
    _this.onSelectionChange = function (start, end) {
      _this.refInputRoot.input && _this.refInputRoot.input.setSelectionRange(start, end);
      _this.refInputRoot.input && _this.refInputRoot.input.focus();
    };
    _this._onSelectionChange = (0, _debounce["default"])(_this.onSelectionChange, 200);
    return _this;
  }
  (0, _createClass2["default"])(TimePicker, [{
    key: "isDateValid",
    value: function isDateValid(value) {
      return (0, _get2["default"])((0, _getPrototypeOf2["default"])(TimePicker.prototype), "isDateValid", this).call(this, value) && _TimePanel["default"].isValid(value, converSelectRange(this.props));
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state) {
      var _this2 = this;
      var value = state.value && this.isDateValid(state.value) ? state.value : null;
      return /*#__PURE__*/React.createElement(_Consumer["default"], {
        componentName: "DatePicker"
      }, function (Locales) {
        return /*#__PURE__*/React.createElement(_TimePanel["default"], (0, _assign["default"])({}, _this2.props, {
          selectableRange: converSelectRange(_this2.props),
          ONSELECTRANGECHANGE: _this2._onSelectionChange,
          value: value,
          onPicked: _this2.onPicked,
          onCancelPicked: _this2.onCancelPicked,
          Locales: Locales
        }));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return (0, _assign["default"])({}, {
        // '18:30:00 - 20:30:00' or ['09:30:00 - 12:00:00', '14:30:00 - 18:30:00']
        selectableRange: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].string)]),
        isShowCurrent: _propTypes["default"].bool,
        footer: _propTypes["default"].func,
        onValueChange: _propTypes["default"].func
      }, _BasePicker2["default"].propTypes);
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return (0, _assign["default"])({}, {
        isShowCurrent: false
      }, _BasePicker2["default"].defaultProps);
    }
  }]);
  return TimePicker;
}(_BasePicker2["default"]);
exports["default"] = TimePicker;
TimePicker.TimeSelect = _TimeSelect["default"];