"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _TimeSpinner = _interopRequireDefault(require("../basic/TimeSpinner.js"));
var _date = require("../../../utils/date");
var _constants = require("../constants");
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
var _Consumer = _interopRequireDefault(require("../../Config/Consumer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var mapPropsToState = function mapPropsToState(props) {
  var _context;
  var format = props.format,
    value = props.value,
    selectableRange = props.selectableRange;
  var state = {
    format: format || _constants.DEFAULT_FORMATS.time,
    currentDate: value || (0, _date.parseDate)('00:00:00', _constants.DEFAULT_FORMATS.time),
    confirmButtonDisabled: value === null || !TimePanel.isValid(value, selectableRange),
    currentButtonDisabled: !(0, _date.isLimitRange)(new Date(), selectableRange, _constants.DEFAULT_FORMATS.time)
  };
  state.isShowSeconds = (0, _indexOf["default"])(_context = state.format || '').call(_context, 'ss') !== -1;
  return state;
};
var TimePanel = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TimePanel, _React$Component);
  var _super = _createSuper(TimePanel);
  function TimePanel(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TimePanel);
    _this = _super.call(this, props);
    _this.handleChange = function (date) {
      var currentDate = _this.state.currentDate;
      var newDate = new Date(currentDate);
      if (date.hours !== undefined) {
        newDate.setHours(date.hours);
      }
      if (date.minutes !== undefined) {
        newDate.setMinutes(date.minutes);
      }
      if (date.seconds !== undefined) {
        newDate.setSeconds(date.seconds);
      }
      if (!TimePanel.isValid(newDate, _this.props.selectableRange)) {
        _this.setState({
          confirmButtonDisabled: true,
          currentDate: newDate
        }, function () {
          _this.props.onValueChange(newDate);
        });
      } else {
        _this.setState({
          confirmButtonDisabled: false,
          currentDate: newDate
        }, function () {
          _this.props.onValueChange(newDate);
          _this.handleConfirm(true, false); //面板展开，不保存值
        });
      }
    };
    // 点击确定按钮
    _this.handleConfirm = function (isKeepPannelOpen, isConfirmValue) {
      var currentDate = _this.state.currentDate;
      var _this$props = _this.props,
        onPicked = _this$props.onPicked,
        selectableRange = _this$props.selectableRange;
      var date = new Date((0, _date.limitRange)(currentDate, selectableRange, _constants.DEFAULT_FORMATS.time));
      onPicked(date, isKeepPannelOpen, isConfirmValue);
    };
    // 点击取消按钮
    _this.handleCancel = function () {
      _this.props.onCancelPicked();
    };
    // 点击此刻按钮
    _this.handleCurrent = function () {
      var onPicked = _this.props.onPicked;
      var value = new Date();
      onPicked(value, false, true);
    };
    _this.state = mapPropsToState(props);
    return _this;
  }
  (0, _createClass2["default"])(TimePanel, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props2 = this.props,
        onSelectRangeChange = _this$props2.onSelectRangeChange,
        selectableRange = _this$props2.selectableRange,
        isShowCurrent = _this$props2.isShowCurrent,
        footer = _this$props2.footer,
        prefixCls = _this$props2.prefixCls;
      var _this$state = this.state,
        isShowSeconds = _this$state.isShowSeconds,
        currentDate = _this$state.currentDate,
        confirmButtonDisabled = _this$state.confirmButtonDisabled,
        currentButtonDisabled = _this$state.currentButtonDisabled;
      var hours = currentDate ? currentDate.getHours() : null;
      var minutes = currentDate ? currentDate.getMinutes() : null;
      var seconds = currentDate ? currentDate.getSeconds() : null;
      return /*#__PURE__*/_react["default"].createElement(_Consumer["default"], {
        componentName: "DatePicker"
      }, function (Locales) {
        var _context2;
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _concat["default"])(_context2 = "".concat(prefixCls, "-picker-panel ")).call(_context2, prefixCls, "-time-panel")
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-time-panel__content"), {
            'has-seconds': isShowSeconds
          })
        }, /*#__PURE__*/_react["default"].createElement(_TimeSpinner["default"], {
          isShowSeconds: isShowSeconds,
          hours: hours,
          minutes: minutes,
          seconds: seconds,
          selectableRange: selectableRange,
          onSelectRangeChange: onSelectRangeChange,
          onChange: _this2.handleChange
        })), typeof footer == 'function' && footer() && /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-time-panel__extra-footer")
        }, footer()), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-time-panel__footer")
        }, /*#__PURE__*/_react["default"].createElement("div", null, isShowCurrent ? /*#__PURE__*/_react["default"].createElement("button", {
          type: "button",
          disabled: currentButtonDisabled,
          className: (0, _classnames["default"])("".concat(prefixCls, "-time-panel__btn confirm"), {
            'disabled': currentButtonDisabled
          }),
          onClick: _this2.handleCurrent
        }, Locales.now) : null), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("button", {
          type: "button",
          className: "".concat(prefixCls, "-time-panel__btn cancel"),
          onClick: _this2.handleCancel
        }, Locales.cancel), /*#__PURE__*/_react["default"].createElement("button", {
          type: "button",
          disabled: confirmButtonDisabled,
          className: (0, _classnames["default"])("".concat(prefixCls, "-time-panel__btn confirm"), {
            'disabled': confirmButtonDisabled
          }),
          onClick: function onClick() {
            return _this2.handleConfirm(false, true);
          }
        }, Locales.confirm))));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        prefixCls: _propTypes["default"].string,
        format: _propTypes["default"].string,
        value: _propTypes["default"].instanceOf(Date),
        onPicked: _propTypes["default"].func.isRequired,
        onCancelPicked: _propTypes["default"].func.isRequired,
        selectableRange: _TimeSpinner["default"].propTypes.selectableRange,
        onSelectRangeChange: _TimeSpinner["default"].propTypes.onSelectRangeChange,
        isShowCurrent: _propTypes["default"].bool,
        footer: _propTypes["default"].func,
        onValueChange: _propTypes["default"].func
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        prefixCls: 'fishd',
        isShowCurrent: false,
        onValueChange: function onValueChange() {}
      };
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if ("value" in nextProps && !(0, _isEqual["default"])(nextProps.value, prevState.prevPropValue)) {
        var state = mapPropsToState(nextProps);
        state.prevPropValue = nextProps.value;
        return state;
      }
      return null;
    }
  }]);
  return TimePanel;
}(_react["default"].Component);
TimePanel.isValid = function (value, selectableRange) {
  return value === null || (0, _date.isLimitRange)(value, selectableRange, _constants.DEFAULT_FORMATS.time);
};
var _default = TimePanel;
exports["default"] = _default;