"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _parseFloat2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-float"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));
var _maxSafeInteger = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/max-safe-integer"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _lastIndexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/last-index-of"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _isNegativeZero = _interopRequireDefault(require("is-negative-zero"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _utils = require("../../../utils");
var _InputHandler = _interopRequireDefault(require("./InputHandler"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function noop() {}
function preventDefault(e) {
  e.preventDefault();
}
function defaultParser(input) {
  /* eslint-disable-next-line */
  return input.replace(/[^\w\.-]+/g, '');
}
function getValidValue(value, min, max) {
  var val = (0, _parseFloat2["default"])(value, 10);
  // https://github.com/ant-design/ant-design/issues/7358
  if (isNaN(val)) {
    return value;
  }
  if (val < min) {
    val = min;
  }
  if (val > max) {
    val = max;
  }
  return val;
}
function toPrecisionAsStep(props, num) {
  if (isNotCompleteNumber(num) || num === '') {
    return num;
  }
  var precision = Math.abs(getMaxPrecision(props, num));
  if (precision === 0) {
    return num.toString();
  }
  if (!isNaN(precision)) {
    return Number(num).toFixed(precision);
  }
  return num.toString();
}
// '1.' '1x' 'xx' '' => are not complete numbers
function isNotCompleteNumber(num) {
  var _context;
  return isNaN(num) || num === '' || num === null || num && (0, _indexOf["default"])(_context = num.toString()).call(_context, '.') === num.toString().length - 1;
}
// step={1.0} value={1.51}
// press +
// then value should be 2.51, rather than 2.5
// if this.props.precision is undefined
// https://github.com/react-component/input-number/issues/39
// 获取最大数值精度
function getMaxPrecision(props, currentValue) {
  var ratio = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
  if ('precision' in props) {
    return props.precision;
  }
  var step = props.step;
  var ratioPrecision = getPrecision(props, ratio);
  var stepPrecision = getPrecision(props, step);
  var currentValuePrecision = getPrecision(props, currentValue);
  if (!currentValue) {
    return ratioPrecision + stepPrecision;
  }
  return Math.max(currentValuePrecision, ratioPrecision + stepPrecision);
}
//获取数值精度
function getPrecision(props, value) {
  if ('precision' in props) {
    return props.precision;
  }
  var valueString = value.toString();
  if ((0, _indexOf["default"])(valueString).call(valueString, 'e-') >= 0) {
    return (0, _parseInt2["default"])((0, _slice["default"])(valueString).call(valueString, (0, _indexOf["default"])(valueString).call(valueString, 'e-') + 2), 10);
  }
  var precision = 0;
  if ((0, _indexOf["default"])(valueString).call(valueString, '.') >= 0) {
    precision = valueString.length - (0, _indexOf["default"])(valueString).call(valueString, '.') - 1;
  }
  return precision;
}
function getPrecisionFactor(props, currentValue) {
  var ratio = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
  var precision = getMaxPrecision(props, currentValue, ratio);
  return Math.pow(10, precision);
}
function getRatio(e) {
  var ratio = 1;
  if (e.metaKey || e.ctrlKey) {
    ratio = 0.1;
  } else if (e.shiftKey) {
    ratio = 10;
  }
  return ratio;
}
function getValueFromEvent(e) {
  var _context2;
  // optimize for chinese input experience
  // https://github.com/ant-design/ant-design/issues/8196
  return (0, _trim["default"])(_context2 = e.target.value).call(_context2).replace(/。/g, '.');
}
/**
 * When click and hold on a button - the speed of auto changin the value.
 */
var SPEED = 200;
/**
 * When click and hold on a button - the delay before auto changin the value.
 */
var DELAY = 600;
/**
 * Max Safe Integer -- on IE this is not available, so manually set the number in that case.
 * The reason this is used, instead of Infinity is because numbers above the MSI are unstable
 */
var MAX_SAFE_INTEGER = _maxSafeInteger["default"] || Math.pow(2, 53) - 1;
var RcInputNumber = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(RcInputNumber, _React$Component);
  var _super = _createSuper(RcInputNumber);
  function RcInputNumber(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, RcInputNumber);
    _this = _super.call(this, props);
    _this.onKeyDown = function (e) {
      var onKeyDown = _this.props.onKeyDown;
      if (e.keyCode === _utils.KeyCode.UP) {
        var ratio = getRatio(e);
        _this.up(e, ratio);
        _this.stop();
      } else if (e.keyCode === _utils.KeyCode.DOWN) {
        var _ratio = getRatio(e);
        _this.down(e, _ratio);
        _this.stop();
      }
      // Trigger user key down
      _this.recordCursorPosition();
      _this.lastKeyCode = e.keyCode;
      if (onKeyDown) {
        var _context3;
        for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }
        onKeyDown.apply(void 0, (0, _concat["default"])(_context3 = [e]).call(_context3, args));
      }
    };
    _this.onKeyUp = function (e) {
      var onKeyUp = _this.props.onKeyUp;
      _this.stop();
      _this.recordCursorPosition();
      // Trigger user key up
      if (onKeyUp) {
        var _context4;
        for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }
        onKeyUp.apply(void 0, (0, _concat["default"])(_context4 = [e]).call(_context4, args));
      }
    };
    _this.onChange = function (e) {
      if (_this.state.focused) {
        _this.setState({
          inputting: true
        });
      }
      var input = _this.props.parser(getValueFromEvent(e));
      // valid number or invalid string
      var newInputValue = _this.toNumberWhenUserInput(input);
      var reg = /^\d+(\.)?/;
      // 以.开头的小数 如 .7
      var regExt = /^\.(?!\.)\d+$|(^\.$)/;
      var conditionInt = !isNaN(newInputValue) && reg.test(newInputValue);
      var conditionExt = regExt.test(newInputValue);
      var conditionEpt = newInputValue === '';
      if (conditionInt || conditionExt || conditionEpt) {
        _this.setState({
          inputValue: newInputValue
        });
        _this.props.onChange(newInputValue);
      } else {
        return;
      }
    };
    _this.onMouseUp = function () {
      var onMouseUp = _this.props.onMouseUp;
      _this.recordCursorPosition();
      if (onMouseUp) {
        onMouseUp.apply(void 0, arguments);
      }
    };
    _this.onFocus = function () {
      var _this$props;
      _this.setState({
        focused: true
      });
      (_this$props = _this.props).onFocus.apply(_this$props, arguments);
    };
    _this.onBlur = function (e) {
      for (var _len3 = arguments.length, args = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        args[_key3 - 1] = arguments[_key3];
      }
      _this.setState({
        focused: false,
        inputting: false
      });
      var value = _this.getCurrentValidValue(_this.state.inputValue);
      e.persist(); // fix https://github.com/react-component/input-number/issues/51
      _this.setValue(value, function () {
        var _this$props2, _context5;
        (_this$props2 = _this.props).onBlur.apply(_this$props2, (0, _concat["default"])(_context5 = [e]).call(_context5, args));
      });
    };
    _this.getInputDisplayValue = function () {
      var _this$state = _this.state,
        focused = _this$state.focused,
        inputValue = _this$state.inputValue,
        value = _this$state.value;
      var inputDisplayValue;
      if (focused) {
        inputDisplayValue = inputValue;
      } else {
        inputDisplayValue = toPrecisionAsStep(_this.props, value);
      }
      if (inputDisplayValue === undefined || inputDisplayValue === null) {
        inputDisplayValue = '';
      }
      return inputDisplayValue;
    };
    _this.recordCursorPosition = function () {
      // Record position
      try {
        _this.cursorStart = _this.input.selectionStart;
        _this.cursorEnd = _this.input.selectionEnd;
        _this.currentValue = _this.input.value;
        _this.cursorBefore = _this.input.value.substring(0, _this.cursorStart);
        _this.cursorAfter = _this.input.value.substring(_this.cursorEnd);
      } catch (e) {
        // Fix error in Chrome:
        // Failed to read the 'selectionStart' property from 'HTMLInputElement'
        // http://stackoverflow.com/q/21177489/3040605
      }
    };
    _this.restoreByAfter = function (str) {
      if (str === undefined) return false;
      var fullStr = _this.input.value;
      var index = (0, _lastIndexOf["default"])(fullStr).call(fullStr, str);
      if (index === -1) return false;
      if (index + str.length === fullStr.length) {
        _this.fixCaret(index, index);
        return true;
      }
      return false;
    };
    _this.partRestoreByAfter = function (str) {
      if (str === undefined) return false;
      // For loop from full str to the str with last char to map. e.g. 123
      // -> 123
      // -> 23
      // -> 3
      return (0, _some["default"])(Array.prototype).call(str, function (_, start) {
        var partStr = str.substring(start);
        return _this.restoreByAfter(partStr);
      });
    };
    _this.stop = function () {
      if (_this.autoStepTimer) {
        clearTimeout(_this.autoStepTimer);
      }
    };
    _this.down = function (e, ratio, recursive) {
      _this.pressingUpOrDown = true;
      _this.step('down', e, ratio, recursive);
    };
    _this.up = function (e, ratio, recursive) {
      _this.pressingUpOrDown = true;
      _this.step('up', e, ratio, recursive);
    };
    _this.saveUp = function (node) {
      _this.upHandler = node;
    };
    _this.saveDown = function (node) {
      _this.downHandler = node;
    };
    _this.saveInput = function (node) {
      _this.input = node;
    };
    var value;
    if ('value' in props) {
      value = props.value;
    } else {
      value = props.defaultValue;
    }
    value = _this.toNumber(value);
    _this.state = {
      inputValue: toPrecisionAsStep(props, value),
      value: value,
      focused: props.autoFocus,
      inputting: false,
      prevProps: props
    };
    return _this;
  }
  (0, _createClass2["default"])(RcInputNumber, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.componentDidUpdate();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      // Restore cursor
      try {
        // Firefox set the input cursor after it get focused.
        // This caused that if an input didn't init with the selection,
        // set will cause cursor not correct when first focus.
        // Safari will focus input if set selection. We need skip this.
        if (this.cursorStart !== undefined && this.state.focused) {
          // In most cases, the string after cursor is stable.
          // We can move the cursor before it
          if (
          // If not match full str, try to match part of str
          !this.partRestoreByAfter(this.cursorAfter)) {
            // If not match any of then, let's just keep the position
            // TODO: Logic should not reach here, need check if happens
            var pos = this.cursorStart + 1;
            // If not have last string, just position to the end
            if (!this.cursorAfter) {
              pos = this.input.value.length;
            } else if (this.lastKeyCode === _utils.KeyCode.BACKSPACE) {
              pos = this.cursorStart - 1;
            } else if (this.lastKeyCode === _utils.KeyCode.DELETE) {
              pos = this.cursorStart;
            }
            this.fixCaret(pos, pos);
          } else if (this.currentValue === this.input.value) {
            // Handle some special key code
            switch (this.lastKeyCode) {
              case _utils.KeyCode.BACKSPACE:
                this.fixCaret(this.cursorStart - 1, this.cursorStart - 1);
                break;
              case _utils.KeyCode.DELETE:
                this.fixCaret(this.cursorStart + 1, this.cursorStart + 1);
                break;
              default:
              // Do nothing
            }
          }
        }
      } catch (e) {
        // Do nothing
      }
      // Reset last key
      this.lastKeyCode = null;
      // pressingUpOrDown is true means that someone just click up or down button
      if (!this.pressingUpOrDown) {
        return;
      }
      if (this.props.focusOnUpDown && this.state.focused) {
        if (document.activeElement !== this.input) {
          this.focus();
        }
      }
      this.pressingUpOrDown = false;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.stop();
    }
  }, {
    key: "getCurrentValidValue",
    value: function getCurrentValidValue(value) {
      var val = value;
      if (val === '') {
        val = '';
      } else if (!isNotCompleteNumber(val)) {
        val = getValidValue(val, this.props.min, this.props.max);
      } else {
        val = this.state.value;
      }
      return this.toNumber(val);
    }
  }, {
    key: "setValue",
    value: function setValue(v, callback) {
      // trigger onChange
      var newValue = isNotCompleteNumber((0, _parseFloat2["default"])(v, 10)) ? undefined : (0, _parseFloat2["default"])(v, 10);
      var changed = newValue !== this.state.value || "".concat(newValue) !== "".concat(this.state.inputValue); // https://github.com/ant-design/ant-design/issues/7363
      if (!('value' in this.props)) {
        this.setState({
          value: newValue,
          inputValue: toPrecisionAsStep(this.props, v)
        }, callback);
      } else {
        // always set input value same as value
        this.setState({
          inputValue: toPrecisionAsStep(this.props, this.state.value)
        }, callback);
      }
      if (changed) {
        this.props.onChange(newValue);
      }
    }
  }, {
    key: "fixCaret",
    value: function fixCaret(start, end) {
      if (start === undefined || end === undefined || !this.input || !this.input.value) {
        return;
      }
      try {
        var currentStart = this.input.selectionStart;
        var currentEnd = this.input.selectionEnd;
        if (start !== currentStart || end !== currentEnd) {
          this.input.setSelectionRange(start, end);
        }
      } catch (e) {
        // Fix error in Chrome:
        // Failed to read the 'selectionStart' property from 'HTMLInputElement'
        // http://stackoverflow.com/q/21177489/3040605
      }
    }
  }, {
    key: "focus",
    value: function focus() {
      this.input.focus();
      this.recordCursorPosition();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.input.blur();
    }
  }, {
    key: "formatWrapper",
    value: function formatWrapper(num) {
      // http://2ality.com/2012/03/signedzero.html
      // https://github.com/ant-design/ant-design/issues/9439
      if ((0, _isNegativeZero["default"])(num)) {
        return '-0';
      }
      if (this.props.formatter) {
        return this.props.formatter(num);
      }
      return num;
    }
  }, {
    key: "toNumber",
    value: function toNumber(num) {
      if (isNotCompleteNumber(num)) {
        return num;
      }
      if ('precision' in this.props) {
        return Number(Number(num).toFixed(this.props.precision));
      }
      return Number(num);
    }
    // '1.0' '1.00'  => may be a inputing number
  }, {
    key: "toNumberWhenUserInput",
    value: function toNumberWhenUserInput(num) {
      // num.length > 16 => prevent input large number will became Infinity
      if ((/\.\d*0$/.test(num) || num.length > 16) && this.state.focused) {
        return num;
      }
      return this.toNumber(num);
    }
  }, {
    key: "upStep",
    value: function upStep(val, rat) {
      var _this$props3 = this.props,
        step = _this$props3.step,
        min = _this$props3.min;
      var precisionFactor = getPrecisionFactor(this.props, val, rat);
      var precision = Math.abs(getMaxPrecision(this.props, val, rat));
      var result;
      if (typeof val === 'number') {
        result = ((precisionFactor * val + precisionFactor * step * rat) / precisionFactor).toFixed(precision);
      } else {
        result = min === -Infinity ? step : min;
      }
      return this.toNumber(result);
    }
  }, {
    key: "downStep",
    value: function downStep(val, rat) {
      var _this$props4 = this.props,
        step = _this$props4.step,
        min = _this$props4.min;
      var precisionFactor = getPrecisionFactor(this.props, val, rat);
      var precision = Math.abs(getMaxPrecision(this.props, val, rat));
      var result;
      if (typeof val === 'number') {
        result = ((precisionFactor * val - precisionFactor * step * rat) / precisionFactor).toFixed(precision);
      } else {
        result = min === -Infinity ? -step : min;
      }
      return this.toNumber(result);
    }
  }, {
    key: "step",
    value: function step(type, e) {
      var _this2 = this;
      var ratio = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
      var recursive = arguments.length > 3 ? arguments[3] : undefined;
      this.stop();
      if (e) {
        e.persist();
        e.preventDefault();
      }
      var props = this.props;
      if (props.disabled) {
        return;
      }
      var value = this.getCurrentValidValue(this.state.inputValue) || 0;
      if (isNotCompleteNumber(value)) {
        return;
      }
      var val = this["".concat(type, "Step")](value, ratio);
      var outOfRange = val > props.max || val < props.min;
      if (val > props.max) {
        val = props.max;
      } else if (val < props.min) {
        val = props.min;
      }
      this.setValue(val);
      this.setState({
        focused: true
      });
      if (outOfRange) {
        return;
      }
      this.autoStepTimer = (0, _setTimeout2["default"])(function () {
        _this2[type](e, ratio, true);
      }, recursive ? SPEED : DELAY);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames, _context6, _context7, _context8, _context9;
      var props = (0, _assign["default"])({}, this.props);
      var prefixCls = props.prefixCls,
        disabled = props.disabled,
        readOnly = props.readOnly,
        useTouch = props.useTouch;
      var classes = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, prefixCls, true), (0, _defineProperty2["default"])(_classNames, props.className, !!props.className), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-disabled"), disabled), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-focused"), this.state.focused), _classNames));
      var upDisabledClass = '';
      var downDisabledClass = '';
      var value = this.state.value;
      if (value || value === 0) {
        if (!isNaN(value)) {
          var val = Number(value);
          if (val >= props.max) {
            upDisabledClass = "".concat(prefixCls, "-handler-up-disabled");
          }
          if (val <= props.min) {
            downDisabledClass = "".concat(prefixCls, "-handler-down-disabled");
          }
        } else {
          upDisabledClass = "".concat(prefixCls, "-handler-up-disabled");
          downDisabledClass = "".concat(prefixCls, "-handler-down-disabled");
        }
      }
      var dataOrAriaAttributeProps = {};
      for (var key in props) {
        if (props.hasOwnProperty(key) && (key.substr(0, 5) === 'data-' || key.substr(0, 5) === 'aria-' || key === 'role')) {
          dataOrAriaAttributeProps[key] = props[key];
        }
      }
      var editable = !props.readOnly && !props.disabled;
      // focus state, show input value
      // unfocus state, show valid value
      var inputDisplayValue = this.getInputDisplayValue();
      var upEvents;
      var downEvents;
      if (useTouch) {
        upEvents = {
          onTouchStart: editable && !upDisabledClass ? this.up : noop,
          onTouchEnd: this.stop
        };
        downEvents = {
          onTouchStart: editable && !downDisabledClass ? this.down : noop,
          onTouchEnd: this.stop
        };
      } else {
        upEvents = {
          onMouseDown: editable && !upDisabledClass ? this.up : noop,
          onMouseUp: this.stop,
          onMouseLeave: this.stop
        };
        downEvents = {
          onMouseDown: editable && !downDisabledClass ? this.down : noop,
          onMouseUp: this.stop,
          onMouseLeave: this.stop
        };
      }
      var inputDisplayValueFormat = this.formatWrapper(inputDisplayValue);
      var isUpDisabled = !!upDisabledClass || disabled || readOnly;
      var isDownDisabled = !!downDisabledClass || disabled || readOnly;
      // ref for test
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes,
        style: props.style,
        onMouseEnter: props.onMouseEnter,
        onMouseLeave: props.onMouseLeave,
        onMouseOver: props.onMouseOver,
        onMouseOut: props.onMouseOut
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-handler-wrap")
      }, /*#__PURE__*/_react["default"].createElement(_InputHandler["default"], (0, _assign["default"])({
        ref: this.saveUp,
        disabled: isUpDisabled,
        prefixCls: prefixCls,
        unselectable: "unselectable"
      }, upEvents, {
        role: "button",
        "aria-label": "Increase Value",
        "aria-disabled": !!isUpDisabled,
        className: (0, _concat["default"])(_context6 = (0, _concat["default"])(_context7 = "".concat(prefixCls, "-handler ")).call(_context7, prefixCls, "-handler-up ")).call(_context6, upDisabledClass)
      }), this.props.upHandler || /*#__PURE__*/_react["default"].createElement("span", {
        unselectable: "unselectable",
        className: "".concat(prefixCls, "-handler-up-inner"),
        onClick: preventDefault
      })), /*#__PURE__*/_react["default"].createElement(_InputHandler["default"], (0, _assign["default"])({
        ref: this.saveDown,
        disabled: isDownDisabled,
        prefixCls: prefixCls,
        unselectable: "unselectable"
      }, downEvents, {
        role: "button",
        "aria-label": "Decrease Value",
        "aria-disabled": !!isDownDisabled,
        className: (0, _concat["default"])(_context8 = (0, _concat["default"])(_context9 = "".concat(prefixCls, "-handler ")).call(_context9, prefixCls, "-handler-down ")).call(_context8, downDisabledClass)
      }), this.props.downHandler || /*#__PURE__*/_react["default"].createElement("span", {
        unselectable: "unselectable",
        className: "".concat(prefixCls, "-handler-down-inner"),
        onClick: preventDefault
      }))), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-input-wrap"),
        role: "spinbutton",
        "aria-valuemin": props.min,
        "aria-valuemax": props.max,
        "aria-valuenow": value
      }, /*#__PURE__*/_react["default"].createElement("input", (0, _assign["default"])({
        required: props.required,
        type: props.type,
        placeholder: props.placeholder,
        onClick: props.onClick,
        onMouseUp: this.onMouseUp,
        className: "".concat(prefixCls, "-input"),
        tabIndex: props.tabIndex,
        autoComplete: "off",
        onFocus: this.onFocus,
        onBlur: this.onBlur,
        onKeyDown: editable ? this.onKeyDown : noop,
        onKeyUp: editable ? this.onKeyUp : noop,
        autoFocus: props.autoFocus,
        maxLength: props.maxLength,
        readOnly: props.readOnly,
        disabled: props.disabled,
        max: props.max,
        min: props.min,
        step: props.step,
        name: props.name,
        id: props.id,
        onChange: this.onChange,
        ref: this.saveInput,
        value: inputDisplayValueFormat,
        pattern: props.pattern
      }, dataOrAriaAttributeProps))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {
        prevProps: nextProps
      };
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      if ('value' in nextProps && prevProps.value !== nextProps.value) {
        var value = prevState.focused ? nextProps.value : getValidValue(nextProps.value, nextProps.min, nextProps.max);
        var inputValue = prevState.inputting ? value : toPrecisionAsStep(nextProps, value);
        newState.value = value;
        newState.inputValue = inputValue;
      }
      return newState;
    }
  }]);
  return RcInputNumber;
}(_react["default"].Component);
RcInputNumber.propTypes = {
  value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  defaultValue: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  focusOnUpDown: _propTypes["default"].bool,
  autoFocus: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  onKeyDown: _propTypes["default"].func,
  onKeyUp: _propTypes["default"].func,
  prefixCls: _propTypes["default"].string,
  tabIndex: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  disabled: _propTypes["default"].bool,
  onFocus: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  readOnly: _propTypes["default"].bool,
  max: _propTypes["default"].number,
  min: _propTypes["default"].number,
  step: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  upHandler: _propTypes["default"].node,
  downHandler: _propTypes["default"].node,
  useTouch: _propTypes["default"].bool,
  formatter: _propTypes["default"].func,
  parser: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func,
  onMouseUp: _propTypes["default"].func,
  precision: _propTypes["default"].number,
  required: _propTypes["default"].bool,
  pattern: _propTypes["default"].string
};
RcInputNumber.defaultProps = {
  focusOnUpDown: true,
  useTouch: false,
  prefixCls: 'rc-input-number',
  min: -MAX_SAFE_INTEGER,
  step: 1,
  style: {},
  onChange: noop,
  onKeyDown: noop,
  onFocus: noop,
  onBlur: noop,
  parser: defaultParser,
  required: false
};
(0, _reactLifecyclesCompat.polyfill)(RcInputNumber);
var _default = RcInputNumber;
exports["default"] = _default;