"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.SubMenu = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _find = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _react = _interopRequireDefault(require("react"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _rcTrigger = _interopRequireDefault(require("rc-trigger"));
var _utils = require("../../../utils");
var _classnames = _interopRequireDefault(require("classnames"));
var _miniStore = require("mini-store");
var _SubPopupMenu = _interopRequireDefault(require("./SubPopupMenu"));
var _placements = _interopRequireDefault(require("./placements"));
var _rcAnimate = _interopRequireDefault(require("rc-animate"));
var _util = require("./util");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var guid = 0;
var popupPlacementMap = {
  horizontal: 'bottomLeft',
  vertical: 'rightTop',
  'vertical-left': 'rightTop',
  'vertical-right': 'leftTop'
};
var updateDefaultActiveFirst = function updateDefaultActiveFirst(store, eventKey, defaultActiveFirst) {
  var menuId = (0, _util.getMenuIdFromSubMenuEventKey)(eventKey);
  var state = store.getState();
  store.setState({
    defaultActiveFirst: (0, _assign["default"])((0, _assign["default"])({}, state.defaultActiveFirst), (0, _defineProperty2["default"])({}, menuId, defaultActiveFirst))
  });
};
var SubMenu = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(SubMenu, _React$Component);
  var _super = _createSuper(SubMenu);
  function SubMenu(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, SubMenu);
    _this = _super.call(this, props);
    _this.onDestroy = function (key) {
      _this.props.onDestroy(key);
    };
    _this.onKeyDown = function (e) {
      var keyCode = e.keyCode;
      var menu = _this.menuInstance;
      var _this$props = _this.props,
        isOpen = _this$props.isOpen,
        store = _this$props.store;
      if (keyCode === _utils.KeyCode.ENTER) {
        _this.onTitleClick(e);
        updateDefaultActiveFirst(store, _this.props.eventKey, true);
        return true;
      }
      if (keyCode === _utils.KeyCode.RIGHT) {
        if (isOpen) {
          menu.onKeyDown(e);
        } else {
          _this.triggerOpenChange(true);
          // need to update current menu's defaultActiveFirst value
          updateDefaultActiveFirst(store, _this.props.eventKey, true);
        }
        return true;
      }
      if (keyCode === _utils.KeyCode.LEFT) {
        var handled;
        if (isOpen) {
          handled = menu.onKeyDown(e);
        } else {
          return undefined;
        }
        if (!handled) {
          _this.triggerOpenChange(false);
          handled = true;
        }
        return handled;
      }
      if (isOpen && (keyCode === _utils.KeyCode.UP || keyCode === _utils.KeyCode.DOWN)) {
        return menu.onKeyDown(e);
      }
    };
    _this.onOpenChange = function (e) {
      _this.props.onOpenChange(e);
    };
    _this.onPopupVisibleChange = function (visible) {
      _this.triggerOpenChange(visible, visible ? 'mouseenter' : 'mouseleave');
    };
    _this.onMouseEnter = function (e) {
      var _this$props2 = _this.props,
        key = _this$props2.eventKey,
        onMouseEnter = _this$props2.onMouseEnter,
        store = _this$props2.store;
      updateDefaultActiveFirst(store, _this.props.eventKey, false);
      onMouseEnter({
        key: key,
        domEvent: e
      });
    };
    _this.onMouseLeave = function (e) {
      var _this$props3 = _this.props,
        parentMenu = _this$props3.parentMenu,
        eventKey = _this$props3.eventKey,
        onMouseLeave = _this$props3.onMouseLeave;
      parentMenu.subMenuInstance = (0, _assertThisInitialized2["default"])(_this);
      onMouseLeave({
        key: eventKey,
        domEvent: e
      });
    };
    _this.onTitleMouseEnter = function (domEvent) {
      var _this$props4 = _this.props,
        key = _this$props4.eventKey,
        onItemHover = _this$props4.onItemHover,
        onTitleMouseEnter = _this$props4.onTitleMouseEnter;
      onItemHover({
        key: key,
        hover: true
      });
      onTitleMouseEnter({
        key: key,
        domEvent: domEvent
      });
    };
    _this.onTitleMouseLeave = function (e) {
      var _this$props5 = _this.props,
        parentMenu = _this$props5.parentMenu,
        eventKey = _this$props5.eventKey,
        onItemHover = _this$props5.onItemHover,
        onTitleMouseLeave = _this$props5.onTitleMouseLeave;
      parentMenu.subMenuInstance = (0, _assertThisInitialized2["default"])(_this);
      onItemHover({
        key: eventKey,
        hover: false
      });
      onTitleMouseLeave({
        key: eventKey,
        domEvent: e
      });
    };
    _this.onTitleClick = function (e) {
      var _assertThisInitialize = (0, _assertThisInitialized2["default"])(_this),
        props = _assertThisInitialize.props;
      props.onTitleClick({
        key: props.eventKey,
        domEvent: e
      });
      if (props.triggerSubMenuAction === 'hover') {
        return;
      }
      _this.triggerOpenChange(!props.isOpen, 'click');
      updateDefaultActiveFirst(props.store, _this.props.eventKey, false);
    };
    _this.onSubMenuClick = function (info) {
      _this.props.onClick(_this.addKeyPath(info));
    };
    _this.onSelect = function (info) {
      _this.props.onSelect(info);
    };
    _this.onDeselect = function (info) {
      _this.props.onDeselect(info);
    };
    _this.getPrefixCls = function () {
      return "".concat(_this.props.rootPrefixCls, "-submenu");
    };
    _this.getActiveClassName = function () {
      return "".concat(_this.getPrefixCls(), "-active");
    };
    _this.getDisabledClassName = function () {
      return "".concat(_this.getPrefixCls(), "-disabled");
    };
    _this.getSelectedClassName = function () {
      return "".concat(_this.getPrefixCls(), "-selected");
    };
    _this.getOpenClassName = function () {
      return "".concat(_this.props.rootPrefixCls, "-submenu-open");
    };
    _this.saveMenuInstance = function (c) {
      // children menu instance
      _this.menuInstance = c;
    };
    _this.addKeyPath = function (info) {
      var _context;
      return (0, _assign["default"])((0, _assign["default"])({}, info), {
        keyPath: (0, _concat["default"])(_context = info.keyPath || []).call(_context, _this.props.eventKey)
      });
    };
    _this.triggerOpenChange = function (open, type) {
      var key = _this.props.eventKey;
      var openChange = function openChange() {
        _this.onOpenChange({
          key: key,
          item: (0, _assertThisInitialized2["default"])(_this),
          trigger: type,
          open: open
        });
      };
      if (type === 'mouseenter') {
        // make sure mouseenter happen after other menu item's mouseleave
        _this.mouseenterTimeout = (0, _setTimeout2["default"])(function () {
          openChange();
        }, 0);
      } else {
        openChange();
      }
    };
    _this.isChildrenSelected = function () {
      var ret = {
        find: false
      };
      (0, _util.loopMenuItemRecursively)(_this.props.children, _this.props.selectedKeys, ret);
      return (0, _find["default"])(ret);
    };
    _this.isOpen = function () {
      var _context2;
      return (0, _indexOf["default"])(_context2 = _this.props.openKeys).call(_context2, _this.props.eventKey) !== -1;
    };
    _this.adjustWidth = function () {
      /* istanbul ignore if */
      if (!_this.subMenuTitle || !_this.menuInstance) {
        return;
      }
      var popupMenu = _reactDom["default"].findDOMNode(_this.menuInstance);
      if (popupMenu.offsetWidth >= _this.subMenuTitle.offsetWidth) {
        return;
      }
      /* istanbul ignore next */
      popupMenu.style.minWidth = "".concat(_this.subMenuTitle.offsetWidth, "px");
    };
    _this.saveSubMenuTitle = function (subMenuTitle) {
      _this.subMenuTitle = subMenuTitle;
    };
    var store = props.store;
    var eventKey = props.eventKey;
    var defaultActiveFirst = store.getState().defaultActiveFirst;
    _this.isRootMenu = false;
    var value = false;
    if (defaultActiveFirst) {
      value = defaultActiveFirst[eventKey];
    }
    updateDefaultActiveFirst(store, eventKey, value);
    return _this;
  }
  (0, _createClass2["default"])(SubMenu, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.componentDidUpdate();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _this2 = this;
      var _this$props6 = this.props,
        mode = _this$props6.mode,
        parentMenu = _this$props6.parentMenu,
        manualRef = _this$props6.manualRef;
      // invoke customized ref to expose component to mixin
      if (manualRef) {
        manualRef(this);
      }
      if (mode !== 'horizontal' || !parentMenu.isRootMenu || !this.props.isOpen) {
        return;
      }
      this.minWidthTimeout = (0, _setTimeout2["default"])(function () {
        return _this2.adjustWidth();
      }, 0);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props7 = this.props,
        onDestroy = _this$props7.onDestroy,
        eventKey = _this$props7.eventKey;
      if (onDestroy) {
        onDestroy(eventKey);
      }
      /* istanbul ignore if */
      if (this.minWidthTimeout) {
        clearTimeout(this.minWidthTimeout);
      }
      /* istanbul ignore if */
      if (this.mouseenterTimeout) {
        clearTimeout(this.mouseenterTimeout);
      }
    }
  }, {
    key: "renderChildren",
    value: function renderChildren(children) {
      var props = this.props;
      var baseProps = {
        mode: props.mode === 'horizontal' ? 'vertical' : props.mode,
        visible: this.props.isOpen,
        level: props.level + 1,
        inlineIndent: props.inlineIndent,
        focusable: false,
        onClick: this.onSubMenuClick,
        onSelect: this.onSelect,
        onDeselect: this.onDeselect,
        onDestroy: this.onDestroy,
        selectedKeys: props.selectedKeys,
        eventKey: "".concat(props.eventKey, "-menu-"),
        openKeys: props.openKeys,
        openTransitionName: props.openTransitionName,
        openAnimation: props.openAnimation,
        onOpenChange: this.onOpenChange,
        subMenuOpenDelay: props.subMenuOpenDelay,
        parentMenu: this,
        subMenuCloseDelay: props.subMenuCloseDelay,
        forceSubMenuRender: props.forceSubMenuRender,
        triggerSubMenuAction: props.triggerSubMenuAction,
        builtinPlacements: props.builtinPlacements,
        defaultActiveFirst: props.store.getState().defaultActiveFirst[(0, _util.getMenuIdFromSubMenuEventKey)(props.eventKey)],
        multiple: props.multiple,
        prefixCls: props.rootPrefixCls,
        id: this._menuId,
        manualRef: this.saveMenuInstance
      };
      var haveRendered = this.haveRendered;
      this.haveRendered = true;
      this.haveOpened = this.haveOpened || baseProps.visible || baseProps.forceSubMenuRender;
      // never rendered not planning to, don't render
      if (!this.haveOpened) {
        return /*#__PURE__*/_react["default"].createElement("div", null);
      }
      // don't show transition on first rendering (no animation for opened menu)
      // show appear transition if it's not visible (not sure why)
      // show appear transition if it's not inline mode
      var transitionAppear = haveRendered || !baseProps.visible || !baseProps.mode === 'inline';
      baseProps.className = " ".concat(baseProps.prefixCls, "-sub");
      var animProps = {};
      if (baseProps.openTransitionName) {
        animProps.transitionName = baseProps.openTransitionName;
      } else if ((0, _typeof2["default"])(baseProps.openAnimation) === 'object') {
        animProps.animation = (0, _assign["default"])({}, baseProps.openAnimation);
        if (!transitionAppear) {
          delete animProps.animation.appear;
        }
      }
      return /*#__PURE__*/_react["default"].createElement(_rcAnimate["default"], (0, _assign["default"])({}, animProps, {
        showProp: "visible",
        component: "",
        transitionAppear: transitionAppear
      }), /*#__PURE__*/_react["default"].createElement(_SubPopupMenu["default"], (0, _assign["default"])({}, baseProps, {
        id: this._menuId
      }), children));
    }
  }, {
    key: "render",
    value: function render() {
      var _context3, _classNames, _context4;
      var props = (0, _assign["default"])({}, this.props);
      var isOpen = props.isOpen;
      var prefixCls = this.getPrefixCls();
      var isInlineMode = props.mode === 'inline';
      var className = (0, _classnames["default"])(prefixCls, (0, _concat["default"])(_context3 = "".concat(prefixCls, "-")).call(_context3, props.mode), (_classNames = {}, (0, _defineProperty2["default"])(_classNames, props.className, !!props.className), (0, _defineProperty2["default"])(_classNames, this.getOpenClassName(), isOpen), (0, _defineProperty2["default"])(_classNames, this.getActiveClassName(), props.active || isOpen && !isInlineMode), (0, _defineProperty2["default"])(_classNames, this.getDisabledClassName(), props.disabled), (0, _defineProperty2["default"])(_classNames, this.getSelectedClassName(), this.isChildrenSelected()), _classNames));
      if (!this._menuId) {
        if (props.eventKey) {
          this._menuId = "".concat(props.eventKey, "$Menu");
        } else {
          this._menuId = "$__$".concat(++guid, "$Menu");
        }
      }
      var mouseEvents = {};
      var titleClickEvents = {};
      var titleMouseEvents = {};
      if (!props.disabled) {
        mouseEvents = {
          onMouseLeave: this.onMouseLeave,
          onMouseEnter: this.onMouseEnter
        };
        // only works in title, not outer li
        titleClickEvents = {
          onClick: this.onTitleClick
        };
        titleMouseEvents = {
          onMouseEnter: this.onTitleMouseEnter,
          onMouseLeave: this.onTitleMouseLeave
        };
      }
      var style = {};
      if (isInlineMode) {
        style.paddingLeft = props.inlineIndent * props.level;
      }
      var ariaOwns = {};
      // only set aria-owns when menu is open
      // otherwise it would be an invalid aria-owns value
      // since corresponding node cannot be found
      if (this.props.isOpen) {
        ariaOwns = {
          'aria-owns': this._menuId
        };
      }
      var title = /*#__PURE__*/_react["default"].createElement("div", (0, _assign["default"])({
        ref: this.saveSubMenuTitle,
        style: style,
        className: "".concat(prefixCls, "-title")
      }, titleMouseEvents, titleClickEvents, {
        "aria-expanded": isOpen
      }, ariaOwns, {
        "aria-haspopup": "true",
        title: typeof props.title === 'string' ? props.title : undefined
      }), props.title, /*#__PURE__*/_react["default"].createElement("i", {
        className: "".concat(prefixCls, "-arrow")
      }));
      var children = this.renderChildren(props.children);
      var getPopupContainer = props.parentMenu.isRootMenu ? props.parentMenu.props.getPopupContainer : function (triggerNode) {
        return triggerNode.parentNode;
      };
      var popupPlacement = popupPlacementMap[props.mode];
      var popupAlign = props.popupOffset ? {
        offset: props.popupOffset
      } : {};
      var popupClassName = props.mode === 'inline' ? '' : props.popupClassName;
      var disabled = props.disabled,
        triggerSubMenuAction = props.triggerSubMenuAction,
        subMenuOpenDelay = props.subMenuOpenDelay,
        forceSubMenuRender = props.forceSubMenuRender,
        subMenuCloseDelay = props.subMenuCloseDelay,
        builtinPlacements = props.builtinPlacements;
      (0, _forEach["default"])(_util.menuAllProps).call(_util.menuAllProps, function (key) {
        return delete props[key];
      });
      // Set onClick to null, to ignore propagated onClick event
      delete props.onClick;
      return /*#__PURE__*/_react["default"].createElement("li", (0, _assign["default"])({}, props, mouseEvents, {
        className: className,
        role: "menuitem"
      }), isInlineMode && title, isInlineMode && children, !isInlineMode && /*#__PURE__*/_react["default"].createElement(_rcTrigger["default"], {
        prefixCls: prefixCls,
        popupClassName: (0, _concat["default"])(_context4 = "".concat(prefixCls, "-popup ")).call(_context4, popupClassName),
        getPopupContainer: getPopupContainer,
        builtinPlacements: (0, _assign["default"])({}, _placements["default"], builtinPlacements),
        popupPlacement: popupPlacement,
        popupVisible: isOpen,
        popupAlign: popupAlign,
        popup: children,
        action: disabled ? [] : [triggerSubMenuAction],
        mouseEnterDelay: subMenuOpenDelay,
        mouseLeaveDelay: subMenuCloseDelay,
        onPopupVisibleChange: this.onPopupVisibleChange,
        forceRender: forceSubMenuRender
      }, title));
    }
  }]);
  return SubMenu;
}(_react["default"].Component);
exports.SubMenu = SubMenu;
SubMenu.propTypes = {
  parentMenu: _propTypes["default"].object,
  title: _propTypes["default"].node,
  // children: PropTypes.any,
  children: _propTypes["default"].node,
  selectedKeys: _propTypes["default"].array,
  openKeys: _propTypes["default"].array,
  onClick: _propTypes["default"].func,
  onOpenChange: _propTypes["default"].func,
  rootPrefixCls: _propTypes["default"].string,
  eventKey: _propTypes["default"].string,
  multiple: _propTypes["default"].bool,
  active: _propTypes["default"].bool,
  onItemHover: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  triggerSubMenuAction: _propTypes["default"].string,
  onDeselect: _propTypes["default"].func,
  onDestroy: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func,
  onTitleMouseEnter: _propTypes["default"].func,
  onTitleMouseLeave: _propTypes["default"].func,
  onTitleClick: _propTypes["default"].func,
  popupOffset: _propTypes["default"].array,
  isOpen: _propTypes["default"].bool,
  store: _propTypes["default"].object,
  mode: _propTypes["default"].oneOf(['horizontal', 'vertical', 'vertical-left', 'vertical-right', 'inline']),
  manualRef: _propTypes["default"].func
};
SubMenu.defaultProps = {
  onMouseEnter: _util.noop,
  onMouseLeave: _util.noop,
  onTitleMouseEnter: _util.noop,
  onTitleMouseLeave: _util.noop,
  onTitleClick: _util.noop,
  manualRef: _util.noop,
  mode: 'vertical',
  title: ''
};
var connected = (0, _miniStore.connect)(function (_ref, _ref2) {
  var openKeys = _ref.openKeys,
    activeKey = _ref.activeKey,
    selectedKeys = _ref.selectedKeys;
  var eventKey = _ref2.eventKey,
    subMenuKey = _ref2.subMenuKey;
  return {
    isOpen: (0, _indexOf["default"])(openKeys).call(openKeys, eventKey) > -1,
    active: activeKey[subMenuKey] === eventKey,
    selectedKeys: selectedKeys
  };
})(SubMenu);
connected.isSubMenu = true;
var _default = connected;
exports["default"] = _default;