"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var ReactDOM = _interopRequireWildcard(require("react-dom"));
var _Dialog = _interopRequireDefault(require("./Dialog"));
var _utils = require("../../utils");
require("./style/index.less");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var IS_REACT_16 = ('createPortal' in ReactDOM);
var DialogWrap = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(DialogWrap, _React$Component);
  var _super = _createSuper(DialogWrap);
  function DialogWrap() {
    var _this;
    (0, _classCallCheck2["default"])(this, DialogWrap);
    _this = _super.apply(this, arguments);
    _this.saveDialog = function (node) {
      _this._component = node;
    };
    _this.getComponent = function () {
      var extra = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return /*#__PURE__*/React.createElement(_Dialog["default"], (0, _assign["default"])({
        ref: _this.saveDialog
      }, _this.props, extra, {
        key: "dialog"
      }));
    };
    // fix issue #10656
    /*
     * Custom container should not be return, because in the Portal component, it will remove the
     * return container element here, if the custom container is the only child of it's component,
     * like issue #10656, It will has a conflict with removeChild method in react-dom.
     * So here should add a child (div element) to custom container.
     * */
    _this.getContainer = function () {
      var container = document.createElement('div');
      if (_this.props.getContainer) {
        _this.props.getContainer().appendChild(container);
      } else {
        document.body.appendChild(container);
      }
      return container;
    };
    return _this;
  }
  (0, _createClass2["default"])(DialogWrap, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(_ref) {
      var visible = _ref.visible;
      return !!(this.props.visible || visible);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (IS_REACT_16) {
        return;
      }
      if (this.props.visible) {
        this.renderComponent({
          afterClose: this.removeContainer,
          onClose: function onClose() {},
          visible: false
        });
      } else {
        this.removeContainer();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var visible = this.props.visible;
      var portal = null;
      if (!IS_REACT_16) {
        return /*#__PURE__*/React.createElement(_utils.ContainerRender, {
          parent: this,
          visible: visible,
          autoDestroy: false,
          getComponent: this.getComponent,
          getContainer: this.getContainer
        }, function (_ref2) {
          var renderComponent = _ref2.renderComponent,
            removeContainer = _ref2.removeContainer;
          _this2.renderComponent = renderComponent;
          _this2.removeContainer = removeContainer;
          return null;
        });
      }
      if (visible || this._component) {
        portal = /*#__PURE__*/React.createElement(_utils.Portal, {
          getContainer: this.getContainer
        }, this.getComponent());
      }
      return portal;
    }
  }]);
  return DialogWrap;
}(React.Component);
DialogWrap.defaultProps = {
  visible: false
};
var _default = DialogWrap;
exports["default"] = _default;