"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Pager = _interopRequireDefault(require("./Pager"));
var _Options = _interopRequireDefault(require("./Options"));
var _KeyCode = _interopRequireDefault(require("./KeyCode"));
var _Consumer = _interopRequireDefault(require("../../Config/Consumer"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function noop() {}
function isInteger(value) {
  return typeof value === 'number' && isFinite(value) && Math.floor(value) === value;
}
function defaultItemRender(page, type, element) {
  return element;
}
function calculatePage(p, state, props) {
  var pageSize = p;
  if (typeof pageSize === 'undefined') {
    pageSize = state.pageSize;
  }
  return Math.floor((props.total - 1) / pageSize) + 1;
}
var Pagination = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Pagination, _React$Component);
  var _super = _createSuper(Pagination);
  function Pagination(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Pagination);
    _this = _super.call(this, props);
    _this.savePaginationNode = function (node) {
      _this.paginationNode = node;
    };
    _this.isValid = function (page) {
      return isInteger(page) && page >= 1 && page !== _this.state.current;
    };
    _this.handleKeyDown = function (e) {
      if (e.keyCode === _KeyCode["default"].ARROW_UP || e.keyCode === _KeyCode["default"].ARROW_DOWN) {
        e.preventDefault();
      }
    };
    _this.handleKeyUp = function (e) {
      var inputValue = e.target.value;
      var currentInputValue = _this.state.currentInputValue;
      var value;
      if (inputValue === '') {
        value = inputValue;
      } else if (isNaN(Number(inputValue))) {
        value = currentInputValue;
      } else {
        value = Number(inputValue);
      }
      if (value !== currentInputValue) {
        _this.setState({
          currentInputValue: value
        });
      }
      if (e.keyCode === _KeyCode["default"].ENTER) {
        _this.handleChange(value);
      } else if (e.keyCode === _KeyCode["default"].ARROW_UP) {
        _this.handleChange(value - 1);
      } else if (e.keyCode === _KeyCode["default"].ARROW_DOWN) {
        _this.handleChange(value + 1);
      }
    };
    _this.changePageSize = function (size) {
      var current = _this.state.current;
      var newCurrent = calculatePage(size, _this.state, _this.props);
      current = current > newCurrent ? newCurrent : current;
      // fix the issue:
      // Once 'total' is 0, 'current' in 'onShowSizeChange' is 0, which is not correct.
      if (newCurrent === 0) {
        current = _this.state.current;
      }
      if (typeof size === 'number') {
        if (!('pageSize' in _this.props)) {
          _this.setState({
            pageSize: size
          });
        }
        if (!('current' in _this.props)) {
          _this.setState({
            current: current,
            currentInputValue: current
          });
        }
      }
      _this.props.onShowSizeChange(current, size);
    };
    _this.handleChange = function (p) {
      var page = p;
      if (_this.isValid(page)) {
        var currentPage = calculatePage(undefined, _this.state, _this.props);
        if (page > currentPage) {
          page = currentPage;
        }
        if (!('current' in _this.props)) {
          _this.setState({
            current: page,
            currentInputValue: page
          });
        }
        var _pageSize = _this.state.pageSize;
        _this.props.onChange(page, _pageSize);
        return page;
      }
      return _this.state.current;
    };
    _this.prev = function () {
      if (_this.hasPrev()) {
        _this.handleChange(_this.state.current - 1);
      }
    };
    _this.next = function () {
      if (_this.hasNext()) {
        _this.handleChange(_this.state.current + 1);
      }
    };
    _this.jumpPrev = function () {
      _this.handleChange(_this.getJumpPrevPage());
    };
    _this.jumpNext = function () {
      _this.handleChange(_this.getJumpNextPage());
    };
    _this.hasPrev = function () {
      return _this.state.current > 1;
    };
    _this.hasNext = function () {
      return _this.state.current < calculatePage(undefined, _this.state, _this.props);
    };
    _this.runIfEnter = function (event, callback) {
      if (event.key === 'Enter' || event.charCode === 13) {
        for (var _len = arguments.length, restParams = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
          restParams[_key - 2] = arguments[_key];
        }
        callback.apply(void 0, restParams);
      }
    };
    _this.runIfEnterPrev = function (e) {
      _this.runIfEnter(e, _this.prev);
    };
    _this.runIfEnterNext = function (e) {
      _this.runIfEnter(e, _this.next);
    };
    _this.runIfEnterJumpPrev = function (e) {
      _this.runIfEnter(e, _this.jumpPrev);
    };
    _this.runIfEnterJumpNext = function (e) {
      _this.runIfEnter(e, _this.jumpNext);
    };
    _this.handleGoTO = function (e) {
      if (e.keyCode === _KeyCode["default"].ENTER || e.type === 'click') {
        _this.handleChange(_this.state.currentInputValue);
      }
    };
    var hasOnChange = props.onChange !== noop;
    var hasCurrent = ('current' in props);
    if (hasCurrent && !hasOnChange) {
      console.warn('Warning: You provided a `current` prop to a Pagination component without an `onChange` handler. This will render a read-only component.'); // eslint-disable-line
    }

    var current = props.defaultCurrent;
    if ('current' in props) {
      current = props.current;
    }
    var pageSize = props.defaultPageSize;
    if ('pageSize' in props) {
      pageSize = props.pageSize;
    }
    _this.state = {
      current: current,
      currentInputValue: current,
      pageSize: pageSize
    };
    return _this;
  }
  (0, _createClass2["default"])(Pagination, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      // When current page change, fix focused style of prev item
      // A hacky solution of https://github.com/ant-design/ant-design/issues/8948
      var prefixCls = this.props.prefixCls;
      if (prevState.current !== this.state.current && this.paginationNode) {
        var _context;
        var lastCurrentNode = this.paginationNode.querySelector((0, _concat["default"])(_context = ".".concat(prefixCls, "-item-")).call(_context, prevState.current));
        if (lastCurrentNode && document.activeElement === lastCurrentNode) {
          lastCurrentNode.blur();
        }
      }
    }
  }, {
    key: "getJumpPrevPage",
    value: function getJumpPrevPage() {
      return Math.max(1, this.state.current - (this.props.showLessItems ? 3 : 5));
    }
  }, {
    key: "getJumpNextPage",
    value: function getJumpNextPage() {
      return Math.min(calculatePage(undefined, this.state, this.props), this.state.current + (this.props.showLessItems ? 3 : 5));
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      return /*#__PURE__*/_react["default"].createElement(_Consumer["default"], {
        componentName: "Pagination"
      }, function (Locale) {
        var _context2, _context10, _context11, _context12;
        // When hideOnSinglePage is true and there is only 1 page, hide the pager
        if (_this2.props.hideOnSinglePage === true && _this2.props.total <= _this2.state.pageSize) {
          return null;
        }
        var props = _this2.props;
        var locale = props.locale || Locale;
        var prefixCls = props.prefixCls;
        var allPages = calculatePage(undefined, _this2.state, _this2.props);
        var pagerList = [];
        var jumpPrev = null;
        var jumpNext = null;
        var firstPager = null;
        var lastPager = null;
        var gotoButton = null;
        var goButton = props.showQuickJumper && props.showQuickJumper.goButton;
        var pageBufferSize = props.showLessItems ? 1 : 2;
        var _this2$state = _this2.state,
          current = _this2$state.current,
          pageSize = _this2$state.pageSize;
        var prevPage = current - 1 > 0 ? current - 1 : 0;
        var nextPage = current + 1 < allPages ? current + 1 : allPages;
        var dataOrAriaAttributeProps = (0, _reduce["default"])(_context2 = (0, _keys["default"])(props)).call(_context2, function (prev, key) {
          if (key.substr(0, 5) === 'data-' || key.substr(0, 5) === 'aria-' || key === 'role') {
            prev[key] = props[key];
          }
          return prev;
        }, {});
        if (props.simple) {
          var _context5, _context6, _context7, _context8, _context9;
          if (goButton) {
            var _context3, _context4;
            if (typeof goButton === 'boolean') {
              gotoButton = /*#__PURE__*/_react["default"].createElement("button", {
                type: "button",
                onClick: _this2.handleGoTO,
                onKeyUp: _this2.handleGoTO
              }, locale.jump_to_confirm);
            } else {
              gotoButton = /*#__PURE__*/_react["default"].createElement("span", {
                onClick: _this2.handleGoTO,
                onKeyUp: _this2.handleGoTO
              }, goButton);
            }
            gotoButton = /*#__PURE__*/_react["default"].createElement("li", {
              title: props.showTitle ? (0, _concat["default"])(_context3 = (0, _concat["default"])(_context4 = "".concat(locale.jump_to)).call(_context4, _this2.state.current, "/")).call(_context3, allPages) : null,
              className: "".concat(prefixCls, "-simple-pager")
            }, gotoButton);
          }
          return /*#__PURE__*/_react["default"].createElement("ul", (0, _assign["default"])({
            className: (0, _concat["default"])(_context5 = (0, _concat["default"])(_context6 = "".concat(prefixCls, " ")).call(_context6, prefixCls, "-simple ")).call(_context5, props.className),
            style: props.style,
            ref: _this2.savePaginationNode
          }, dataOrAriaAttributeProps), /*#__PURE__*/_react["default"].createElement("li", {
            title: props.showTitle ? locale.prev_page : null,
            onClick: _this2.prev,
            tabIndex: _this2.hasPrev() ? 0 : null,
            onKeyPress: _this2.runIfEnterPrev,
            className: (0, _concat["default"])(_context7 = "".concat(_this2.hasPrev() ? '' : "".concat(prefixCls, "-disabled"), " ")).call(_context7, prefixCls, "-prev"),
            "aria-disabled": !_this2.hasPrev()
          }, props.itemRender(prevPage, 'prev', /*#__PURE__*/_react["default"].createElement("a", {
            className: "".concat(prefixCls, "-item-link")
          }))), /*#__PURE__*/_react["default"].createElement("li", {
            title: props.showTitle ? (0, _concat["default"])(_context8 = "".concat(_this2.state.current, "/")).call(_context8, allPages) : null,
            className: "".concat(prefixCls, "-simple-pager")
          }, /*#__PURE__*/_react["default"].createElement("input", {
            type: "text",
            value: _this2.state.currentInputValue,
            onKeyDown: _this2.handleKeyDown,
            onKeyUp: _this2.handleKeyUp,
            onChange: _this2.handleKeyUp,
            size: "3"
          }), /*#__PURE__*/_react["default"].createElement("span", {
            className: "".concat(prefixCls, "-slash")
          }, "\uFF0F"), allPages), /*#__PURE__*/_react["default"].createElement("li", {
            title: props.showTitle ? locale.next_page : null,
            onClick: _this2.next,
            tabIndex: _this2.hasPrev() ? 0 : null,
            onKeyPress: _this2.runIfEnterNext,
            className: (0, _concat["default"])(_context9 = "".concat(_this2.hasNext() ? '' : "".concat(prefixCls, "-disabled"), " ")).call(_context9, prefixCls, "-next"),
            "aria-disabled": !_this2.hasNext()
          }, props.itemRender(nextPage, 'next', /*#__PURE__*/_react["default"].createElement("a", {
            className: "".concat(prefixCls, "-item-link")
          }))), gotoButton);
        }
        if (allPages <= 5 + pageBufferSize * 2) {
          for (var i = 1; i <= allPages; i++) {
            var active = _this2.state.current === i;
            pagerList.push( /*#__PURE__*/_react["default"].createElement(_Pager["default"], {
              locale: locale,
              rootPrefixCls: prefixCls,
              onClick: _this2.handleChange,
              onKeyPress: _this2.runIfEnter,
              key: i,
              page: i,
              active: active,
              showTitle: props.showTitle,
              itemRender: props.itemRender
            }));
          }
        } else {
          var prevItemTitle = props.showLessItems ? locale.prev_3 : locale.prev_5;
          var nextItemTitle = props.showLessItems ? locale.next_3 : locale.next_5;
          if (props.showPrevNextJumpers) {
            jumpPrev = /*#__PURE__*/_react["default"].createElement("li", {
              title: props.showTitle ? prevItemTitle : null,
              key: "prev",
              onClick: _this2.jumpPrev,
              tabIndex: "0",
              onKeyPress: _this2.runIfEnterJumpPrev,
              className: "".concat(prefixCls, "-jump-prev")
            }, props.itemRender(_this2.getJumpPrevPage(), 'jump-prev', /*#__PURE__*/_react["default"].createElement("a", {
              className: "".concat(prefixCls, "-item-link")
            })));
            jumpNext = /*#__PURE__*/_react["default"].createElement("li", {
              title: props.showTitle ? nextItemTitle : null,
              key: "next",
              tabIndex: "0",
              onClick: _this2.jumpNext,
              onKeyPress: _this2.runIfEnterJumpNext,
              className: "".concat(prefixCls, "-jump-next")
            }, props.itemRender(_this2.getJumpNextPage(), 'jump-next', /*#__PURE__*/_react["default"].createElement("a", {
              className: "".concat(prefixCls, "-item-link")
            })));
          }
          lastPager = /*#__PURE__*/_react["default"].createElement(_Pager["default"], {
            locale: locale,
            last: true,
            rootPrefixCls: prefixCls,
            onClick: _this2.handleChange,
            onKeyPress: _this2.runIfEnter,
            key: allPages,
            page: allPages,
            active: false,
            showTitle: props.showTitle,
            itemRender: props.itemRender
          });
          firstPager = /*#__PURE__*/_react["default"].createElement(_Pager["default"], {
            locale: locale,
            rootPrefixCls: prefixCls,
            onClick: _this2.handleChange,
            onKeyPress: _this2.runIfEnter,
            key: 1,
            page: 1,
            active: false,
            showTitle: props.showTitle,
            itemRender: props.itemRender
          });
          var left = Math.max(1, current - pageBufferSize);
          var right = Math.min(current + pageBufferSize, allPages);
          if (current - 1 <= pageBufferSize) {
            right = 1 + pageBufferSize * 2;
          }
          if (allPages - current <= pageBufferSize) {
            left = allPages - pageBufferSize * 2;
          }
          for (var _i = left; _i <= right; _i++) {
            var _active = current === _i;
            pagerList.push( /*#__PURE__*/_react["default"].createElement(_Pager["default"], {
              locale: locale,
              rootPrefixCls: prefixCls,
              onClick: _this2.handleChange,
              onKeyPress: _this2.runIfEnter,
              key: _i,
              page: _i,
              active: _active,
              showTitle: props.showTitle,
              itemRender: props.itemRender
            }));
          }
          if (current - 1 >= pageBufferSize * 2 && current !== 1 + 2) {
            pagerList[0] = /*#__PURE__*/_react["default"].cloneElement(pagerList[0], {
              className: "".concat(prefixCls, "-item-after-jump-prev")
            });
            pagerList.unshift(jumpPrev);
          }
          if (allPages - current >= pageBufferSize * 2 && current !== allPages - 2) {
            pagerList[pagerList.length - 1] = /*#__PURE__*/_react["default"].cloneElement(pagerList[pagerList.length - 1], {
              className: "".concat(prefixCls, "-item-before-jump-next")
            });
            pagerList.push(jumpNext);
          }
          if (left !== 1) {
            pagerList.unshift(firstPager);
          }
          if (right !== allPages) {
            pagerList.push(lastPager);
          }
        }
        var totalText = null;
        if (props.showTotal) {
          totalText = /*#__PURE__*/_react["default"].createElement("li", {
            className: "".concat(prefixCls, "-total-text")
          }, props.showTotal(props.total, [(current - 1) * pageSize + 1, current * pageSize > props.total ? props.total : current * pageSize]));
        }
        var prevDisabled = !_this2.hasPrev();
        var nextDisabled = !_this2.hasNext();
        return /*#__PURE__*/_react["default"].createElement("ul", (0, _assign["default"])({
          className: (0, _concat["default"])(_context10 = "".concat(prefixCls, " ")).call(_context10, props.className),
          style: props.style,
          unselectable: "unselectable",
          ref: _this2.savePaginationNode
        }, dataOrAriaAttributeProps), totalText, /*#__PURE__*/_react["default"].createElement("li", {
          title: props.showTitle ? locale.prev_page : null,
          onClick: _this2.prev,
          tabIndex: prevDisabled ? null : 0,
          onKeyPress: _this2.runIfEnterPrev,
          className: (0, _concat["default"])(_context11 = "".concat(!prevDisabled ? '' : "".concat(prefixCls, "-disabled"), " ")).call(_context11, prefixCls, "-prev"),
          "aria-disabled": prevDisabled
        }, props.itemRender(prevPage, 'prev', /*#__PURE__*/_react["default"].createElement("a", {
          className: "".concat(prefixCls, "-item-link")
        }))), pagerList, /*#__PURE__*/_react["default"].createElement("li", {
          title: props.showTitle ? locale.next_page : null,
          onClick: _this2.next,
          tabIndex: nextDisabled ? null : 0,
          onKeyPress: _this2.runIfEnterNext,
          className: (0, _concat["default"])(_context12 = "".concat(!nextDisabled ? '' : "".concat(prefixCls, "-disabled"), " ")).call(_context12, prefixCls, "-next"),
          "aria-disabled": nextDisabled
        }, props.itemRender(nextPage, 'next', /*#__PURE__*/_react["default"].createElement("a", {
          className: "".concat(prefixCls, "-item-link")
        }))), /*#__PURE__*/_react["default"].createElement(_Options["default"], {
          locale: locale,
          rootPrefixCls: prefixCls,
          selectComponentClass: props.selectComponentClass,
          selectPrefixCls: props.selectPrefixCls,
          changeSize: _this2.props.showSizeChanger ? _this2.changePageSize : null,
          current: _this2.state.current,
          pageSize: _this2.state.pageSize,
          pageSizeOptions: _this2.props.pageSizeOptions,
          quickGo: _this2.props.showQuickJumper ? _this2.handleChange : null,
          goButton: goButton
        }));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, prevState) {
      var newState = {};
      if ('current' in props) {
        newState.current = props.current;
        if (props.current !== prevState.current) {
          newState.currentInputValue = newState.current;
        }
      }
      if ('pageSize' in props && props.pageSize !== prevState.pageSize) {
        var current = prevState.current;
        var newCurrent = calculatePage(props.pageSize, prevState, props);
        current = current > newCurrent ? newCurrent : current;
        if (!('current' in props)) {
          newState.current = current;
          newState.currentInputValue = current;
        }
        newState.pageSize = props.pageSize;
      }
      return newState;
    }
  }]);
  return Pagination;
}(_react["default"].Component);
Pagination.propTypes = {
  prefixCls: _propTypes["default"].string,
  current: _propTypes["default"].number,
  defaultCurrent: _propTypes["default"].number,
  total: _propTypes["default"].number,
  pageSize: _propTypes["default"].number,
  defaultPageSize: _propTypes["default"].number,
  onChange: _propTypes["default"].func,
  hideOnSinglePage: _propTypes["default"].bool,
  showSizeChanger: _propTypes["default"].bool,
  showLessItems: _propTypes["default"].bool,
  onShowSizeChange: _propTypes["default"].func,
  selectComponentClass: _propTypes["default"].func,
  showPrevNextJumpers: _propTypes["default"].bool,
  showQuickJumper: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].object]),
  showTitle: _propTypes["default"].bool,
  pageSizeOptions: _propTypes["default"].arrayOf(_propTypes["default"].string),
  showTotal: _propTypes["default"].func,
  locale: _propTypes["default"].object,
  style: _propTypes["default"].object,
  itemRender: _propTypes["default"].func
};
Pagination.defaultProps = {
  defaultCurrent: 1,
  total: 0,
  defaultPageSize: 10,
  onChange: noop,
  className: '',
  selectPrefixCls: 'rc-select',
  prefixCls: 'rc-pagination',
  selectComponentClass: null,
  hideOnSinglePage: false,
  showPrevNextJumpers: true,
  showQuickJumper: false,
  showSizeChanger: false,
  showLessItems: false,
  showTitle: true,
  onShowSizeChange: noop,
  style: {},
  itemRender: defaultItemRender
};
(0, _reactLifecyclesCompat.polyfill)(Pagination);
var _default = Pagination;
exports["default"] = _default;