"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.sanitize = sanitize;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _quill = require("../quill");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Inline = _quill.Quill["import"]('blots/inline');
var Link = /*#__PURE__*/function (_Inline) {
  (0, _inherits2["default"])(Link, _Inline);
  var _super = _createSuper(Link);
  function Link() {
    (0, _classCallCheck2["default"])(this, Link);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Link, [{
    key: "format",
    value:
    // static sanitize(url) {
    //   return sanitize(url, this.PROTOCOL_WHITELIST) ? url : this.SANITIZED_URL;
    // }
    function format(name, data) {
      if (name !== this.statics.blotName || !data) {
        (0, _get2["default"])((0, _getPrototypeOf2["default"])(Link.prototype), "format", this).call(this, name, data);
      } else {
        // 在超链接内输入回车时需要为光标添加超链接
        this.statics.formatCursor = true;
        if (data) {
          this.domNode.setAttribute('href', data.url);
          if (data.type != null) {
            this.domNode.setAttribute('data-ql-link-type', data.type);
            if (data.type == 'attachment') {
              this.domNode.setAttribute('contenteditable', 'false');
              this.domNode.setAttribute('download', data.name || '');
            }
          }
        }
      }
    }
  }], [{
    key: "create",
    value: function create(data) {
      this.formatCursor = false;
      var node = (0, _get2["default"])((0, _getPrototypeOf2["default"])(Link), "create", this).call(this, data);
      if (data) {
        node.setAttribute('target', '_blank');
        node.setAttribute('href', data.url);
        if (data.type != null) {
          node.setAttribute('data-ql-link-type', data.type);
          if (data.type == 'attachment') {
            node.setAttribute('download', data.name || '');
            node.setAttribute('contenteditable', 'false');
          }
        }
      }
      return node;
    }
  }, {
    key: "formats",
    value: function formats(node) {
      // 修复在超链接后输入回车光标被异常添加超链接的问题
      var domChildren = node.children;
      // let containsCursor = /<\s*span\s*class\s*=\s*['"]\s*ql-cursor\s*['"]\s*>\s*\ufeff\s*<\s*\/\s*span\s*>/gi;
      if (!this.formatCursor && domChildren && domChildren.length == 1 && domChildren[0].innerText == "\uFEFF") {
        return {};
      }
      return {
        url: node.getAttribute('href'),
        type: node.getAttribute('data-ql-link-type'),
        name: node.getAttribute('download')
      };
    }
  }]);
  return Link;
}(Inline);
exports["default"] = Link;
Link.blotName = 'link';
Link.tagName = 'A';
Link.formatCursor = false; // 是否为光标添加超链接
// Link.SANITIZED_URL = 'about:blank';
// Link.PROTOCOL_WHITELIST = ['http', 'https', 'mailto', 'tel'];
function sanitize(url, protocols) {
  var _context, _context2;
  var anchor = document.createElement('a');
  anchor.href = url;
  var protocol = (0, _slice["default"])(_context = anchor.href).call(_context, 0, (0, _indexOf["default"])(_context2 = anchor.href).call(_context2, ':'));
  return (0, _indexOf["default"])(protocols).call(protocols, protocol) > -1;
}