"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TagPlaceholder = exports.EmbedPlaceholder = exports.ClassNamePlaceholder = void 0;
exports.convertPlaceholderHTML = convertPlaceholderHTML;
exports["default"] = register;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _quill = require("../../../quill");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Container = _quill.Quill["import"]('blots/container');
var Scroll = _quill.Quill["import"]('blots/scroll');
var ATTRIBUTES = ['data-embed-source', 'data-type', 'data-src', 'data-size', 'style'];
var Parchment = _quill.Quill["import"]('parchment');
var Embed = _quill.Quill["import"]('blots/block/embed');
var EmbedPlaceholder = /*#__PURE__*/function (_Embed) {
  (0, _inherits2["default"])(EmbedPlaceholder, _Embed);
  var _super = _createSuper(EmbedPlaceholder);
  function EmbedPlaceholder() {
    (0, _classCallCheck2["default"])(this, EmbedPlaceholder);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(EmbedPlaceholder, [{
    key: "format",
    value: function format(name, value) {
      if (name === 'style') {
        this.domNode.style.cssText = value;
        return;
      }
      if ((0, _indexOf["default"])(ATTRIBUTES).call(ATTRIBUTES, name) === -1) {
        (0, _get2["default"])((0, _getPrototypeOf2["default"])(EmbedPlaceholder.prototype), "format", this).call(this, name, value);
        return;
      }
      if (value) {
        this.domNode.setAttribute(name, value);
      } else {
        this.domNode.removeAttribute(name);
      }
    }
  }, {
    key: "handling",
    value: function handling(_handling) {
      this.domNode.__formats = this.constructor.formats(this.domNode);
      this.domNode.__handling = _handling;
    }
  }], [{
    key: "create",
    value: function create(value) {
      var node = (0, _get2["default"])((0, _getPrototypeOf2["default"])(EmbedPlaceholder), "create", this).call(this);
      if (typeof value === 'string') {
        node.setAttribute(ATTRIBUTES[0], value);
      } else {
        for (var key in value) {
          if (!Object.prototype.hasOwnProperty.call(value, key)) continue;
          node.setAttribute(key, value[key]);
        }
      }
      node.setAttribute('contenteditable', false);
      node.setAttribute('unselectable', 'on');
      // node.setAttribute('title', node.textContent);
      return node;
    }
  }, {
    key: "formats",
    value: function formats(domNode) {
      if (domNode.__handling && domNode.__formats) {
        return domNode.__formats;
      }
      var attrList = (0, _slice["default"])(ATTRIBUTES).call(ATTRIBUTES, 3);
      return (0, _reduce["default"])(attrList).call(attrList, function (formats, attribute) {
        if (domNode.hasAttribute(attribute)) {
          formats[attribute] = domNode.getAttribute(attribute);
        }
        return formats;
      }, {});
    }
  }, {
    key: "value",
    value: function value(domNode) {
      var attrs = (0, _slice["default"])(ATTRIBUTES).call(ATTRIBUTES, 0, 3);
      var result = {};
      (0, _forEach["default"])(attrs).call(attrs, function (attr) {
        var res = '';
        if (domNode.hasAttribute(attr)) {
          res = domNode.getAttribute(attr);
        } else {
          switch (attr) {
            case ATTRIBUTES[0]:
              res = encodeURIComponent(domNode.outerHTML);
              break;
            case ATTRIBUTES[1]:
              res = domNode.tagName;
              break;
            case ATTRIBUTES[2]:
              res = domNode.getAttribute('src');
              break;
            case 'style':
              res = domNode.style.cssText;
              break;
            default:
              res = domNode[attr] || '';
          }
        }
        if (res) result[attr] = res;
      });
      return result;
    }
  }]);
  return EmbedPlaceholder;
}(Embed);
exports.EmbedPlaceholder = EmbedPlaceholder;
EmbedPlaceholder.blotName = 'embed-placeholder';
EmbedPlaceholder.tagName = 'span';
EmbedPlaceholder.scope = Parchment.Scope.INLINE_BLOT;
// Container.allowedChildren.push(EmbedPlaceholder)
Scroll.allowedChildren.push(EmbedPlaceholder);
var TagPlaceholder = /*#__PURE__*/function (_EmbedPlaceholder) {
  (0, _inherits2["default"])(TagPlaceholder, _EmbedPlaceholder);
  var _super2 = _createSuper(TagPlaceholder);
  function TagPlaceholder() {
    (0, _classCallCheck2["default"])(this, TagPlaceholder);
    return _super2.apply(this, arguments);
  }
  return (0, _createClass2["default"])(TagPlaceholder);
}(EmbedPlaceholder);
exports.TagPlaceholder = TagPlaceholder;
TagPlaceholder.tagName = ['video', 'iframe'];
var ClassNamePlaceholder = /*#__PURE__*/function (_EmbedPlaceholder2) {
  (0, _inherits2["default"])(ClassNamePlaceholder, _EmbedPlaceholder2);
  var _super3 = _createSuper(ClassNamePlaceholder);
  function ClassNamePlaceholder() {
    (0, _classCallCheck2["default"])(this, ClassNamePlaceholder);
    return _super3.apply(this, arguments);
  }
  return (0, _createClass2["default"])(ClassNamePlaceholder);
}(EmbedPlaceholder);
exports.ClassNamePlaceholder = ClassNamePlaceholder;
ClassNamePlaceholder.className = 'ql-embed-placeholder';
var tagReg = /<([\w-]+)((?:\s+[\w-:.]*(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*>([^<]*?)<\/\1>/g;
var attrReg = /([\w-:.]+)(?:\s*=\s*(?:"((?:\\.|[^"])*)"|'((?:\\.|[^'])*)'))?/g;
function convertPlaceholderHTML() {
  var _context;
  var html = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  if (!html) return '';
  var matchReg = new RegExp((0, _concat["default"])(_context = "class\\s*=\\s*(?:\"[^\"]*\\b(".concat(ClassNamePlaceholder.className, ")\\b[^\"]*\"|'[^']*\\b(")).call(_context, ClassNamePlaceholder.className, ")\\b[^']*')") // eslint-disable-line
  );

  return html.replace(tagReg, function (m, tag) {
    var attrs = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
    if (!tag || tag.toLowerCase() !== EmbedPlaceholder.tagName || !matchReg.test(attrs)) {
      return m;
    }
    var attributes = getAttributes(attrs);
    var source = decodeURIComponent(attributes[ATTRIBUTES[0]]);
    // if (!attributes.style) return source
    return replaceHTMLAttr(source, {
      style: attributes.style,
      'data-size': attributes['data-size']
    });
  });
}
function getAttributes(str) {
  var attributes = {};
  str.replace(attrReg, function (m, name, attr1, attr2) {
    var _context2;
    var attr = (0, _trim["default"])(_context2 = attr1 || attr2 || '').call(_context2);
    attributes[name] = attr;
  });
  return attributes;
}
var sourceTagReg = /<([\w-]+)((?:\s+[\w-:.]*(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*>/;
function replaceHTMLAttr() {
  var html = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var attrs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return html.replace(sourceTagReg, function (m, tag) {
    var _context3, _context5;
    var attr = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
    var attributes = getAttributes(attr);
    (0, _assign["default"])(attributes, attrs);
    var attrsStr = (0, _reduce["default"])(_context3 = (0, _keys["default"])(attributes)).call(_context3, function (str, key) {
      var _context4;
      var val = attributes[key];
      if (val == null) return str;
      str += val === '' ? " ".concat(key) : (0, _concat["default"])(_context4 = " ".concat(key, "=\"")).call(_context4, val, "\"");
      return str;
    }, '');
    return (0, _concat["default"])(_context5 = "<".concat(tag)).call(_context5, attrsStr, ">");
  });
}
function register() {
  var formats = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [TagPlaceholder];
  if (!(0, _isArray["default"])(formats)) formats = [formats];
  formats.push(ClassNamePlaceholder);
  (0, _forEach["default"])(formats).call(formats, function (fmt) {
    _quill.Quill.register(fmt, true);
    fmt.tagName = EmbedPlaceholder.tagName;
    fmt.className = ClassNamePlaceholder.className;
  });
}