"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/keys"));
var _BaseModule2 = _interopRequireDefault(require("./BaseModule"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Keyboard = /*#__PURE__*/function (_BaseModule) {
  (0, _inherits2["default"])(Keyboard, _BaseModule);
  var _super = _createSuper(Keyboard);
  function Keyboard() {
    (0, _classCallCheck2["default"])(this, Keyboard);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Keyboard, [{
    key: "onCreate",
    value: function onCreate(e) {
      var _this = this;
      this.keyboardProxy = function (evt) {
        return _this.keyboardHandle(evt);
      };
      document.addEventListener('keydown', this.keyboardProxy, true);
    }
  }, {
    key: "onDestroy",
    value: function onDestroy() {
      document.removeEventListener('keydown', this.keyboardProxy, true);
    }
  }, {
    key: "keyboardHandle",
    value: function keyboardHandle(evt) {
      if (evt.defaultPrevented) return;
      if (evt.shiftKey || evt.ctrlKey || evt.altKey) {
        return;
      }
      if (!this.activeEle || evt.fromResize || evt.ctrlKey) return;
      var code = evt.keyCode;
      var index = this.blot.offset(this.quill.scroll);
      var nextBlot;
      var handled = false;
      // delete
      if (code === (0, _keys["default"])(Keyboard).BACKSPACE || code === (0, _keys["default"])(Keyboard).DELETE) {
        this.blot.deleteAt(0);
        this.blot.parent.optimize();
        handled = true;
        // direction key
      } else if (code >= (0, _keys["default"])(Keyboard).LEFT && code <= (0, _keys["default"])(Keyboard).DOWN) {
        if (code === (0, _keys["default"])(Keyboard).RIGHT) {
          index++;
        } else if (code === (0, _keys["default"])(Keyboard).UP) {
          index = this.getOtherLineIndex(-1);
          nextBlot = this.quill.getLeaf(index)[0];
        } else if (code === (0, _keys["default"])(Keyboard).DOWN) {
          index = this.getOtherLineIndex(1);
          nextBlot = this.quill.getLeaf(index)[0];
        }
        handled = true;
      }
      if (handled) {
        evt.stopPropagation();
        evt.preventDefault();
      }
      if (nextBlot && this.resizer.judgeShow(nextBlot, nextBlot.domNode)) return;
      this.quill.setSelection(index);
      this.resizer.hide();
    }
  }, {
    key: "getOtherLineIndex",
    value: function getOtherLineIndex(dir) {
      var index = this.blot.offset(this.quill.scroll);
      var _this$quill$getLine = this.quill.getLine(index),
        _this$quill$getLine2 = (0, _slicedToArray2["default"])(_this$quill$getLine, 1),
        line = _this$quill$getLine2[0];
      var lineIndex = this.blot.offset(line) + 1;
      var otherLine = dir > 0 ? line.next : line.prev;
      if (otherLine) {
        var len = otherLine.length();
        if (otherLine.statics.blotName === 'block') len--;
        index = otherLine.offset(this.quill.scroll) + Math.min(len, lineIndex);
      }
      return index;
    }
    // 转发event到quill
  }, {
    key: "dispatchEvent",
    value: function dispatchEvent(evt) {
      var event = new evt.constructor(evt);
      event.fromResize = true;
      this.quill.root.dispatchEvent(event);
    }
  }], [{
    key: "injectInit",
    value: function injectInit(quill) {
      // left/right
      var bindings = quill.keyboard.bindings;
      bindings[(0, _keys["default"])(this).LEFT].unshift(this.makeArrowHandler((0, _keys["default"])(this).LEFT, false));
      bindings[(0, _keys["default"])(this).RIGHT].unshift(this.makeArrowHandler((0, _keys["default"])(this).RIGHT, false));
      // // up
      // const upBinding = this.makeArrowHandler(this.keys.UP, false)
      // if (bindings[this.keys.UP]) {
      //   bindings[this.keys.UP].unshift(upBinding)
      // } else {
      //   quill.keyboard.addBinding(upBinding)
      // }
      // // down
      // const downBinding = this.makeArrowHandler(this.keys.DOWN, false)
      // if (bindings[this.keys.DOWN]) {
      //   bindings[this.keys.DOWN].unshift(downBinding)
      // } else {
      //   quill.keyboard.addBinding(downBinding)
      // }
    }
  }, {
    key: "makeArrowHandler",
    value: function makeArrowHandler(key, shiftKey) {
      var _ref;
      var where = key === (0, _keys["default"])(Keyboard).LEFT ? 'prefix' : 'suffix';
      return _ref = {
        key: key,
        shiftKey: shiftKey,
        altKey: null
      }, (0, _defineProperty2["default"])(_ref, where, /^$/), (0, _defineProperty2["default"])(_ref, "handler", function handler(range) {
        if (!this.quill.resizer) return true;
        var index = range.index;
        // check end of line
        var _this$quill$getLine3 = this.quill.getLine(range.index),
          _this$quill$getLine4 = (0, _slicedToArray2["default"])(_this$quill$getLine3, 1),
          line = _this$quill$getLine4[0];
        var lineIndex = this.quill.getIndex(line);
        if (key === (0, _keys["default"])(Keyboard).RIGHT && lineIndex + line.length() - 1 === index) return true;
        // get leaf/offset
        if (key === (0, _keys["default"])(Keyboard).RIGHT) {
          index += range.length + 1;
        }
        var _this$quill$getLeaf = this.quill.getLeaf(index),
          _this$quill$getLeaf2 = (0, _slicedToArray2["default"])(_this$quill$getLeaf, 1),
          leaf = _this$quill$getLeaf2[0];
        var offset = leaf.offset(leaf.parent);
        // check start of line
        if (key === (0, _keys["default"])(Keyboard).LEFT && (index === 0 || index === lineIndex)) return true;
        // get previous leaf
        if (key === (0, _keys["default"])(Keyboard).LEFT) {
          if (offset === 0) {
            index -= 1;
            leaf = this.quill.getLeaf(index)[0];
          }
        }
        return !this.quill.resizer.judgeShow(leaf);
      }), _ref;
    }
  }]);
  return Keyboard;
}(_BaseModule2["default"]);
exports["default"] = Keyboard;
Keyboard.keys = {
  BACKSPACE: 'Backspace',
  TAB: 'Tab',
  ENTER: 'Enter',
  ESCAPE: 'Escape',
  LEFT: 'ArrowLeft',
  UP: 'ArrowUp',
  RIGHT: 'ArrowRight',
  DOWN: 'ArrowDown',
  DELETE: 'Delete'
};