"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _parseFloat2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-float"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _BaseModule2 = _interopRequireDefault(require("./BaseModule"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Resize = /*#__PURE__*/function (_BaseModule) {
  (0, _inherits2["default"])(Resize, _BaseModule);
  var _super = _createSuper(Resize);
  function Resize() {
    (0, _classCallCheck2["default"])(this, Resize);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Resize, [{
    key: "onCreate",
    value: function onCreate() {
      // track resize handles
      this.boxes = [];
      // add 4 resize handles
      this.addBox('nwse-resize'); // top left
      this.addBox('nesw-resize'); // top right
      this.addBox('nwse-resize'); // bottom right
      this.addBox('nesw-resize'); // bottom left
      this.positionBoxes();
    }
  }, {
    key: "onDestroy",
    value: function onDestroy() {
      // reset drag handle cursors
      this.setCursor('');
    }
  }, {
    key: "positionBoxes",
    value: function positionBoxes() {
      var _context,
        _this = this;
      var handleXOffset = "".concat(-(0, _parseFloat2["default"])(this.options.styles.handle.width) / 2, "px");
      var handleYOffset = "".concat(-(0, _parseFloat2["default"])(this.options.styles.handle.height) / 2, "px");
      (0, _forEach["default"])(_context = [{
        left: handleXOffset,
        top: handleYOffset
      }, {
        right: handleXOffset,
        top: handleYOffset
      }, {
        right: handleXOffset,
        bottom: handleYOffset
      }, {
        left: handleXOffset,
        bottom: handleYOffset
      } // bottom left
      ]).call(_context, function (pos, idx) {
        (0, _assign["default"])(_this.boxes[idx].style, pos);
      });
    }
  }, {
    key: "addBox",
    value: function addBox(cursor) {
      var _context2;
      // create div element for resize handle
      var box = document.createElement('div');
      // Star with the specified styles
      (0, _assign["default"])(box.style, this.options.styles.handle);
      box.style.cursor = cursor;
      // Set the width/height to use 'px'
      box.style.width = "".concat(this.options.styles.handle.width, "px");
      box.style.height = "".concat(this.options.styles.handle.height, "px");
      // listen for mousedown on each box
      box.addEventListener('mousedown', (0, _bind["default"])(_context2 = this.handleMousedown).call(_context2, this), false);
      // add drag handle to document
      this.overlay.appendChild(box);
      // keep track of drag handle
      this.boxes.push(box);
    }
  }, {
    key: "handleMousedown",
    value: function handleMousedown(evt) {
      var _this2 = this;
      this.blot.handling && this.blot.handling(true);
      // note which box
      this.dragBox = evt.target;
      // note starting mousedown position
      this.dragStartX = evt.clientX;
      this.dragStartY = evt.clientY;
      // store the width before the drag
      this.preDragSize = {
        width: this.activeEle.offsetWidth,
        height: this.activeEle.offsetHeight
      };
      // store the natural size
      this.naturalSize = this.getNaturalSize();
      // set the proper cursor everywhere
      var _this$naturalSize = this.naturalSize,
        width = _this$naturalSize.width,
        height = _this$naturalSize.height;
      this.localRatio = height / width;
      this.editorMaxWidth = this.quill.container.clientWidth - 30;
      this.setCursor(this.dragBox.style.cursor);
      this.handleDragProxy = function (evt) {
        return _this2.handleDrag(evt);
      };
      this.handleMouseupProxy = function (evt) {
        return _this2.handleMouseup(evt);
      };
      // listen for movement and mouseup
      document.addEventListener('mousemove', this.handleDragProxy, false);
      document.addEventListener('mouseup', this.handleMouseupProxy, false);
    }
  }, {
    key: "handleMouseup",
    value: function handleMouseup() {
      // reset cursor everywhere
      this.setCursor('');
      this.blot.handling && this.blot.handling(false);
      // stop listening for movement and mouseup
      document.removeEventListener('mousemove', this.handleDragProxy);
      document.removeEventListener('mouseup', this.handleMouseupProxy);
    }
  }, {
    key: "handleDrag",
    value: function handleDrag(evt) {
      var _context3,
        _this3 = this;
      if (!this.activeEle || !this.blot) {
        // activeEle not set yet
        return;
      }
      // update size
      var deltaX = evt.clientX - this.dragStartX;
      var deltaY = evt.clientY - this.dragStartY;
      var options = this.options.parchment[this.blot.statics.blotName];
      var size = {};
      var direction = 1;
      (0, _forEach["default"])(_context3 = options.attribute || ['width']).call(_context3, function (key) {
        size[key] = _this3.preDragSize[key];
      });
      // left-side
      if (this.dragBox === this.boxes[0] || this.dragBox === this.boxes[3]) {
        direction = -1;
      }
      if (size.width) {
        size.width = Math.round(this.preDragSize.width + deltaX * direction);
      }
      if (size.height) {
        size.height = Math.round(this.preDragSize.height + deltaY * direction);
      }
      (0, _assign["default"])(this.activeEle.style, this.calcSize(size, options.limit));
      this.requestUpdate();
    }
  }, {
    key: "calcSize",
    value: function calcSize(size) {
      var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var width = size.width,
        height = size.height;
      // keep ratio
      if (limit.ratio) {
        var limitHeight;
        if (limit.ratio !== true) {
          this.localRatio = limit.ratio;
        }
        // const maxWidth = Math.max(limit.maxWidth || 0, this.editorMaxWidth)
        if (limit.minWidth) width = Math.max(limit.minWidth, width);
        if (limit.maxWidth) width = Math.min(limit.maxWidth, width);
        if (this.editorMaxWidth) width = Math.min(this.editorMaxWidth, width);
        height = width * this.localRatio;
        if (limit.minHeight && height < limit.minHeight) {
          limitHeight = true;
          height = limit.minHeight;
        }
        if (limit.maxHeight && height > limit.maxHeight) {
          limitHeight = true;
          height = limit.maxHeight;
        }
        if (limitHeight) {
          width = height / this.localRatio;
        }
      } else {
        if (size.width) {
          if (limit.minWidth) width = Math.max(limit.minWidth, width);
          if (limit.maxWidth) width = Math.min(limit.maxWidth, width);
        }
        if (size.height) {
          if (limit.minHeight) height = Math.max(limit.minHeight, height);
          if (limit.maxHeight) height = Math.min(limit.maxHeight, height);
        }
      }
      if (width) size.width = width + 'px';
      if (height) size.height = height + 'px';
      return size;
    }
  }, {
    key: "getNaturalSize",
    value: function getNaturalSize() {
      var ele = this.activeEle;
      var size = [0, 0];
      if (!ele.getAttribute('width') && !ele.getAttribute('height')) {
        size = [ele.naturalWidth || ele.offsetWidth, ele.naturalHeight || ele.offsetHeight];
        ele.setAttribute('width', size[0]);
        ele.setAttribute('height', size[1]);
      } else {
        size = [ele.getAttribute('width'), ele.getAttribute('height')];
      }
      return {
        width: (0, _parseInt2["default"])(size[0]),
        height: (0, _parseInt2["default"])(size[1])
      };
    }
  }, {
    key: "setCursor",
    value: function setCursor(value) {
      var _context4;
      (0, _forEach["default"])(_context4 = [document.body, this.activeEle]).call(_context4, function (el) {
        el.style.cursor = value; // eslint-disable-line no-param-reassign
      });
    }
  }]);

  return Resize;
}(_BaseModule2["default"]);
exports["default"] = Resize;