"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _BaseModule2 = _interopRequireDefault(require("./BaseModule"));
var _quill = require("../../../quill");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Parchment = _quill.Quill["import"]('parchment');
// Quill.js 2.x support
var ClassAttributor = Parchment.ClassAttributor ? Parchment.ClassAttributor : Parchment.Attributor.Class;
var ImageFormatClass = new ClassAttributor('imagestyle', 'ql-resize-style');
var Toolbar = /*#__PURE__*/function (_BaseModule) {
  (0, _inherits2["default"])(Toolbar, _BaseModule);
  var _super = _createSuper(Toolbar);
  function Toolbar() {
    (0, _classCallCheck2["default"])(this, Toolbar);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Toolbar, [{
    key: "onCreate",
    value: function onCreate() {
      // Setup Toolbar
      this.toolbar = document.createElement('div');
      (0, _assign["default"])(this.toolbar.style, this.options.styles.toolbar);
      this.overlay.appendChild(this.toolbar);
      // Setup Buttons
      this._defineAlignments();
      this._addToolbarButtons();
    }
  }, {
    key: "_defineAlignments",
    value: function _defineAlignments() {
      var _this = this;
      this.alignments = [{
        icon: "<i class=\"fishdicon fishdicon-richeditor-align-lef\"></i>",
        apply: function apply() {
          ImageFormatClass.add(_this.activeEle, 'left');
        },
        isApplied: function isApplied() {
          return ImageFormatClass.value(_this.activeEle) === 'left';
        }
      }, {
        icon: "<i class=\"fishdicon fishdicon-richeditor-align-mid\"></i>",
        apply: function apply() {
          ImageFormatClass.add(_this.activeEle, 'center');
        },
        isApplied: function isApplied() {
          return ImageFormatClass.value(_this.activeEle) === 'center';
        }
      }, {
        icon: "<i class=\"fishdicon fishdicon-richeditor-align-rig\"></i>",
        apply: function apply() {
          ImageFormatClass.add(_this.activeEle, 'right');
        },
        isApplied: function isApplied() {
          return ImageFormatClass.value(_this.activeEle) === 'right';
        }
      }
      // {
      //   icon:`<i class="fishdicon fishdicon-richeditor-align-all"></i>`,
      //   apply: () => {
      //     ImageFormatClass.add(this.activeEle, 'full');
      //   },
      //   isApplied: () => ImageFormatClass.value(this.activeEle) === 'full'
      // }
      ];
    }
  }, {
    key: "_addToolbarButtons",
    value: function _addToolbarButtons() {
      var _context,
        _this2 = this;
      var buttons = [];
      (0, _forEach["default"])(_context = this.alignments).call(_context, function (alignment, idx) {
        var button = document.createElement('span');
        buttons.push(button);
        button.innerHTML = alignment.icon;
        button.addEventListener('click', function () {
          // deselect all buttons
          (0, _forEach["default"])(buttons).call(buttons, function (button) {
            return button.style.filter = '';
          });
          if (alignment.isApplied()) {
            // If applied, unapply
            ImageFormatClass.remove(_this2.activeEle);
          } else {
            // otherwise, select button and apply
            _this2._selectButton(button);
            alignment.apply();
          }
          // image may change position; redraw drag handles
          _this2.requestUpdate();
        });
        (0, _assign["default"])(button.style, _this2.options.styles.toolbarButton);
        if (idx > 0) {
          button.style.borderLeftWidth = '0';
        }
        // console.log(button)
        (0, _assign["default"])(button.children[0].style, _this2.options.styles.toolbarButtonSvg);
        if (alignment.isApplied()) {
          // select button if previously applied
          _this2._selectButton(button);
        }
        _this2.toolbar.appendChild(button);
      });
      // Edit button
      // const button = document.createElement('span')
      // button.innerHTML = IconPencil
      // Object.assign(button.style, this.options.styles.toolbarButton)
      // button.style.borderLeftWidth = '0'
      // button.addEventListener('click', () => {
      //   this.quill.emitter.emit('resize-edit', this.activeEle, this.blot)
      // })
      // this.toolbar.appendChild(button)
    }
  }, {
    key: "_selectButton",
    value: function _selectButton(button) {
      button.style.filter = 'invert(20%)';
    }
  }]);
  return Toolbar;
}(_BaseModule2["default"]);
exports["default"] = Toolbar;