"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.CodeBlockContainer = exports.Code = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _block = _interopRequireDefault(require("../blots/block"));
var _break = _interopRequireDefault(require("../blots/break"));
var _cursor = _interopRequireDefault(require("../blots/cursor"));
var _inline = _interopRequireDefault(require("../blots/inline"));
var _text = _interopRequireWildcard(require("../blots/text"));
var _container = _interopRequireDefault(require("../blots/container"));
var _quill = _interopRequireDefault(require("../core/quill"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var CodeBlockContainer = /*#__PURE__*/function (_Container) {
  (0, _inherits2["default"])(CodeBlockContainer, _Container);
  var _super = _createSuper(CodeBlockContainer);
  function CodeBlockContainer() {
    (0, _classCallCheck2["default"])(this, CodeBlockContainer);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(CodeBlockContainer, [{
    key: "code",
    value: function code(index, length) {
      var _context, _context2;
      return (0, _slice["default"])(_context = (0, _map["default"])(_context2 = this.children).call(_context2, function (child) {
        return child.length() <= 1 ? '' : child.domNode.innerText;
      }).join('\n')).call(_context, index, index + length);
    }
  }, {
    key: "html",
    value: function html(index, length) {
      // `\n`s are needed in order to support empty lines at the beginning and the end.
      // https://html.spec.whatwg.org/multipage/syntax.html#element-restrictions
      return "<pre>\n".concat((0, _text.escapeText)(this.code(index, length)), "\n</pre>");
    }
  }], [{
    key: "create",
    value: function create(value) {
      var domNode = (0, _get2["default"])((0, _getPrototypeOf2["default"])(CodeBlockContainer), "create", this).call(this, value);
      domNode.setAttribute('spellcheck', false);
      return domNode;
    }
  }]);
  return CodeBlockContainer;
}(_container["default"]);
exports.CodeBlockContainer = CodeBlockContainer;
var CodeBlock = /*#__PURE__*/function (_Block) {
  (0, _inherits2["default"])(CodeBlock, _Block);
  var _super2 = _createSuper(CodeBlock);
  function CodeBlock() {
    (0, _classCallCheck2["default"])(this, CodeBlock);
    return _super2.apply(this, arguments);
  }
  (0, _createClass2["default"])(CodeBlock, null, [{
    key: "register",
    value: function register() {
      _quill["default"].register(CodeBlockContainer);
    }
  }]);
  return CodeBlock;
}(_block["default"]);
exports["default"] = CodeBlock;
var Code = /*#__PURE__*/function (_Inline) {
  (0, _inherits2["default"])(Code, _Inline);
  var _super3 = _createSuper(Code);
  function Code() {
    (0, _classCallCheck2["default"])(this, Code);
    return _super3.apply(this, arguments);
  }
  return (0, _createClass2["default"])(Code);
}(_inline["default"]);
exports.Code = Code;
Code.blotName = 'code';
Code.tagName = 'CODE';
CodeBlock.blotName = 'code-block';
CodeBlock.className = 'ql-code-block';
CodeBlock.tagName = 'DIV';
CodeBlockContainer.blotName = 'code-block-container';
CodeBlockContainer.className = 'ql-code-block-container';
CodeBlockContainer.tagName = 'DIV';
CodeBlockContainer.allowedChildren = [CodeBlock];
CodeBlock.allowedChildren = [_text["default"], _break["default"], _cursor["default"]];
CodeBlock.requiredContainer = CodeBlockContainer;
CodeBlock.TAB = '  ';