"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.matchAttributor = matchAttributor;
exports.matchBlot = matchBlot;
exports.matchNewline = matchNewline;
exports.matchText = matchText;
exports.traverse = traverse;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _weakMap = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/weak-map"));
var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var _keys2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/keys"));
var _startsWith = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/starts-with"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _parseFloat2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-float"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));
var _quillDelta = _interopRequireDefault(require("quill-delta"));
var _parchment = require("parchment");
var _block = require("../blots/block");
var _quill = _interopRequireDefault(require("../core/quill"));
var _logger = _interopRequireDefault(require("../core/logger"));
var _module = _interopRequireDefault(require("../core/module"));
var _align = require("../formats/align");
var _background = require("../formats/background");
var _code = _interopRequireDefault(require("../formats/code"));
var _color = require("../formats/color");
var _direction = require("../formats/direction");
var _font = require("../formats/font");
var _size = require("../formats/size");
var _keyboard = require("./keyboard");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var _context, _context2;
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var debug = (0, _logger["default"])('quill:clipboard');
var CLIPBOARD_CONFIG = [[Node.TEXT_NODE, matchText], [Node.TEXT_NODE, matchNewline], ['br', matchBreak], [Node.ELEMENT_NODE, matchNewline], [Node.ELEMENT_NODE, matchBlot], [Node.ELEMENT_NODE, matchAttributor], [Node.ELEMENT_NODE, matchStyles], ['li', matchIndent], ['ol, ul', matchList], ['pre', matchCodeBlock], ['tr', matchTable], ['b', (0, _bind["default"])(matchAlias).call(matchAlias, matchAlias, 'bold')], ['i', (0, _bind["default"])(matchAlias).call(matchAlias, matchAlias, 'italic')], ['strike', (0, _bind["default"])(matchAlias).call(matchAlias, matchAlias, 'strike')], ['style', matchIgnore]];
var ATTRIBUTE_ATTRIBUTORS = (0, _reduce["default"])(_context = [_align.AlignAttribute, _direction.DirectionAttribute]).call(_context, function (memo, attr) {
  memo[attr.keyName] = attr;
  return memo;
}, {});
var STYLE_ATTRIBUTORS = (0, _reduce["default"])(_context2 = [_align.AlignStyle, _background.BackgroundStyle, _color.ColorStyle, _direction.DirectionStyle, _font.FontStyle, _size.SizeStyle]).call(_context2, function (memo, attr) {
  memo[attr.keyName] = attr;
  return memo;
}, {});
var Clipboard = /*#__PURE__*/function (_Module) {
  (0, _inherits2["default"])(Clipboard, _Module);
  var _super = _createSuper(Clipboard);
  function Clipboard(quill, options) {
    var _context3, _context4;
    var _this;
    (0, _classCallCheck2["default"])(this, Clipboard);
    _this = _super.call(this, quill, options);
    _this.quill.root.addEventListener('copy', function (e) {
      return _this.onCaptureCopy(e, false);
    });
    _this.quill.root.addEventListener('cut', function (e) {
      return _this.onCaptureCopy(e, true);
    });
    _this.quill.root.addEventListener('paste', (0, _bind["default"])(_context3 = _this.onCapturePaste).call(_context3, (0, _assertThisInitialized2["default"])(_this)));
    _this.matchers = [];
    (0, _forEach["default"])(_context4 = (0, _concat["default"])(CLIPBOARD_CONFIG).call(CLIPBOARD_CONFIG, _this.options.matchers)).call(_context4, function (_ref) {
      var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
        selector = _ref2[0],
        matcher = _ref2[1];
      _this.addMatcher(selector, matcher);
    });
    return _this;
  }
  (0, _createClass2["default"])(Clipboard, [{
    key: "addMatcher",
    value: function addMatcher(selector, matcher) {
      this.matchers.push([selector, matcher]);
    }
  }, {
    key: "convert",
    value: function convert(_ref3) {
      var html = _ref3.html,
        text = _ref3.text;
      var formats = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      if (formats[_code["default"].blotName]) {
        return new _quillDelta["default"]().insert(text, (0, _defineProperty2["default"])({}, _code["default"].blotName, formats[_code["default"].blotName]));
      }
      if (!html) {
        return new _quillDelta["default"]().insert(text || '');
      }
      var delta = this.convertHTML(html);
      // Remove trailing newline
      if (deltaEndsWith(delta, '\n') && (delta.ops[delta.ops.length - 1].attributes == null || formats.table)) {
        return delta.compose(new _quillDelta["default"]().retain(delta.length() - 1)["delete"](1));
      }
      return delta;
    }
  }, {
    key: "convertHTML",
    value: function convertHTML(html) {
      var doc = new DOMParser().parseFromString(html, 'text/html');
      var container = doc.body;
      var nodeMatches = new _weakMap["default"]();
      var _this$prepareMatching = this.prepareMatching(container, nodeMatches),
        _this$prepareMatching2 = (0, _slicedToArray2["default"])(_this$prepareMatching, 2),
        elementMatchers = _this$prepareMatching2[0],
        textMatchers = _this$prepareMatching2[1];
      return traverse(this.quill.scroll, container, elementMatchers, textMatchers, nodeMatches);
    }
  }, {
    key: "dangerouslyPasteHTML",
    value: function dangerouslyPasteHTML(index, html) {
      var source = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _quill["default"].sources.API;
      if (typeof index === 'string') {
        var delta = this.convert({
          html: index,
          text: ''
        });
        this.quill.setContents(delta, html);
        this.quill.setSelection(0, _quill["default"].sources.SILENT);
      } else {
        var _context5;
        var paste = this.convert({
          html: html,
          text: ''
        });
        this.quill.updateContents((0, _concat["default"])(_context5 = new _quillDelta["default"]().retain(index)).call(_context5, paste), source);
        this.quill.setSelection(index + paste.length(), _quill["default"].sources.SILENT);
      }
    }
  }, {
    key: "onCaptureCopy",
    value: function onCaptureCopy(e) {
      var isCut = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (e.defaultPrevented) return;
      e.preventDefault();
      var _this$quill$selection = this.quill.selection.getRange(),
        _this$quill$selection2 = (0, _slicedToArray2["default"])(_this$quill$selection, 1),
        range = _this$quill$selection2[0];
      if (range == null) return;
      var _this$onCopy = this.onCopy(range, isCut),
        html = _this$onCopy.html,
        text = _this$onCopy.text;
      e.clipboardData.setData('text/plain', text);
      e.clipboardData.setData('text/html', html);
      if (isCut) {
        (0, _keyboard.deleteRange)({
          range: range,
          quill: this.quill
        });
      }
    }
  }, {
    key: "onCapturePaste",
    value: function onCapturePaste(e) {
      if (e.defaultPrevented || !this.quill.isEnabled()) return;
      e.preventDefault();
      var range = this.quill.getSelection(true);
      if (range == null) return;
      var html = e.clipboardData.getData('text/html');
      var text = e.clipboardData.getData('text/plain');
      var files = (0, _from["default"])(e.clipboardData.files || []);
      if (!html && files.length > 0) {
        this.quill.uploader.upload(range, files);
        return;
      }
      if (html && files.length > 0) {
        var doc = new DOMParser().parseFromString(html, 'text/html');
        if (doc.body.childElementCount === 1 && doc.body.firstElementChild.tagName === 'IMG') {
          this.quill.uploader.upload(range, files);
          return;
        }
      }
      this.onPaste(range, {
        html: html,
        text: text
      });
    }
  }, {
    key: "onCopy",
    value: function onCopy(range) {
      var text = this.quill.getText(range);
      var html = this.quill.getSemanticHTML(range);
      return {
        html: html,
        text: text
      };
    }
  }, {
    key: "onPaste",
    value: function onPaste(range, _ref4) {
      var _context6;
      var text = _ref4.text,
        html = _ref4.html;
      var formats = this.quill.getFormat(range.index);
      var pastedDelta = this.convert({
        text: text,
        html: html
      }, formats);
      debug.log('onPaste', pastedDelta, {
        text: text,
        html: html
      });
      var delta = (0, _concat["default"])(_context6 = new _quillDelta["default"]().retain(range.index)["delete"](range.length)).call(_context6, pastedDelta);
      this.quill.updateContents(delta, _quill["default"].sources.USER);
      // range.length contributes to delta.length()
      this.quill.setSelection(delta.length() - range.length, _quill["default"].sources.SILENT);
      this.quill.scrollIntoView();
    }
  }, {
    key: "prepareMatching",
    value: function prepareMatching(container, nodeMatches) {
      var _context7;
      var elementMatchers = [];
      var textMatchers = [];
      (0, _forEach["default"])(_context7 = this.matchers).call(_context7, function (pair) {
        var _context8;
        var _pair = (0, _slicedToArray2["default"])(pair, 2),
          selector = _pair[0],
          matcher = _pair[1];
        switch (selector) {
          case Node.TEXT_NODE:
            textMatchers.push(matcher);
            break;
          case Node.ELEMENT_NODE:
            elementMatchers.push(matcher);
            break;
          default:
            (0, _forEach["default"])(_context8 = (0, _from["default"])(container.querySelectorAll(selector))).call(_context8, function (node) {
              if (nodeMatches.has(node)) {
                var matches = nodeMatches.get(node);
                matches.push(matcher);
              } else {
                nodeMatches.set(node, [matcher]);
              }
            });
            break;
        }
      });
      return [elementMatchers, textMatchers];
    }
  }]);
  return Clipboard;
}(_module["default"]);
exports["default"] = Clipboard;
Clipboard.DEFAULTS = {
  matchers: []
};
function applyFormat(delta, format, value) {
  if ((0, _typeof2["default"])(format) === 'object') {
    var _context9;
    return (0, _reduce["default"])(_context9 = (0, _keys["default"])(format)).call(_context9, function (newDelta, key) {
      return applyFormat(newDelta, key, format[key]);
    }, delta);
  }
  return (0, _reduce["default"])(delta).call(delta, function (newDelta, op) {
    if (op.attributes && op.attributes[format]) {
      return newDelta.push(op);
    }
    var formats = value ? (0, _defineProperty2["default"])({}, format, value) : {};
    if (formats.list === 'ordered') {
      formats.orderedList = true;
    }
    return newDelta.insert(op.insert, (0, _assign["default"])((0, _assign["default"])({}, formats), op.attributes));
  }, new _quillDelta["default"]());
}
function deltaEndsWith(delta, text) {
  var endText = '';
  for (var i = delta.ops.length - 1; i >= 0 && endText.length < text.length; --i // eslint-disable-line no-plusplus
  ) {
    var op = delta.ops[i];
    if (typeof op.insert !== 'string') break;
    endText = op.insert + endText;
  }
  return (0, _slice["default"])(endText).call(endText, -1 * text.length) === text;
}
function isLine(node) {
  var _context10;
  if (node.childNodes.length === 0) return false; // Exclude embed blocks
  return (0, _includes["default"])(_context10 = ['address', 'article', 'blockquote', 'canvas', 'dd', 'div', 'dl', 'dt', 'fieldset', 'figcaption', 'figure', 'footer', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'header', 'iframe', 'li', 'main', 'nav', 'ol', 'output', 'p', 'pre', 'section', 'table', 'td', 'tr', 'ul', 'video']).call(_context10, node.tagName.toLowerCase());
}
var preNodes = new _weakMap["default"]();
function isPre(node) {
  if (node == null) return false;
  if (!preNodes.has(node)) {
    if (node.tagName === 'PRE') {
      preNodes.set(node, true);
    } else {
      preNodes.set(node, isPre(node.parentNode));
    }
  }
  return preNodes.get(node);
}
function traverse(scroll, node, elementMatchers, textMatchers, nodeMatches) {
  // Post-order
  if (node.nodeType === node.TEXT_NODE) {
    return (0, _reduce["default"])(textMatchers).call(textMatchers, function (delta, matcher) {
      return matcher(node, delta, scroll);
    }, new _quillDelta["default"]());
  }
  if (node.nodeType === node.ELEMENT_NODE) {
    var _context11;
    return (0, _reduce["default"])(_context11 = (0, _from["default"])(node.childNodes || [])).call(_context11, function (delta, childNode) {
      var childrenDelta = traverse(scroll, childNode, elementMatchers, textMatchers, nodeMatches);
      if (childNode.nodeType === node.ELEMENT_NODE) {
        var _context12;
        childrenDelta = (0, _reduce["default"])(elementMatchers).call(elementMatchers, function (reducedDelta, matcher) {
          return matcher(childNode, reducedDelta, scroll);
        }, childrenDelta);
        childrenDelta = (0, _reduce["default"])(_context12 = nodeMatches.get(childNode) || []).call(_context12, function (reducedDelta, matcher) {
          return matcher(childNode, reducedDelta, scroll);
        }, childrenDelta);
      }
      return (0, _concat["default"])(delta).call(delta, childrenDelta);
    }, new _quillDelta["default"]());
  }
  return new _quillDelta["default"]();
}
function matchAlias(format, node, delta) {
  return applyFormat(delta, format, true);
}
function matchAttributor(node, delta, scroll) {
  var _context13, _context14;
  var attributes = (0, _keys2["default"])(_parchment.Attributor).call(_parchment.Attributor, node);
  var classes = (0, _keys2["default"])(_parchment.ClassAttributor).call(_parchment.ClassAttributor, node);
  var styles = (0, _keys2["default"])(_parchment.StyleAttributor).call(_parchment.StyleAttributor, node);
  var formats = {};
  (0, _forEach["default"])(_context13 = (0, _concat["default"])(_context14 = (0, _concat["default"])(attributes).call(attributes, classes)).call(_context14, styles)).call(_context13, function (name) {
    var attr = scroll.query(name, _parchment.Scope.ATTRIBUTE);
    if (attr != null) {
      formats[attr.attrName] = attr.value(node);
      if (formats[attr.attrName]) return;
    }
    attr = ATTRIBUTE_ATTRIBUTORS[name];
    if (attr != null && (attr.attrName === name || attr.keyName === name)) {
      formats[attr.attrName] = attr.value(node) || undefined;
    }
    attr = STYLE_ATTRIBUTORS[name];
    if (attr != null && (attr.attrName === name || attr.keyName === name)) {
      attr = STYLE_ATTRIBUTORS[name];
      formats[attr.attrName] = attr.value(node) || undefined;
    }
  });
  if ((0, _keys["default"])(formats).length > 0) {
    return applyFormat(delta, formats);
  }
  return delta;
}
function matchBlot(node, delta, scroll) {
  var match = scroll.query(node);
  if (match == null) return delta;
  if (match.prototype instanceof _parchment.EmbedBlot) {
    var embed = {};
    var value = match.value(node);
    if (value != null) {
      embed[match.blotName] = value;
      return new _quillDelta["default"]().insert(embed, match.formats(node, scroll));
    }
  } else {
    if (match.prototype instanceof _parchment.BlockBlot && !deltaEndsWith(delta, '\n')) {
      delta.insert('\n');
    }
    if (typeof match.formats === 'function') {
      return applyFormat(delta, match.blotName, match.formats(node, scroll));
    }
  }
  return delta;
}
function matchBreak(node, delta) {
  if (!deltaEndsWith(delta, '\n')) {
    delta.insert('\n');
  }
  return delta;
}
function matchCodeBlock(node, delta, scroll) {
  var match = scroll.query('code-block');
  var language = match ? match.formats(node, scroll) : true;
  return applyFormat(delta, 'code-block', language);
}
function matchIgnore() {
  return new _quillDelta["default"]();
}
function matchIndent(node, delta, scroll) {
  var match = scroll.query(node);
  if (match == null || match.blotName !== 'list' || match.blotName !== 'orderedList' || !deltaEndsWith(delta, '\n')) {
    return delta;
  }
  var indent = -1;
  var parent = node.parentNode;
  while (parent != null) {
    var _context15;
    if ((0, _includes["default"])(_context15 = ['OL', 'UL']).call(_context15, parent.tagName)) {
      indent += 1;
    }
    parent = parent.parentNode;
  }
  if (indent <= 0) return delta;
  return (0, _reduce["default"])(delta).call(delta, function (composed, op) {
    if (op.attributes && typeof op.attributes.indent === 'number') {
      return composed.push(op);
    }
    return composed.insert(op.insert, (0, _assign["default"])({
      indent: indent
    }, op.attributes || {}));
  }, new _quillDelta["default"]());
}
function matchList(node, delta) {
  var list = node.tagName === 'OL' ? 'ordered' : 'bullet';
  return applyFormat(delta, 'list', list);
}
function matchNewline(node, delta, scroll) {
  if (!deltaEndsWith(delta, '\n')) {
    if (isLine(node)) {
      return delta.insert('\n');
    }
    if (delta.length() > 0 && node.nextSibling) {
      var nextSibling = node.nextSibling;
      while (nextSibling != null) {
        if (isLine(nextSibling)) {
          return delta.insert('\n');
        }
        var match = scroll.query(nextSibling);
        if (match && match.prototype instanceof _block.BlockEmbed) {
          return delta.insert('\n');
        }
        nextSibling = nextSibling.firstChild;
      }
    }
  }
  return delta;
}
function matchStyles(node, delta) {
  var _context16;
  var formats = {};
  var style = node.style || {};
  if (style.fontStyle === 'italic') {
    formats.italic = true;
  }
  if (style.textDecoration === 'underline') {
    formats.underline = true;
  }
  if (style.textDecoration === 'line-through') {
    formats.strike = true;
  }
  if ((0, _startsWith["default"])(_context16 = style.fontWeight).call(_context16, 'bold') || (0, _parseInt2["default"])(style.fontWeight, 10) >= 700) {
    formats.bold = true;
  }
  if ((0, _keys["default"])(formats).length > 0) {
    delta = applyFormat(delta, formats);
  }
  if ((0, _parseFloat2["default"])(style.textIndent || 0) > 0) {
    var _context17;
    // Could be 0.5in
    return (0, _concat["default"])(_context17 = new _quillDelta["default"]().insert('\t')).call(_context17, delta);
  }
  return delta;
}
function matchTable(node, delta) {
  var table = node.parentNode.tagName === 'TABLE' ? node.parentNode : node.parentNode.parentNode;
  var rows = (0, _from["default"])(table.querySelectorAll('tr'));
  var row = (0, _indexOf["default"])(rows).call(rows, node) + 1;
  return applyFormat(delta, 'table', row);
}
function matchText(node, delta) {
  var text = node.data;
  // Word represents empty line with <o:p>&nbsp;</o:p>
  if (node.parentNode.tagName === 'O:P') {
    return delta.insert((0, _trim["default"])(text).call(text));
  }
  if ((0, _trim["default"])(text).call(text).length === 0 && (0, _includes["default"])(text).call(text, '\n')) {
    return delta;
  }
  if (!isPre(node)) {
    var replacer = function replacer(collapse, match) {
      var replaced = match.replace(/[^\u00a0]/g, ''); // \u00a0 is nbsp;
      return replaced.length < 1 && collapse ? ' ' : replaced;
    };
    text = text.replace(/\r\n/g, ' ').replace(/\n/g, ' ');
    text = text.replace(/\s\s+/g, (0, _bind["default"])(replacer).call(replacer, replacer, true)); // collapse whitespace
    if (node.previousSibling == null && isLine(node.parentNode) || node.previousSibling != null && isLine(node.previousSibling)) {
      text = text.replace(/^\s+/, (0, _bind["default"])(replacer).call(replacer, replacer, false));
    }
    if (node.nextSibling == null && isLine(node.parentNode) || node.nextSibling != null && isLine(node.nextSibling)) {
      text = text.replace(/\s+$/, (0, _bind["default"])(replacer).call(replacer, replacer, false));
    }
  }
  return delta.insert(text);
}