"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _fill = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/fill"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var _quillDelta = _interopRequireDefault(require("quill-delta"));
var _quill = _interopRequireDefault(require("../core/quill"));
var _module = _interopRequireDefault(require("../core/module"));
var _table = require("../formats/table");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Table = /*#__PURE__*/function (_Module) {
  (0, _inherits2["default"])(Table, _Module);
  var _super = _createSuper(Table);
  function Table() {
    var _context;
    var _this;
    (0, _classCallCheck2["default"])(this, Table);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, (0, _concat["default"])(_context = [this]).call(_context, args));
    _this.listenBalanceCells();
    return _this;
  }
  (0, _createClass2["default"])(Table, [{
    key: "balanceTables",
    value: function balanceTables() {
      var _context2;
      (0, _forEach["default"])(_context2 = this.quill.scroll.descendants(_table.TableContainer)).call(_context2, function (table) {
        table.balanceCells();
      });
    }
  }, {
    key: "deleteColumn",
    value: function deleteColumn() {
      var _this$getTable = this.getTable(),
        _this$getTable2 = (0, _slicedToArray2["default"])(_this$getTable, 3),
        table = _this$getTable2[0],
        cell = _this$getTable2[2];
      if (cell == null) return;
      table.deleteColumn(cell.cellOffset());
      this.quill.update(_quill["default"].sources.USER);
    }
  }, {
    key: "deleteRow",
    value: function deleteRow() {
      var _this$getTable3 = this.getTable(),
        _this$getTable4 = (0, _slicedToArray2["default"])(_this$getTable3, 2),
        row = _this$getTable4[1];
      if (row == null) return;
      row.remove();
      this.quill.update(_quill["default"].sources.USER);
    }
  }, {
    key: "deleteTable",
    value: function deleteTable() {
      var _this$getTable5 = this.getTable(),
        _this$getTable6 = (0, _slicedToArray2["default"])(_this$getTable5, 1),
        table = _this$getTable6[0];
      if (table == null) return;
      var offset = table.offset();
      table.remove();
      this.quill.update(_quill["default"].sources.USER);
      this.quill.setSelection(offset, _quill["default"].sources.SILENT);
    }
  }, {
    key: "getTable",
    value: function getTable() {
      var range = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.quill.getSelection();
      if (range == null) return [null, null, null, -1];
      var _this$quill$getLine = this.quill.getLine(range.index),
        _this$quill$getLine2 = (0, _slicedToArray2["default"])(_this$quill$getLine, 2),
        cell = _this$quill$getLine2[0],
        offset = _this$quill$getLine2[1];
      if (cell == null || cell.statics.blotName !== _table.TableCell.blotName) {
        return [null, null, null, -1];
      }
      var row = cell.parent;
      var table = row.parent.parent;
      return [table, row, cell, offset];
    }
  }, {
    key: "insertColumn",
    value: function insertColumn(offset) {
      var range = this.quill.getSelection();
      var _this$getTable7 = this.getTable(range),
        _this$getTable8 = (0, _slicedToArray2["default"])(_this$getTable7, 3),
        table = _this$getTable8[0],
        row = _this$getTable8[1],
        cell = _this$getTable8[2];
      if (cell == null) return;
      var column = cell.cellOffset();
      table.insertColumn(column + offset);
      this.quill.update(_quill["default"].sources.USER);
      var shift = row.rowOffset();
      if (offset === 0) {
        shift += 1;
      }
      this.quill.setSelection(range.index + shift, range.length, _quill["default"].sources.SILENT);
    }
  }, {
    key: "insertColumnLeft",
    value: function insertColumnLeft() {
      this.insertColumn(0);
    }
  }, {
    key: "insertColumnRight",
    value: function insertColumnRight() {
      this.insertColumn(1);
    }
  }, {
    key: "insertRow",
    value: function insertRow(offset) {
      var range = this.quill.getSelection();
      var _this$getTable9 = this.getTable(range),
        _this$getTable10 = (0, _slicedToArray2["default"])(_this$getTable9, 3),
        table = _this$getTable10[0],
        row = _this$getTable10[1],
        cell = _this$getTable10[2];
      if (cell == null) return;
      var index = row.rowOffset();
      table.insertRow(index + offset);
      this.quill.update(_quill["default"].sources.USER);
      if (offset > 0) {
        this.quill.setSelection(range, _quill["default"].sources.SILENT);
      } else {
        this.quill.setSelection(range.index + row.children.length, range.length, _quill["default"].sources.SILENT);
      }
    }
  }, {
    key: "insertRowAbove",
    value: function insertRowAbove() {
      this.insertRow(0);
    }
  }, {
    key: "insertRowBelow",
    value: function insertRowBelow() {
      this.insertRow(1);
    }
  }, {
    key: "insertTable",
    value: function insertTable(rows, columns) {
      var _context3, _context4;
      var range = this.quill.getSelection();
      if (range == null) return;
      var delta = (0, _reduce["default"])(_context3 = (0, _fill["default"])(_context4 = new Array(rows)).call(_context4, 0)).call(_context3, function (memo) {
        var _context5;
        var text = (0, _fill["default"])(_context5 = new Array(columns)).call(_context5, '\n').join('');
        return memo.insert(text, {
          table: (0, _table.tableId)()
        });
      }, new _quillDelta["default"]().retain(range.index));
      this.quill.updateContents(delta, _quill["default"].sources.USER);
      this.quill.setSelection(range.index, _quill["default"].sources.SILENT);
      this.balanceTables();
    }
  }, {
    key: "listenBalanceCells",
    value: function listenBalanceCells() {
      var _this2 = this;
      this.quill.on(_quill["default"].events.SCROLL_OPTIMIZE, function (mutations) {
        (0, _some["default"])(mutations).call(mutations, function (mutation) {
          var _context6;
          if ((0, _includes["default"])(_context6 = ['TD', 'TR', 'TBODY', 'TABLE']).call(_context6, mutation.target.tagName)) {
            _this2.quill.once(_quill["default"].events.TEXT_CHANGE, function (delta, old, source) {
              if (source !== _quill["default"].sources.USER) return;
              _this2.balanceTables();
            });
            return true;
          }
          return false;
        });
      });
    }
  }], [{
    key: "register",
    value: function register() {
      _quill["default"].register(_table.TableCell);
      _quill["default"].register(_table.TableRow);
      _quill["default"].register(_table.TableBody);
      _quill["default"].register(_table.TableContainer);
    }
  }]);
  return Table;
}(_module["default"]);
var _default = Table;
exports["default"] = _default;