"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _quillDelta = _interopRequireDefault(require("quill-delta"));
var _emitter = _interopRequireDefault(require("../core/emitter"));
var _module = _interopRequireDefault(require("../core/module"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Uploader = /*#__PURE__*/function (_Module) {
  (0, _inherits2["default"])(Uploader, _Module);
  var _super = _createSuper(Uploader);
  function Uploader(quill, options) {
    var _this;
    (0, _classCallCheck2["default"])(this, Uploader);
    var _a;
    _this = _super.call(this, quill, options);
    // 这里的执行结果, 图片 drop, 自动读取 base64 渲染, 因为自定义图片上传, 会用接口传, 这里就没必要了
    if ((_a = quill.options.modules.imageDrop) === null || _a === void 0 ? void 0 : _a.customDropImage) {
      return (0, _possibleConstructorReturn2["default"])(_this);
    }
    quill.root.addEventListener('drop', function (e) {
      e.preventDefault();
      var _native;
      if (document.caretRangeFromPoint) {
        _native = document.caretRangeFromPoint(e.clientX, e.clientY);
      } else if (document.caretPositionFromPoint) {
        var position = document.caretPositionFromPoint(e.clientX, e.clientY);
        _native = document.createRange();
        _native.setStart(position.offsetNode, position.offset);
        _native.setEnd(position.offsetNode, position.offset);
      } else {
        return;
      }
      var normalized = quill.selection.normalizeNative(_native);
      var range = quill.selection.normalizedToRange(normalized);
      _this.upload(range, e.dataTransfer.files);
    });
    return _this;
  }
  (0, _createClass2["default"])(Uploader, [{
    key: "upload",
    value: function upload(range, files) {
      var _context,
        _this2 = this;
      var uploads = [];
      (0, _forEach["default"])(_context = (0, _from["default"])(files)).call(_context, function (file) {
        var _context2;
        if (file && (0, _includes["default"])(_context2 = _this2.options.mimetypes).call(_context2, file.type)) {
          uploads.push(file);
        }
      });
      if (uploads.length > 0) {
        this.options.handler.call(this, range, uploads);
      }
    }
  }]);
  return Uploader;
}(_module["default"]);
Uploader.DEFAULTS = {
  mimetypes: ['image/png', 'image/jpeg'],
  handler: function handler(range, files) {
    var _this3 = this;
    var promises = (0, _map["default"])(files).call(files, function (file) {
      return new _promise["default"](function (resolve) {
        var reader = new FileReader();
        reader.onload = function (e) {
          resolve(e.target.result);
        };
        reader.readAsDataURL(file);
      });
    });
    _promise["default"].all(promises).then(function (images) {
      var update = (0, _reduce["default"])(images).call(images, function (delta, image) {
        return delta.insert({
          image: image
        });
      }, new _quillDelta["default"]().retain(range.index)["delete"](range.length));
      _this3.quill.updateContents(update, _emitter["default"].sources.USER);
      _this3.quill.setSelection(range.index + images.length, _emitter["default"].sources.SILENT);
    });
  }
};
var _default = Uploader;
exports["default"] = _default;