"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var optionsCounter = 0;
function toggleAriaAttribute(element, attribute) {
  element.setAttribute(attribute, !(element.getAttribute(attribute) === 'true'));
}
var Picker = /*#__PURE__*/function () {
  function Picker(select) {
    var _this = this,
      _context;
    (0, _classCallCheck2["default"])(this, Picker);
    this.select = select;
    this.container = document.createElement('span');
    this.buildPicker();
    this.select.style.display = 'none';
    this.select.parentNode.insertBefore(this.container, this.select);
    this.label.addEventListener('mousedown', function () {
      _this.togglePicker();
    });
    this.label.addEventListener('keydown', function (event) {
      switch (event.key) {
        case 'Enter':
          _this.togglePicker();
          break;
        case 'Escape':
          _this.escape();
          event.preventDefault();
          break;
        default:
      }
    });
    this.select.addEventListener('change', (0, _bind["default"])(_context = this.update).call(_context, this));
  }
  (0, _createClass2["default"])(Picker, [{
    key: "togglePicker",
    value: function togglePicker() {
      this.container.classList.toggle('ql-expanded');
      // Toggle aria-expanded and aria-hidden to make the picker accessible
      toggleAriaAttribute(this.label, 'aria-expanded');
      toggleAriaAttribute(this.options, 'aria-hidden');
    }
  }, {
    key: "buildItem",
    value: function buildItem(option) {
      var _this2 = this;
      var item = document.createElement('span');
      item.tabIndex = '0';
      item.setAttribute('role', 'button');
      item.classList.add('ql-picker-item');
      if (option.hasAttribute('value')) {
        item.setAttribute('data-value', option.getAttribute('value'));
      }
      if (option.textContent) {
        item.setAttribute('data-label', option.textContent);
      }
      item.addEventListener('click', function () {
        _this2.selectItem(item, true);
      });
      item.addEventListener('keydown', function (event) {
        switch (event.key) {
          case 'Enter':
            _this2.selectItem(item, true);
            event.preventDefault();
            break;
          case 'Escape':
            _this2.escape();
            event.preventDefault();
            break;
          default:
        }
      });
      return item;
    }
  }, {
    key: "buildLabel",
    value: function buildLabel() {
      var label = document.createElement('span');
      label.classList.add('ql-picker-label');
      label.innerHTML = "<svg viewbox=\"0 0 18 18\">\n                        <polygon class=\"ql-stroke\" points=\"7 11 9 13 11 11 7 11\"></polygon>\n                        <polygon class=\"ql-stroke\" points=\"7 7 9 5 11 7 7 7\"></polygon>\n                      </svg>\n                      ";
      label.tabIndex = '0';
      label.setAttribute('role', 'button');
      label.setAttribute('aria-expanded', 'false');
      this.container.appendChild(label);
      return label;
    }
  }, {
    key: "buildOptions",
    value: function buildOptions() {
      var _context2,
        _this3 = this;
      var options = document.createElement('span');
      options.classList.add('ql-picker-options');
      // Don't want screen readers to read this until options are visible
      options.setAttribute('aria-hidden', 'true');
      options.tabIndex = '-1';
      // Need a unique id for aria-controls
      options.id = "ql-picker-options-".concat(optionsCounter);
      optionsCounter += 1;
      this.label.setAttribute('aria-controls', options.id);
      this.options = options;
      (0, _forEach["default"])(_context2 = (0, _from["default"])(this.select.options)).call(_context2, function (option) {
        var item = _this3.buildItem(option);
        options.appendChild(item);
        if (option.selected === true) {
          _this3.selectItem(item);
        }
      });
      this.container.appendChild(options);
    }
  }, {
    key: "buildPicker",
    value: function buildPicker() {
      var _context3,
        _this4 = this;
      (0, _forEach["default"])(_context3 = (0, _from["default"])(this.select.attributes)).call(_context3, function (item) {
        _this4.container.setAttribute(item.name, item.value);
      });
      this.container.classList.add('ql-picker');
      this.label = this.buildLabel();
      this.buildOptions();
    }
  }, {
    key: "escape",
    value: function escape() {
      var _this5 = this;
      // Close menu and return focus to trigger label
      this.close();
      // Need setTimeout for accessibility to ensure that the browser executes
      // focus on the next process thread and after any DOM content changes
      (0, _setTimeout2["default"])(function () {
        return _this5.label.focus();
      }, 1);
    }
  }, {
    key: "close",
    value: function close() {
      this.container.classList.remove('ql-expanded');
      this.label.setAttribute('aria-expanded', 'false');
      this.options.setAttribute('aria-hidden', 'true');
    }
  }, {
    key: "selectItem",
    value: function selectItem(item) {
      var _context4;
      var trigger = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var selected = this.container.querySelector('.ql-selected');
      if (item === selected) return;
      if (selected != null) {
        selected.classList.remove('ql-selected');
      }
      if (item == null) return;
      item.classList.add('ql-selected');
      this.select.selectedIndex = (0, _indexOf["default"])(_context4 = (0, _from["default"])(item.parentNode.children)).call(_context4, item);
      if (item.hasAttribute('data-value')) {
        this.label.setAttribute('data-value', item.getAttribute('data-value'));
      } else {
        this.label.removeAttribute('data-value');
      }
      if (item.hasAttribute('data-label')) {
        this.label.setAttribute('data-label', item.getAttribute('data-label'));
      } else {
        this.label.removeAttribute('data-label');
      }
      if (trigger) {
        this.select.dispatchEvent(new Event('change'));
        this.close();
      }
    }
  }, {
    key: "update",
    value: function update() {
      var option;
      if (this.select.selectedIndex > -1) {
        var item = this.container.querySelector('.ql-picker-options').children[this.select.selectedIndex];
        option = this.select.options[this.select.selectedIndex];
        this.selectItem(item);
      } else {
        this.selectItem(null);
      }
      var isActive = option != null && option !== this.select.querySelector('option[selected]');
      this.label.classList.toggle('ql-active', isActive);
    }
  }]);
  return Picker;
}();
var _default = Picker;
exports["default"] = _default;