"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _utils = require("../../utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var Handle = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Handle, _React$Component);
  var _super = _createSuper(Handle);
  function Handle() {
    var _this;
    (0, _classCallCheck2["default"])(this, Handle);
    _this = _super.apply(this, arguments);
    _this.state = {
      clickFocused: false
    };
    _this.handleMouseUp = function () {
      if (document.activeElement === _this.handle) {
        _this.setClickFocus(true);
      }
    };
    _this.handleBlur = function () {
      _this.setClickFocus(false);
    };
    _this.handleKeyDown = function () {
      _this.setClickFocus(false);
    };
    return _this;
  }
  (0, _createClass2["default"])(Handle, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // mouseup won't trigger if mouse moved out of handle,
      // so we listen on document here.
      this.onMouseUpListener = (0, _utils.addEventListener)(document, 'mouseup', this.handleMouseUp);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.onMouseUpListener) {
        this.onMouseUpListener.remove();
      }
    }
  }, {
    key: "setClickFocus",
    value: function setClickFocus(focused) {
      this.setState({
        clickFocused: focused
      });
    }
  }, {
    key: "clickFocus",
    value: function clickFocus() {
      this.setClickFocus(true);
      this.focus();
    }
  }, {
    key: "focus",
    value: function focus() {
      this.handle.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.handle.blur();
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        vertical = _a.vertical,
        offset = _a.offset,
        style = _a.style,
        disabled = _a.disabled,
        min = _a.min,
        max = _a.max,
        value = _a.value,
        tabIndex = _a.tabIndex,
        handle = _a.handle,
        restProps = __rest(_a, ["prefixCls", "vertical", "offset", "style", "disabled", "min", "max", "value", "tabIndex", "handle"]);
      var elClassName = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, this.props.className, true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-handle-custom"), !!this.props.handle), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-handle-click-focused"), this.state.clickFocused), _classNames));
      var postionStyle = vertical ? {
        bottom: "".concat(offset, "%")
      } : {
        left: "".concat(offset, "%")
      };
      var elStyle = (0, _assign["default"])((0, _assign["default"])({}, style), postionStyle);
      var ariaProps = {};
      if (value !== undefined) {
        ariaProps = (0, _assign["default"])((0, _assign["default"])({}, ariaProps), {
          'aria-valuemin': min,
          'aria-valuemax': max,
          'aria-valuenow': value,
          'aria-disabled': !!disabled
        });
      }
      return /*#__PURE__*/_react["default"].createElement("div", (0, _assign["default"])({
        ref: function ref(node) {
          return _this2.handle = node;
        },
        role: "slider",
        tabIndex: disabled ? null : tabIndex || 0
      }, ariaProps, restProps, {
        className: elClassName,
        style: elStyle,
        onBlur: this.handleBlur,
        onKeyDown: this.handleKeyDown
      }), !!handle && handle);
    }
  }]);
  return Handle;
}(_react["default"].Component);
exports["default"] = Handle;
Handle.propTypes = {
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  vertical: _propTypes["default"].bool,
  offset: _propTypes["default"].number,
  style: _propTypes["default"].object,
  disabled: _propTypes["default"].bool,
  min: _propTypes["default"].number,
  max: _propTypes["default"].number,
  value: _propTypes["default"].number,
  tabIndex: _propTypes["default"].number,
  handle: _propTypes["default"].node
};