"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _sort = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/sort"));
var _parseFloat2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-float"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var Marks = function Marks(_ref) {
  var _context, _context2;
  var className = _ref.className,
    vertical = _ref.vertical,
    marks = _ref.marks,
    included = _ref.included,
    upperBound = _ref.upperBound,
    lowerBound = _ref.lowerBound,
    max = _ref.max,
    min = _ref.min,
    onClickLabel = _ref.onClickLabel;
  var marksKeys = (0, _keys["default"])(marks);
  var marksCount = marksKeys.length;
  var unit = marksCount > 1 ? 100 / (marksCount - 1) : 100;
  var markWidth = unit * 0.9;
  var range = max - min;
  var elements = (0, _map["default"])(_context = (0, _sort["default"])(_context2 = (0, _map["default"])(marksKeys).call(marksKeys, _parseFloat2["default"])).call(_context2, function (a, b) {
    return a - b;
  })).call(_context, function (point) {
    var _classNames;
    var markPoint = marks[point];
    var markPointIsObject = (0, _typeof2["default"])(markPoint) === 'object' && ! /*#__PURE__*/_react["default"].isValidElement(markPoint);
    var markLabel = markPointIsObject ? markPoint.label : markPoint;
    if (!markLabel && markLabel !== 0) {
      return null;
    }
    var isActive = !included && point === upperBound || included && point <= upperBound && point >= lowerBound;
    var markClassName = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(className, "-text"), true), (0, _defineProperty2["default"])(_classNames, "".concat(className, "-text-active"), isActive), _classNames));
    var bottomStyle = {
      marginBottom: '-50%',
      bottom: "".concat((point - min) / range * 100, "%")
    };
    var leftStyle = {
      width: "".concat(markWidth, "%"),
      marginLeft: "".concat(-markWidth / 2, "%"),
      left: "".concat((point - min) / range * 100, "%")
    };
    var style = vertical ? bottomStyle : leftStyle;
    var markStyle = markPointIsObject ? (0, _assign["default"])((0, _assign["default"])({}, style), markPoint.style) : style;
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: markClassName,
      style: markStyle,
      key: point,
      onMouseDown: function onMouseDown(e) {
        return onClickLabel(e, point);
      },
      onTouchStart: function onTouchStart(e) {
        return onClickLabel(e, point);
      }
    }, markLabel);
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: className
  }, elements);
};
Marks.propTypes = {
  className: _propTypes["default"].string,
  vertical: _propTypes["default"].bool,
  marks: _propTypes["default"].object,
  included: _propTypes["default"].bool,
  upperBound: _propTypes["default"].number,
  lowerBound: _propTypes["default"].number,
  max: _propTypes["default"].number,
  min: _propTypes["default"].number,
  onClickLabel: _propTypes["default"].func
};
var _default = Marks;
exports["default"] = _default;