"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _parseFloat2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-float"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _warning = _interopRequireDefault(require("warning"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var calcPoints = function calcPoints(vertical, marks, dots, step, min, max) {
  var _context;
  (0, _warning["default"])(dots ? step > 0 : true, '`Slider[step]` should be a positive number in order to make Slider[dots] work.');
  var points = (0, _map["default"])(_context = (0, _keys["default"])(marks)).call(_context, _parseFloat2["default"]);
  if (dots) {
    for (var i = min; i <= max; i = i + step) {
      if ((0, _indexOf["default"])(points).call(points, i) >= 0) continue;
      points.push(i);
    }
  }
  return points;
};
var Steps = function Steps(_ref) {
  var _context2;
  var prefixCls = _ref.prefixCls,
    vertical = _ref.vertical,
    marks = _ref.marks,
    dots = _ref.dots,
    step = _ref.step,
    included = _ref.included,
    lowerBound = _ref.lowerBound,
    upperBound = _ref.upperBound,
    max = _ref.max,
    min = _ref.min,
    dotStyle = _ref.dotStyle,
    activeDotStyle = _ref.activeDotStyle;
  var range = max - min;
  var elements = (0, _map["default"])(_context2 = calcPoints(vertical, marks, dots, step, min, max)).call(_context2, function (point) {
    var _classNames;
    var offset = "".concat(Math.abs(point - min) / range * 100, "%");
    var isActived = !included && point === upperBound || included && point <= upperBound && point >= lowerBound;
    var style = vertical ? (0, _assign["default"])({
      bottom: offset
    }, dotStyle) : (0, _assign["default"])({
      left: offset
    }, dotStyle);
    if (isActived) {
      style = (0, _assign["default"])((0, _assign["default"])({}, style), activeDotStyle);
    }
    var pointClassName = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-dot"), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-dot-active"), isActived), _classNames));
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: pointClassName,
      style: style,
      key: point
    });
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-step")
  }, elements);
};
Steps.propTypes = {
  prefixCls: _propTypes["default"].string,
  vertical: _propTypes["default"].bool,
  marks: _propTypes["default"].object,
  dots: _propTypes["default"].bool,
  step: _propTypes["default"].number,
  included: _propTypes["default"].bool,
  lowerBound: _propTypes["default"].number,
  upperBound: _propTypes["default"].number,
  max: _propTypes["default"].number,
  min: _propTypes["default"].number,
  dotStyle: _propTypes["default"].object,
  activeDotStyle: _propTypes["default"].object
};
var _default = Steps;
exports["default"] = _default;