"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = createSliderWithTooltip;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _index = _interopRequireDefault(require("../Tooltip/index"));
var _RcHandle = _interopRequireDefault(require("./RcHandle"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
function createSliderWithTooltip(Component) {
  var _a;
  return _a = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2["default"])(ComponentWrapper, _React$Component);
    var _super = _createSuper(ComponentWrapper);
    function ComponentWrapper(props) {
      var _this;
      (0, _classCallCheck2["default"])(this, ComponentWrapper);
      _this = _super.call(this, props);
      _this.handleTooltipVisibleChange = function (index, visible) {
        _this.setState(function (prevState) {
          return {
            visibles: (0, _assign["default"])((0, _assign["default"])({}, prevState.visibles), (0, _defineProperty2["default"])({}, index, visible))
          };
        });
      };
      _this.handleWithTooltip = function (_a) {
        var value = _a.value,
          dragging = _a.dragging,
          index = _a.index,
          disabled = _a.disabled,
          restProps = __rest(_a, ["value", "dragging", "index", "disabled"]);
        var _this$props = _this.props,
          tipProps = _this$props.tipProps,
          handleStyle = _this$props.handleStyle;
        var _tipProps$prefixCls = tipProps.prefixCls,
          prefixCls = _tipProps$prefixCls === void 0 ? 'rc-slider-tooltip' : _tipProps$prefixCls,
          _tipProps$placement = tipProps.placement,
          placement = _tipProps$placement === void 0 ? 'top' : _tipProps$placement,
          _tipProps$visible = tipProps.visible,
          visible = _tipProps$visible === void 0 ? visible || false : _tipProps$visible,
          restTooltipProps = __rest(tipProps, ["prefixCls", "placement", "visible"]);
        var handleStyleWithIndex;
        if ((0, _isArray["default"])(handleStyle)) {
          handleStyleWithIndex = handleStyle[index] || handleStyle[0];
        } else {
          handleStyleWithIndex = handleStyle;
        }
        return /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _assign["default"])({}, restTooltipProps, {
          prefixCls: prefixCls,
          placement: placement,
          visible: !disabled && (_this.state.visibles[index] || dragging) || visible,
          key: index
        }), /*#__PURE__*/_react["default"].createElement(_RcHandle["default"], (0, _assign["default"])({}, restProps, {
          style: (0, _assign["default"])({}, handleStyleWithIndex),
          value: value,
          onMouseEnter: function onMouseEnter() {
            return _this.handleTooltipVisibleChange(index, true);
          },
          onMouseLeave: function onMouseLeave() {
            return _this.handleTooltipVisibleChange(index, false);
          }
        })));
      };
      _this.state = {
        visibles: {}
      };
      return _this;
    }
    (0, _createClass2["default"])(ComponentWrapper, [{
      key: "render",
      value: function render() {
        return /*#__PURE__*/_react["default"].createElement(Component, (0, _assign["default"])({}, this.props, {
          handle: this.handleWithTooltip
        }));
      }
    }]);
    return ComponentWrapper;
  }(_react["default"].Component), _a.propTypes = {
    handleStyle: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].arrayOf(_propTypes["default"].object)]),
    tipProps: _propTypes["default"].object
  }, _a.defaultProps = {
    handleStyle: [{}],
    tipProps: {}
  }, _a;
}