"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Dropdown = _interopRequireDefault(require("../Dropdown"));
var _Menu = _interopRequireDefault(require("../Menu"));
var _Icon = _interopRequireDefault(require("../Icon"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function checkSelection(props, data, type, byDefaultChecked) {
  var store = props.store,
    getCheckboxPropsByItem = props.getCheckboxPropsByItem,
    getRecordKey = props.getRecordKey;
  // type should be 'every' | 'some'
  if (type === 'every' || type === 'some') {
    return byDefaultChecked ? data[type](function (item, i) {
      return getCheckboxPropsByItem(item, i).defaultChecked;
    }) : data[type](function (item, i) {
      var _context;
      return (0, _indexOf["default"])(_context = store.getState().selectedRowKeys).call(_context, getRecordKey(item, i)) >= 0;
    });
  }
  return false;
}
function getCheckState(props) {
  var store = props.store,
    data = props.data;
  var checked;
  if (!data.length) {
    checked = false;
  } else {
    checked = store.getState().selectionDirty ? checkSelection(props, data, 'every', false) : checkSelection(props, data, 'every', false) || checkSelection(props, data, 'every', true);
  }
  return checked;
}
function getIndeterminateState(props) {
  var store = props.store,
    data = props.data;
  var indeterminate;
  if (!data.length) {
    indeterminate = false;
  } else {
    indeterminate = store.getState().selectionDirty ? checkSelection(props, data, 'some', false) && !checkSelection(props, data, 'every', false) : checkSelection(props, data, 'some', false) && !checkSelection(props, data, 'every', false) || checkSelection(props, data, 'some', true) && !checkSelection(props, data, 'every', true);
  }
  return indeterminate;
}
function getCheckAndIndeterminateState(props, state) {
  var checked = getCheckState(props);
  var indeterminate = getIndeterminateState(props);
  var newState = {};
  if (indeterminate !== state.indeterminate) {
    newState.indeterminate = indeterminate;
  }
  if (checked !== state.checked) {
    newState.checked = checked;
  }
  return newState;
}
var SelectionCheckboxAll = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(SelectionCheckboxAll, _React$Component);
  var _super = _createSuper(SelectionCheckboxAll);
  function SelectionCheckboxAll(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, SelectionCheckboxAll);
    _this = _super.call(this, props);
    _this.handleSelectAllChange = function (e) {
      var checked = e.target.checked;
      _this.props.onSelect(checked ? 'all' : 'removeAll', 0, null);
    };
    _this.defaultSelections = props.hideDefaultSelections ? [] : [{
      key: 'all',
      text: props.locale.selectAll,
      onSelect: function onSelect() {}
    }, {
      key: 'invert',
      text: props.locale.selectInvert,
      onSelect: function onSelect() {}
    }];
    _this.state = {
      checked: getCheckState(props),
      indeterminate: getIndeterminateState(props)
    };
    return _this;
  }
  (0, _createClass2["default"])(SelectionCheckboxAll, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.subscribe();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.unsubscribe) {
        this.unsubscribe();
      }
    }
  }, {
    key: "subscribe",
    value: function subscribe() {
      var _this2 = this;
      var store = this.props.store;
      this.unsubscribe = store.subscribe(function () {
        _this2.setState(getCheckAndIndeterminateState(_this2.props, _this2.state));
      });
    }
  }, {
    key: "renderMenus",
    value: function renderMenus(selections) {
      var _this3 = this;
      return (0, _map["default"])(selections).call(selections, function (selection, index) {
        return /*#__PURE__*/React.createElement(_Menu["default"].Item, {
          key: selection.key || index
        }, /*#__PURE__*/React.createElement("div", {
          onClick: function onClick() {
            _this3.props.onSelect(selection.key, index, selection.onSelect);
          }
        }, selection.text));
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        disabled = _this$props.disabled,
        prefixCls = _this$props.prefixCls,
        selections = _this$props.selections,
        getPopupContainer = _this$props.getPopupContainer;
      var _this$state = this.state,
        checked = _this$state.checked,
        indeterminate = _this$state.indeterminate;
      var selectionPrefixCls = "".concat(prefixCls, "-selection");
      var customSelections = null;
      if (selections) {
        var _context2;
        var newSelections = (0, _isArray["default"])(selections) ? (0, _concat["default"])(_context2 = this.defaultSelections).call(_context2, selections) : this.defaultSelections;
        var menu = /*#__PURE__*/React.createElement(_Menu["default"], {
          className: "".concat(selectionPrefixCls, "-menu"),
          selectedKeys: []
        }, this.renderMenus(newSelections));
        customSelections = newSelections.length > 0 ? /*#__PURE__*/React.createElement(_Dropdown["default"], {
          overlay: menu,
          getPopupContainer: getPopupContainer
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(selectionPrefixCls, "-down")
        }, /*#__PURE__*/React.createElement(_Icon["default"], {
          type: "down-bolder"
        }))) : null;
      }
      return /*#__PURE__*/React.createElement("div", {
        className: selectionPrefixCls
      }, /*#__PURE__*/React.createElement(_Checkbox["default"], {
        className: (0, _classnames["default"])((0, _defineProperty2["default"])({}, "".concat(selectionPrefixCls, "-select-all-custom"), customSelections)),
        checked: checked,
        indeterminate: indeterminate,
        disabled: disabled,
        onChange: this.handleSelectAllChange
      }), customSelections);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      return getCheckAndIndeterminateState(nextProps, prevState);
    }
  }]);
  return SelectionCheckboxAll;
}(React.Component);
(0, _reactLifecyclesCompat.polyfill)(SelectionCheckboxAll);
var _default = SelectionCheckboxAll;
exports["default"] = _default;