"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _miniStore = require("mini-store");
var _classnames = _interopRequireDefault(require("classnames"));
var _ColGroup = _interopRequireDefault(require("./ColGroup"));
var _TableHeader = _interopRequireDefault(require("./TableHeader"));
var _TableRow = _interopRequireDefault(require("./TableRow"));
var _ExpandableRow = _interopRequireDefault(require("./ExpandableRow"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var BaseTable = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(BaseTable, _React$Component);
  var _super = _createSuper(BaseTable);
  function BaseTable() {
    var _this;
    (0, _classCallCheck2["default"])(this, BaseTable);
    _this = _super.apply(this, arguments);
    _this.handleRowHover = function (isHover, key) {
      _this.props.store.setState({
        currentHoverKey: isHover ? key : null
      });
    };
    _this.renderRows = function (renderData, indent) {
      var ancestorKeys = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
      var table = _this.context.table;
      var columnManager = table.columnManager,
        components = table.components;
      var _table$props = table.props,
        prefixCls = _table$props.prefixCls,
        activeRowByClick = _table$props.activeRowByClick,
        childrenColumnName = _table$props.childrenColumnName,
        rowClassName = _table$props.rowClassName,
        rowRef = _table$props.rowRef,
        onRowClick = _table$props.onRowClick,
        onRowDoubleClick = _table$props.onRowDoubleClick,
        onRowContextMenu = _table$props.onRowContextMenu,
        onRowMouseEnter = _table$props.onRowMouseEnter,
        onRowMouseLeave = _table$props.onRowMouseLeave,
        onRow = _table$props.onRow;
      var _this$props = _this.props,
        getRowKey = _this$props.getRowKey,
        fixed = _this$props.fixed,
        expander = _this$props.expander,
        isAnyColumnsFixed = _this$props.isAnyColumnsFixed;
      var rows = [];
      var _loop = function _loop(i) {
        var record = renderData[i];
        var key = getRowKey(record, i);
        var className = typeof rowClassName === 'string' ? rowClassName : rowClassName(record, i, indent);
        var onHoverProps = {};
        if (columnManager.isAnyColumnsFixed()) {
          onHoverProps.onHover = _this.handleRowHover;
        }
        var leafColumns;
        if (fixed === 'left') {
          leafColumns = columnManager.leftLeafColumns();
        } else if (fixed === 'right') {
          leafColumns = columnManager.rightLeafColumns();
        } else {
          leafColumns = _this.getColumns(columnManager.leafColumns());
        }
        var rowPrefixCls = "".concat(prefixCls, "-row");
        var row = /*#__PURE__*/_react["default"].createElement(_ExpandableRow["default"], (0, _assign["default"])({}, expander.props, {
          fixed: fixed,
          index: i,
          prefixCls: rowPrefixCls,
          record: record,
          key: key,
          rowKey: key,
          onRowClick: onRowClick,
          needIndentSpaced: expander.needIndentSpaced,
          onExpandedChange: expander.handleExpandChange
        }), function (expandableRow) {
          return /*#__PURE__*/_react["default"].createElement(_TableRow["default"], (0, _assign["default"])({
            fixed: fixed,
            indent: indent,
            className: className,
            activeRowByClick: activeRowByClick,
            record: record,
            index: i,
            prefixCls: rowPrefixCls,
            childrenColumnName: childrenColumnName,
            columns: leafColumns,
            onRow: onRow,
            onRowDoubleClick: onRowDoubleClick,
            onRowContextMenu: onRowContextMenu,
            onRowMouseEnter: onRowMouseEnter,
            onRowMouseLeave: onRowMouseLeave
          }, onHoverProps, {
            rowKey: key,
            ancestorKeys: ancestorKeys,
            ref: rowRef(record, i, indent),
            components: components,
            isAnyColumnsFixed: isAnyColumnsFixed
          }, expandableRow));
        });
        rows.push(row);
        expander.renderRows(_this.renderRows, rows, record, i, indent, fixed, key, ancestorKeys);
      };
      for (var i = 0; i < renderData.length; i++) {
        _loop(i);
      }
      return rows;
    };
    return _this;
  }
  (0, _createClass2["default"])(BaseTable, [{
    key: "getColumns",
    value: function getColumns(cols) {
      var _context;
      var _this$props2 = this.props,
        _this$props2$columns = _this$props2.columns,
        columns = _this$props2$columns === void 0 ? [] : _this$props2$columns,
        fixed = _this$props2.fixed;
      var table = this.context.table;
      var prefixCls = table.props.prefixCls;
      return (0, _map["default"])(_context = cols || columns).call(_context, function (column) {
        return (0, _assign["default"])((0, _assign["default"])({}, column), {
          className: !!column.fixed && !fixed ? (0, _classnames["default"])("".concat(prefixCls, "-fixed-columns-in-body"), column.className) : column.className
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var table = this.context.table;
      var components = table.components;
      var _table$props2 = table.props,
        prefixCls = _table$props2.prefixCls,
        scroll = _table$props2.scroll,
        data = _table$props2.data,
        getBodyWrapper = _table$props2.getBodyWrapper;
      var _this$props3 = this.props,
        expander = _this$props3.expander,
        tableClassName = _this$props3.tableClassName,
        hasHead = _this$props3.hasHead,
        hasBody = _this$props3.hasBody,
        fixed = _this$props3.fixed;
      var tableStyle = {};
      if (!fixed && scroll.x) {
        // not set width, then use content fixed width
        if (scroll.x === true) {
          tableStyle.tableLayout = 'fixed';
        } else {
          tableStyle.width = scroll.x;
        }
      }
      var Table = hasBody ? components.table : 'table';
      var BodyWrapper = components.body.wrapper;
      var body;
      if (hasBody) {
        body = /*#__PURE__*/_react["default"].createElement(BodyWrapper, {
          className: "".concat(prefixCls, "-tbody")
        }, this.renderRows(data, 0));
        if (getBodyWrapper) {
          body = getBodyWrapper(body);
        }
      }
      var columns = this.getColumns();
      // ellipsis-column 添加 fixed支持
      if ((0, _some["default"])(columns).call(columns, function (column) {
        return column.ellipsis;
      })) {
        tableStyle.tableLayout = 'fixed';
        // 左右 fixed Table 添加宽度
        if (fixed) {
          var columnsWidthTotal = (0, _reduce["default"])(columns).call(columns, function (a, b) {
            return a + (0, _parseInt2["default"])(b.width);
          }, 0);
          columnsWidthTotal && (tableStyle.width = columnsWidthTotal);
        }
      }
      return /*#__PURE__*/_react["default"].createElement(Table, {
        className: tableClassName,
        style: tableStyle,
        key: "table"
      }, /*#__PURE__*/_react["default"].createElement(_ColGroup["default"], {
        columns: columns,
        fixed: fixed
      }), hasHead && /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], {
        expander: expander,
        columns: columns,
        fixed: fixed
      }), body);
    }
  }]);
  return BaseTable;
}(_react["default"].Component);
BaseTable.propTypes = {
  fixed: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool]),
  columns: _propTypes["default"].array.isRequired,
  tableClassName: _propTypes["default"].string.isRequired,
  hasHead: _propTypes["default"].bool.isRequired,
  hasBody: _propTypes["default"].bool.isRequired,
  store: _propTypes["default"].object.isRequired,
  expander: _propTypes["default"].object.isRequired,
  activeRowByClick: _propTypes["default"].func,
  getRowKey: _propTypes["default"].func,
  isAnyColumnsFixed: _propTypes["default"].bool
};
BaseTable.contextTypes = {
  table: _propTypes["default"].any
};
var _default = (0, _miniStore.connect)()(BaseTable);
exports["default"] = _default;