"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _get = _interopRequireDefault(require("lodash/get"));
var _Ellipsis = _interopRequireDefault(require("../../Ellipsis"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function isInvalidRenderCellText(text) {
  return text && ! /*#__PURE__*/_react["default"].isValidElement(text) && Object.prototype.toString.call(text) === '[object Object]';
}
var TableCell = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TableCell, _React$Component);
  var _super = _createSuper(TableCell);
  function TableCell() {
    var _this;
    (0, _classCallCheck2["default"])(this, TableCell);
    _this = _super.apply(this, arguments);
    _this.handleClick = function (e) {
      var _this$props = _this.props,
        record = _this$props.record,
        onCellClick = _this$props.column.onCellClick;
      if (onCellClick) {
        onCellClick(record, e);
      }
    };
    return _this;
  }
  (0, _createClass2["default"])(TableCell, [{
    key: "render",
    value: function render() {
      var _context;
      var _this$props2 = this.props,
        record = _this$props2.record,
        indentSize = _this$props2.indentSize,
        prefixCls = _this$props2.prefixCls,
        indent = _this$props2.indent,
        index = _this$props2.index,
        expandIcon = _this$props2.expandIcon,
        column = _this$props2.column,
        BodyCell = _this$props2.component;
      var dataIndex = column.dataIndex,
        render = column.render,
        _column$className = column.className,
        className = _column$className === void 0 ? '' : _column$className;
      // We should return undefined if no dataIndex is specified, but in order to
      // be compatible with object-path's behavior, we return the record object instead.
      var text;
      if (typeof dataIndex === 'number') {
        text = (0, _get["default"])(record, dataIndex);
      } else if (!dataIndex || dataIndex.length === 0) {
        text = record;
      } else {
        text = (0, _get["default"])(record, dataIndex);
      }
      var tdProps = {};
      var colSpan;
      var rowSpan;
      if (render) {
        text = render(text, record, index);
        if (isInvalidRenderCellText(text)) {
          tdProps = text.props || tdProps;
          colSpan = tdProps.colSpan;
          rowSpan = tdProps.rowSpan;
          text = text.children;
        }
      }
      if (column.onCell) {
        tdProps = (0, _assign["default"])((0, _assign["default"])({}, tdProps), column.onCell(record, index));
      }
      // Fix https://github.com/ant-design/ant-design/issues/1202
      if (isInvalidRenderCellText(text)) {
        text = null;
      }
      var indentText = expandIcon ? /*#__PURE__*/_react["default"].createElement("span", {
        style: {
          paddingLeft: "".concat(indentSize * indent, "px")
        },
        className: (0, _concat["default"])(_context = "".concat(prefixCls, "-indent indent-level-")).call(_context, indent)
      }) : null;
      if (rowSpan === 0 || colSpan === 0) {
        return null;
      }
      if (column.align) {
        tdProps.style = (0, _assign["default"])((0, _assign["default"])({}, tdProps.style), {
          textAlign: column.align
        });
      }
      if (column.ellipsis) {
        text = /*#__PURE__*/_react["default"].createElement(_Ellipsis["default"], {
          width: '100%',
          style: {
            position: 'relative',
            top: '3px'
          }
        }, text);
      }
      return /*#__PURE__*/_react["default"].createElement(BodyCell, (0, _assign["default"])({
        className: className,
        onClick: this.handleClick
      }, tdProps), indentText, expandIcon, text);
    }
  }]);
  return TableCell;
}(_react["default"].Component);
exports["default"] = TableCell;
TableCell.propTypes = {
  record: _propTypes["default"].object,
  prefixCls: _propTypes["default"].string,
  index: _propTypes["default"].number,
  indent: _propTypes["default"].number,
  indentSize: _propTypes["default"].number,
  column: _propTypes["default"].object,
  expandIcon: _propTypes["default"].node,
  component: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].node, _propTypes["default"].string])
};