"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _miniStore = require("mini-store");
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
function TableHeaderRow(_ref) {
  var row = _ref.row,
    index = _ref.index,
    height = _ref.height,
    components = _ref.components,
    onHeaderRow = _ref.onHeaderRow,
    prefixCls = _ref.prefixCls;
  var HeaderRow = components.header.row;
  var HeaderCell = components.header.cell;
  var rowProps = onHeaderRow((0, _map["default"])(row).call(row, function (cell) {
    return cell.column;
  }), index);
  var customStyle = rowProps ? rowProps.style : {};
  var style = (0, _assign["default"])({
    height: height
  }, customStyle);
  return /*#__PURE__*/_react["default"].createElement(HeaderRow, (0, _assign["default"])({}, rowProps, {
    style: style
  }), (0, _map["default"])(row).call(row, function (cell, i) {
    var column = cell.column,
      cellProps = __rest(cell, ["column"]);
    var customProps = column.onHeaderCell ? column.onHeaderCell(column) : {};
    if (column.align) {
      var _context;
      customProps.style = (0, _assign["default"])((0, _assign["default"])({}, customProps.style), {
        textAlign: column.align
      });
      customProps.className = (0, _classnames["default"])(customProps.className, column.className, (0, _defineProperty2["default"])({}, (0, _concat["default"])(_context = "".concat(prefixCls, "-align-")).call(_context, column.align), !!column.align));
    }
    return /*#__PURE__*/_react["default"].createElement(HeaderCell, (0, _assign["default"])({}, cellProps, customProps, {
      key: column.key || column.dataIndex || i
    }));
  }));
}
TableHeaderRow.propTypes = {
  row: _propTypes["default"].array,
  index: _propTypes["default"].number,
  prefixCls: _propTypes["default"].string,
  height: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  components: _propTypes["default"].shape({
    table: _propTypes["default"].any,
    header: _propTypes["default"].shape({
      wrapper: _propTypes["default"].any,
      row: _propTypes["default"].any,
      cell: _propTypes["default"].any
    }),
    body: _propTypes["default"].shape({
      wrapper: _propTypes["default"].any,
      row: _propTypes["default"].any,
      cell: _propTypes["default"].any
    })
  }),
  onHeaderRow: _propTypes["default"].func
};
function getRowHeight(state, props) {
  var fixedColumnsHeadRowsHeight = state.fixedColumnsHeadRowsHeight;
  var columns = props.columns,
    rows = props.rows,
    fixed = props.fixed;
  var headerHeight = fixedColumnsHeadRowsHeight[0];
  if (!fixed) {
    return null;
  }
  if (headerHeight && columns) {
    if (headerHeight === 'auto') {
      return 'auto';
    }
    return headerHeight / rows.length;
  }
  return null;
}
var _default = (0, _miniStore.connect)(function (state, props) {
  return {
    height: getRowHeight(state, props)
  };
})(TableHeaderRow);
exports["default"] = _default;