import * as React from 'react';
import './style/index.less';
export declare type TabsType = 'line' | 'card' | 'editable-card' | 'section' | 'borderless-section' | 'highlighted-section';
export declare type TabsPosition = 'top' | 'right' | 'bottom' | 'left';
export interface TabsProps {
    activeKey?: string;
    animated?: boolean | {
        inkBar: boolean;
        tabPane: boolean;
    };
    className?: string;
    defaultActiveKey?: string;
    hideAdd?: boolean;
    loading?: boolean;
    prefixCls?: string;
    size?: 'large' | 'default' | 'small';
    style?: React.CSSProperties;
    tabBarExtraContent?: React.ReactNode | null;
    tabBarStyle?: React.CSSProperties;
    tabBarGutter?: number;
    type?: TabsType;
    tabPosition?: TabsPosition;
    children?: React.ReactNode;
    onEdit?: (targetKey: string | React.MouseEvent<HTMLElement>, action: any) => void;
    onChange?: (activeKey: string) => void;
    onTabClick?: Function;
    onPrevClick?: React.MouseEventHandler<any>;
    onNextClick?: React.MouseEventHandler<any>;
}
export interface TabPaneProps {
    /** 选项卡头显示文字 */
    tab?: React.ReactNode | string;
    style?: React.CSSProperties;
    closable?: boolean;
    className?: string;
    disabled?: boolean;
    forceRender?: boolean;
    children?: React.ReactNode;
}
export default class Tabs extends React.Component<TabsProps, any> {
    static TabPane: React.ClassicComponentClass<TabPaneProps>;
    static defaultProps: {
        prefixCls: string;
        hideAdd: boolean;
        loading: boolean;
        size: string;
        tabPosition: string;
        type: string;
    };
    createNewTab: (targetKey: React.MouseEvent<HTMLElement>) => void;
    removeTab: (targetKey: string, e: React.MouseEvent<HTMLElement>) => void;
    handleChange: (activeKey: string) => void;
    componentDidMount(): void;
    render(): JSX.Element;
}
