"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _warning = _interopRequireDefault(require("warning"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var TabBarTabsNode = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TabBarTabsNode, _React$Component);
  var _super = _createSuper(TabBarTabsNode);
  function TabBarTabsNode() {
    (0, _classCallCheck2["default"])(this, TabBarTabsNode);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(TabBarTabsNode, [{
    key: "render",
    value: function render() {
      var _context,
        _this = this;
      var _this$props = this.props,
        children = _this$props.panels,
        activeKey = _this$props.activeKey,
        prefixCls = _this$props.prefixCls,
        tabBarGutter = _this$props.tabBarGutter;
      var rst = [];
      (0, _forEach["default"])(_context = _react["default"].Children).call(_context, children, function (child, index) {
        if (!child) {
          return;
        }
        var key = child.key;
        var cls = activeKey === key ? "".concat(prefixCls, "-tab-active") : '';
        cls += " ".concat(prefixCls, "-tab");
        var events = {};
        if (child.props.disabled) {
          cls += " ".concat(prefixCls, "-tab-disabled");
        } else {
          var _context2;
          events = {
            onClick: (0, _bind["default"])(_context2 = _this.props.onTabClick).call(_context2, _this, key)
          };
        }
        var ref = {};
        if (activeKey === key) {
          ref.ref = _this.props.saveRef('activeTab');
        }
        (0, _warning["default"])('tab' in child.props, 'There must be `tab` property on children of Tabs.');
        rst.push( /*#__PURE__*/_react["default"].createElement("div", (0, _assign["default"])({
          role: "tab",
          "aria-disabled": child.props.disabled ? 'true' : 'false',
          "aria-selected": activeKey === key ? 'true' : 'false'
        }, events, {
          className: cls,
          key: key,
          style: {
            marginRight: tabBarGutter && index === children.length - 1 ? 0 : tabBarGutter
          }
        }, ref), child.props.tab));
      });
      return rst;
    }
  }]);
  return TabBarTabsNode;
}(_react["default"].Component);
exports["default"] = TabBarTabsNode;
TabBarTabsNode.propTypes = {
  activeKey: _propTypes["default"].string.isRequired,
  panels: _propTypes["default"].node,
  prefixCls: _propTypes["default"].string,
  tabBarGutter: _propTypes["default"].number,
  onTabClick: _propTypes["default"].func,
  saveRef: _propTypes["default"].func
};
TabBarTabsNode.defaultProps = {
  panels: [],
  prefixCls: [],
  tabBarGutter: null,
  onTabClick: function onTabClick() {},
  saveRef: function saveRef() {}
};