"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames2 = _interopRequireDefault(require("classnames"));
var _utils = require("./utils");
var _index = _interopRequireDefault(require("../../Spin/index"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var TabContent = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TabContent, _React$Component);
  var _super = _createSuper(TabContent);
  function TabContent() {
    (0, _classCallCheck2["default"])(this, TabContent);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(TabContent, [{
    key: "getTabPanes",
    value: function getTabPanes() {
      var _context;
      var props = this.props;
      var activeKey = props.activeKey;
      var children = props.children;
      var newChildren = [];
      if (props.loading) {
        return /*#__PURE__*/_react["default"].createElement(_index["default"].Container, {
          style: {
            height: '100%',
            width: '100%',
            minHeight: '28px'
          }
        }, /*#__PURE__*/_react["default"].createElement(_index["default"], {
          spinning: true
        }));
      }
      (0, _forEach["default"])(_context = _react["default"].Children).call(_context, children, function (child) {
        if (!child) {
          return;
        }
        var key = child.key;
        var active = activeKey === key;
        newChildren.push( /*#__PURE__*/_react["default"].cloneElement(child, {
          active: active,
          destroyInactiveTabPane: props.destroyInactiveTabPane,
          rootPrefixCls: props.prefixCls
        }));
      });
      return newChildren;
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames;
      var props = this.props;
      var prefixCls = props.prefixCls,
        children = props.children,
        activeKey = props.activeKey,
        tabBarPosition = props.tabBarPosition,
        animated = props.animated,
        animatedWithMargin = props.animatedWithMargin;
      var style = props.style;
      var classes = (0, _classnames2["default"])((_classnames = {}, (0, _defineProperty2["default"])(_classnames, "".concat(prefixCls, "-content"), true), (0, _defineProperty2["default"])(_classnames, animated ? "".concat(prefixCls, "-content-animated") : "".concat(prefixCls, "-content-no-animated"), true), _classnames));
      if (animated) {
        var activeIndex = (0, _utils.getActiveIndex)(children, activeKey);
        if (activeIndex !== -1) {
          var animatedStyle = animatedWithMargin ? (0, _utils.getMarginStyle)(activeIndex, tabBarPosition) : (0, _utils.getTransformPropValue)((0, _utils.getTransformByIndex)(activeIndex, tabBarPosition));
          style = (0, _assign["default"])((0, _assign["default"])({}, style), animatedStyle);
        } else {
          style = (0, _assign["default"])((0, _assign["default"])({}, style), {
            display: 'none'
          });
        }
      }
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes,
        style: style
      }, this.getTabPanes());
    }
  }]);
  return TabContent;
}(_react["default"].Component);
exports["default"] = TabContent;
TabContent.propTypes = {
  animated: _propTypes["default"].bool,
  animatedWithMargin: _propTypes["default"].bool,
  prefixCls: _propTypes["default"].string,
  children: _propTypes["default"].node,
  activeKey: _propTypes["default"].string,
  // style: PropTypes.any,
  style: _propTypes["default"].object,
  tabBarPosition: _propTypes["default"].string
};
TabContent.defaultProps = {
  animated: true
};