"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _reverse = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reverse"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _KeyCode = _interopRequireDefault(require("./KeyCode"));
var _TabPane = _interopRequireDefault(require("./TabPane"));
var _classnames2 = _interopRequireDefault(require("classnames"));
var _utils = require("./utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
function noop() {}
function getDefaultActiveKey(props) {
  var _context;
  var activeKey;
  (0, _forEach["default"])(_context = _react["default"].Children).call(_context, props.children, function (child) {
    if (child && !activeKey && !child.props.disabled) {
      activeKey = child.key;
    }
  });
  return activeKey;
}
function activeKeyIsValid(props, key) {
  var _context2;
  var keys = (0, _map["default"])(_context2 = _react["default"].Children).call(_context2, props.children, function (child) {
    return child && child.key;
  });
  return (0, _indexOf["default"])(keys).call(keys, key) >= 0;
}
var Tabs = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Tabs, _React$Component);
  var _super = _createSuper(Tabs);
  function Tabs(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Tabs);
    _this = _super.call(this, props);
    _this.onTabClick = function (activeKey, e) {
      if (_this.tabBar.props.onTabClick) {
        _this.tabBar.props.onTabClick(activeKey, e);
      }
      _this.setActiveKey(activeKey);
    };
    _this.onNavKeyDown = function (e) {
      var eventKeyCode = e.keyCode;
      if (eventKeyCode === _KeyCode["default"].RIGHT || eventKeyCode === _KeyCode["default"].DOWN) {
        e.preventDefault();
        var nextKey = _this.getNextActiveKey(true);
        _this.onTabClick(nextKey);
      } else if (eventKeyCode === _KeyCode["default"].LEFT || eventKeyCode === _KeyCode["default"].UP) {
        e.preventDefault();
        var previousKey = _this.getNextActiveKey(false);
        _this.onTabClick(previousKey);
      }
    };
    _this.onScroll = function (_ref) {
      var target = _ref.target,
        currentTarget = _ref.currentTarget;
      if (target === currentTarget && target.scrollLeft > 0) {
        target.scrollLeft = 0;
      }
    };
    _this.setActiveKey = function (activeKey) {
      if (_this.state.activeKey !== activeKey) {
        if (!('activeKey' in _this.props)) {
          _this.setState({
            activeKey: activeKey
          });
        }
        _this.props.onChange(activeKey);
      }
    };
    _this.getNextActiveKey = function (next) {
      var _context3;
      var activeKey = _this.state.activeKey;
      var children = [];
      (0, _forEach["default"])(_context3 = _react["default"].Children).call(_context3, _this.props.children, function (c) {
        if (c && !c.props.disabled) {
          if (next) {
            children.push(c);
          } else {
            children.unshift(c);
          }
        }
      });
      var length = children.length;
      var ret = length && children[0].key;
      (0, _forEach["default"])(children).call(children, function (child, i) {
        if (child.key === activeKey) {
          if (i === length - 1) {
            ret = children[0].key;
          } else {
            ret = children[i + 1].key;
          }
        }
      });
      return ret;
    };
    var activeKey;
    if ('activeKey' in props && typeof props.activeKey == 'string') {
      activeKey = props.activeKey;
    } else if ('defaultActiveKey' in props && typeof props.defaultActiveKey == 'string') {
      activeKey = props.defaultActiveKey;
    } else {
      activeKey = getDefaultActiveKey(props);
    }
    _this.state = {
      activeKey: activeKey
    };
    return _this;
  }
  (0, _createClass2["default"])(Tabs, [{
    key: "render",
    value: function render() {
      var _context4, _classnames;
      var props = this.props;
      var prefixCls = props.prefixCls,
        navWrapper = props.navWrapper,
        tabBarPosition = props.tabBarPosition,
        className = props.className,
        renderTabContent = props.renderTabContent,
        renderTabBar = props.renderTabBar,
        destroyInactiveTabPane = props.destroyInactiveTabPane,
        restProps = __rest(props, ["prefixCls", "navWrapper", "tabBarPosition", "className", "renderTabContent", "renderTabBar", "destroyInactiveTabPane"]);
      var cls = (0, _classnames2["default"])((_classnames = {}, (0, _defineProperty2["default"])(_classnames, prefixCls, 1), (0, _defineProperty2["default"])(_classnames, (0, _concat["default"])(_context4 = "".concat(prefixCls, "-")).call(_context4, tabBarPosition), 1), (0, _defineProperty2["default"])(_classnames, className, !!className), _classnames));
      this.tabBar = renderTabBar();
      var contents = [/*#__PURE__*/_react["default"].cloneElement(this.tabBar, {
        prefixCls: prefixCls,
        navWrapper: navWrapper,
        key: 'tabBar',
        onKeyDown: this.onNavKeyDown,
        tabBarPosition: tabBarPosition,
        onTabClick: this.onTabClick,
        panels: props.children,
        activeKey: this.state.activeKey
      }), /*#__PURE__*/_react["default"].cloneElement(renderTabContent(), {
        prefixCls: prefixCls,
        tabBarPosition: tabBarPosition,
        activeKey: this.state.activeKey,
        destroyInactiveTabPane: destroyInactiveTabPane,
        children: props.children,
        onChange: this.setActiveKey,
        key: 'tabContent'
      })];
      if (tabBarPosition === 'bottom') {
        (0, _reverse["default"])(contents).call(contents);
      }
      return /*#__PURE__*/_react["default"].createElement("div", (0, _assign["default"])({
        className: cls,
        style: props.style
      }, (0, _utils.getDataAttr)(restProps), {
        onScroll: this.onScroll
      }), contents);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if ('activeKey' in nextProps) {
        newState.activeKey = nextProps.activeKey;
      } else if (!activeKeyIsValid(nextProps, prevState.activeKey)) {
        // https://github.com/ant-design/ant-design/issues/7093
        newState.activeKey = getDefaultActiveKey(nextProps);
      }
      return newState;
    }
  }]);
  return Tabs;
}(_react["default"].Component);
Tabs.propTypes = {
  destroyInactiveTabPane: _propTypes["default"].bool,
  renderTabBar: _propTypes["default"].func.isRequired,
  renderTabContent: _propTypes["default"].func.isRequired,
  navWrapper: _propTypes["default"].func,
  onChange: _propTypes["default"].func,
  children: _propTypes["default"].node,
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  tabBarPosition: _propTypes["default"].string,
  style: _propTypes["default"].object,
  activeKey: _propTypes["default"].string,
  defaultActiveKey: _propTypes["default"].string
};
Tabs.defaultProps = {
  prefixCls: 'rc-tabs',
  destroyInactiveTabPane: false,
  onChange: noop,
  navWrapper: function navWrapper(arg) {
    return arg;
  },
  tabBarPosition: 'top',
  children: null,
  style: {}
};
Tabs.TabPane = _TabPane["default"];
(0, _reactLifecyclesCompat.polyfill)(Tabs);
var _default = Tabs;
exports["default"] = _default;