import * as React from 'react';
import Tree, { TreeProps, FishdTreeNodeExpandedEvent, FishdTreeNodeSelectedEvent, FishdTreeNode } from './Tree';
export declare type ExpandAction = false | 'click' | 'doubleClick';
export interface DirectoryTreeProps extends TreeProps {
    expandAction?: ExpandAction;
}
export interface DirectoryTreeState {
    expandedKeys?: string[];
    selectedKeys?: string[];
}
declare class DirectoryTree extends React.Component<DirectoryTreeProps, DirectoryTreeState> {
    static defaultProps: {
        prefixCls: string;
        showIcon: boolean;
        expandAction: string;
    };
    state: DirectoryTreeState;
    tree: Tree;
    onDebounceExpand: (event: React.MouseEvent<HTMLElement>, node: FishdTreeNode) => void;
    lastSelectedKey?: string;
    cachedSelectedKeys?: string[];
    static getDerivedStateFromProps(nextProps: DirectoryTreeProps): DirectoryTreeState;
    constructor(props: DirectoryTreeProps);
    onExpand: (expandedKeys: string[], info: FishdTreeNodeExpandedEvent) => void | PromiseLike<any>;
    onClick: (event: React.MouseEvent<HTMLElement>, node: FishdTreeNode) => void;
    onDoubleClick: (event: React.MouseEvent<HTMLElement>, node: FishdTreeNode) => void;
    onSelect: (keys: string[], event: FishdTreeNodeSelectedEvent) => void;
    expandFolderNode: (event: React.MouseEvent<HTMLElement>, node: FishdTreeNode) => void;
    setUncontrolledState: (state: DirectoryTreeState) => void;
    render(): JSX.Element;
}
export default DirectoryTree;
