"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;
exports.selectorPropTypes = exports.selectorContextTypes = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _util = require("../util");
var _index = _interopRequireDefault(require("../../../Icon/index"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var selectorPropTypes = {
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  open: _propTypes["default"].bool,
  valueList: _propTypes["default"].array,
  allowClear: _propTypes["default"].bool,
  showArrow: _propTypes["default"].bool,
  uniqueTreeNodeByLabel: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  removeSelected: _propTypes["default"].func,
  // Pass by component
  ariaId: _propTypes["default"].string
};
exports.selectorPropTypes = selectorPropTypes;
var selectorContextTypes = {
  onSelectorFocus: _propTypes["default"].func.isRequired,
  onSelectorBlur: _propTypes["default"].func.isRequired,
  onSelectorKeyDown: _propTypes["default"].func.isRequired,
  onSelectorClear: _propTypes["default"].func.isRequired
};
exports.selectorContextTypes = selectorContextTypes;
function _default(modeName) {
  var BaseSelector = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2["default"])(BaseSelector, _React$Component);
    var _super = _createSuper(BaseSelector);
    function BaseSelector() {
      var _this;
      (0, _classCallCheck2["default"])(this, BaseSelector);
      _this = _super.call(this);
      _this.onFocus = function () {
        var _this$props = _this.props,
          onFocus = _this$props.onFocus,
          focused = _this$props.focused;
        var onSelectorFocus = _this.context.rcTreeSelect.onSelectorFocus;
        if (!focused) {
          onSelectorFocus();
        }
        if (onFocus) {
          onFocus.apply(void 0, arguments);
        }
      };
      _this.onBlur = function () {
        var onBlur = _this.props.onBlur;
        var onSelectorBlur = _this.context.rcTreeSelect.onSelectorBlur;
        // TODO: Not trigger when is inner component get focused
        onSelectorBlur();
        if (onBlur) {
          onBlur.apply(void 0, arguments);
        }
      };
      _this.focus = function () {
        _this.domRef.current.focus();
      };
      _this.blur = function () {
        _this.domRef.current.focus();
      };
      _this.domRef = (0, _util.createRef)();
      return _this;
    }
    (0, _createClass2["default"])(BaseSelector, [{
      key: "renderClear",
      value: function renderClear() {
        var _this$props2 = this.props,
          prefixCls = _this$props2.prefixCls,
          allowClear = _this$props2.allowClear,
          valueList = _this$props2.valueList;
        var onSelectorClear = this.context.rcTreeSelect.onSelectorClear;
        if (!allowClear || !valueList.length || !valueList[0].value) {
          return null;
        }
        return /*#__PURE__*/_react["default"].createElement("span", {
          key: "clear",
          className: "".concat(prefixCls, "-selection__clear"),
          onClick: onSelectorClear
        });
      }
    }, {
      key: "renderArrow",
      value: function renderArrow() {
        var _this$props3 = this.props,
          prefixCls = _this$props3.prefixCls,
          showArrow = _this$props3.showArrow;
        if (!showArrow) {
          return null;
        }
        return /*#__PURE__*/_react["default"].createElement(_index["default"], {
          key: "arrow",
          type: "down-fill",
          className: "".concat(prefixCls, "-arrow"),
          style: {
            outline: 'none'
          }
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _classNames, _context;
        var _this$props4 = this.props,
          prefixCls = _this$props4.prefixCls,
          className = _this$props4.className,
          style = _this$props4.style,
          open = _this$props4.open,
          focused = _this$props4.focused,
          disabled = _this$props4.disabled,
          allowClear = _this$props4.allowClear,
          onClick = _this$props4.onClick,
          ariaId = _this$props4.ariaId,
          renderSelection = _this$props4.renderSelection,
          renderPlaceholder = _this$props4.renderPlaceholder,
          tabIndex = _this$props4.tabIndex,
          showArrow = _this$props4.showArrow;
        var onSelectorKeyDown = this.context.rcTreeSelect.onSelectorKeyDown;
        var myTabIndex = tabIndex;
        if (disabled) {
          myTabIndex = null;
        }
        return /*#__PURE__*/_react["default"].createElement("span", {
          style: style,
          // 用 onMouseDown 代替 onClick，修复加载页面后点击弹层，RcTrigger v2.6.2 中
          // onDocumentClick 先于 onPopupMouseDown 执行，导致的弹层异常关闭的问题
          onMouseDown: onClick,
          className: (0, _classnames["default"])(className, prefixCls, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-open"), open), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-focused"), open || focused), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-disabled"), disabled), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-enabled"), !disabled), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-allow-clear"), allowClear), _classNames)),
          ref: this.domRef,
          role: "combobox",
          "aria-expanded": open,
          "aria-owns": open ? ariaId : undefined,
          "aria-controls": open ? ariaId : undefined,
          "aria-haspopup": "listbox",
          "aria-disabled": disabled,
          tabIndex: myTabIndex,
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          onKeyDown: onSelectorKeyDown
        }, /*#__PURE__*/_react["default"].createElement("span", {
          key: "selection",
          className: (0, _classnames["default"])("".concat(prefixCls, "-selection"), (0, _concat["default"])(_context = "".concat(prefixCls, "-selection--")).call(_context, modeName), {
            readonly: modeName == 'multiple' && showArrow
          })
        }, renderSelection(), this.renderClear(), this.renderArrow(), renderPlaceholder && renderPlaceholder()));
      }
    }]);
    return BaseSelector;
  }(_react["default"].Component);
  BaseSelector.propTypes = (0, _assign["default"])((0, _assign["default"])({}, selectorPropTypes), {
    // Pass by HOC
    renderSelection: _propTypes["default"].func.isRequired,
    renderPlaceholder: _propTypes["default"].func,
    tabIndex: _propTypes["default"].number
  });
  BaseSelector.contextTypes = {
    rcTreeSelect: _propTypes["default"].shape((0, _assign["default"])({}, selectorContextTypes))
  };
  BaseSelector.defaultProps = {
    tabIndex: 0
  };
  (0, _reactLifecyclesCompat.polyfill)(BaseSelector);
  return BaseSelector;
}