"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _rcTrigger = _interopRequireDefault(require("rc-trigger"));
var _classnames = _interopRequireDefault(require("classnames"));
var _util = require("./util");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var commonPlacements = {
  overflow: {
    adjustX: 1,
    adjustY: 1
  },
  ignoreShake: true
};
var BUILT_IN_PLACEMENTS = {
  leftCenter: (0, _assign["default"])({
    points: ['cr', 'cl'],
    offset: [-8, 0]
  }, commonPlacements),
  leftTop: (0, _assign["default"])({
    points: ['tr', 'tl'],
    offset: [-8, 0]
  }, commonPlacements),
  leftBottom: (0, _assign["default"])({
    points: ['br', 'bl'],
    offset: [-8, 0]
  }, commonPlacements),
  rightCenter: (0, _assign["default"])({
    points: ['cl', 'cr'],
    offset: [8, 0]
  }, commonPlacements),
  rightTop: (0, _assign["default"])({
    points: ['tl', 'tr'],
    offset: [8, 0]
  }, commonPlacements),
  rightBottom: (0, _assign["default"])({
    points: ['bl', 'br'],
    offset: [8, 0]
  }, commonPlacements),
  topCenter: (0, _assign["default"])({
    points: ['bc', 'tc'],
    offset: [0, -8]
  }, commonPlacements),
  topRight: (0, _assign["default"])({
    points: ['br', 'tr'],
    offset: [0, -8]
  }, commonPlacements),
  topLeft: (0, _assign["default"])({
    points: ['bl', 'tl'],
    offset: [0, -8]
  }, commonPlacements),
  bottomCenter: (0, _assign["default"])({
    points: ['tc', 'bc'],
    offset: [0, 8]
  }, commonPlacements),
  bottomRight: (0, _assign["default"])({
    points: ['tr', 'br'],
    offset: [0, 8]
  }, commonPlacements),
  bottomLeft: (0, _assign["default"])({
    points: ['tl', 'bl'],
    offset: [0, 8]
  }, commonPlacements)
};
var SelectTrigger = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(SelectTrigger, _React$Component);
  var _super = _createSuper(SelectTrigger);
  function SelectTrigger(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, SelectTrigger);
    _this = _super.call(this, props);
    _this.getDropdownTransitionName = function () {
      var _this$props = _this.props,
        transitionName = _this$props.transitionName,
        animation = _this$props.animation,
        dropdownPrefixCls = _this$props.dropdownPrefixCls;
      if (!transitionName && animation) {
        var _context;
        return (0, _concat["default"])(_context = "".concat(dropdownPrefixCls, "-")).call(_context, animation);
      }
      return transitionName;
    };
    _this.forcePopupAlign = function () {
      var $trigger = _this.triggerRef.current;
      if ($trigger) {
        $trigger.forcePopupAlign();
      }
    };
    _this.triggerRef = (0, _util.createRef)();
    return _this;
  }
  (0, _createClass2["default"])(SelectTrigger, [{
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props2 = this.props,
        disabled = _this$props2.disabled,
        isMultiple = _this$props2.isMultiple,
        dropdownPopupAlign = _this$props2.dropdownPopupAlign,
        dropdownMatchSelectWidth = _this$props2.dropdownMatchSelectWidth,
        dropdownClassName = _this$props2.dropdownClassName,
        dropdownStyle = _this$props2.dropdownStyle,
        onDropdownVisibleChange = _this$props2.onDropdownVisibleChange,
        getPopupContainer = _this$props2.getPopupContainer,
        dropdownPrefixCls = _this$props2.dropdownPrefixCls,
        popupElement = _this$props2.popupElement,
        open = _this$props2.open,
        children = _this$props2.children,
        placement = _this$props2.placement;
      // TODO: [Legacy] Use new action when trigger fixed: https://github.com/react-component/trigger/pull/86
      // When false do nothing with the width
      // ref: https://github.com/ant-design/ant-design/issues/10927
      var stretch;
      if (dropdownMatchSelectWidth !== false) {
        stretch = dropdownMatchSelectWidth ? 'width' : 'minWidth';
      }
      return /*#__PURE__*/_react["default"].createElement(_rcTrigger["default"], {
        ref: this.triggerRef,
        action: disabled ? [] : ['click'],
        popupPlacement: placement,
        // forceRender
        builtinPlacements: BUILT_IN_PLACEMENTS,
        popupAlign: dropdownPopupAlign,
        prefixCls: dropdownPrefixCls,
        popupTransitionName: this.getDropdownTransitionName(),
        onPopupVisibleChange: onDropdownVisibleChange,
        popup: popupElement,
        popupVisible: open,
        getPopupContainer: getPopupContainer,
        stretch: stretch,
        popupClassName: (0, _classnames["default"])(dropdownClassName, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(dropdownPrefixCls, "--multiple"), isMultiple), (0, _defineProperty2["default"])(_classNames, "".concat(dropdownPrefixCls, "--single"), !isMultiple), _classNames)),
        popupStyle: dropdownStyle
      }, children);
    }
  }]);
  return SelectTrigger;
}(_react["default"].Component);
SelectTrigger.propTypes = {
  // Pass by outside user props
  disabled: _propTypes["default"].bool,
  dropdownPopupAlign: _propTypes["default"].object,
  placement: _propTypes["default"].string,
  dropdownClassName: _propTypes["default"].string,
  dropdownStyle: _propTypes["default"].object,
  getPopupContainer: _propTypes["default"].func,
  children: _propTypes["default"].node,
  dropdownMatchSelectWidth: _propTypes["default"].bool,
  transitionName: _propTypes["default"].string,
  animation: _propTypes["default"].string,
  // Pass by Select
  isMultiple: _propTypes["default"].bool,
  dropdownPrefixCls: _propTypes["default"].string,
  onDropdownVisibleChange: _propTypes["default"].func,
  popupElement: _propTypes["default"].node,
  open: _propTypes["default"].bool
};
SelectTrigger.defaultProps = {
  open: false
};
(0, _reactLifecyclesCompat.polyfill)(SelectTrigger);
var _default = SelectTrigger;
exports["default"] = _default;