import * as React from 'react';
export interface ThenableArgument {
    (_: any): any;
}
export interface MessageType {
    (): void;
    then: (fill: ThenableArgument, reject: ThenableArgument) => Promise<any>;
    promise: Promise<any>;
}
declare type ConfigContent = React.ReactNode | string;
declare type ConfigDuration = number | (() => void);
export declare type ConfigOnClose = () => void;
export interface ConfigOptions {
    top?: number;
    duration?: number;
    prefixCls?: string;
    getContainer?: () => HTMLElement;
    transitionName?: string;
    maxCount?: number;
}
declare const _default: {
    info(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    success(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    error(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    warn(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    warning(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    loading(content: ConfigContent, duration?: ConfigDuration, onClose?: ConfigOnClose): MessageType;
    config(options: ConfigOptions): void;
    destroy(): void;
};
export default _default;
