import * as React from 'react';
import { AnimateHooks } from './animate';
export declare type AnimationNames = {
    appear: string;
    appearActive: string;
    enter: string;
    enterActive: string;
    leave: string;
    leaveActive: string;
};
export declare type AnimateChildProps = {
    names: AnimationNames;
} & AnimateHooks & {
    onAppearing?: (node?: HTMLElement) => void;
    onAppeared?: (node?: HTMLElement) => void;
    onEntering?: (node?: HTMLElement) => void;
    onEntered?: (node?: HTMLElement) => void;
    onExit?: (node?: HTMLElement) => void;
    onExiting?: (node?: HTMLElement) => void;
    onExited?: (node?: HTMLElement) => void;
    timeout: number | {
        appear?: number;
        enter?: number;
        exit?: number;
    };
};
export interface AnimateChildState {
    node: React.ReactNode;
    endListeners: {
        transitionend: [];
        animationend: [];
    };
    timeoutMap: object;
}
export interface EndListeners {
    transitionend: any[];
    animationend: any[];
}
export default class AnimateChild extends React.Component<AnimateChildProps, AnimateChildState> {
    static propTypes: {
        names: any;
        onAppear: any;
        onAppearing: any;
        onAppeared: any;
        onEnter: any;
        onEntering: any;
        onEntered: any;
        onExit: any;
        onExiting: any;
        onExited: any;
        timeout: any;
    };
    static defaultProps: {
        onAppear: () => void;
        onAppearing: () => void;
        onAppeared: () => void;
        onEnter: () => void;
        onEntering: () => void;
        onEntered: () => void;
        onExit: () => void;
        onExiting: () => void;
        onExited: () => void;
    };
    endListeners: EndListeners;
    timeoutMap: {};
    node: HTMLElement;
    transitionOff: () => void;
    animationOff: () => void;
    constructor(props: any);
    componentWillUnmount(): void;
    generateEndListener: (node: any, done: any, eventName: any, id: any) => (e: any) => void;
    addEndListener: (node: any, done: any) => void;
    removeEndtListener: () => void;
    removeClassNames: (node: any, names: any) => void;
    handleEnter: (node: any, isAppearing?: boolean) => void;
    handleEntering: (node: any, isAppearing?: boolean) => void;
    handleEntered: (node: any, isAppearing?: boolean) => void;
    handleExit: (node: any) => void;
    handleExiting: (node: any) => void;
    handleExited: (node: any) => void;
    render(): JSX.Element;
}
