"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _isNan = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/is-nan"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Slider = _interopRequireDefault(require("../Slider"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _Popover = _interopRequireDefault(require("../Popover"));
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var AudioPlayer = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(AudioPlayer, _React$Component);
  var _super = _createSuper(AudioPlayer);
  function AudioPlayer(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, AudioPlayer);
    _this = _super.call(this, props);
    _this.audioInstance = null;
    _this.controlAudio = function (type, value) {
      var audio = _this.audioInstance;
      var numberValue = Number(value);
      switch (type) {
        case 'allTime':
          _this.setState({
            allTime: audio.duration,
            disabled: isNaN(audio.duration) || !isFinite(audio.duration)
          });
          _this.props.onCanPlay();
          break;
        case 'play':
          if (_this.state.disabled) {
            return;
          }
          audio.play();
          _this.setState({
            isPlay: true
          });
          break;
        case 'pause':
          if (_this.state.disabled) {
            return;
          }
          audio.pause();
          _this.setState({
            isPlay: false
          });
          break;
        case 'changeCurrentTime':
          _this.setState({
            currentTime: value
          });
          audio.currentTime = value;
          if (value == audio.duration) {
            _this.setState({
              isPlay: false
            });
          }
          break;
        case 'getCurrentTime':
          _this.setState({
            currentTime: audio.currentTime
          });
          if (audio.currentTime == audio.duration) {
            _this.setState({
              isPlay: false
            });
          }
          break;
        case 'changeVolume':
          audio.volume = value / 100;
          _this.setState({
            currentVolume: value,
            isMuted: !value
          });
          break;
        case 'changeRate':
          if ((0, _isNan["default"])(numberValue)) {
            throw new Error("rateOptions props error:\n          rateOptions.value or item of rateOptions.range can not convert to number");
          }
          audio.playbackRate = numberValue;
          _this.setState({
            rate: value,
            rateOpen: false
          });
          break;
      }
    };
    _this.millisecondToDate = function (time) {
      var _context3;
      var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var second = Math.floor(time % 60);
      var minute = Math.floor(time / 60);
      if (!format) {
        return minute * 60 + second;
      }
      var hour;
      if (minute > 60) {
        var _context, _context2;
        hour = minute / 60;
        minute = minute % 60;
        return (0, _concat["default"])(_context = (0, _concat["default"])(_context2 = "".concat(Math.floor(hour), ":")).call(_context2, Math.floor(minute), ":")).call(_context, Math.floor(second));
      }
      return (0, _concat["default"])(_context3 = "".concat(minute, ":")).call(_context3, second >= 10 ? second : "0".concat(second));
    };
    _this.getVolumePopupContent = function () {
      var currentVolume = _this.state.currentVolume;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "change-audio-volume-box"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "change-audio-volume-value"
      }, currentVolume, "%"), /*#__PURE__*/_react["default"].createElement("div", {
        className: "change-audio-volume-slider"
      }, /*#__PURE__*/_react["default"].createElement(_Slider["default"], {
        vertical: true,
        min: 0,
        max: 100,
        step: 1,
        handle: /*#__PURE__*/_react["default"].createElement("div", {
          className: "change-audio-volume-customer-handle"
        }, /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
          type: "sound-drag"
        })),
        tipFormatter: null,
        defaultValue: currentVolume,
        onChange: function onChange(value) {
          return _this.controlAudio('changeVolume', value);
        }
      })));
    };
    // 调节音量面板状态变化
    _this.onVolumeVisibleChange = function (state) {
      _this.setState({
        volumeOpen: state
      });
    };
    // 调节播放速度板状态变化
    _this.onRateVisibleChange = function (state) {
      _this.setState({
        rateOpen: state
      });
    };
    _this.state = {
      isPlay: _this.props.autoPlay,
      isMuted: _this.props.muted,
      currentVolume: (0, _parseInt2["default"])(String(_this.props.volume * 100)),
      volumeOpen: false,
      rateOpen: false,
      allTime: 0,
      currentTime: 0,
      disabled: !_this.props.src,
      rate: _this.props.rateOptions.value || 1 // 播放速度
    };

    _this.audioInstance = null;
    return _this;
  }
  (0, _createClass2["default"])(AudioPlayer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.controlAudio('changeRate', this.state.rate);
      if (this.props.autoPlay) {
        this.audioInstance.play();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$state = this.state,
        isPlay = _this$state.isPlay,
        isMuted = _this$state.isMuted,
        allTime = _this$state.allTime,
        currentTime = _this$state.currentTime,
        currentVolume = _this$state.currentVolume,
        volumeOpen = _this$state.volumeOpen,
        rateOpen = _this$state.rateOpen,
        disabled = _this$state.disabled,
        rate = _this$state.rate;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        title = _a.title,
        src = _a.src,
        autoPlay = _a.autoPlay,
        className = _a.className,
        size = _a.size,
        loop = _a.loop,
        preload = _a.preload,
        controlVolume = _a.controlVolume,
        controlProgress = _a.controlProgress,
        displayTime = _a.displayTime,
        download = _a.download,
        rateOptions = _a.rateOptions,
        onCanPlay = _a.onCanPlay,
        onLoadedMetadata = _a.onLoadedMetadata,
        onCanPlayThrough = _a.onCanPlayThrough,
        onAbort = _a.onAbort,
        onEnded = _a.onEnded,
        onError = _a.onError,
        onPause = _a.onPause,
        onPlay = _a.onPlay,
        onSeeked = _a.onSeeked,
        otherProps = __rest(_a, ["prefixCls", "title", "src", "autoPlay", "className", "size", "loop", "preload", "controlVolume", "controlProgress", "displayTime", "download", "rateOptions", "onCanPlay", "onLoadedMetadata", "onCanPlayThrough", "onAbort", "onEnded", "onError", "onPause", "onPlay", "onSeeked"]);
      var _rateOptions$value = rateOptions.value,
        rateValue = _rateOptions$value === void 0 ? 0 : _rateOptions$value,
        _rateOptions$suffix = rateOptions.suffix,
        rateSuffix = _rateOptions$suffix === void 0 ? 'x' : _rateOptions$suffix,
        _rateOptions$decimal = rateOptions.decimal,
        rateDecimal = _rateOptions$decimal === void 0 ? 1 : _rateOptions$decimal,
        _rateOptions$range = rateOptions.range,
        rateRange = _rateOptions$range === void 0 ? [] : _rateOptions$range;
      var getRateText = function getRateText(rate) {
        var _context4;
        return (0, _concat["default"])(_context4 = "".concat(Number(rate).toFixed(rateDecimal))).call(_context4, rateSuffix);
      };
      var sizeCls = size === 'small' ? 'sm' : '';
      var pausePlayIcon = !isPlay ? 'play' : 'stop';
      var volumeIcon = function volumeIcon() {
        if (isMuted || currentVolume === 0) {
          return 'sound-mute';
        } else if (currentVolume > 0 && currentVolume <= 50) {
          return 'sound-medium';
        } else {
          return 'sound-loud';
        }
      };
      return /*#__PURE__*/_react["default"].createElement(_Consumer["default"], {
        componentName: "AudioPlayer"
      }, function (Locale) {
        var _context5, _context6;
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])(prefixCls, className, (0, _defineProperty2["default"])({}, (0, _concat["default"])(_context5 = "".concat(prefixCls, "-")).call(_context5, sizeCls), sizeCls))
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-wrap"), (0, _defineProperty2["default"])({}, (0, _concat["default"])(_context6 = "".concat(prefixCls, "-")).call(_context6, sizeCls, "-wrap"), sizeCls)),
          title: title
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "audio-box"
        }, /*#__PURE__*/_react["default"].createElement("audio", (0, _assign["default"])({
          ref: function ref(instance) {
            return _this2.audioInstance = instance;
          },
          src: src,
          preload: preload,
          loop: loop,
          volume: currentVolume / 100,
          onCanPlay: function onCanPlay() {
            return _this2.controlAudio('allTime');
          },
          onTimeUpdate: function onTimeUpdate(e) {
            return _this2.controlAudio('getCurrentTime');
          },
          onLoadedMetadata: onLoadedMetadata,
          onCanPlayThrough: onCanPlayThrough,
          onAbort: onAbort,
          onEnded: onEnded,
          onError: onError,
          onPause: onPause,
          onPlay: onPlay,
          onSeeked: onSeeked
        }, otherProps), Locale.notSupport)), /*#__PURE__*/_react["default"].createElement("div", {
          className: "box pause-play-box pause-play-box-".concat(disabled ? 'disabled' : 'enable'),
          onClick: function onClick() {
            return _this2.controlAudio(isPlay ? 'pause' : 'play');
          }
        }, /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
          className: "handle-audio-icon pause-play",
          type: pausePlayIcon
        })), controlProgress ? /*#__PURE__*/_react["default"].createElement("div", {
          className: "box step-box"
        }, /*#__PURE__*/_react["default"].createElement(_Slider["default"], {
          step: 1,
          min: 0,
          max: Number(_this2.millisecondToDate(allTime, false)),
          value: currentTime,
          disabled: disabled,
          tipMode: "all",
          tipFormatter: function tipFormatter(value) {
            return _this2.millisecondToDate(value);
          },
          onChange: function onChange(value) {
            return _this2.controlAudio('changeCurrentTime', value);
          }
        })) : null, displayTime ? /*#__PURE__*/_react["default"].createElement("div", {
          className: "box time-box"
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "current"
        }, _this2.millisecondToDate(currentTime) + ' / ' + _this2.millisecondToDate(allTime))) : null, controlVolume ? /*#__PURE__*/_react["default"].createElement(_Popover["default"], {
          overlayClassName: "change-audio-volume",
          trigger: "click",
          placement: "top",
          content: _this2.getVolumePopupContent(),
          visible: volumeOpen,
          onVisibleChange: _this2.onVolumeVisibleChange,
          getPopupContainer: function getPopupContainer(node) {
            return node.parentElement;
          }
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "box volume-box"
        }, /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
          className: "handle-audio-icon control-volume",
          type: volumeIcon()
        }))) : null, rateRange.length ? /*#__PURE__*/_react["default"].createElement(_Popover["default"], {
          overlayClassName: "change-audio-rate",
          trigger: "click",
          placement: "top",
          visible: rateOpen,
          onVisibleChange: _this2.onRateVisibleChange,
          getPopupContainer: function getPopupContainer(node) {
            return node.parentElement;
          },
          content: (0, _map["default"])(rateRange).call(rateRange, function (rateItem) {
            return /*#__PURE__*/_react["default"].createElement("p", {
              className: "change-audio-rate-item",
              key: "rate-".concat(rateItem),
              onClick: function onClick() {
                _this2.controlAudio('changeRate', rateItem);
              }
            }, getRateText(rateItem));
          })
        }, /*#__PURE__*/_react["default"].createElement("p", {
          className: "box rate-box"
        }, getRateText(rate))) : rateValue ? /*#__PURE__*/_react["default"].createElement("p", {
          className: "box rate-box"
        }, getRateText(rateValue)) : null, download ? /*#__PURE__*/_react["default"].createElement("div", {
          className: "box download-box"
        }, /*#__PURE__*/_react["default"].createElement("a", {
          download: true,
          target: "_blank",
          rel: "noopener noreferrer",
          href: src
        }, /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
          className: "handle-audio-icon download",
          type: "sound-download"
        }))) : null));
      });
    }
  }]);
  return AudioPlayer;
}(_react["default"].Component);
AudioPlayer.propTypes = {
  prefixCls: _propTypes["default"].string.isRequired,
  className: _propTypes["default"].string,
  size: _propTypes["default"].oneOf(['default', 'small']),
  title: _propTypes["default"].string,
  src: _propTypes["default"].string,
  loop: _propTypes["default"].bool,
  preload: _propTypes["default"].string,
  autoPlay: _propTypes["default"].bool,
  muted: _propTypes["default"].bool,
  volume: _propTypes["default"].number,
  controlVolume: _propTypes["default"].bool,
  controlProgress: _propTypes["default"].bool,
  displayTime: _propTypes["default"].bool,
  rateOptions: _propTypes["default"].object,
  download: _propTypes["default"].bool,
  onLoadedMetadata: _propTypes["default"].func,
  onCanPlay: _propTypes["default"].func,
  onCanPlayThrough: _propTypes["default"].func,
  onAbort: _propTypes["default"].func,
  onEnded: _propTypes["default"].func,
  onError: _propTypes["default"].func,
  onPause: _propTypes["default"].func,
  onPlay: _propTypes["default"].func,
  onSeeked: _propTypes["default"].func
};
AudioPlayer.defaultProps = {
  prefixCls: 'fishd-audio-player',
  className: '',
  size: 'default',
  title: '',
  src: '',
  loop: false,
  preload: 'metadata',
  autoPlay: false,
  muted: false,
  volume: 1.0,
  controlVolume: true,
  controlProgress: true,
  displayTime: true,
  rateOptions: {
    value: 0
  },
  download: false,
  onLoadedMetadata: function onLoadedMetadata() {},
  onCanPlay: function onCanPlay() {},
  onCanPlayThrough: function onCanPlayThrough() {},
  onAbort: function onAbort() {},
  onEnded: function onEnded() {},
  onError: function onError() {},
  onPause: function onPause() {},
  onPlay: function onPlay() {},
  onSeeked: function onSeeked() {} // 当用户已移动/跳跃到音频中的新位置时的回调
};
var _default = AudioPlayer;
exports["default"] = _default;