"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _react = _interopRequireDefault(require("react"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _color = _interopRequireDefault(require("./helpers/color"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var WIDTH = 200;
var HEIGHT = 150;
var Board = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Board, _React$Component);
  var _super = _createSuper(Board);
  function Board(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Board);
    _this = _super.call(this, props);
    _this.onBoardMouseDown = function (e) {
      var buttons = e.buttons;
      // only work on left click
      // @see https://developer.mozilla.org/en-US/docs/Web/Events/mousedown
      if (buttons !== 1) return;
      _this.removeListeners();
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
      window.addEventListener('mousemove', _this.onBoardDrag);
      window.addEventListener('mouseup', _this.onBoardDragEnd);
    };
    _this.onBoardTouchStart = function (e) {
      if (e.touches.length !== 1) {
        return;
      }
      _this.removeTouchListeners();
      var x = e.targetTouches[0].clientX;
      var y = e.targetTouches[0].clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
      window.addEventListener('touchmove', _this.onBoardTouchMove);
      window.addEventListener('touchend', _this.onBoardTouchEnd);
    };
    _this.onBoardTouchMove = function (e) {
      if (e.preventDefault) {
        e.preventDefault();
      }
      var x = e.targetTouches[0].clientX;
      var y = e.targetTouches[0].clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
    };
    _this.onBoardTouchEnd = function () {
      _this.removeTouchListeners();
    };
    _this.onBoardDrag = function (e) {
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
    };
    _this.onBoardDragEnd = function (e) {
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
      _this.removeListeners();
    };
    _this.getPrefixCls = function () {
      return "".concat(_this.props.rootPrefixCls, "-board");
    };
    _this.removeTouchListeners = function () {
      window.removeEventListener('touchmove', _this.onBoardTouchMove);
      window.removeEventListener('touchend', _this.onBoardTouchEnd);
    };
    _this.removeListeners = function () {
      window.removeEventListener('mousemove', _this.onBoardDrag);
      window.removeEventListener('mouseup', _this.onBoardDragEnd);
    };
    /**
     * 移动光标位置到
     * @param  {object} pos X Y 全局坐标点
     */
    _this.pointMoveTo = function (pos) {
      var rect = _reactDom["default"].findDOMNode((0, _assertThisInitialized2["default"])(_this)).getBoundingClientRect();
      var left = pos.x - rect.left;
      var top = pos.y - rect.top;
      var rWidth = rect.width || WIDTH;
      var rHeight = rect.height || HEIGHT;
      left = Math.max(0, left);
      left = Math.min(left, rWidth);
      top = Math.max(0, top);
      top = Math.min(top, rHeight);
      var color = _this.props.color;
      color.saturation = left / rWidth;
      color.brightness = 1 - top / rHeight;
      _this.props.onChange(color);
    };
    return _this;
  }
  (0, _createClass2["default"])(Board, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeListeners();
      this.removeTouchListeners();
    }
  }, {
    key: "render",
    value: function render() {
      var prefixCls = this.getPrefixCls();
      var color = this.props.color;
      var hueHsv = {
        h: color.hue,
        s: 1,
        v: 1
      };
      var hueColor = new _color["default"](hueHsv).toHexString();
      var xRel = color.saturation * 100;
      var yRel = (1 - color.brightness) * 100;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: prefixCls
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-hsv"),
        style: {
          backgroundColor: hueColor
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-value")
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-saturation")
      })), /*#__PURE__*/_react["default"].createElement("span", {
        style: {
          left: "".concat(xRel, "%"),
          top: "".concat(yRel, "%")
        }
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-handler"),
        onMouseDown: this.onBoardMouseDown,
        onTouchStart: this.onBoardTouchStart
      }));
    }
  }]);
  return Board;
}(_react["default"].Component);
exports["default"] = Board;
Board.propTypes = {
  color: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  rootPrefixCls: _propTypes["default"].string
};