"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _color = _interopRequireDefault(require("./helpers/color"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var History = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(History, _React$Component);
  var _super = _createSuper(History);
  function History() {
    (0, _classCallCheck2["default"])(this, History);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(History, [{
    key: "render",
    value: function render() {
      var _this = this;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        colorHistory = _this$props.colorHistory,
        maxHistory = _this$props.maxHistory;
      var renderColors = (0, _toConsumableArray2["default"])(colorHistory);
      if (colorHistory.length < maxHistory) {
        var _context;
        var historyList = (0, _from["default"])({
          length: maxHistory - colorHistory.length
        });
        renderColors = (0, _concat["default"])(_context = []).call(_context, (0, _toConsumableArray2["default"])(renderColors), (0, _toConsumableArray2["default"])(historyList));
      }
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-history")
      }, (0, _map["default"])(renderColors).call(renderColors, function (obj, key) {
        if (obj) {
          var props = {};
          if ((0, _typeof2["default"])(obj) === 'object') {
            var _Color$RGB = (0, _slicedToArray2["default"])(new _color["default"](obj.color).RGB, 3),
              r = _Color$RGB[0],
              g = _Color$RGB[1],
              b = _Color$RGB[2];
            var RGBA = [r, g, b];
            RGBA.push(obj.alpha / 100);
            props = {
              key: key,
              onClick: function onClick() {
                return _this.props.onHistoryClick(obj);
              },
              className: "".concat(prefixCls, "-history-color"),
              style: {
                background: "rgba(".concat(RGBA.join(','), ")")
              }
            };
          } else if (typeof obj === 'string') {
            props = {
              key: key,
              onClick: function onClick() {
                return _this.props.onHistoryClick({
                  color: obj,
                  alpha: 100
                });
              },
              className: "".concat(prefixCls, "-history-color"),
              style: {
                background: obj
              }
            };
          }
          return /*#__PURE__*/_react["default"].createElement("span", (0, _assign["default"])({}, props));
        } else {
          var _props = {
            key: key,
            className: "".concat(prefixCls, "-history-color 111")
          };
          return /*#__PURE__*/_react["default"].createElement("span", (0, _assign["default"])({}, _props));
        }
      }));
    }
  }]);
  return History;
}(_react["default"].Component);
exports["default"] = History;
History.propTypes = {
  colorHistory: _propTypes["default"].array,
  maxHistory: _propTypes["default"].number,
  onHistoryClick: _propTypes["default"].func,
  prefixCls: _propTypes["default"].string
};