import React from 'react';
import Color from './helpers/color';
export declare type ParamsColor = {
    hue?: number;
    saturation?: number;
    brightness?: number;
    hex?: string;
    red?: number;
    green?: number;
    blue?: number;
    alpha?: number;
    toHexString: () => string;
};
interface ParamsProps {
    alpha?: number;
    color?: string | ParamsColor | Color;
    enableAlpha?: boolean;
    enableHistory?: boolean;
    mode?: string;
    onAlphaChange?: (alpha: number) => void;
    onChange?: (value: any, flag: boolean) => void;
    rootPrefixCls?: string;
}
interface ParamsState {
    mode: string;
    hex: string;
    color: object;
}
declare class Params extends React.Component<ParamsProps, ParamsState> {
    static propTypes: {
        alpha: any;
        color: any;
        enableAlpha: any;
        enableHistory: any;
        mode: any;
        onAlphaChange: any;
        onChange: any;
        rootPrefixCls: any;
    };
    static defaultProps: {
        mode: string;
        enableAlpha: boolean;
    };
    static getDerivedStateFromProps(nextProps: any, prevState: any): {
        color?: string;
        hex?: string;
    };
    constructor(props: ParamsProps);
    getChannelInRange: (value: any, index: any) => number;
    getPrefixCls: () => string;
    handleHexBlur: () => void;
    handleHexPress: (event: any) => void;
    handleHexChange: (event: any) => void;
    handleModeChange: () => void;
    handleAlphaHandler: (event: any) => void;
    updateColorByChanel: (channel: any, value: any) => ParamsColor;
    handleColorChannelChange: (index: any, event: any) => void;
    render(): JSX.Element;
}
export default Params;
