"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _rcTrigger = _interopRequireDefault(require("rc-trigger"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _utils = require("../../utils");
var _validationColor = _interopRequireDefault(require("./utils/validationColor"));
var _Panel = _interopRequireDefault(require("./Panel"));
var _placements = _interopRequireDefault(require("./placements"));
var _color = _interopRequireDefault(require("./helpers/color"));
var _index = _interopRequireDefault(require("../Icon/index"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
// @ts-nocheck

function noop() {}
var QuickPanel = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(QuickPanel, _React$Component);
  var _super = _createSuper(QuickPanel);
  function QuickPanel(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, QuickPanel);
    _this = _super.call(this, props);
    _this.onFocus = function () {
      if (_this._blurTimer) {
        clearTimeout(_this._blurTimer);
        _this._blurTimer = null;
      } else {
        _this.props.onFocus();
      }
    };
    _this.onBlur = function () {
      if (_this._blurTimer) {
        clearTimeout(_this._blurTimer);
      }
      _this._blurTimer = (0, _setTimeout2["default"])(function () {
        // if is system color picker open, then stop run blur
        if (_this.systemColorPickerOpen) {
          _this.systemColorPickerOpen = false;
          return;
        }
        _this.props.onBlur();
      }, 100);
    };
    _this.handleChange = function (color, alpha) {
      var fireChange = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        onChange = _this$props.onChange,
        onVisibleChange = _this$props.onVisibleChange,
        __useInComponent = _this$props.__useInComponent;
      if (disabled) return;
      _this.setState({
        color: color
      });
      onChange({
        color: color,
        alpha: alpha
      });
      // colorPicker弹层中使用，点击时触发visibleChange
      if (__useInComponent && fireChange) {
        onVisibleChange(false);
      }
    };
    _this.onChange = function (colors) {
      _this.setState((0, _assign["default"])({}, colors));
    };
    _this.onVisibleChangeFromTrigger = function (visible) {
      _this.setVisible(visible);
      //自定义选择颜色弹层关闭时才颜色改变确认
      if (!visible) {
        _this.props.onChange(_this.state);
      }
    };
    _this.onPanelMount = function (panelDOMRef) {
      if (_this.state.visible) {
        (0, _setTimeout2["default"])(function () {
          panelDOMRef.focus();
        }, 0);
      }
    };
    _this.handleKeyDown = function (e) {
      var keyCode = e.keyCode;
      if (keyCode === _utils.KeyCode.ESC && _this.props.esc || keyCode === _utils.KeyCode.ENTER) {
        _this.setVisible(false, function () {
          _this.props.onChange(_this.state);
        });
      }
    };
    _this.handleSpnKeyDown = function (e) {
      var keyCode = e.keyCode;
      var colorMap = _this.props.colorMap;
      var _this$state = _this.state,
        color = _this$state.color,
        visible = _this$state.visible;
      var activeIndex = (0, _indexOf["default"])(colorMap).call(colorMap, color);
      if (activeIndex === -1 || visible) return;
      // LEFT/RIGHT触发选择
      if (keyCode === _utils.KeyCode.LEFT) {
        _this.handleChange(colorMap[activeIndex - 1 === -1 ? colorMap.length - 1 : activeIndex - 1], 100, false);
      }
      if (keyCode === _utils.KeyCode.RIGHT) {
        _this.handleChange(colorMap[activeIndex + 1 === colorMap.length ? 0 : activeIndex + 1], 100, false);
      }
    };
    _this.setVisible = function (visible, callback) {
      if (_this.state.visible !== visible) {
        _this.setState({
          visible: visible
        }, function () {
          if (typeof callback === 'function') callback();
          var _this$props2 = _this.props,
            onVisibleChange = _this$props2.onVisibleChange,
            enableHistory = _this$props2.enableHistory,
            maxHistory = _this$props2.maxHistory;
          onVisibleChange(_this.state.visible);
          //关闭时记录历史记录
          if (!_this.state.visible && enableHistory) {
            var _context, _context2;
            var _this$state2 = _this.state,
              color = _this$state2.color,
              _alpha = _this$state2.alpha,
              colorHistory = _this$state2.colorHistory;
            if (colorHistory.length && color === colorHistory[0].color && _alpha === colorHistory[0].alpha) return;
            _this.setState({
              colorHistory: colorHistory.length >= maxHistory ? (0, _concat["default"])(_context = [{
                color: color,
                alpha: _alpha
              }]).call(_context, (0, _toConsumableArray2["default"])((0, _slice["default"])(colorHistory).call(colorHistory, 0, -1))) : (0, _concat["default"])(_context2 = [{
                color: color,
                alpha: _alpha
              }]).call(_context2, (0, _toConsumableArray2["default"])(colorHistory))
            });
          }
        });
      }
    };
    _this.getPickerElement = function () {
      var _this$props3 = _this.props,
        mode = _this$props3.mode,
        className = _this$props3.className,
        enableAlpha = _this$props3.enableAlpha,
        enableHistory = _this$props3.enableHistory,
        maxHistory = _this$props3.maxHistory;
      return /*#__PURE__*/_react["default"].createElement(_Panel["default"], {
        onMount: _this.onPanelMount,
        defaultColor: _this.state.color,
        alpha: _this.state.alpha,
        enableAlpha: enableAlpha,
        prefixCls: "fishd-color-picker-panel",
        onChange: _this.onChange,
        onBlur: _this.onBlur,
        mode: mode,
        className: className,
        colorHistory: _this.state.colorHistory,
        enableHistory: enableHistory,
        maxHistory: maxHistory
      });
    };
    var alpha = typeof props.alpha === 'undefined' ? props.defaultAlpha : Math.min(props.alpha, props.defaultAlpha);
    _this.state = {
      color: props.color || props.defaultColor,
      alpha: alpha,
      visible: false,
      colorHistory: props.colorHistory
    };
    return _this;
  }
  (0, _createClass2["default"])(QuickPanel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.onMount(this.ref);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props4 = this.props,
        prefixCls = _this$props4.prefixCls,
        colorMap = _this$props4.colorMap,
        userSelectColor = _this$props4.userSelectColor,
        getPopupContainer = _this$props4.getPopupContainer,
        disabled = _this$props4.disabled,
        __useInComponent = _this$props4.__useInComponent,
        popupStyle = _this$props4.popupStyle;
      var _Color$RGB = (0, _slicedToArray2["default"])(new _color["default"](this.state.color).RGB, 3),
        r = _Color$RGB[0],
        g = _Color$RGB[1],
        b = _Color$RGB[2];
      var RGBA = [r, g, b];
      var customChecked = !(0, _includes["default"])(colorMap).call(colorMap, this.state.color);
      RGBA.push(this.state.alpha / 100);
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: function ref(_ref) {
          return _this2.ref = _ref;
        },
        className: [prefixCls, this.props.className].join(' '),
        style: this.props.style,
        onFocus: this.onFocus,
        onKeyDown: this.handleSpnKeyDown,
        onBlur: this.onBlur,
        tabIndex: 0
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-inner")
      }, (0, _map["default"])(colorMap).call(colorMap, function (color, i) {
        var _classNames;
        var spnClasses = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-color-spn"), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-color-spn-active"), _this2.state.color === color), _classNames));
        return /*#__PURE__*/_react["default"].createElement("span", {
          key: i,
          className: spnClasses,
          style: {
            background: color
          },
          onClick: function onClick() {
            return _this2.handleChange(color, 100);
          }
        });
      }), userSelectColor && !__useInComponent && /*#__PURE__*/_react["default"].createElement(_rcTrigger["default"], {
        popup: /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-content"),
          onKeyDown: this.handleKeyDown
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-arrow")
        }), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-inner")
        }, this.getPickerElement())),
        builtinPlacements: _placements["default"],
        popupPlacement: 'topCenter',
        action: disabled ? [] : ['click'],
        destroyPopupOnHide: true,
        popupStyle: popupStyle,
        getPopupContainer: getPopupContainer,
        popupVisible: this.state.visible,
        onPopupVisibleChange: this.onVisibleChangeFromTrigger,
        prefixCls: "fishd-color-picker-panel"
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-custom-btn")
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-custom-btn-text"),
        style: customChecked ? {
          backgroundColor: "rgba(".concat(RGBA.join(','), ")"),
          color: '#fff',
          textShadow: '0 0.5px 0.5px rgba(0,0,0,50%)'
        } : {}
      }, customChecked && /*#__PURE__*/_react["default"].createElement(_index["default"], {
        type: "check-line-bold"
      }), "\u81EA\u5B9A\u4E49")))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if ('color' in nextProps) {
        newState.color = nextProps.color;
      }
      if ('alpha' in nextProps && nextProps.alpha !== undefined) {
        newState.alpha = nextProps.alpha;
      }
      return newState;
    }
  }]);
  return QuickPanel;
}(_react["default"].Component);
QuickPanel.propTypes = {
  __useInComponent: _propTypes["default"].bool,
  alpha: _propTypes["default"].number,
  className: _propTypes["default"].string,
  color: _validationColor["default"],
  colorHistory: _propTypes["default"].array,
  colorMap: _propTypes["default"].array,
  defaultAlpha: _propTypes["default"].number,
  defaultColor: _validationColor["default"],
  disabled: _propTypes["default"].bool,
  enableAlpha: _propTypes["default"].bool,
  enableHistory: _propTypes["default"].bool,
  getPopupContainer: _propTypes["default"].func,
  maxHistory: _propTypes["default"].number,
  mode: _propTypes["default"].oneOf(['RGB', 'HSL', 'HSB']),
  onBlur: _propTypes["default"].func,
  onChange: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onMount: _propTypes["default"].func,
  onVisibleChange: _propTypes["default"].func,
  prefixCls: _propTypes["default"].string,
  userSelectColor: _propTypes["default"].bool,
  style: _propTypes["default"].object,
  popupStyle: _propTypes["default"].object,
  esc: _propTypes["default"].bool
};
QuickPanel.defaultProps = {
  __useInComponent: false,
  className: '',
  colorHistory: [],
  colorMap: ['#33bbff', '#337eff', '#8a73ff', '#bb67e6', '#f290b6', '#f24957', '#cc613d', '#faa702', '#ffe500', '#aacc00', '#26bf40', '#3dd9af', '#333333', '#666666', '#999999', '#cccccc'],
  defaultAlpha: 100,
  defaultColor: '#33bbff',
  enableAlpha: false,
  enableHistory: true,
  maxHistory: 8,
  mode: 'RGB',
  onBlur: noop,
  onChange: noop,
  onFocus: noop,
  onMount: noop,
  onVisibleChange: noop,
  prefixCls: 'fishd-color-picker-quick-panel',
  userSelectColor: true,
  style: {},
  popupStyle: {},
  esc: true
};
(0, _reactLifecyclesCompat.polyfill)(QuickPanel);
var _default = QuickPanel;
exports["default"] = _default;