"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.changeRuntimeLocale = changeRuntimeLocale;
exports["default"] = void 0;
exports.getRuntimeLocale = getRuntimeLocale;
var _react = _interopRequireDefault(require("react"));
var _zh_CN = _interopRequireDefault(require("../../Locale/zh_CN"));
var _Context = require("./Context");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var runtimeLocale = {};
function getRuntimeLocale(componentName) {
  if (!runtimeLocale.locale) {
    // 获取默认Locale;
    changeRuntimeLocale();
  }
  return runtimeLocale[componentName] || {};
}
// 部分组件如Modal 可以通过函数式调用  所以需要runtimeLocale提供支撑
function changeRuntimeLocale(LocaleValue) {
  if (!LocaleValue || !LocaleValue.locale) {
    runtimeLocale = _zh_CN["default"];
  } else {
    runtimeLocale = LocaleValue;
  }
}
var ProviderWrap = function ProviderWrap(props) {
  var Locale = props.Locale || _zh_CN["default"];
  var children = props.children;
  var renderProvider = function renderProvider() {
    changeRuntimeLocale(Locale);
    return props.children;
  };
  return /*#__PURE__*/_react["default"].createElement(_Context.Provider, {
    value: Locale
  }, renderProvider());
};
var _default = ProviderWrap;
exports["default"] = _default;