/// <reference types="react" />
import BasePicker, { Mode } from './BasePicker';
import DateRangePicker from './DateRangePicker';
declare type DatePickerProps = {
    placeholder: string;
    value: Date;
    mode?: Mode;
    showTime?: boolean;
};
export default class DatePicker extends BasePicker {
    static DateRangePicker: typeof DateRangePicker;
    static get propTypes(): {
        placeholder: any;
        value: any;
        mode: any;
    } & {
        className: any;
        placeholder: any;
        format: any;
        disabledDate: any;
        footer: any;
        showTime: any;
        showWeekNumber: any;
        shortcuts: any;
        placement: any;
        prefixCls: any;
        firstDayOfWeek: any;
        getPopupContainer: any;
        showTrigger: any;
        allowClear: any;
        disabled: any;
        esc: any;
        value: any;
        onFocus: any;
        onBlur: any;
        onChange: any;
        onVisibleChange: any;
        style: any;
        yearCount: any;
    };
    static get defaultProps(): {
        prefixCls: string;
        yearCount: number;
        showWeekNumber: boolean;
        mode: string;
        firstDayOfWeek: number;
        showTime: boolean;
        showTimeCurrent: boolean;
        defaultTimeValue: any;
        timeSelectMode: string;
        timeSelectModeProps: {
            start: string;
            end: string;
            step: string;
            minTime: string;
            maxTime: string;
        };
    } & {
        placeholder: string;
        placement: string;
        prefixCls: string;
        showTrigger: boolean;
        allowClear: boolean;
        disabled: boolean;
        esc: boolean;
        onFocus: () => void;
        onBlur: () => void;
        onChange: () => void;
        onVisibleChange: () => void;
    };
    constructor(props: DatePickerProps);
    isDateValid(value: any): boolean;
    pickerPanel(state: any): JSX.Element;
}
export {};
