/// <reference types="react" />
import BasePicker, { BasePickerProps } from './BasePicker';
export declare type TimeSelectProps = {
    start?: string;
    end?: string;
    step?: string;
    minTime?: string;
    maxTime?: string;
};
export declare type TimeProps = TimeSelectProps & BasePickerProps;
export default class TimeSelect extends BasePicker {
    static get propTypes(): {
        start: any;
        end: any;
        step: any;
        minTime: any;
        maxTime: any;
    } & {
        className: any;
        placeholder: any;
        format: any;
        disabledDate: any;
        footer: any;
        showTime: any;
        showWeekNumber: any;
        shortcuts: any;
        placement: any;
        prefixCls: any;
        firstDayOfWeek: any;
        getPopupContainer: any;
        showTrigger: any;
        allowClear: any;
        disabled: any;
        esc: any;
        value: any;
        onFocus: any;
        onBlur: any;
        onChange: any;
        onVisibleChange: any;
        style: any;
        yearCount: any;
    };
    static get defaultProps(): {
        placeholder: string;
        placement: string;
        prefixCls: string;
        showTrigger: boolean;
        allowClear: boolean;
        disabled: boolean;
        esc: boolean;
        onFocus: () => void;
        onBlur: () => void;
        onChange: () => void;
        onVisibleChange: () => void;
    };
    constructor(props: TimeProps);
    isDateValid(value: any): boolean;
    pickerPanel(state: any): JSX.Element;
}
