"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _index = _interopRequireDefault(require("../../Input/index"));
var _index2 = _interopRequireDefault(require("../../Icon/index"));
var _index3 = _interopRequireDefault(require("../../Button/index"));
var _index4 = _interopRequireDefault(require("../../TimePicker/index"));
var _YearAndMonthPopover = _interopRequireDefault(require("./YearAndMonthPopover.js"));
var _basic = require("../basic");
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
var _date = require("../../../utils/date");
var _Consumer = _interopRequireDefault(require("../../Config/Consumer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var PICKER_VIEWS = {
  YEAR: 'year',
  MONTH: 'month',
  DATE: 'date'
};
var isInputValid = function isInputValid(text, date, disabledDate) {
  if ((0, _trim["default"])(text).call(text) === '' || !(0, _date.isValidValue)(date) || !DatePanel.isValid(date, disabledDate)) return false;
  return true;
};
var DatePanel = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(DatePanel, _React$Component);
  var _super = _createSuper(DatePanel);
  function DatePanel(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DatePanel);
    _this = _super.call(this, props);
    // 日期时间都选择，确定按钮才可点击
    _this.confirmBtnDisabled = function () {
      var _this$state = _this.state,
        date = _this$state.date,
        time = _this$state.time;
      return !(date && time);
    };
    // 未选择日期时，时间不可选
    _this.timePickerDisable = function () {
      var _this$state2 = _this.state,
        date = _this$state2.date,
        dateInputText = _this$state2.dateInputText;
      return !(date && dateInputText);
    };
    // 日期输入框变化
    _this.handleDateInputChange = function (e) {
      var _this$props = _this.props,
        disabledDate = _this$props.disabledDate,
        format = _this$props.format;
      var inputText = e.target.value;
      var ndate = (0, _date.parseDate)(inputText, (0, _date.dateFormat)(format));
      if (!isInputValid(inputText, ndate, disabledDate)) {
        _this.setState({
          dateInputText: inputText
        });
      } else {
        //only set value on a valid date input
        _this.setState({
          dateInputText: inputText,
          date: new Date(ndate),
          currentDate: new Date(ndate)
        });
      }
    };
    // 日期输入框失焦时，重置入合法值
    _this.handleDateInputBlur = function (e) {
      var date = _this.state.date;
      _this.setState({
        dateInputText: (0, _date.formatDate)(date, (0, _date.dateFormat)(_this.props.format))
      });
    };
    // 时间输入框变化
    _this.handleTimeInputChange = function (val) {
      if (val) {
        _this.setState({
          time: new Date(val)
        });
      }
    };
    // 上一年
    _this.prevYear = function () {
      _this.setState({
        currentDate: (0, _date.prevYear)(_this.state.currentDate)
      });
    };
    // 下一年
    _this.nextYear = function () {
      _this.setState({
        currentDate: (0, _date.nextYear)(_this.state.currentDate)
      });
    };
    // 上一月
    _this.prevMonth = function () {
      _this.setState({
        currentDate: (0, _date.prevMonth)(_this.state.currentDate)
      });
    };
    // 下一月
    _this.nextMonth = function () {
      _this.setState({
        currentDate: (0, _date.nextMonth)(_this.state.currentDate)
      });
    };
    // 切换年份
    _this.handleChangeYear = function (year) {
      var currentDate = _this.state.currentDate;
      _this.setState({
        currentDate: new Date(new Date(currentDate).setFullYear(year))
      });
    };
    // 切换月份
    _this.handleChangeMonth = function (month, locales) {
      var _context;
      var currentDate = _this.state.currentDate;
      var monthNumber = (0, _indexOf["default"])(_context = locales.MONTH_ARRAY).call(_context, month);
      _this.setState({
        currentDate: new Date(new Date(currentDate).setMonth(monthNumber))
      });
    };
    // 点击日期
    _this.handleDatePick = function (value) {
      var _this$props2 = _this.props,
        mode = _this$props2.mode,
        showTime = _this$props2.showTime,
        onPick = _this$props2.onPick,
        format = _this$props2.format;
      var pdate = value.date;
      if (mode === _date.SELECTION_MODES.DAY) {
        if (!showTime) {
          onPick(pdate);
        }
        _this.setState({
          date: new Date(pdate),
          dateInputText: (0, _date.formatDate)(pdate, (0, _date.dateFormat)(format)),
          currentDate: pdate
        });
      } else if (mode === _date.SELECTION_MODES.WEEK) {
        onPick(pdate);
      }
    };
    // 点击确定按钮
    _this.handleConfirm = function () {
      var _this$state3 = _this.state,
        date = _this$state3.date,
        time = _this$state3.time;
      var pickedTime = (0, _date.setTime)(date, time);
      _this.props.onPick(pickedTime, false, true);
    };
    // 点击取消按钮
    _this.handleCancel = function () {
      _this.props.onCancelPicked();
    };
    var currentView = PICKER_VIEWS.DATE;
    // switch (props.mode) {
    //   case SELECTION_MODES.MONTH:
    //     currentView = PICKER_VIEWS.MONTH; break;
    //   case SELECTION_MODES.YEAR:
    //     currentView = PICKER_VIEWS.YEAR; break;
    // }
    _this.state = (0, _assign["default"])({}, {
      currentView: currentView
    }, DatePanel.propsToState(props));
    return _this;
  }
  (0, _createClass2["default"])(DatePanel, [{
    key: "_pickerContent",
    value:
    // 年份、月份面板先注释掉，需要时再打开
    function _pickerContent() {
      var _this$props3 = this.props,
        mode = _this$props3.mode,
        disabledDate = _this$props3.disabledDate,
        showWeekNumber = _this$props3.showWeekNumber,
        firstDayOfWeek = _this$props3.firstDayOfWeek;
      var _this$state4 = this.state,
        date = _this$state4.date,
        currentDate = _this$state4.currentDate;
      var currentView = this.state.currentView;
      var result = null;
      switch (currentView) {
        case PICKER_VIEWS.DATE:
          result = /*#__PURE__*/_react["default"].createElement(_basic.DateTable, {
            onPick: this.handleDatePick,
            date: currentDate,
            value: date,
            mode: mode,
            disabledDate: disabledDate,
            showWeekNumber: showWeekNumber,
            firstDayOfWeek: firstDayOfWeek
          });
          break;
        // case PICKER_VIEWS.YEAR:
        //   result = (<YearTable
        //     ref="yearTable"
        //     value={value}
        //     date={date}
        //     onPick={this.handleYearPick.bind(this)}
        //     disabledDate={disabledDate}
        //   />);
        //   break;
        // case PICKER_VIEWS.MONTH:
        //   result = (<MonthTable
        //     value={value}
        //     date={date}
        //     onPick={this.handleMonthPick.bind(this)}
        //     disabledDate={disabledDate}
        //   />);
        //   break;
        default:
          throw new Error('invalid currentView value');
      }
      return result;
    }
    // 点击快捷按钮
  }, {
    key: "handleShortcutClick",
    value: function handleShortcutClick(shortcut) {
      shortcut.onClick();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props4 = this.props,
        format = _this$props4.format,
        shortcuts = _this$props4.shortcuts,
        yearCount = _this$props4.yearCount,
        showTime = _this$props4.showTime,
        showTimeCurrent = _this$props4.showTimeCurrent,
        timeSelectableRange = _this$props4.timeSelectableRange,
        footer = _this$props4.footer,
        prefixCls = _this$props4.prefixCls,
        timeSelectMode = _this$props4.timeSelectMode,
        timeSelectModeProps = _this$props4.timeSelectModeProps;
      var _this$state5 = this.state,
        currentView = _this$state5.currentView,
        currentDate = _this$state5.currentDate,
        dateInputText = _this$state5.dateInputText,
        time = _this$state5.time;
      var _deconstructDate = (0, _date.deconstructDate)(currentDate),
        month = _deconstructDate.month;
      return /*#__PURE__*/_react["default"].createElement(_Consumer["default"], {
        componentName: "DatePicker"
      }, function (Locales, lang) {
        var _context2, _context3, _context4, _context5, _context6;
        var monthSelector = currentView === PICKER_VIEWS.DATE && /*#__PURE__*/_react["default"].createElement(_YearAndMonthPopover["default"], {
          key: "month",
          value: currentDate.getMonth() + 1,
          sourceData: Locales.MONTH_ARRAY,
          onChange: function onChange(month) {
            return _this2.handleChangeMonth(month, Locales);
          }
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-date-picker__header-label"), {
            active: currentView === 'month'
          })
        }, Locales.MONTH_ARRAY[month]));
        var yearSelector = /*#__PURE__*/_react["default"].createElement(_YearAndMonthPopover["default"], {
          key: "year",
          value: currentDate.getFullYear(),
          sourceData: (0, _date.YEARS_ARRAY)(yearCount),
          onChange: _this2.handleChangeYear
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "".concat(prefixCls, "-date-picker__header-label")
        }, (0, _concat["default"])(_context2 = "".concat(currentDate.getFullYear())).call(_context2, Locales.year)));
        // TODO: 配置此处展示方式
        var selectors = lang === 'en_US' ? [monthSelector, yearSelector] : [yearSelector, monthSelector];
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-picker-panel"), "".concat(prefixCls, "-date-picker"), {
            'has-sidebar': shortcuts,
            'has-time': showTime
          })
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__body-wrapper")
        }, (0, _isArray["default"])(shortcuts) && /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-picker-panel__sidebar"))
        }, (0, _map["default"])(shortcuts).call(shortcuts, function (e, idx) {
          return /*#__PURE__*/_react["default"].createElement("button", {
            key: idx,
            type: "button",
            className: "".concat(prefixCls, "-picker-panel__shortcut"),
            onClick: function onClick() {
              return _this2.handleShortcutClick(e);
            }
          }, e.text);
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__body")
        }, showTime && /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-date-picker__time-header")
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "".concat(prefixCls, "-date-picker__editor-wrap")
        }, /*#__PURE__*/_react["default"].createElement(_index["default"], {
          placeholder: Locales.selectDate,
          value: dateInputText,
          onChange: _this2.handleDateInputChange,
          onBlur: _this2.handleDateInputBlur
        })), /*#__PURE__*/_react["default"].createElement("span", {
          className: "".concat(prefixCls, "-date-picker__editor-wrap")
        }, timeSelectMode === 'TimePicker' ? /*#__PURE__*/_react["default"].createElement(_index4["default"], {
          className: "".concat(prefixCls, "-date-picker-time__editor"),
          placeholder: Locales.selectTime,
          format: (0, _date.timeFormat)(format),
          getPopupContainer: function getPopupContainer(node) {
            return node.parentNode;
          },
          showTrigger: false,
          allowClear: false,
          disabled: _this2.timePickerDisable(),
          value: time,
          onChange: _this2.handleTimeInputChange,
          isShowCurrent: showTimeCurrent,
          selectableRange: timeSelectableRange
        }) : /*#__PURE__*/_react["default"].createElement(_index4["default"].TimeSelect, {
          className: "".concat(prefixCls, "-date-picker-time__editor"),
          placeholder: Locales.selectTime,
          getPopupContainer: function getPopupContainer(node) {
            return node.parentNode;
          },
          showTrigger: false,
          allowClear: false,
          disabled: _this2.timePickerDisable(),
          value: time,
          onChange: _this2.handleTimeInputChange,
          start: timeSelectModeProps.start,
          step: timeSelectModeProps.step,
          end: timeSelectModeProps.end,
          maxTime: timeSelectModeProps.maxTime,
          minTime: timeSelectModeProps.minTime
        }))), currentView !== 'time' && /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-date-picker__header")
        }, /*#__PURE__*/_react["default"].createElement(_index2["default"], {
          type: "left-double",
          onClick: _this2.prevYear,
          className: (0, _concat["default"])(_context3 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context3, prefixCls, "-date-picker__prev-btn")
        }), currentView === PICKER_VIEWS.DATE && /*#__PURE__*/_react["default"].createElement(_index2["default"], {
          type: "left",
          onClick: _this2.prevMonth,
          className: (0, _concat["default"])(_context4 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context4, prefixCls, "-date-picker__prev-btn")
        }), selectors, /*#__PURE__*/_react["default"].createElement(_index2["default"], {
          type: "right-double",
          onClick: _this2.nextYear,
          className: (0, _concat["default"])(_context5 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context5, prefixCls, "-date-picker__next-btn")
        }), currentView === PICKER_VIEWS.DATE && /*#__PURE__*/_react["default"].createElement(_index2["default"], {
          type: "right",
          onClick: _this2.nextMonth,
          className: (0, _concat["default"])(_context6 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context6, prefixCls, "-date-picker__next-btn")
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__content")
        }, _this2._pickerContent()))), typeof footer == 'function' && footer() && /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__extra-footer")
        }, footer()), showTime && currentView === PICKER_VIEWS.DATE && /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__footer")
        }, /*#__PURE__*/_react["default"].createElement(_index3["default"], {
          className: "".concat(prefixCls, "-picker-panel__btn cancel"),
          onClick: _this2.handleCancel
        }, Locales.cancel), /*#__PURE__*/_react["default"].createElement(_index3["default"], {
          type: "primary",
          className: "".concat(prefixCls, "-picker-panel__btn confirm"),
          onClick: _this2.handleConfirm,
          disabled: _this2.confirmBtnDisabled()
        }, Locales.confirm)));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      var _context7;
      return {
        prefixCls: _propTypes["default"].string,
        format: _propTypes["default"].string,
        value: _propTypes["default"].instanceOf(Date),
        onPick: _propTypes["default"].func.isRequired,
        onCancelPicked: _propTypes["default"].func.isRequired,
        yearCount: _propTypes["default"].number,
        showWeekNumber: _propTypes["default"].bool,
        shortcuts: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          text: _propTypes["default"].string.isRequired,
          onClick: _propTypes["default"].func.isRequired
        })),
        mode: _propTypes["default"].oneOf((0, _map["default"])(_context7 = (0, _keys["default"])(_date.SELECTION_MODES)).call(_context7, function (e) {
          return _date.SELECTION_MODES[e];
        })),
        disabledDate: _propTypes["default"].func,
        firstDayOfWeek: _propTypes["default"].number,
        footer: _propTypes["default"].func,
        //时间面板
        showTime: _propTypes["default"].bool,
        showTimeCurrent: _propTypes["default"].bool,
        timeSelectableRange: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].string)]),
        defaultTimeValue: _propTypes["default"].instanceOf(Date),
        timeSelectMode: _propTypes["default"].oneOf(['TimePicker', 'TimeSelect']),
        timeSelectModeProps: _propTypes["default"].object
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        prefixCls: 'fishd',
        yearCount: 50,
        showWeekNumber: false,
        mode: _date.SELECTION_MODES.DAY,
        firstDayOfWeek: 0,
        showTime: false,
        showTimeCurrent: false,
        defaultTimeValue: null,
        timeSelectMode: 'TimePicker',
        timeSelectModeProps: {
          start: '09:00',
          end: '18:00',
          step: '00:30',
          minTime: '',
          maxTime: ''
        }
      };
    }
  }, {
    key: "propsToState",
    value: function propsToState(_ref) {
      var value = _ref.value,
        format = _ref.format,
        defaultTimeValue = _ref.defaultTimeValue;
      var state = {};
      state.currentDate = (0, _date.isValidValue)(value) ? (0, _date.toDate)(value) : new Date(); // 日历视图
      state.date = (0, _date.toDate)(value); // 日期
      state.dateInputText = (0, _date.formatDate)(value, (0, _date.dateFormat)(format)); // 日期输入框的值(string)，当props.value为null时，值为''
      state.time = (0, _date.toDate)(value || defaultTimeValue); // 时间
      return state;
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if ('value' in nextProps && !(0, _isEqual["default"])(nextProps.value, prevState.prevPropValue)) {
        var state = DatePanel.propsToState(nextProps);
        state.prevPropValue = nextProps.value;
        return state;
      }
      return null;
    }
  }]);
  return DatePanel;
}(_react["default"].Component);
DatePanel.isValid = function (value, disabledDate) {
  return typeof disabledDate === 'function' && value instanceof Date ? !disabledDate(value) : true;
};
var _default = DatePanel;
exports["default"] = _default;