"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _find = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _scrollbar = require("../scrollbar");
var _domScrollIntoView = _interopRequireDefault(require("dom-scroll-into-view"));
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var TimeSelectPanel = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TimeSelectPanel, _React$Component);
  var _super = _createSuper(TimeSelectPanel);
  function TimeSelectPanel(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TimeSelectPanel);
    _this = _super.call(this, props);
    _this.items = function () {
      return getItems(_this.props);
    };
    _this.scrollToOption = function () {
      var className = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "selected";
      var menu = _this.timeSelectRoot.querySelector(".".concat(_this.props.prefixCls, "-picker-panel__content"));
      var selected = menu.getElementsByClassName(className)[0];
      selected && (0, _domScrollIntoView["default"])(selected, menu, {
        offsetTop: 74,
        alignWithTop: true
      });
    };
    _this.state = {};
    return _this;
  }
  (0, _createClass2["default"])(TimeSelectPanel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.scrollToOption();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.scrollToOption();
    }
  }, {
    key: "handleClick",
    value: function handleClick(item) {
      var _this$props = this.props,
        onPicked = _this$props.onPicked,
        dateParser = _this$props.dateParser;
      if (!item.disabled) {
        onPicked(dateParser(item.value), false, true);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this,
        _context;
      var _this$props2 = this.props,
        value = _this$props2.value,
        prefixCls = _this$props2.prefixCls;
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: function ref(node) {
          return _this2.timeSelectRoot = node;
        },
        className: "".concat(prefixCls, "-picker-panel time-select-panel")
      }, /*#__PURE__*/_react["default"].createElement(_scrollbar.Scrollbar, {
        wrapClass: "".concat(prefixCls, "-picker-panel__content"),
        noresize: true
      }, (0, _map["default"])(_context = this.items()).call(_context, function (item, idx) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: idx,
          className: (0, _classnames["default"])('time-select-item', {
            selected: value === item.value,
            disabled: item.disabled
          }),
          disabled: item.disabled,
          onClick: function onClick() {
            return _this2.handleClick(item);
          }
        }, item.value);
      })));
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        prefixCls: _propTypes["default"].string,
        value: _propTypes["default"].string,
        onPicked: _propTypes["default"].func.isRequired,
        start: _propTypes["default"].string,
        end: _propTypes["default"].string,
        step: _propTypes["default"].string,
        minTime: _propTypes["default"].string,
        maxTime: _propTypes["default"].string,
        dateParser: _propTypes["default"].func.isRequired
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        prefixCls: 'fishd',
        start: '09:00',
        end: '18:00',
        step: '00:30',
        minTime: '',
        maxTime: '',
        onPicked: function onPicked() {}
      };
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if ('value' in nextProps && !(0, _isEqual["default"])(nextProps.vlaue, prevState.prevPropValue)) {
        return {
          prevPropValue: nextProps.vlaue
        };
      }
      return null;
    }
  }]);
  return TimeSelectPanel;
}(_react["default"].Component);
TimeSelectPanel.isValid = function (value, _ref) {
  var _context2;
  var start = _ref.start,
    end = _ref.end,
    step = _ref.step,
    minTime = _ref.minTime,
    maxTime = _ref.maxTime;
  var items = getItems({
    start: start,
    end: end,
    step: step,
    minTime: minTime,
    maxTime: maxTime
  });
  return !!(0, _find["default"])(_context2 = (0, _filter["default"])(items).call(items, function (e) {
    return !e.disabled;
  })).call(_context2, function (e) {
    return e.value === value;
  });
};
var getItems = function getItems(_ref2) {
  var start = _ref2.start,
    end = _ref2.end,
    step = _ref2.step,
    minTime = _ref2.minTime,
    maxTime = _ref2.maxTime;
  var result = [];
  if (start && end && step) {
    var current = start;
    while (compareTime(current, end) <= 0) {
      result.push({
        value: current,
        disabled: compareTime(current, minTime || '-1:-1') <= 0 || compareTime(current, maxTime || '100:100') >= 0
      });
      current = nextTime(current, step);
    }
  }
  return result;
};
var parseTime = function parseTime(time) {
  var values = (time || '').split(':');
  if (values.length >= 2) {
    var hours = (0, _parseInt2["default"])(values[0], 10);
    var minutes = (0, _parseInt2["default"])(values[1], 10);
    return {
      hours: hours,
      minutes: minutes
    };
  }
  return null;
};
var compareTime = function compareTime(time1, time2) {
  var value1 = parseTime(time1);
  var value2 = parseTime(time2);
  var minutes1 = value1.minutes + value1.hours * 60;
  var minutes2 = value2.minutes + value2.hours * 60;
  if (minutes1 === minutes2) {
    return 0;
  }
  return minutes1 > minutes2 ? 1 : -1;
};
var formatTime = function formatTime(time) {
  return (time.hours < 10 ? '0' + time.hours : time.hours) + ':' + (time.minutes < 10 ? '0' + time.minutes : time.minutes);
};
var nextTime = function nextTime(time, step) {
  var timeValue = parseTime(time);
  var stepValue = parseTime(step);
  var next = {
    hours: timeValue.hours,
    minutes: timeValue.minutes
  };
  next.minutes += stepValue.minutes;
  next.hours += stepValue.hours;
  next.hours += Math.floor(next.minutes / 60);
  next.minutes = next.minutes % 60;
  return formatTime(next);
};
var _default = TimeSelectPanel;
exports["default"] = _default;