"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Bar = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _util = require("./util");
var _dom = require("../libs/utils/dom");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Bar = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Bar, _React$Component);
  var _super = _createSuper(Bar);
  function Bar(props) {
    var _context, _context2, _context3, _context4;
    var _this;
    (0, _classCallCheck2["default"])(this, Bar);
    _this = _super.call(this, props);
    _this.clickTrackHandler = (0, _bind["default"])(_context = _this.clickTrackHandler).call(_context, (0, _assertThisInitialized2["default"])(_this));
    _this.clickThumbHandler = (0, _bind["default"])(_context2 = _this.clickThumbHandler).call(_context2, (0, _assertThisInitialized2["default"])(_this));
    _this.mouseMoveDocumentHandler = (0, _bind["default"])(_context3 = _this.mouseMoveDocumentHandler).call(_context3, (0, _assertThisInitialized2["default"])(_this));
    _this.mouseUpDocumentHandler = (0, _bind["default"])(_context4 = _this.mouseUpDocumentHandler).call(_context4, (0, _assertThisInitialized2["default"])(_this));
    return _this;
  }
  (0, _createClass2["default"])(Bar, [{
    key: "bar",
    get: function get() {
      return _util.BAR_MAP[this.props.vertical ? 'vertical' : 'horizontal'];
    }
  }, {
    key: "wrap",
    get: function get() {
      return this.props.getParentWrap();
    }
  }, {
    key: "clickThumbHandler",
    value: function clickThumbHandler(e) {
      this.startDrag(e);
      this[this.bar.axis] = e.currentTarget[this.bar.offset] - (e[this.bar.client] - e.currentTarget.getBoundingClientRect()[this.bar.direction]);
    }
  }, {
    key: "clickTrackHandler",
    value: function clickTrackHandler(e) {
      var offset = Math.abs(e.target.getBoundingClientRect()[this.bar.direction] - e[this.bar.client]);
      var thumbHalf = this.thumbRef[this.bar.offset] / 2;
      var thumbPositionPercentage = (offset - thumbHalf) * 100 / this.rootRef[this.bar.offset];
      this.wrap[this.bar.scroll] = thumbPositionPercentage * this.wrap[this.bar.scrollSize] / 100;
    }
  }, {
    key: "startDrag",
    value: function startDrag(e) {
      e.nativeEvent.stopImmediatePropagation;
      this.cursorDown = true;
      (0, _dom.on)(document, 'mousemove', this.mouseMoveDocumentHandler);
      (0, _dom.on)(document, 'mouseup', this.mouseUpDocumentHandler);
      document.onselectstart = function () {
        return false;
      };
    }
  }, {
    key: "mouseMoveDocumentHandler",
    value: function mouseMoveDocumentHandler(e) {
      if (this.cursorDown === false) return;
      var prevPage = this[this.bar.axis];
      if (!prevPage) return;
      var offset = e[this.bar.client] - this.rootRef.getBoundingClientRect()[this.bar.direction];
      var thumbClickPosition = this.thumbRef[this.bar.offset] - prevPage;
      var thumbPositionPercentage = (offset - thumbClickPosition) * 100 / this.rootRef[this.bar.offset];
      this.wrap[this.bar.scroll] = thumbPositionPercentage * this.wrap[this.bar.scrollSize] / 100;
    }
  }, {
    key: "mouseUpDocumentHandler",
    value: function mouseUpDocumentHandler() {
      this.cursorDown = false;
      this[this.bar.axis] = 0;
      (0, _dom.off)(document, 'mousemove', this.mouseMoveDocumentHandler);
      document.onselectstart = null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        size = _this$props.size,
        move = _this$props.move,
        prefixCls = _this$props.prefixCls;
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: function ref(root) {
          return _this2.rootRef = root;
        },
        className: (0, _classnames["default"])("".concat(prefixCls, "-scrollbar__bar"), "is-".concat(this.bar.key)),
        onMouseDown: this.clickTrackHandler
      }, /*#__PURE__*/_react["default"].createElement("div", {
        ref: function ref(thumb) {
          return _this2.thumbRef = thumb;
        },
        className: "".concat(prefixCls, "-scrollbar__thumb"),
        onMouseDown: this.clickThumbHandler,
        style: (0, _util.renderThumbStyle)({
          size: size,
          move: move,
          bar: this.bar
        })
      }));
    }
  }]);
  return Bar;
}(_react["default"].Component);
exports.Bar = Bar;
Bar.propTypes = {
  vertical: _propTypes["default"].bool,
  size: _propTypes["default"].string,
  move: _propTypes["default"].number,
  getParentWrap: _propTypes["default"].func.isRequired,
  prefixCls: _propTypes["default"].string
};
Bar.defaultProps = {
  prefixCls: 'fishd'
};