"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Scrollbar = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _classnames = _interopRequireDefault(require("classnames"));
var _resizeEvent = require("../libs/utils/resize-event");
var _scrollarWidth = require("./scrollar-width");
var _Bar = require("./Bar");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var Scrollbar = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Scrollbar, _React$Component);
  var _super = _createSuper(Scrollbar);
  function Scrollbar(props) {
    var _context;
    var _this;
    (0, _classCallCheck2["default"])(this, Scrollbar);
    _this = _super.call(this, props);
    _this.state = {
      sizeWidth: '0',
      sizeHeight: '0',
      moveX: 0,
      moveY: 0
    };
    _this.update = (0, _bind["default"])(_context = _this._update).call(_context, (0, _assertThisInitialized2["default"])(_this));
    return _this;
  }
  (0, _createClass2["default"])(Scrollbar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this["native"]) return;
      var rafId = requestAnimationFrame(this.update);
      this.cleanRAF = function () {
        cancelAnimationFrame(rafId);
      };
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _this2 = this;
      this.resizeDom = _reactDom["default"].findDOMNode(this.refs.resize);
      if (!this.props.noresize) {
        (0, _resizeEvent.addResizeListener)(this.resizeDom, this.update);
        this.cleanResize = function () {
          (0, _resizeEvent.removeResizeListener)(_this2.resizeDom, _this2.update);
        };
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.cleanRAF();
      this.cleanResize && this.cleanResize();
    }
  }, {
    key: "wrap",
    get: function get() {
      return this.refs.wrap;
    }
  }, {
    key: "handleScroll",
    value: function handleScroll() {
      var wrap = this.wrap;
      this.setState({
        moveY: wrap.scrollTop * 100 / wrap.clientHeight,
        moveX: wrap.scrollLeft * 100 / wrap.clientWidth
      });
    }
  }, {
    key: "_update",
    value: function _update() {
      var heightPercentage, widthPercentage;
      var wrap = this.wrap;
      if (!wrap) return;
      heightPercentage = wrap.clientHeight * 100 / wrap.scrollHeight;
      widthPercentage = wrap.clientWidth * 100 / wrap.scrollWidth;
      var sizeHeight = heightPercentage < 100 ? heightPercentage + '%' : '';
      var sizeWidth = widthPercentage < 100 ? widthPercentage + '%' : '';
      this.setState({
        sizeHeight: sizeHeight,
        sizeWidth: sizeWidth
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      /* eslint-disable */
      var _a = this.props,
        _native = _a["native"],
        viewStyle = _a.viewStyle,
        wrapStyle = _a.wrapStyle,
        viewClass = _a.viewClass,
        children = _a.children,
        viewComponent = _a.viewComponent,
        wrapClass = _a.wrapClass,
        noresize = _a.noresize,
        className = _a.className,
        prefixCls = _a.prefixCls,
        others = __rest(_a, ["native", "viewStyle", "wrapStyle", "viewClass", "children", "viewComponent", "wrapClass", "noresize", "className", "prefixCls"]);
      var _this$state = this.state,
        moveX = _this$state.moveX,
        moveY = _this$state.moveY,
        sizeWidth = _this$state.sizeWidth,
        sizeHeight = _this$state.sizeHeight;
      /* eslint-enable */
      var style = wrapStyle;
      var gutter = (0, _scrollarWidth.getScrollBarWidth)();
      if (gutter) {
        var gutterWith = "-".concat(gutter, "px");
        if ((0, _isArray["default"])(wrapStyle)) {
          var _context2;
          style = _assign["default"].apply(null, (0, _concat["default"])(_context2 = []).call(_context2, (0, _toConsumableArray2["default"])(wrapStyle), [{
            marginRight: gutterWith,
            marginBottom: gutterWith
          }]));
        } else {
          style = (0, _assign["default"])({}, wrapStyle, {
            marginRight: gutterWith,
            marginBottom: gutterWith
          });
        }
      }
      var view = /*#__PURE__*/_react["default"].createElement(viewComponent, {
        className: (0, _classnames["default"])("".concat(prefixCls, "-scrollbar__view"), viewClass),
        style: viewStyle,
        ref: 'resize'
      }, children);
      var nodes;
      if (!_native) {
        var _context3;
        var wrap = /*#__PURE__*/_react["default"].createElement("div", (0, _assign["default"])({}, others, {
          ref: "wrap",
          key: 0,
          style: style,
          onScroll: (0, _bind["default"])(_context3 = this.handleScroll).call(_context3, this),
          className: (0, _classnames["default"])(wrapClass, "".concat(prefixCls, "-scrollbar__wrap"), gutter ? '' : "".concat(prefixCls, "-scrollbar__wrap--hidden-default"))
        }), view);
        nodes = [wrap, /*#__PURE__*/_react["default"].createElement(_Bar.Bar, {
          key: 1,
          move: moveX,
          size: sizeWidth,
          getParentWrap: function getParentWrap() {
            return _this3.wrap;
          }
        }), /*#__PURE__*/_react["default"].createElement(_Bar.Bar, {
          key: 2,
          move: moveY,
          size: sizeHeight,
          getParentWrap: function getParentWrap() {
            return _this3.wrap;
          },
          vertical: true
        })];
      } else {
        nodes = [/*#__PURE__*/_react["default"].createElement("div", (0, _assign["default"])({}, others, {
          key: 0,
          ref: "wrap",
          className: (0, _classnames["default"])(wrapClass, "".concat(prefixCls, "-scrollbar__wrap")),
          style: style
        }), view)];
      }
      return /*#__PURE__*/_react["default"].createElement('div', {
        className: (0, _classnames["default"])("".concat(prefixCls, "-scrollbar"), className)
      }, nodes);
    }
  }]);
  return Scrollbar;
}(_react["default"].Component);
exports.Scrollbar = Scrollbar;
Scrollbar.propTypes = {
  "native": _propTypes["default"].bool,
  wrapStyle: _propTypes["default"].object,
  wrapClass: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  viewClass: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  viewStyle: _propTypes["default"].object,
  className: _propTypes["default"].string,
  viewComponent: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].element]),
  noresize: _propTypes["default"].bool,
  prefixCls: _propTypes["default"].string
};
Scrollbar.defaultProps = {
  viewComponent: 'div',
  prefixCls: 'fishd'
};