import * as React from 'react';
declare type EventType = React.KeyboardEvent<HTMLDivElement> | React.MouseEvent<HTMLDivElement | HTMLButtonElement>;
interface DrawerProps {
    className?: string;
    style?: React.CSSProperties;
    width?: number | string;
    height?: number | string;
    open?: boolean;
    placement?: string;
    wrapperClassName: string | undefined;
    level?: string | [string, string];
    levelMove?: number | [number, number];
    ease?: string;
    duration?: string;
    getContainer?: string | React.ReactNode | (() => React.ReactNode) | boolean;
    handler?: boolean | React.ReactNode;
    onChange?: (flag: boolean) => void;
    onMaskClick?: (e: EventType) => void;
    onHandleClick?: (e: EventType) => void;
    onCloseClick?: (e: EventType) => void;
    showMask?: boolean;
    maskStyle?: React.CSSProperties;
    closed?: boolean;
    visible?: boolean;
    mask?: boolean;
}
export default class Drawer extends React.Component<DrawerProps> {
    static propTypes: {
        className: any;
        wrapperClassName: any;
        width: any;
        height: any;
        visible: any;
        closed: any;
        placement: any;
        getContainer: any;
        style: any;
        mask: any;
        maskStyle: any;
        children: any;
        handler: any;
        level: any;
        ease: any;
        duration: any;
        onChange: any;
        onMaskClick: any;
        onHandleClick: any;
        onCloseClick: any;
    };
    static defaultProps: {
        placement: string;
        onChange: () => void;
        onMaskClick: () => void;
        onHandleClick: () => void;
    };
    constructor(props: DrawerProps);
    render(): JSX.Element;
}
export {};
