import * as React from 'react';
import { TooltipProps } from '../Tooltip';
interface EllipsisProps {
    tooltip?: boolean;
    tooltipProps?: TooltipProps;
    length?: number;
    lines?: number;
    fullWidthRecognition?: boolean;
    className?: string;
    width?: number | string;
    style?: React.CSSProperties;
    prefix?: string;
}
interface EllipsisState {
    text: string;
    targetCount: number;
    tooltipVisible: boolean;
}
export default class Ellipsis extends React.Component<EllipsisProps, EllipsisState> {
    static defaultProps: {
        prefix: string;
        fullWidthRecognition: boolean;
        tooltip: boolean;
        tooltipProps: {};
    };
    static propTypes: {
        prefix: any;
        lines: any;
        width: any;
        length: any;
        tooltip: any;
        tooltipProps: any;
        fullWidthRecognition: any;
        className: any;
        style: any;
        children: any;
    };
    private node;
    private widthNode;
    private lineClampNode;
    private shadowChildren;
    private root;
    private content;
    private shadow;
    state: Readonly<EllipsisState>;
    componentDidMount(): void;
    componentDidUpdate(perProps: any): void;
    getTargetNode: () => HTMLElement;
    computeLine: () => void;
    bisection: (th: any, m: any, b: any, e: any, text: any, shadowNode: any) => any;
    handleRoot: (n: any) => void;
    handleContent: (n: any) => void;
    handleNode: (n: any) => void;
    handleShadow: (n: any) => void;
    handleShadowChildren: (n: any) => void;
    handleTooltipVisibleChange: (visible: any) => void;
    render(): JSX.Element;
}
export {};
