"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getStrFullLength = exports["default"] = exports.cutStrByFullLength = void 0;
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Tooltip = _interopRequireDefault(require("../Tooltip"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var getStrFullLength = function getStrFullLength() {
  var _context;
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return (0, _reduce["default"])(_context = str.split('')).call(_context, function (pre, cur) {
    var charCode = cur.charCodeAt(0);
    if (charCode >= 0 && charCode <= 128) {
      return pre + 1;
    }
    return pre + 2;
  }, 0);
};
exports.getStrFullLength = getStrFullLength;
var cutStrByFullLength = function cutStrByFullLength() {
  var _context2;
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var maxLength = arguments.length > 1 ? arguments[1] : undefined;
  var showLength = 0;
  return (0, _reduce["default"])(_context2 = str.split('')).call(_context2, function (pre, cur) {
    var charCode = cur.charCodeAt(0);
    if (charCode >= 0 && charCode <= 128) {
      showLength += 1;
    } else {
      showLength += 2;
    }
    if (showLength <= maxLength) {
      return pre + cur;
    }
    return pre;
  }, '');
};
exports.cutStrByFullLength = cutStrByFullLength;
var EllipsisText = function EllipsisText(_a) {
  var prefix = _a.prefix,
    text = _a.text,
    length = _a.length,
    tooltip = _a.tooltip,
    className = _a.className,
    fullWidthRecognition = _a.fullWidthRecognition,
    tooltipProps = _a.tooltipProps,
    other = __rest(_a, ["prefix", "text", "length", "tooltip", "className", "fullWidthRecognition", "tooltipProps"]);
  if (typeof text !== 'string') {
    throw new Error('Ellipsis children must be string.');
  }
  var textLength = fullWidthRecognition ? getStrFullLength(text) : text.length;
  if (textLength <= length || length < 0) {
    return /*#__PURE__*/React.createElement("span", (0, _assign["default"])({
      className: className
    }, other), text);
  }
  var tail = '...';
  var displayText;
  if (length - tail.length <= 0) {
    displayText = '';
  } else {
    displayText = fullWidthRecognition ? cutStrByFullLength(text, length) : (0, _slice["default"])(text).call(text, 0, length);
  }
  if (tooltip) {
    return /*#__PURE__*/React.createElement(_Tooltip["default"], (0, _assign["default"])({}, tooltipProps, {
      overlayClassName: "".concat(prefix, "-tooltip"),
      title: text
    }), /*#__PURE__*/React.createElement("span", {
      className: className
    }, displayText, tail));
  }
  return /*#__PURE__*/React.createElement("span", (0, _assign["default"])({
    className: className
  }, other), displayText, tail);
};
EllipsisText.propTypes = {
  prefix: _propTypes["default"].string,
  text: _propTypes["default"].string,
  length: _propTypes["default"].number,
  tooltip: _propTypes["default"].bool,
  fullWidthRecognition: _propTypes["default"].bool,
  tooltipProps: _propTypes["default"].object
};
var _default = EllipsisText;
exports["default"] = _default;