"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _parseInt = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/parse-int"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _utils = require("../../utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var FooterToolbar = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(FooterToolbar, _React$Component);
  var _super = _createSuper(FooterToolbar);
  function FooterToolbar(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, FooterToolbar);
    _this = _super.call(this, props);
    _this.state = {
      offset: 0
    };
    _this.setToolbarPosition = function () {
      var target = _this.props.target;
      var _getComputedStyle = getComputedStyle(_this.wrapper),
        height = _getComputedStyle.height;
      var wrapperHeight = (0, _parseInt["default"])(height);
      var targetElement = document.documentElement;
      if (target && typeof target === 'function' && target() !== window) {
        targetElement = target();
      }
      var offsetObj = {
        containerHeight: targetElement.clientHeight,
        containerScrollTop: targetElement.scrollTop
      };
      var offset = offsetObj.containerHeight + offsetObj.containerScrollTop - wrapperHeight;
      var maxOffset = targetElement.scrollHeight - wrapperHeight;
      _this.setState({
        offset: offset > maxOffset ? maxOffset : offset
      });
    };
    return _this;
  }
  (0, _createClass2["default"])(FooterToolbar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      this.setToolbarPosition();
      var target = this.props.target && this.props.target() || window;
      this.scrollListener = (0, _utils.addEventListener)(target, 'scroll', function () {
        _this2.setToolbarPosition();
      });
      this.resizeListener = (0, _utils.addEventListener)(window, 'resize', function () {
        _this2.setToolbarPosition();
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.scrollListener) {
        this.scrollListener.remove();
      }
      if (this.resizeListener) {
        this.resizeListener.remove();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this3 = this;
      var _this$props = this.props,
        children = _this$props.children,
        className = _this$props.className,
        prefixCls = _this$props.prefixCls,
        style = _this$props.style;
      var toolbarStyle = (0, _assign["default"])((0, _assign["default"])({}, style), {
        position: 'absolute',
        top: this.state.offset
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, className, true), (0, _defineProperty2["default"])(_classNames, prefixCls, true), _classNames)),
        style: toolbarStyle,
        ref: function ref(wrapper) {
          _this3.wrapper = wrapper;
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-inner")
      }, children));
    }
  }]);
  return FooterToolbar;
}(_react["default"].Component);
FooterToolbar.defaultProps = {
  children: null,
  className: '',
  prefixCls: 'fishd-footer-toolbar'
};
FooterToolbar.propTypes = {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  prefixCls: _propTypes["default"].string,
  target: _propTypes["default"].func,
  style: _propTypes["default"].object
};
var _default = FooterToolbar;
exports["default"] = _default;