"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = createFieldsStore;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));
var _set = _interopRequireDefault(require("lodash/set"));
var _createFormField = _interopRequireWildcard(require("./createFormField"));
var _utils = require("./utils");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function partOf(a, b) {
  var _context;
  return (0, _indexOf["default"])(b).call(b, a) === 0 && (0, _indexOf["default"])(_context = ['.', '[']).call(_context, b[a.length]) !== -1;
}
var FieldsStore = /*#__PURE__*/function () {
  function FieldsStore(fields) {
    var _this = this;
    (0, _classCallCheck2["default"])(this, FieldsStore);
    this.setFieldsInitialValue = function (initialValues) {
      var _context2;
      var flattenedInitialValues = _this.flattenRegisteredFields(initialValues);
      var fieldsMeta = _this.fieldsMeta;
      (0, _forEach["default"])(_context2 = (0, _keys["default"])(flattenedInitialValues)).call(_context2, function (name) {
        if (fieldsMeta[name]) {
          _this.setFieldMeta(name, (0, _assign["default"])((0, _assign["default"])({}, _this.getFieldMeta(name)), {
            initialValue: flattenedInitialValues[name]
          }));
        }
      });
    };
    this.getAllValues = function () {
      var _context3;
      var fieldsMeta = _this.fieldsMeta,
        fields = _this.fields;
      return (0, _reduce["default"])(_context3 = (0, _keys["default"])(fieldsMeta)).call(_context3, function (acc, name) {
        return (0, _set["default"])(acc, name, _this.getValueFromFields(name, fields));
      }, {});
    };
    this.getFieldsValue = function (names) {
      return _this.getNestedFields(names, _this.getFieldValue);
    };
    this.getFieldValue = function (name) {
      var fields = _this.fields;
      return _this.getNestedField(name, function (fullName) {
        return _this.getValueFromFields(fullName, fields);
      });
    };
    this.getFieldsError = function (names) {
      return _this.getNestedFields(names, _this.getFieldError);
    };
    this.getFieldError = function (name) {
      return _this.getNestedField(name, function (fullName) {
        return (0, _utils.getErrorStrs)(_this.getFieldMember(fullName, 'errors'));
      });
    };
    this.isFieldValidating = function (name) {
      return _this.getFieldMember(name, 'validating');
    };
    this.isFieldsValidating = function (ns) {
      var names = ns || _this.getValidFieldsName();
      return (0, _some["default"])(names).call(names, function (n) {
        return _this.isFieldValidating(n);
      });
    };
    this.isFieldTouched = function (name) {
      return _this.getFieldMember(name, 'touched');
    };
    this.isFieldsTouched = function (ns) {
      var names = ns || _this.getValidFieldsName();
      return (0, _some["default"])(names).call(names, function (n) {
        return _this.isFieldTouched(n);
      });
    };
    this.fields = this.flattenFields(fields);
    this.fieldsMeta = {};
  }
  (0, _createClass2["default"])(FieldsStore, [{
    key: "updateFields",
    value: function updateFields(fields) {
      this.fields = this.flattenFields(fields);
    }
  }, {
    key: "flattenFields",
    value: function flattenFields(fields) {
      return (0, _utils.flattenFields)(fields, function (_, node) {
        return (0, _createFormField.isFormField)(node);
      }, 'You must wrap field data with `createFormField`.');
    }
  }, {
    key: "flattenRegisteredFields",
    value: function flattenRegisteredFields(fields) {
      var validFieldsName = this.getAllFieldsName();
      return (0, _utils.flattenFields)(fields, function (path) {
        return (0, _indexOf["default"])(validFieldsName).call(validFieldsName, path) >= 0;
      }, 'You cannot set field before registering it.');
    }
  }, {
    key: "setFields",
    value: function setFields(fields) {
      var _context4,
        _this2 = this,
        _context5;
      var fieldsMeta = this.fieldsMeta;
      var nowFields = (0, _assign["default"])((0, _assign["default"])({}, this.fields), fields);
      var nowValues = {};
      (0, _forEach["default"])(_context4 = (0, _keys["default"])(fieldsMeta)).call(_context4, function (f) {
        return nowValues[f] = _this2.getValueFromFields(f, nowFields);
      });
      (0, _forEach["default"])(_context5 = (0, _keys["default"])(nowValues)).call(_context5, function (f) {
        var value = nowValues[f];
        var fieldMeta = _this2.getFieldMeta(f);
        if (fieldMeta && fieldMeta.normalize) {
          var nowValue = fieldMeta.normalize(value, _this2.getValueFromFields(f, _this2.fields), nowValues);
          if (nowValue !== value) {
            nowFields[f] = (0, _assign["default"])((0, _assign["default"])({}, nowFields[f]), {
              value: nowValue
            });
          }
        }
      });
      this.fields = nowFields;
    }
  }, {
    key: "resetFields",
    value: function resetFields(ns) {
      var fields = this.fields;
      var names = ns ? this.getValidFieldsFullName(ns) : this.getAllFieldsName();
      return (0, _reduce["default"])(names).call(names, function (acc, name) {
        var field = fields[name];
        if (field && 'value' in field) {
          acc[name] = {};
        }
        return acc;
      }, {});
    }
  }, {
    key: "setFieldMeta",
    value: function setFieldMeta(name, meta) {
      this.fieldsMeta[name] = meta;
    }
  }, {
    key: "getFieldMeta",
    value: function getFieldMeta(name) {
      this.fieldsMeta[name] = this.fieldsMeta[name] || {};
      return this.fieldsMeta[name];
    }
  }, {
    key: "getValueFromFields",
    value: function getValueFromFields(name, fields) {
      var field = fields[name];
      if (field && 'value' in field) {
        return field.value;
      }
      var fieldMeta = this.getFieldMeta(name);
      return fieldMeta && fieldMeta.initialValue;
    }
  }, {
    key: "getValidFieldsName",
    value: function getValidFieldsName() {
      var _context6,
        _this3 = this;
      var fieldsMeta = this.fieldsMeta;
      return fieldsMeta ? (0, _filter["default"])(_context6 = (0, _keys["default"])(fieldsMeta)).call(_context6, function (name) {
        return !_this3.getFieldMeta(name).hidden;
      }) : [];
    }
  }, {
    key: "getAllFieldsName",
    value: function getAllFieldsName() {
      var fieldsMeta = this.fieldsMeta;
      return fieldsMeta ? (0, _keys["default"])(fieldsMeta) : [];
    }
  }, {
    key: "getValidFieldsFullName",
    value: function getValidFieldsFullName(maybePartialName) {
      var _context7;
      var maybePartialNames = (0, _isArray["default"])(maybePartialName) ? maybePartialName : [maybePartialName];
      return (0, _filter["default"])(_context7 = this.getValidFieldsName()).call(_context7, function (fullName) {
        return (0, _some["default"])(maybePartialNames).call(maybePartialNames, function (partialName) {
          var _context8;
          return fullName === partialName || (0, _utils.startsWith)(fullName, partialName) && (0, _indexOf["default"])(_context8 = ['.', '[']).call(_context8, fullName[partialName.length]) >= 0;
        });
      });
    }
  }, {
    key: "getFieldValuePropValue",
    value: function getFieldValuePropValue(fieldMeta) {
      var name = fieldMeta.name,
        getValueProps = fieldMeta.getValueProps,
        valuePropName = fieldMeta.valuePropName;
      var field = this.getField(name);
      var fieldValue = 'value' in field ? field.value : fieldMeta.initialValue;
      if (getValueProps) {
        return getValueProps(fieldValue);
      }
      return (0, _defineProperty2["default"])({}, valuePropName, fieldValue);
    }
  }, {
    key: "getField",
    value: function getField(name) {
      return (0, _assign["default"])((0, _assign["default"])({}, this.fields[name]), {
        name: name
      });
    }
  }, {
    key: "getNotCollectedFields",
    value: function getNotCollectedFields() {
      var _context9,
        _context10,
        _context11,
        _this4 = this;
      return (0, _reduce["default"])(_context9 = (0, _map["default"])(_context10 = (0, _filter["default"])(_context11 = this.getValidFieldsName()).call(_context11, function (name) {
        return !_this4.fields[name];
      })).call(_context10, function (name) {
        return {
          name: name,
          dirty: false,
          value: _this4.getFieldMeta(name).initialValue
        };
      })).call(_context9, function (acc, field) {
        return (0, _set["default"])(acc, field.name, (0, _createFormField["default"])(field));
      }, {});
    }
  }, {
    key: "getNestedAllFields",
    value: function getNestedAllFields() {
      var _context12,
        _this5 = this;
      return (0, _reduce["default"])(_context12 = (0, _keys["default"])(this.fields)).call(_context12, function (acc, name) {
        return (0, _set["default"])(acc, name, (0, _createFormField["default"])(_this5.fields[name]));
      }, this.getNotCollectedFields());
    }
  }, {
    key: "getFieldMember",
    value: function getFieldMember(name, member) {
      return this.getField(name)[member];
    }
  }, {
    key: "getNestedFields",
    value: function getNestedFields(names, getter) {
      var fields = names || this.getValidFieldsName();
      return (0, _reduce["default"])(fields).call(fields, function (acc, f) {
        return (0, _set["default"])(acc, f, getter(f));
      }, {});
    }
  }, {
    key: "getNestedField",
    value: function getNestedField(name, getter) {
      var fullNames = this.getValidFieldsFullName(name);
      if (fullNames.length === 0 ||
      // Not registered
      fullNames.length === 1 && fullNames[0] === name // Name already is full name.
      ) {
        return getter(name);
      }
      var isArrayValue = fullNames[0][name.length] === '[';
      var suffixNameStartIndex = isArrayValue ? name.length : name.length + 1;
      return (0, _reduce["default"])(fullNames).call(fullNames, function (acc, fullName) {
        return (0, _set["default"])(acc, (0, _slice["default"])(fullName).call(fullName, suffixNameStartIndex), getter(fullName));
      }, isArrayValue ? [] : {});
    }
    // @private
    // BG: `a` and `a.b` cannot be use in the same form
  }, {
    key: "isValidNestedFieldName",
    value: function isValidNestedFieldName(name) {
      var names = this.getAllFieldsName();
      return (0, _every["default"])(names).call(names, function (n) {
        return !partOf(n, name) && !partOf(name, n);
      });
    }
  }, {
    key: "clearField",
    value: function clearField(name) {
      delete this.fields[name];
      delete this.fieldsMeta[name];
    }
  }]);
  return FieldsStore;
}();
function createFieldsStore(fields) {
  return new FieldsStore(fields);
}