"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _omit = _interopRequireDefault(require("omit.js"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var defaultSizeMap = {
  small: {
    width: 90,
    height: 60
  },
  "default": {
    width: 150,
    height: 100
  },
  large: {
    width: 240,
    height: 160
  }
};
var Status = {
  PENDING: 'pending',
  LOADING: 'loading',
  LOADED: 'loaded',
  FAILED: 'failed'
};
var noop = function noop() {};
var ImageLoader = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ImageLoader, _React$Component);
  var _super = _createSuper(ImageLoader);
  function ImageLoader(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ImageLoader);
    _this = _super.call(this, props);
    _this.base64Img = function (cls) {
      var _context;
      var placeholderSize = _this.props.placeholderSize;
      var sizeProps = {
        width: '100%'
      };
      if ((0, _typeof2["default"])(placeholderSize) === 'object') {
        sizeProps = (0, _assign["default"])({}, sizeProps, placeholderSize);
      } else if ((0, _indexOf["default"])(_context = ['small', 'default', 'large']).call(_context, placeholderSize) > -1) {
        sizeProps = (0, _assign["default"])({}, sizeProps, defaultSizeMap[placeholderSize]);
      }
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: cls,
        style: (0, _assign["default"])({}, sizeProps)
      });
    };
    _this.state = {
      status: props.src ? Status.LOADING : Status.PENDING,
      prevProps: props
    };
    return _this;
  }
  (0, _createClass2["default"])(ImageLoader, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.state.status === Status.LOADING) {
        this.createLoader();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.state.status === Status.LOADING && !this.img) {
        this.createLoader();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.destroyLoader();
    }
  }, {
    key: "getClassName",
    value: function getClassName() {
      var _context2, _context3;
      var prefixCls = this.props.prefixCls;
      var className = (0, _concat["default"])(_context2 = (0, _concat["default"])(_context3 = "".concat(prefixCls, " ")).call(_context3, prefixCls, "-")).call(_context2, this.state.status);
      if (this.props.className) {
        var _context4;
        className = (0, _concat["default"])(_context4 = "".concat(className, " ")).call(_context4, this.props.className);
      }
      return className;
    }
  }, {
    key: "createLoader",
    value: function createLoader() {
      var _context5, _context6;
      this.destroyLoader(); // We can only have one loader at a time.
      this.img = new Image();
      this.img.onload = (0, _bind["default"])(_context5 = this.handleLoad).call(_context5, this);
      this.img.onerror = (0, _bind["default"])(_context6 = this.handleError).call(_context6, this);
      this.img.src = this.props.src;
    }
  }, {
    key: "destroyLoader",
    value: function destroyLoader() {
      if (this.img) {
        this.img.onload = null;
        this.img.onerror = null;
        this.img = null;
      }
    }
  }, {
    key: "handleLoad",
    value: function handleLoad(event) {
      this.destroyLoader();
      this.setState({
        status: Status.LOADED
      });
      if (this.props.onLoad) this.props.onLoad(event);
    }
  }, {
    key: "handleError",
    value: function handleError(error) {
      this.destroyLoader();
      this.setState({
        status: Status.FAILED
      });
      if (this.props.onError) this.props.onError(error);
    }
  }, {
    key: "renderImg",
    value: function renderImg() {
      var _this$props = this.props,
        src = _this$props.src,
        imgProps = _this$props.imgProps;
      var otherProps = (0, _omit["default"])(imgProps, ['src']);
      return /*#__PURE__*/_react["default"].createElement("img", (0, _assign["default"])({
        src: src
      }, otherProps));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        style = _this$props2.style,
        preLoader = _this$props2.preLoader,
        failedLoader = _this$props2.failedLoader;
      var wrapperProps = {
        style: {},
        className: this.getClassName()
      };
      if (style) {
        wrapperProps.style = style;
      }
      var content = null;
      switch (this.state.status) {
        case Status.LOADED:
          // 加载成功
          content = this.renderImg();
          break;
        case Status.FAILED:
          // 使用自定义加载失败图片
          if (failedLoader) {
            if (typeof failedLoader === 'function') {
              content = failedLoader();
            } else {
              content = failedLoader;
            }
            // 使用系统预置加载失败图片
          } else {
            content = this.base64Img('failed-img');
          }
          break;
        default:
          // 使用自定义占位图片
          if (preLoader) {
            if (typeof preLoader === 'function') {
              content = preLoader();
            } else {
              content = preLoader;
            }
            // 使用系统预置占位图片
          } else {
            content = this.base64Img('preload-img');
          }
          break;
      }
      return /*#__PURE__*/_react["default"].createElement("div", (0, _assign["default"])({}, wrapperProps), content);
    }
  }]);
  return ImageLoader;
}(_react["default"].Component);
ImageLoader.propTypes = {
  className: _propTypes["default"].string,
  prefixCls: _propTypes["default"].string,
  placeholderSize: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  style: _propTypes["default"].object,
  preLoader: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].func]),
  failedLoader: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].func]),
  src: _propTypes["default"].string,
  onLoad: _propTypes["default"].func,
  onError: _propTypes["default"].func,
  imgProps: _propTypes["default"].object
};
ImageLoader.defaultProps = {
  prefixCls: 'fishd-image-loader',
  placeholderSize: 'default',
  onLoad: noop,
  onError: noop
};
ImageLoader.getDerivedStateFromProps = function (nextProps, prevState) {
  var _prevState$prevProps = prevState.prevProps,
    prevProps = _prevState$prevProps === void 0 ? {
      src: ''
    } : _prevState$prevProps;
  var newState = {
    prevProps: nextProps
  };
  if (prevProps.src !== nextProps.src) {
    newState.status = nextProps.src ? Status.LOADING : Status.PENDING;
  }
  return newState;
};
(0, _reactLifecyclesCompat.polyfill)(ImageLoader);
var _default = ImageLoader;
exports["default"] = _default;