"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/keys"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _splice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/splice"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Spin = _interopRequireDefault(require("../Spin"));
var _sortable = _interopRequireDefault(require("./sortable"));
var _Pagination = _interopRequireDefault(require("../Pagination"));
var _Grid = require("../Grid");
var _Item = _interopRequireDefault(require("./Item"));
require("./style/index.less");
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var List = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(List, _React$Component);
  var _super = _createSuper(List);
  function List() {
    var _this;
    (0, _classCallCheck2["default"])(this, List);
    _this = _super.apply(this, arguments);
    _this.state = {
      paginationCurrent: 1
    };
    _this.defaultPaginationProps = {
      current: 1,
      pageSize: 10,
      onChange: function onChange(page, pageSize) {
        var pagination = _this.props.pagination;
        _this.setState({
          paginationCurrent: page
        });
        if (pagination && pagination.onChange) {
          pagination.onChange(page, pageSize);
        }
      },
      total: 0
    };
    _this.keys = {};
    _this.renderItem = function (item, index) {
      var _this$props = _this.props,
        dataSource = _this$props.dataSource,
        renderItem = _this$props.renderItem,
        rowKey = _this$props.rowKey;
      var key;
      if (typeof rowKey === 'function') {
        key = rowKey(dataSource[index]);
      } else if (typeof rowKey === 'string') {
        key = dataSource[rowKey];
      } else {
        key = dataSource.key;
      }
      if (!key) {
        key = "list-item-".concat(index);
      }
      (0, _keys["default"])(_this)[index] = key;
      return renderItem(item, index);
    };
    _this.renderEmpty = function (Locale) {
      var defaultEmptyText = Locale ? Locale.emptyText : '暂无数据';
      var emptyText = _this.props.locale ? _this.props.locale.emptyText : defaultEmptyText;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(_this.props.prefixCls, "-empty-text")
      }, emptyText);
    };
    return _this;
  }
  (0, _createClass2["default"])(List, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        grid: this.props.grid
      };
    }
  }, {
    key: "isSomethingAfterLastItem",
    value: function isSomethingAfterLastItem() {
      var _this$props2 = this.props,
        loadMore = _this$props2.loadMore,
        pagination = _this$props2.pagination,
        footer = _this$props2.footer;
      return !!(loadMore || pagination || footer);
    }
  }, {
    key: "render",
    value: function render() {
      var _context,
        _classNames,
        _this2 = this;
      var paginationCurrent = this.state.paginationCurrent;
      var _a = this.props,
        bordered = _a.bordered,
        split = _a.split,
        className = _a.className,
        children = _a.children,
        itemLayout = _a.itemLayout,
        loadMore = _a.loadMore,
        pagination = _a.pagination,
        prefixCls = _a.prefixCls,
        grid = _a.grid,
        dataSource = _a.dataSource,
        size = _a.size,
        rowKey = _a.rowKey,
        renderItem = _a.renderItem,
        header = _a.header,
        footer = _a.footer,
        loading = _a.loading,
        striped = _a.striped,
        rest = __rest(_a, ["bordered", "split", "className", "children", "itemLayout", "loadMore", "pagination", "prefixCls", "grid", "dataSource", "size", "rowKey", "renderItem", "header", "footer", "loading", "striped"]);
      var loadingProp = loading;
      if (typeof loadingProp === 'boolean') {
        loadingProp = {
          spinning: loadingProp
        };
      }
      var isLoading = loadingProp && loadingProp.spinning;
      // large => lg
      // small => sm
      var sizeCls = '';
      switch (size) {
        case 'large':
          sizeCls = 'lg';
          break;
        case 'small':
          sizeCls = 'sm';
          break;
      }
      var classString = (0, _classnames["default"])(prefixCls, className, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-vertical"), itemLayout === 'vertical'), (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context = "".concat(prefixCls, "-")).call(_context, sizeCls), sizeCls), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-split"), split), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-bordered"), bordered), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-loading"), isLoading), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-grid"), grid), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-striped"), striped), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-something-after-last-item"), this.isSomethingAfterLastItem()), _classNames));
      var paginationProps = (0, _assign["default"])((0, _assign["default"])((0, _assign["default"])({}, this.defaultPaginationProps), {
        total: dataSource.length,
        current: paginationCurrent
      }), pagination || {});
      var largestPage = Math.ceil(paginationProps.total / paginationProps.pageSize);
      if (paginationProps.current > largestPage) {
        paginationProps.current = largestPage;
      }
      var paginationContent = pagination ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-pagination")
      }, /*#__PURE__*/_react["default"].createElement(_Pagination["default"], (0, _assign["default"])({}, paginationProps, {
        onChange: this.defaultPaginationProps.onChange
      }))) : null;
      var splitDataSource = (0, _toConsumableArray2["default"])(dataSource);
      if (pagination) {
        if (dataSource.length > (paginationProps.current - 1) * paginationProps.pageSize) {
          var _context2;
          splitDataSource = (0, _splice["default"])(_context2 = (0, _toConsumableArray2["default"])(dataSource)).call(_context2, (paginationProps.current - 1) * paginationProps.pageSize, paginationProps.pageSize);
        }
      }
      var renderChildrenContent = function renderChildrenContent(Locale) {
        var childrenContent;
        childrenContent = isLoading && /*#__PURE__*/_react["default"].createElement("div", {
          style: {
            minHeight: 53
          }
        });
        if (splitDataSource.length > 0) {
          var _context3;
          var items = (0, _map["default"])(splitDataSource).call(splitDataSource, function (item, index) {
            return _this2.renderItem(item, index);
          });
          var childrenList = (0, _map["default"])(_context3 = _react["default"].Children).call(_context3, items, function (child, index) {
            return /*#__PURE__*/_react["default"].cloneElement(child, {
              key: (0, _keys["default"])(_this2)[index]
            });
          });
          childrenContent = grid ? /*#__PURE__*/_react["default"].createElement(_Grid.Row, {
            gutter: grid.gutter
          }, childrenList) : childrenList;
        } else if (!children && !isLoading) {
          childrenContent = /*#__PURE__*/_react["default"].createElement("div", null, _this2.renderEmpty(Locale));
        }
        return childrenContent;
      };
      var paginationPosition = paginationProps.position || 'bottom';
      return /*#__PURE__*/_react["default"].createElement(_Consumer["default"], {
        componentName: "List"
      }, function (Locale) {
        return /*#__PURE__*/_react["default"].createElement("div", (0, _assign["default"])({
          className: classString
        }, rest), (paginationPosition === 'top' || paginationPosition === 'both') && paginationContent, header && /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-header")
        }, header), /*#__PURE__*/_react["default"].createElement(_Spin["default"], (0, _assign["default"])({}, loadingProp), renderChildrenContent(Locale), children), footer && /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-footer")
        }, footer), loadMore || (paginationPosition === 'bottom' || paginationPosition === 'both') && paginationContent);
      });
    }
  }]);
  return List;
}(_react["default"].Component);
List.Item = _Item["default"];
List.Sortable = _sortable["default"];
List.childContextTypes = {
  grid: _propTypes["default"].any
};
List.propTypes = {
  locale: _propTypes["default"].shape({
    emptyText: _propTypes["default"].string
  }),
  dataSource: _propTypes["default"].array,
  prefixCls: _propTypes["default"].string,
  bordered: _propTypes["default"].bool,
  split: _propTypes["default"].bool,
  loading: _propTypes["default"].bool,
  pagination: _propTypes["default"].bool,
  striped: _propTypes["default"].bool
};
List.defaultProps = {
  dataSource: [],
  prefixCls: 'fishd-list',
  bordered: false,
  split: true,
  loading: false,
  pagination: false,
  striped: false
};
var _default = List;
exports["default"] = _default;