"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HORIZONTAL = void 0;
exports.SortableComposition = SortableComposition;
exports.VERTICAL = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _helpers = require("./helpers.js");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var VERTICAL = 'VERTICAL';
exports.VERTICAL = VERTICAL;
var HORIZONTAL = 'HORIZONTAL';
/*** Higher-order component - this component works like a factory for draggable items */
exports.HORIZONTAL = HORIZONTAL;
var draggingIndex = null;
function SortableComposition(Component) {
  var flowDirection = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : VERTICAL;
  var _a;
  return _a = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2["default"])(Sortable, _React$Component);
    var _super = _createSuper(Sortable);
    function Sortable() {
      var _this;
      (0, _classCallCheck2["default"])(this, Sortable);
      _this = _super.apply(this, arguments);
      _this.sortEnd = function (e) {
        e.preventDefault();
        draggingIndex = null;
      };
      _this.sortStart = function (e) {
        draggingIndex = e.currentTarget.dataset.id;
        var dt = e.dataTransfer;
        if (dt !== undefined) {
          dt.effectAllowed = 'move';
          e.dataTransfer.setData('text', e.target.innerHTML);
          if (dt.setDragImage && e.currentTarget.tagName.toLowerCase() === 'a') {
            dt.setDragImage(e.target, 0, 0);
          }
        }
      };
      _this.dragOver = function (e) {
        e.preventDefault();
        var moveInMiddle = _this.props.moveInMiddle;
        var overEl = e.currentTarget; //underlying element
        var indexDragged = Number(overEl.dataset.id); //index of underlying element in the set DOM elements
        var indexFrom = Number(draggingIndex);
        var height = overEl.getBoundingClientRect().height;
        var width = overEl.getBoundingClientRect().width;
        var positionX = e.clientX;
        var positionY = e.clientY;
        var topOffset = overEl.getBoundingClientRect().top;
        var leftOffset = overEl.getBoundingClientRect().left;
        var mouseBeyond;
        var items = _this.props.items;
        if (flowDirection === VERTICAL) {
          mouseBeyond = (0, _helpers.isMouseBeyond)(positionY, topOffset, height, moveInMiddle);
        }
        if (flowDirection === HORIZONTAL) {
          mouseBeyond = (0, _helpers.isMouseBeyond)(positionX, leftOffset, width, moveInMiddle);
        }
        if (indexDragged !== indexFrom && mouseBeyond) {
          items = (0, _helpers.swapArrayElements)(items, indexFrom, indexDragged);
          draggingIndex = indexDragged;
          _this.props.onSortItems(items);
        }
      };
      return _this;
    }
    (0, _createClass2["default"])(Sortable, [{
      key: "render",
      value: function render() {
        var newProps = (0, _assign["default"])({}, this.props);
        delete newProps.onSortItems;
        var sortId = newProps.sortId,
          moveInMiddle = newProps.moveInMiddle,
          items = newProps.items,
          props = __rest(newProps, ["sortId", "moveInMiddle", "items"]);
        return /*#__PURE__*/_react["default"].createElement(Component, (0, _assign["default"])({
          draggable: true,
          onDragOver: this.dragOver,
          onDragStart: this.sortStart,
          onDragEnd: this.sortEnd,
          onTouchStart: this.sortStart,
          onTouchMove: this.dragOver,
          onTouchEnd: this.sortEnd,
          "data-id": sortId
        }, props));
      }
    }]);
    return Sortable;
  }(_react["default"].Component), _a.propTypes = {
    items: _propTypes["default"].array.isRequired,
    onSortItems: _propTypes["default"].func.isRequired,
    sortId: _propTypes["default"].number,
    moveInMiddle: _propTypes["default"].bool
  }, _a.defaultProps = {
    moveInMiddle: false
  }, _a;
}