"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = confirm;
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var React = _interopRequireWildcard(require("react"));
var ReactDOM = _interopRequireWildcard(require("react-dom"));
var _classnames = _interopRequireDefault(require("classnames"));
var _index = _interopRequireDefault(require("../Icon/index"));
var _Modal = _interopRequireDefault(require("./Modal"));
var _ActionButton = _interopRequireDefault(require("./ActionButton"));
var _Provider = require("../Config/Locale/Provider");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var _this = void 0;
var IS_REACT_16 = !!ReactDOM.createPortal;
var ConfirmDialog = function ConfirmDialog(props) {
  var _context;
  var runtimeLocale = (0, _Provider.getRuntimeLocale)('Modal');
  var onCancel = props.onCancel,
    onOk = props.onOk,
    close = props.close,
    zIndex = props.zIndex,
    afterClose = props.afterClose,
    visible = props.visible,
    esc = props.esc;
  var iconType = props.iconType || 'hints-descriptions';
  var okType = props.okType || 'primary';
  var prefixCls = props.prefixCls || 'fishd-confirm';
  // 默认为 true，保持向下兼容
  var okCancel = 'okCancel' in props ? props.okCancel : true;
  var width = props.width || 416;
  var style = props.style || {};
  // 默认为 false，保持旧版默认行为
  var maskClosable = props.maskClosable === undefined ? false : props.maskClosable;
  var okText = props.okText || runtimeLocale.okText;
  var cancelText = props.cancelText || runtimeLocale.cancelText;
  var classString = (0, _classnames["default"])(prefixCls, (0, _concat["default"])(_context = "".concat(prefixCls, "-")).call(_context, props.type), props.className);
  var cancelButton = okCancel && /*#__PURE__*/React.createElement(_ActionButton["default"], {
    actionFn: onCancel,
    closeModal: close
  }, cancelText);
  return /*#__PURE__*/React.createElement(_Modal["default"], {
    className: classString,
    onCancel: (0, _bind["default"])(close).call(close, _this, {
      triggerCancel: true
    }),
    visible: visible,
    title: "",
    footer: "",
    maskClosable: maskClosable,
    style: style,
    width: width,
    zIndex: zIndex,
    afterClose: afterClose,
    esc: esc
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-body-wrapper")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-body")
  }, /*#__PURE__*/React.createElement(_index["default"], {
    type: iconType
  }), /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-title")
  }, props.title), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-content")
  }, props.content)), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-btns")
  }, cancelButton, /*#__PURE__*/React.createElement(_ActionButton["default"], {
    type: okType,
    actionFn: onOk,
    closeModal: close,
    autoFocus: true
  }, okText || runtimeLocale.okText))));
};
function confirm(config) {
  var div = document.createElement('div');
  document.body.appendChild(div);
  function close() {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    if (IS_REACT_16) {
      var _context2;
      render((0, _assign["default"])((0, _assign["default"])({}, config), {
        close: close,
        visible: false,
        afterClose: (0, _bind["default"])(destroy).apply(destroy, (0, _concat["default"])(_context2 = [this]).call(_context2, args))
      }));
    } else {
      destroy.apply(void 0, args);
    }
  }
  function destroy() {
    var unmountResult = ReactDOM.unmountComponentAtNode(div);
    if (unmountResult && div.parentNode) {
      div.parentNode.removeChild(div);
    }
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    var triggerCancel = args && args.length && (0, _some["default"])(args).call(args, function (param) {
      return param && param.triggerCancel;
    });
    if (config.onCancel && triggerCancel) {
      config.onCancel.apply(config, args);
    }
  }
  function render(props) {
    ReactDOM.render( /*#__PURE__*/React.createElement(ConfirmDialog, (0, _assign["default"])({}, props)), div);
  }
  render((0, _assign["default"])((0, _assign["default"])({}, config), {
    visible: true,
    close: close
  }));
  return {
    destroy: close
  };
}