"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var Pager = function Pager(props) {
  var _context, _context2;
  var prefixCls = "".concat(props.rootPrefixCls, "-item");
  var cls = (0, _concat["default"])(_context = (0, _concat["default"])(_context2 = "".concat(prefixCls, " ")).call(_context2, prefixCls, "-")).call(_context, props.page);
  if (props.active) {
    var _context3;
    cls = (0, _concat["default"])(_context3 = "".concat(cls, " ")).call(_context3, prefixCls, "-active");
  }
  if (props.className) {
    var _context4;
    cls = (0, _concat["default"])(_context4 = "".concat(cls, " ")).call(_context4, props.className);
  }
  var handleClick = function handleClick() {
    props.onClick(props.page);
  };
  var handleKeyPress = function handleKeyPress(e) {
    props.onKeyPress(e, props.onClick, props.page);
  };
  return /*#__PURE__*/_react["default"].createElement("li", {
    title: props.showTitle ? props.page : null,
    className: cls,
    onClick: handleClick,
    onKeyPress: handleKeyPress,
    tabIndex: "0"
  }, props.itemRender(props.page, 'page', /*#__PURE__*/_react["default"].createElement("a", null, props.page)));
};
Pager.propTypes = {
  page: _propTypes["default"].number,
  active: _propTypes["default"].bool,
  last: _propTypes["default"].bool,
  locale: _propTypes["default"].object,
  className: _propTypes["default"].string,
  showTitle: _propTypes["default"].bool,
  rootPrefixCls: _propTypes["default"].string,
  onClick: _propTypes["default"].func,
  onKeyPress: _propTypes["default"].func,
  itemRender: _propTypes["default"].func
};
var _default = Pager;
exports["default"] = _default;