"use strict";

function _typeof3(obj) { "@babel/helpers - typeof"; return _typeof3 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof3(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _toArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toArray"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _endsWith = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/ends-with"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _map3 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _find = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
var _merge = _interopRequireDefault(require("lodash/merge"));
var _quillDelta = _interopRequireWildcard(require("quill-delta"));
var _parchment = require("parchment");
var _selection = require("./selection");
var _cursor = _interopRequireDefault(require("../blots/cursor"));
var _block = _interopRequireWildcard(require("../blots/block"));
var _break = _interopRequireDefault(require("../blots/break"));
var _text = _interopRequireWildcard(require("../blots/text"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var ASCII = /^[ -~]*$/;
var Editor = /*#__PURE__*/function () {
  function Editor(scroll) {
    (0, _classCallCheck2["default"])(this, Editor);
    this.scroll = scroll;
    this.delta = this.getDelta();
  }
  (0, _createClass2["default"])(Editor, [{
    key: "applyDelta",
    value: function applyDelta(delta) {
      var _this = this;
      this.scroll.update();
      var scrollLength = this.scroll.length();
      this.scroll.batchStart();
      var normalizedDelta = normalizeDelta(delta);
      var deleteDelta = new _quillDelta["default"]();
      (0, _reduce["default"])(normalizedDelta).call(normalizedDelta, function (index, op) {
        var _context;
        var length = _quillDelta.Op.length(op);
        var attributes = op.attributes || {};
        var addedNewline = false;
        if (op.insert != null) {
          deleteDelta.retain(length);
          if (typeof op.insert === 'string') {
            var text = op.insert;
            addedNewline = !(0, _endsWith["default"])(text).call(text, '\n') && (scrollLength <= index || _this.scroll.descendant(_block.BlockEmbed, index)[0]);
            _this.scroll.insertAt(index, text);
            var _this$scroll$line = _this.scroll.line(index),
              _this$scroll$line2 = (0, _slicedToArray2["default"])(_this$scroll$line, 2),
              line = _this$scroll$line2[0],
              offset = _this$scroll$line2[1];
            var formats = (0, _merge["default"])({}, (0, _block.bubbleFormats)(line));
            if (line instanceof _block["default"]) {
              var _line$descendant = line.descendant(_parchment.LeafBlot, offset),
                _line$descendant2 = (0, _slicedToArray2["default"])(_line$descendant, 1),
                leaf = _line$descendant2[0];
              formats = (0, _merge["default"])(formats, (0, _block.bubbleFormats)(leaf));
            }
            attributes = _quillDelta.AttributeMap.diff(formats, attributes) || {};
          } else if ((0, _typeof2["default"])(op.insert) === 'object') {
            var key = (0, _keys["default"])(op.insert)[0]; // There should only be one key
            if (key == null) return index;
            addedNewline = _this.scroll.query(key, _parchment.Scope.INLINE) != null && (scrollLength <= index || _this.scroll.descendant(_block.BlockEmbed, index)[0]);
            _this.scroll.insertAt(index, key, op.insert[key]);
          }
          scrollLength += length;
        } else {
          deleteDelta.push(op);
        }
        (0, _forEach["default"])(_context = (0, _keys["default"])(attributes)).call(_context, function (name) {
          _this.scroll.formatAt(index, length, name, attributes[name]);
        });
        var addedLength = addedNewline ? 1 : 0;
        scrollLength += addedLength;
        deleteDelta["delete"](addedLength);
        return index + length + addedLength;
      }, 0);
      (0, _reduce["default"])(deleteDelta).call(deleteDelta, function (index, op) {
        if (typeof op["delete"] === 'number') {
          _this.scroll.deleteAt(index, op["delete"]);
          return index;
        }
        return index + _quillDelta.Op.length(op);
      }, 0);
      this.scroll.batchEnd();
      this.scroll.optimize();
      return this.update(normalizedDelta);
    }
  }, {
    key: "deleteText",
    value: function deleteText(index, length) {
      this.scroll.deleteAt(index, length);
      return this.update(new _quillDelta["default"]().retain(index)["delete"](length));
    }
  }, {
    key: "formatLine",
    value: function formatLine(index, length) {
      var _context2,
        _this2 = this;
      var formats = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      this.scroll.update();
      (0, _forEach["default"])(_context2 = (0, _keys["default"])(formats)).call(_context2, function (format) {
        var _context3;
        (0, _forEach["default"])(_context3 = _this2.scroll.lines(index, Math.max(length, 1))).call(_context3, function (line) {
          line.format(format, formats[format]);
        });
      });
      this.scroll.optimize();
      var delta = new _quillDelta["default"]().retain(index).retain(length, (0, _cloneDeep["default"])(formats));
      return this.update(delta);
    }
  }, {
    key: "formatText",
    value: function formatText(index, length) {
      var _context4,
        _this3 = this;
      var formats = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      (0, _forEach["default"])(_context4 = (0, _keys["default"])(formats)).call(_context4, function (format) {
        _this3.scroll.formatAt(index, length, format, formats[format]);
      });
      var delta = new _quillDelta["default"]().retain(index).retain(length, (0, _cloneDeep["default"])(formats));
      return this.update(delta);
    }
  }, {
    key: "getContents",
    value: function getContents(index, length) {
      var _context5;
      return (0, _slice["default"])(_context5 = this.delta).call(_context5, index, index + length);
    }
  }, {
    key: "getDelta",
    value: function getDelta() {
      var _context6;
      return (0, _reduce["default"])(_context6 = this.scroll.lines()).call(_context6, function (delta, line) {
        return (0, _concat["default"])(delta).call(delta, line.delta());
      }, new _quillDelta["default"]());
    }
  }, {
    key: "getFormat",
    value: function getFormat(index) {
      var _context8;
      var length = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var lines = [];
      var leaves = [];
      if (length === 0) {
        var _context7;
        (0, _forEach["default"])(_context7 = this.scroll.path(index)).call(_context7, function (path) {
          var _path = (0, _slicedToArray2["default"])(path, 1),
            blot = _path[0];
          if (blot instanceof _block["default"]) {
            lines.push(blot);
          } else if (blot instanceof _parchment.LeafBlot) {
            leaves.push(blot);
          }
        });
      } else {
        lines = this.scroll.lines(index, length);
        leaves = this.scroll.descendants(_parchment.LeafBlot, index, length);
      }
      var _map = (0, _map3["default"])(_context8 = [lines, leaves]).call(_context8, function (blots) {
        if (blots.length === 0) return {};
        var formats = (0, _block.bubbleFormats)(blots.shift());
        while ((0, _keys["default"])(formats).length > 0) {
          var blot = blots.shift();
          if (blot == null) return formats;
          formats = combineFormats((0, _block.bubbleFormats)(blot), formats);
        }
        return formats;
      });
      var _map2 = (0, _slicedToArray2["default"])(_map, 2);
      lines = _map2[0];
      leaves = _map2[1];
      return (0, _assign["default"])((0, _assign["default"])({}, lines), leaves);
    }
  }, {
    key: "getHTML",
    value: function getHTML(index, length) {
      var _this$scroll$line3 = this.scroll.line(index),
        _this$scroll$line4 = (0, _slicedToArray2["default"])(_this$scroll$line3, 2),
        line = _this$scroll$line4[0],
        lineOffset = _this$scroll$line4[1];
      if (line.length() >= lineOffset + length) {
        return convertHTML(line, lineOffset, length, true);
      }
      return convertHTML(this.scroll, index, length, true);
    }
  }, {
    key: "getText",
    value: function getText(index, length) {
      var _context9, _context10;
      return (0, _map3["default"])(_context9 = (0, _filter["default"])(_context10 = this.getContents(index, length)).call(_context10, function (op) {
        return typeof op.insert === 'string';
      })).call(_context9, function (op) {
        return op.insert;
      }).join('');
    }
  }, {
    key: "insertEmbed",
    value: function insertEmbed(index, embed, value) {
      this.scroll.insertAt(index, embed, value);
      return this.update(new _quillDelta["default"]().retain(index).insert((0, _defineProperty2["default"])({}, embed, value)));
    }
  }, {
    key: "insertText",
    value: function insertText(index, text) {
      var _context11,
        _this4 = this;
      var formats = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      text = text.replace(/\r\n/g, '\n').replace(/\r/g, '\n');
      this.scroll.insertAt(index, text);
      (0, _forEach["default"])(_context11 = (0, _keys["default"])(formats)).call(_context11, function (format) {
        _this4.scroll.formatAt(index, text.length, format, formats[format]);
      });
      return this.update(new _quillDelta["default"]().retain(index).insert(text, (0, _cloneDeep["default"])(formats)));
    }
  }, {
    key: "isBlank",
    value: function isBlank() {
      if (this.scroll.children.length === 0) return true;
      if (this.scroll.children.length > 1) return false;
      var block = this.scroll.children.head;
      if (block.statics.blotName !== _block["default"].blotName) return false;
      if (block.children.length > 1) return false;
      return block.children.head instanceof _break["default"];
    }
  }, {
    key: "removeFormat",
    value: function removeFormat(index, length) {
      var _context13, _context14;
      var text = this.getText(index, length);
      var _this$scroll$line5 = this.scroll.line(index + length),
        _this$scroll$line6 = (0, _slicedToArray2["default"])(_this$scroll$line5, 2),
        line = _this$scroll$line6[0],
        offset = _this$scroll$line6[1];
      var suffixLength = 0;
      var suffix = new _quillDelta["default"]();
      if (line != null) {
        var _context12;
        suffixLength = line.length() - offset;
        suffix = (0, _slice["default"])(_context12 = line.delta()).call(_context12, offset, offset + suffixLength - 1).insert('\n');
      }
      var contents = this.getContents(index, length + suffixLength);
      var diff = contents.diff((0, _concat["default"])(_context13 = new _quillDelta["default"]().insert(text)).call(_context13, suffix));
      var delta = (0, _concat["default"])(_context14 = new _quillDelta["default"]().retain(index)).call(_context14, diff);
      return this.applyDelta(delta);
    }
  }, {
    key: "update",
    value: function update(change) {
      var _context15;
      var mutations = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var selectionInfo = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
      var oldDelta = this.delta;
      if (mutations.length === 1 && mutations[0].type === 'characterData' && mutations[0].target.data.match(ASCII) && (0, _find["default"])(_context15 = this.scroll).call(_context15, mutations[0].target)) {
        var _context16, _context17;
        // Optimization for character changes
        var textBlot = (0, _find["default"])(_context16 = this.scroll).call(_context16, mutations[0].target);
        var formats = (0, _block.bubbleFormats)(textBlot);
        var index = textBlot.offset(this.scroll);
        var oldValue = mutations[0].oldValue.replace(_cursor["default"].CONTENTS, '');
        var oldText = new _quillDelta["default"]().insert(oldValue);
        var newText = new _quillDelta["default"]().insert(textBlot.value());
        var relativeSelectionInfo = selectionInfo && {
          oldRange: shiftRange(selectionInfo.oldRange, -index),
          newRange: shiftRange(selectionInfo.newRange, -index)
        };
        var diffDelta = (0, _concat["default"])(_context17 = new _quillDelta["default"]().retain(index)).call(_context17, oldText.diff(newText, relativeSelectionInfo));
        change = (0, _reduce["default"])(diffDelta).call(diffDelta, function (delta, op) {
          if (op.insert) {
            return delta.insert(op.insert, formats);
          }
          return delta.push(op);
        }, new _quillDelta["default"]());
        this.delta = oldDelta.compose(change);
      } else {
        this.delta = this.getDelta();
        if (!change || !(0, _isEqual["default"])(oldDelta.compose(change), this.delta)) {
          change = oldDelta.diff(this.delta, selectionInfo);
        }
      }
      return change;
    }
  }]);
  return Editor;
}();
function convertListHTML(items, lastIndent, types) {
  var _context25;
  if (items.length === 0) {
    var _context18;
    var _getListType = getListType(types.pop()),
      _getListType2 = (0, _slicedToArray2["default"])(_getListType, 1),
      _endTag = _getListType2[0];
    if (lastIndent <= 0) {
      return "</li></".concat(_endTag, ">");
    }
    return (0, _concat["default"])(_context18 = "</li></".concat(_endTag, ">")).call(_context18, convertListHTML([], lastIndent - 1, types));
  }
  var _items = (0, _toArray2["default"])(items),
    _items$ = _items[0],
    child = _items$.child,
    offset = _items$.offset,
    length = _items$.length,
    indent = _items$.indent,
    type = _items$.type,
    rest = (0, _slice["default"])(_items).call(_items, 1);
  var _getListType3 = getListType(type),
    _getListType4 = (0, _slicedToArray2["default"])(_getListType3, 2),
    tag = _getListType4[0],
    attribute = _getListType4[1];
  if (indent > lastIndent) {
    var _context22;
    types.push(type);
    if (indent === lastIndent + 1) {
      var _context19, _context20, _context21;
      return (0, _concat["default"])(_context19 = (0, _concat["default"])(_context20 = (0, _concat["default"])(_context21 = "<".concat(tag, "><li")).call(_context21, attribute, ">")).call(_context20, convertHTML(child, offset, length))).call(_context19, convertListHTML(rest, indent, types));
    }
    return (0, _concat["default"])(_context22 = "<".concat(tag, "><li>")).call(_context22, convertListHTML(items, lastIndent + 1, types));
  }
  var previousType = types[types.length - 1];
  if (indent === lastIndent && type === previousType) {
    var _context23, _context24;
    return (0, _concat["default"])(_context23 = (0, _concat["default"])(_context24 = "</li><li".concat(attribute, ">")).call(_context24, convertHTML(child, offset, length))).call(_context23, convertListHTML(rest, indent, types));
  }
  var _getListType5 = getListType(types.pop()),
    _getListType6 = (0, _slicedToArray2["default"])(_getListType5, 1),
    endTag = _getListType6[0];
  return (0, _concat["default"])(_context25 = "</li></".concat(endTag, ">")).call(_context25, convertListHTML(items, lastIndent - 1, types));
}
function convertHTML(blot, index, length) {
  var isRoot = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  if (typeof blot.html === 'function') {
    return blot.html(index, length);
  }
  if (blot instanceof _text["default"]) {
    var _context26;
    return (0, _text.escapeText)((0, _slice["default"])(_context26 = blot.value()).call(_context26, index, index + length));
  }
  if (blot.children) {
    var _context28, _context29;
    // TODO fix API
    if (blot.statics.blotName === 'list-container') {
      var items = [];
      blot.children.forEachAt(index, length, function (child, offset, childLength) {
        var formats = child.formats();
        items.push({
          child: child,
          offset: offset,
          length: childLength,
          indent: formats.indent || 0,
          type: formats.list
        });
      });
      return convertListHTML(items, -1, []);
    }
    var parts = [];
    blot.children.forEachAt(index, length, function (child, offset, childLength) {
      parts.push(convertHTML(child, offset, childLength));
    });
    if (isRoot || blot.statics.blotName === 'list') {
      return parts.join('');
    }
    var _blot$domNode = blot.domNode,
      outerHTML = _blot$domNode.outerHTML,
      innerHTML = _blot$domNode.innerHTML;
    var _outerHTML$split = outerHTML.split(">".concat(innerHTML, "<")),
      _outerHTML$split2 = (0, _slicedToArray2["default"])(_outerHTML$split, 2),
      start = _outerHTML$split2[0],
      end = _outerHTML$split2[1];
    // TODO cleanup
    if (start === '<table') {
      var _context27;
      return (0, _concat["default"])(_context27 = "<table style=\"border: 1px solid #000;\">".concat(parts.join(''), "<")).call(_context27, end);
    }
    return (0, _concat["default"])(_context28 = (0, _concat["default"])(_context29 = "".concat(start, ">")).call(_context29, parts.join(''), "<")).call(_context28, end);
  }
  return blot.domNode.outerHTML;
}
function combineFormats(formats, combined) {
  var _context30;
  return (0, _reduce["default"])(_context30 = (0, _keys["default"])(combined)).call(_context30, function (merged, name) {
    if (formats[name] == null) return merged;
    if (combined[name] === formats[name]) {
      merged[name] = combined[name];
    } else if ((0, _isArray["default"])(combined[name])) {
      var _context31;
      if ((0, _indexOf["default"])(_context31 = combined[name]).call(_context31, formats[name]) < 0) {
        var _context32;
        merged[name] = (0, _concat["default"])(_context32 = combined[name]).call(_context32, [formats[name]]);
      }
    } else {
      merged[name] = [combined[name], formats[name]];
    }
    return merged;
  }, {});
}
function getListType(type) {
  var tag = type === 'ordered' ? 'ol' : 'ul';
  switch (type) {
    case 'checked':
      return [tag, ' data-list="checked"'];
    case 'unchecked':
      return [tag, ' data-list="unchecked"'];
    default:
      return [tag, ''];
  }
}
function normalizeDelta(delta) {
  return (0, _reduce["default"])(delta).call(delta, function (normalizedDelta, op) {
    if (typeof op.insert === 'string') {
      var text = op.insert.replace(/\r\n/g, '\n').replace(/\r/g, '\n');
      return normalizedDelta.insert(text, op.attributes);
    }
    return normalizedDelta.push(op);
  }, new _quillDelta["default"]());
}
function shiftRange(_ref, amount) {
  var index = _ref.index,
    length = _ref.length;
  return new _selection.Range(index + amount, length);
}
var _default = Editor;
exports["default"] = _default;