"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableRow = exports.TableContainer = exports.TableCell = exports.TableBody = void 0;
exports.tableId = tableId;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get3 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _fill = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/fill"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _block = _interopRequireDefault(require("../blots/block"));
var _container = _interopRequireDefault(require("../blots/container"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var TableCell = /*#__PURE__*/function (_Block) {
  (0, _inherits2["default"])(TableCell, _Block);
  var _super = _createSuper(TableCell);
  function TableCell() {
    (0, _classCallCheck2["default"])(this, TableCell);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(TableCell, [{
    key: "cellOffset",
    value: function cellOffset() {
      if (this.parent) {
        var _context;
        return (0, _indexOf["default"])(_context = this.parent.children).call(_context, this);
      }
      return -1;
    }
  }, {
    key: "format",
    value: function format(name, value) {
      if (name === TableCell.blotName && value) {
        this.domNode.setAttribute('data-row', value);
      } else {
        (0, _get3["default"])((0, _getPrototypeOf2["default"])(TableCell.prototype), "format", this).call(this, name, value);
      }
    }
  }, {
    key: "row",
    value: function row() {
      return this.parent;
    }
  }, {
    key: "rowOffset",
    value: function rowOffset() {
      if (this.row()) {
        return this.row().rowOffset();
      }
      return -1;
    }
  }, {
    key: "table",
    value: function table() {
      return this.row() && this.row().table();
    }
  }], [{
    key: "create",
    value: function create(value) {
      var node = (0, _get3["default"])((0, _getPrototypeOf2["default"])(TableCell), "create", this).call(this);
      if (value) {
        node.setAttribute('data-row', value);
      } else {
        node.setAttribute('data-row', tableId());
      }
      return node;
    }
  }, {
    key: "formats",
    value: function formats(domNode) {
      if (domNode.hasAttribute('data-row')) {
        return domNode.getAttribute('data-row');
      }
      return undefined;
    }
  }]);
  return TableCell;
}(_block["default"]);
exports.TableCell = TableCell;
TableCell.blotName = 'table';
TableCell.tagName = 'TD';
var TableRow = /*#__PURE__*/function (_Container) {
  (0, _inherits2["default"])(TableRow, _Container);
  var _super2 = _createSuper(TableRow);
  function TableRow() {
    (0, _classCallCheck2["default"])(this, TableRow);
    return _super2.apply(this, arguments);
  }
  (0, _createClass2["default"])(TableRow, [{
    key: "checkMerge",
    value: function checkMerge() {
      if ((0, _get3["default"])((0, _getPrototypeOf2["default"])(TableRow.prototype), "checkMerge", this).call(this) && this.next.children.head != null) {
        var thisHead = this.children.head.formats();
        var thisTail = this.children.tail.formats();
        var nextHead = this.next.children.head.formats();
        var nextTail = this.next.children.tail.formats();
        return thisHead.table === thisTail.table && thisHead.table === nextHead.table && thisHead.table === nextTail.table;
      }
      return false;
    }
  }, {
    key: "optimize",
    value: function optimize() {
      var _get2,
        _context2,
        _context3,
        _this = this;
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      (_get2 = (0, _get3["default"])((0, _getPrototypeOf2["default"])(TableRow.prototype), "optimize", this)).call.apply(_get2, (0, _concat["default"])(_context2 = [this]).call(_context2, args));
      (0, _forEach["default"])(_context3 = this.children).call(_context3, function (child) {
        if (child.next == null) return;
        var childFormats = child.formats();
        var nextFormats = child.next.formats();
        if (childFormats.table !== nextFormats.table) {
          var next = _this.splitAfter(child);
          if (next) {
            next.optimize();
          }
          // We might be able to merge with prev now
          if (_this.prev) {
            _this.prev.optimize();
          }
        }
      });
    }
  }, {
    key: "rowOffset",
    value: function rowOffset() {
      if (this.parent) {
        var _context4;
        return (0, _indexOf["default"])(_context4 = this.parent.children).call(_context4, this);
      }
      return -1;
    }
  }, {
    key: "table",
    value: function table() {
      return this.parent && this.parent.parent;
    }
  }]);
  return TableRow;
}(_container["default"]);
exports.TableRow = TableRow;
TableRow.blotName = 'table-row';
TableRow.tagName = 'TR';
var TableBody = /*#__PURE__*/function (_Container2) {
  (0, _inherits2["default"])(TableBody, _Container2);
  var _super3 = _createSuper(TableBody);
  function TableBody() {
    (0, _classCallCheck2["default"])(this, TableBody);
    return _super3.apply(this, arguments);
  }
  return (0, _createClass2["default"])(TableBody);
}(_container["default"]);
exports.TableBody = TableBody;
TableBody.blotName = 'table-body';
TableBody.tagName = 'TBODY';
var TableContainer = /*#__PURE__*/function (_Container3) {
  (0, _inherits2["default"])(TableContainer, _Container3);
  var _super4 = _createSuper(TableContainer);
  function TableContainer() {
    (0, _classCallCheck2["default"])(this, TableContainer);
    return _super4.apply(this, arguments);
  }
  (0, _createClass2["default"])(TableContainer, [{
    key: "balanceCells",
    value: function balanceCells() {
      var _this2 = this;
      var rows = this.descendants(TableRow);
      var maxColumns = (0, _reduce["default"])(rows).call(rows, function (max, row) {
        return Math.max(row.children.length, max);
      }, 0);
      (0, _forEach["default"])(rows).call(rows, function (row) {
        var _context5, _context6;
        (0, _forEach["default"])(_context5 = (0, _fill["default"])(_context6 = new Array(maxColumns - row.children.length)).call(_context6, 0)).call(_context5, function () {
          var value;
          if (row.children.head != null) {
            value = TableCell.formats(row.children.head.domNode);
          }
          var blot = _this2.scroll.create(TableCell.blotName, value);
          row.appendChild(blot);
          blot.optimize(); // Add break blot
        });
      });
    }
  }, {
    key: "cells",
    value: function cells(column) {
      var _context7;
      return (0, _map["default"])(_context7 = this.rows()).call(_context7, function (row) {
        return row.children.at(column);
      });
    }
  }, {
    key: "deleteColumn",
    value: function deleteColumn(index) {
      var _context8;
      var _this$descendant = this.descendant(TableBody),
        _this$descendant2 = (0, _slicedToArray2["default"])(_this$descendant, 1),
        body = _this$descendant2[0];
      if (body == null || body.children.head == null) return;
      (0, _forEach["default"])(_context8 = body.children).call(_context8, function (row) {
        var cell = row.children.at(index);
        if (cell != null) {
          cell.remove();
        }
      });
    }
  }, {
    key: "insertColumn",
    value: function insertColumn(index) {
      var _context9,
        _this3 = this;
      var _this$descendant3 = this.descendant(TableBody),
        _this$descendant4 = (0, _slicedToArray2["default"])(_this$descendant3, 1),
        body = _this$descendant4[0];
      if (body == null || body.children.head == null) return;
      (0, _forEach["default"])(_context9 = body.children).call(_context9, function (row) {
        var ref = row.children.at(index);
        var value = TableCell.formats(row.children.head.domNode);
        var cell = _this3.scroll.create(TableCell.blotName, value);
        row.insertBefore(cell, ref);
      });
    }
  }, {
    key: "insertRow",
    value: function insertRow(index) {
      var _context10,
        _this4 = this;
      var _this$descendant5 = this.descendant(TableBody),
        _this$descendant6 = (0, _slicedToArray2["default"])(_this$descendant5, 1),
        body = _this$descendant6[0];
      if (body == null || body.children.head == null) return;
      var id = tableId();
      var row = this.scroll.create(TableRow.blotName);
      (0, _forEach["default"])(_context10 = body.children.head.children).call(_context10, function () {
        var cell = _this4.scroll.create(TableCell.blotName, id);
        row.appendChild(cell);
      });
      var ref = body.children.at(index);
      body.insertBefore(row, ref);
    }
  }, {
    key: "rows",
    value: function rows() {
      var _context11;
      var body = this.children.head;
      if (body == null) return [];
      return (0, _map["default"])(_context11 = body.children).call(_context11, function (row) {
        return row;
      });
    }
  }]);
  return TableContainer;
}(_container["default"]);
exports.TableContainer = TableContainer;
TableContainer.blotName = 'table-container';
TableContainer.tagName = 'TABLE';
TableContainer.allowedChildren = [TableBody];
TableBody.requiredContainer = TableContainer;
TableBody.allowedChildren = [TableRow];
TableRow.requiredContainer = TableBody;
TableRow.allowedChildren = [TableCell];
TableCell.requiredContainer = TableRow;
function tableId() {
  var _context12;
  var id = (0, _slice["default"])(_context12 = Math.random().toString(36)).call(_context12, 2, 6);
  return "row-".concat(id);
}