"use strict";

function _typeof3(obj) { "@babel/helpers - typeof"; return _typeof3 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof3(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.SHORTKEY = void 0;
exports.deleteRange = deleteRange;
exports.normalize = normalize;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));
var _startsWith = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/starts-with"));
var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
var _quillDelta = _interopRequireWildcard(require("quill-delta"));
var _parchment = require("parchment");
var _quill = _interopRequireDefault(require("../core/quill"));
var _logger = _interopRequireDefault(require("../core/logger"));
var _module = _interopRequireDefault(require("../core/module"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var debug = (0, _logger["default"])('quill:keyboard');
var SHORTKEY = /Mac/i.test(navigator.platform) ? 'metaKey' : 'ctrlKey';
exports.SHORTKEY = SHORTKEY;
var Keyboard = /*#__PURE__*/function (_Module) {
  (0, _inherits2["default"])(Keyboard, _Module);
  var _super = _createSuper(Keyboard);
  function Keyboard(quill, options) {
    var _context;
    var _this;
    (0, _classCallCheck2["default"])(this, Keyboard);
    _this = _super.call(this, quill, options);
    _this.bindings = {};
    (0, _forEach["default"])(_context = (0, _keys["default"])(_this.options.bindings)).call(_context, function (name) {
      if (_this.options.bindings[name]) {
        _this.addBinding(_this.options.bindings[name]);
      }
    });
    _this.addBinding({
      key: 'Enter',
      shiftKey: null
    }, _this.handleEnter);
    _this.addBinding({
      key: 'Enter',
      metaKey: null,
      ctrlKey: null,
      altKey: null
    }, function () {});
    if (/Firefox/i.test(navigator.userAgent)) {
      // Need to handle delete and backspace for Firefox in the general case #1171
      _this.addBinding({
        key: 'Backspace'
      }, {
        collapsed: true
      }, _this.handleBackspace);
      _this.addBinding({
        key: 'Delete'
      }, {
        collapsed: true
      }, _this.handleDelete);
    } else {
      _this.addBinding({
        key: 'Backspace'
      }, {
        collapsed: true,
        prefix: /^.?$/
      }, _this.handleBackspace);
      _this.addBinding({
        key: 'Delete'
      }, {
        collapsed: true,
        suffix: /^.?$/
      }, _this.handleDelete);
    }
    _this.addBinding({
      key: 'Backspace'
    }, {
      collapsed: false
    }, _this.handleDeleteRange);
    _this.addBinding({
      key: 'Delete'
    }, {
      collapsed: false
    }, _this.handleDeleteRange);
    _this.addBinding({
      key: 'Backspace',
      altKey: null,
      ctrlKey: null,
      metaKey: null,
      shiftKey: null
    }, {
      collapsed: true,
      offset: 0
    }, _this.handleBackspace);
    _this.listen();
    return _this;
  }
  (0, _createClass2["default"])(Keyboard, [{
    key: "addBinding",
    value: function addBinding(keyBinding) {
      var _this2 = this;
      var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var handler = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var binding = normalize(keyBinding);
      if (binding == null) {
        debug.warn('Attempted to add invalid keyboard binding', binding);
        return;
      }
      if (typeof context === 'function') {
        context = {
          handler: context
        };
      }
      if (typeof handler === 'function') {
        handler = {
          handler: handler
        };
      }
      var keys = (0, _isArray["default"])(binding.key) ? binding.key : [binding.key];
      (0, _forEach["default"])(keys).call(keys, function (key) {
        var singleBinding = (0, _assign["default"])((0, _assign["default"])((0, _assign["default"])((0, _assign["default"])({}, binding), {
          key: key
        }), context), handler);
        _this2.bindings[singleBinding.key] = _this2.bindings[singleBinding.key] || [];
        _this2.bindings[singleBinding.key].push(singleBinding);
      });
    }
  }, {
    key: "listen",
    value: function listen() {
      var _this3 = this;
      this.quill.root.addEventListener('keydown', function (evt) {
        var _context2, _context3, _context4;
        if (evt.defaultPrevented || evt.isComposing) return;
        var bindings = (0, _concat["default"])(_context2 = _this3.bindings[evt.key] || []).call(_context2, _this3.bindings[evt.which] || []);
        var matches = (0, _filter["default"])(bindings).call(bindings, function (binding) {
          return Keyboard.match(evt, binding);
        });
        if (matches.length === 0) return;
        var range = _this3.quill.getSelection();
        if (range == null || !_this3.quill.hasFocus()) return;
        var _this3$quill$getLine = _this3.quill.getLine(range.index),
          _this3$quill$getLine2 = (0, _slicedToArray2["default"])(_this3$quill$getLine, 2),
          line = _this3$quill$getLine2[0],
          offset = _this3$quill$getLine2[1];
        var _this3$quill$getLeaf = _this3.quill.getLeaf(range.index),
          _this3$quill$getLeaf2 = (0, _slicedToArray2["default"])(_this3$quill$getLeaf, 2),
          leafStart = _this3$quill$getLeaf2[0],
          offsetStart = _this3$quill$getLeaf2[1];
        var _ref = range.length === 0 ? [leafStart, offsetStart] : _this3.quill.getLeaf(range.index + range.length),
          _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
          leafEnd = _ref2[0],
          offsetEnd = _ref2[1];
        var prefixText = leafStart instanceof _parchment.TextBlot ? (0, _slice["default"])(_context3 = leafStart.value()).call(_context3, 0, offsetStart) : '';
        var suffixText = leafEnd instanceof _parchment.TextBlot ? (0, _slice["default"])(_context4 = leafEnd.value()).call(_context4, offsetEnd) : '';
        var curContext = {
          collapsed: range.length === 0,
          empty: range.length === 0 && line.length() <= 1,
          format: _this3.quill.getFormat(range),
          line: line,
          offset: offset,
          prefix: prefixText,
          suffix: suffixText,
          event: evt
        };
        var prevented = (0, _some["default"])(matches).call(matches, function (binding) {
          if (binding.collapsed != null && binding.collapsed !== curContext.collapsed) {
            return false;
          }
          if (binding.empty != null && binding.empty !== curContext.empty) {
            return false;
          }
          if (binding.offset != null && binding.offset !== curContext.offset) {
            return false;
          }
          if ((0, _isArray["default"])(binding.format)) {
            var _context5;
            // any format is present
            if ((0, _every["default"])(_context5 = binding.format).call(_context5, function (name) {
              return curContext.format[name] == null;
            })) {
              return false;
            }
          } else if ((0, _typeof2["default"])(binding.format) === 'object') {
            var _context6;
            // all formats must match
            if (!(0, _every["default"])(_context6 = (0, _keys["default"])(binding.format)).call(_context6, function (name) {
              if (binding.format[name] === true) return curContext.format[name] != null;
              if (binding.format[name] === false) return curContext.format[name] == null;
              return (0, _isEqual["default"])(binding.format[name], curContext.format[name]);
            })) {
              return false;
            }
          }
          if (binding.prefix != null && !binding.prefix.test(curContext.prefix)) {
            return false;
          }
          if (binding.suffix != null && !binding.suffix.test(curContext.suffix)) {
            return false;
          }
          return binding.handler.call(_this3, range, curContext, binding) !== true;
        });
        if (prevented) {
          evt.preventDefault();
        }
      });
    }
  }, {
    key: "handleBackspace",
    value: function handleBackspace(range, context) {
      // Check for astral symbols
      var length = /[\uD800-\uDBFF][\uDC00-\uDFFF]$/.test(context.prefix) ? 2 : 1;
      if (range.index === 0 || this.quill.getLength() <= 1) return;
      var formats = {};
      var _this$quill$getLine = this.quill.getLine(range.index),
        _this$quill$getLine2 = (0, _slicedToArray2["default"])(_this$quill$getLine, 1),
        line = _this$quill$getLine2[0];
      var delta = new _quillDelta["default"]().retain(range.index - length)["delete"](length);
      if (context.offset === 0) {
        // Always deleting newline here, length always 1
        var _this$quill$getLine3 = this.quill.getLine(range.index - 1),
          _this$quill$getLine4 = (0, _slicedToArray2["default"])(_this$quill$getLine3, 1),
          prev = _this$quill$getLine4[0];
        if (prev) {
          var isPrevLineEmpty = prev.statics.blotName === 'block' && prev.length() <= 1;
          if (!isPrevLineEmpty) {
            var curFormats = line.formats();
            var prevFormats = this.quill.getFormat(range.index - 1, 1);
            formats = _quillDelta.AttributeMap.diff(curFormats, prevFormats) || {};
            if ((0, _keys["default"])(formats).length > 0) {
              // line.length() - 1 targets \n in line, another -1 for newline being deleted
              var formatDelta = new _quillDelta["default"]().retain(range.index + line.length() - 2).retain(1, formats);
              delta = delta.compose(formatDelta);
            }
          }
        }
      }
      this.quill.updateContents(delta, _quill["default"].sources.USER);
      this.quill.focus();
    }
  }, {
    key: "handleDelete",
    value: function handleDelete(range, context) {
      // Check for astral symbols
      var length = /^[\uD800-\uDBFF][\uDC00-\uDFFF]/.test(context.suffix) ? 2 : 1;
      if (range.index >= this.quill.getLength() - length) return;
      var formats = {};
      var _this$quill$getLine5 = this.quill.getLine(range.index),
        _this$quill$getLine6 = (0, _slicedToArray2["default"])(_this$quill$getLine5, 1),
        line = _this$quill$getLine6[0];
      var delta = new _quillDelta["default"]().retain(range.index)["delete"](length);
      if (context.offset >= line.length() - 1) {
        var _this$quill$getLine7 = this.quill.getLine(range.index + 1),
          _this$quill$getLine8 = (0, _slicedToArray2["default"])(_this$quill$getLine7, 1),
          next = _this$quill$getLine8[0];
        if (next) {
          var curFormats = line.formats();
          var nextFormats = this.quill.getFormat(range.index, 1);
          formats = _quillDelta.AttributeMap.diff(curFormats, nextFormats) || {};
          if ((0, _keys["default"])(formats).length > 0) {
            delta = delta.retain(next.length() - 1).retain(1, formats);
          }
        }
      }
      this.quill.updateContents(delta, _quill["default"].sources.USER);
      this.quill.focus();
    }
  }, {
    key: "handleDeleteRange",
    value: function handleDeleteRange(range) {
      deleteRange({
        range: range,
        quill: this.quill
      });
      this.quill.focus();
    }
  }, {
    key: "handleEnter",
    value: function handleEnter(range, context) {
      var _context7,
        _this4 = this;
      var lineFormats = (0, _reduce["default"])(_context7 = (0, _keys["default"])(context.format)).call(_context7, function (formats, format) {
        if (_this4.quill.scroll.query(format, _parchment.Scope.BLOCK) && !(0, _isArray["default"])(context.format[format])) {
          formats[format] = context.format[format];
        }
        return formats;
      }, {});
      var delta = new _quillDelta["default"]().retain(range.index)["delete"](range.length).insert('\n', lineFormats);
      this.quill.updateContents(delta, _quill["default"].sources.USER);
      this.quill.setSelection(range.index + 1, _quill["default"].sources.SILENT);
      this.quill.focus();
    }
  }], [{
    key: "match",
    value: function match(evt, binding) {
      var _context8;
      if ((0, _some["default"])(_context8 = ['altKey', 'ctrlKey', 'metaKey', 'shiftKey']).call(_context8, function (key) {
        return !!binding[key] !== evt[key] && binding[key] !== null;
      })) {
        return false;
      }
      return binding.key === evt.key || binding.key === evt.which;
    }
  }]);
  return Keyboard;
}(_module["default"]);
exports["default"] = Keyboard;
Keyboard.DEFAULTS = {
  bindings: {
    bold: makeFormatHandler('bold'),
    italic: makeFormatHandler('italic'),
    underline: makeFormatHandler('underline'),
    indent: {
      // highlight tab or tab at beginning of list, indent or blockquote
      key: 'Tab',
      format: ['blockquote', 'indent', 'list', 'orderedList'],
      handler: function handler(range, context) {
        if (context.collapsed && context.offset !== 0) return true;
        this.quill.format('indent', '+1', _quill["default"].sources.USER);
        return false;
      }
    },
    outdent: {
      key: 'Tab',
      shiftKey: true,
      format: ['blockquote', 'indent', 'list', 'orderedList'],
      // highlight tab or tab at beginning of list, indent or blockquote
      handler: function handler(range, context) {
        if (context.collapsed && context.offset !== 0) return true;
        this.quill.format('indent', '-1', _quill["default"].sources.USER);
        return false;
      }
    },
    'outdent backspace': {
      key: 'Backspace',
      collapsed: true,
      shiftKey: null,
      metaKey: null,
      ctrlKey: null,
      altKey: null,
      format: ['indent', 'list', 'orderedList'],
      offset: 0,
      handler: function handler(range, context) {
        if (context.format.indent != null) {
          this.quill.format('indent', '-1', _quill["default"].sources.USER);
        } else if (context.format.orderedList != null) {
          this.quill.format('orderedList', false, _quill["default"].sources.USER);
        } else if (context.format.list != null) {
          this.quill.format('list', false, _quill["default"].sources.USER);
        }
      }
    },
    'indent code-block': makeCodeBlockHandler(true),
    'outdent code-block': makeCodeBlockHandler(false),
    'remove tab': {
      key: 'Tab',
      shiftKey: true,
      collapsed: true,
      prefix: /\t$/,
      handler: function handler(range) {
        this.quill.deleteText(range.index - 1, 1, _quill["default"].sources.USER);
      }
    },
    tab: {
      key: 'Tab',
      handler: function handler(range, context) {
        if (context.format.table) return true;
        this.quill.history.cutoff();
        var delta = new _quillDelta["default"]().retain(range.index)["delete"](range.length).insert('\t');
        this.quill.updateContents(delta, _quill["default"].sources.USER);
        this.quill.history.cutoff();
        this.quill.setSelection(range.index + 1, _quill["default"].sources.SILENT);
        return false;
      }
    },
    'blockquote empty enter': {
      key: 'Enter',
      collapsed: true,
      format: ['blockquote'],
      empty: true,
      handler: function handler() {
        this.quill.format('blockquote', false, _quill["default"].sources.USER);
      }
    },
    'list empty enter': {
      key: 'Enter',
      collapsed: true,
      format: ['list', 'orderedList'],
      empty: true,
      handler: function handler(range, context) {
        var formats = context.format.orderedList ? {
          orderedList: false
        } : {
          list: false
        };
        if (context.format.indent) {
          formats.indent = false;
        }
        this.quill.formatLine(range.index, range.length, formats, _quill["default"].sources.USER);
      }
    },
    'checklist enter': {
      key: 'Enter',
      collapsed: true,
      format: {
        list: 'checked'
      },
      handler: function handler(range) {
        var _this$quill$getLine9 = this.quill.getLine(range.index),
          _this$quill$getLine10 = (0, _slicedToArray2["default"])(_this$quill$getLine9, 2),
          line = _this$quill$getLine10[0],
          offset = _this$quill$getLine10[1];
        var formats = (0, _assign["default"])((0, _assign["default"])({}, line.formats()), {
          list: 'checked'
        });
        var delta = new _quillDelta["default"]().retain(range.index).insert('\n', formats).retain(line.length() - offset - 1).retain(1, {
          list: 'unchecked'
        });
        this.quill.updateContents(delta, _quill["default"].sources.USER);
        this.quill.setSelection(range.index + 1, _quill["default"].sources.SILENT);
        this.quill.scrollIntoView();
      }
    },
    'header enter': {
      key: 'Enter',
      collapsed: true,
      format: ['header'],
      suffix: /^$/,
      handler: function handler(range, context) {
        var _this$quill$getLine11 = this.quill.getLine(range.index),
          _this$quill$getLine12 = (0, _slicedToArray2["default"])(_this$quill$getLine11, 2),
          line = _this$quill$getLine12[0],
          offset = _this$quill$getLine12[1];
        var delta = new _quillDelta["default"]().retain(range.index).insert('\n', context.format).retain(line.length() - offset - 1).retain(1, {
          header: null
        });
        this.quill.updateContents(delta, _quill["default"].sources.USER);
        this.quill.setSelection(range.index + 1, _quill["default"].sources.SILENT);
        this.quill.scrollIntoView();
      }
    },
    'table backspace': {
      key: 'Backspace',
      format: ['table'],
      collapsed: true,
      offset: 0,
      handler: function handler() {}
    },
    'table delete': {
      key: 'Delete',
      format: ['table'],
      collapsed: true,
      suffix: /^$/,
      handler: function handler() {}
    },
    'table enter': {
      key: 'Enter',
      shiftKey: null,
      format: ['table'],
      handler: function handler(range) {
        var module = this.quill.getModule('table');
        if (module) {
          var _module$getTable = module.getTable(range),
            _module$getTable2 = (0, _slicedToArray2["default"])(_module$getTable, 4),
            table = _module$getTable2[0],
            row = _module$getTable2[1],
            cell = _module$getTable2[2],
            offset = _module$getTable2[3];
          var shift = tableSide(table, row, cell, offset);
          if (shift == null) return;
          var index = table.offset();
          if (shift < 0) {
            var delta = new _quillDelta["default"]().retain(index).insert('\n');
            this.quill.updateContents(delta, _quill["default"].sources.USER);
            this.quill.setSelection(range.index + 1, range.length, _quill["default"].sources.SILENT);
          } else if (shift > 0) {
            index += table.length();
            var _delta = new _quillDelta["default"]().retain(index).insert('\n');
            this.quill.updateContents(_delta, _quill["default"].sources.USER);
            this.quill.setSelection(index, _quill["default"].sources.USER);
          }
        }
      }
    },
    'table tab': {
      key: 'Tab',
      shiftKey: null,
      format: ['table'],
      handler: function handler(range, context) {
        var event = context.event,
          cell = context.line;
        var offset = cell.offset(this.quill.scroll);
        if (event.shiftKey) {
          this.quill.setSelection(offset - 1, _quill["default"].sources.USER);
        } else {
          this.quill.setSelection(offset + cell.length(), _quill["default"].sources.USER);
        }
      }
    },
    'list autofill': {
      key: ' ',
      shiftKey: null,
      collapsed: true,
      format: {
        'code-block': false,
        blockquote: false,
        table: false
      },
      prefix: /^\s*?(\d+\.|-|\*|\[ ?\]|\[x\])$/,
      handler: function handler(range, context) {
        var _context9;
        if (this.quill.scroll.query('list') == null) return true;
        var length = context.prefix.length;
        var _this$quill$getLine13 = this.quill.getLine(range.index),
          _this$quill$getLine14 = (0, _slicedToArray2["default"])(_this$quill$getLine13, 2),
          line = _this$quill$getLine14[0],
          offset = _this$quill$getLine14[1];
        if (offset > length) return true;
        var value;
        switch ((0, _trim["default"])(_context9 = context.prefix).call(_context9)) {
          case '[]':
          case '[ ]':
            value = 'unchecked';
            break;
          case '[x]':
            value = 'checked';
            break;
          case '-':
          case '*':
            value = 'bullet';
            break;
          default:
            value = 'ordered';
        }
        this.quill.insertText(range.index, ' ', _quill["default"].sources.USER);
        this.quill.history.cutoff();
        var delta = new _quillDelta["default"]().retain(range.index - offset)["delete"](length + 1).retain(line.length() - 2 - offset).retain(1, value === 'ordered' ? {
          'orderedList': 'ordered'
        } : {
          list: value
        });
        this.quill.updateContents(delta, _quill["default"].sources.USER);
        this.quill.history.cutoff();
        this.quill.setSelection(range.index - length, _quill["default"].sources.SILENT);
        return false;
      }
    },
    'code exit': {
      key: 'Enter',
      collapsed: true,
      format: ['code-block'],
      prefix: /^$/,
      suffix: /^\s*$/,
      handler: function handler(range) {
        var _this$quill$getLine15 = this.quill.getLine(range.index),
          _this$quill$getLine16 = (0, _slicedToArray2["default"])(_this$quill$getLine15, 2),
          line = _this$quill$getLine16[0],
          offset = _this$quill$getLine16[1];
        var numLines = 2;
        var cur = line;
        while (cur != null && cur.length() <= 1 && cur.formats()['code-block']) {
          cur = cur.prev;
          numLines -= 1;
          // Requisite prev lines are empty
          if (numLines <= 0) {
            var delta = new _quillDelta["default"]().retain(range.index + line.length() - offset - 2).retain(1, {
              'code-block': null
            })["delete"](1);
            this.quill.updateContents(delta, _quill["default"].sources.USER);
            this.quill.setSelection(range.index - 1, _quill["default"].sources.SILENT);
            return false;
          }
        }
        return true;
      }
    },
    'embed left': makeEmbedArrowHandler('ArrowLeft', false),
    'embed left shift': makeEmbedArrowHandler('ArrowLeft', true),
    'embed right': makeEmbedArrowHandler('ArrowRight', false),
    'embed right shift': makeEmbedArrowHandler('ArrowRight', true),
    'table down': makeTableArrowHandler(false),
    'table up': makeTableArrowHandler(true)
  }
};
function makeCodeBlockHandler(indent) {
  return {
    key: 'Tab',
    shiftKey: !indent,
    format: {
      'code-block': true
    },
    handler: function handler(range) {
      var CodeBlock = this.quill.scroll.query('code-block');
      var lines = range.length === 0 ? this.quill.getLines(range.index, 1) : this.quill.getLines(range);
      var index = range.index,
        length = range.length;
      (0, _forEach["default"])(lines).call(lines, function (line, i) {
        var _context10;
        if (indent) {
          line.insertAt(0, CodeBlock.TAB);
          if (i === 0) {
            index += CodeBlock.TAB.length;
          } else {
            length += CodeBlock.TAB.length;
          }
        } else if ((0, _startsWith["default"])(_context10 = line.domNode.textContent).call(_context10, CodeBlock.TAB)) {
          line.deleteAt(0, CodeBlock.TAB.length);
          if (i === 0) {
            index -= CodeBlock.TAB.length;
          } else {
            length -= CodeBlock.TAB.length;
          }
        }
      });
      this.quill.update(_quill["default"].sources.USER);
      this.quill.setSelection(index, length, _quill["default"].sources.SILENT);
    }
  };
}
function makeEmbedArrowHandler(key, shiftKey) {
  var _ref3;
  var where = key === 'ArrowLeft' ? 'prefix' : 'suffix';
  return _ref3 = {
    key: key,
    shiftKey: shiftKey,
    altKey: null
  }, (0, _defineProperty2["default"])(_ref3, where, /^$/), (0, _defineProperty2["default"])(_ref3, "handler", function handler(range) {
    var index = range.index;
    if (key === 'ArrowRight') {
      index += range.length + 1;
    }
    var _this$quill$getLeaf = this.quill.getLeaf(index),
      _this$quill$getLeaf2 = (0, _slicedToArray2["default"])(_this$quill$getLeaf, 1),
      leaf = _this$quill$getLeaf2[0];
    if (!(leaf instanceof _parchment.EmbedBlot)) return true;
    if (key === 'ArrowLeft') {
      if (shiftKey) {
        this.quill.setSelection(range.index - 1, range.length + 1, _quill["default"].sources.USER);
      } else {
        this.quill.setSelection(range.index - 1, _quill["default"].sources.USER);
      }
    } else if (shiftKey) {
      this.quill.setSelection(range.index, range.length + 1, _quill["default"].sources.USER);
    } else {
      this.quill.setSelection(range.index + range.length + 1, _quill["default"].sources.USER);
    }
    return false;
  }), _ref3;
}
function makeFormatHandler(format) {
  return {
    key: format[0],
    shortKey: true,
    handler: function handler(range, context) {
      this.quill.format(format, !context.format[format], _quill["default"].sources.USER);
    }
  };
}
function makeTableArrowHandler(up) {
  return {
    key: up ? 'ArrowUp' : 'ArrowDown',
    collapsed: true,
    format: ['table'],
    handler: function handler(range, context) {
      // TODO move to table module
      var key = up ? 'prev' : 'next';
      var cell = context.line;
      var targetRow = cell.parent[key];
      if (targetRow != null) {
        if (targetRow.statics.blotName === 'table-row') {
          var targetCell = targetRow.children.head;
          var cur = cell;
          while (cur.prev != null) {
            cur = cur.prev;
            targetCell = targetCell.next;
          }
          var index = targetCell.offset(this.quill.scroll) + Math.min(context.offset, targetCell.length() - 1);
          this.quill.setSelection(index, 0, _quill["default"].sources.USER);
        }
      } else {
        var targetLine = cell.table()[key];
        if (targetLine != null) {
          if (up) {
            this.quill.setSelection(targetLine.offset(this.quill.scroll) + targetLine.length() - 1, 0, _quill["default"].sources.USER);
          } else {
            this.quill.setSelection(targetLine.offset(this.quill.scroll), 0, _quill["default"].sources.USER);
          }
        }
      }
      return false;
    }
  };
}
function normalize(binding) {
  if (typeof binding === 'string' || typeof binding === 'number') {
    binding = {
      key: binding
    };
  } else if ((0, _typeof2["default"])(binding) === 'object') {
    binding = (0, _cloneDeep["default"])(binding);
  } else {
    return null;
  }
  if (binding.shortKey) {
    binding[SHORTKEY] = binding.shortKey;
    delete binding.shortKey;
  }
  return binding;
}
// TODO: Move into quill.js or editor.js
function deleteRange(_ref4) {
  var quill = _ref4.quill,
    range = _ref4.range;
  var lines = quill.getLines(range);
  var formats = {};
  if (lines.length > 1) {
    var firstFormats = lines[0].formats();
    var lastFormats = lines[lines.length - 1].formats();
    formats = _quillDelta.AttributeMap.diff(lastFormats, firstFormats) || {};
  }
  quill.deleteText(range, _quill["default"].sources.USER);
  if ((0, _keys["default"])(formats).length > 0) {
    quill.formatLine(range.index, 1, formats, _quill["default"].sources.USER);
  }
  quill.setSelection(range.index, _quill["default"].sources.SILENT);
}
function tableSide(table, row, cell, offset) {
  if (row.prev == null && row.next == null) {
    if (cell.prev == null && cell.next == null) {
      return offset === 0 ? -1 : 1;
    }
    return cell.prev == null ? -1 : 1;
  }
  if (row.prev == null) {
    return -1;
  }
  if (row.next == null) {
    return 1;
  }
  return null;
}