"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addControls = addControls;
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));
var _find = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _quillDelta = _interopRequireDefault(require("quill-delta"));
var _parchment = require("parchment");
var _quill = _interopRequireDefault(require("../core/quill"));
var _logger = _interopRequireDefault(require("../core/logger"));
var _module = _interopRequireDefault(require("../core/module"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var debug = (0, _logger["default"])('quill:toolbar');
var Toolbar = /*#__PURE__*/function (_Module) {
  (0, _inherits2["default"])(Toolbar, _Module);
  var _super = _createSuper(Toolbar);
  function Toolbar(quill, options) {
    var _context, _context2;
    var _this;
    (0, _classCallCheck2["default"])(this, Toolbar);
    _this = _super.call(this, quill, options);
    if ((0, _isArray["default"])(_this.options.container)) {
      var container = document.createElement('div');
      addControls(container, _this.options.container);
      quill.container.parentNode.insertBefore(container, quill.container);
      _this.container = container;
    } else if (typeof _this.options.container === 'string') {
      _this.container = document.querySelector(_this.options.container);
    } else {
      _this.container = _this.options.container;
    }
    if (!(_this.container instanceof HTMLElement)) {
      return (0, _possibleConstructorReturn2["default"])(_this, debug.error('Container required for toolbar', _this.options));
    }
    _this.container.classList.add('ql-toolbar');
    _this.controls = [];
    _this.handlers = {};
    (0, _forEach["default"])(_context = (0, _keys["default"])(_this.options.handlers)).call(_context, function (format) {
      _this.addHandler(format, _this.options.handlers[format]);
    });
    (0, _forEach["default"])(_context2 = (0, _from["default"])(_this.container.querySelectorAll('button, select'))).call(_context2, function (input) {
      _this.attach(input);
    });
    _this.quill.on(_quill["default"].events.EDITOR_CHANGE, function (type, range) {
      if (type === _quill["default"].events.SELECTION_CHANGE) {
        _this.update(range);
      }
    });
    _this.quill.on(_quill["default"].events.SCROLL_OPTIMIZE, function () {
      var _this$quill$selection = _this.quill.selection.getRange(),
        _this$quill$selection2 = (0, _slicedToArray2["default"])(_this$quill$selection, 1),
        range = _this$quill$selection2[0]; // quill.getSelection triggers update
      _this.update(range);
    });
    return _this;
  }
  (0, _createClass2["default"])(Toolbar, [{
    key: "addHandler",
    value: function addHandler(format, handler) {
      this.handlers[format] = handler;
    }
  }, {
    key: "attach",
    value: function attach(input) {
      var _context3,
        _this2 = this;
      var format = (0, _find["default"])(_context3 = (0, _from["default"])(input.classList)).call(_context3, function (className) {
        return (0, _indexOf["default"])(className).call(className, 'ql-') === 0;
      });
      if (!format) return;
      format = (0, _slice["default"])(format).call(format, 'ql-'.length);
      if (input.tagName === 'BUTTON') {
        input.setAttribute('type', 'button');
      }
      if (this.handlers[format] == null && this.quill.scroll.query(format) == null) {
        debug.warn('ignoring attaching to nonexistent format', format, input);
        return;
      }
      var eventName = input.tagName === 'SELECT' ? 'change' : 'click';
      input.addEventListener(eventName, function (e) {
        var value;
        if (input.tagName === 'SELECT') {
          if (input.selectedIndex < 0) return;
          var selected = input.options[input.selectedIndex];
          if (selected.hasAttribute('selected')) {
            value = false;
          } else {
            value = selected.value || false;
          }
        } else {
          if (input.classList.contains('ql-active')) {
            value = false;
          } else {
            value = input.value || !input.hasAttribute('value');
          }
          e.preventDefault();
        }
        _this2.quill.focus();
        var _this2$quill$selectio = _this2.quill.selection.getRange(),
          _this2$quill$selectio2 = (0, _slicedToArray2["default"])(_this2$quill$selectio, 1),
          range = _this2$quill$selectio2[0];
        if (_this2.handlers[format] != null) {
          _this2.handlers[format].call(_this2, value);
        } else if (_this2.quill.scroll.query(format).prototype instanceof _parchment.EmbedBlot) {
          value = prompt("Enter ".concat(format)); // eslint-disable-line no-alert
          if (!value) return;
          _this2.quill.updateContents(new _quillDelta["default"]().retain(range.index)["delete"](range.length).insert((0, _defineProperty2["default"])({}, format, value)), _quill["default"].sources.USER);
        } else {
          _this2.quill.format(format, value, _quill["default"].sources.USER);
        }
        _this2.update(range);
      });
      this.controls.push([format, input]);
    }
  }, {
    key: "update",
    value: function update(range) {
      var _context4;
      var formats = range == null ? {} : this.quill.getFormat(range);
      (0, _forEach["default"])(_context4 = this.controls).call(_context4, function (pair) {
        var _pair = (0, _slicedToArray2["default"])(pair, 2),
          format = _pair[0],
          input = _pair[1];
        if (input.tagName === 'SELECT') {
          var option;
          if (range == null) {
            option = null;
          } else if (formats[format] == null) {
            option = input.querySelector('option[selected]');
          } else if (!(0, _isArray["default"])(formats[format])) {
            var value = formats[format];
            if (typeof value === 'string') {
              value = value.replace(/"/g, '\\"');
            }
            option = input.querySelector("option[value=\"".concat(value, "\"]"));
          }
          if (option == null) {
            input.value = ''; // TODO make configurable?
            input.selectedIndex = -1;
          } else {
            option.selected = true;
          }
        } else if (range == null) {
          input.classList.remove('ql-active');
        } else if (input.hasAttribute('value')) {
          // both being null should match (default values)
          // '1' should match with 1 (headers)
          // 针对 orderedList 的特殊判断, 为了不修改 toolbar 的外层配置在此加上兼容
          if (formats.orderedList && format === 'list') {
            format = 'orderedList';
          }
          var isActive = formats[format] === input.getAttribute('value') || formats[format] != null && formats[format].toString() === input.getAttribute('value') || formats[format] == null && !input.getAttribute('value');
          input.classList.toggle('ql-active', isActive);
        } else {
          input.classList.toggle('ql-active', formats[format] != null);
        }
      });
    }
  }]);
  return Toolbar;
}(_module["default"]);
exports["default"] = Toolbar;
Toolbar.DEFAULTS = {};
function addButton(container, format, value) {
  var input = document.createElement('button');
  input.setAttribute('type', 'button');
  input.classList.add("ql-".concat(format));
  if (value != null) {
    input.value = value;
  }
  container.appendChild(input);
}
function addControls(container, groups) {
  if (!(0, _isArray["default"])(groups[0])) {
    groups = [groups];
  }
  (0, _forEach["default"])(groups).call(groups, function (controls) {
    var group = document.createElement('span');
    group.classList.add('ql-formats');
    (0, _forEach["default"])(controls).call(controls, function (control) {
      if (typeof control === 'string') {
        addButton(group, control);
      } else {
        var format = (0, _keys["default"])(control)[0];
        var value = control[format];
        if ((0, _isArray["default"])(value)) {
          addSelect(group, format, value);
        } else {
          addButton(group, format, value);
        }
      }
    });
    container.appendChild(group);
  });
}
function addSelect(container, format, values) {
  var input = document.createElement('select');
  input.classList.add("ql-".concat(format));
  (0, _forEach["default"])(values).call(values, function (value) {
    var option = document.createElement('option');
    if (value !== false) {
      option.setAttribute('value', value);
    } else {
      option.setAttribute('selected', 'selected');
    }
    input.appendChild(option);
  });
  container.appendChild(input);
}
Toolbar.DEFAULTS = {
  container: null,
  handlers: {
    clean: function clean() {
      var _this3 = this;
      var range = this.quill.getSelection();
      if (range == null) return;
      if (range.length === 0) {
        var _context5;
        var formats = this.quill.getFormat();
        (0, _forEach["default"])(_context5 = (0, _keys["default"])(formats)).call(_context5, function (name) {
          // Clean functionality in existing apps only clean inline formats
          if (_this3.quill.scroll.query(name, _parchment.Scope.INLINE) != null) {
            _this3.quill.format(name, false, _quill["default"].sources.USER);
          }
        });
      } else {
        this.quill.removeFormat(range, _quill["default"].sources.USER);
      }
    },
    direction: function direction(value) {
      var _this$quill$getFormat = this.quill.getFormat(),
        align = _this$quill$getFormat.align;
      if (value === 'rtl' && align == null) {
        this.quill.format('align', 'right', _quill["default"].sources.USER);
      } else if (!value && align === 'right') {
        this.quill.format('align', false, _quill["default"].sources.USER);
      }
      this.quill.format('direction', value, _quill["default"].sources.USER);
    },
    indent: function indent(value) {
      var range = this.quill.getSelection();
      var formats = this.quill.getFormat(range);
      var indent = (0, _parseInt2["default"])(formats.indent || 0, 10);
      if (value === '+1' || value === '-1') {
        var modifier = value === '+1' ? 1 : -1;
        if (formats.direction === 'rtl') modifier *= -1;
        this.quill.format('indent', indent + modifier, _quill["default"].sources.USER);
      }
    },
    link: function link(value) {
      if (value === true) {
        value = prompt('Enter link URL:'); // eslint-disable-line no-alert
      }

      this.quill.format('link', value, _quill["default"].sources.USER);
    },
    list: function list(value) {
      var range = this.quill.getSelection();
      var formats = this.quill.getFormat(range);
      if (value === 'check') {
        if (formats.list === 'checked' || formats.list === 'unchecked') {
          this.quill.format('list', false, _quill["default"].sources.USER);
        } else {
          this.quill.format('list', 'unchecked', _quill["default"].sources.USER);
        }
      } else {
        if (value === 'ordered') {
          this.quill.format('orderedList', value, _quill["default"].sources.USER);
        } else {
          this.quill.format('list', value, _quill["default"].sources.USER);
        }
      }
    }
  }
};