"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _core = _interopRequireDefault(require("./core"));
var _align = require("./formats/align");
var _direction = require("./formats/direction");
var _indent = _interopRequireDefault(require("./formats/indent"));
var _blockquote = _interopRequireDefault(require("./formats/blockquote"));
var _header = _interopRequireDefault(require("./formats/header"));
var _list = _interopRequireDefault(require("./formats/list"));
var _orderedList = _interopRequireDefault(require("./formats/orderedList"));
var _background = require("./formats/background");
var _color = require("./formats/color");
var _font = require("./formats/font");
var _size = require("./formats/size");
var _bold = _interopRequireDefault(require("./formats/bold"));
var _italic = _interopRequireDefault(require("./formats/italic"));
var _link = _interopRequireDefault(require("./formats/link"));
var _script = _interopRequireDefault(require("./formats/script"));
var _strike = _interopRequireDefault(require("./formats/strike"));
var _underline = _interopRequireDefault(require("./formats/underline"));
var _formula = _interopRequireDefault(require("./formats/formula"));
var _image = _interopRequireDefault(require("./formats/image"));
var _video = _interopRequireDefault(require("./formats/video"));
var _code = _interopRequireWildcard(require("./formats/code"));
var _syntax = _interopRequireDefault(require("./modules/syntax"));
var _table = _interopRequireDefault(require("./modules/table"));
var _toolbar = _interopRequireDefault(require("./modules/toolbar"));
var _icons = _interopRequireDefault(require("./ui/icons"));
var _picker = _interopRequireDefault(require("./ui/picker"));
var _colorPicker = _interopRequireDefault(require("./ui/color-picker"));
var _iconPicker = _interopRequireDefault(require("./ui/icon-picker"));
var _tooltip = _interopRequireDefault(require("./ui/tooltip"));
var _snow = _interopRequireDefault(require("./themes/snow"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
_core["default"].register({
  'attributors/attribute/direction': _direction.DirectionAttribute,
  'attributors/class/align': _align.AlignClass,
  'attributors/class/background': _background.BackgroundClass,
  'attributors/class/color': _color.ColorClass,
  'attributors/class/direction': _direction.DirectionClass,
  'attributors/class/font': _font.FontClass,
  'attributors/class/size': _size.SizeClass,
  'attributors/style/align': _align.AlignStyle,
  'attributors/style/background': _background.BackgroundStyle,
  'attributors/style/color': _color.ColorStyle,
  'attributors/style/direction': _direction.DirectionStyle,
  'attributors/style/font': _font.FontStyle,
  'attributors/style/size': _size.SizeStyle
}, true);
_core["default"].register({
  'formats/align': _align.AlignClass,
  'formats/direction': _direction.DirectionClass,
  'formats/indent': _indent["default"],
  'formats/background': _background.BackgroundStyle,
  'formats/color': _color.ColorStyle,
  'formats/font': _font.FontClass,
  'formats/size': _size.SizeClass,
  'formats/blockquote': _blockquote["default"],
  'formats/code-block': _code["default"],
  'formats/header': _header["default"],
  'formats/list': _list["default"],
  'formats/orderedList': _orderedList["default"],
  'formats/bold': _bold["default"],
  'formats/code': _code.Code,
  'formats/italic': _italic["default"],
  'formats/link': _link["default"],
  'formats/script': _script["default"],
  'formats/strike': _strike["default"],
  'formats/underline': _underline["default"],
  'formats/formula': _formula["default"],
  'formats/image': _image["default"],
  'formats/video': _video["default"],
  'modules/syntax': _syntax["default"],
  'modules/table': _table["default"],
  'modules/toolbar': _toolbar["default"],
  'themes/snow': _snow["default"],
  'ui/icons': _icons["default"],
  'ui/picker': _picker["default"],
  'ui/icon-picker': _iconPicker["default"],
  'ui/color-picker': _colorPicker["default"],
  'ui/tooltip': _tooltip["default"]
}, true);
var _default = _core["default"];
exports["default"] = _default;