"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.BaseTooltip = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));
var _startsWith = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/starts-with"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _merge = _interopRequireDefault(require("lodash/merge"));
var _emitter = _interopRequireDefault(require("../core/emitter"));
var _theme = _interopRequireDefault(require("../core/theme"));
var _colorPicker = _interopRequireDefault(require("../ui/color-picker"));
var _iconPicker = _interopRequireDefault(require("../ui/icon-picker"));
var _picker = _interopRequireDefault(require("../ui/picker"));
var _tooltip = _interopRequireDefault(require("../ui/tooltip"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var ALIGNS = [false, 'center', 'right', 'justify'];
var COLORS = ['#000000', '#e60000', '#ff9900', '#ffff00', '#008a00', '#0066cc', '#9933ff', '#ffffff', '#facccc', '#ffebcc', '#ffffcc', '#cce8cc', '#cce0f5', '#ebd6ff', '#bbbbbb', '#f06666', '#ffc266', '#ffff66', '#66b966', '#66a3e0', '#c285ff', '#888888', '#a10000', '#b26b00', '#b2b200', '#006100', '#0047b2', '#6b24b2', '#444444', '#5c0000', '#663d00', '#666600', '#003700', '#002966', '#3d1466'];
var FONTS = [false, 'serif', 'monospace'];
var HEADERS = ['1', '2', '3', false];
var SIZES = ['small', false, 'large', 'huge'];
var BaseTheme = /*#__PURE__*/function (_Theme) {
  (0, _inherits2["default"])(BaseTheme, _Theme);
  var _super = _createSuper(BaseTheme);
  function BaseTheme(quill, options) {
    var _this;
    (0, _classCallCheck2["default"])(this, BaseTheme);
    _this = _super.call(this, quill, options);
    var listener = function listener(e) {
      if (!document.body.contains(quill.root)) {
        document.body.removeEventListener('click', listener);
        return;
      }
      if (_this.tooltip != null && !_this.tooltip.root.contains(e.target) && document.activeElement !== _this.tooltip.textbox && !_this.quill.hasFocus()) {
        _this.tooltip.hide();
      }
      if (_this.pickers != null) {
        var _context;
        (0, _forEach["default"])(_context = _this.pickers).call(_context, function (picker) {
          if (!picker.container.contains(e.target)) {
            picker.close();
          }
        });
      }
    };
    quill.emitter.listenDOM('click', document.body, listener);
    return _this;
  }
  (0, _createClass2["default"])(BaseTheme, [{
    key: "addModule",
    value: function addModule(name) {
      var module = (0, _get2["default"])((0, _getPrototypeOf2["default"])(BaseTheme.prototype), "addModule", this).call(this, name);
      if (name === 'toolbar') {
        this.extendToolbar(module);
      }
      return module;
    }
  }, {
    key: "buildButtons",
    value: function buildButtons(buttons, icons) {
      var _context2;
      (0, _forEach["default"])(_context2 = (0, _from["default"])(buttons)).call(_context2, function (button) {
        var _context3;
        var className = button.getAttribute('class') || '';
        (0, _forEach["default"])(_context3 = className.split(/\s+/)).call(_context3, function (name) {
          if (!(0, _startsWith["default"])(name).call(name, 'ql-')) return;
          name = (0, _slice["default"])(name).call(name, 'ql-'.length);
          if (icons[name] == null) return;
          if (name === 'direction') {
            button.innerHTML = icons[name][''] + icons[name].rtl;
          } else if (typeof icons[name] === 'string') {
            button.innerHTML = icons[name];
          } else {
            var value = button.value || '';
            if (value != null && icons[name][value]) {
              button.innerHTML = icons[name][value];
            }
          }
        });
      });
    }
  }, {
    key: "buildPickers",
    value: function buildPickers(selects, icons) {
      var _context4,
        _this2 = this;
      this.pickers = (0, _map["default"])(_context4 = (0, _from["default"])(selects)).call(_context4, function (select) {
        if (select.classList.contains('ql-align')) {
          if (select.querySelector('option') == null) {
            fillSelect(select, ALIGNS);
          }
          return new _iconPicker["default"](select, icons.align);
        }
        if (select.classList.contains('ql-background') || select.classList.contains('ql-color')) {
          var format = select.classList.contains('ql-background') ? 'background' : 'color';
          if (select.querySelector('option') == null) {
            fillSelect(select, COLORS, format === 'background' ? '#ffffff' : '#000000');
          }
          return new _colorPicker["default"](select, icons[format]);
        }
        if (select.querySelector('option') == null) {
          if (select.classList.contains('ql-font')) {
            fillSelect(select, FONTS);
          } else if (select.classList.contains('ql-header')) {
            fillSelect(select, HEADERS);
          } else if (select.classList.contains('ql-size')) {
            fillSelect(select, SIZES);
          }
        }
        return new _picker["default"](select);
      });
      var update = function update() {
        var _context5;
        (0, _forEach["default"])(_context5 = _this2.pickers).call(_context5, function (picker) {
          picker.update();
        });
      };
      this.quill.on(_emitter["default"].events.EDITOR_CHANGE, update);
    }
  }]);
  return BaseTheme;
}(_theme["default"]);
exports["default"] = BaseTheme;
BaseTheme.DEFAULTS = (0, _merge["default"])({}, _theme["default"].DEFAULTS, {
  modules: {
    toolbar: {
      handlers: {
        formula: function formula() {
          this.quill.theme.tooltip.edit('formula');
        },
        image: function image() {
          var _this3 = this;
          var fileInput = this.container.querySelector('input.ql-image[type=file]');
          if (fileInput == null) {
            fileInput = document.createElement('input');
            fileInput.setAttribute('type', 'file');
            fileInput.setAttribute('accept', this.quill.uploader.options.mimetypes.join(', '));
            fileInput.classList.add('ql-image');
            fileInput.addEventListener('change', function () {
              var range = _this3.quill.getSelection(true);
              _this3.quill.uploader.upload(range, fileInput.files);
              fileInput.value = '';
            });
            this.container.appendChild(fileInput);
          }
          fileInput.click();
        },
        video: function video() {
          this.quill.theme.tooltip.edit('video');
        }
      }
    }
  }
});
var BaseTooltip = /*#__PURE__*/function (_Tooltip) {
  (0, _inherits2["default"])(BaseTooltip, _Tooltip);
  var _super2 = _createSuper(BaseTooltip);
  function BaseTooltip(quill, boundsContainer) {
    var _this4;
    (0, _classCallCheck2["default"])(this, BaseTooltip);
    _this4 = _super2.call(this, quill, boundsContainer);
    _this4.textbox = _this4.root.querySelector('input[type="text"]');
    _this4.listen();
    return _this4;
  }
  (0, _createClass2["default"])(BaseTooltip, [{
    key: "listen",
    value: function listen() {
      var _this5 = this;
      this.textbox.addEventListener('keydown', function (event) {
        if (event.key === 'Enter') {
          _this5.save();
          event.preventDefault();
        } else if (event.key === 'Escape') {
          _this5.cancel();
          event.preventDefault();
        }
      });
    }
  }, {
    key: "cancel",
    value: function cancel() {
      this.hide();
    }
  }, {
    key: "edit",
    value: function edit() {
      var mode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'link';
      var preview = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      this.root.classList.remove('ql-hidden');
      this.root.classList.add('ql-editing');
      if (preview != null) {
        this.textbox.value = preview;
      } else if (mode !== this.root.getAttribute('data-mode')) {
        this.textbox.value = '';
      }
      this.position(this.quill.getBounds(this.quill.selection.savedRange));
      this.textbox.select();
      this.textbox.setAttribute('placeholder', this.textbox.getAttribute("data-".concat(mode)) || '');
      this.root.setAttribute('data-mode', mode);
    }
  }, {
    key: "restoreFocus",
    value: function restoreFocus() {
      var scrollTop = this.quill.scrollingContainer.scrollTop;
      this.quill.focus();
      this.quill.scrollingContainer.scrollTop = scrollTop;
    }
  }, {
    key: "save",
    value: function save() {
      var value = this.textbox.value;
      switch (this.root.getAttribute('data-mode')) {
        case 'link':
          {
            var scrollTop = this.quill.root.scrollTop;
            if (this.linkRange) {
              this.quill.formatText(this.linkRange, 'link', value, _emitter["default"].sources.USER);
              delete this.linkRange;
            } else {
              this.restoreFocus();
              this.quill.format('link', value, _emitter["default"].sources.USER);
            }
            this.quill.root.scrollTop = scrollTop;
            break;
          }
        case 'video':
          {
            value = extractVideoUrl(value);
          }
        // eslint-disable-next-line no-fallthrough
        case 'formula':
          {
            if (!value) break;
            var range = this.quill.getSelection(true);
            if (range != null) {
              var index = range.index + range.length;
              this.quill.insertEmbed(index, this.root.getAttribute('data-mode'), value, _emitter["default"].sources.USER);
              if (this.root.getAttribute('data-mode') === 'formula') {
                this.quill.insertText(index + 1, ' ', _emitter["default"].sources.USER);
              }
              this.quill.setSelection(index + 2, _emitter["default"].sources.USER);
            }
            break;
          }
        default:
      }
      this.textbox.value = '';
      this.hide();
    }
  }]);
  return BaseTooltip;
}(_tooltip["default"]);
exports.BaseTooltip = BaseTooltip;
function extractVideoUrl(url) {
  var match = url.match(/^(?:(https?):\/\/)?(?:(?:www|m)\.)?youtube\.com\/watch.*v=([a-zA-Z0-9_-]+)/) || url.match(/^(?:(https?):\/\/)?(?:(?:www|m)\.)?youtu\.be\/([a-zA-Z0-9_-]+)/);
  if (match) {
    var _context6;
    return (0, _concat["default"])(_context6 = "".concat(match[1] || 'https', "://www.youtube.com/embed/")).call(_context6, match[2], "?showinfo=0");
  }
  // eslint-disable-next-line no-cond-assign
  if (match = url.match(/^(?:(https?):\/\/)?(?:www\.)?vimeo\.com\/(\d+)/)) {
    var _context7;
    return (0, _concat["default"])(_context7 = "".concat(match[1] || 'https', "://player.vimeo.com/video/")).call(_context7, match[2], "/");
  }
  return url;
}
function fillSelect(select, values) {
  var defaultValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  (0, _forEach["default"])(values).call(values, function (value) {
    var option = document.createElement('option');
    if (value === defaultValue) {
      option.setAttribute('selected', 'selected');
    } else {
      option.setAttribute('value', value);
    }
    select.appendChild(option);
  });
}