"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var Tooltip = /*#__PURE__*/function () {
  function Tooltip(quill, boundsContainer) {
    var _this = this;
    (0, _classCallCheck2["default"])(this, Tooltip);
    this.quill = quill;
    this.boundsContainer = boundsContainer || document.body;
    this.root = quill.addContainer('ql-tooltip');
    this.root.innerHTML = this.constructor.TEMPLATE;
    if (this.quill.root === this.quill.scrollingContainer) {
      this.quill.root.addEventListener('scroll', function () {
        _this.root.style.marginTop = "".concat(-1 * _this.quill.root.scrollTop, "px");
      });
    }
    this.hide();
  }
  (0, _createClass2["default"])(Tooltip, [{
    key: "hide",
    value: function hide() {
      this.root.classList.add('ql-hidden');
    }
  }, {
    key: "position",
    value: function position(reference) {
      var left = reference.left + reference.width / 2 - this.root.offsetWidth / 2;
      // root.scrollTop should be 0 if scrollContainer !== root
      var top = reference.bottom + this.quill.root.scrollTop;
      this.root.style.left = "".concat(left, "px");
      this.root.style.top = "".concat(top, "px");
      this.root.classList.remove('ql-flip');
      var containerBounds = this.boundsContainer.getBoundingClientRect();
      var rootBounds = this.root.getBoundingClientRect();
      var shift = 0;
      if (rootBounds.right > containerBounds.right) {
        shift = containerBounds.right - rootBounds.right;
        this.root.style.left = "".concat(left + shift, "px");
      }
      if (rootBounds.left < containerBounds.left) {
        shift = containerBounds.left - rootBounds.left;
        this.root.style.left = "".concat(left + shift, "px");
      }
      if (rootBounds.bottom > containerBounds.bottom) {
        var height = rootBounds.bottom - rootBounds.top;
        var verticalShift = reference.bottom - reference.top + height;
        this.root.style.top = "".concat(top - verticalShift, "px");
        this.root.classList.add('ql-flip');
      }
      return shift;
    }
  }, {
    key: "show",
    value: function show() {
      this.root.classList.remove('ql-editing');
      this.root.classList.remove('ql-hidden');
    }
  }]);
  return Tooltip;
}();
var _default = Tooltip;
exports["default"] = _default;