import * as React from 'react';
import { PureComponent } from 'react';
import { CustomToolbarProps, CustomToolbarState } from './interface';
declare module 'react' {
    interface ImgHTMLAttributes<T> {
        value?: string;
    }
}
declare class CustomToolbar extends PureComponent<CustomToolbarProps, CustomToolbarState> {
    static defaultProps: {
        className: string;
        iconPrefix: string;
        toolbar: any[];
        customEmoji: any[];
        customLink: {};
        customInsertValue: {};
        prefixCls: string;
        popoverPlacement: string;
        tooltipPlacement: string;
        formatPainterActive: boolean;
        insertTableDisabled: boolean;
        getPopupContainer: () => HTMLElement;
    };
    private defaultSizes;
    private defaultLineHeight;
    private curSizeList;
    private curInsertValueList;
    private Locale;
    toolbarCtner: HTMLDivElement;
    constructor(props: CustomToolbarProps);
    componentDidMount(): void;
    handleIVSearchChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    handleClearIVSearch: () => void;
    getModuleHTML: (mType: any, key: any) => JSX.Element;
    handleLineHeightItemClick: (e: any) => void;
    handleFormatPainterClick: () => void;
    handleSizeItemClick: (e: any) => void;
    genToolbar: (toolbar: any) => any[];
    handleSizePopoverVisibleChange: (visible: boolean) => void;
    handleTablePopoverVisibleChange: (visible: boolean) => void;
    handleTableInsertPopover: (row: number, col: number) => void;
    handleLineHeightPopoverVisibleChange: (visible: any) => void;
    render(): JSX.Element;
}
export default CustomToolbar;
