"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _findIndex = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find-index"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _stringify = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/json/stringify"));
var _sort = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/sort"));
var _react = _interopRequireDefault(require("react"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _Modal = _interopRequireDefault(require("../Modal"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Tooltip = _interopRequireDefault(require("../Tooltip"));
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var CheckboxGroup = _Checkbox["default"].Group;
var getColumnKey = function getColumnKey(column) {
  if ('colSpan' in column) {
    return column.filtrateTitle || column.title;
  } else {
    return column.key || column.dataIndex || column.filtrateTitle || column.title;
  }
};
var flatten = function flatten(arr) {
  return (0, _reduce["default"])(arr).call(arr, function (prev, next) {
    return (0, _concat["default"])(prev).call(prev, (0, _isArray["default"])(next) ? flatten(next) : next);
  }, []);
};
var getCheckedOptions = function getCheckedOptions(columns, hideColumns) {
  var _context, _context2;
  return (0, _map["default"])(_context = (0, _filter["default"])(_context2 = (0, _filter["default"])(columns
  // 去除表头合并不显示的列
  ).call(columns
  // 去除表头合并不显示的列
  , function (column) {
    return column.colSpan !== 0;
  })
  // 去除初始化就被隐藏的列
  ).call(_context2, function (column) {
    return (0, _findIndex["default"])(hideColumns).call(hideColumns, function (key) {
      return key === getColumnKey(column);
    }) === -1;
  })
  // 只留uniqueId
  ).call(_context, function (column) {
    return getColumnKey(column);
  });
};
var getColSpanOption = function getColSpanOption(columns) {
  var colSpanOption = [];
  (0, _forEach["default"])(columns).call(columns, function (column, index) {
    if ('colSpan' in column && column.colSpan !== 0) {
      var _context3;
      colSpanOption.push({
        key: column.filtrateTitle || column.title,
        value: (0, _map["default"])(_context3 = (0, _slice["default"])(columns).call(columns, index, index + column.colSpan)).call(_context3, function (column) {
          return column.key || column.dataIndex;
        })
      });
    }
  });
  return colSpanOption;
};
var ColumnFiltrateModal = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ColumnFiltrateModal, _React$Component);
  var _super = _createSuper(ColumnFiltrateModal);
  function ColumnFiltrateModal(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ColumnFiltrateModal);
    _this = _super.call(this, props);
    _this.showModal = function () {
      _this.setState({
        visible: true
      });
    };
    _this.handleOk = function () {
      _this.setState({
        visible: false,
        checkedOptionConfirm: _this.state.checkedOption,
        okButtonDisabled: true
      }, function () {
        var _context4, _context5;
        // 被隐藏的列表key
        _this.props.onChange(flatten((0, _map["default"])(_context4 = (0, _filter["default"])(_context5 = _this.getOptions()).call(_context5, function (column) {
          var _context6;
          return (0, _indexOf["default"])(_context6 = _this.state.checkedOptionConfirm).call(_context6, column.value) === -1;
        })).call(_context4, function (column) {
          var _context7;
          var indexOfColSpan = (0, _findIndex["default"])(_context7 = _this.state.colSpanOption).call(_context7, function (option) {
            return option.key === column.value;
          });
          if (indexOfColSpan !== -1) {
            return _this.state.colSpanOption[indexOfColSpan].value;
          } else {
            return column.value;
          }
        })));
      });
    };
    _this.handleCancel = function () {
      _this.setState({
        visible: false,
        checkedOption: _this.state.checkedOptionConfirm,
        okButtonDisabled: true
      });
    };
    _this.onChange = function (checkedOption) {
      var checkedOptionConfirm = _this.state.checkedOptionConfirm;
      _this.setState({
        checkedOption: checkedOption,
        okButtonDisabled: (0, _stringify["default"])(checkedOption && (0, _sort["default"])(checkedOption).call(checkedOption)) == (0, _stringify["default"])(checkedOptionConfirm && (0, _sort["default"])(checkedOptionConfirm).call(checkedOptionConfirm))
      });
    };
    _this.getOptions = function () {
      var _context8, _context9;
      var _this$props = _this.props,
        columns = _this$props.columns,
        defaultColumns = _this$props.defaultColumns;
      return (0, _filter["default"])(_context8 = (0, _map["default"])(_context9 = (0, _filter["default"])(columns
      // 去除表头合并的不显示的
      ).call(columns
      // 去除表头合并的不显示的
      , function (column) {
        return column.colSpan !== 0;
      })
      // 获取他们的label、value、disabled
      ).call(_context9, function (column) {
        var uniqKey = getColumnKey(column);
        //fixed /分组不能控制显示隐藏
        var disabled = !!column.fixed || !!column.children || !!column.filtrateDefault;
        var title = column.filtrateTitle || column.title;
        return {
          label: /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
            title: title
          }, title),
          value: uniqKey,
          disabled: disabled
        };
      })
      // 去除默认展示数据项
      ).call(_context8, function (column) {
        return (0, _findIndex["default"])(defaultColumns).call(defaultColumns, function (key) {
          return key === column.value;
        }) === -1;
      });
    };
    //默认一直显示的选项
    _this.getDefaultOption = function () {
      var _context10;
      var _this$props2 = _this.props,
        columns = _this$props2.columns,
        _this$props2$defaultC = _this$props2.defaultColumns,
        defaultColumns = _this$props2$defaultC === void 0 ? [] : _this$props2$defaultC;
      return (0, _map["default"])(_context10 = (0, _filter["default"])(columns).call(columns, function (column) {
        return (0, _findIndex["default"])(defaultColumns).call(defaultColumns, function (key) {
          return key === getColumnKey(column);
        }) !== -1;
      })).call(_context10, function (column) {
        return {
          label: /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
            title: column.filtrateTitle || column.title
          }, column.filtrateTitle || column.title),
          value: getColumnKey(column),
          disabled: true
        };
      });
    };
    var _this$props3 = _this.props,
      columns = _this$props3.columns,
      hideColumns = _this$props3.hideColumns;
    var option = getCheckedOptions(columns, hideColumns);
    _this.state = {
      visible: false,
      checkedOption: option,
      checkedOptionConfirm: option,
      okButtonDisabled: true,
      prevProps: props,
      colSpanOption: getColSpanOption(columns)
    };
    return _this;
  }
  (0, _createClass2["default"])(ColumnFiltrateModal, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var prefixCls = this.props.prefixCls;
      var _this$state = this.state,
        visible = _this$state.visible,
        checkedOption = _this$state.checkedOption,
        okButtonDisabled = _this$state.okButtonDisabled;
      var options = this.getOptions();
      var defaultOption = this.getDefaultOption();
      return /*#__PURE__*/_react["default"].createElement(_Consumer["default"], {
        componentName: "Table"
      }, function (Locale) {
        return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
          className: "".concat(prefixCls, "-filtrate-icon"),
          type: "Settingx",
          onClick: _this2.showModal
        }), /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
          title: Locale.modalTitle,
          wrapClassName: "".concat(prefixCls, "-filtrate-modal"),
          visible: visible,
          width: 680,
          okButtonDisabled: okButtonDisabled,
          onOk: _this2.handleOk,
          onCancel: _this2.handleCancel,
          okText: Locale.okText,
          cancelText: Locale.cancelText
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-filtrate-modal-enable-list")
        }, /*#__PURE__*/_react["default"].createElement(CheckboxGroup, {
          value: checkedOption,
          options: options,
          onChange: _this2.onChange
        })), defaultOption && !!defaultOption.length && /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-filtrate-modal-disabled-list")
        }, /*#__PURE__*/_react["default"].createElement("p", {
          className: "title"
        }, Locale.defaultOptionTitle), /*#__PURE__*/_react["default"].createElement(CheckboxGroup, {
          options: defaultOption,
          defaultValue: (0, _map["default"])(defaultOption).call(defaultOption, function (option) {
            return option.value;
          })
        }))));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      //监听column个数变化，重新初始化checkedOption
      if ('columns' in nextProps && nextProps.columns.length !== prevProps.columns.length) {
        var columns = nextProps.columns,
          hideColumns = nextProps.hideColumns;
        var option = getCheckedOptions(columns, hideColumns);
        newState.checkedOption = option;
        newState.checkedOptionConfirm = option;
        newState.colSpanOption = getColSpanOption(columns);
      }
      return newState;
    }
  }]);
  return ColumnFiltrateModal;
}(_react["default"].Component);
ColumnFiltrateModal.defaultProps = {
  defaultColumns: [],
  hideColumns: []
};
(0, _reactLifecyclesCompat.polyfill)(ColumnFiltrateModal);
var _default = ColumnFiltrateModal;
exports["default"] = _default;