import * as React from 'react';
import { SpinProps } from '../Spin';
import { Store } from './createStore';
import Column from './Column';
import ColumnGroup from './ColumnGroup';
import { TableProps, TableSize, TableState, RowSelectionType, TableLocale, ColumnProps, SelectionItemSelectFn, SelectionInfo } from './interface';
import { RadioChangeEvent } from '../Radio';
import { CheckboxChangeEvent } from '../Checkbox';
import { LocaleProperties } from '../Locale';
declare class Table<T> extends React.Component<TableProps<T>, TableState<T>> {
    static Column: typeof Column;
    static ColumnGroup: typeof ColumnGroup;
    static propTypes: {
        dataSource: any;
        columns: any;
        activeRowByClick: any;
        prefixCls: any;
        useFixedHeader: any;
        rowSelection: any;
        columnFiltrate: any;
        className: any;
        size: any;
        loading: any;
        bordered: any;
        onChange: any;
        locale: any;
        dropdownPrefixCls: any;
    };
    static defaultProps: {
        activeRowByClick: boolean;
        dataSource: any[];
        prefixCls: string;
        useFixedHeader: boolean;
        className: string;
        size: TableSize;
        loading: boolean;
        bordered: boolean;
        indentSize: number;
        locale: {};
        rowKey: string;
        showHeader: boolean;
    };
    store: Store;
    static getDerivedStateFromProps(nextProps: any, prevState: any): any;
    constructor(props: TableProps<T>);
    getCheckboxPropsByItem: (item: T, index: number) => any;
    getDefaultSelection(): any[];
    getDefaultPagination(props: TableProps<T>): {};
    componentDidUpdate(prevProps: TableProps<T>): void;
    onRow: (record: T, index: number) => any;
    setSelectedRowKeys(selectedRowKeys: string[], selectionInfo: SelectionInfo<T>): void;
    hasPagination(props?: any): boolean;
    getDefaultSortOrder(columns?: ColumnProps<T>[]): {
        sortColumn: any;
        sortOrder: any;
    };
    getSorterFn(): (a: T, b: T) => number;
    toggleSortOrder(order: 'ascend' | 'descend', column: ColumnProps<T>): void;
    toggleTwoStateSortOrder(order: 'ascend' | 'descend', column: ColumnProps<T>): void;
    handleFilter: (column: ColumnProps<T>, nextFilters: string[]) => void;
    handleSelect: (record: T, rowIndex: number, e: CheckboxChangeEvent) => void;
    handleRadioSelect: (record: T, rowIndex: number, e: RadioChangeEvent) => void;
    handleSelectRow: (selectionKey: string, index: number, onSelectFunc: SelectionItemSelectFn) => any;
    handlePageChange: (current: number, ...otherArguments: any[]) => void;
    renderSelectionBox: (type: RowSelectionType | undefined) => (_: any, record: T, index: number) => JSX.Element;
    getRecordKey: (record: T, index: number) => any;
    getPopupContainer: () => HTMLElement;
    renderRowSelection(locale: TableLocale): ColumnProps<T>[];
    renderColumnsFiltrate(columnsProps: any, locale: any): any;
    handleColumnsFiltrateDraggableChange: (hideColumns: string[], sortedColumns: string[]) => void;
    handleColumnsFiltrateChange: (hideColumns: string[]) => void;
    getColumnKey(column: ColumnProps<T>, index?: number): React.Key;
    getMaxCurrent(total: number): number;
    isSortColumn(column: ColumnProps<T>): boolean;
    renderColumnsDropdown(columns: ColumnProps<T>[], locale: TableLocale): any[];
    handleShowSizeChange: (current: number, pageSize: number) => void;
    renderPagination(paginationPosition: string): JSX.Element;
    prepareParamsArguments(state: any): [any, string[], Record<string, any>];
    findColumn(myKey: string | number): any;
    getCurrentPageData(): T[];
    getFlatData(): any[];
    getFlatCurrentPageData(): any[];
    recursiveSort(data: T[], sorterFn: (a: any, b: any) => number): T[];
    getLocalData(): T[];
    renderTable: (loading: SpinProps, Locale: LocaleProperties['Table']) => JSX.Element;
    render(): JSX.Element;
}
export default Table;
