"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _splice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/splice"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDnd = require("react-dnd");
var _DragAndDrop = _interopRequireDefault(require("./DragAndDrop"));
require("./index.less");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var modulePrefix = 'TableDraggable';
var dragingIndex = -1;
/**
 * @param {*} WrappedTable
 * @param {*} config
 *                - dnd 是否启用 Drag&Drop
 *                - renderBodyRow 自定义渲染 row
 */
var TableDraggableHOC = function TableDraggableHOC(WrappedTable, config) {
  var _a;
  var BodyRow = /*#__PURE__*/function (_Component) {
    (0, _inherits2["default"])(BodyRow, _Component);
    var _super = _createSuper(BodyRow);
    function BodyRow() {
      (0, _classCallCheck2["default"])(this, BodyRow);
      return _super.apply(this, arguments);
    }
    (0, _createClass2["default"])(BodyRow, [{
      key: "render",
      value: function render() {
        var _a = this.props,
          isOver = _a.isOver,
          connectDragSource = _a.connectDragSource,
          connectDropTarget = _a.connectDropTarget,
          moveRow = _a.moveRow,
          restProps = __rest(_a, ["isOver", "connectDragSource", "connectDropTarget", "moveRow"]);
        var style = (0, _assign["default"])((0, _assign["default"])({}, restProps.style), {
          cursor: 'move'
        });
        var style2 = (0, _assign["default"])((0, _assign["default"])({}, restProps.style), {
          cursor: 'auto'
        });
        var className = restProps.className;
        if (isOver) {
          if (restProps.index > dragingIndex) {
            className += ' drop-over-downward';
          }
          if (restProps.index < dragingIndex) {
            className += ' drop-over-upward';
          }
        }
        if (config.renderBodyRow) {
          var rendered = config.renderBodyRow((0, _assign["default"])((0, _assign["default"])({}, restProps), {
            className: className,
            style: style
          }));
          var renderedNoMove = config.renderBodyRow((0, _assign["default"])((0, _assign["default"])({}, restProps), {
            className: className,
            style2: style2
          }));
          // 自定义渲染 TableRow 时是否开启拖拽功能
          if (config.dndRow) {
            var isRowDnd = config.dndRow((0, _assign["default"])({}, restProps));
            return isRowDnd ? connectDragSource(connectDropTarget(rendered)) : renderedNoMove;
          } else {
            return renderedNoMove ? config.dnd ? connectDragSource(connectDropTarget(rendered)) : renderedNoMove : null;
          }
        }
        return connectDragSource(connectDropTarget( /*#__PURE__*/_react["default"].createElement("tr", (0, _assign["default"])({}, restProps, {
          style: style
        }))));
      }
    }]);
    return BodyRow;
  }(_react.Component);
  var rowSource = {
    beginDrag: function beginDrag(props) {
      dragingIndex = props.index;
      return {
        record: props.record,
        index: props.index
      };
    }
  };
  var rowTarget = config.rowTarget || {
    drop: function drop(props, monitor) {
      var dragIndex = monitor.getItem().index;
      var hoverIndex = props.index;
      // Don't replace items with themselves
      if (dragIndex === hoverIndex) {
        return;
      }
      // Time to actually perform the action
      // 非自定义渲染 Row 时才进行移动
      props.moveRow(dragIndex, hoverIndex);
      // Note: we're mutating the monitor item here!
      // Generally it's better to avoid mutations,
      // but it's good here for the sake of performance
      // to avoid expensive index searches.
      monitor.getItem().index = hoverIndex;
    }
  };
  var DragableBodyRow = (0, _reactDnd.DropTarget)('row', rowTarget, function (connect, monitor) {
    return {
      connectDropTarget: connect.dropTarget(),
      isOver: monitor.isOver()
    };
  })((0, _reactDnd.DragSource)('row', rowSource, function (connect) {
    return {
      connectDragSource: connect.dragSource()
    };
  })(BodyRow));
  return _a = /*#__PURE__*/function (_Component2) {
    (0, _inherits2["default"])(TableWrapper, _Component2);
    var _super2 = _createSuper(TableWrapper);
    function TableWrapper() {
      var _this;
      (0, _classCallCheck2["default"])(this, TableWrapper);
      _this = _super2.apply(this, arguments);
      _this.state = {
        dataSource: []
      };
      _this.components = {
        body: {
          row: DragableBodyRow
        }
      };
      _this.moveRow = function (dragIndex, hoverIndex) {
        var _context;
        var dataSource = (0, _slice["default"])(_context = _this.state.dataSource).call(_context);
        // 自定义渲染 Row 时指定该项，不修改 Table 的 dataSource
        if (config.rowTarget) {
          _this.props.onRowMoved && _this.props.onRowMoved(dragIndex, hoverIndex);
        } else {
          // 默认逻辑：拖动 & 排序
          var dragged = (0, _splice["default"])(dataSource).call(dataSource, dragIndex, 1)[0];
          (0, _splice["default"])(dataSource).call(dataSource, hoverIndex, 0, dragged);
          _this.setState({
            dataSource: dataSource
          });
          _this.props.onRowMoved && _this.props.onRowMoved(dataSource);
        }
      };
      return _this;
    }
    (0, _createClass2["default"])(TableWrapper, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.setState({
          dataSource: this.props.dataSource
        });
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        if (this.props.dataSource !== prevProps.dataSource && this.props.dataSource !== this.state.dataSource) {
          this.setState({
            dataSource: this.props.dataSource
          });
        }
      }
    }, {
      key: "render",
      value: function render() {
        var _this2 = this;
        var _a = this.props,
          dataSource = _a.dataSource,
          _a$onRow = _a.onRow,
          _onRow = _a$onRow === void 0 ? function () {} : _a$onRow,
          otherProps = __rest(_a, ["dataSource", "onRow"]);
        return /*#__PURE__*/_react["default"].createElement(_DragAndDrop["default"], null, /*#__PURE__*/_react["default"].createElement(WrappedTable, (0, _assign["default"])({
          dataSource: this.state.dataSource,
          components: this.components,
          onRow: function onRow(record, index) {
            return (0, _assign["default"])({
              record: record,
              index: index,
              moveRow: _this2.moveRow
            }, _onRow(record, index));
          }
        }, otherProps)));
      }
    }]);
    return TableWrapper;
  }(_react.Component), _a.propTypes = {
    onRowMoved: _propTypes["default"].func
  }, _a;
};
var _default = TableDraggableHOC;
exports["default"] = _default;