"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _miniStore = require("mini-store");
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _shallowequal = _interopRequireDefault(require("shallowequal"));
var _TableRow = _interopRequireDefault(require("./TableRow"));
var _utils = require("./utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var ExpandableTable = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ExpandableTable, _React$Component);
  var _super = _createSuper(ExpandableTable);
  function ExpandableTable(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ExpandableTable);
    _this = _super.call(this, props);
    _this.handleExpandChange = function (expanded, record, event, rowKey) {
      var destroy = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
      if (event) {
        event.preventDefault();
        event.stopPropagation();
      }
      var _this$props = _this.props,
        onExpandedRowsChange = _this$props.onExpandedRowsChange,
        onExpand = _this$props.onExpand;
      var _this$store$getState = _this.store.getState(),
        expandedRowKeys = _this$store$getState.expandedRowKeys;
      if (expanded) {
        var _context;
        // row was expanded
        expandedRowKeys = (0, _concat["default"])(_context = []).call(_context, (0, _toConsumableArray2["default"])(expandedRowKeys), [rowKey]);
      } else {
        // row was collapse
        var expandedRowIndex = (0, _indexOf["default"])(expandedRowKeys).call(expandedRowKeys, rowKey);
        if (expandedRowIndex !== -1) {
          expandedRowKeys = (0, _utils.remove)(expandedRowKeys, rowKey);
        }
      }
      if (!_this.props.expandedRowKeys) {
        _this.store.setState({
          expandedRowKeys: expandedRowKeys
        });
      }
      // De-dup of repeat call
      if (!_this.latestExpandedRows || !(0, _shallowequal["default"])(_this.latestExpandedRows, expandedRowKeys)) {
        _this.latestExpandedRows = expandedRowKeys;
        onExpandedRowsChange(expandedRowKeys);
      }
      if (!destroy) {
        onExpand(expanded, record);
      }
    };
    _this.renderExpandIndentCell = function (rows, fixed) {
      var _this$props2 = _this.props,
        prefixCls = _this$props2.prefixCls,
        expandIconAsCell = _this$props2.expandIconAsCell;
      if (!expandIconAsCell || fixed === 'right' || !rows.length) {
        return;
      }
      var iconColumn = {
        key: 'rc-table-expand-icon-cell',
        className: "".concat(prefixCls, "-expand-icon-th"),
        title: '',
        rowSpan: rows.length
      };
      rows[0].unshift((0, _assign["default"])((0, _assign["default"])({}, iconColumn), {
        column: iconColumn
      }));
    };
    _this.renderRows = function (renderRows, rows, record, index, indent, fixed, parentKey, ancestorKeys) {
      var _context2;
      var _this$props3 = _this.props,
        expandedRowClassName = _this$props3.expandedRowClassName,
        expandedRowRender = _this$props3.expandedRowRender,
        childrenColumnName = _this$props3.childrenColumnName;
      var childrenData = record[childrenColumnName];
      var nextAncestorKeys = (0, _concat["default"])(_context2 = []).call(_context2, (0, _toConsumableArray2["default"])(ancestorKeys), [parentKey]);
      var nextIndent = indent + 1;
      if (expandedRowRender) {
        rows.push(_this.renderExpandedRow(record, index, expandedRowRender, expandedRowClassName(record, index, indent), nextAncestorKeys, nextIndent, fixed));
      }
      if (childrenData) {
        rows.push.apply(rows, (0, _toConsumableArray2["default"])(renderRows(childrenData, nextIndent, nextAncestorKeys)));
      }
    };
    var data = props.data,
      childrenColumnName = props.childrenColumnName,
      defaultExpandAllRows = props.defaultExpandAllRows,
      expandedRowKeys = props.expandedRowKeys,
      defaultExpandedRowKeys = props.defaultExpandedRowKeys,
      getRowKey = props.getRowKey;
    var finnalExpandedRowKeys = [];
    var rows = (0, _toConsumableArray2["default"])(data);
    if (defaultExpandAllRows) {
      for (var i = 0; i < rows.length; i++) {
        var row = rows[i];
        finnalExpandedRowKeys.push(getRowKey(row, i));
        rows = (0, _concat["default"])(rows).call(rows, row[childrenColumnName] || []);
      }
    } else {
      finnalExpandedRowKeys = expandedRowKeys || defaultExpandedRowKeys;
    }
    _this.columnManager = props.columnManager;
    _this.store = props.store;
    _this.store.setState({
      expandedRowsHeight: {},
      expandedRowKeys: finnalExpandedRowKeys
    });
    return _this;
  }
  (0, _createClass2["default"])(ExpandableTable, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.handleUpdated();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if ('expandedRowKeys' in this.props) {
        this.store.setState({
          expandedRowKeys: this.props.expandedRowKeys
        });
      }
      this.handleUpdated();
    }
  }, {
    key: "handleUpdated",
    value: function handleUpdated() {
      // We should record latest expanded rows to avoid multiple rows remove
      // cause `onExpandedRowsChange` trigger many times
      this.latestExpandedRows = null;
    }
  }, {
    key: "renderExpandedRow",
    value: function renderExpandedRow(record, index, _render, className, ancestorKeys, indent, fixed) {
      var _this2 = this;
      var _this$props4 = this.props,
        prefixCls = _this$props4.prefixCls,
        expandIconAsCell = _this$props4.expandIconAsCell,
        indentSize = _this$props4.indentSize;
      var parentKey = ancestorKeys[ancestorKeys.length - 1];
      var rowKey = "".concat(parentKey, "-extra-row");
      var components = {
        body: {
          row: 'tr',
          cell: 'td'
        }
      };
      var colCount;
      if (fixed === 'left') {
        colCount = this.columnManager.leftLeafColumns().length;
      } else if (fixed === 'right') {
        colCount = this.columnManager.rightLeafColumns().length;
      } else {
        colCount = this.columnManager.leafColumns().length;
      }
      var columns = [{
        key: 'extra-row',
        render: function render() {
          var _this2$store$getState = _this2.store.getState(),
            expandedRowKeys = _this2$store$getState.expandedRowKeys;
          var expanded = !!~(0, _indexOf["default"])(expandedRowKeys).call(expandedRowKeys, parentKey);
          return {
            props: {
              colSpan: colCount
            },
            children: fixed !== 'right' ? _render(record, index, indent, expanded) : '&nbsp;'
          };
        }
      }];
      if (expandIconAsCell && fixed !== 'right') {
        columns.unshift({
          key: 'expand-icon-placeholder',
          render: function render() {
            return null;
          }
        });
      }
      return /*#__PURE__*/_react["default"].createElement(_TableRow["default"], {
        key: rowKey,
        columns: columns,
        className: className,
        rowKey: rowKey,
        ancestorKeys: ancestorKeys,
        prefixCls: "".concat(prefixCls, "-expanded-row"),
        indentSize: indentSize,
        indent: indent,
        fixed: fixed,
        components: components,
        expandedRow: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
        data = _this$props5.data,
        childrenColumnName = _this$props5.childrenColumnName,
        children = _this$props5.children;
      var needIndentSpaced = (0, _some["default"])(data).call(data, function (record) {
        return record[childrenColumnName];
      });
      return children({
        props: this.props,
        needIndentSpaced: needIndentSpaced,
        renderRows: this.renderRows,
        handleExpandChange: this.handleExpandChange,
        renderExpandIndentCell: this.renderExpandIndentCell
      });
    }
  }]);
  return ExpandableTable;
}(_react["default"].Component);
ExpandableTable.propTypes = {
  expandIconAsCell: _propTypes["default"].bool,
  expandedRowKeys: _propTypes["default"].array,
  expandedRowClassName: _propTypes["default"].func,
  defaultExpandAllRows: _propTypes["default"].bool,
  defaultExpandedRowKeys: _propTypes["default"].array,
  expandIconColumnIndex: _propTypes["default"].number,
  expandedRowRender: _propTypes["default"].func,
  expandIcon: _propTypes["default"].func,
  childrenColumnName: _propTypes["default"].string,
  indentSize: _propTypes["default"].number,
  onExpand: _propTypes["default"].func,
  onExpandedRowsChange: _propTypes["default"].func,
  columnManager: _propTypes["default"].object.isRequired,
  store: _propTypes["default"].object.isRequired,
  prefixCls: _propTypes["default"].string.isRequired,
  data: _propTypes["default"].array,
  children: _propTypes["default"].func.isRequired,
  getRowKey: _propTypes["default"].func.isRequired
};
ExpandableTable.defaultProps = {
  expandIconAsCell: false,
  expandedRowClassName: function expandedRowClassName() {
    return '';
  },
  expandIconColumnIndex: 0,
  defaultExpandAllRows: false,
  defaultExpandedRowKeys: [],
  childrenColumnName: 'children',
  indentSize: 15,
  onExpand: function onExpand() {},
  onExpandedRowsChange: function onExpandedRowsChange() {}
};
(0, _reactLifecyclesCompat.polyfill)(ExpandableTable);
var _default = (0, _miniStore.connect)()(ExpandableTable);
exports["default"] = _default;