"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));
var _react = _interopRequireDefault(require("react"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _miniStore = require("mini-store");
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _classnames = _interopRequireDefault(require("classnames"));
var _TableCell = _interopRequireDefault(require("./TableCell"));
var _utils = require("./utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var noop = function noop() {};
var TableRow = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TableRow, _React$Component);
  var _super = _createSuper(TableRow);
  function TableRow(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TableRow);
    _this = _super.call(this, props);
    _this.onRowClick = function (event) {
      var _this$props = _this.props,
        store = _this$props.store,
        record = _this$props.record,
        index = _this$props.index,
        onRowClick = _this$props.onRowClick,
        activeRowByClick = _this$props.activeRowByClick,
        rowKey = _this$props.rowKey;
      // 点击高亮功能
      activeRowByClick && store.setState({
        currentClickedKey: rowKey
      });
      if (onRowClick) {
        onRowClick(record, index, event);
      }
    };
    _this.onRowDoubleClick = function (event) {
      var _this$props2 = _this.props,
        record = _this$props2.record,
        index = _this$props2.index,
        onRowDoubleClick = _this$props2.onRowDoubleClick;
      if (onRowDoubleClick) {
        onRowDoubleClick(record, index, event);
      }
    };
    _this.onContextMenu = function (event) {
      var _this$props3 = _this.props,
        record = _this$props3.record,
        index = _this$props3.index,
        onRowContextMenu = _this$props3.onRowContextMenu;
      if (onRowContextMenu) {
        onRowContextMenu(record, index, event);
      }
    };
    _this.onMouseEnter = function (event) {
      var _this$props4 = _this.props,
        record = _this$props4.record,
        index = _this$props4.index,
        onRowMouseEnter = _this$props4.onRowMouseEnter,
        onHover = _this$props4.onHover,
        rowKey = _this$props4.rowKey;
      onHover(true, rowKey);
      if (onRowMouseEnter) {
        onRowMouseEnter(record, index, event);
      }
    };
    _this.onMouseLeave = function (event) {
      var _this$props5 = _this.props,
        record = _this$props5.record,
        index = _this$props5.index,
        onRowMouseLeave = _this$props5.onRowMouseLeave,
        onHover = _this$props5.onHover,
        rowKey = _this$props5.rowKey;
      onHover(false, rowKey);
      if (onRowMouseLeave) {
        onRowMouseLeave(record, index, event);
      }
    };
    _this.shouldRender = props.visible;
    _this.state = {};
    return _this;
  }
  (0, _createClass2["default"])(TableRow, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.state.shouldRender) {
        this.saveRowRef();
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return !!(this.props.visible || nextProps.visible);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.state.shouldRender && !this.rowRef) {
        this.saveRowRef();
      }
    }
  }, {
    key: "setExpanedRowHeight",
    value: function setExpanedRowHeight() {
      var _this$props6 = this.props,
        store = _this$props6.store,
        rowKey = _this$props6.rowKey;
      var _store$getState = store.getState(),
        expandedRowsHeight = _store$getState.expandedRowsHeight;
      var height = this.rowRef.getBoundingClientRect().height;
      expandedRowsHeight = (0, _assign["default"])((0, _assign["default"])({}, expandedRowsHeight), (0, _defineProperty2["default"])({}, rowKey, height));
      store.setState({
        expandedRowsHeight: expandedRowsHeight
      });
    }
  }, {
    key: "setRowHeight",
    value: function setRowHeight() {
      var _this$props7 = this.props,
        store = _this$props7.store,
        rowKey = _this$props7.rowKey;
      var _store$getState2 = store.getState(),
        fixedColumnsBodyRowsHeight = _store$getState2.fixedColumnsBodyRowsHeight;
      var height = this.rowRef.getBoundingClientRect().height;
      store.setState({
        fixedColumnsBodyRowsHeight: (0, _assign["default"])((0, _assign["default"])({}, fixedColumnsBodyRowsHeight), (0, _defineProperty2["default"])({}, rowKey, height))
      });
    }
  }, {
    key: "getStyle",
    value: function getStyle() {
      var _this$props8 = this.props,
        height = _this$props8.height,
        visible = _this$props8.visible;
      if (height && height !== this.style.height) {
        this.style = (0, _assign["default"])((0, _assign["default"])({}, this.style), {
          height: height
        });
      }
      if (!visible && !this.style.display) {
        this.style = (0, _assign["default"])((0, _assign["default"])({}, this.style), {
          display: 'none'
        });
      }
      return this.style;
    }
  }, {
    key: "saveRowRef",
    value: function saveRowRef() {
      this.rowRef = _reactDom["default"].findDOMNode(this);
      var _this$props9 = this.props,
        isAnyColumnsFixed = _this$props9.isAnyColumnsFixed,
        fixed = _this$props9.fixed,
        expandedRow = _this$props9.expandedRow,
        ancestorKeys = _this$props9.ancestorKeys;
      if (!isAnyColumnsFixed) {
        return;
      }
      if (!fixed && expandedRow) {
        this.setExpanedRowHeight();
      }
      if (!fixed && ancestorKeys.length >= 0) {
        this.setRowHeight();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _context;
      if (!this.state.shouldRender) {
        return null;
      }
      var _this$props10 = this.props,
        prefixCls = _this$props10.prefixCls,
        columns = _this$props10.columns,
        record = _this$props10.record,
        rowKey = _this$props10.rowKey,
        index = _this$props10.index,
        onRow = _this$props10.onRow,
        indent = _this$props10.indent,
        indentSize = _this$props10.indentSize,
        hovered = _this$props10.hovered,
        clicked = _this$props10.clicked,
        height = _this$props10.height,
        visible = _this$props10.visible,
        components = _this$props10.components,
        hasExpandIcon = _this$props10.hasExpandIcon,
        renderExpandIcon = _this$props10.renderExpandIcon,
        renderExpandIconCell = _this$props10.renderExpandIconCell;
      var BodyRow = components.body.row;
      var BodyCell = components.body.cell;
      var className = this.props.className;
      if (hovered) {
        className += " ".concat(prefixCls, "-hover");
      }
      if (clicked) {
        className += " ".concat(prefixCls, "-click");
      }
      var cells = [];
      renderExpandIconCell(cells);
      for (var i = 0; i < columns.length; i++) {
        var column = columns[i];
        (0, _utils.warningOnce)(column.onCellClick === undefined, 'column[onCellClick] is deprecated, please use column[onCell] instead.');
        cells.push( /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
          prefixCls: prefixCls,
          record: record,
          indentSize: indentSize,
          indent: indent,
          index: index,
          column: column,
          key: column.key || column.dataIndex,
          expandIcon: hasExpandIcon(i) && renderExpandIcon(),
          component: BodyCell
        }));
      }
      var _a = onRow(record, index) || {},
        customClassName = _a.className,
        customStyle = _a.style,
        rowProps = __rest(_a, ["className", "style"]);
      var style = {
        height: height
      };
      if (!visible) {
        style.display = 'none';
      }
      style = (0, _assign["default"])((0, _assign["default"])({}, style), customStyle);
      var rowClassName = (0, _classnames["default"])(prefixCls, className, (0, _concat["default"])(_context = "".concat(prefixCls, "-level-")).call(_context, indent), customClassName);
      return /*#__PURE__*/_react["default"].createElement(BodyRow, (0, _assign["default"])({
        onClick: this.onRowClick,
        onDoubleClick: this.onRowDoubleClick,
        onMouseEnter: this.onMouseEnter,
        onMouseLeave: this.onMouseLeave,
        onContextMenu: this.onContextMenu
      }, rowProps, {
        className: rowClassName,
        style: style,
        "data-row-key": rowKey
      }), cells);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (prevState.visible || !prevState.visible && nextProps.visible) {
        return {
          shouldRender: true,
          visible: nextProps.visible
        };
      }
      return {
        visible: nextProps.visible
      };
    }
  }]);
  return TableRow;
}(_react["default"].Component);
TableRow.propTypes = {
  onRow: _propTypes["default"].func,
  onRowClick: _propTypes["default"].func,
  onRowDoubleClick: _propTypes["default"].func,
  onRowContextMenu: _propTypes["default"].func,
  onRowMouseEnter: _propTypes["default"].func,
  onRowMouseLeave: _propTypes["default"].func,
  record: _propTypes["default"].object,
  prefixCls: _propTypes["default"].string,
  onHover: _propTypes["default"].func,
  columns: _propTypes["default"].array,
  activeRowByClick: _propTypes["default"].bool,
  height: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  index: _propTypes["default"].number,
  rowKey: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]).isRequired,
  className: _propTypes["default"].string,
  indent: _propTypes["default"].number,
  indentSize: _propTypes["default"].number,
  hasExpandIcon: _propTypes["default"].func,
  hovered: _propTypes["default"].bool.isRequired,
  clicked: _propTypes["default"].bool.isRequired,
  visible: _propTypes["default"].bool.isRequired,
  store: _propTypes["default"].object.isRequired,
  fixed: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool]),
  renderExpandIcon: _propTypes["default"].func,
  renderExpandIconCell: _propTypes["default"].func,
  components: _propTypes["default"].shape({
    table: _propTypes["default"].any,
    header: _propTypes["default"].shape({
      wrapper: _propTypes["default"].any,
      row: _propTypes["default"].any,
      cell: _propTypes["default"].any
    }),
    body: _propTypes["default"].shape({
      wrapper: _propTypes["default"].any,
      row: _propTypes["default"].any,
      cell: _propTypes["default"].any
    })
  }),
  expandedRow: _propTypes["default"].bool,
  isAnyColumnsFixed: _propTypes["default"].bool,
  ancestorKeys: _propTypes["default"].array.isRequired
};
TableRow.defaultProps = {
  onRow: noop,
  onHover: noop,
  hasExpandIcon: noop,
  renderExpandIcon: noop,
  renderExpandIconCell: noop
};
function getRowHeight(state, props) {
  var expandedRowsHeight = state.expandedRowsHeight,
    fixedColumnsBodyRowsHeight = state.fixedColumnsBodyRowsHeight;
  var fixed = props.fixed,
    rowKey = props.rowKey;
  if (!fixed) {
    return null;
  }
  if (expandedRowsHeight[rowKey]) {
    return expandedRowsHeight[rowKey];
  }
  if (fixedColumnsBodyRowsHeight[rowKey]) {
    return fixedColumnsBodyRowsHeight[rowKey];
  }
  return null;
}
(0, _reactLifecyclesCompat.polyfill)(TableRow);
var _default = (0, _miniStore.connect)(function (state, props) {
  var currentHoverKey = state.currentHoverKey,
    currentClickedKey = state.currentClickedKey,
    expandedRowKeys = state.expandedRowKeys;
  var rowKey = props.rowKey,
    ancestorKeys = props.ancestorKeys;
  var visible = ancestorKeys.length === 0 || (0, _every["default"])(ancestorKeys).call(ancestorKeys, function (k) {
    return ~(0, _indexOf["default"])(expandedRowKeys).call(expandedRowKeys, k);
  });
  return {
    visible: visible,
    hovered: currentHoverKey === rowKey,
    clicked: currentClickedKey === rowKey,
    height: getRowHeight(state, props)
  };
})(TableRow);
exports["default"] = _default;