"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getActiveIndex = getActiveIndex;
exports.getActiveKey = getActiveKey;
exports.getDataAttr = getDataAttr;
exports.getMarginStyle = getMarginStyle;
exports.getStyle = getStyle;
exports.getTransformByIndex = getTransformByIndex;
exports.getTransformPropValue = getTransformPropValue;
exports.isTransformSupported = isTransformSupported;
exports.isVertical = isVertical;
exports.setPxStyle = setPxStyle;
exports.setTransform = setTransform;
exports.setTransition = setTransition;
exports.toArray = toArray;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _react = _interopRequireDefault(require("react"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function toArray(children) {
  var _context;
  // allow [c,[a,b]]
  var c = [];
  (0, _forEach["default"])(_context = _react["default"].Children).call(_context, children, function (child) {
    if (child) {
      c.push(child);
    }
  });
  return c;
}
function getActiveIndex(children, activeKey) {
  var c = toArray(children);
  for (var i = 0; i < c.length; i++) {
    if (c[i].key === activeKey) {
      return i;
    }
  }
  return -1;
}
function getActiveKey(children, index) {
  var c = toArray(children);
  return c[index].key;
}
function setTransform(style, v) {
  style.transform = v;
  style.webkitTransform = v;
  style.mozTransform = v;
}
function isTransformSupported(style) {
  return 'transform' in style || 'webkitTransform' in style || 'MozTransform' in style;
}
function setTransition(style, v) {
  style.transition = v;
  style.webkitTransition = v;
  style.MozTransition = v;
}
function getTransformPropValue(v) {
  return {
    transform: v,
    WebkitTransform: v,
    MozTransform: v
  };
}
function isVertical(tabBarPosition) {
  return tabBarPosition === 'left' || tabBarPosition === 'right';
}
function getTransformByIndex(index, tabBarPosition) {
  var _context2;
  var translate = isVertical(tabBarPosition) ? 'translateY' : 'translateX';
  return (0, _concat["default"])(_context2 = "".concat(translate, "(")).call(_context2, -index * 100, "%) translateZ(0)");
}
function getMarginStyle(index, tabBarPosition) {
  var marginDirection = isVertical(tabBarPosition) ? 'marginTop' : 'marginLeft';
  return (0, _defineProperty2["default"])({}, marginDirection, "".concat(-index * 100, "%"));
}
function getStyle(el, property) {
  return +getComputedStyle(el).getPropertyValue(property).replace('px', '');
}
function setPxStyle(el, value, vertical) {
  value = vertical ? "0px, ".concat(value, "px, 0px") : "".concat(value, "px, 0px, 0px");
  setTransform(el.style, "translate3d(".concat(value, ")"));
}
function getDataAttr(props) {
  var _context3;
  return (0, _reduce["default"])(_context3 = (0, _keys["default"])(props)).call(_context3, function (prev, key) {
    if (key.substr(0, 5) === 'aria-' || key.substr(0, 5) === 'data-' || key === 'role') {
      prev[key] = props[key];
    }
    return prev;
  }, {});
}