"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));
var _set = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _omit = _interopRequireDefault(require("omit.js"));
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _util = require("../TreeSelect/rcTree/util");
var _Tree = _interopRequireDefault(require("./Tree"));
var _util2 = require("./util");
var _Icon = _interopRequireDefault(require("../Icon"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
function getIcon(props) {
  var isLeaf = props.isLeaf,
    expanded = props.expanded;
  if (isLeaf) {
    return /*#__PURE__*/React.createElement(_Icon["default"], {
      type: "file-line"
    });
  }
  return /*#__PURE__*/React.createElement(_Icon["default"], {
    type: expanded ? 'folder-open-line' : 'folder-close-line'
  });
}
var DirectoryTree = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(DirectoryTree, _React$Component);
  var _super = _createSuper(DirectoryTree);
  function DirectoryTree(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DirectoryTree);
    _this = _super.call(this, props);
    _this.onExpand = function (expandedKeys, info) {
      var onExpand = _this.props.onExpand;
      _this.setUncontrolledState({
        expandedKeys: expandedKeys
      });
      // Call origin function
      if (onExpand) {
        return onExpand(expandedKeys, info);
      }
      return undefined;
    };
    _this.onClick = function (event, node) {
      var _this$props = _this.props,
        onClick = _this$props.onClick,
        expandAction = _this$props.expandAction;
      // Expand the tree
      if (expandAction === 'click') {
        _this.onDebounceExpand(event, node);
      }
      if (onClick) {
        onClick(event, node);
      }
    };
    _this.onDoubleClick = function (event, node) {
      var _this$props2 = _this.props,
        onDoubleClick = _this$props2.onDoubleClick,
        expandAction = _this$props2.expandAction;
      // Expand the tree
      if (expandAction === 'doubleClick') {
        _this.onDebounceExpand(event, node);
      }
      if (onDoubleClick) {
        onDoubleClick(event, node);
      }
    };
    _this.onSelect = function (keys, event) {
      var _this$props3 = _this.props,
        onSelect = _this$props3.onSelect,
        multiple = _this$props3.multiple,
        children = _this$props3.children;
      var _this$state = _this.state,
        _this$state$expandedK = _this$state.expandedKeys,
        expandedKeys = _this$state$expandedK === void 0 ? [] : _this$state$expandedK,
        _this$state$selectedK = _this$state.selectedKeys,
        selectedKeys = _this$state$selectedK === void 0 ? [] : _this$state$selectedK;
      var node = event.node,
        nativeEvent = event.nativeEvent;
      var _node$props$eventKey = node.props.eventKey,
        eventKey = _node$props$eventKey === void 0 ? '' : _node$props$eventKey;
      var newState = {};
      // Windows / Mac single pick
      var ctrlPick = nativeEvent.ctrlKey || nativeEvent.metaKey;
      var shiftPick = nativeEvent.shiftKey;
      // Generate new selected keys
      var newSelectedKeys = (0, _slice["default"])(selectedKeys).call(selectedKeys);
      if (multiple && ctrlPick) {
        // Control click
        newSelectedKeys = keys;
        _this.lastSelectedKey = eventKey;
        _this.cachedSelectedKeys = newSelectedKeys;
      } else if (multiple && shiftPick) {
        var _context;
        // Shift click
        newSelectedKeys = (0, _from["default"])(new _set["default"]((0, _concat["default"])(_context = []).call(_context, (0, _toConsumableArray2["default"])(_this.cachedSelectedKeys || []), (0, _toConsumableArray2["default"])((0, _util2.calcRangeKeys)(children, expandedKeys, eventKey, _this.lastSelectedKey)))));
      } else {
        // Single click
        newSelectedKeys = [eventKey];
        _this.lastSelectedKey = eventKey;
        _this.cachedSelectedKeys = newSelectedKeys;
      }
      newState.selectedKeys = newSelectedKeys;
      if (onSelect) {
        onSelect(newSelectedKeys, event);
      }
      _this.setUncontrolledState(newState);
    };
    _this.expandFolderNode = function (event, node) {
      var isLeaf = node.props.isLeaf;
      if (isLeaf || event.shiftKey || event.metaKey || event.ctrlKey) {
        return;
      }
      // Get internal rc-tree
      var internalTree = _this.tree.tree;
      // Call internal rc-tree expand function
      // https://github.com/ant-design/ant-design/issues/12567
      internalTree.onNodeExpand(event, node);
    };
    _this.setUncontrolledState = function (state) {
      var newState = (0, _omit["default"])(state, (0, _keys["default"])(_this.props));
      if ((0, _keys["default"])(newState).length) {
        _this.setState(newState);
      }
    };
    var defaultExpandAll = props.defaultExpandAll,
      defaultExpandParent = props.defaultExpandParent,
      expandedKeys = props.expandedKeys,
      defaultExpandedKeys = props.defaultExpandedKeys,
      children = props.children;
    var _convertTreeToEntitie = (0, _util.convertTreeToEntities)(children),
      keyEntities = _convertTreeToEntitie.keyEntities;
    // Selected keys
    _this.state = {
      selectedKeys: props.selectedKeys || props.defaultSelectedKeys || []
    };
    // Expanded keys
    if (defaultExpandAll) {
      _this.state.expandedKeys = (0, _util2.getFullKeyList)(props.children);
    } else if (defaultExpandParent) {
      _this.state.expandedKeys = (0, _util.conductExpandParent)(expandedKeys || defaultExpandedKeys, keyEntities);
    } else {
      _this.state.expandedKeys = expandedKeys || defaultExpandedKeys;
    }
    _this.onDebounceExpand = (0, _debounce["default"])(_this.expandFolderNode, 200, {
      leading: true
    });
    return _this;
  }
  (0, _createClass2["default"])(DirectoryTree, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        className = _a.className,
        props = __rest(_a, ["prefixCls", "className"]);
      var _this$state2 = this.state,
        expandedKeys = _this$state2.expandedKeys,
        selectedKeys = _this$state2.selectedKeys;
      var connectClassName = (0, _classnames["default"])("".concat(prefixCls, "-directory"), className);
      return /*#__PURE__*/React.createElement(_Tree["default"], (0, _assign["default"])({
        icon: getIcon,
        ref: function ref(node) {
          return _this2.tree = node;
        }
      }, props, {
        prefixCls: prefixCls,
        className: connectClassName,
        expandedKeys: expandedKeys,
        selectedKeys: selectedKeys,
        onSelect: this.onSelect,
        onClick: this.onClick,
        onDoubleClick: this.onDoubleClick,
        onExpand: this.onExpand
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      var newState = {};
      if ('expandedKeys' in nextProps) {
        newState.expandedKeys = nextProps.expandedKeys;
      }
      if ('selectedKeys' in nextProps) {
        newState.selectedKeys = nextProps.selectedKeys;
      }
      return newState;
    }
  }]);
  return DirectoryTree;
}(React.Component);
DirectoryTree.defaultProps = {
  prefixCls: 'fishd-tree',
  showIcon: true,
  expandAction: 'click'
};
(0, _reactLifecyclesCompat.polyfill)(DirectoryTree);
var _default = DirectoryTree;
exports["default"] = _default;