"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.popupContextTypes = exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _rcTree = _interopRequireDefault(require("../../rcTree"));
var _index = _interopRequireDefault(require("../../../Spin/index"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var popupContextTypes = {
  onPopupKeyDown: _propTypes["default"].func.isRequired,
  onTreeNodeSelect: _propTypes["default"].func.isRequired,
  onTreeNodeCheck: _propTypes["default"].func.isRequired
};
exports.popupContextTypes = popupContextTypes;
var BasePopup = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(BasePopup, _React$Component);
  var _super = _createSuper(BasePopup);
  function BasePopup(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, BasePopup);
    _this = _super.call(this);
    _this.onTreeExpand = function (expandedKeyList, extra) {
      var _this$props = _this.props,
        onTreeExpanded = _this$props.onTreeExpanded,
        onExpand = _this$props.onExpand;
      _this.setState({
        expandedKeyList: expandedKeyList
      }, onTreeExpanded);
      onExpand && onExpand(expandedKeyList, extra);
    };
    _this.onLoad = function (loadedKeys) {
      _this.setState({
        loadedKeys: loadedKeys
      });
    };
    /**
     * This method pass to Tree component which is used for add filtered class
     * in TreeNode > li
     */
    _this.filterTreeNode = function (treeNode) {
      var _this$props2 = _this.props,
        upperSearchValue = _this$props2.upperSearchValue,
        treeNodeFilterProp = _this$props2.treeNodeFilterProp;
      var filterVal = treeNode.props[treeNodeFilterProp];
      if (typeof filterVal === 'string') {
        var _context;
        return upperSearchValue && (0, _indexOf["default"])(_context = filterVal.toUpperCase()).call(_context, upperSearchValue) !== -1;
      }
      return false;
    };
    _this.renderNotFound = function () {
      var _this$props3 = _this.props,
        prefixCls = _this$props3.prefixCls,
        notFoundContent = _this$props3.notFoundContent,
        loading = _this$props3.loading;
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-not-found")
      }, loading ? /*#__PURE__*/_react["default"].createElement(_index["default"], {
        size: "small"
      }) : notFoundContent);
    };
    var treeDefaultExpandAll = props.treeDefaultExpandAll,
      treeDefaultExpandedKeys = props.treeDefaultExpandedKeys,
      keyEntities = props.keyEntities;
    // TODO: make `expandedKeyList` control
    var expandedKeyList = treeDefaultExpandedKeys;
    if (treeDefaultExpandAll) {
      expandedKeyList = (0, _keys["default"])(keyEntities);
    }
    _this.state = {
      keyList: [],
      expandedKeyList: expandedKeyList,
      loadedKeys: []
    };
    return _this;
  }
  (0, _createClass2["default"])(BasePopup, [{
    key: "render",
    value: function render() {
      var _this$state = this.state,
        keyList = _this$state.keyList,
        expandedKeyList = _this$state.expandedKeyList,
        loadedKeys = _this$state.loadedKeys;
      var _this$props4 = this.props,
        prefixCls = _this$props4.prefixCls,
        treeNodes = _this$props4.treeNodes,
        filteredTreeNodes = _this$props4.filteredTreeNodes,
        showIcon = _this$props4.showIcon,
        treeLine = _this$props4.treeLine,
        treeCheckable = _this$props4.treeCheckable,
        treeCheckStrictly = _this$props4.treeCheckStrictly,
        treeCheckType = _this$props4.treeCheckType,
        multiple = _this$props4.multiple,
        loadData = _this$props4.loadData,
        loading = _this$props4.loading,
        ariaId = _this$props4.ariaId,
        renderSearch = _this$props4.renderSearch,
        renderResetItem = _this$props4.renderResetItem,
        autoExpandParent = _this$props4.autoExpandParent,
        icon = _this$props4.icon,
        doCheckChildInSearch = _this$props4.doCheckChildInSearch;
      var _this$context$rcTreeS = this.context.rcTreeSelect,
        onPopupKeyDown = _this$context$rcTreeS.onPopupKeyDown,
        onTreeNodeSelect = _this$context$rcTreeS.onTreeNodeSelect,
        onTreeNodeCheck = _this$context$rcTreeS.onTreeNodeCheck;
      var treeProps = {};
      if (treeCheckable) {
        treeProps.checkedKeys = keyList;
      } else {
        treeProps.selectedKeys = keyList;
      }
      var $notFound;
      var $treeNodes;
      if (!treeNodes || !treeNodes.length || loading) {
        $notFound = this.renderNotFound();
      } else if (filteredTreeNodes) {
        if (filteredTreeNodes.length) {
          treeProps.checkStrictly = true;
          $treeNodes = filteredTreeNodes;
        } else {
          $notFound = this.renderNotFound();
        }
      } else {
        $treeNodes = treeNodes;
      }
      var $tree;
      var isNotFound = false;
      if ($notFound) {
        $tree = $notFound;
        isNotFound = true;
      } else {
        $tree = /*#__PURE__*/_react["default"].createElement(_rcTree["default"], (0, _assign["default"])({
          doCheckChildInSearch: doCheckChildInSearch,
          autoExpandParent: autoExpandParent,
          prefixCls: "".concat(prefixCls, "-tree"),
          className: (0, _classnames["default"])(!showIcon && "".concat(prefixCls, "-tree-icon-hide")),
          icon: icon,
          showIcon: showIcon,
          showLine: treeLine,
          selectable: !treeCheckable,
          checkable: treeCheckable,
          checkStrictly: treeCheckStrictly,
          checkType: treeCheckType,
          multiple: multiple,
          loadData: loadData,
          loadedKeys: loadedKeys,
          expandedKeys: expandedKeyList,
          filterTreeNode: this.filterTreeNode,
          onSelect: onTreeNodeSelect,
          onCheck: onTreeNodeCheck,
          onExpand: this.onTreeExpand,
          onLoad: this.onLoad
        }, treeProps), $treeNodes);
      }
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-base-popup"),
        role: "listbox",
        id: ariaId,
        onKeyDown: onPopupKeyDown,
        tabIndex: -1
      }, renderSearch ? renderSearch() : null, renderResetItem && !isNotFound ? renderResetItem() : null, $tree);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _ref = prevState || {},
        _ref$prevProps = _ref.prevProps,
        prevProps = _ref$prevProps === void 0 ? {} : _ref$prevProps,
        loadedKeys = _ref.loadedKeys;
      var valueList = nextProps.valueList,
        valueEntities = nextProps.valueEntities,
        keyEntities = nextProps.keyEntities,
        filteredTreeNodes = nextProps.filteredTreeNodes,
        upperSearchValue = nextProps.upperSearchValue;
      var newState = {
        prevProps: nextProps
      };
      // Check value update
      if (valueList !== prevProps.valueList) {
        var _context2, _context3;
        newState.keyList = (0, _map["default"])(_context2 = (0, _filter["default"])(_context3 = (0, _map["default"])(valueList).call(valueList, function (_ref2) {
          var value = _ref2.value;
          return valueEntities[value];
        })).call(_context3, function (entity) {
          return entity;
        })).call(_context2, function (_ref3) {
          var key = _ref3.key;
          return key;
        });
      }
      // 清空搜索内容后恢复搜索前的展开状态
      if (upperSearchValue && !prevState.savedExpandedKeyList) {
        // 保存搜索前展开的节点
        newState.prevExpandedKeyList = (0, _isArray["default"])(prevState.expandedKeyList) ? (0, _toConsumableArray2["default"])(prevState.expandedKeyList) : [];
        newState.savedExpandedKeyList = true;
      } else if (!upperSearchValue && prevState.savedExpandedKeyList) {
        // 恢复搜索前展开的节点
        newState.expandedKeyList = (0, _isArray["default"])(prevState.prevExpandedKeyList) ? (0, _toConsumableArray2["default"])(prevState.prevExpandedKeyList) : [];
        newState.savedExpandedKeyList = false;
      }
      // Show all when tree is in filter mode
      if (filteredTreeNodes && filteredTreeNodes.length && filteredTreeNodes !== prevProps.filteredTreeNodes) {
        newState.expandedKeyList = (0, _keys["default"])(keyEntities);
      }
      // Clean loadedKeys if key not exist in keyEntities anymore
      if (nextProps.loadData) {
        newState.loadedKeys = (0, _filter["default"])(loadedKeys).call(loadedKeys, function (key) {
          return key in keyEntities;
        });
      }
      return newState;
    }
  }]);
  return BasePopup;
}(_react["default"].Component);
BasePopup.propTypes = {
  prefixCls: _propTypes["default"].string,
  upperSearchValue: _propTypes["default"].string,
  valueList: _propTypes["default"].array,
  valueEntities: _propTypes["default"].object,
  keyEntities: _propTypes["default"].object,
  showIcon: _propTypes["default"].bool,
  icon: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].node]),
  treeLine: _propTypes["default"].bool,
  treeNodeFilterProp: _propTypes["default"].string,
  treeCheckable: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].node]),
  doCheckChildInSearch: _propTypes["default"].bool,
  treeCheckStrictly: _propTypes["default"].bool,
  treeCheckType: _propTypes["default"].string,
  treeDefaultExpandAll: _propTypes["default"].bool,
  treeDefaultExpandedKeys: _propTypes["default"].array,
  loadData: _propTypes["default"].func,
  loading: _propTypes["default"].bool,
  multiple: _propTypes["default"].bool,
  autoExpandParent: _propTypes["default"].bool,
  treeNodes: _propTypes["default"].node,
  filteredTreeNodes: _propTypes["default"].node,
  notFoundContent: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),
  ariaId: _propTypes["default"].string,
  // HOC
  renderSearch: _propTypes["default"].func,
  renderResetItem: _propTypes["default"].func,
  onTreeExpanded: _propTypes["default"].func,
  // 确定或取消选择
  onCancel: _propTypes["default"].func,
  onConfirm: _propTypes["default"].func,
  onExpand: _propTypes["default"].func // 节点展开时的回调
};

BasePopup.contextTypes = {
  rcTreeSelect: _propTypes["default"].shape((0, _assign["default"])({}, popupContextTypes))
};
(0, _reactLifecyclesCompat.polyfill)(BasePopup);
var _default = BasePopup;
exports["default"] = _default;