"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.searchContextTypes = exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _util = require("./util");
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
/**
 * Since search box is in different position with different mode.
 * - Single: in the popup box
 * - multiple: in the selector
 * Move the code as a SearchInput for easy management.
 */

var searchContextTypes = {
  onSearchInputChange: _propTypes["default"].func.isRequired
};
exports.searchContextTypes = searchContextTypes;
var SearchInput = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(SearchInput, _React$Component);
  var _super = _createSuper(SearchInput);
  function SearchInput(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, SearchInput);
    _this = _super.call(this, props);
    /**
     * `scrollWidth` is not correct in IE, do the workaround.
     * ref: https://github.com/react-component/tree-select/issues/65
     */
    _this.alignInputWidth = function () {
      _this.inputRef.current.style.width = "".concat(_this.mirrorInputRef.current.clientWidth, "px");
    };
    /**
     * Need additional timeout for focus cause parent dom is not ready when didMount trigger
     */
    _this.focus = function (isDidMount) {
      if (_this.inputRef.current) {
        _this.inputRef.current.focus();
        if (isDidMount) {
          (0, _setTimeout2["default"])(function () {
            _this.inputRef.current.focus();
          }, 0);
        }
      }
    };
    _this.blur = function () {
      if (_this.inputRef.current) {
        _this.inputRef.current.blur();
      }
    };
    _this.handleClearInput = function () {
      var r = _this.inputRef;
      r.current.value = '';
      _this.handleInputChange({
        target: {
          value: ''
        }
      });
    };
    _this.handleInputChange = function (e) {
      var _this$context$rcTreeS = _this.context.rcTreeSelect,
        onSearchInputChange = _this$context$rcTreeS.onSearchInputChange,
        onSearchInputKeyDown = _this$context$rcTreeS.onSearchInputKeyDown;
      var value = e.target.value;
      if (value) {
        _this.setState({
          showClear: true
        });
      } else {
        _this.setState({
          showClear: false
        });
      }
      onSearchInputChange(e);
    };
    _this.inputRef = (0, _util.createRef)();
    _this.mirrorInputRef = (0, _util.createRef)();
    _this.state = {
      showClear: !!_this.props.searchValue
    };
    return _this;
  }
  (0, _createClass2["default"])(SearchInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
        open = _this$props.open,
        needAlign = _this$props.needAlign;
      if (needAlign) {
        this.alignInputWidth();
      }
      if (open) {
        this.focus(true);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props2 = this.props,
        open = _this$props2.open,
        searchValue = _this$props2.searchValue,
        needAlign = _this$props2.needAlign;
      if (open && prevProps.open !== open) {
        this.focus();
      }
      if (needAlign && searchValue !== prevProps.searchValue) {
        this.alignInputWidth();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        searchValue = _this$props3.searchValue,
        prefixCls = _this$props3.prefixCls,
        disabled = _this$props3.disabled,
        renderPlaceholder = _this$props3.renderPlaceholder,
        open = _this$props3.open,
        ariaId = _this$props3.ariaId;
      var _this$context$rcTreeS2 = this.context.rcTreeSelect,
        onSearchInputChange = _this$context$rcTreeS2.onSearchInputChange,
        onSearchInputKeyDown = _this$context$rcTreeS2.onSearchInputKeyDown;
      var showClear = this.state.showClear;
      var clearIconClass = (0, _classnames["default"])((0, _defineProperty2["default"])({
        'hide': !showClear,
        'select-clear-icon': true
      }, "".concat(prefixCls, "-selection__clear"), true));
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-search__field__wrap")
      }, /*#__PURE__*/_react["default"].createElement("input", {
        type: "text",
        ref: this.inputRef,
        onChange: this.handleInputChange,
        onKeyDown: onSearchInputKeyDown,
        value: searchValue,
        disabled: disabled,
        className: "".concat(prefixCls, "-search__field"),
        "aria-label": "filter select",
        "aria-autocomplete": "list",
        "aria-controls": open ? ariaId : undefined,
        "aria-multiline": "false"
      }), /*#__PURE__*/_react["default"].createElement("span", {
        ref: this.mirrorInputRef,
        className: "".concat(prefixCls, "-search__field__mirror")
      }, searchValue, "\xA0"), renderPlaceholder ? renderPlaceholder() : null, /*#__PURE__*/_react["default"].createElement("span", {
        className: clearIconClass,
        onClick: this.handleClearInput
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {
        prevProps: nextProps
      };
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      if (nextProps.searchValue != prevProps.searchValue) {
        newState.showClear = !!nextProps.searchValue;
      }
      return newState;
    }
  }]);
  return SearchInput;
}(_react["default"].Component);
SearchInput.propTypes = {
  open: _propTypes["default"].bool,
  searchValue: _propTypes["default"].string,
  prefixCls: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  renderPlaceholder: _propTypes["default"].func,
  needAlign: _propTypes["default"].bool,
  ariaId: _propTypes["default"].string
};
SearchInput.contextTypes = {
  rcTreeSelect: _propTypes["default"].shape((0, _assign["default"])({}, searchContextTypes))
};
(0, _reactLifecyclesCompat.polyfill)(SearchInput);
var _default = SearchInput;
exports["default"] = _default;