"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _classnames = _interopRequireDefault(require("classnames"));
require("./style/index.less");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var Trend = function Trend(props) {
  var _props$colorful = props.colorful,
    colorful = _props$colorful === void 0 ? true : _props$colorful,
    _props$reverseColor = props.reverseColor,
    reverseColor = _props$reverseColor === void 0 ? false : _props$reverseColor,
    flag = props.flag,
    children = props.children,
    className = props.className,
    _props$size = props.size,
    size = _props$size === void 0 ? 'small' : _props$size,
    style = props.style,
    value = props.value,
    restProps = __rest(props, ["colorful", "reverseColor", "flag", "children", "className", "size", "style", "value"]);
  var cls = (0, _classnames["default"])('trend-item', {
    'trend-item-grey': !colorful,
    'reverse-color': reverseColor && colorful,
    normal: size == 'normal',
    large: size == 'large'
  }, className);
  var renderFlag = function renderFlag() {
    var _context;
    if (!flag) return;
    var iconType = null,
      mark = null;
    if (flag == 'up') {
      mark = '+';
      iconType = 'trendrise';
    } else {
      mark = '-';
      iconType = 'trenddecline';
    }
    return /*#__PURE__*/React.createElement("span", {
      className: flag
    }, value && typeof value == 'string' ? (0, _concat["default"])(_context = "".concat(mark)).call(_context, value) : /*#__PURE__*/React.createElement(_Icon["default"], {
      type: iconType
    }));
  };
  return /*#__PURE__*/React.createElement("div", (0, _assign["default"])({}, restProps, {
    className: cls,
    title: typeof children === 'string' ? children : '',
    style: style
  }), /*#__PURE__*/React.createElement("span", {
    className: "value"
  }, children), renderFlag());
};
Trend.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  flag: _propTypes["default"].string,
  size: _propTypes["default"].string,
  value: _propTypes["default"].string,
  colorful: _propTypes["default"].bool,
  reverseColor: _propTypes["default"].bool,
  children: _propTypes["default"].node
};
var _default = Trend;
exports["default"] = _default;