"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _setInterval2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-interval"));
var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var React = _interopRequireWildcard(require("react"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _index = _interopRequireDefault(require("./src/index.js"));
var _classnames = _interopRequireDefault(require("classnames"));
var _uniqBy = _interopRequireDefault(require("lodash/uniqBy"));
var _Dragger = _interopRequireDefault(require("./Dragger"));
var _UploadList = _interopRequireDefault(require("./UploadList"));
var _utils = require("./utils");
var _Consumer = _interopRequireDefault(require("../Config/Locale/Consumer"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Upload = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Upload, _React$Component);
  var _super = _createSuper(Upload);
  function Upload(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Upload);
    _this = _super.call(this, props);
    _this.onStart = function (file) {
      var _context;
      var nextFileList = (0, _concat["default"])(_context = _this.state.fileList).call(_context);
      var targetItem = (0, _utils.fileToObject)(file);
      targetItem.status = 'uploading';
      nextFileList.push(targetItem);
      _this.onChange({
        file: targetItem,
        fileList: nextFileList
      });
      // fix ie progress
      if (!window.FormData) {
        _this.autoUpdateProgress(0, targetItem);
      }
    };
    _this.onSuccess = function (response, file) {
      _this.clearProgressTimer();
      try {
        if (typeof response === 'string') {
          response = JSON.parse(response);
        }
      } catch (e) {
        /* do nothing */
      }
      var fileList = _this.state.fileList;
      var targetItem = (0, _utils.getFileItem)(file, fileList);
      // removed
      if (!targetItem) {
        return;
      }
      targetItem.status = 'done';
      targetItem.response = response;
      _this.onChange({
        file: (0, _assign["default"])({}, targetItem),
        fileList: fileList
      });
    };
    _this.onProgress = function (e, file) {
      var fileList = _this.state.fileList;
      var targetItem = (0, _utils.getFileItem)(file, fileList);
      // removed
      if (!targetItem) {
        return;
      }
      targetItem.percent = e.percent;
      _this.onChange({
        event: e,
        file: (0, _assign["default"])({}, targetItem),
        fileList: _this.state.fileList
      });
    };
    _this.onError = function (error, response, file) {
      _this.clearProgressTimer();
      var fileList = _this.state.fileList;
      var targetItem = (0, _utils.getFileItem)(file, fileList);
      // removed
      if (!targetItem) {
        return;
      }
      targetItem.error = error;
      targetItem.response = response;
      targetItem.status = 'error';
      _this.onChange({
        file: (0, _assign["default"])({}, targetItem),
        fileList: fileList
      });
    };
    _this.handleDeleteAll = function () {
      var _context2;
      (0, _forEach["default"])(_context2 = _this.state.fileList).call(_context2, function (file) {
        _this.upload.abort(file);
        file.status = 'removed'; // eslint-disable-line
      });

      _this.setState({
        fileList: []
      });
      var onDeleteAll = _this.props.onDeleteAll;
      if (onDeleteAll) {
        onDeleteAll();
      }
    };
    _this.handleManualRemove = function (file) {
      _this.upload.abort(file);
      file.status = 'removed'; // eslint-disable-line
      _this.handleRemove(file);
    };
    _this.onChange = function (info) {
      if (!('fileList' in _this.props)) {
        _this.setState({
          fileList: info.fileList
        });
      }
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange(info);
      }
    };
    _this.onFileDrop = function (e) {
      _this.setState({
        dragState: e.type
      });
    };
    _this.beforeUpload = function (file, fileList) {
      if (!_this.props.beforeUpload) {
        return true;
      }
      var result = _this.props.beforeUpload(file, fileList);
      if (result === false) {
        var _context3;
        _this.onChange({
          file: file,
          fileList: (0, _uniqBy["default"])((0, _concat["default"])(_context3 = _this.state.fileList).call(_context3, (0, _map["default"])(fileList).call(fileList, _utils.fileToObject)), function (item) {
            return item.uid;
          })
        });
        return false;
      } else if (result && result.then) {
        return result;
      }
      return true;
    };
    _this.saveUpload = function (node) {
      _this.upload = node;
    };
    _this.renderUploadList = function (locale) {
      var _this$props = _this.props,
        showUploadList = _this$props.showUploadList,
        listType = _this$props.listType,
        onPreview = _this$props.onPreview,
        disabled = _this$props.disabled,
        maxFileCount = _this$props.maxFileCount,
        showDeleteAll = _this$props.showDeleteAll;
      var showRemoveIcon = showUploadList.showRemoveIcon,
        showPreviewIcon = showUploadList.showPreviewIcon;
      return /*#__PURE__*/React.createElement(_UploadList["default"], {
        listType: listType,
        items: _this.state.fileList,
        onPreview: onPreview,
        onRemove: _this.handleManualRemove,
        onDeleteAll: _this.handleDeleteAll,
        showRemoveIcon: !disabled && showRemoveIcon,
        showPreviewIcon: showPreviewIcon,
        maxFileCount: maxFileCount,
        showDeleteAll: showDeleteAll,
        locale: (0, _assign["default"])((0, _assign["default"])({}, locale), _this.props.locale)
      });
    };
    _this.state = {
      fileList: props.fileList || props.defaultFileList || [],
      dragState: 'drop',
      action: props.action || ''
    };
    return _this;
  }
  (0, _createClass2["default"])(Upload, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.clearProgressTimer();
    }
  }, {
    key: "autoUpdateProgress",
    value: function autoUpdateProgress(_, file) {
      var _this2 = this;
      var getPercent = (0, _utils.genPercentAdd)();
      var curPercent = 0;
      this.clearProgressTimer();
      this.progressTimer = (0, _setInterval2["default"])(function () {
        curPercent = getPercent(curPercent);
        _this2.onProgress({
          percent: curPercent * 100
        }, file);
      }, 200);
    }
  }, {
    key: "handleRemove",
    value: function handleRemove(file) {
      var _this3 = this;
      var onRemove = this.props.onRemove;
      _promise["default"].resolve(typeof onRemove === 'function' ? onRemove(file) : onRemove).then(function (ret) {
        // Prevent removing file
        if (ret === false) {
          return;
        }
        var removedFileList = (0, _utils.removeFileItem)(file, _this3.state.fileList);
        if (removedFileList) {
          _this3.onChange({
            file: file,
            fileList: removedFileList
          });
        }
      });
    }
  }, {
    key: "clearProgressTimer",
    value: function clearProgressTimer() {
      clearInterval(this.progressTimer);
    }
  }, {
    key: "renderUpload",
    value: function renderUpload(Locale) {
      var _context5, _classNames2;
      var _this$props2 = this.props,
        _this$props2$prefixCl = _this$props2.prefixCls,
        prefixCls = _this$props2$prefixCl === void 0 ? '' : _this$props2$prefixCl,
        className = _this$props2.className,
        style = _this$props2.style,
        showUploadList = _this$props2.showUploadList,
        listType = _this$props2.listType,
        type = _this$props2.type,
        disabled = _this$props2.disabled,
        children = _this$props2.children,
        tip = _this$props2.tip;
      var rcUploadProps = (0, _assign["default"])((0, _assign["default"])({
        onStart: this.onStart,
        onError: this.onError,
        onProgress: this.onProgress,
        onSuccess: this.onSuccess
      }, this.props), {
        beforeUpload: this.beforeUpload
      });
      delete rcUploadProps.className;
      delete rcUploadProps.style;
      delete rcUploadProps.action;
      var uploadList = showUploadList ? this.renderUploadList({
        uploading: Locale.uploading,
        removeFile: Locale.removeFile,
        uploadError: Locale.uploadError,
        previewFile: Locale.previewFile
      }) : null;
      var uploadTips = tip ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-tip")
      }, tip) : null;
      if (type === 'drag') {
        var _context4, _classNames;
        var dragCls = (0, _classnames["default"])(prefixCls, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-drag"), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-drag-uploading"), (0, _some["default"])(_context4 = this.state.fileList).call(_context4, function (file) {
          return file.status === 'uploading';
        })), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-drag-hover"), this.state.dragState === 'dragover'), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-disabled"), disabled), _classNames));
        return /*#__PURE__*/React.createElement("span", {
          className: className,
          style: style
        }, /*#__PURE__*/React.createElement("div", {
          className: dragCls,
          onDrop: this.onFileDrop,
          onDragOver: this.onFileDrop,
          onDragLeave: this.onFileDrop
        }, /*#__PURE__*/React.createElement(_index["default"], (0, _assign["default"])({}, rcUploadProps, {
          action: this.state.action,
          ref: this.saveUpload,
          className: "".concat(prefixCls, "-btn")
        }), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-drag-container")
        }, children))), uploadTips, uploadList);
      }
      var uploadButtonCls = (0, _classnames["default"])(prefixCls, (_classNames2 = {}, (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-select"), true), (0, _defineProperty2["default"])(_classNames2, (0, _concat["default"])(_context5 = "".concat(prefixCls, "-select-")).call(_context5, listType), true), (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-disabled"), disabled), _classNames2));
      var uploadButton = /*#__PURE__*/React.createElement("div", {
        className: uploadButtonCls,
        style: {
          display: children ? '' : 'none'
        }
      }, /*#__PURE__*/React.createElement(_index["default"], (0, _assign["default"])({}, rcUploadProps, {
        action: this.state.action,
        ref: this.saveUpload
      })));
      var renderNode = null;
      if (listType === 'picture-card') {
        renderNode = /*#__PURE__*/React.createElement("span", {
          className: className,
          style: style
        }, uploadList, uploadButton, uploadTips);
      } else {
        renderNode = /*#__PURE__*/React.createElement("span", {
          className: className,
          style: style
        }, uploadButton, uploadTips, uploadList);
      }
      return renderNode;
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;
      return /*#__PURE__*/React.createElement(_Consumer["default"], {
        componentName: "Upload"
      }, function (Locale) {
        return _this4.renderUpload(Locale);
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      // action 受控
      if ('action' in nextProps && prevState.action !== nextProps.action) {
        newState.action = nextProps.action;
      }
      if ('fileList' in nextProps) {
        newState.fileList = nextProps.fileList || [];
      }
      return newState;
    }
  }]);
  return Upload;
}(React.Component);
Upload.Dragger = _Dragger["default"];
Upload.defaultProps = {
  prefixCls: 'fishd-upload',
  type: 'select',
  multiple: false,
  action: '',
  data: {},
  accept: '',
  beforeUpload: _utils.T,
  showUploadList: true,
  listType: 'text',
  className: '',
  disabled: false,
  supportServerRender: true,
  tip: ''
};
(0, _reactLifecyclesCompat.polyfill)(Upload);
var _default = Upload;
exports["default"] = _default;