"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var React = _interopRequireWildcard(require("react"));
var _rcAnimate = _interopRequireDefault(require("rc-animate"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _Tooltip = _interopRequireDefault(require("../Tooltip"));
var _Progress = _interopRequireDefault(require("../Progress"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Consumer = _interopRequireDefault(require("../Config/Locale/Consumer"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var fileListItemHeight = 24;
// https://developer.mozilla.org/en-US/docs/Web/API/FileReader/readAsDataURL
var previewFile = function previewFile(file, callback) {
  var reader = new FileReader();
  reader.onloadend = function () {
    return callback(reader.result);
  };
  reader.readAsDataURL(file);
};
var extname = function extname(url) {
  if (!url) {
    return '';
  }
  var temp = url.split('/');
  var filename = temp[temp.length - 1];
  var filenameWithoutSuffix = filename.split(/#|\?/)[0];
  return (/\.[^./\\]*$/.exec(filenameWithoutSuffix) || [''])[0];
};
var isImageUrl = function isImageUrl(url) {
  var extension = extname(url);
  if (/^data:image\//.test(url) || /(webp|svg|png|gif|jpg|jpeg|bmp)$/i.test(extension)) {
    return true;
  } else if (/^data:/.test(url)) {
    // other file types of base64
    return false;
  } else if (extension) {
    // other file types which have extension
    return false;
  }
  return true;
};
var UploadList = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(UploadList, _React$Component);
  var _super = _createSuper(UploadList);
  function UploadList() {
    var _this;
    (0, _classCallCheck2["default"])(this, UploadList);
    _this = _super.apply(this, arguments);
    _this.handleClose = function (file) {
      var onRemove = _this.props.onRemove;
      if (onRemove) {
        onRemove(file);
      }
    };
    _this.handleDeleteAll = function () {
      var onDeleteAll = _this.props.onDeleteAll;
      if (onDeleteAll) {
        onDeleteAll();
      }
    };
    _this.handlePreview = function (file, e) {
      var onPreview = _this.props.onPreview;
      if (!onPreview) {
        return;
      }
      e.preventDefault();
      return onPreview(file);
    };
    return _this;
  }
  (0, _createClass2["default"])(UploadList, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _context,
        _this2 = this;
      if (this.props.listType !== 'picture' && this.props.listType !== 'picture-card') {
        return;
      }
      (0, _forEach["default"])(_context = this.props.items || []).call(_context, function (file) {
        if (typeof document === 'undefined' || typeof window === 'undefined' || !window.FileReader || !window.File || !(file.originFileObj instanceof File) || file.thumbUrl !== undefined) {
          return;
        }
        /*eslint-disable */
        file.thumbUrl = '';
        /*eslint-enable */
        previewFile(file.originFileObj, function (previewDataUrl) {
          /*eslint-disable */
          file.thumbUrl = previewDataUrl;
          /*eslint-enable */
          _this2.forceUpdate();
        });
      });
    }
  }, {
    key: "renderUploadList",
    value: function renderUploadList(Locale) {
      var _this3 = this,
        _context3,
        _classNames2;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        _this$props$items = _this$props.items,
        items = _this$props$items === void 0 ? [] : _this$props$items,
        listType = _this$props.listType,
        showPreviewIcon = _this$props.showPreviewIcon,
        showRemoveIcon = _this$props.showRemoveIcon,
        locale = _this$props.locale,
        showDeleteAll = _this$props.showDeleteAll,
        maxFileCount = _this$props.maxFileCount;
      var list = (0, _map["default"])(items).call(items, function (file) {
        var _context2, _classNames;
        var progress;
        var icon = /*#__PURE__*/React.createElement(_Icon["default"], {
          type: file.status === 'uploading' ? 'load-line' : 'clip-line',
          spinning: file.status === 'uploading' ? true : false
        });
        if (listType === 'picture' || listType === 'picture-card') {
          if (listType === 'picture-card' && file.status === 'uploading') {
            icon = /*#__PURE__*/React.createElement("div", {
              className: "".concat(prefixCls, "-list-item-uploading-text")
            }, locale.uploading);
          } else if (!file.thumbUrl && !file.url) {
            icon = /*#__PURE__*/React.createElement(_Icon["default"], {
              type: "image-line",
              className: "".concat(prefixCls, "-list-item-thumbnail")
            });
          } else {
            var thumbnail = isImageUrl(file.thumbUrl || file.url) ? /*#__PURE__*/React.createElement("img", {
              src: file.thumbUrl || file.url,
              alt: file.name
            }) : /*#__PURE__*/React.createElement(_Icon["default"], {
              type: "file-line",
              className: "".concat(prefixCls, "-list-item-icon")
            });
            icon = /*#__PURE__*/React.createElement("a", {
              className: "".concat(prefixCls, "-list-item-thumbnail"),
              onClick: function onClick(e) {
                return _this3.handlePreview(file, e);
              },
              href: file.url || file.thumbUrl,
              target: "_blank",
              rel: "noopener noreferrer"
            }, thumbnail);
          }
        }
        if (file.status === 'uploading') {
          // show loading icon if upload progress listener is disabled
          var loadingProgress = 'percent' in file ? /*#__PURE__*/React.createElement(_Progress["default"], (0, _assign["default"])({
            type: "line"
          }, _this3.props.progressAttr, {
            percent: file.percent,
            operation: /*#__PURE__*/React.createElement("div", {
              className: "".concat(prefixCls, "-action-cancel"),
              onClick: function onClick() {
                return _this3.handleClose(file);
              }
            }, Locale.cancelText)
          })) : null;
          progress = /*#__PURE__*/React.createElement("div", {
            className: "".concat(prefixCls, "-list-item-progress"),
            key: "progress"
          }, loadingProgress);
        }
        var infoUploadingClass = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-list-item"), true), (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context2 = "".concat(prefixCls, "-list-item-")).call(_context2, file.status), true), _classNames));
        var preview = file.url ? /*#__PURE__*/React.createElement("a", (0, _assign["default"])({}, file.linkProps, {
          href: file.url,
          target: "_blank",
          rel: "noopener noreferrer",
          className: "".concat(prefixCls, "-list-item-name"),
          onClick: function onClick(e) {
            return _this3.handlePreview(file, e);
          },
          title: file.name
        }), file.name) : /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-list-item-name"),
          onClick: function onClick(e) {
            return _this3.handlePreview(file, e);
          },
          title: file.name
        }, file.name);
        var style = {
          pointerEvents: 'none',
          opacity: 0.5
        };
        var previewIcon = showPreviewIcon ? /*#__PURE__*/React.createElement("a", {
          href: file.url || file.thumbUrl,
          target: "_blank",
          rel: "noopener noreferrer",
          style: file.url || file.thumbUrl ? undefined : style,
          onClick: function onClick(e) {
            return _this3.handlePreview(file, e);
          },
          title: locale.previewFile
        }, /*#__PURE__*/React.createElement(_Icon["default"], {
          type: "watch-line"
        })) : null;
        var removeIcon = showRemoveIcon ? /*#__PURE__*/React.createElement(_Icon["default"], {
          type: "delete-line",
          title: locale.removeFile,
          onClick: function onClick() {
            return _this3.handleClose(file);
          }
        }) : null;
        var removeIconCross = showRemoveIcon ? /*#__PURE__*/React.createElement(_Icon["default"], {
          type: "hints-alone-error",
          title: locale.removeFile,
          onClick: function onClick() {
            return _this3.handleClose(file);
          }
        }) : null;
        var actions = listType === 'picture-card' && file.status !== 'uploading' ? /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-list-item-actions")
        }, previewIcon, removeIcon) : removeIconCross;
        var message;
        if (file.response && typeof file.response === 'string') {
          message = file.response;
        } else {
          message = file.error && file.error.statusText || locale.uploadError;
        }
        var iconAndPreview = file.status === 'error' ? /*#__PURE__*/React.createElement(_Tooltip["default"], {
          title: message
        }, icon, preview) : /*#__PURE__*/React.createElement("span", null, icon, preview);
        return /*#__PURE__*/React.createElement("div", {
          className: infoUploadingClass,
          key: file.uid
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-list-item-info")
        }, iconAndPreview), actions, /*#__PURE__*/React.createElement(_rcAnimate["default"], {
          transitionName: "fade",
          component: ""
        }, progress));
      });
      var showScrollbar = listType === 'text' && list.length > maxFileCount;
      var listClassNames = (0, _classnames["default"])((_classNames2 = {}, (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-list"), true), (0, _defineProperty2["default"])(_classNames2, (0, _concat["default"])(_context3 = "".concat(prefixCls, "-list-")).call(_context3, listType), true), (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-list-scroll"), showScrollbar), _classNames2));
      var animationDirection = listType === 'picture-card' ? 'animate-inline' : 'animate';
      var deleteAllCls = (0, _classnames["default"])("".concat(prefixCls, "-list-scroll-delete-all"), (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-hide"), !showDeleteAll));
      var renderNode = null;
      if (showScrollbar) {
        var _context4;
        renderNode = /*#__PURE__*/React.createElement("div", {
          className: null
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-list-scroll-info")
        }, /*#__PURE__*/React.createElement("span", null, Locale.uploadedTip.replace('${length}', String(list.length))), /*#__PURE__*/React.createElement("span", {
          className: deleteAllCls,
          onClick: function onClick() {
            return _this3.handleDeleteAll();
          }
        }, Locale.deleteText)), /*#__PURE__*/React.createElement(_rcAnimate["default"], {
          transitionName: (0, _concat["default"])(_context4 = "".concat(prefixCls, "-")).call(_context4, animationDirection),
          component: "div",
          className: listClassNames,
          style: {
            height: fileListItemHeight * maxFileCount + fileListItemHeight / 2
          }
        }, list));
      } else {
        var _context5;
        renderNode = /*#__PURE__*/React.createElement(_rcAnimate["default"], {
          transitionName: (0, _concat["default"])(_context5 = "".concat(prefixCls, "-")).call(_context5, animationDirection),
          component: "div",
          className: listClassNames
        }, list);
      }
      return renderNode;
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;
      return /*#__PURE__*/React.createElement(_Consumer["default"], {
        componentName: "Upload"
      }, function (Locale) {
        return _this4.renderUploadList(Locale);
      });
    }
  }]);
  return UploadList;
}(React.Component);
exports["default"] = UploadList;
UploadList.defaultProps = {
  listType: 'text',
  progressAttr: {
    strokeWidth: 2,
    showInfo: false
  },
  prefixCls: 'fishd-upload',
  showRemoveIcon: true,
  showPreviewIcon: true,
  maxFileCount: 5,
  showDeleteAll: true
};