"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames2 = _interopRequireDefault(require("classnames"));
var _omit = _interopRequireDefault(require("omit.js"));
var _Video = _interopRequireDefault(require("./Video"));
var _VideoModal = _interopRequireDefault(require("./VideoModal"));
var _Icon = _interopRequireDefault(require("../Icon"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var VideoViewer = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(VideoViewer, _React$Component);
  var _super = _createSuper(VideoViewer);
  function VideoViewer(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, VideoViewer);
    _this = _super.call(this, props);
    // 点击缩略图
    _this.handleThumbClick = function (e) {
      if (_this.props.failedMessage !== null) return;
      _this.setState({
        videoModalVisible: true
      }, function () {
        var video = _this.video && _this.video.current;
        var player = video && video.getVideoPlayer();
        if (player && typeof player.play === 'function') {
          player.play();
        }
      });
      _this.props.onThumbClick && _this.props.onThumbClick(e);
    };
    // 模态框关闭的回调
    _this.onClose = function () {
      var video = _this.video && _this.video.current;
      var player = video && video.getVideoPlayer();
      if (player && typeof player.pause === 'function') {
        player.pause();
      }
      _this.props.modalProps.afterClose && _this.props.modalProps.afterClose();
    };
    // 点击模态框关闭按钮
    _this.handleCancel = function (e) {
      _this.setState({
        videoModalVisible: false
      });
      _this.props.modalProps.onCancel && _this.props.modalProps.onCancel();
    };
    _this.state = {
      videoModalVisible: false
    };
    _this.video = /*#__PURE__*/React.createRef();
    return _this;
  }
  (0, _createClass2["default"])(VideoViewer, [{
    key: "render",
    value: function render() {
      var _classnames;
      var videoModalVisible = this.state.videoModalVisible;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        width = _this$props.width,
        height = _this$props.height,
        poster = _this$props.poster,
        modalProps = _this$props.modalProps,
        videoProps = _this$props.videoProps,
        failedMessage = _this$props.failedMessage;
      var otherModalProps = (0, _omit["default"])(modalProps, ['visible', 'afterClose', 'onCancel']);
      var otherVideoProps = (0, _omit["default"])(videoProps, ['autoPlay']);
      var thumbCls = (0, _classnames2["default"])((_classnames = {}, (0, _defineProperty2["default"])(_classnames, "".concat(prefixCls, "-thumb"), true), (0, _defineProperty2["default"])(_classnames, "".concat(prefixCls, "-thumb-disabled"), failedMessage !== null), _classnames));
      var wrapStyle = {
        width: width,
        height: height
      };
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-wrap"),
        style: wrapStyle
      }, /*#__PURE__*/React.createElement("div", {
        className: thumbCls,
        onClick: this.handleThumbClick
      }, failedMessage === null ? /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames2["default"])(["".concat(prefixCls, "-thumb-status"), "".concat(prefixCls, "-thumb-big-play-button")])
      }, /*#__PURE__*/React.createElement(_Icon["default"], {
        type: "play"
      })) : /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames2["default"])(["".concat(prefixCls, "-thumb-status"), "".concat(prefixCls, "-thumb-failed-message")])
      }, /*#__PURE__*/React.createElement("span", null, failedMessage)), /*#__PURE__*/React.createElement(_Video["default"], {
        width: width,
        height: height,
        poster: poster,
        sources: otherVideoProps.sources,
        controls: false
      })), /*#__PURE__*/React.createElement(_VideoModal["default"], (0, _assign["default"])({}, otherModalProps, {
        visible: videoModalVisible,
        afterClose: this.onClose,
        onCancel: this.handleCancel
      }), /*#__PURE__*/React.createElement(_Video["default"], (0, _assign["default"])({}, otherVideoProps, {
        ref: this.video,
        autoplay: true,
        bigPlayButton: false
      }))));
    }
  }]);
  return VideoViewer;
}(React.Component);
VideoViewer.propTypes = {
  prefixCls: _propTypes["default"].string,
  width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  poster: _propTypes["default"].string,
  failedMessage: _propTypes["default"].string,
  modalProps: _propTypes["default"].object,
  videoProps: _propTypes["default"].object,
  onThumbClick: _propTypes["default"].func
};
VideoViewer.defaultProps = {
  prefixCls: 'fishd-video-viewer',
  poster: null,
  width: 240,
  height: 135,
  failedMessage: null
};
VideoViewer.Video = _Video["default"];
VideoViewer.VideoModal = _VideoModal["default"];
var _default = VideoViewer;
exports["default"] = _default;